PRGSTART:
;--------------------------------------------
***********************************************************************
p:	lea	Start,a0	; Start data
	lea	DataEnd,a1	; End data
	lea	Write,a2	; Destination for codes
	moveq	#0,d1		; Packing Parameters
	bsr	PackIt
	lea	Write(pc),a0
	move.l	a0,a1
	move.l	(a0),d0
	add.l	d0,a1
	rts
***********************************************************************
d:	lea	Write,a0	; Data Start
	lea	Into,a1		; Data Destination
	bra.w	DePackIt
***********************************************************************
;-------------------------
;Flag bits
	rsreset
SkpFlg:	rs.b 1
EndFlg:	rs.b 1
EndBits:rs.b 0
;-------------
ZerLn	=64
EquLn	=64
AddLn	=16
SkipLn	=98
	rsreset
			; Zero bytes
ZerCod:	rs.b	ZerLn	; CX
ZerByt:	rs.b	1	; C	X
ZerWor:	rs.b	1	; C	Xb, X
ZerLon:	rs.b	1	; C	Xbb, Xb, X

			; Equal bytes
EquCod:	rs.b	EquLn	; CX	n
EquByt:	rs.b	1	; C	n	X
EquWor:	rs.b	1	; C	n	Xb, X
EquLon:	rs.b	1	; C	n	Xbb, Xb, X

			; Aritmethric sequences
AddCod:	rs.b	AddLn	; CX	A	n
AddByt:	rs.b	1	; C	A	n	X
AddWor:	rs.b	1	; C	A	n	Xb, X
AddLon:	rs.b	1	; C	A	n	Xbb, Xb, X

			; Nonepacked sequences
SkipCod:rs.b	SkipLn	; CX
SkipByt:rs.b	1	; C	X
SkipWor:rs.b	1	; C	Xb, X
SkipLon:rs.b	1	; C	Xbb, Xb, X
StrCode:rs.b	1	; C
EndCode:rs.b	1	; C
CodeNum:rs.b	0
;--------------------------------
PackIt:	lea	(a0),a6		; ReadPos
	lea	(a2),a5		; WritePos
	lea	(a6),a4		; ReadCounter
	lea	(a6),a2		; SkipCounter
		;   ,a1		; End of data
	move.l	d1,d7		; Flag
;--------------------------------
	move.l	a6,-(sp)
	move.l	a5,-(sp)
	lea	8(a5),a5
	move.b	#EndCode,(a5)+
MainLoop:
	;move.w	(a6),$dff180
	moveq	#0,d6		; Stack counter
	lea	1(a4),a4
	cmp.l	a1,a4
	bmi.b	IRcn1
	bset	#EndFlg,d7
	bra.w	SkipData
IRcn1:	move.b	(a4),d0
	move.b	d0,d1
	sub.b	(a6),d0		; AddVal
	moveq	#1,d2		; Counter
CmpLop1:addq.l	#1,d2
	lea	1(a4),a4
	cmp.l	a1,a4
	bpl.b	CmpCnt
	add.b	d0,d1
	cmp.b	(a4),d1
	beq.b	CmpLop1
CmpCnt:	tst.b	d0
	bne.w	Adding
	tst.b	(a6)
	bne.b	EqualN

;---------------------------------
	; Packed zero bytes
	; d2=Length
ZerCode:cmp.l	#ZerLn+1,d2
	bpl.b	ZeroByte
	add.b	#ZerCod-1,d2
	move.b	d2,-(sp)	; CX
	addq.l	#1,d6		; sp+1
	bra.w	SkipCode
ZeroByte:
	sub.l	#ZerLn+1,d2	; -(ZerLn+1)
	cmp.l	#2^8,d2
	bpl.b	ZeroWord
	move.b	#ZerByt,-(sp)	; C, X
	move.b	d2,-(sp)
	addq.l	#2,d6		; sp+2
	bra.w	SkipCode
ZeroWord:
	sub.l	#2^8,d2		; -(ZerLn+1+2^8)
	cmp.l	#2^16,d2
	bpl.b	ZeroLong
	move.l	d2,d0
	lsr.l	#8,d0
	move.b	#ZerWor,-(sp)	; C, Xb, X
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#3,d6		; sp+3
	bra.w	SkipCode
ZeroLong:
	sub.l	#2^16,d2	; -(ZerLn+1+2^8+2^16)
	move.l	d2,d0
	lsr.l	#8,d0
	move.l	d0,d1
	lsr.l	#8,d1
	move.b	#ZerLon,-(sp)	; C, Xbb, Xb, X
	move.b	d1,-(sp)
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#4,d6		; sp+4
	bra.w	SkipCode
;-----------------------------------
	; Packed equal bytes
	; d2=Length
	; (a6)=Equal byte
EqualN:	cmp.l	#3,d2
	bpl.b	EquCode
	btst	#SkpFlg,d7
	beq.b	EquCode
	bra.w	SkipData
EquCode:cmp.l	#EquLn+2,d2
	bpl.b	EquByte
	add.b	#EquCod-2,d2
	move.b	d2,-(sp)
	move.b	(a6),-(sp)	; CX, n
	addq.l	#2,d6		; sp+2
	bra.w	SkipCode
EquByte:sub.l	#EquLn+2,d2	; -(EquLn+2)
	cmp.l	#2^8,d2
	bpl.b	EquWord
	move.b	#EquByt,-(sp)	; C, n, X
	move.b	(a6),-(sp)
	move.b	d2,-(sp)
	addq.l	#3,d6		; sp+3
	bra.w	SkipCode
EquWord:sub.l	#2^8,d2		; -(EquLn+2+2^8)
	cmp.l	#2^16,d2
	bpl.b	EquLong
	move.l	d2,d0
	lsr.l	#8,d0
	move.b	#EquWor,-(sp)	; C, n, Xb, X
	move.b	(a6),-(sp)
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#4,d6		; sp+4
	bra.w	SkipCode
EquLong:sub.l	#2^16,d2	; -(EquLn+2+2^8+2^16)
	move.l	d2,d0
	lsr.l	#8,d0
	move.l	d0,d1
	lsr.l	#8,d1
	move.b	#EquLon,-(sp)	; C, n, Xbb, Xb, X
	move.b	(a6),-(sp)
	move.b	d1,-(sp)
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#5,d6		; sp+5
	bra.w	SkipCode
;-----------------------------------
	; Packed aritmethric sequences
	; d0= Delta X
	; -1(a4)= Start byte
	; d2= Length
Adding:	move.w	d0,d3
	cmp.l	#3,d2
	beq.b	AddSkp
	bhi.b	AddCode
	bra.w	SkipData
AddSkp:	btst	#SkpFlg,d7
	bne.b	SkipData
AddCode:cmp.l	#AddLn+3,d2
	bpl.b	AddByte
	add.b	#AddCod-3,d2
	move.b	d2,-(sp)
	move.b	d3,-(sp)
	move.b	-1(a4),-(sp)	; CX, A, n
	addq.l	#3,d6		; sp+3
	bra.w	SkipCode
AddByte:sub.l	#AddLn+3,d2	' -(AddLn+3)
	cmp.l	#2^8,d2
	bpl.b	AddWord
	move.b	#AddByt,-(sp)	; C, A, n, X
	move.b	d3,-(sp)
	move.b	-1(a4),-(sp)
	move.b	d2,-(sp)
	addq.l	#4,d6		; sp+4
	bra.b	SkipCode
AddWord:sub.l	#2^8,d2		; -(AddLn+3+2^8)
	cmp.l	#2^16,d2
	bpl.b	AddLong
	move.l	d2,d0
	lsr.l	#8,d0
	move.b	#AddWor,-(sp)	; C, A, n, Xb, X
	move.b	d3,-(sp)
	move.b	-1(a4),-(sp)
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#5,d6		; sp+5
	bra.b	SkipCode
AddLong:sub.l	#2^16,d2	; -(AddLn+3+2^8+2^16)
	move.l	d2,d0
	lsr.l	#8,d0
	move.l	d0,d1
	lsr.l	#8,d1
	move.b	#AddLon,-(sp)	; C, A, n, Xbb, Xb, X
	move.b	d3,-(sp)
	move.b	-1(a4),-(sp)
	move.b	d1,-(sp)
	move.b	d0,-(sp)
	move.b	d2,-(sp)
	addq.l	#6,d6		; sp+6
	bra.b	SkipCode
;-----------------------------------
SkipData:
	tst.b	(a6)
	bne.b	SkpDo
	btst	#SkpFlg,d7
	bne.b	SkpDo
	clr.b	(a5)+
	lea	1(a6),a2
	bra.b	NoSkpDo
SkpDo:	bset	#SkpFlg,d7
NoSkpDo:lea	1(a6),a6
	lea	(a6),a4
	btst	#EndFlg,d7
	beq.w	MainLoop

SkipCode:
	btst	#SkpFlg,d7
	beq.b	WriteCode
	bclr	#SkpFlg,d7
	move.l	a6,d0
	sub.l	a2,d0
SkipLop:move.b	(a2)+,(a5)+
	cmp.l	a2,a6
	bne.b	SkipLop
	cmp.l	#SkipLn+1,d0
	bpl.b	SkipByte
	add.b	#SkipCod-1,d0
	move.b	d0,(a5)+
	bra.b	EndSkipping
SkipByte:
	sub.l	#SkipLn+1,d0
	cmp.l	#2^8,d0
	bpl.b	SkipWord
	move.b	d0,(a5)+
	move.b	#SkipByt,(a5)+
	bra.b	EndSkipping
SkipWord:
	sub.l	#2^8,d0
	cmp.l	#2^16,d0
	bpl.b	SkipLong
	move.l	d0,d1
	lsr.l	#8,d1
	move.b	d0,(a5)+
	move.b	d1,(a5)+
	move.b	#SkipWor,(a5)+
	bra.b	EndSkipping
SkipLong:
	sub.l	#2^16,d0
	move.l	d0,d1
	lsr.l	#8,d1
	move.l	d1,d2
	lsr.l	#8,d2
	move.b	d0,(a5)+
	move.b	d1,(a5)+
	move.b	d2,(a5)+
	move.b	#SkipLon,(a5)+
EndSkipping:
;----------------------------------
	; Write codes for packed data...
	; (Stored in stack.)
WriteCode:
	tst.l	d6
	beq.b	NoWrite
	subq.l	#1,d6
StkLoop:move.b	(sp)+,(a5)+
	dbf	d6,StkLoop
	cmp.l	a1,a4
	bmi.b	NoWrite
	bset	#EndFlg,d7
NoWrite:lea	(a4),a6
	lea	(a4),a2

	btst	#EndFlg,d7
	beq.w	MainLoop
	move.b	#StrCode,(a5)+

	move.l	(sp)+,a0
	sub.l	a0,a5
	move.l	a5,(a0)
	lea	(a1),a5
	sub.l	(sp)+,a5
	move.l	a5,4(a0)
	rts
;----------------------------------------------------------------
DePackIt:
	move.l	(a0),d0
	move.l	4(a0),d1
	move.l	#2^24,d2
	cmp.l	d2,d1
	bhi.w	DePerr
	cmp.l	d2,d0
	bhi.w	DePerr
	moveq	#0,d2
	cmp.l	d2,d1
	beq.w	DePerr
	cmp.l	d2,d0
	beq.w	DePerr
	;cmp.l	d1,d0		; Can the crunched data be longer than
	;bhi.w	DePerr		; the uncrunched data?

	lea	(a0,d0.l),a6	; End of Data
	lea	(a1,d1.l),a5	; End of Decrunched data
	cmp.b	#StrCode,-(a6)
	bne.w	DePerr
DecrLoop:
	moveq	#0,d0	; Fill Len
	moveq	#0,d1	; Equ Byte
	moveq	#0,d2	; Add Byte
	move.b	-(a6),d0

	moveq	#0,d3
	cmp.b	#ZerCod+ZerLn,d0
	bhs.b	DecCn1
	sub.b	#ZerCod-1,d0
	bra.w	FillMem
DecCn1:	moveq	#ZerLn+1,d3
	cmp.b	#ZerByt,d0
	bne.b	DecCn2
DecByt:	move.b	-(a6),d0
	bra.w	FillMem
DecCn2:	cmp.b	#ZerWor,d0
	bne.b	DecCn3
DecWor:	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^8,d3
	bra.b	DecByt
DecCn3:	cmp.w	#ZerLon,d0
	bne.b	DecCn4
DecLon:	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^16,d3
	bra.b	DecWor
DecCn4:
	moveq	#0,d3
	cmp.b	#EquCod+EquLn,d0
	bhs.b	DecCn5
	sub.b	#EquCod-2,d0
DecCodN:move.b	-(a6),d1
	bra.w	FillMem
DecCn5:	moveq	#EquLn+2,d3
	cmp.b	#EquByt,d0
	bne.b	DecCn6
DecBytN:move.b	-(a6),d1
	bra.b	DecByt
DecCn6:	cmp.b	#EquWor,d0
	bne.b	DecCn7
DecWorN:move.b	-(a6),d1
	bra.b	DecWor
DecCn7:	cmp.w	#EquLon,d0
	bne.b	DecCn8
DecLonN:move.b	-(a6),d1
	bra.b	DecLon
DecCn8:
	moveq	#0,d3
	cmp.b	#AddCod+AddLn,d0
	bhs.b	DecCn9
	sub.b	#AddCod-3,d0
	move.b	-(a6),d2
	bra.b	DecCodN
DecCn9:	moveq	#AddLn+3,d3
	cmp.b	#AddByt,d0
	bne.b	DecCnA
	move.b	-(a6),d2
	bra.b	DecBytN
DecCnA:	cmp.b	#AddWor,d0
	bne.b	DecCnB
	move.b	-(a6),d2
	bra.b	DecWorN
DecCnB:	cmp.w	#AddLon,d0
	bne.b	DecCnC
	move.b	-(a6),d2
	bra.b	DecLonN
DecCnC:
	moveq	#0,d3
	cmp.b	#SkipCod+SkipLn,d0
	bhs.b	DecCnD
	sub.b	#SkipCod-1,d0
	bra.b	DecrSkip
DecCnD:	moveq	#SkipLn+1,d3
	cmp.b	#SkipByt,d0
	bne.b	DecCnE
DecBytS:move.b	-(a6),d0
	bra.b	DecrSkip
DecCnE:	cmp.b	#SkipWor,d0
	bne.b	DecCnF
DecWorS:move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^8,d3
	bra.b	DecBytS
DecCnF:	cmp.w	#SkipLon,d0
	bne.b	DecCnG
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^16,d3
	bra.b	DecWorS
DecCnG:	cmp.b	#EndCode,d0
	beq.b	EndDecr
DecrSkip:add.l	d3,d0
SkpLoop:move.b	(a6),$dff180
	move.b	-(a6),-(a5)
	subq.l	#1,d0
	bne.b	SkpLoop
	bra.w	DecrLoop
FillMem:add.l	d3,d0
FillLop:move.b	d1,$dff180
	move.b	d1,-(a5)
	sub.b	d2,d1
	subq.l	#1,d0
	bne.b	FillLop
	bra.w	DecrLoop
EndDecr:rts
DePerr:	moveq	#-1,d0
DerrLop:move.w	$dff006,$dff180
	dbf	d0,DerrLop
	rts
;--------------------------
Write:	dcb.b	1024,0	; Packed data
Into:	dcb.b	1024,0	; Depacked raw data
;--------------------------

Start:	incdir	ram:
	incbin	setup
DataEnd:cnop	0,2
;--------------------------
PRGEND:
