;--------------------------------
; ProTracker includes

* Screen IDs
MainScreen_ID		EQU	1
HelpScreen_ID		EQU	2
DirScreen_ID		EQU	3
PresetScreen_ID		EQU	4
SetupScreen1_ID		EQU	5
PLSTScreen_ID		EQU	6
SetupScreen2_ID		EQU	7

* FileFormat offsets
sd_songname		EQU	0
sd_sampleinfo		EQU	20
sd_numofpatt		EQU	950
sd_pattpos		EQU	952
sd_mahokakt		EQU	1080
sd_patterndata		EQU	1084

* audXtemp offsets
; -maw- moved to PT313.s


* Exec Library Offsets
LVOFindTask		EQU	-294
LVOFindName		EQU	-276
LVOForbid		EQU	-132
LVOPermit		EQU	-138
LVOAddPort		EQU	-354
LVORemPort		EQU	-360
LVOWaitPort		EQU	-384
LVOOpenLibrary		EQU	-552
LVOCloseLibrary		EQU	-414
LVOOpenDevice		EQU	-444
LVOCloseDevice		EQU	-450
LVODoIO			EQU	-456
LVOGetMsg		EQU	-372
LVOReplyMsg		EQU	-378
LVOAllocMem		EQU	-198
LVOAllocAbs		EQU	-204
LVOFreeMem		EQU	-210
LVOAvailMem		EQU	-216
LVOAddIntServer		EQU	-168
LVORemIntServer		EQU	-174
LVOPutMsg		EQU	-366
LVOOpenResource		EQU	-498
LVOSetFunction		EQU	-420

* CIA Resource Offsets
AddICRVector		EQU	-6
RemICRVector		EQU	-12

* DOS Library Offsets
LVOOpen			EQU	-30
LVOClose		EQU	-36
LVORead			EQU	-42
LVOWrite		EQU	-48
LVODeleteFile		EQU	-72
LVORename		EQU	-78
LVOLock			EQU	-84
LVOUnLock		EQU	-90
LVOExamine		EQU	-102
LVOExNext		EQU	-108
LVOInfo			EQU	-114
LVOSeek			EQU	-66
LVOCreateDir		EQU	-120
LVODateStamp		EQU	-192
LVODelay		EQU	-198
LVOExecute		EQU	-222
LVOUnLoadSeg		EQU	-156
LVODeviceProc		EQU	-174

* Intuition Library Offsets
LVOAutoRequest	  	EQU	-348
LVOEasyRequestArgs	EQU	-588
LVORequester		EQU	-240
LVOBuildSysRequest	EQU	-360
LVOFreeSysRequest	EQU	-372
LVOEndRequest		EQU	-366
LVODisplayAlert   	EQU	-90 
LVOOpenWorkbench  	EQU	-210
LVOCloseWorkbench 	EQU	-78
LVOWBenchToFront  	EQU	-342
LVOScreenToBack		EQU	-246
LVOScreenToFront	EQU	-252

ib_ViewLord	EQU	34
gb_copinit	EQU	38

* Graphics Library Offsets
LVOBltBitMap		EQU	-30
LVOLoadView		EQU	-222
LVOWaitBlit		EQU	-228
LVOWaitTOF		EQU	-270
LVOOwnBlitter		EQU	-456
LVODisownBlitter 	EQU	-462

* DateStamp
ofib_DateStamp		EQU	$84
ds_Days			EQU	$00
ds_Minute		EQU	$04
ds_Tick			EQU	$08

* Exec Memory Alloc Flags
MEMF_ANY		EQU	$0000
MEMF_PUBLIC		EQU	$0001
MEMF_CHIP		EQU	$0002
MEMF_FAST		EQU	$0004
MEMF_CLEAR		EQU	$10000
MEMF_LARGEST		EQU	$20000

* IO Block Offsets
IO_COMMAND		EQU	$1C
IO_ACTUAL		EQU	$20
IO_LENGTH		EQU	$24
IO_DATA			EQU	$28
IO_OFFSET		EQU	$2C

* Device Commands 
CMD_READ		EQU	$2
CMD_WRITE		EQU	$3
CMD_UPDATE		EQU	$4
TD_MOTOR		EQU	$9
TD_FORMAT		EQU	$B
TD_CHANGESTATE		EQU	$E
TD_PROTSTATUS		EQU	$F

* Arp Functions
LVOPatternMatch		EQU	-432
LVOPreParse		EQU	-558

* Misc defs
DirNameLength		EQU	30
ConfigFileSize		EQU	1024
KeyBufSize		EQU	20

* PowerPacker.Library function offsets
ppLoadData 		EQU	-30
ppDecrunchhBuffer	EQU	-36
ppCalcCheckSum		EQU	-42
ppCalcPassKey		EQU	-48
ppDecrypt		EQU	-54
ppGetPassword		EQU	-60
ppObsolete1		EQU	-66
ppObsolete2		EQU	-72
ppDecrHdr		EQU	-78
ppCryptDecrHdr		EQU	-84
ppOverlayDecrHdr	EQU	-90
ppAllocCrunchInfo	EQU	-96
ppFreeCrunchInfo	EQU	-102
ppCrunchBuffer		EQU	-108
ppWriteDataHeader	EQU	-114
ppEnterPassword		EQU	-120
ppPasswordCallBack	EQU	-126
ppErrorMessage		EQU	-132

* Needed version number
PPVERSION		EQU	35

* Decrunch colors for ppLoadData and ppDecrunchBuffer
DECR_COL0		EQU	 0
DECR_COL1		EQU	 1
DECR_POINTER		EQU	 2
DECR_SCROLL		EQU	 3
DECR_NONE		EQU	 4

* Error codes returned by ppLoadData
PP_OPENERR		EQU	-1
PP_READERR		EQU	-2
PP_NOMEMORY		EQU	-3
PP_CRYPTED		EQU	-4
PP_PASSERR		EQU	-5
PP_UNKNOWNPP		EQU	-6
PP_EMPTYFILE		EQU	-7

* Size of speedup buffer
SPEEDUP_BUFFLARGE	EQU	 0
SPEEDUP_BUFFMEDIUM	EQU	 1
SPEEDUP_BUFFSMALL	EQU	 2

* Possible return values from ppCrunchBuffer
PP_CRUNCHABORTED	EQU	 0
PP_BUFFEROVERFLOW	EQU	-1

* Bitplane values
Res			EQU	640
Height			EQU	256
BPLNo			EQU	3

