
; Gadget event structure
	rsreset
ev_Next:	rs.l	1	; Pointer to next event (0 = last)
ev_GadID:	rs.w	1	; reference to gadgetlist (x,y area)
ev_Type:	rs.w	1	; Type of gadget
ev_Code:	rs.l	1	; Assembly routine to be called afterwards
ev_Special:	rs.l	1	; SpecialInfo (varies from type to type)
ev_SIZEOF:	rs.b	0

; Event types
EV_TEXTKIND	EQU	0
EV_INTEGERKIND	EQU	1
EV_STRINGKIND	EQU	2
EV_INTSTRKIND	EQU	3
EV_SLIDERKIND	EQU	3
EV_BROWSEKIND	EQU	4
EV_BOOLEANKIND	EQU	5
EV_GETNOTE	EQU	6	; Specially for ProTracker

; Types of Data (BitNum)
SI_BYTE		EQU	0
SI_WORD		EQU	1
SI_LONG		EQU	2

; SpecialInfo for EV_TEXTKIND = pointer to first text structure
; SpecialInfo for EV_INTEGERKIND = pointer to first integer structure


; SpecialInfo for EV_STRINGKIND
	rsreset
sk_Text:	rs.l	1	; Pointer to text structure
sk_Length:	rs.w	1	; real text length
sk_Display:	rs.w	1	; number of chars to be displayed
sk_TextPos:	rs.w	1	; position offset
sk_SIZEOF:	rs.b	0

; SpecialInfo for EV_SLIDERKIND
	rsreset
sl_From:	rs.l	1	; Variable varies from this value(UpLeft)...
sl_To:		rs.l	1	; ... to this value(LowerRight)
sl_Pointer:	rs.l	1	; Pointer to counter (value)
sl_BitNum:	rs.b	1	; SI_BYTE, SI_WORD, SI_LONG
sl_SlideType:	rs.b	1	; see below
sl_Xpos:	rs.w	1	; x pos of left side in area
sl_Ypos:	rs.w	1	; y pos of upper edge in area
sl_Area:	rs.w	1	; Size of slider area in pixels (Width/Height)
sl_Width:	rs.w	1	; Width of slider in pixels)
sl_Height:	rs.w	1	; Height of slider in pixels
sl_Pos:		rs.w	1	; Pixel-Position offset
sl_Code:	rs.l	1	; Code to be called for each move
sl_SIZEOF:	rs.b	0

; Type of sliders
SL_BLANK	EQU	0	; None (or userdefined by assembly routine)
SL_VERSLIDE	EQU	1	; Vertical
SL_HORIZSLIDE	EQU	2	; Horizontal

; SpecialInfo for EV_BROWSEKIND
	rsreset
br_Text:	rs.l	1	; Pointer to chain of text structures
br_Strings:	rs.b	1	; Number of text strings
br_BitNum:	rs.b	1	; SI_BYTE, SI_WORD, SI_LONG
br_Count:	rs.l	1	; Pointer to counter
br_SIZEOF:	rs.b	0

; SpecialInfo for EV_BOOLEANKIND (Bit Flag)
	rsreset
bo_Text:	rs.l	1	; Pointer to two linked text structures
bo_Addr:	rs.l	1	; Byte address
bo_BitPos:	rs.w	1	; Which bit to change
bo_SIZEOF:	rs.b	0

; SpecialInfo for EV_GETNOTE (From note table)
	rsreset
gn_Addr:	rs.l	1	; Address of Note (Word)
gn_Xpos:	rs.w	1
gn_Ypos:	rs.w	1
gn_Type:	rs.w	1	; Text type (Shaddow text/Plain color text)
gn_Apen:	rs.b	1	; Text foreground color
gn_Bpen:	rs.b	1	; Text background color
gn_SIZEOF:	rs.b	0

; Gadget text structure
	rsreset
tx_Next:	rs.l	1	; Pointer to next text struct (0 = last)
tx_String:	rs.l	1	; Pointer to text string
tx_Length:	rs.w	1	; Length (or null terminated)
tx_Xpos:	rs.w	1
tx_Ypos:	rs.w	1
tx_Type:	rs.w	1	; Shaddow text / Plain color text
tx_Apen:	rs.b	1	; Text foreground color
tx_Bpen:	rs.b	1	; Text background color
tx_SIZEOF:	rs.b	0

; Text/Integer types
TX_OVERLAP	EQU	0	; Text singecolor
TX_TWOCOLOR	EQU	1	; Text with back and foreground color
TX_MULTICOLOR	EQU	2	; Text with shaddow

; Integer structure
	rsreset
in_Next:	rs.l	1	; Pointer to next text struct (0 = last)
in_Integer:	rs.l	1	; Pointer to Integer
in_Digits:	rs.w	1	; Number of digits
in_BitNum:	rs.b	1	; SI_BYTE, SI_WORD, SI_LONG
in_Flags:	rs.b	1
in_Xpos:	rs.w	1
in_Ypos:	rs.w	1
in_Type:	rs.w	1	; Shaddow text / Plain color text
in_Apen:	rs.b	1	; Text foreground color
in_Bpen:	rs.b	1	; Text background color
in_SIZEOF:	rs.b	0

; Integer flags
INTF_BLANKZERO	EQU	1<<0
INTF_HEX	EQU	1<<1
INTF_LEFT	EQU	1<<2
INTF_SIGNED	EQU	1<<3

