;---------------------------------------------------------------------
; Extended Instruction Set

;---------------------
; Rcc			- Return on condition code

RCC	macro		; Return on Carry Clear
	bcs.b	.Rcc\@
	rts
.Rcc\@
	endm

RCS	macro		; Return on Carry Set
	bcc.b	.Rcc\@
	rts
.Rcc\@
	endm

REQ	macro		; Return on result EQual
	bne.b	.Rcc\@
	rts
.Rcc\@
	endm

RGE	macro		; Return on result Greater or Equal
	blt.b	.Rcc\@
	rts
.Rcc\@
	endm

RGT	macro		; Return on result Greater or True
	ble.b	.Rcc\@
	rts
.Rcc\@
	endm

RHI	macro		; Return on result HIgher
	bls.b	.Rcc\@
	rts
.Rcc\@
	endm

RHS	macro		; Return on ressult Higher or Same
	blo.b	.Rcc\@
	rts
.Rcc\@
	endm

RLE	macro		; Return on result Lower or Equal
	bgt.b	.Rcc\@
	rts
.Rcc\@
	endm

RLO	macro		; Return on result LOwer
	bhs.b	.Rcc\@
	rts
.Rcc\@
	endm

RLS	macro		; Return on result Lower or Same
	bhi.b	.Rcc\@
	rts
.Rcc\@
	endm

RLT	macro		; Return on result Lower or True
	bge.b	.Rcc\@
	rts
.Rcc\@
	endm

RMI	macro		; Return on result MInus
	bpl.b	.Rcc\@
	rts
.Rcc\@
	endm

RNE	macro		; Return on result Not Equal
	beq.b	.Rcc\@
	rts
.Rcc\@
	endm

RPL	macro		; Return on result PLus
	bmi.b	.Rcc\@
	rts
.Rcc\@
	endm

RVC	macro		; Return on V (Overflow) flag Clear
	bvs.b	.Rcc\@
	rts
.Rcc\@
	endm

RVS	macro		; Return on V (Overflow) falg Set
	bvc.b	.Rcc\@
	rts
.Rcc\@
	endm

;---------------------
; Jcc			- Jump on condition code

JCC	macro		; Jump on Carry Clear
	bcs.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JCS	macro		; Jump on Carry Set
	bcc.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JEQ	macro		; Jump on result EQual
	bne.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JGE	macro		; Jump on result Greater or Equal
	blt.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JGT	macro		; Jump on result Greater or True
	ble.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JHI	macro		; Jump on result HIgher
	bls.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JHS	macro		; Jump on ressult Higher or Same
	blo.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JLE	macro		; Jump on result Lower or Equal
	bgt.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JLO	macro		; Jump on result LOwer
	bhs.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JLS	macro		; Jump on result Lower or Same
	bhi.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JLT	macro		; Jump on result Lower or True
	bge.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JMI	macro		; Jump on result MInus
	bpl.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JNE	macro		; Jump on result Not Equal
	beq.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JPL	macro		; Jump on result PLus
	bmi.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JVC	macro		; Jump on V (Overflow) flag Clear
	bvs.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

JVS	macro		; Jump on V (Overflow) falg Set
	bvc.b	.Jcc\@
	jmp	\1
.Jcc\@
	endm

;---------------------
; abs	- Absolute
; -maw- start
; I was decommenting this because OMA doesnt like the syntax and it is not needed
*ABS	macro
*	tst	\1
*	bpl.b	.abs\@
*	neg	\1
*.abs\@
* 	endm
*
*ABS.B	macro
*	tst.b	\1
*	bpl.b	.abs\@
*	neg.b	\1
*.abs\@
*	endm
*
*ABS.W	macro
*	tst.w	\1
*	bpl.b	.abs\@
*	neg.w	\1
*.abs\@
*	endm
*
*ABS.L	macro
*	tst.l	\1
*	bpl.b	.abs\@
*	neg.l	\1
*.abs\@
*	endm
; -maw- end
;---------------------

BHS	Macro
	bcc	\1
	endm

BLO	Macro
	bcs	\1
	endm

;---------------------

push	macro
	movem.l	\1,-(sp)
	endm

pop	macro
	movem.l	(sp)+,\1
	endm

;---------------------

ROUND	macro		; Unsigned rounding
	move.w	d7,-(sp)
	move.w	\1,d7
	asr.w	#1,d7
	swap	\2
	cmp.w	d7,\2
	bls.b	.rnd1\@
	swap	\2
	addq.w	#1,\2
	bra.b	.rnd2\@
.rnd1\@	swap	\2
.rnd2\@	move.w	(sp)+,d7
	endm

;example:
;	move.l	#100,d0
;	divu	#6,d0		; d0 = 100/6 = 16.6666667
;	round	#6,d0		; Round(d0) = 17

;---------------------------------------------------------------------------
