;**********************************************************
;*	   Protracker Version 3.15 (Jun 1993)  	  *
;*  (C) Copyright 1993 Lars Hamre, Tom Bech, Ivar Olsen   *
;*                and Bjarte Andreassen.                  *
;*   All rights reserved. This program is public domain.  *
;*                                                        *
;*  Updated by: Tom "Outland" Bech (db62@hp825.bih.no)    *
;*              Ivar "Olorin" Just Olsen and              *
;*              Bjarte "Krest" Andreassen of CRB.         *
;*--------------------------------------------------------*
;*  This version of Protracker is based upon Protracker   *
;*  Version 2.0 - Release A, which was written and copy-  *
;*  righted in 1991 by Lars Hamre of Amiga Freelancers.   *
;*  (Internet: larsha@sofus.dhhalden.no). Lars Hamre is   *
;*  author of version 1.0-V2.0A.			  *
;**********************************************************
; Version 3.15 is based on PT 3.10. (Apr 1993)
; It was adapted to work with the OMA Macro Assembler V2.0.
; It now includes the DYN-12bit system of PuW.
; DYN invention & realisation:
; Markus Weichselbaum
; Detlef "Dedi" Pleiss
; DYN system ported to PT by Markus "maw" Weichselbaum.
; Editor tab size: 8
;-------------------
; CREDITS:
; Thanx go to Lars Hamre for releasing the PT source and to
; Tom Bech and all of CRB for giving me the chance to put the
; DYN stuff into PT.
; Detlef Pleiss for making the DYN run in PuW MusComp and for helping me out with
; the softint handling.
;----------------------------------------------------------
;

;**********************************************************

	incdir	hd1:Languages/sources/Protracker/
	include	"PT-Includes.i"
	include	"extinstr.i"

;******************** CODE HUNK *********************

	SECTION ptcode,CODE

; ---- Constants -----------------
MAX_INSTR = 31			; we can handle max. 31 instruments
SAMPLE_LENGTHS = MAX_INSTR*4	; should give 124
MAX_PERIOD_NR = 37      	; 37 periods per tuning table
FINETUNETABLE_SIZE = MAX_PERIOD_NR*2

;--- The instrument structure
	rsreset
INSTR_NAME	rs.b 22 	; 0
INSTR_LENGTH	rs.w 1		; 22
INSTR_FINETUNE	rs.b 1		; 24
INSTR_VOLUME	rs.b 1		; 25
INSTR_REPSTART	rs.w 1		; 26
INSTR_REPLEN	rs.w 1		; 28
INSTR_SIZEOF	rs.w 0		; 30

;--- the module structure
	rsreset
SONG_NAME	rs.b 20

	rsreset
n_note		rs.w 1	; 0 W
n_cmd		rs.w 1	; 2 W
n_cmdlo	EQU n_cmd+1	; 3 b ; low B of cmd
n_start		rs.l 1	; 4 L
n_length	rs.w 1	; 8 W
n_loopstart	rs.l 1  ; 10 L
n_replen	rs.w 1  ; 14 W
n_period	rs.w 1	; 16 W
n_finetune	rs.b 1  ; 18 B
n_volume	rs.b 1	; 19 B
n_relvol	rs.w 1	; 20 W
n_toneportdirec	rs.b 1	; 22 B
n_toneportspeed	rs.b 1	; 23 B
n_wantedperiod	rs.w 1	; 24 W
n_vibratocmd	rs.b 1	; 26 B
n_vibratopos	rs.b 1	; 27 B
n_tremolocmd	rs.b 1	; 28 B
n_tremolopos	rs.b 1	; 29 B
n_wavecontrol	rs.b 1	; 30 B
n_glissfunk	rs.b 1	; 31 B
n_sampleoffset	rs.b 1	; 32 B
n_pattpos	rs.b 1	; 33 B
n_loopcount	rs.b 1	; 34 B
n_funkoffset	rs.b 1	; 35 B
n_wavestart	rs.l 1	; 36 L
n_reallength	rs.w 1	; 40 W
n_trigger	rs.b 1	; 42 B
n_samplenum	rs.b 1	; 43 B
n_tracktogl	rs.w 1
n_oldstart	rs.l 1
n_oldlength	rs.l 1

; -maw- Extended AudchanXtemp
n_dynflag	rs.b 1	; 44 b	; true if this sample has a dyn tab.
n_intsetloop	rs.b 1  ; 45 b  ; true if only loop part of normal sample via interrupt
n_normalsmp:	rs.b 1	; true, if normal sample should be started by audio interrupt
n_dummy:	rs.b 1
n_intcnt:	rs.w 1	; interrupt counter
n_PartTabAdr	rs.l 1	; start of this channels part table
n_DynPtr:	rs.l 1	; ptr to dyntable
n_DynPtrPre:	rs.l 1	; "hidden" dynptr (hidden so interrupt cant see it)
n_DynPartVol:	rs.w 1	; part volume of played part (pure)
n_DynOldVol:	rs.w 1	; oldvol
n_DynPlayVol:	rs.w 1	; play vol (like in "C"-cmd)
n_DmaOff:	rs.w 1	; dmacon bits with bit/set bit cleared
n_DmaOn:	rs.w 1	; dmacon bits with bit/set bit set
n_IntenaOff:	rs.w 1	; intena for stop sound
n_IntenaOn:	rs.w 1	; intena for stop sound
n_channel:	rs.w 1	; the channel this structure is for (quite useful)
n_DynLoopColor: rs.w 1	; For debugging only, colors set by interrupts.
n_DynTestColor:	rs.w 1	; For debugging only, colors set by interrupts.

n_SIZEOF	rs.w 0  ; ; -maw-


;-------------------------------------------
Startup:push	d0/a0		; save initial values
	clr.l	.retmsg
	sub.l	a1,a1
	move.l	4.w,a6
	jsr	LVOFindTask(a6)		; find us
	move.l	d0,a4
	tst.l	$ac(a4)			; pr_CLI
	beq.s	.wb			; workbench!
	pop	d0/a0			; restore regs
	bra	.end			; and run the user prog
.wb	lea	$5c(a4),a0		; pr_MsgPort
	move.l	4.w,a6
	jsr	LVOWaitPort(a6)		; wait for a message
	lea	$5c(a4),a0		; pr_MsgPort
	jsr	LVOGetMsg(a6)		; then get it
	move.l	d0,.retmsg		; save it for later reply
	nop				; command line ?
	push	d0/a0			; restore
.end	bsr.s	main			; call ProTracker
	move.l	d0,-(sp)		; save it
	tst.l	.retmsg
	beq.s	.exit			; if I was a CLI
	move.l	4.w,a6
	jsr	LVOForbid(a6)
	move.l	.retmsg(pc),a1
	jsr	LVOReplyMsg(a6)
.exit	move.l	(sp)+,d0		; exit code
	rts
	cnop	0,4
.retmsg	dc.l	0

main:	MOVE.L	SP,StackSave
	MOVE.L	4.w,A6
	lea	rb_ProgName,a1
	jsr	LVOFindTask(a6)	
	move.l	d0,TaskFlag
	SUB.L	A1,A1
	JSR	LVOFindTask(A6)
	MOVE.L	D0,PTProcess
	move.l	d0,a0
	lea	rb_ProgName(pc),a1
	move.l	a1,88(a0)		;TC_UserData

	BSR	OpenLotsOfLibs
	bsr	CheckPTtask
	bne	errorexit2
	bsr	AllocateAudio
	bne	errorexit2
	BSR	OpenLotsOfThings

	BSR	SetMusicInt	; CIA
	bne	errorexit1

	bsr	SetAudInts	; -maw-
	JSR	InitAudChan	; -maw-

	bsr	FindVersion
	BSR	SetInputHandler
	BSR	SetAutoReq
	BSR	OpenPseudoScreen
	BSR	SetVBInt
	JSR	SetPatternPos
	BSR	SetNormalPtrCol
	BSR	StorePtrCol
	JSR	ShowVolumeBar
	BSR	ShowVUMeters
	BSR	RedrawToggles
	BSR	DoShowFreeMem
	jsr	DoShowTrackToggles
	BSR	SetTempo
	BSR	SetCopList
	jsr	ClrTestColors	; -maw-
	MOVE.W	#1,notogfl
	BSR	DisplayMainScreen
	LEA	VersionText(PC),A0
	JSR	ShowStatusText
	BSR	ShowAboutReq	;show an about requester
MainLoop:
	BSR	DoKeyBuffer
	BSR	CheckTransKeys
	BSR	CheckCtrlKeys
	BSR	CheckAltKeys
	BSR	CheckKeyboard
	BSR	CheckF1_F2
	BSR	CheckF3_F5
	BSR	CheckF6_F10
	BSR	CheckPlayKeys
	BSR	ArrowKeys2
	jsr	CheckNTSCPos
	BSR	ShowTimer
	BSR	ShowFreeMem
	BSR	CheckBlockPos
	JSR	CheckSampleLength
	BSR	CheckRedraw
	btst	#2,$dff016
	bne.s	.not
	bsr	CheckRightGadgs
.not	BTST	#6,$BFE001
	BNE.S	MainLoop    		; Loop if not pressed
	TST.W	CurrScreen
	BNE.S	MainSkip
	MOVE.W	#1,notogfl
	BSR	DisplayMainScreen
	JSR	ShowAllRight
	BSR	WaitForButtonUp
MainSkip:
	BSR	ArrowKeys
	BRA	CheckGadgets

	cnop	0,4
notogfl:	dc.w 0
PTProcess:	dc.l 0
rb_CurrentDir:	dc.l 0
rb_ProgName:	dc.b "PT 3.15",0
VersionText:	dc.b 'Protracker 3.15',0
		dc.b '$VER: Protracker 3.15 (16/06/93)',0 ; version string
		cnop 0,2

CheckRedraw:
	TST.B	UpdateTempo
	BEQ.S	.redr
	CLR.B	UpdateTempo
	BSR	SetTempo
.redr	CMP.L	#'patp',RunMode
	RNE
	JSR	ShowPosition	; This one sets PattRfshNum
	TST.B	PattRfsh
	REQ
	MOVE.L	PattRfshNum,PatternNumber
	JMP	RedrawPattern

;---- Cleanup upon exit from PT ----

AskQuit:LEA	QuitPTText,A0		;display "Are you sure?" gadget
	BSR	AreYouSure		;get response
	BEQ	ExitCleanup		;if "yes" pressed -> Quit PT!
	RTS				;else just return

ExitCleanup:
	JSR	StopIt
	JSR	TurnOffVoices
	BCLR	#1,$BFE001
	bset	#1,MiscBitFlags+3	;FilterFlag
	MOVE.B	LEDStatus,D0
	AND.B	#2,D0
	OR.B	D0,$BFE001 ; Restore LED Status
	BSR	EscPressed
	BSR	EscPressed
	BSR	ResetVBInt
	BSR	ResetMusicInt
	bsr	ResetAudInts	; -maw-
	BSR	ResetInputHandler
	BSR	ResetCopList
	BSR	ResetAutoReq
	BSR	ClosePseudoScreen
errorexit1
	BSR	FreeAudioChannels
	JSR	FreeCopyBuf
.cnt3	BSR	FreeDevsList
	BSR	FreeAllDirMem
	JSR	GiveBackInstrMem
errorexit2
	jsr	ClosePPLib
	bsr.w	CloseMathLibs
	MOVE.L	4.w,A6
	MOVE.L	GfxBase,A1
	JSR	LVOCloseLibrary(A6)
	MOVE.L	IntuitionBase,A1
	JSR	LVOCloseLibrary(A6)
	MOVE.L	DosBase,A1
	JSR	LVOCloseLibrary(A6)
	MOVE.L	StackSave,SP
	MOVEQ	#0,D0
	RTS

;---- Open Lots Of Things ----

OpenLotsOfLibs:
	MOVE.L	4.w,A6
	LEA	DOSname(PC),A1		; Open DOS library
	MOVEQ	#0,D0
	JSR	LVOOpenLibrary(A6)
	MOVE.L	D0,DosBase
	beq	.error
	LEA	GraphicsName(PC),A1	; Open graphics library
	MOVEQ	#0,D0
	JSR	LVOOpenLibrary(A6)
	MOVE.L	D0,GfxBase
	beq	.error
	LEA	IntuitionName(PC),A1	; Open Intuition library
	MOVEQ	#0,D0
	JSR	LVOOpenLibrary(A6)
	MOVE.L	D0,IntuitionBase
	beq	.error
	LEA	TransName(PC),A1	; Open mathtrans library
	MOVEQ	#0,D0
	JSR	LVOOpenLibrary(A6)
	MOVE.L	D0,TransBase
	LEA	FFPName(PC),A1		; Open mathieeedubbas library
	MOVEQ	#0,D0
	JSR	LVOOpenLibrary(A6)
	MOVE.L	D0,FFPBase
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

CloseMathLibs:
	MOVE.L	4.w,A6
	MOVE.L	TransBase,d0
	beq.s	.cnt1
	move.l	d0,A1
	JSR	LVOCloseLibrary(A6)
.cnt1	MOVE.L	FFPBase,d0
	beq.s	.cnt2
	move.l	d0,A1
	JSR	LVOCloseLibrary(A6)
.cnt2	rts

OpenLotsOfThings:
	MOVE.B	$BFE001,LEDStatus
	BSET	#1,$BFE001
	bclr	#1,MiscBitFlags+3	;FilterFlag
	JSR	TurnOffVoices
	clr.l	CopListPtr

	move.l	#TextBpl,d0
	MOVE.L	D0,TextBplPtr

	move.l	#SongData,d0
	MOVE.L	D0,SongDataPtr

	MOVE.L	D0,A0
	LEA	$0014(A0),A0
	MOVEQ	#30,D0
.loop1	MOVE.W	#1,$001C(A0)
	LEA	$001E(A0),A0
	DBRA	D0,.loop1
	MOVE.L	SongDataPtr,A0
	MOVE.W	#$017F,sd_numofpatt(A0)
	MOVE.L	#'M.K.',sd_mahokakt(A0)	; M.K. again...

	MOVEQ	#6,D0
	MOVE.L	D0,CurrSpeed
	MOVE.L	#DirPathList,PathPtr
	MOVE.L	#CopListBitplanes,CopListBplPtr
	MOVE.L	#CopListColors,CopListColorPtr
	MOVE.L	#CopListBpl4,CopListBpl4Ptr
	MOVE.L	#KbdTransTable2,KeyTransTabPtr
	MOVE.L	#NoteNames1,NoteNamesPtr
	MOVE.L	#VUMeterColors,TheRightColors

	jsr	SetScrPatternPos

	lea	Topaz60Data,a0
	lea	1024(a0),a1
	move.w	#64*8-1,d1
.loop2	move.w	(a0)+,d0
	lsr.w	#4,d0
	move.w	d0,(a1)+
	dbf	d1,.loop2

	jsr	KillRainbow
	move.w	#-32,d0
	move.w	#25,d1
	move.w	#dirdragmaxlen,d2
	jsr	SetSpriteDragBar

	JSR	DoResetAll
	JSR	DoLoadConfig

	BSR	SetDefSpritePtrs
	jsr	InitSpritePos
	jsr	SetColBlock
	JSR	RedrawPattern
	JSR	ShowPosition
	JSR	ShowSongLength
	MOVE.W	#1,InsNum
	JSR	ShowSampleInfo

SetupVUCols:
	TST.W	SamScrEnable
	RNE
	LEA	CopListMark2,A0	; VUmeter coloring
	move.w	#$C3,d5
	add.w	ScrYPos,d5
	sub.w	NTSCYPos,d5
	lsl.w	#8,d5
	OR.B	#$07,D5		; Start position
	LEA	VUMeterColors,A5
	MOVEQ	#47,D7		; Change 48 lines
alotlp4	MOVE.W	D5,(A0)+
	MOVE.W	#$FFFE,(A0)+
	LEA	VUmeterColRegs(PC),A1
	MOVEQ	#1,D6
alotlp5	MOVE.W	(A5),D4
	MOVE.W	(A1)+,(A0)+
	MOVE.W	#3,FadeX
	MOVE.W	D4,D0
	JSR	FadeCol
	MOVE.W	D0,(A0)+
	MOVE.W	(A1)+,(A0)+
	MOVE.W	D4,(A0)+
	MOVE.W	(A1)+,(A0)+
	MOVE.W	#-3,FadeX
	MOVE.W	D4,D0
	JSR	FadeCol
	MOVE.W	D0,(A0)+
	DBRA	D6,alotlp5
	ADDQ.W	#2,A5
	ADD.W	#$0100,D5	; Next line...
	DBRA	D7,alotlp4
	jsr	SetScreenColors	; initialise colours
	RTS

*****************************************************************************
CheckPTtask
*****************************************************************************
	tst.l	TaskFlag
	bne.b	.PTtaskExists
	moveq	#0,d0
	rts
.PTtaskExists
	lea	TaskBodyIText(pc),a1
	bsr.w	DisplayAutoRequest
	moveq	#-1,d0
	rts
	cnop	0,4
TaskFlag	dc.l	0
*****************************************************************************
AllocateAudio:
*****************************************************************************
	lea	AudIOReply,a1
	move.l	PTProcess(pc),d0
	move.l	d0,16(a1)
	lea	AudIOReply,a1
	move.l	4.w,a6
	jsr	LVOAddPort(a6)

	lea	AudIORequest,a1
	move.b	#127,9(a1)			; LN_PRI
	move.l	#AudIOReply,14(a1)		; MN_REPLYPORT
	move.l	#ChannelMap,34(a1)		; ioa_Data
	move.l	#1,38(a1)			;ioa_Length
	move.l	#MyUnit,24(a1)			;IO_UNIT
	moveq	#0,d0				; Unit
	moveq	#0,d1				; Flags
	lea	AudioName(pc),a0
	jsr	LVOOpenDevice(a6)
	tst.l	d0
	bne	AudioError

	lea	AudIORequest,a1
	move.b	31(a1),d0			; IO_ERROR
	bne	AudioError

	move.l	20(a1),_SaveDevPtr		; IO_DEVICE
	tst.l	_SaveDevPtr
	beq	AudioError
	move.w	32(a1),_SaveAllocKey		; ioa_AllocKey
	moveq	#0,d0
	rts
*******************************************************************************
FreeAudioChannels:
*******************************************************************************
	lea	AudIORequest,a1
	move.l	_SaveDevPtr(pc),20(a1)
	move.l	#ChannelMap,24(a1)
	move.w	_SaveAllocKey(pc),32(a1)
	move.l	4.w,a6
	jsr	LVOCloseDevice(a6)

	lea	AudIORequest,a1
	move.b	31(a1),d0
	tst.b	d0
	bne.b	AudioError

CleanUpAudio:
	lea	AudIOReply,a1
	move.l	4.w,a6
	jsr	LVORemPort(a6)
	moveq	#-1,d0			; Tell error
	rts
*******************************************************************************
AudioError:	
*******************************************************************************
	cmp.l	#-11,d0
	bne.b	.OtherErr
	lea	AUDBodyIText(pc),a1	; 'Allocation error'
	bra.b	.PopReq
.OtherErr
	lea	AUDGenIText(pc),a1
.PopReq	
	bsr.b	DisplayAutoRequest
	bra.w	CleanUpAudio

*******************************************************************************
DisplayAutoRequest:			; Text to A1!!!!!
*******************************************************************************
	push	d1-d7/a0-a6
	move.l	IntuitionBase,a6
	move.l	52(a6),a0		; ib_ActiveWindow

	push	a0/a1
	move.l	56(a6),a0		; ib_ActiveScreen
	moveq	#0,d0
	move.l	40(a0),a1		; sc_Font
	move.w	4(a1),d0		; ta_YSize (in Struct TextAttr)
	addq.w	#1,d0
	add.b	35(a0),d0		; sc_WBorTop
	move.l	d0,AUDBodyIText2+4
	move.l	d0,TaskBodyIText2+4
	move.l	d0,CIABodyIText2+4
	pop	a0/a1

	suba.l	a2,a2			; AUDPosIText(pc),a2	; Posetive text
	lea	AUDNegIText(pc),a3	; Negative text
	moveq	#0,d0			; Pos Flags
	moveq	#0,d1			; Neg Flags
	moveq	#0,d2			; Width
	moveq	#0,d3			; Height
	jsr	LVOAutoRequest(a6)
	pop	d1-d7/a0-a6
	rts
	cnop	0,4
*******************************************************************************
AUDBodyIText:	dc.l	0,0,0,AudioErrorText1,AUDBodyIText2
AUDBodyIText2:	dc.l	0,0,0,AudioErrorText2,0,0

AudioErrorText1:dc.b	'Couldn''t allocate',0
		cnop	0,2
AudioErrorText2:dc.b	'the audiochannels!',0
		cnop	0,2

AUDGenIText:	dc.l	0,0,0,AudioGenErrText,0,0
AudioGenErrText:dc.b	'General audiodevice error!',0
		cnop	0,2

AUDNegIText:	dc.l	0,0,0,NegText,0
NegText:	dc.b	'Resume',0
		cnop	0,2
AudReqTitle:	dc.b	'Protracker request!',0
		cnop	0,2
****
TaskBodyIText:	dc.l	0,0,0,TaskErrorText1,TaskBodyIText2
TaskBodyIText2:	dc.l	0,0,0,TaskErrorText2,0,0
TaskErrorText1:	dc.b	'        TASK INTERFERANCE!',0
		cnop	0,2
TaskErrorText2:	dc.b	'ProTracker 3.15 is already running.',0
		cnop	0,2
****
CIABodyIText:	dc.l	0,0,0,CIAErrorText1,CIABodyIText2
CIABodyIText2:	dc.l	0,0,0,CIAErrorText2,0,0
CIAErrorText1:	dc.b	'     Unable to get CIA timer',0
		cnop	0,2
CIAErrorText2:	dc.b	'Terminate other tasks and try again.',0
		cnop	0,2

***************************************************************************
_SaveDevPtr:	dc.l	0
_SaveAllocKey:	dc.w	0
MyUnit:		dc.l	0
ChannelMap:	dc.b	15	;dc.b	1,8,2,4
		cnop	0,2
*******************************************************************************
VUmeterColRegs
	dc.w	$01B2,$01B4,$01B6,$01BA,$01BC,$01BE

CopListBpl4Ptr	dc.l	0
CopListPtr	dc.l	0
CopListBplPtr	dc.l	0
CopListColorPtr	dc.l	0

DOSname:	dc.b	'dos.library',0
IntuitionName:	dc.b	'intuition.library',0
GraphicsName:	dc.b	'graphics.library',0
TransName:	dc.b	'mathtrans.library',0
FFPName:	dc.b	'mathffp.library',0
AudioName:	dc.b	'audio.device',0
		cnop	0,2

SetSamSpritePtrs
	MOVE.L	#LoopSpriteData1,Ch1SpritePtr
	MOVE.L	#LoopSpriteData2,Ch2SpritePtr
	MOVE.L	#PlayPosSpriteData,Ch3SpritePtr
	MOVE.L	#NoSpriteData,Ch4SpritePtr
	BRA.S	sdsp2
SetDefSpritePtrs
	MOVE.L	#VUSpriteData1,Ch1SpritePtr
	MOVE.L	#VUSpriteData2,Ch2SpritePtr
	MOVE.L	#VUSpriteData3,Ch3SpritePtr
	MOVE.L	#VUSpriteData4,Ch4SpritePtr
sdsp2	MOVE.L	#DragBarSpriteData,DragBarPosPtr
	MOVE.L	#PointerSpriteData,PointerSpritePtr
	MOVE.L	#LineCurSpriteData,LineCurPosPtr
	MOVE.L	#ColBlockSpriteData,ColSpritePtr
	MOVE.L	PointerSpritePtr,SpritePtrsPtr

SetSpriteAdr
	LEA	SpritePtrsPtr,A0	; Set pointers to spritedata
	LEA	CopList,A1
	MOVEQ	#16-1,D2
alotloop2
	MOVE.W	(A0)+,2(A1)
	ADDQ.L	#4,A1
	DBRA	D2,alotloop2
	RTS

	cnop	0,4
PointerSpritePtr
	dc.l	0

;---- AutoRequest() ----

SetAutoReq
	MOVE.L	4.w,a6
	JSR	LVOForbid(A6)

	MOVE.L	IntuitionBase,A1
	MOVE.L	#NewAutoRequest,D0
	MOVE.L	#LVOAutoRequest,A0
	JSR	LVOSetFunction(A6)
	MOVE.L	D0,AutoReqSave

	cmp.w	#36,KickVersion
	bmi.s	.contvers

	MOVE.L	IntuitionBase,A1
	MOVE.L	#NewEasyRequest,D0
	MOVE.L	#LVOEasyRequestArgs,A0
	JSR	LVOSetFunction(A6)
	MOVE.L	D0,EasyReqSave

	MOVE.L	IntuitionBase,A1
	MOVE.L	#NewFreeSysRequest,D0
	MOVE.L	#LVOFreeSysRequest,A0
	JSR	LVOSetFunction(A6)
	MOVE.L	D0,FreeSysReqSave

	MOVE.L	IntuitionBase,A1
	MOVE.L	#NewBuildSysRequest,D0
	MOVE.L	#LVOBuildSysRequest,A0
	JSR	LVOSetFunction(A6)
	MOVE.L	D0,BuildSysReqSave

	MOVE.L	IntuitionBase,A1
	MOVE.L	#NewEndRequest,D0
	MOVE.L	#LVOEndRequest,A0
	JSR	LVOSetFunction(A6)
	MOVE.L	D0,EndReqSave
.contvers
	JSR	LVOPermit(A6)
	RTS

ResetAutoReq
	MOVE.L	4.w,a6
	JSR	LVOForbid(A6)

	MOVE.L	IntuitionBase,A1
	MOVE.L	AutoReqSave(PC),D0
	MOVE.L	#LVOAutoRequest,A0
	JSR	LVOSetFunction(A6)

	cmp.w	#36,KickVersion
	bmi.s	.contvers

	MOVE.L	IntuitionBase,A1
	MOVE.L	EasyReqSave(PC),D0
	MOVE.L	#LVOEasyRequestArgs,A0
	JSR	LVOSetFunction(A6)

	MOVE.L	IntuitionBase,A1
	MOVE.L	FreeSysReqSave(PC),D0
	MOVE.L	#LVOFreeSysRequest,A0
	JSR	LVOSetFunction(A6)

	MOVE.L	IntuitionBase,A1
	MOVE.L	BuildSysReqSave(PC),D0
	MOVE.L	#LVOBuildSysRequest,A0
	JSR	LVOSetFunction(A6)

	MOVE.L	IntuitionBase,A1
	MOVE.L	EndReqSave(PC),D0
	MOVE.L	#LVOEndRequest,A0
	JSR	LVOSetFunction(A6)
.contvers
	JSR	LVOPermit(A6)
	RTS

NewAutoRequest
	TST.W	MountFlag
	JNE	PositiveReturn
	TST.B	ReqRunning
	BNE.S	JustAutoReq
	addq.b	#1,ReqRunning
	MOVE.L	A0,-(SP)
	bsr	ResetCopList
	MOVE.L	(SP)+,A0
	pea	ReqReturn(pc)
	move.l	AutoReqSave(pc),-(sp)
	rts
JustAutoReq
	addq.b 	#1,ReqRunning
	pea	ReqReturn(pc)
	move.l	AutoReqSave(pc),-(sp)
	rts

NewEasyRequest
	TST.W	MountFlag
	JNE	PositiveReturn
	TST.B	ReqRunning
	bne.S	JustBEReq
	addq.b 	#1,ReqRunning
	MOVE.L	A0,-(SP)
	bsr	ResetCopList
	MOVE.L	(SP)+,A0
	pea	ReqReturn(pc)
	move.l	EasyReqSave(pc),-(sp)
	rts
JustBEReq
	addq.b 	#1,ReqRunning
	pea	ReqReturn(pc)
	move.l	EasyReqSave(pc),-(sp)
	rts

NewBuildSysRequest
	TST.W	MountFlag
	JNE	PositiveReturn
	TST.B	ReqRunning
	bne.S	JustBSReq
	addq.b 	#1,ReqRunning
	MOVE.L	A0,-(SP)
	bsr	ResetCopList
	MOVE.L	(SP)+,A0
	move.l	BuildSysReqSave(pc),-(sp)
	rts
JustBSReq
	addq.b 	#1,ReqRunning
	move.l	BuildSysReqSave(pc),-(sp)
	rts

NewFreeSysRequest
	pea	ReqReturn(pc)
	move.l	FreeSysReqSave(pc),-(sp)
	rts

NewEndRequest
	pea	ReqReturn(pc)
	move.l	EndReqSave(pc),-(sp)
	rts

ReqReturn
	subq.b	#1,ReqRunning
	RNE
	bra	SetCopList

	cnop	0,4
AutoReqSave
	dc.l	0
EasyReqSave
	dc.l	0
BuildSysReqSave
	dc.l	0
FreeSysReqSave
	dc.l	0
EndReqSave
	dc.l	0

;----------------------------------------

; v33 = Kick1.2
; v34 = Kick1.3
; v35 = Kick1.3 NTSC
; v36 = Kick2.0b
; v37 = Kick2.04

FindVersion
	move.w	#33,KickVersion
	moveq	#34,d0
	bsr	TestVers
	beq.s	.cnt
	move.w	#34,KickVersion
	moveq	#36,d0
	bsr	TestVers
	beq.s	.cnt
	move.w	#36,KickVersion
.cnt	rts
	cnop	0,4
KickVersion	dc.w	0

TestVers
	move.l	4.w,a6
	lea	IntuitionName,a1
	jsr	LVOOpenLibrary(a6)
	tst.l	d0
	beq.b	.notvrs
	move.l	d0,a1
	jsr	LVOCloseLibrary(a6)
	moveq	#-1,d0
	rts
.notvrs	moveq	#0,d0
	rts

;---- The Pseudoscreen ----

OpenPseudoScreen
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	IntuitionBase,a6
	lea	ScreenDefs(pc),a0
	jsr	-198(a6)	;OpenScreen()
	move.l	d0,PsScrHnd
	movem.l	(sp)+,d0-d7/a0-a6
	rts

ClosePseudoScreen
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	IntuitionBase,a6
	move.l	PsScrHnd,a0
	cmp.l	#0,a0
	beq.s	NoPSCls
	jsr	-66(a6)		;CloseScreen()
NoPSCls:movem.l	(sp)+,d0-d7/a0-a6
	rts

WaitForActivate:
	movem.l	d0-d7/a0-a6,-(sp)
	tst.l	PsScrHnd
	beq.b	NoFSWait
WaitFSLoop:
	move.l	DosBase,a6
	moveq	#10,d1
	jsr	LVODelay(a6)
	move.l	IntuitionBase,a6
	move.l	60(a6),d0		;ib_FirstScreen
	cmp.l	PsScrHnd,d0
	bne.s	WaitFSLoop
NoFSWait:
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	cnop	0,4
; Pseudoscreen defs
ScreenDefs:
	dc.w	0,0			;upper left corner
	dc.w	640,12			;lower right corner
	dc.w	1			;depth
	dc.b	0,1			;textcolor, backgroundcolor
	dc.w	$8000			;viewmode=MED-RES
	dc.w	15			;screen=custom screen
	dc.l	0			;font pointer=no font (standard)
	dc.l	HeadLin			;pointer to headlinetext
	dc.l	0			;gadget pointer
	dc.l	0			;bitmap pointer (no)

PsScrHnd:	dc.l	0
HeadLin:dc.b	"Protracker 3.15",0
	even

;---- Copper List ----

SetCopList:
	movem.l d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	sub.l	a1,a1
	jsr	LVOLoadView(a6)
	jsr	LVOWaitTOF(a6)
	jsr	LVOWaitTOF(a6)
	jsr	SetExtSync
	move.l	#CopList,CopListPtr
	MOVE.L	#CopList,$DFF080
	move.w	#0,$dff088
	movem.l (sp)+,d0-d7/a0-a6
	RTS

ResetCopList:
	movem.l d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	move.l	IntuitionBase,a1
	lea	ib_ViewLord(a1),a1
	jsr	LVOLoadView(a6)
	jsr	LVOWaitTOF(a6)
	jsr	LVOWaitTOF(a6)
	move.l	GfxBase,a0
	move.l	gb_copinit(a0),CopListPtr
	move.l	gb_copinit(a0),$dff080
	move.w	#0,$dff088
	movem.l (sp)+,d0-d7/a0-a6
	RTS

;---- Vertical Blank Interrupt ----

SetVBInt:
	MOVEQ	#5,D0
	LEA	VBIntServer,A1
	MOVE.L	4.w,a6
	JSR	LVOAddIntServer(A6)
	MOVEQ	#4,D0
	LEA	CopIntServer,A1
	MOVE.L	4.w,a6
	JSR	LVOAddIntServer(A6)
	move.w	#-1,VBIntOn
	RTS

ResetVBInt:
	tst.w	VBIntOn
	REQ
	clr.w	VBIntOn
	MOVEQ	#5,D0
	LEA	VBIntServer,A1
	MOVE.L	4.w,a6
	JSR	LVORemIntServer(A6)
	MOVEQ	#4,D0
	LEA	CopIntServer,A1
	MOVE.L	4.w,a6
	JSR	LVORemIntServer(A6)
	RTS


DoFileInv:
	movem.l	d0-d3/a0/a5,-(sp)
	move.l	FileNamesPtr(pc),a5
	tst.w	FileInvOn
	bne.b	ikkedo2
	movem.w	MouseX,d0/d1
	lea	DirGadgetsList,a0
	move.b	#$ff,NoInvFlag
	jsr	GetGadgetInt
	clr.b	NoInvFlag
	bsr.w	SlettGamle
	cmp.w	#38,d2			;File Area (no.38)
	bne.s	ikkedo3
	sub.w	#3,d1			; upper border
	ext.l	d1
	divu	#6,d1
	cmp.w	#19,d1			;take care of some shit
	beq.s	ikkedo3
	cmp.w	di_Entries(a5),d1
	bge.s	ikkedo3
	move.w	forrigeinv,d2
	cmp.w	d1,d2			;still same?
	beq.s	ikkedo2
	move.w	d1,forrigeinv		;this one is now the last
	bsr.s	dothefileinv
	bra.s	ikkedo2
ikkedo3	move.w	#-1,forrigeinv		;no ivert => no clear!
ikkedo2	movem.l	(sp)+,d0-d3/a0/a5
	rts
	cnop	0,4
FileInvOn:dc.w -1

SlettGamle:      ; ??? argh - what is this? norge? ppl!
	movem.w	d0-d7,-(sp)
	cmp.w	#-1,forrigeinv
	beq.s	rettslett
	cmp.w	#38,d2
	bne.s	dodaslett
	sub.w	#3,d1			; upper border
	divu	#6,d1
	move.w	forrigeinv,d2
	cmp.w	d1,d2			;still same?
	beq.s	rettslett
dodaslett:
	bsr.s	dothefileinv
rettslett:
	movem.w	(sp)+,d0-d7
	rts

dothefileinv:
	move.w	forrigeinv,d1
	mulu	#6,d1
	add.w	#3,d1			; upper border
	lea	BitPlaneData+40,a0
	mulu	#80,d1
	lea	(a0,d1.w),a0
	move.w	#7-1,d2
fcplop1	move.w	#37-1,d3
	move.b	(a0),d0
	eor.b	#%00111111,d0
	move.b	d0,(a0)+
fcplop2	eor.b	#$ff,(a0)+
	dbf	d3,fcplop2
	lea	42(a0),a0
	dbf	d2,fcplop1
	rts
	cnop	0,4
forrigeinv:	dc.w	-1

VBInt:	MOVEM.L	D0-D7/A0-A6,-(SP)
	BSR	UpdatePointerPos
	BSR	VUmeters
	tst.l	CopListPtr
	beq.s	.not
	move.l	CopListPtr,$dff080
.not	cmp.w	#DirScreen_ID,CurrScreen
	bne.s	.ikkedo
	bsr.w	DoFileInv
.ikkedo	BSR	ArrowKeys         ; ikkedo? Aikido? Karate? Mikado?
	bsr	DoKeyRepeat
	BSR	UpdateTicks
	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

;-- -maw- now we do the scope in a Softint :-)
CopInt:	movem.l	d0-a6,-(sp)
	bsr.s	.doint
	movem.l	(sp)+,d0-a6
	rts
.doint	btst	#3,MiscBitFlags+3	; Softint?
	beq.w	Scope			; if not, just do the copper int
	lea	ScopeintHandler,a1      ; cause the soft int
	move.l	4.w,a6
	jsr	-180(a6)
	rts

SoftScope:
	MOVEM.L	D0-D7/A0-A6,-(SP)
	BSR	Scope	
	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

;---- Level 3 interrupts -----

VBIntServer:
	dc.l	0,0
	dc.b	2,0 			; type, priority
	dc.l	.name
	dc.l	0,VBInt
.name	dc.b	"PT3.15 VBInt",0
	cnop	0,2

VBIntOn:dc.w	0

CopIntServer:
	dc.l	0,0
	dc.b	2,0 			; type, priority
	dc.l	.name
	dc.l	0,CopInt
.name	dc.b	"PT3.15 CopInt",0
	cnop	0,2

;---- Softint for updating pattern

PatternSoftintHandler:
	dc.l	0,0
	dc.b	NT_INTERRUPT,-32 			; type, priority
	dc.l	.name
	dc.l	0,Patternint
.name	dc.b	"PT3.15 Pattern SoftInt",0
	cnop	0,2

Patternint:
	movem.l	d0-a6,-(sp)
	CMP.L	#'patp',RunMode
	bne.s	.exit
	TST.W	SamScrEnable
	bne.s	.exit
	MOVE.L	SongDataPtr,A0			;pointer to moduledata	
	LEA	952(A0),A0			;adress of pos-table
	ADD.L	CurrPos,A0			;get current pattern
	moveq	#0,d0
	MOVE.B	(A0),d0
	cmp.l	PatternNumber,d0
	beq.s	.exit
	MOVE.L	d0,PatternNumber
	JSR	DoRedrawPattern
.exit	movem.l	(sp)+,d0-a6
	rts

;---- Softint for music routine caused by CIA -maw-

SoftintHandler
	dc.l 0,0
	dc.b NT_INTERRUPT,32 			; type, priority
	dc.l softintname
	dc.l 0,Softint
softintname
	dc.b "PT3.15 Music SoftInt",0
	cnop	0,2

Softint:;btst	#2,ScrnBitFlags+3
	;beq.s	.notestcol
	;move.w	SoftintTestColor,_custom+COLOR00	; a0 is NOT _custom !!!
.notestcol:
	jmp	IntMusic

;----- Softint for scope caused by Copper -maw-

ScopeintHandler:
	dc.l 0,0
	dc.b NT_INTERRUPT,-32 			; type, priority
	dc.l scopeintname
	dc.l 0,Scopeint
scopeintname:
	dc.b "PT3.15 Scope SoftInt",0
	cnop	0,2

Scopeint:
	;btst	#2,ScrnBitFlags+3
	;beq.s	.notestcol
	;move.w	#$FF0,_custom+COLOR00	; yellow
.notestcol:
	jsr	SoftScope
	;btst	#2,ScrnBitFlags+3
	;beq.s	.norc
	;move.w	ColorTable,_custom+COLOR00
.norc:	rts
	

;*** AUDIO INTERRUPTS -maw- ***

;-- interrupt structures --

Aud0IntStruct
	dc.l 0,0
	dc.b NT_INTERRUPT,0        		; type, priority
	dc.l aud0intname
	dc.l audchan1temp,aud0int
aud0intname
	dc.b "PT3.15 Aud0Int",0
	cnop	0,2
Aud1IntStruct
	dc.l 0,0
	dc.b NT_INTERRUPT,0        		; type, priority
	dc.l aud1intname
	dc.l audchan2temp,aud1int
aud1intname
	dc.b "PT3.15 Aud1Int",0
	cnop	0,2
Aud2IntStruct
	dc.l 0,0
	dc.b NT_INTERRUPT,0        		; type, priority
	dc.l aud2intname
	dc.l audchan3temp,aud2int
aud2intname
	dc.b "PT3.15 Aud2Int",0
	cnop	0,2
Aud3IntStruct
	dc.l 0,0
	dc.b NT_INTERRUPT,0        		; type, priority
	dc.l aud3intname
	dc.l audchan4temp,aud3int
aud3intname
	dc.b "PT3.15 Aud3Int",0
	cnop	0,2

;-- macros (I am lazy :-)

SetAudIntVec MACRO intnum,intstruct,oldintstruct
	moveq	\1,d0
	move.l	\2,a1
	move.l	4.w,a6
	jsr	-162(a6)	; SetIntVector
	move.l	d0,\3
	ENDM

RemAudIntVec MACRO
	moveq	\1,d0
	move.l	\2,a1	
	move.l	4.w,a6
	jsr	-162(a6)	; SetIntVector
	ENDM

;-- Install/remove code

SetAudInts:
	move.w	#$0780,_custom+intena ; -maw- ; turn off all interrupts!
        SetAudIntVec #INTB_AUD0,#Aud0IntStruct,OldAud0Int
        SetAudIntVec #INTB_AUD1,#Aud1IntStruct,OldAud1Int
        SetAudIntVec #INTB_AUD2,#Aud2IntStruct,OldAud2Int
        SetAudIntVec #INTB_AUD3,#Aud3IntStruct,OldAud3Int
	rts

ResetAudInts:
        RemAudIntVec #INTB_AUD0,OldAud0Int
        RemAudIntVec #INTB_AUD1,OldAud1Int
        RemAudIntVec #INTB_AUD2,OldAud2Int
        RemAudIntVec #INTB_AUD3,OldAud3Int
	rts

;*********** AUDIO INTERRUPTS ************************************

; Note: these interrupts are NOT interrupting each other (this is tested)
; dynint may destroy : d0,d1,a0,a1,a5,a6 and must end with rts
; dynint will find in:
	; d1 = intena AND intreqr
	; a0 = custom
	; a1 = isdata, = audchanXtemp
	; a5 = ptr to own code
	; a6 = execbase
aud0int:
	lea	AUD0+0*AUDOFS(a0),a6	; custom+aud0 (=Aud0Ptr)
	bra.s	channelint	
aud1int:
	lea	AUD0+1*AUDOFS(a0),a6	
	bra.s	channelint
aud2int:
	lea	AUD0+2*AUDOFS(a0),a6	
	bra.s	channelint
aud3int:
	lea	AUD0+3*AUDOFS(a0),a6	
;	bra.s	channelint

channelint:
	move.l	a0,a5	; custom
	move.w	#$4000,intena(a5)	; disable all other interrupts
	tst.b	n_normalsmp(a1)		; start normal sample?
	bne	.start_normal
	tst.b	n_dynflag(a1)   	; start dyn sample ?
	beq	.red_error
;--- D Y N   S A M P L E -----
	move.w	n_intcnt(a1),d0		; first interrupt after enable?
	bne.s	.dynpart2
.dynpart0:
	;move.w	n_DynTestColor(a1),COLOR00(a5)	

	btst	#3,DiskBitFlags+2	; UNDYN TEST
	beq.s	.dnowait
	;move.w	#$07F,COLOR00(a5)
	moveq	#80,d1
	jsr	_Wait1line
.dnowait:
	move.l	n_DynPtr(a1),d1		; if ptr is zero, kill da sound
	beq	.red_error
	move.l	d1,a0   		; a0 = ptr	
	tst.l	(a0)			; test part adress
	ble	.red_error		; do not start if zero or negative
	move.w	6(a0),d1                ; get part volume
	addq.l	#8,n_DynPtr(a1)		; increment the dyn ptr
	move.w	d1,n_DynOldVol(a1)	; next part still has this part volume
	move.w	d1,n_DynPartVol(a1)	; this part volume
	bsr.s	.dynvol_sub		; calculate the volume
	move.w	d1,AUDVOL(a6)		; put it into AUDVOL
	move.w	n_period(a1),AUDPER(a6)	; set the period now
	move.w	n_DmaOn(a1),dmacon(a5)	; dma on
	move.w	n_IntenaOff(a1),intreq(a5)	; clear da intreq bit
	bra	.exit
;------------
.dynvol_sub:
	move.w	n_DynPlayVol(a1),d0	; this is n_volume*RelVolume/64
	bne.s	.nz			; if it is not zero
	moveq	#0,d1           	; if play volume is zero, real part volme is also 0
	bra.s	.vok
.nz:	tst.w	d1			; is the part volume zero?
	beq.s	.vok			; then it really should be zero!
	mulu.w	d0,d1
	add.w	#32,d1			; use rounding
	lsr.w	#6,d1		
	bne.s	.vok        		; but don't let it go zero...
	moveq	#1,d1			; it should be 1 at least
.vok:	rts	
;--------------
.dynpart2:
	;move.w	n_DynLoopColor(a1),COLOR00(a5)	; dark yellow
	move.w	n_IntenaOff(a1),intreq(a5)	; clear da intreq bit

	move.w	n_DynOldVol(a1),d1      ; part volume for this part
	move.w	d1,n_DynPartVol(a1)	; this is the actual pure part volume
        bsr.s	.dynvol_sub		; take actual settings
	move.w	d1,AUDVOL(a6)		; volume into AUDxVOL

	move.l	n_DynPtr(a1),d1		; if ptr is zero, kill da sound
	beq.s	.kill
	move.l	d1,a0   		; a0 = ptr	
.scan:	move.l	(a0)+,d1		; get next part adress
	bgt.s	.norm			; if it was negative, it is the loop offset
	beq.s	.quiet       		; if next is zero, prepare to make quiet
	add.l	d1,a0                   ; add this negative offset
	bra.s	.scan
.norm:	move.l	d1,AUDPTR(a6)		; put it into AUDxPTR
	move.w	(a0)+,AUDLEN(a6)	; put part_length into AUDxLEN
	move.w	(a0)+,n_DynOldVol(a1)	; keep the pure part volume
	move.l	a0,n_DynPtr(a1)		; increment the dyn ptr
	bra	.exit			; go on with next channel
;-------
.quiet:	move.l	#Silence,AUDPTR(A6)	; put into AUDxPTR
	move.w	#16,AUDLEN(A6)		; AUDxLEN will be 1
	move.w	d1,n_DynOldVol(A1)	; next volume will be 0
	move.l	d1,n_DynPtr(a1)		; clr the dyn pointer (d1 is still zero)
	bra	.exit
;-------
.kill:	move.w	n_IntenaOff(a1),intena(a5)	; disable Audio interrupt
	move.w	n_DmaOff(a1),dmacon(a5)      	; DMA off
	sf	n_dynflag(a1)			; export the ready status
	clr.w	n_DynOldVol(a1)
	clr.w	n_DynPartVol(a1)
	move.w	d1,AUDVOL(A6)			; d1 is zero here
;	move.w	d1,AUDDAT(A6)
	move.w	#1,AUDPER(A6)
	bra	.exit

;--------- N O R M A L   S A M P L E ---------------------------

.start_normal:
	tst.w	n_intcnt(a1)		; first interrupt after enable?
	beq.s	.part1
	cmp.w	#1,n_intcnt(a1)		; was the first set already?
	beq.s	.part2
	bra	.red_error
;-- SET FIRST PART -----------------------------
.part1:	;move.w	n_DynTestColor(a1),COLOR00(a5)	; dark red

	btst	#3,DiskBitFlags+2	; UNDYN TEST
	beq.s	.nnowait
	;move.w	#$07F,COLOR00(a5)	
	moveq	#80,d1
	jsr	_Wait1line
.nnowait:
	moveq	#0,d0
	move.b	n_volume(a1),d0         ; volume is a byte only!
	mulu	n_relvol(a1),d0
	add.w	#32,d0		
	lsr.w	#6,d0
	move.w	d0,AUDVOL(a6)
	move.w	n_DmaOn(a1),dmacon(a5)		; dma on
	move.w	n_IntenaOff(a1),intreq(a5)	; clear da intreq bit
	move.w	n_period(a1),AUDPER(a6)		; before dma on or after?
	bra	.exit
;-- SET LOOP PART ------------------------
.part2:	;move.w	n_DynLoopColor(a1),COLOR00(a5)		; dark yellow
	move.w	n_IntenaOff(a1),intreq(a5)	; clear da intreq bit
	move.w	n_IntenaOff(a1),intena(a5)	; switch off this audio interrupt
	clr.b	n_normalsmp(a1)			; clear da flag
	move.l	n_loopstart(a1),AUDPTR(a6)	; set loopstart
	move.w	n_replen(a1),AUDLEN(A6)		; set replen
;	bra	exit
;--------------------
.exit:	addq.w	#1,n_intcnt(a1)
	;move.w	ColorTable,COLOR00(a5) 	; clear test color again
	move.w	#$C000,intena(a5)	; all other interrupts allowed again
	rts
;----------------------------
.red_error:
	move.w	#-1,d0			
.wsns:	move.w	d0,d1
	and.w	#$F00,d1                ; redish error colors
	;move.w	d1,COLOR00(a5)
	dbra	d0,.wsns
	move.w	n_IntenaOff(a1),intena(a5)	; audio interrupts off
	clr.b	n_normalsmp(a1)
	clr.b	n_dynflag(a1)
	bra.s	.exit

;---- Music Interrupt ----

SetMusicInt:
	bset	#0,MiscBitFlags+3	;IntMode
	bsr	SetCIAInt
	bne.s	.error
	moveq	#0,d0
	RTS
.error	moveq	#-1,d0
	rts

ResetMusicInt:
	bsr	ResetCIAInt
	RTS

MusicCIAIntServer:
	dc.l	0,0
	dc.b	2,16			 ; type, priority
	dc.l	musintname2
	dc.l	0,CIAIntMusic

musintname2:	dc.b "Protracker CIA MusicInt",0
	cnop	0,2

;---- CIA Interrupt ----

ciatalo = $400
ciatahi = $500
ciatblo = $600
ciatbhi = $700
;ciaicr	= $D00
ciacra  = $E00
ciacrb  = $F00

SetCIAInt:
	LEA	$BFD000,A5
	MOVE.B	#'b',CIAAname+3
	bsr	SetCIA
	bne.s	.cnt1
	bsr	TryTimerA
	beq.s	.end
	bsr	TryTimerB
	beq.s	.end
.cnt1	MOVE.B	#'a',CIAAname+3
	LEA	$BFE001,A5
	bsr	SetCIA
	bne.s	.cnt2
	bsr	TryTimerA
	beq.s	.end
	bsr	TryTimerB
	beq.s	.end
.cnt2	CLR.L	CIAAbase
	tst.l	CopListPtr
	bne.b	.skip
	lea	CIABodyIText(pc),a1
	bsr.w	DisplayAutoRequest	; if all timers fail.
.skip	moveq	#-1,d0
	rts
.end	moveq	#0,d0
	rts

SetCIA:	MOVEQ	#0,D0
	LEA	CIAAname(PC),A1
	MOVE.L	4.w,a6
	JSR	LVOOpenResource(A6)
	MOVE.L	D0,CIAAbase
	BEQ	CIAError
	MOVE.L	D0,A6

	MOVE.L	GfxBase,A0
	MOVE.W	206(A0),D0		; DisplayFlags
	BTST	#2,D0			; PAL/NTSC?
	BEQ.S	.NTSC
	MOVE.L	#1773447,D7 		; PAL
	BRA.S	.skip
.NTSC	MOVE.L	#1789773,D7 		; NTSC
.skip	MOVE.L	D7,TimerValue
	DIVU	#125,D7 		; Default to normal 50 Hz timer
	moveq	#0,d0
	rts
TryTimerB:
	LEA	MusicCIAIntServer(PC),A1
	MOVEQ	#1,D0			; Bit 1: Timer B
	JSR	AddICRVector(A6)
	MOVE.L	#1,TimerFlag
	TST.L	D0
	BNE.S	CIAError
	MOVE.L	A5,CIAAaddr
	clr.b	ciacrb(a5)
	MOVE.B	D7,ciatblo(A5)
	LSR.W	#8,D7
	MOVE.B	D7,ciatbhi(A5)
	moveq	#0,d0
	rts
TryTimerA:
	LEA	MusicCIAIntServer(PC),A1
	MOVEQ	#0,D0			; Bit 0: Timer A
	JSR	AddICRVector(A6)
	CLR.L	TimerFlag
	TST.L	D0
	BNE.S	CIAError
	MOVE.L	A5,CIAAaddr
	clr.b	ciacra(a5)
	MOVE.B	D7,ciatalo(A5)
	LSR.W	#8,D7
	MOVE.B	D7,ciatahi(A5)
	moveq	#0,d0
	rts
CIAError:moveq	#-1,d0
	rts
	
ResetCIAInt:
	MOVE.L	CIAAbase,D0
	REQ
	CLR.L	CIAAbase
	MOVE.L	D0,A6
	MOVE.L	CIAAaddr(PC),A5
	TST.L	TimerFlag
	BEQ.S	.timerA
.timerB	BCLR	#0,ciacrb(A5)
	MOVEQ	#1,D0
	BRA.S	RemInt
.timerA	BCLR	#0,ciacra(A5)
	MOVEQ	#0,D0
RemInt:	LEA	MusicCIAIntServer(PC),A1
	MOVEQ	#0,d0
	JSR	RemICRVector(A6)
	RTS

	cnop	0,4
CIAAname:	dc.b 'ciaa.resource',0
CIAAbase:	dc.l 0
TimerFlag:	dc.l 0
TimerValue:	dc.l 0

;---- Tempo ----

ChangeTempo:
	CMP.W	#94,D0
	BHS.S	TempoDown
	CMP.W	#80,D0
	BHS.S	TempoUp
	RTS

TempoUp:MOVE.W	Tempo,D0
	ADDQ.W	#1,D0
	BTST	#2,$DFF016
	BNE.S	.skip
	ADDQ.W	#8,D0
	ADDQ.W	#1,D0
.skip	CMP.W	#255,D0
	BLS.S	temposk
	MOVE.W	#255,D0
temposk	MOVE.W	D0,Tempo
	MOVE.W	D0,RealTempo
	BSR.S	ShowTempo
	BSR.S	SetTempo
	JMP	Wait_4000

TempoDown:
	MOVE.W	Tempo,D0
	SUBQ.W	#1,D0
	BTST	#2,$DFF016
	BNE.S	.skip
	SUBQ.W	#8,D0
	SUBQ.W	#1,D0
.skip	CMP.W	#32,D0
	BHS.S	temposk
	MOVE.W	#32,D0
	BRA.S	temposk

ShowTempo:
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	MOVE.W	#3*80+19,TextOffset
	MOVE.W	RealTempo(PC),WordNumber
	JMP	Print3DecDigits

SetTempo:
	MOVEQ	#125,D0
	MOVE.L	CIAAbase,D1
	BEQ.S	.skip3
	btst	#0,MiscBitFlags+3	;IntMode
	beq.s	.cnt1
	MOVE.W	RealTempo(PC),D0
.cnt1	CMP.W	#32,D0
	BHS.S	.skip1
	MOVEQ	#32,D0
.skip1	btst	#0,MiscBitFlags+3	;IntMode
	beq.s	.skip3
	MOVE.W	D0,RealTempo
.skip3	TST.W	SamScrEnable
	BNE.S	.skip2
	MOVE.W	D0,WordNumber
	move.w	#605,AnyTextPos
	move.w	#143,AnyTextPos+2
	JSR	PrintAny3DecDigits	; show timer value
.skip2	MOVE.L	CIAAbase,D0
	REQ
	moveq	#125,d0
	btst	#0,MiscBitFlags+3	;IntMode
	beq.s	.cnt2			; eq = VB
	MOVE.W	RealTempo(PC),D0
.cnt2	MOVE.L	TimerValue(PC),D1
	DIVU	D0,D1
	MOVE.L	CIAAaddr(PC),A5
	MOVE.L	TimerFlag(PC),D0
	BEQ.S	.timera
	move.b	#%00010001,ciacrb(a5)	; TimerB (continous)
	MOVE.B	D1,ciatblo(A5)	;and set the CIA timer
	LSR.W	#8,D1
	MOVE.B	D1,ciatbhi(A5)
	RTS
.timera	move.b	#%00010001,ciacra(a5)	; TimerA (continous)
	MOVE.B	D1,ciatalo(A5)
	LSR.W	#8,D1
	MOVE.B	D1,ciatahi(A5)
	RTS

	cnop	0,4
RealTempo:	dc.w	125
CIAAaddr:	dc.l	0

;---- Input Event Handler ----

;hsi!genly!ang!thanos@uunet.uu.net (Thanos Angelopoulos) has written this
;patch to make the input handler code work with 2.04. This in not in the
;current 1.2 source. You should put it there yourself, and change my code
;to use DoIO instead.

SetInputHandler:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	$4.w,a6
	lea	InpEvPort,a1
	move.l	a1,-(sp)
	moveq	#-1,d0
	jsr	-330(a6)		;allocate the next free signal in this
	move.l	d0,d2			;task -> save it in d2
	sub.l	a1,a1			;task: this one :)
	jsr	-294(a6)
	move.l	(sp)+,a1		;port addr
	clr.b	9(a1)			;LN_PRI
;	move.b	#50,9(a1)
	move.l	#inpevname,10(a1)	;private port name
	move.b	#4,8(a1)		;node type = MSGPORT
	move.b	d2,15(a1)		;this signal (MP_SigBit)
	move.l	d0,16(a1)		;this task (MP_SigTask)
	jsr	-354(a6)		;add the message-port
	movem.l	(sp)+,d0-d7/a0-a6
	move.l	$4.w,a6
	LEA	InputDevName,A0
	MOVEQ	#0,D0
	LEA	InpEvIOReq,A1
	MOVEQ	#0,D1
	MOVE.L	#InpEvPort,14(A1)
	JSR	LVOOpenDevice(A6)
	tst.l	d0
	bne.s	nodev	
	LEA	InpEvIOReq,A1
	MOVE.W	#9,IO_COMMAND(A1) 	; IND_ADDHANDLER
	MOVE.L	#InpEvStuff,IO_DATA(A1)
	JSR	LVODoIO(A6)
	RTS

nodev:	jmp	$fc0000

ResetInputHandler:
	MOVE.L	4.w,a6
	LEA	InpEvIOReq,A1
	MOVE.W	#10,IO_COMMAND(A1) 	; IND_REMHANDLER
	MOVE.L	#InpEvStuff,IO_DATA(A1)
	JSR	LVODoIO(A6)
	LEA	InpEvIOReq,A1
	JSR	LVOCloseDevice(A6)
	LEA	InpEvPort,A1
	JSR	LVORemPort(A6)
	RTS

	cnop	0,4
InpEvStuff:
	dc.l	0,0
	dc.b	2,52 			; type, priority
	dc.l	inpevname
	dc.l	0,InputHandler

inpevname:
	dc.b "Protracker InputHandler",0

InputHandler: 				; A0-InputEvent, A1-Data Area
	MOVE.L	A2,-(SP)
	TST.B	ReqRunning
	BNE.S	inphend
	SUB.L	A2,A2
	MOVE.L	A0,A1
	MOVE.B	4(A1),D0 		; ie_Class
	CMP.B	#1,D0    		; RAWKEY
	BEQ.S	InpRawkey
	CMP.B	#2,D0    		; RAWMOUSE
	BEQ.S	InpRawmouse
	MOVE.L	A1,A2
InpNext:MOVE.L	(A1),A1
	MOVE.L	A1,D0
	BNE.S	InputHandler
inphend	MOVE.L	A0,D0
	MOVE.L	(SP)+,A2
	RTS

InpRawkey:
	BSR	InpUnchain
	MOVE.W	6(A1),D0
	movem.l d0-d7/a0-a6,-(sp)
	BSR	ProcessRawkey
	movem.l (sp)+,d0-d7/a0-a6
	BRA	InpNext

InpRawmouse:
	BSR	InpUnchain
	MOVE.W	MouseX3,D0
	MOVE.W	MsRealY,D1
	move.w	10(a1),d2
	move.w	12(a1),d3
	tst.w	PointerFlag
	beq.s	.cnt
	add.w	d2,DeltaX
	add.w	d3,DeltaY
.cnt	tst.w	PointerFlag
	bne.s	.skip4
	ADD.W	d2,D0
	ADD.W	d3,D1
	asr.w	#1,d3
	TST.W	D0
	BPL.S	.skip1
	MOVEQ	#0,D0
.skip1	TST.W	D1
	BPL.S	.skip2
	move.w	d3,NTSCAdd
	MOVEQ	#0,D1
.skip2	CMP.W	#639,D0
	bmi.s	.skip3
	MOVE.W	#639,D0
.skip3	move.w	#511,d2
	btst	#0,ScrnBitFlags+3	; NTSCFlag
	beq.s	.cnt2
	sub.w	#NTSCDiff*2,d2
.cnt2	CMP.W	d2,D1
	bmi.s	.skip4
	move.w	d3,NTSCAdd
	MOVE.W	d2,D1

.skip4	move.w	d1,MsRealY
	move.w	NTSCYPos,d2
	add.w	d2,d2
	add.w	d2,d1
	MOVE.W	D0,MouseX3
	MOVE.W	D1,MouseY3
	;LSR.W	#1,D0			;this IS medres, remember? :)
	LSR.W	#1,D1
	MOVE.W	D0,MouseX
	MOVE.W	D1,MouseY
	BRA.W	InpNext

InpUnchain:
	MOVE.L	A2,D0
	BNE.S	.inpunc
	MOVE.L	(A1),A0
	RTS
.inpunc	MOVE.L	(A1),(A2)
	RTS

;---- Process rawkey code from the keyboard ----

ProcessRawkey:
	CMP.B	LastRawkey,D0
	REQ
	MOVE.B	D0,LastRawkey
	CMP.B	#67+128,D0
	BEQ	LowerInstr2
	CMP.B	#96,D0
	BEQ	ShiftOn
	CMP.B	#97,D0
	BEQ	ShiftOn2
	CMP.B	#100,D0
	BEQ	AltOn
	CMP.B	#101,D0
	BEQ	AltOn2
	CMP.B	#99,D0
	BEQ	CtrlOn
	CMP.B	#102,D0
	BEQ	LeftAmigaOn
	CMP.B	#103,d0
	BEQ	RightAmigaOn
	CMP.B	#99+128,D0
	BEQ	CtrlOff
	CMP.B	#100+128,D0
	BEQ	AltOff
	CMP.B	#96+128,D0
	BEQ.W	ShiftOff
	CMP.B	#101+128,D0
	BEQ	AltOff
	CMP.B	#97+128,D0
	BEQ.W	ShiftOff
	CMP.B	#102+128,D0
	BEQ	LeftAmigaOff
	CMP.B	#103+128,d0
	BEQ	RightAmigaOff
	CMP.B	#98,D0		; capslock
	BEQ.W	KeyRepOn
	CMP.B	#98+128,D0	; caps(un)lock
	BEQ.W	KeyRepOff
	move.b	d0,KeyStruck
KBIntSetKey:
	move.w	KeyRepDelay,RastCont
	bra	InsertKey

LowerInstr2:
	CLR.W	HiLowInstr
	BRA.S	KBIntSetKey

KeyRepOn:
	ST	KeyRepeat
	RTS

KeyRepOff:SF	KeyRepeat
	RTS

ShiftOn:MOVE.W	#1,ShiftKeyStatus
	RTS

ShiftOn2:MOVE.W	#1,ShiftKeyStatus
	BRA.W	KBIntSetKey
 
ShiftOff:CLR.W	ShiftKeyStatus
	RTS
 
AltOn:	MOVE.W	#1,AltKeyStatus
	RTS

AltOn2:	MOVE.W	#1,AltKeyStatus
	BRA.W	KBIntSetKey
 
AltOff:	CLR.W	AltKeyStatus
	RTS

CtrlOn:	MOVE.W	#1,CtrlKeyStatus
	RTS
 
CtrlOff:CLR.W	CtrlKeyStatus
	RTS

LeftAmigaOn:
	MOVE.W	#1,LeftAmigaStatus
	RTS
 
LeftAmigaOff:
	CLR.W	LeftAmigaStatus
	RTS

RightAmigaOn:
	MOVE.W	#1,RightAmigaStatus
	BRA.W	KBIntSetKey
 
RightAmigaOff:
	CLR.W	RightAmigaStatus
	RTS

KeyBufLen = 128

ResetKeys:
	clr.b	SaveKey
	clr.w	ShiftKeyStatus
	clr.w	AltKeyStatus
	clr.w	CtrlKeyStatus
	clr.w	LeftAmigaStatus
	clr.w	RightAmigaStatus
ClearKeyBuf:
	clr.w	KeyPoint1
	clr.w	KeyPoint2
	clr.b	RawKeyCode
	move.b	#255,LastRawkey
	rts
DoKeyBuffer:
	moveq	#0,d0
	lea	KeyBuffer,a1
	move.w	KeyPoint2(pc),d1
	cmp.w	KeyPoint1(pc),d1
	beq.s	.nokey
	addq.w	#1,KeyPoint1
	and.w	#KeyBufLen-1,KeyPoint1
	move.w	KeyPoint1(pc),d1
	move.b	(a1,d1.w),d0
.nokey	move.b	d0,RawKeyCode
	rts
DoKeyRepeat:
	move.b	LastRawkey(pc),d0
	and.b	#$80,d0
	bne.s	.end
	tst.w	RastCont
	bmi.s	.end
	subq.w	#1,RastCont
	tst.w	RastCont
	bpl.s	.end
	move.w	KeyRepSpeed,RastCont
	bsr.s	InsertKey
.end	rts
InsertKey:
	move.b	LastRawkey(pc),d0
	move.b	d0,d1
	and.b	#$80,d1
	bne.s	.noins			; do not insert key-up codes
	move.w	KeyPoint1(pc),d1
	subq.w	#1,d1
	and.w	#KeyBufLen-1,d1
	cmp.w	KeyPoint2(pc),d1
	beq.s	.cnt
	move.w	KeyPoint2(pc),d2
	addq.w	#1,d2
	cmp.w	#KeyBufLen,d2
	bmi.s	.cnt
	moveq	#0,d2
.cnt	move.w	d2,KeyPoint2
	lea	KeyBuffer,a0
	move.b	d0,(a0,d2.w)
.noins	rts

	cnop	0,4
RastCont:		dc.w	0
RasterCont:		dc.w	0
KeyPoint1:		dc.w	0
KeyPoint2:		dc.w	0

ShiftKeyStatus:		dc.w	0
AltKeyStatus:		dc.w	0
CtrlKeyStatus:		dc.w	0
LeftAmigaStatus:	dc.w	0
RightAmigaStatus:	dc.w	0
KeyStruck:		dc.w	0
LastRawkey:		dc.b	255
SaveKey:		dc.b	0
KeyRepeat:		dc.b	0
	cnop	0,2

KeyBuffer:	ds.b	KeyBufLen

;---- Update Mousepointer Position ----

UpdatePointerPos:
	MOVE.W	MouseX,D0
	lsr.w	#1,d0
	ADDQ.W	#3,D0
	MOVE.W	MsRealY,D1
	lsr.w	#1,d1
	MOVEQ	#11,D2			;11 in height
	MOVE.L	PointerSpritePtr,A0
	add.w	NTSCYPos,d1
	JSR	SetSpritePos
	rts

;---- Timer ----

UpdateTicks:
	CMP.L	#'patp',RunMode
	RNE
	ADDQ.W	#1,PatternTicks
	MOVE.W	PatternTicks(PC),D0
	MOVE.L	4.w,A0
	CMP.B	$0212(A0),D0	; 50/60 Hz
	RNE
	CLR.W	PatternTicks
	ADDQ.L	#1,TimerTicks
	RTS	
 
ShowTimer:
	cmp.w	#MainScreen_ID,CurrScreen
	beq.b	DoUpdateTider
	rts

DoUpdateTider:
	move.w	#0,WordNumber
	MOVE.W	#33*80+70,TextOffset
	JSR	Print2DecDigits
	MOVE.L	TimerTicks(PC),D0
	DIVU	#60,D0
	MOVE.W	D0,WordNumber
	SWAP	D0
	MOVE.W	D0,D7
	addq.w	#1,TextOffset
	JSR	Print2DecDigits
	MOVE.W	D7,WordNumber
	ADDQ.W	#1,TextOffset
	JSR	Print2DecDigits
	move.l	#NewDateStamp,d1
	move.l	DosBase,a6
	jsr	-192(a6)		;get datestamp
	move.l	NewDateStamp,d0		;get current day
	move.l	OldDateStamp,d1		;same?
	cmp.l	d1,d0
	beq.s	NoUpdate1		;nope, update the datefield
	bsr.w	UpdateTheDate
NoUpdate1:
	move.l	NewDateStamp+4,d0	;get number of minutes of the day
	move.l	OldDateStamp+4,d1	;same?
	cmp.l	d1,d0
	beq.s	NoUpdate2
	bsr.w	UpdateTheMin		;nope, update the minute/hourfield
NoUpdate2:
	move.l	NewDateStamp+8,d0	;get number of ticks
	divu	#50,d0			;get seconds
	move.l	d0,NewDateStamp+8
	move.l	OldDateStamp+8,d1	;same?
	cmp.l	d1,d0
	beq.s	ExUpdateTider
	bsr.w	UpdateTheSec		;nope, update the minute/hourfield
ExUpdateTider:
	lea	NewDateStamp,a0
	lea	OldDateStamp,a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	rts

UpdateTheMin:
	divu	#60,d0			;get hours
	move.w	d0,WordNumber
	swap	d0
	move.w	d0,-(sp)
	MOVE.W	#25*80+70,TextOffset
	JSR	Print2DecDigits		;hours
	move.w	(sp)+,d0
	move.w	d0,WordNumber
	addq.w	#1,TextOffset
	JSR	Print2DecDigits		;minutes
	rts

UpdateTheSec:
	ext.l	d0
	divu	#60,d0
	swap	d0
	move.w	d0,WordNumber
	MOVE.W	#25*80+76,TextOffset	;seconds
	JSR	Print2DecDigits
	rts

UpdateTheDate:
	jsr	CalculateDate
	move.w	TheDay,d0
	move.w	d0,WordNumber
	move.w	#17*80+70,TextOffset
	jsr	Print2DecDigits
	lea	MonthArray,a0
	move.w	TheMonth,d0
	sub.w	#1,d0
	mulu	#5,d0
	add.w	d0,a0
	move.w	#17*80+72,d1
	move.w	#5,D0
	jsr	ShowText3
	move.w	TheYear,d0
	move.w	d0,WordNumber
	move.w	#17*80+77,TextOffset
	jsr	Print2DecDigits
	rts

	cnop	0,4
NewDateStamp:	dc.l	0,0,0
OldDateStamp:	dc.l	0,0,0
PatternTicks:	dc.w	0
TimerTicks:	dc.l	0
MonthArray:	dc.b	"-Jan-","-Feb-","-Mar-","-Apr-","-May-","-Jun-","-Jul-"
		dc.b	"-Aug-","-Sep-","-Oct-","-Nov-","-Dec-"
DayArray:	dc.b	"Mon-","Tue-","Wed-","Thu-","Fri-","Sat-","Sun-"

;---- QuadraScope display ----

ns_sampleptr =  0
ns_endptr    =  4
ns_repeatptr =  8
ns_rependptr = 12
ns_period    = 16
ns_volume    = 18

Scope:	LEA	audchan1temp,A0
	LEA	ScopeInfo,A2
	LEA	ScopeSamInfo,A1
	LEA	BlankSample,A3
	MOVEQ.L	#3,D6
.scloop	MOVE.W	(A0),D0       ; n_note
	AND.W	#$0FFF,D0
	OR.W	n_period(A0),D0
	BEQ	.ScoSampleEnd ; end if no note & no period

	MOVE.W	n_period(A0),ns_period(A2)
	MOVE.B	n_volume(A0),ns_volume(A2)

	TST.B	n_trigger(A0)	
	BEQ	.ScoContinue    ; go to continue if not new triggered
.ScoRetrig
	SF	n_trigger(A0)
	BSR	SetScope
	MOVEQ	#0,D0
	MOVE.B	n_samplenum(A0),D0
	SUBQ.W	#1,D0
	LSL.W	#4,D0
	MOVE.L	ns_sampleptr(A1,D0.W),ns_sampleptr(A2)
	MOVE.L	ns_endptr(A1,D0.W),ns_endptr(A2)
	MOVE.L	ns_repeatptr(A1,D0.W),ns_repeatptr(A2)
	MOVE.L	ns_rependptr(A1,D0.W),ns_rependptr(A2)
	MOVE.L	ns_sampleptr(A2),D0
	CMP.L	A3,D0 			; at end of sample...
	BEQ.S	.ScoNextChan
	BRA.s	.ScoChk
.ScoContinue
	MOVE.L	ns_sampleptr(A2),D0
	CMP.L	A3,D0 			; at end of sample...
	BEQ.S	.ScoNextChan
	MOVEQ.L	#0,D1
	MOVE.W	ns_period(A2),D1
	LSR.W	#1,D1
	BEQ.S	.ScoNextChan
	MOVE.L	#35469,D2
	DIVU	D1,D2
	EXT.L	D2
	ADD.L	D2,D0
.ScoChk	CMP.L	ns_endptr(A2),D0
	BLO.S	.ScoUpdatePtr
	TST.L	ns_repeatptr(A2)
	BNE.S	.loop2
.ScoSampleEnd
	MOVE.L	A3,D0
	BRA.S	.ScoUpdatePtr

.loop2	SUB.L	ns_endptr(A2),D0
	ADD.L	ns_repeatptr(A2),D0
	MOVE.L	ns_rependptr(A2),ns_endptr(A2)
	CMP.L	ns_endptr(A2),D0
	BHS.s	.loop2
.ScoUpdatePtr
	MOVE.L	D0,ns_sampleptr(A2)
.ScoNextChan
	ADD.L	#20,A2
;	ADD.L	#44,A0		; Arggh!!! This one meant 3 days for me! -maw-
 	lea	n_SIZEOF(a0),a0
	DBRA	D6,.scloop

; now draw channels
	MOVEQ	#-1,D4
	TST.W	SamScrEnable
	BEQ.S	.nclr
	MOVEQ	#0,D4
.nclr	MOVEQ	#0,D7
	MOVE.W	$DFF002,D6 		; dmaconr

	clr.w	RealSampVol
	btst	#0,ActiveChannels+1
	beq	.cnt1
	move.l	#6*80+41,d0
	MOVEQ	#0,D5
	MOVE.L	#22*80+41,A1
	LEA	xBlankSample,A2
	BTST	#0,D6         ; check if dma is active for channel 0
	BEQ.S	.skp1
	LEA	ScopeInfo,A2
	MOVE.B	ns_volume(A2),D5
.skp1	BSR.W	.ScoDraw
.cnt1	move.w	RealSampVol(pc),d0
	move.w	d0,audchan1toggle+6

	clr.w	RealSampVol
	btst	#1,ActiveChannels+1
	beq	.cnt2
	move.l	#6*80+47,d0
	MOVEQ	#0,D5
	MOVE.L	#22*80+47,A1
	LEA	xBlankSample,A2
	BTST	#1,D6	  	; check if dma is active for channel 1
	BEQ.S	.skp2
	LEA	ScopeInfo+20,A2
	MOVE.B	ns_volume(A2),D5
.skp2	BSR.W	.ScoDraw
.cnt2	move.w	RealSampVol(pc),d0
	move.w	d0,audchan2toggle+6

	clr.w	RealSampVol
	btst	#2,ActiveChannels+1
	beq	.cnt3
	move.l	#6*80+53,d0
	MOVEQ	#0,D5
	MOVE.L	#22*80+53,A1
	LEA	xBlankSample,A2
	BTST	#2,D6          	; check if dma is active for channel 2
	BEQ.S	.skp3
	LEA	ScopeInfo+40,A2
	MOVE.B	ns_volume(A2),D5
.skp3	BSR.S	.ScoDraw
.cnt3	move.w	RealSampVol(pc),d0
	move.w	d0,audchan3toggle+6

	clr.w	RealSampVol
	btst	#3,ActiveChannels+1
	beq	.cnt4
	move.l	#6*80+59,d0
	MOVEQ	#0,D5
	MOVE.L	#22*80+59,A1
	LEA	xBlankSample,A2
	BTST	#3,D6		; check if dma is active for channel 3
	BEQ.S	.skp4
	LEA	ScopeInfo+60,A2
	MOVE.B	ns_volume(A2),D5
.skp4	BSR	.ScoDraw
.cnt4	move.w	RealSampVol(pc),d0
	move.w	d0,audchan4toggle+6

	TST.L	D7
	BEQ	.loscr
	RTS

.ScoDraw
	TST.B	ScopeEnable
	BEQ.W	.pos
	cmp.b	#2,VUMeterMode
	beq.s	.cnt9
	cmp.w	#MainScreen_ID,CurrScreen
	BNE.W	.pos
.cnt9
	cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.cnt5
	MOVE.L	TextBplPtr,A0
	ADD.L	d0,A0
	MOVEQ	#0,D0
	MOVEQ	#33-1,D1
.loop	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	LEA	75(A0),A0
	DBRA	D1,.loop
.cnt5
	muls	RelVolume,d5
	add.l	#32,d5
	lsr.l	#6,d5	;divu	#MaxVol,d5
	LSR.W	#1,D5
	CMP.W	#32,D5
	BLS.W	.skp9
	MOVEQ	#32,D5
.skp9	MOVE.L	(A2),A0
	ADD.L	TextBplPtr,A1

	movem.l	d6/d7,-(sp)
	moveq	#0,d6
	moveq	#0,d7
	cmp.w	#MainScreen_ID,CurrScreen
	bne.w	.cnt8
	btst	#3,ScrnBitFlags+3	; SolidScopeFlag
	bne.s	.skpA
	bsr	PlotPixels
	bra.s	.cnt7
.skpA	bsr	SolidPlotPixels	; -maw-
	bra.s	.cnt7
.cnt8	bsr	DontPlotPixels
.cnt7	move.w	d7,RealSampVol
	movem.l	(sp)+,d6/d7

.pos	TST.B	D4
	RNE
	LEA	xBlankSample(PC),A0
	CMP.L	A0,A2
	BEQ.S	.loscr
	MOVE.L	(A2),D1
	MOVE.L	SamDrawStart(PC),D0
	CMP.L	D0,D1
	RLS
	CMP.L	SamDrawEnd(PC),D1
	RHS
	SUB.L	D0,D1
	MULU	#314,D1
	MOVE.L	SamDisplay,D0
	REQ
	DIVU	D0,D1
	ST	D4
	ST	D7
	MOVE.L	D1,D0
	ADDQ.W	#6,D0
	MOVE.W	#139,D1
.pspr	MOVEQ	#64,D2
	LEA	PlayPosSpriteData,A0
	JMP	SetSpritePos
.loscr	MOVEQ	#0,D0
	MOVE.W	#270,D1
	BRA.S	.pspr

PlotPixels:
	MOVEQ	#5-1,D2
.lop1	MOVEQ	#8-1,D3
.lop2	MOVE.B	(A0)+,D0	; get byte
	EXT.W	D0		; extend to word
	move.w	d0,d6
	bpl.s	.cnt
	neg.w	d6
.cnt	cmp.w	d6,d7           ; get highest value
	bge.s	.cnt2
	move.w	d6,d7
.cnt2	NEG.W	D0		; negate
	MULS	D5,D0		; multiply by volume

	ASR.W	#8,D0		; shift down
	MOVE.W	D0,D1
	ASL.W	#6,D0		; * 64
	ASL.W	#4,D1		; * 16
	ADD.W	D1,D0		; (64+16) = * 80 (Res/8)

	BSET	D3,(a1,D0.W)	; set a pixel
	DBRA	D3,.lop2
	ADDQ.L	#1,A1		; yes
	DBRA	D2,.lop1
	rts

SolidPlotPixels:		; -maw-
				; just another style
	MOVEQ	#5-1,D2         ; for all bytes
.lop1	MOVEQ	#8-1,D3         ; for all bits
.lop2	MOVE.B	(A0)+,D0	; get byte
	EXT.W	D0		; extend to word
	move.w	d0,d6
	bpl.s	.cnt
	neg.w	d6
.cnt	cmp.w	d6,d7           ; get highest value
	bge.s	.cnt2
	move.w	d6,d7
.cnt2	NEG.W	D0		; negate
	MULS	D5,D0		; multiply by volume
	ASR.W	#8,D0		; shift down
	MOVE.W	D0,D1                       ; 4
	ASL.W	#6,D0		; * 64      ; 38
	ASL.W	#4,D1		; * 16      ; 22
	ADD.W	D1,D0		; (64+16) = * 80 (Res/8) ; 8     = 72 tz
				; mulu seems to be faster here!
.dot:
	BSET	D3,(a1,D0.W)	; set a pixel
	tst.w	d0
	beq.s	.zero
	bmi.s	.add
	sub.w	#80,d0
	bra.s	.dot	
.add:	add.w	#80,d0
	bra.s	.dot
.zero:	DBRA	D3,.lop2
	ADDQ.L	#1,A1		; yes
	DBRA	D2,.lop1
	rts


DontPlotPixels:
	cmp.b	#2,VUMeterMode
	RNE
	MOVEQ	#(5*8)-1,D2
.lop1	MOVE.B	(A0)+,D0	; get byte
	EXT.W	D0		; extend to word
	bpl.s	.cnt
	neg.w	d0
.cnt	cmp.w	d0,d7
	bge.s	.cnt2
	move.w	d0,d7
.cnt2	DBRA	D2,.lop1
	rts

SetScope
	MOVEQ	#0,D1
	MOVE.B	n_samplenum(A0),D1
	SUBQ.W	#1,D1
	LSL.W	#4,D1
	LEA	ScopeSamInfo,A4
	LEA	0(a4,D1.W),A4

	MOVE.L	n_start(A0),D0
	MOVE.L	D0,ns_sampleptr(A4)
	MOVEQ	#0,D1
	MOVE.W	n_length(A0),D1
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	D0,ns_endptr(A4)

	MOVE.L	n_loopstart(A0),D0
	MOVE.L	D0,ns_repeatptr(A4)
	MOVEQ	#0,D1
	MOVE.W	n_replen(A0),D1
	CMP.W	#1,D1
	BEQ.S	sconorep
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	D0,ns_rependptr(A4)
	RTS
sconorep
	CLR.L	ns_repeatptr(A4)
	RTS

ToggleAnaScope
	TST.W	notogfl
	RNE
	BSR	WaitForButtonUp
	MOVEQ	#0,D4
	TST.B	AnaScopFlag
	BNE.S	tasana
	ST	AnaScopFlag
	ST	ScopeEnable
	rts
tasana	SF	AnaScopFlag
	ST	ScopeEnable
	rts

	cnop	0,4
ScopeEnable:	dc.b 0
AnaScopFlag:	dc.b 1
xBlankSample:	dc.l BlankSample
SamDrawStart:	dc.l 0
SamDrawEnd:	dc.l 0
RealSampVol:	dc.w 0

;---- Show Free/Tune Memory ----

DoShowFreeMem
	MOVE.W	#1,UpdateFreeMem
ShowFreeMem
	MOVEM.L	D0-D7/A0-A6,-(SP)
	TST.W	UpdateFreeMem
	BEQ.S	sfmskp
	CLR.W	UpdateFreeMem
	CLR.L	FreeMemory
	CLR.L	TuneMemory
sfmskp	BSR	ShowTuneMem
	MOVEQ	#MEMF_ANY,D1
sfmskp2	MOVE.L	4.w,a6
	JSR	LVOAvailMem(A6)
	CMP.L	FreeMemory(PC),D0	;no changes? -> don't print
	BEQ.W	fremend
	MOVE.L	D0,FreeMemory
	btst	#2,MiscBitFlags+3	;ShowDecFlag
	BNE.W	shfrdec
	MOVE.L	D0,D6
	MOVE.W	#131*80+73,TextOffset
	SWAP	D0
	AND.W	#$FF,D0
	MOVE.W	D0,WordNumber
	JSR	PrintHexByte
	MOVE.W	D6,WordNumber
	JSR	PrintHexWord
	MOVEQ	#MEMF_CHIP,D1
	MOVE.L	4.w,a6
	JSR	LVOAvailMem(A6)
	MOVE.L	D0,D6
	MOVE.W	#124*80+73-12,TextOffset
	SWAP	D0
	AND.W	#$FF,D0
	MOVE.W	D0,WordNumber
	JSR	PrintHexByte
	MOVE.W	D6,WordNumber
	JSR	PrintHexWord
	MOVEQ	#MEMF_FAST,D1
	MOVE.L	4.w,a6
	JSR	LVOAvailMem(A6)
	MOVE.L	D0,D6
	MOVE.W	#131*80+73-12,TextOffset
	SWAP	D0
	AND.W	#$FF,D0
	MOVE.W	D0,WordNumber
	JSR	PrintHexByte
	MOVE.W	D6,WordNumber
	JSR	PrintHexWord
fremend	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

shfrdec	MOVE.L	FreeMemory(PC),D0
	MOVE.W	#131*80+73,TextOffset
	JSR	Print6DecDigits
	MOVEQ	#MEMF_CHIP,D1
	MOVE.L	4.w,a6
	JSR	LVOAvailMem(A6)
	MOVE.W	#124*80+73-12,TextOffset
	JSR	Print6DecDigits
	MOVEQ	#MEMF_FAST,D1
	MOVE.L	4.w,a6
	JSR	LVOAvailMem(A6)
	MOVE.W	#131*80+73-12,TextOffset
	JSR	Print6DecDigits
	BRA.S	fremend

ShowTuneMem
	MOVE.L	SongDataPtr,A0
	LEA	42(A0),A0
	MOVE.W	TuneUp(PC),D7
	SUBQ.W	#1,D7
	MOVE.W	#31,TuneUp
	MOVEQ	#0,D0			; Zero length
stumeloop
	MOVEQ	#0,D1
	MOVE.W	(A0),D1
	ASL.W	#1,D1
	ADD.L	D1,D0			; Add samplelength
	ADD.L	#30,A0	
	DBRA	D7,stumeloop
	ADD.L	#1084,D0		; Add 1084 to length
	MOVE.L	SongDataPtr,A0
	MOVEQ	#127,D7
	ADD.L	#952,A0
	MOVEQ	#0,D6
stumeloop2
	MOVE.B	(A0)+,D5
	CMP.B	D5,D6
	BHI.S	stumeskip
	MOVE.B	D5,D6
stumeskip
	DBRA	D7,stumeloop2
	ADDQ.W	#1,D6
	ASL.L	#8,D6
	ASL.L	#2,D6
	ADD.L	D6,D0			; Add 1024 x Number of patterns
	CMP.L	TuneMemory(PC),D0
	REQ
	MOVE.L	D0,TuneMemory
	btst	#2,MiscBitFlags+3	;ShowDecFlag
	BNE.S	shtudec
	MOVE.L	D0,D6
	MOVE.W	#124*80+73,TextOffset
	SWAP	D0
	AND.W	#$FF,D0
	MOVE.W	D0,WordNumber
	JSR	PrintHexByte
	MOVE.W	D6,WordNumber
	JMP	PrintHexWord

shtudec	MOVE.L	TuneMemory(PC),D0
	MOVE.W	#124*80+73,TextOffset
	JMP	Print6DecDigits

	cnop	0,4
UpdateFreeMem	dc.w	0
FreeMemory	dc.l	0
TuneMemory	dc.l	0
TuneUp		dc.w	31

;---- Audio Channel Toggles ----

DoToggleMute:
	CMP.W	#34,D0
	BHS.S	ToggleCh4
	CMP.W	#23,D0
	BHS.S	ToggleCh3
	CMP.W	#12,D0
	BHS.S	ToggleCh2
ToggleCh1:
	LEA	audchan1toggle(PC),A0
	BRA.S	TogChan
ToggleCh2:
	LEA	audchan2toggle(PC),A0
	BRA.S	TogChan
ToggleCh3:
	LEA	audchan3toggle(PC),A0
	BRA.S	TogChan
ToggleCh4:
	LEA	audchan4toggle(PC),A0
	;BRA.S	TogChan
TogChan:CLR.B	RawKeyCode
	EOR.W	#1,(A0)
	BSR	WaitForButtonUp
	CLR.W	D0
	MOVE.W	audchan4toggle(PC),D0
	LSL.B	#1,D0
	OR.W	audchan3toggle(PC),D0
	LSL.B	#1,D0
	OR.W	audchan2toggle(PC),D0
	LSL.B	#1,D0
	OR.W	audchan1toggle(PC),D0
	MOVE.W	D0,ActiveChannels
	BSR	RedrawToggles
	JSR	Wait_4000
	JMP	Wait_4000

RedrawToggles:
	cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.cnt
	bsr	ClearKeyBuf
.cnt	move.w	ActiveChannels(pc),d2
	move.l	#6*80+41,d0
	lea	audchan1temp,a1
	bsr	ToggleQuadra
	lsr.w	#1,d2
	move.l	#6*80+47,d0
	lea	audchan2temp,a1
	bsr	ToggleQuadra
	lsr.w	#1,d2
	move.l	#6*80+53,d0
	lea	audchan3temp,a1
	bsr	ToggleQuadra
	lsr.w	#1,d2
	move.l	#6*80+59,d0
	lea	audchan4temp,a1
	bsr	ToggleQuadra
	bsr	UpdateSampleVolume
	rts


ToggleQuadra:			; Channel on/off
	btst	#0,d2
	bne	.end
	clr.w	n_relvol(a1)
	cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.cnt
	MOVE.L	TextBplPtr,A0
	ADD.L	d0,A0
	MOVE.B	#%00010001,D0
	MOVEQ	#33-1,D1
.loop	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	MOVE.B	D0,(A0)+
	ror.b	#2,d0
	LEA	75(A0),A0
	DBRA	D1,.loop
.cnt	rts
.end	move.w	RelVolume,n_relvol(a1)
	rts

;---- VU Meters ----

ShowVUMeters:
	LEA	VUSpriteData1,A2
	lea	audchan1toggle(PC),a3
	bsr	DoSetVUMeterSpr
	LEA	VUSpriteData2,A2
	lea	audchan2toggle(PC),a3
	bsr	DoSetVUMeterSpr
	LEA	VUSpriteData3,A2
	lea	audchan3toggle(PC),a3
	bsr	DoSetVUMeterSpr
	LEA	VUSpriteData4,A2
	lea	audchan4toggle(PC),a3
	bsr	DoSetVUMeterSpr
	rts
VUmeters:
	tst.b	VUMeterMode
	REQ
	LEA	audchan1temp,A1
	LEA	VUSpriteData1,A2
	lea	audchan1toggle(PC),a3
	BSR.S	OneVUmeter
	LEA	audchan2temp,A1
	LEA	VUSpriteData2,A2
	lea	audchan2toggle(PC),a3
	BSR.S	OneVUmeter
	LEA	audchan3temp,A1
	LEA	VUSpriteData3,A2
	lea	audchan3toggle(PC),a3
	BSR.S	OneVUmeter
	LEA	audchan4temp,A1
	LEA	VUSpriteData4,A2
	lea	audchan4toggle(PC),a3
OneVUmeter:
	move.w	(a3),d0
	cmp.b	#2,VUMeterMode
	beq.s	RealVUm
	TST.L	RunMode
	BEQ.W	VUmeterDown
	TST.W	D0
	BEQ.W	VUmeterDown
	TST.L	Counter
	BNE.W	VUmeterDown
	TST.W	(A1)
	BEQ.W	VUmeterDown
.cnt2	MOVEQ	#0,D0				; New note
	MOVE.B	n_volume(A1),D0			; Get volume
	CMP.W	#$3f,D0				; Higher than $40 ?
	BLS.S	.skip				; No, skip
	MOVEQ	#$3f,D0				; Yes, set to $40
.skip	mulu	#48,d0
.skip2	mulu	RelVolume,d0
	add.l	#32,d0
	lsr.l	#6,d0	;divu	#MaxVol,d0
	lsr.w	#6,d0
	bne.s	.cnt3
	moveq	#1,d0
.cnt3	move.w	d0,4(a3)
	bra.s	DoSetVUMeterSpr
RealVUm:move.w	6(a3),d1
	moveq	#0,d0
	move.b	n_volume(a1),d0
	mulu	d1,d0
	mulu	#48,d0			; argghh -maw-
	lsr.l	#7,d0	;divu	#128,d0 ; this could be done faster! >:-(
	mulu	RelVolume,d0
	add.l	#32,d0
	lsr.l	#6,d0	;divu	#MaxVol,d0
	lsr.w	#6,d0
	bne.s	.cnt
	moveq	#1,d0
.cnt	cmp.w	4(a3),d0
	bmi.s	VUmeterDown2
	move.w	d0,4(a3)
DoSetVUMeterSpr:
	move.w	4(a3),d2
	move.w	#198,d1
	sub.w	d2,d1
	move.w	2(a3),d0
	tst.b	VUMeterMode
	bne.s	.cnt
	moveq	#-64,d0
.cnt	move.l	a2,a0
	jmp	SetSpritePos

VUmeterDown2:
	move.w	4(a3),d1
	sub.w	d0,d1
	lsr.w	#1,d1
	sub.w	d1,4(a3)
VUmeterDown:
	subq.w	#1,4(a3)
	cmp.w	#1,4(a3)
	bpl.s	.cnt
	move.w	#1,4(a3)
.cnt	bra	DoSetVUMeterSpr

	cnop	0,4
audchan1toggle:	dc.w	1,46,1,0
Chan1Volume:	dc.w	0
audchan2toggle:	dc.w	1,106,1,0
Chan2Volume:	dc.w	0
audchan3toggle:	dc.w	1,166,1,0
Chan3Volume:	dc.w	0
audchan4toggle:	dc.w	1,226,1,0
Chan4Volume:	dc.w	0
ActiveChannels:	dc.w	15

SetAnalyzerVolumes:
	MOVEM.L	D0-D3/A0,-(SP)
	LSL.W	#8,D2
	DIVU	#640,D2
	CMP.W	#$F0A0,A5
	BNE.S	savCh2
	TST.W	audchan1toggle
	BEQ.S	savCh2
	CMP.W	Chan1Volume,D2 			; volume
	BLO.S	savCh2
	MOVE.W	D2,Chan1Volume
savCh2	CMP.W	#$F0B0,A5
	BNE.S	savCh3
	TST.W	audchan2toggle
	BEQ.S	savCh3
	CMP.W	Chan2Volume,D2
	BLO.S	savCh3
	MOVE.W	D2,Chan2Volume
savCh3	CMP.W	#$F0C0,A5
	BNE.S	savCh4
	TST.W	audchan3toggle
	BEQ.S	savCh4
	CMP.W	Chan3Volume,D2
	BLO.S	savCh4
	MOVE.W	D2,Chan3Volume
savCh4	CMP.W	#$F0D0,A5
	BNE.S	savNone
	TST.W	audchan4toggle
	BEQ.S	savNone
	CMP.W	Chan4Volume,D2
	BLO.S	savNone
	MOVE.W	D2,Chan4Volume
savNone	MOVEM.L	(SP)+,D0-D3/A0
	MOVEQ	#1,D4
	RTS

;---- Volume dragbar ----
VolSize = 12
VolArea = 192-VolSize
VolXPos = 124
VolYPos = 35

MastVolumeDown:
	moveq	#-1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#-10,d0
.cnt	bra.s	DoMastVolume
MastVolumeUp:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	bra.w	DoMastVolume
DoMastVolume:
	add.w	d0,VolBarPos
	bpl.s	.cnt3
	clr.w	VolBarPos
.cnt3	cmp.w	#VolArea,VolBarPos
	bmi.s	.cnt4
	move.w	#VolArea,VolBarPos
.cnt4	bra	ShowVolumeBar

DoVolumeDragBar:
	MOVE.W	MouseX,D0
	move.w	VolBarPos(pc),d2
	sub.w	#VolXPos,d0
	cmp.w	d0,d2
	bgt	.volleft
	move.w	d0,d1
	sub.w	#VolSize,d1
	cmp.w	d1,d2
	ble	.volright
	move.w	d0,d4
	sub.w	d2,d4
	move.w	#Box2,Volbox
	bsr	ShowVolumeBar
.loop	btst	#6,$bfe001
	bne	.end
	jsr	CheckNTSCPos
	MOVE.W	MouseX,D0
	sub.w	#VolXPos,d0
	sub.w	d4,d0
	bgt.s	.cnt1
	moveq	#0,d0
.cnt1	cmp.w	#VolArea,d0
	bls.s	.cnt2
	move.w	#VolArea,d0
.cnt2	cmp.w	d0,d2
	beq	.loop
	move.w	d0,d2
	move.w	d0,VolBarPos
	bsr	ShowVolumeBar
.not	btst	#6,$bfe001
	beq.s	.loop
.end	move.w	#Box1,Volbox
	bra	ShowVolumeBar
.volleft
	sub.w	#VolSize,VolBarPos
	bpl.s	.cnt3
	clr.w	VolBarPos
.cnt3	bra	ShowVolumeBar
.volright
	add.w	#VolSize,VolBarPos
	cmp.w	#VolArea,VolBarPos
	bmi.s	.cnt4
	move.w	#VolArea,VolBarPos
.cnt4	;bra	ShowVolumeBar
ShowVolumeBar:
	movem.l d0-d7/a0-a6,-(sp)
	move.w	VolBarPos(pc),d0
	move.w	d0,Volps1
	move.w	d0,Volps2
	move.w	d0,d1
	add.w	#VolSize,d1
	move.w	d1,Volps3
	move.w	#VolArea,d1
	sub.w	d0,d1
	move.w	d1,Volps3+4
	lea	HorizSlider(pc),a0
	move.w	#VolXPos,d0
	moveq	#VolYPos,d1
	jsr	PaintScreen
	move.w	#VolArea,d1
	sub.w	VolBarPos(pc),d1
	mulu	#MaxVol,d1
	divu	#VolArea,d1
	move.w	#MaxVol,d0
	sub.w	d1,d0
	move.w	d0,RelVolume
	tst.w	audchan1toggle
	beq.s	.cnt1
	move.w	d0,audchan1temp+n_relvol
.cnt1	tst.w	audchan2toggle
	beq.s	.cnt2
	move.w	d0,audchan2temp+n_relvol
.cnt2	tst.w	audchan3toggle
	beq.s	.cnt3
	move.w	d0,audchan3temp+n_relvol
.cnt3	tst.w	audchan4toggle
	beq.s	.cnt4
	move.w	d0,audchan4temp+n_relvol
.cnt4	bsr	UpdateSampleVolume
	movem.l (sp)+,d0-d7/a0-a6
	rts

UpdateSampleVolume:
	lea	AudChanPtrs,a1	; -maw-
	lea	_custom+AUD0,a5
	moveq	#3,d1		; for all channels
.loop:	move.l	(a1)+,a0	
	bsr.s	.update
	lea	AUDOFS(a5),a5
	dbra	d1,.loop
	rts
.update	moveq	#0,d0
	move.b	n_volume(a0),d0
	muls	n_relvol(a0),d0
	add.l	#32,d0
	lsr.l	#6,d0	;	divu	#MaxVol,d0
	tst.b	n_dynflag(a0)
	bne.s	.no_update
	move.w	d0,AUDVOL(a5)	; DMA Volume is not
.no_update:			; allowed for DYNs  -maw-
	rts

	cnop	0,4
VolBarPos:dc.w	VolArea

HorizSlider:
	dc.w Box5,2,0,0
Volps1	dc.w 0,7		; Clear left area
Volbox	dc.w Box1
Volps2	dc.w 0,0,VolSize,7	; Draw slider box
	dc.w Box5,2
Volps3	dc.w VolSize,0,34,7	; Clear right area
	dc.w EndPaint

;---- Gadget snuffler ----

GetGadgetInt
	move.b	#-1,WaitGadget
	move.w	#-1,FileInvOn
	bsr.s	GetGadget3
	clr.w	FileInvOn
	rts
GetGadget
	move.w	#-1,FileInvOn
	bsr.s	GetGadget2
	clr.w	FileInvOn
	rts
GetGadget2
	clr.b	WaitGadget
GetGadget3
	move.w	d7,-(sp)
GetGadgetloop
	move.w	(a0)+,d2		;id
	move.w	(a0)+,d7		;gadget type
	move.w	(a0)+,d3		;x0
	move.w	(a0)+,d4		;y0
	move.w	(a0)+,d5		;x1
	move.w	(a0)+,d6		;y1
	tst.w	d2			;last gadget?
	beq.s	exitgetgadg
	cmp.w	d0,d3
	bhi.s	GetGadgetloop
	cmp.w	d0,d5
	blo.s	GetGadgetloop
	cmp.w	d1,d4
	bhi.s	GetGadgetloop
	cmp.w	d1,d6
	blo.s	GetGadgetloop
	move.w	d7,GadgType
	tst.w	d7
	beq.s	exitgetgadg
	tst.b	NoInvFlag
	bne.s	exitgetgadg
	bsr.w	ReverseGadget
exitgetgadg
	move.w	(sp)+,d7
	rts
	cnop	0,4
WaitGadget	dc.w	0

ReverseGadget:
	moveq	#0,d7
	bsr.w	reverseit
	movem.l d0-d7/a0-a6,-(sp)
	tst.b	WaitGadget
	bne.s	.cnt2
	move.l	DosBase,d0
	beq.s	.cnt2
	move.l	d0,a6
	moveq	#1,d1
	jsr	LVODelay(a6)
.cnt2	movem.l (sp)+,d0-d7/a0-a6
	movem.w	d0-d1,-(sp)
.loop	jsr	CheckNTSCPos
	movem.w	MouseX,d0/d1
	tst.w	d7
	beq.b	.rcn1
	bsr.w	testrev1
	bra.b	.rcn2
.rcn1	bsr.w	testrev2
.rcn2	btst	#6,$bfe001
	beq.s	.loop

	movem.l d0-d7/a0-a6,-(sp)
	tst.b	WaitGadget
	bne.s	.cnt3
	move.l	DosBase,d0
	beq.s	.cnt3
	move.l	d0,a6
	moveq	#1,d1
	jsr	LVODelay(a6)
.cnt3	movem.l (sp)+,d0-d7/a0-a6
	btst	#6,$bfe001
	beq.s	.loop

	movem.w	(sp)+,d0-d1
	move.w	d7,d2	
	beq.s	noreverseit
	bsr.w	reverseit2
noreverseit
	rts
testrev1
	cmp.w	d0,d3
	bhi.s	reverseit
	cmp.w	d0,d5
	blo.s	reverseit
	cmp.w	d1,d4
	bhi.s	reverseit
	cmp.w	d1,d6
	blo.s	reverseit
	rts
testrev2
	cmp.w	d0,d3
	bhi.s	noreverseit
	cmp.w	d0,d5
	blo.s	noreverseit
	cmp.w	d1,d4
	bhi.s	noreverseit
	cmp.w	d1,d6
	blo.s	noreverseit
reverseit
	eor.w	d2,d7
reverseit2
	movem.w	d0-d7,-(sp)
	cmp.w	#1,GadgType
	bne	revcna
	bsr	InvertGadg
revcna	cmp.w	#2,GadgType
	bne	revcnb
	bsr	InvertGadg2
revcnb	movem.w	(sp)+,d0-d7
	rts

InvertGadg2:
	move.w	d3,d0
	move.w	d4,d1
	move.w	d5,d2
	addq.w	#1,d2
	move.w	d6,d3
	addq.w	#1,d3
	jmp	InvertAnyBlock

InvertGadg:
	move.w	d3,d7
	move.w	d3,d0
	move.w	d4,d1
	move.w	d1,d3
	addq.w	#1,d3
	move.w	d5,d2
	jsr	InvertAnyBlock3
	move.w	d5,d0
	move.w	d0,d2
	addq.w	#1,d2
	move.w	d4,d1
	addq.w	#1,d1
	move.w	d6,d3
	addq.w	#1,d3
	jsr	InvertAnyBlock3
	move.w	d7,d0
	addq.w	#1,d0
	move.w	d5,d2
	move.w	d6,d1
	move.w	d6,d3
	addq.w	#1,d3
	jsr	InvertAnyBlock3
	move.w	d7,d0
	move.w	d0,d2
	addq.w	#1,d2
	move.w	d4,d1
	addq.w	#1,d1
	move.w	d6,d3
	jmp	InvertAnyBlock3

	cnop	0,4
GadgType:	dc.w	0
NoInvFlag:	dc.w	0

;---- Gadget drawing ----

PaintScreen:
	move.w	d0,PxAdd
	move.w	d1,PyAdd
.loop	move.w	(a0)+,d0
	beq	.end

	cmp.w	#Box1,d0
	bne.s	.pntc1
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	move.w	#1,Col1
	move.w	#3,Col2
	bsr	PaintGadget2
	bra.b	.loop
.pntc1	cmp.w	#Box2,d0
	bne.s	.pntc2
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	move.w	#3,Col1
	move.w	#1,Col2
	bsr	PaintGadget2
	bra.b	.loop
.pntc2	cmp.w	#Box3,d0
	bne.s	.pntc3
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	move.w	#1,Col1
	move.w	#3,Col2
	bsr	PaintGadget3
	bra.w	.loop
.pntc3	cmp.w	#Box4,d0
	bne.s	.pntc4
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	move.w	#3,Col1
	move.w	#1,Col2
	bsr	PaintGadget3
	bra.w	.loop
.pntc4	cmp.w	#Box5,d0
	bne.s	.pntc5
	move.w	(a0)+,d5
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	bsr	PaintGadget
	bra.w	.loop
.pntc5	cmp.w	#Txt1,d0
	bne.s	.pntc6
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	lea	ShowColorText,a2
	bsr	PaintText
	bra.w	.loop
.pntc6	cmp.w	#Txt2,d0
	bne.s	.pntc7
	move.w	(a0)+,d2
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	lea	ShowAnyText1,a2
	bsr	PaintText
	bra.w	.loop
.pntc7	cmp.w	#Txt3,d0
	bne.s	.pntc8
	move.w	(a0)+,d2
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	lea	ShowAnyText2,a2
	bsr	PaintText
	bra.w	.loop
.pntc8	cmp.w	#Lin1,d0
	bne.s	.pntc9
	move.w	(a0)+,d5
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	add.w	PxAdd(pc),d2
	add.w	PyAdd(pc),d3
	jsr	ShowLine
	bra.w	.loop
.pntc9	cmp.w	#Pix1,d0
	bne.s	.pntc10
	move.w	(a0)+,d5
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	add.w	PxAdd(pc),d0
	add.w	PyAdd(pc),d1
	jsr	ShowPixel
	bra.w	.loop
.pntc10
.end	rts

PaintText:
	movem.l	d0-d7,-(sp)
	move.l	a0,a1
	moveq	#-1,d3
.loop	addq.w	#1,d3
	tst.b	(a0)+
	bne.s	.loop
	move.l	a0,d4
	addq.l	#1,d4
	and.l	#-2,d4
	move.l	d4,a0
	move.l	a0,-(sp)
	move.l	a1,a0
	jsr	(a2)
	move.l	(sp)+,a0
	movem.l	(sp)+,d0-d7
	rts

PaintGadget:
	movem.l	d0-d7/a0-a6,-(sp)
	tst.w	d2
	ble.s	.not
	tst.w	d3
	ble.s	.not
	add.w	d0,d2
	add.w	d1,d3
	jsr	ShowAnyBlock	
.not	movem.l	(sp)+,d0-d7/a0-a6
	rts

PaintGadget2:
	movem.l	d0-d7/a0-a6,-(sp)
	tst.w	d2
	ble.w	.not
	tst.w	d3
	ble.w	.not
	add.w	d0,d2
	add.w	d1,d3
	move.w	d0,GadXp1
	move.w	d1,GadYp1
	move.w	d2,GadXp2
	move.w	d3,GadYp2
	moveq	#2,d5
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	move.w	GadXp2(pc),d2
	move.w	GadYp1(pc),d1
	subq.w	#1,d2
	move.w	d1,d3
	addq.w	#1,d3
	move.w	Col1(pc),d5
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	move.w	d0,d2
	addq.w	#1,d2
	move.w	GadYp1(pc),d1
	addq.w	#1,d1
	move.w	GadYp2(pc),d3
	subq.w	#1,d3
	move.w	Col1(pc),d5
	jsr	ShowAnyBlock	
	move.w	GadXp2(pc),d0
	move.w	d0,d2
	subq.w	#1,d0
	move.w	GadYp1(pc),d1
	addq.w	#1,d1
	move.w	GadYp2(pc),d3
	move.w	Col2(pc),d5
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	addq.w	#1,d0
	move.w	GadXp2(pc),d2
	move.w	GadYp2(pc),d1
	move.w	d1,d3
	subq.w	#1,d1
	move.w	Col2(pc),d5
	jsr	ShowAnyBlock	
.not	movem.l	(sp)+,d0-d7/a0-a6
	rts

PaintGadget3:
	movem.l	d0-d7/a0-a6,-(sp)
	tst.w	d2
	ble.w	.not
	tst.w	d3
	ble.w	.not
	add.w	d0,d2
	add.w	d1,d3
	move.w	d0,GadXp1
	move.w	d1,GadYp1
	move.w	d2,GadXp2
	move.w	d3,GadYp2
	moveq	#2,d5
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	move.w	GadXp2(pc),d2
	move.w	GadYp1(pc),d1
	subq.w	#1,d2
	move.w	d1,d3
	addq.w	#1,d3
	move.w	Col1(pc),d5
	jsr	ShowAnyBlock	
	addq.w	#1,d1
	addq.w	#1,d3
	subq.w	#1,d2
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	move.w	d0,d2
	addq.w	#1,d2
	move.w	GadYp1(pc),d1
	addq.w	#1,d1
	move.w	GadYp2(pc),d3
	subq.w	#1,d3
	move.w	Col1(pc),d5
	jsr	ShowAnyBlock	
	addq.w	#1,d0
	addq.w	#1,d2
	subq.w	#1,d3
	jsr	ShowAnyBlock	
	move.w	GadXp2(pc),d0
	move.w	d0,d2
	subq.w	#1,d0
	move.w	GadYp1(pc),d1
	addq.w	#1,d1
	move.w	GadYp2(pc),d3
	move.w	Col2(pc),d5
	jsr	ShowAnyBlock	
	subq.w	#1,d0
	subq.w	#1,d2
	addq.w	#1,d1
	jsr	ShowAnyBlock	
	move.w	GadXp1(pc),d0
	addq.w	#1,d0
	move.w	GadXp2(pc),d2
	move.w	GadYp2(pc),d1
	move.w	d1,d3
	subq.w	#1,d1
	move.w	Col2(pc),d5
	jsr	ShowAnyBlock	
	subq.w	#1,d1
	subq.w	#1,d3
	addq.w	#1,d0
	jsr	ShowAnyBlock	
.not	movem.l	(sp)+,d0-d7/a0-a6
	rts
	cnop	0,4
PxAdd:	dc.w	0
PyAdd:	dc.w	0
Col1:	dc.w	1
Col2:	dc.w	2
GadXp1:	dc.w	0
GadYp1:	dc.w	0
GadXp2:	dc.w	0
GadYp2:	dc.w	0

;---- Disk Operation submenu ----

DiskOp:	move.w	#-1,FileInvOn
	move.w	#-1,forrigeinv
	CLR.B	RawKeyCode
	MOVE.W	CurrScreen,D0
	CMP.W	#3,D0
	BEQ	ExitFromDir
	CMP.W	#1,D0
	RNE
ShowDirScreen:
	BSR	WaitForButtonUp
	move.w	#-1,FileInvOn
	move.w	#-1,forrigeinv
	MOVE.W	#3,CurrScreen
	jsr	ClearKeyBuf
	ST	NoSampleInfo
	BSR	Clear121Lines
	BSR.W	MakeDirScreen
	BNE	DisplayMainAll
	BSR	DrawDevs
	bsr	ShowPNote
	BSR	ShowDiskSpace
	BSR	ShowModPackMode
	;BSR	ShowPackMode
	BSR	ShowRAWIFFMode
	bsr	ShowHideShowInfo
	BSR	ShowFileName
	BSR	ShowMask
	clr.w	FileInvOn
	move.l	FileNamesPtr(pc),a5
	move.w	di_ScrPos(a5),d0
	bsr	RedrawFileNames
DoAutoDir:
	BSR	DoDirDragbar		;update dragbar
	btst	#3,DiskBitFlags+3	;AutoDirFlag
	BEQ	SelectPath
	move.l	FileNamesPtr(pc),a5
	tst.w	di_MemEntries(a5)
	BNE	SelectPath
AutoDir:MOVE.W	DirPathNum,D0
	;CMP.W	#1,D0
	;BEQ	LoadExeGadg
	CMP.W	#2,D0
	BEQ	LoadModuleGadg
	CMP.W	#3,D0
	BEQ	LoadSongGadg
	;CMP.W	#4,D0
	;BEQ	LoadInstrGadg
	CMP.W	#5,D0
	BEQ	LoadSampleGadg
	;CMP.W	#6,D0
	;BEQ	LoadPattGadg
	BRA	SelectModules
SelectPath:
	MOVE.W	DirPathNum,D0
	CMP.W	#1,D0
	BEQ	SelectExe
	CMP.W	#2,D0
	BEQ	SelectModules
	CMP.W	#3,D0
	BEQ	SelectSongs
	CMP.W	#4,D0
	BEQ	SelectInstr
	CMP.W	#5,D0
	BEQ	SelectSamples
	CMP.W	#4,D0
	BEQ	SelectPatt
	RTS

MakeDirScreen:
	LEA	DirScreenData,A0
	lea	UpperBuffer,a1
	JSR	DePackIt
	RNE
RemoveDirScreen:
	LEA	BitPlaneData,A0
	lea	UpperBuffer,a1
	MOVEQ	#2-1,D2
.loop1	MOVE.W	#121*80/4-1,D0
.loop2	MOVE.L	(A0),D1
	MOVE.L	(A1),(A0)+
	MOVE.L	D1,(A1)+
	DBRA	D0,.loop2
	LEA	(256-121)*80(A0),A0		;next bitplane, please
	DBRA	D2,.loop1
	moveq	#0,d0
	RTS

CheckDirGadgets:
	move.l	FileNamesPtr(PC),A5
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	DirGadgetsList,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ
	cmp.w	#1,d2			;back to Main Menu
	beq	ExitFromDir
	cmp.w	#2,d2			;Pack (1) (pp/songpack)
	beq	ToggleModPack
	cmp.w	#3,d2			;Save (SampleForm)
	beq	ToggleIFFSave
	;cmp.w	#4,d2			; Save Icon on/off
	;beq	ToggleSaveIcon
	cmp.w	#5,d2			; Hide/Show .info
	beq	FlipHideShowInfo
	cmp.w	#6,d2			; Reset paths
	beq	ResetPathsGadg
	cmp.w	#7,d2			;Format disk
	beq	DiskFormatGadg
	cmp.w	#8,d2			;Relabel disk
	beq	RelabelDiskGadg
	cmp.w	#9,d2			;Mask string
	beq	DirMaskGadg
	cmp.w	#10,d2			;Makedir
	beq	MakeDirGadg
	cmp.w	#11,d2			;Rename File
	beq	RenameFileGadg
	cmp.w	#12,d2			;Delete File
	beq	DeleteFileGadg
	cmp.w	#13,d2			;Path
	beq	DirPathGadg
	cmp.w	#14,d2			;File Name
	beq	FileNameGadg
	cmp.w	#15,d2			;Flip screen
	beq	ScreenToBack
	cmp.w	#16,d2			;ReadDir
	beq	ReadDirGadg
	cmp.w	#17,d2			;Parent Dir
	beq	ParentDirGadg
	cmp.w	#18,d2
	beq	FlipPathNum

	cmp.w	#20,d2			;Mark Exe
	beq	SelectExe
	;cmp.w	#21,d2			;Save Exe
	;beq	SaveExeGadg
	cmp.w	#22,d2			;Mark Module
	beq	SelectModules
	cmp.w	#23,d2			;Save Module
	beq	SaveModuleGadg
	cmp.w	#24,d2			;Mark song
	beq	SelectSongs
	cmp.w	#25,d2			;Save Song
	beq	SaveSongGadg
	cmp.w	#26,d2			;Mark Instr.
	beq	SelectInstr
	;cmp.w	#27,d2			;Save Instr.
	;beq	SaveInstrGadg
	cmp.w	#28,d2			;Mark samples
	beq	SelectSamples
	cmp.w	#29,d2			;Save Sample
	beq	SaveSampleGadg
	cmp.w	#30,d2			;Mark Patt
	beq	SelectPatt
	;cmp.w	#31,d2			;Save Patt
	;beq	SavePattGadg

	cmp.w	#32,d2			;Filenames Up
	beq	FileNameOneUp
	cmp.w	#33,d2			;Scroll Bar
	beq	MoveDirDragbar
	cmp.w	#34,d2			;Filenames Down	
	beq	FileNameOneDown
	;cmp.w	#35,d2			;Dir Browse
	;beq	DirBrowseGadg
	cmp.w	#37,d2			;Free
	beq	ShowFreeDiskGadg
	cmp.w	#38,d2			;Filenames Box
	beq	FileNamePressed

	cmp.w	#100,d2			;Device gadgets
	bhs	DoDevGadg
	RTS

CheckRightDirGadgets:
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	DirGadgetsList2,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ
	cmp.w	#1,d2
	beq	FlipDevsList
	cmp.w	#10,d2
	beq	GetExePath
	cmp.w	#11,d2
	beq	GetModPath
	cmp.w	#12,d2
	beq	GetSongPath
	cmp.w	#13,d2
	beq	GetInsPath
	cmp.w	#14,d2
	beq	GetSampPath
	cmp.w	#15,d2
	beq	GetPattPath
	rts
GetExePath:
	moveq	#1,d0
	lea	SelectExe(pc),a0
	bra.s	GetThePath
GetModPath:
	moveq	#2,d0
	lea	SelectModules(pc),a0
	bra.s	GetThePath
GetSongPath:
	moveq	#3,d0
	lea	SelectSongs(pc),a0
	bra.s	GetThePath
GetInsPath:
	moveq	#4,d0
	lea	SelectInstr(pc),a0
	bra.s	GetThePath
GetSampPath:
	moveq	#5,d0
	lea	SelectSamples(pc),a0
	bra.s	GetThePath
GetPattPath:
	moveq	#6,d0
	lea	SelectPatt(pc),a0
	;bra.s	GetThePath
GetThePath:
	subq.w	#1,d0
	cmp.w	#5,d0
	RHI
	mulu	#32,d0
	lea	DirPathList,a1
	lea	DefPathList,a2
	lea	(a1,d0.l),a1
	lea	(a2,d0.l),a2
	moveq	#32-1,d0
.loop	move.b	(a2)+,(a1)+
	dbf	d0,.loop
	jsr	(a0)
	btst	#3,DiskBitFlags+3	;AutoDirFlag
	BNE	AutoDir
	rts

RenameFileGadg:
	move.w	Action,SaveAction
	MOVE.W	#10,Action
	LEA	SelectFileRenameText,A0
	JSR	ShowStatusText
	BRA	RestorePtrCol

MakeDirGadg:
	lea	.reqtext(pc),a0
	lea	.dirname(pc),a1
	moveq	#32,d0
	lea	ReqImage3,a2
	jsr	AskForTextString
	RNE
	lea	.maketext(pc),a0
	JSR	ShowStatusText
	BSR	StorePtrCol
	BSR	SetWaitPtrCol

	MOVE.L	PathPtr,A0
	JSR	CopyPath
	lea	.dirname(pc),a0
	MOVEQ	#24-1,D0
.loop2	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop2

	move.l	#FileName,d1
	move.l	DosBase,a6
	jsr	LVOCreateDir(a6)
	BSR	RestorePtrCol
	JSR	ShowAllRight
	btst	#3,DiskBitFlags+3	; AutoDirFlag
	REQ
	move.b	#-1,MaskChanged
	bra	ReadDirGadg
.reqtext	dc.b	10,10,'   Make directory:',0
.maketext	dc.b	'Creating directory...',0
.dirname	dc.b	'modules'
		ds.b	34-7
		cnop	0,2


DeleteFileGadg:
	move.w	Action,SaveAction
	move.w	#4,Action		; Delete file
	LEA	SelectFileDeleteText,A0
	JSR	ShowStatusText
	BRA	SetDeletePtrCol

ToggleModPack:
	bchg	#1,DiskBitFlags+3	;ModPackMode
ShowModPackMode:
	LEA	ToggleOFFText(PC),A0
	btst	#1,DiskBitFlags+3	;ModPackMode
	BEQ.S	.skp
	LEA	ToggleONText2(PC),A0
.skp	MOVEQ	#3,D0
	MOVE.W	#14*80+9,D1
	JSR	ShowText3
	BRA	WaitForButtonUp

;ToggleSongPack:
;	bchg	#0,DiskBitFlags+3	;PackMode
;ShowPackMode:
;	LEA	ToggleOFFText(PC),A0
;	btst	#0,DiskBitFlags+3	;PackMode
;	BEQ.S	.skip
;	LEA	ToggleONText2(PC),A0
;.skip	MOVEQ	#3,D0
;	MOVE.W	#69*80+9,D1
;	JSR	ShowText3
;	BRA	WaitForButtonUp

ToggleIFFSave:
	EOR.B	#1,RAWIFFMode
ShowRAWIFFMode:
	LEA	.text1(PC),A0
	TST.B	RAWIFFMode
	BEQ.S	.cnt
	LEA	.text2(PC),A0
.cnt	MOVEQ	#3,D0
	MOVE.W	#25*80+9,D1
	JSR	ShowText3
	BRA	WaitForButtonUp
.text1	dc.b "RAW",0
.text2	dc.b "IFF",0

ExitFromDir:
	clr.w	dirdragpos
	move.w	#dirdragmaxlen,dirdraglen
	move.b	#$f8,DragBarSpriteData+1; Slette dragbar fra skjermen
	move.l	#-1,OldDateStamp	;make sure date is updated
	move.l	#-1,OldDateStamp+4
	move.l	#-1,OldDateStamp+8
	cmp.w	#-1,forrigeinv
	beq.s	.exit
	movem.l	d0-d3/a0,-(sp)
	jsr	dothefileinv
	movem.l	(sp)+,d0-d3/a0
	move.w	#-1,forrigeinv
	move.w	#-1,FileInvOn
	move.w	#MainScreen_ID,CurrScreen
.exit	BSR	WaitForButtonUp
	CLR.B	RawKeyCode
	BSR	RemoveDirScreen
	BSR	Clear121Lines
DisplayMainAll:
	BSR	DisplayMainScreen
	JSR	ShowSongLength
	JSR	ShowSampleInfo
	JSR	ShowSongName
	jsr	Show_MS
	TST.W	LoadInProgress
	BNE.S	.skp
	JSR	ShowAllRight
.skp	JMP	ShowPosition

;--- Device list ---

DrawDevs:
	jsr	WaitForDiskDrive
	bsr	DevicesMounted
	RNE
DoDrawDevs:
	tst.w	DevsNum
	REQ
	move.b	ShowZeroFlag,d0
	move.b	d0,.saveflag
	move.b	#" ",ShowZeroFlag
	move.l	DevsList(pc),d0
	REQ
	move.l	d0,a0
	move.w	DevsPos(pc),d0
	mulu	#32,d0
	add.l	d0,a0
	move.w	#202,d0
	move.w	#14,d1
	moveq	#8,d3
	move.w	DevsNum(pc),d7
	sub.w	DevsPos(pc),d7
	cmp.w	#16,d7
	bmi.s	.cnt
	moveq	#16,d7
.cnt	subq.w	#1,d7
	bmi.s	.end
.loop	tst.l	(a0)
	REQ
	jsr	ShowColorText
	lea	32(a0),a0
	cmp.w	#202,d0
	bne.b	.cn1
	move.w	#262,d0
	dbf	d7,.loop
	bra.b	.end
.cn1	move.w	#202,d0
	add.w	#11,d1
	dbf	d7,.loop
.end	move.b	.saveflag(pc),d0
	move.b	d0,ShowZeroFlag
	rts
	cnop	0,4
.saveflag	dc.w	0

FlipDevsList:
	bsr	WaitForButtonUp
	cmp.w	#16,DevsNum
	RMI
	move.w	DevsPos(pc),d0
	add.w	#16,d0
	cmp.w	DevsNum(pc),d0
	blt.s	.cnt
	moveq	#0,d0
.cnt	move.w	d0,DevsPos
	bsr.s	ClearDevs
	bra.w	DoDrawDevs
ClearDevs:
	moveq	#16-1,d7
	move.w	#202,d0
	move.w	#14,d1
	moveq	#8,d3
.loop	lea	.text(pc),a0
	jsr	ShowColorText
	cmp.w	#202,d0
	bne.b	.cn1
	move.w	#262,d0
	dbf	d7,.loop
	bra.b	.end
.cn1	move.w	#202,d0
	add.w	#11,d1
	dbf	d7,.loop
.end	rts
	cnop	0,4
.text	dcb.b	20," "

DoDevGadg:
	sub.w	#100,d2
	add.w	DevsPos(pc),d2
	cmp.w	DevsNum(pc),d2
	RGE
	mulu	#32,d2
	move.l	DevsList(pc),a1
	lea	(a1,d2.l),a1
	MOVE.W	DirPathNum,D0
	subq.w	#1,d0
	mulu	#32,d0
	lea	DirPathList,A0
	lea	(a0,d0.l),a0
	MOVEQ	#32-1,D1
.lop1	MOVE.B	(a1)+,(A0)+
	DBRA	D1,.lop1
	BSR	ShowDirPath
	bra.w	addpdir

DevicesMounted:		;		o  }:(   plystre
	movem.l d0-d7/a0-a6,-(sp)
	move.l	4.w,a6
	jsr	LVOForbid(a6)		; We can allow this. It's not for a loong time!
	move.l	DosBase,a1
	move.l	34(a1),a1		; dl_Root (APTR)
	move.l	24(a1),a1		; rn_Info
	move.l	a1,d0
	lsl.l	#2,d0			; Convert BCPL into APTR
	move.l	d0,a1
	move.l	4(a1),d0		; di_DevInfo
	lsl.l	#2,d0			; Convert BCPL into APTR
	move.l	d0,a1			; Ptr to  *Struct DeviceNode
	move.l	a1,.devadr
	bsr.w	.countdev
	addq.w	#6,d0			; 6 stk default paths
	move.w	d0,DevsNum
	mulu	#32,d0
	cmp.l	DevsLen(pc),d0		; don't allocate if the number
	beq.s	.cntr			; of devs is the same!
	move.l	d0,-(sp)
	bsr	FreeDevsList
	move.l	(sp)+,d0
	clr.w	DevsPos
	move.l	d0,DevsLen	; number of bytes to allocate
	MOVE.L	#MEMF_ANY!MEMF_CLEAR,D1
	MOVE.L	4.w,A6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,DevsList
	BEQ.s	.error
.cntr	move.l	DevsList(pc),a0
	move.l	DevsLen(pc),d0
	subq.l	#1,d0
	bmi.s	.cnt2
.clrlop	clr.b	(a0)+
	subq.l	#1,d0
	bpl.s	.clrlop
.cnt2	clr.l	.count
	clr.l	.type
	bsr.s	.getdev		; Partitions/Mounts
	move.l	#2,.type
	bsr.s	.getdev		; Partition Names/Mount Names
	move.l	#1,.type
	bsr.s	.getdev		; Assigns
	bsr.w	.getdefpaths	; Default paths
	move.l	4.w,a6
	jsr	LVOPermit(a6)
	movem.l (sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
.error	movem.l (sp)+,d0-d7/a0-a6
	clr.w	DevsNum
	clr.w	DevsPos
	move.l	4.w,a6
	jsr	LVOPermit(a6)
	jsr	OutOfMemErr
	moveq	#0,d0
	rts

.countdev
	movem.l d1-d7/a0-a6,-(sp)
	move.l	.devadr(pc),a1
	moveq	#0,d0
.loop2	move.l	(a1),d1			; Test for more possible volumes!
	beq.b	.exit
	lsl.l	#2,d1			; Convert BCPL into APTR
	move.l	d1,a1
	tst.l	8(a1)			; dl_Task
	beq.s	.loop2
	add.l	#1,d0
	bra.s	.loop2
.exit	movem.l (sp)+,d1-d7/a0-a6
	rts
.getdev	movem.l d0-d7/a0-a6,-(sp)
	move.l	.devadr(pc),a1
.loop	;cmp.l	#32*16,.count		; Max x Volumenames
	;bge.b	.done
	move.l	(a1),d0			; Test for more possible volumes!
	beq.b	.done
	lsl.l	#2,d0			; Convert BCPL into APTR
	move.l	d0,a1
	tst.l	8(a1)			; dl_Task
	beq.s	.loop
	move.l	.type(pc),d0
	cmp.l	4(a1),d0		; Is it really a volumenode??
	beq.b	.copy
	bra.b	.loop
.done	movem.l (sp)+,d0-d7/a0-a6
	rts
.copy	move.l	40(a1),d0		; dn_Name (Pointer to BCPL String..)
	lsl.l	#2,d0			; Convert BCPL into APTR
	move.l	d0,a2			; Converting successfull. I hope!
	moveq	#0,d5
	move.l	DevsList(pc),a3
	move.l	.count(pc),d5
	lea	(a3,d5.l),a3
	moveq	#31-1,d7		; Used as counter (Safety rules)
	lea	1(a2),a2		; Skip First byte (Namelenght)
.lp	tst.b	(a2)
	beq.b	.done2
	move.b	(a2)+,(a3)+
	dbf	d7,.lp
.done2	move.b	#':',(a3)	; This is surely a volume  ;-)
	add.l	#32,.count	; Jompa to next name
	bra.b	.loop
.getdefpaths
	movem.l d0-d7/a0-a6,-(sp)
	lea	DefPathList,a2
	move.l	DevsList(pc),a3
	move.l	.count(pc),d5
	lea	(a3,d5.l),a3
	move.w	#32*6-1,d7
.lp2	move.b	(a2)+,(a3)+
	dbf	d7,.lp2
	add.l	#32*6,.count
	movem.l (sp)+,d0-d7/a0-a6
	rts
	cnop	0,4
.count	dc.l	0	; Counter for where in VolTable I am
.type	dc.l	0
.devadr	dc.l	0

FreeDevsList:
	move.l	DevsList(pc),d1
	beq.s	.cnt
	move.l	d1,a1
	move.l	DevsLen(pc),d0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	clr.l	DevsList
.cnt	rts

	cnop	0,4
DevsList:	dc.l	0
DevsLen:	dc.l	0
DevsPos:	dc.w	0
DevsNum:	dc.w	0

; --------

FlipPathNum:
	move.w	DirPathNum(pc),d0
	;addq.w	#1,d0
	cmp.w	#6,d0
	blt.s	.cnt
	moveq	#0,d0
.cnt	lsl.w	#2,d0
	move.l	.tab(pc,d0.w),a0
	jmp	(a0)
.tab	dc.l	SelectExe,SelectModules,SelectSongs
	dc.l	SelectInstr,SelectSamples,SelectPatt

ResetPathsGadg:
	lea	.surereset(pc),a0
	BSR	AreYouSure
	RNE
	lea	DefPathList,a0
	lea	DirPathList,a1
	move.w	#32*6-1,d0
.loop	move.b	(a0)+,(a1)+
	dbf	d0,.loop
	bra	ShowDirPath
.surereset
	dc.b	10,10,'   Are you sure you want',10
	dc.b	'    to reset all paths?',0
	cnop	0,2

SelectExe:
	move.w	#0,Action
	MOVEQ	#1,D0
	LEA	SelectModuleText,A0
	lea	ExeDirInfo(pc),a1
	BRA.S	ChangePath
SelectModules:
	move.w	#3,Action
	MOVEQ	#2,D0
	LEA	SelectModuleText,A0
	lea	ModDirInfo(pc),a1
	BRA.S	ChangePath
SelectSongs:
	move.w	#1,Action
	MOVEQ	#3,D0
	LEA	SelectSongText,A0
	lea	SongDirInfo(pc),a1
	BRA.S	ChangePath
SelectInstr:
	move.w	#0,Action
	MOVEQ	#4,D0
	LEA	SelectSampleText,A0
	lea	InsDirInfo(pc),a1
	BRA.S	ChangePath
SelectSamples:
	move.w	#5,Action
	MOVEQ	#5,D0
	LEA	SelectSampleText,A0
	lea	SampDirInfo(pc),a1
	BRA.S	ChangePath
SelectPatt:
	move.w	#0,Action
	MOVEQ	#6,D0
	LEA	SelectModuleText,A0
	lea	PattDirInfo(pc),a1
	;BRA.S	ChangePath
ChangePath:
	movem.l d0-d7/a0-a6,-(sp)
	JSR	ShowStatusText
	movem.l (sp)+,d0-d7/a0-a6

	btst	#2,DiskBitFlags+2
	bne.s	.cnt
	lea	ModDirInfo(pc),a1
.cnt	move.l	a1,FileNamesPtr

	bsr.w	ClearPathMarks
	move.w	d0,DirPathNum
	subq.w	#1,d0
	mulu	#32,d0
	lea	DirPathList,a3
	lea	(a3,d0.l),a3
	MOVE.L	A3,PathPtr

	lea	MarkChar(pc),a0
	move.b	#"`",MarkChar
	move.w	DirPathNum(pc),d1
	mulu	#11,d1
	add.w	#35-11,d1
	moveq	#101,d0
	moveq	#1,d3
	jsr	ShowColorText
	move.w	DirPathNum(pc),d0
	subq.w	#1,d0
	mulu	#10,d0
	lea	.text(pc,d0.l),a0
	move.w	#234,d0
	moveq	#113,d1
	moveq	#10,d3
	jsr	ShowColorText

	BSR	ShowFileName
	BSR	ShowMask
	BSR	ShowDirPath
	BSR	SetNormalPtrCol
	btst	#2,DiskBitFlags+2	; multi cache flag
	beq.s	.cnt2
	move.l	FileNamesPtr(PC),A5
	cmp.w	#19,di_Entries(a5)
	bpl.s	.cnt3
	BSR	ClearFileNames
.cnt3	move.w	di_ScrPos(a5),d0
	bsr	RedrawFileNames
	bsr	DoDirDragbar
	bsr	ShowDiskSpace
.cnt2	BRA	WaitForButtonUp
.text	dc.b	'Executable'
	dc.b	'  Module  '
	dc.b	'   Song   '
	dc.b	'Instrument'
	dc.b	'  Sample  '
	dc.b	' Pattern  '
DirPathNum:dc.w 2

ClearPathMarks:
	movem.l	d0-d3/a0,-(sp)
	lea	MarkChar(pc),a0
	move.b	#" ",MarkChar
	move.w	DirPathNum,d1
	mulu	#11,d1
	add.w	#35-11,d1
	move.w	#101,d0
	moveq	#1,d3
	jsr	ShowColorText
	movem.l	(sp)+,d0-d3/a0
	rts

	cnop	0,4
MarkChar:dc.w	0

;---- Read Dir ----

ReadDirGadg:
	move.w	DirPathNum,d0
	;cmp.w	#1,d0
	;beq	LoadExeGadg
	cmp.w	#2,d0
	beq	LoadModuleGadg
	cmp.w	#3,d0
	beq	LoadSongGadg
	;cmp.w	#4,d0
	;beq	LoadInstrGadg
	cmp.w	#5,d0
	beq	LoadSampleGadg
	;cmp.w	#6,d0
	;beq	LoadPattGadg
	rts

;---- Song Gadgets ----

LoadSongGadg:
	BSR	StorePtrCol
	BSR	WaitForButtonUp
	bsr	SelectSongs
	BSR	ClearFileNames
	move.l	FileNamesPtr(PC),A5
	;BSR	HasDiskChanged
	;tst.l	d0
	;BEQ	LoadSongDirOk
	BSR	ClearDirTotal
	BSR	DirDisk
	BNE	RestorePtrCol
LoadSongDirOk:
	MOVE.W	di_ScrPos(a5),D0
	BSR	RedrawFileNames
	bsr.w	DoDirDragbar
	MOVE.W	#1,Action
	LEA	SelectSongText,A0
	JSR	ShowStatusText
	BRA	RestorePtrCol

SaveSongGadg:
	BSR	SelectSongs
	LEA	SaveSongText,A0
	BSR	AreYouSure
	RNE
	BSR	RestorePtrCol
	JSR	SaveSong
	MOVE.W	#1,Action
	btst	#3,DiskBitFlags+3	;AutoDir
	REQ
	move.b	#-1,MaskChanged
	bra	ReadDirGadg
 
;---- Module Gadgets ----

LoadModuleGadg:
	BSR	StorePtrCol
	BSR	WaitForButtonUp
	BSR	SelectModules
	BSR	ClearFileNames
	move.l	FileNamesPtr(PC),A5
	;BSR	HasDiskChanged
	;tst.l	d0
	;BEQ.S	LoadModDirOk
	BSR	ClearDirTotal
	BSR	DirDisk
	BEQ.S	LoadModDirOk
	BRA	RestorePtrCol

LoadModDirOk:
	MOVE.W	di_ScrPos(a5),D0
	BSR	RedrawFileNames
	bsr.w	DoDirDragbar
	MOVE.W	#3,Action
	LEA	SelectModuleText,A0
	JSR	ShowStatusText
	BRA	RestorePtrCol

SaveModuleGadg:
	BSR	SelectModules
	LEA	SaveModuleText,A0
	BSR	AreYouSure
	RNE
	JSR	SaveModule
	MOVE.W	#3,Action
	jsr	ShowAllRight
	btst	#3,DiskBitFlags+3	;AutoDir
	REQ
	move.b	#-1,MaskChanged
	bra	ReadDirGadg

;---- Sample Gadgets ----

LoadSampleGadg:
	BSR	StorePtrCol
	BSR	WaitForButtonUp
	BSR	SelectSamples
	BSR	ClearFileNames
	move.l	FileNamesPtr(PC),A5
	;BSR	HasDiskChanged
	;tst.l	d0
	;BEQ.S	LoadSampleDirOk
	BSR	ClearDirTotal
	BSR	DirDisk
	BEQ.S	LoadSampleDirOk
	BRA	RestorePtrCol

LoadSampleDirOk:
	MOVE.W	di_ScrPos(a5),D0
	BSR	RedrawFileNames
	bsr.w	DoDirDragbar
	MOVE.W	#5,Action
	LEA	SelectSampleText,A0
	JSR	ShowStatusText
	BRA	RestorePtrCol

SaveSampleGadg:
	BSR	SelectSamples
	CLR.B	RawKeyCode
	MOVE.W	InsNum,D0
	JEQ	NotSampleNull
	LEA	SaveSampleText,A0
	BSR	AreYouSure
	RNE
	BSR	StorePtrCol
	JSR	CreateSampleName
	MOVEQ	#0,D1
	MOVE.W	InsNum,D1
	LSL.L	#2,D1
	LEA	SamplePtrs,A0
	MOVE.L	0(A0,D1.W),DiskDataPtr

	BSR	SetDiskPtrCol
	MOVE.L	DosBase,A6
	MOVE.L	FileNamePtr,D1
	MOVE.L	#1006,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,FileHandle
	BNE	SaveSample
	JSR	CantOpenFile
	BRA	ErrorRestoreCol

SaveSample:
	LEA	SavingSampleText,A0
	JSR	ShowStatusText
	TST.B	RAWIFFMode
	BEQ	savesam
	MOVE.L	FileHandle,D1
	MOVE.L	#IFFFORM,D2
	MOVEQ	#IFFEND-IFFFORM,D3
	JSR	LVOWrite(A6)
savesam	MOVE.L	FileHandle,D1
	MOVE.L	DiskDataPtr,D2
	MOVE.L	DiskDataLength,D3
	JSR	LVOWrite(A6)

	MOVE.L	FileHandle,D1
	JSR	LVOClose(A6)
	CLR.L	FileHandle
	MOVE.W	#5,Action
	JSR	ShowAllRight
	BSR	RestorePtrCol
	btst	#3,DiskBitFlags+3	;AutoDir
	REQ
	move.b	#-1,MaskChanged
	bra	ReadDirGadg

IFFFORM:dc.b	"FORM"
	dc.l	0
	dc.b	"8SVX"
IFFVHDR:dc.b	"VHDR"
	dc.l	20
	dc.l	0,0,32		; oneshot, repeat, hisamples
	dc.w	16726		; This is really NTSC (16574 for PAL!!!)
	dc.b	1,0		; octaves, compression
	dc.l	$10000		; volume
IFFNAME:dc.b	"NAME"
	dc.l	24
	dcb.b	24,0
	dc.b	"ANNO"
	dc.l	16
	dc.b	"Protracker 3.15",0
IFFBODY:dc.b	"BODY"
	dc.l	0
IFFEND:

;---- FileName Gadget ----

ShowFileName:
	bsr	GetFileName
	move.l	a0,ShowTextPtr
	move.w	#113*80+5,TextOffset
	cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.cnt
	move.w	#80*80+10,TextOffset
.cnt	move.w	#20,TextLength
	jsr	ShowText
	rts

FileNameGadg:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	bsr	GetFileName
	move.l	a0,a6
	MOVE.L	A6,ShowTextPtr
	MOVE.L	A6,TextEndPtr
	ADD.L	#20,TextEndPtr
	MOVE.W	#20,TextLength
	MOVE.W	#113*80+5,A4
	JSR	GetTextLine
	BSR	RestorePtrCol
	rts

GetFileName:
	MOVE.L	SongDataPtr,A0
	move.w	DirPathNum,d0
	cmp.w	#1,d0		; exe
	bne.b	.fnc1
	MOVE.L	SongDataPtr,A0
.fnc1	cmp.w	#2,d0		; module
	bne.b	.fnc2
	MOVE.L	SongDataPtr,A0
.fnc2	cmp.w	#3,d0		; song
	bne.b	.fnc3
	move.l	SongDataPtr,A0
.fnc3	cmp.w	#4,d0		; instr
	bne.b	.fnc4
	lea	InsFileName,A0
.fnc4	cmp.w	#5,d0		; sample
	bne.b	.fnc5
	MOVE.L	SongDataPtr,A0
	LEA	-10(A0),A0
	MOVE.W	InsNum,D7
	BNE.S	.skip
	MOVE.W	LastInsNum,D7
.skip	MULU	#30,D7
	ADD.L	D7,A0
.fnc5	cmp.w	#6,d0		; patt
	bne.b	.fnc6
	lea	PatFileName,A0
.fnc6	rts

	cnop	0,4
InsFileName:ds.b	22
PatFileName:ds.b	22

;---- Mask Gadget ----

ShowMask:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	DirPathNum(pc),d0
	subq.w	#1,d0
	mulu	#32,d0
	lea	MaskTab,a6
	lea	(a6,d0.l),a6	; mask
	move.l	A6,ShowTextPtr
	move.l	A6,maskptr
	move.l	a6,a0
	moveq	#41,d0
	moveq	#91,d1
	moveq	#7,d3
	JSR	ShowAnyText3
	movem.l	(sp)+,d0-d7/a0-a6
	rts

DirMaskGadg:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol		;first check which mode we are in
	move.w	DirPathNum,d0
	cmp.w	#6,d0
	RHI
	subq.w	#1,d0
	mulu	#32,d0
	lea	MaskTab,a6
	lea	(a6,d0.l),a6	; mask

	move.l	A6,maskptr
	MOVE.L	A6,ShowTextPtr
	MOVE.L	A6,TextEndPtr
	ADD.L	#31,TextEndPtr
	MOVE.W	#7,TextLength
	moveq	#41,d0
	moveq	#91,d1
	JSR	GetAnyTextLine
	BSR	RestorePtrCol
	move.l	maskptr,a1
	bsr.w	MakeUpperStr		;turn case sensitivity off
	move.b	#-1,MaskChanged
	rts

; a0 = mask, a1 = string to match
MatchMask:
	movem.l	d0-d1/a0-a3,-(sp)
	exg	a0,a1
	tst.b	(a1)
	beq.s	.okmask
.loop1	move.b	(a1)+,d0
	cmp.b	#'#',d0
	bne.s	.cnt1
	cmp.b	#'?',(a1)
	bne.s	.cnt1
	addq.l	#1,a1
	bra.s	.mask1
.cnt1	move.b	(a0)+,d1
	bne.s	.cnt2
	tst.b	d0
	beq.s	.okmask
	bra.s	.notmsk
.cnt2	cmp.b	d0,d1
	beq.s	.loop1
	bra.s	.notmsk
.mask1	move.l	a0,a3
	move.l	a1,a2
	addq.l	#1,a0
.loop2	move.b	(a2)+,d0
	cmp.b	#'#',d0
	bne.s	.cnt3
	cmp.b	#'?',(a2)
	bne.s	.cnt3
	addq.l	#1,a2
	move.l	a2,a1
	move.l	a3,a0
	bra.s	.mask1
.cnt3	move.b	(a3)+,d1
	bne.s	.cnt4
	tst.b	d0
	beq.s	.okmask
	cmp.b	#'#',(a2)
	bne.s	.notmsk
	cmp.b	#'?',1(a2)
	bne.s	.notmsk
	tst.b	2(a2)
	bne.s	.notmsk
	bra.s	.okmask
.cnt4	tst.b	d0
	beq.s	.cnt5
	cmp.b	d0,d1
	beq.s	.loop2
.cnt5	bra.s	.mask1
.okmask	movem.l	(sp)+,d0-d1/a0-a3
	moveq	#0,d0
	rts
.notmsk	movem.l	(sp)+,d0-d1/a0-a3
	moveq	#-1,d0
	rts

InfoMask:	dc.b	'#?.INFO',0
MaskChanged:	dc.w	0
maskptr:	dc.l	0
		cnop	0,2

MakeUpperStr:
	movem.l	d0/a1,-(sp)
.uplp	move.b	(a1)+,d0
	tst.b	d0
	beq.s	.exit
	cmp.b	#'a',d0
	beq.b	.convit
	bmi.s	.uplp
	cmp.b	#'z',d0
	beq.s	.convit
	bpl.s	.uplp
.convit	sub.b	#32,d0
	move.b	d0,-1(a1)
	bra.b	.uplp
.exit	movem.l	(sp)+,d0/a1
	rts

FlipHideShowInfo:
	bsr	WaitForButtonUp
	bchg	#0,DiskBitFlags+2	;HideShowFlag
	move.b	#-1,MaskChanged
ShowHideShowInfo:
	lea	.text(pc),a0
	btst	#0,DiskBitFlags+2	;HideShowFlag
	beq.s	.cnt
	addq.l	#4,a0
.cnt	moveq	#17,d0
	moveq	#47,d1
	moveq	#4,d3
	jmp	ShowColorText
.text	dc.b	'Hide'
	dc.b	'Show'

;---- Directory Path Gadget ----

DirPathGadg:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	MOVE.L	PathPtr,A6
	MOVE.L	A6,ShowTextPtr
	MOVE.L	A6,TextEndPtr
	ADD.L	#31,TextEndPtr
	MOVE.W	#21,TextLength
	MOVE.W	#102*80+5,A4
	JSR	GetTextLine
	BSR	RestorePtrCol
	BSR	WaitForButtonUp
	tst.w	TextAborted
	RNE
	btst	#3,DiskBitFlags+3	;AutoDir
	REQ
	move.b	#-1,MaskChanged
	BRA	ReadDirGadg

CopyPath:
	LEA	FileName,A1
	TST.B	(A0)		; If no path
	REQ
.loop	MOVE.B	(A0)+,(A1)+	; Copy path to filename
	BNE	.loop
	CMP.B	#':',-2(A1)	; If ending with ':' it's ok
	BEQ.S	.back
	CMP.B	#'/',-2(A1)	; If ending with '/' it's ok
	BEQ.S	.back
	MOVE.B	#'/',-1(A1)	; Add '/' to end path
	RTS
.back	SUBQ.L	#1,A1
	RTS

ShowDirPath:
	cmp.w	#DirScreen_ID,CurrScreen
	RNE
	MOVEM.L	D0-D7/A0-A6,-(SP)
	MOVE.L	PathPtr,A0
	MOVEQ	#22,D0
	MOVE.W	#102*80+5,D1
	JSR	ShowText3
	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

;---- File List Gadgets ----

FileNameOneUp:
	TST.W	Action
	REQ
	move.l	FileNamesPtr(PC),A5
	MOVE.W	di_ScrPos(a5),D0
	REQ
	SUBQ.W	#1,D0
	move.w	d0,di_ScrPos(a5)
	bsr	DoDirDragbar
	BTST	#2,$DFF016
	BNE	RedrawFileNames
	SUBQ.W	#3,D0
	BPL	RedrawFileNames
	MOVEQ	#0,D0
	BRA	RedrawFileNames

FileNameOneDown:
	TST.W	Action
	REQ
	move.l	FileNamesPtr(PC),A5
	MOVE.W	di_ScrPos(a5),D0
	ADDQ.W	#1,D0
	BTST	#2,$DFF016
	BNE.S	.fnod2
	ADDQ.W	#3,D0
.fnod2	MOVE.W	di_Entries(A5),D1
	SUB.W	#19,D1			; disp.num
	RMI
	move.w	d0,di_ScrPos(a5)
	bsr	DoDirDragbar
	CMP.W	D1,D0
	BLS	RedrawFileNames
	MOVE.W	D1,D0
	BRA	RedrawFileNames

;---- Dragbar ----

DoDirDragbar:
	movem.l	d0-d3,-(sp)
	moveq	#0,d3
	move.w	#dirdragmaxlen,dirdraglen
	clr.w	dirdragpos
	move.l	FileNamesPtr(pc),a5
	moveq	#dirdragmaxlen,d0
	move.w	#0,d1
	cmp.w	#19,di_Entries(a5)
	bmi.s	.doddb
	beq.s	.doddb
	move.w	#19*dirdragmaxlen,d0
	move.w	di_Entries(a5),d1
	ext.l	d0
	divu	d1,d0
	move.w	d0,dirdraglen		;length of dragbar
	move.w	di_ScrPos(a5),d1	;O
	move.w	di_Entries(a5),d2	;N
	move.w	#dirdragmaxlen,d3	;Y
	sub.w	d0,d3			;Y-L
	mulu	d1,d3			;O*(Y-L)
	sub.w	#19,d2			;N-19
	divu	d2,d3			;O*(Y-L)/(N-19)
	move.w	d3,dirdragpos		;yposition of dragbar in dragbarwindow
.doddb
	move.w	dirdragpos(pc),d3
	add.w	dirdraglen(pc),d3
	cmp.w	#dirdragmaxlen,d3
	bmi.b	.doddb2
	moveq	#dirdragmaxlen,d3
.doddb2	sub.w	dirdraglen(pc),d3
	move.w	d3,dirdragpos
	bsr.w	SetDirDragLen
	movem.l	(sp)+,d0-d3
	rts

	cnop	0,4
dirdragpos:	dc.w	0
dirdraglen:	dc.w	0
dirdragmaxlen	equ 83
dirdragypos	equ 24

MoveDirDragbar:
	move.l	FileNamesPtr(pc),a5
	cmp.w	#19,di_Entries(a5)
	RLS
	move.w	#-1,FileInvOn
	move.w	MouseY,d1
	move.w	dirdragpos,d0
	add.w	#dirdragypos,d0
	sub.w	d0,d1
	bmi	UpperDrag
	cmp.w	dirdraglen,d1
	bpl	LowerDrag
	move.w	d1,d2
	move.w	#dirdragmaxlen,d4
	sub.w	dirdraglen,d4
	bsr	SetDirDragLen2

	move.w	MouseY,d1
.loop	bsr	CheckNTSCPos
	btst	#6,$bfe001
	bne.s	.end
	move.w	d1,d3
	move.w	MouseY,d1
	cmp.w	d1,d3
	beq.s	.loop
	sub.w	d2,d1
	sub.w	#24,d1		; Upper Ypos
	bpl.b	.cn0
	moveq	#0,d1
.cn0	cmp.w	d4,d1
	bmi.b	.cn1
	move.w	d4,d1
.cn1	move.w	d1,dirdragpos

	bsr.w	SetDirDragPos

	movem.l	d0-d7/a0-a6,-(sp)
	move.l	FileNamesPtr(pc),a5
	move.w	di_Entries(a5),d0
	sub.w	#19,d0
	mulu	dirdragpos,d0
	move.w	#dirdragmaxlen,d1
	sub.w	dirdraglen,d1
	divu	d1,d0
	move.w	d0,di_ScrPos(a5)
	bsr.w	RedrawFileNames
	movem.l	(sp)+,d0-d7/a0-a6

	btst	#6,$bfe001
	beq	.loop
.end	bsr	SetDirDragLen
	clr.w	FileInvOn
	rts

UpperDrag:
	sub.w	#19,di_ScrPos(a5)
	bpl	.cnt
	clr.w	di_ScrPos(a5)
.cnt	bsr.w	DoDirDragbar
	move.w	di_ScrPos(a5),d0
	bsr.w	RedrawFileNames
	clr.w	FileInvOn
	rts

LowerDrag:
	add.w	#19,di_ScrPos(a5)
	move.w	di_Entries(a5),d0
	sub.w	#19,d0
	cmp.w	di_ScrPos(a5),d0
	bpl	.cnt
	move.w	d0,di_ScrPos(a5)
.cnt	bsr.w	DoDirDragbar
	move.w	di_ScrPos(a5),d0
	bsr.w	RedrawFileNames
	clr.w	FileInvOn
	rts

SetDirDragPos:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	dirdragpos,d1
	add.w	#dirdragypos,d1
	move.w	#317,d0
	move.w	dirdraglen,d2
	lea	DragBarSpriteData,a0
	jsr	SetSpritePos
	movem.l	(sp)+,d0-d7/a0-a6
	rts

SetDirDragLen:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	dirdragpos,d1
	add.w	#dirdragypos,d1
	move.w	#317,d0
	move.w	dirdraglen,d2
	jsr	SetSpriteDragBar
	movem.l	(sp)+,d0-d7/a0-a6
	rts

SetDirDragLen2:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	dirdragpos,d1
	add.w	#dirdragypos,d1
	move.w	#317,d0
	move.w	dirdraglen,d2
	jsr	SetSpriteDragBar2
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;---- Clicked on a filename ----

FileNamePressed:
	TST.W	forrigeinv
	RMI
	move.w	forrigeinv,d1
	MOVE.W	#1,UpdateFreeMem
	TST.W	Action
	REQ
	AND.L	#$FFFF,D1
	;MOVE.W	D1,di_not2(a5)			; ???
	move.l	FileNamesPtr(PC),A5
	MOVE.W	di_ScrPos(a5),D0
	ADD.W	D1,D0
	CMP.W	di_Entries(A5),D0
	RHS
	MULU	#36,D0
	ADD.L	di_MemPtr(A5),D0
	MOVE.L	D0,A0
	MOVE.W	Action,D6
	cmp.w	#4,d6
	beq.s	.cnt	
	cmp.w	#10,d6
	beq.s	.cnt
	TST.L	32(A0)
	BMI.S	AddDirectory
.cnt	LEA	DirInputName,A1
	MOVEQ	#DirNameLength-1,D0
.loop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop
	CMP.W	#1,D6
	JEQ	LoadSong
	CMP.W	#3,D6
	JEQ	LoadModule
	CMP.W	#5,D6
; JEQ	LoadSample		; -maw-
	JEQ     mawLoadSample 	; -maw-
	CMP.W	#4,D6
	JEQ	DoDeleteFile
	CMP.W	#10,D6
	JEQ	RenameFile
	RTS

AddDirectory:
	MOVE.L	A0,-(SP)
	MOVE.L	PathPtr,A0
	BSR	CopyPath
	MOVE.L	(SP)+,A0
	MOVEQ	#DirNameLength-1,D0
.loop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop
	LEA	FileName,A0
	MOVE.L	PathPtr,A1
	MOVEQ	#32-1,D0
.loop2	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop2
addpdir	BSR	ShowDirPath
	MOVE.W	Action,D6
	CMP.W	#1,D6
	BEQ	LoadSongGadg
	CMP.W	#3,D6
	BEQ	LoadModuleGadg
	CMP.W	#5,D6
	BEQ	LoadSampleGadg
	RTS

ParentDirGadg:
	BSR	WaitForButtonUp
	MOVE.L	PathPtr,A0
	MOVE.L	A0,A1
.loop	TST.B	(A1)+
	BNE.s	.loop
	SUBQ.L	#1,A1
	CMP.L	A0,A1
	RLS
	SUBQ.L	#1,A1
	CMP.B	#'/',(A1)
	BNE.S	.skp1
	CLR.B	(A1)
.skp1	CMP.B	#':',(A1)
	BEQ.S	addpdir
	CMP.B	#'/',(A1)
	BEQ	.slsh
	CLR.B	(A1)
	CMP.L	A0,A1
	BLS.S	addpdir
	SUBQ.L	#1,A1
	BRA.S	.skp1
.slsh	CLR.B	(A1)
	BRA	addpdir

	rsreset			; DirInfo structure
di_MemPtr:	rs.l	1
di_MemSize:	rs.l	1
di_MemEntries:	rs.w	1
di_Days:	rs.l	1
di_Minutes:	rs.l	1
di_Ticks:	rs.l	1
di_Entries:	rs.w	1
di_ScrPos:	rs.w	1
di_DiskFree:	rs.l	1
di_SIZEOF:	rs.b	0

	cnop	0,4

FileNamesPtr:	dc.l	ModDirInfo

ExeDirInfo:	ds.b	di_SIZEOF
ModDirInfo:	ds.b	di_SIZEOF
SongDirInfo:	ds.b	di_SIZEOF
InsDirInfo:	ds.b	di_SIZEOF
SampDirInfo:	ds.b	di_SIZEOF
PattDirInfo:	ds.b	di_SIZEOF

;---- Has Disk Changed ----

HasDiskChanged:
	MOVE.L	DosBase,A6
	MOVE.L	A4,D1
	MOVEQ	#-2,D2
	JSR	LVOLock(A6)
	MOVE.L	D0,FileLock
	BEQ.S	ExamineError
	MOVE.L	FileLock,D1
	MOVE.L	#FileInfoBlock,D2
	JSR	LVOExamine(A6)
	TST.L	D0
	BEQ.S	ExamineError
	LEA	FileInfoBlock,A0
	tst.b	MaskChanged			;test if mask has changed
	bne.s	DiskChanged
	MOVE.L	ofib_DateStamp+ds_Days(A0),D0
	CMP.L	di_Days(A5),D0
	BNE.S	DiskChanged
	MOVE.L	ofib_DateStamp+ds_Minute(A0),D0
	CMP.L	di_Minutes(A5),D0
	BNE.S	DiskChanged
	MOVE.L	ofib_DateStamp+ds_Tick(A0),D0
	CMP.L	di_Ticks(A5),D0
	BNE.S	DiskChanged
	MOVE.L	FileLock,D1
	JSR	LVOUnLock(A6)
	MOVEQ	#0,D0
	RTS	
 
DiskChanged:
	MOVE.L	ofib_DateStamp+ds_Days(A0),di_Days(A5)
	MOVE.L	ofib_DateStamp+ds_Minute(A0),di_Minutes(A5)
	MOVE.L	ofib_DateStamp+ds_Tick(A0),di_Ticks(A5)
	MOVE.L	FileLock,D1
	JSR	LVOUnLock(A6)
	MOVEQ	#-1,D0
	RTS

ExamineError:
	CLR.L	di_Days(A5)
	MOVEQ	#-1,D0
	RTS

ShowFreeDiskGadg:
	BSR	WaitForButtonUp
	BSR.S	LockAndGetInfo
	BSR	DirDiskUnlock
	JMP	ShowAllRight

LockAndGetInfo:
	BSR	StorePtrCol
	BSR	SetDiskPtrCol
	move.l	FileNamesPtr(pc),a5
	MOVE.L	DosBase,A6
	MOVE.L	PathPtr,D1
	MOVEQ	#-2,D2
	JSR	LVOLock(A6)
	MOVE.L	D0,FileLock
	BEQ	DirDiskError
	LEA	ReadingDirText,A0
	JSR	ShowStatusText
	MOVE.L	FileLock,D1
	MOVE.L	#InfoData,D2
	JSR	LVOInfo(A6)
	movem.l d0-d7/a0-a6,-(sp)
	lea	InfoData,a0
	move.l	12(a0),d0	; id_NumBlocks
	move.l	16(a0),d1	; id_NumBlocksUsed
	move.l	20(a0),d2	; id_BytesPerBlock
	sub.l	d1,d0		; Sub all blocks used from total blocks
	move.w	d0,d3		; THIS IS NOT VERY FAST!!!!!
	swap	d0		; We must split register, coz mulu won't
	move.w	d0,d4		; accept longwords!
	mulu	d2,d3		; Ex: cannot calc a volume with size: 50 Mb
	mulu	d2,d4		; But now we can! hehe! Plystre!
	swap	d4
	or.l	d4,d3		; OKI. Let's insert the "reminder"!!!
	MOVE.L	D3,di_DiskFree(a5); Here is the size of bytes free on disk!
	movem.l (sp)+,d0-d7/a0-a6
	move.l	PathPtr,a4
	cmp.l	#'Ram ',(a4)
	beq.b	.GotRamDisk
	cmp.l	#'ram:',(a4)
	beq.b	.GotRamDisk
	cmp.l	#'RAM:',(a4)
	bne.b	ShowDiskSpace
.GotRamDisk			; RAM is handled in other manners!
	movem.l d0-d7/a0-a6,-(sp)
	moveq	#MEMF_FAST,d1
	move.l	4.w,a6
	jsr	LVOAvailMem(a6)
	move.l	d0,di_DiskFree(a5)
	moveq	#MEMF_CHIP,d1
	jsr	LVOAvailMem(a6)
	add.l	d0,di_DiskFree(a5)
	movem.l (sp)+,d0-d7/a0-a6
ShowDiskSpace:
	move.l	FileNamesPtr(pc),a5
	move.w	#247,d0
	move.w	#102,d1
	MOVE.L	di_DiskFree(a5),D2
	move.w	#9,d3
	jsr	PrintAnyDigits
	MOVEQ	#0,D0
	RTS

;---- Get Disk Directory ----

AllocDirMem:
	move.l	FileNamesPtr(pc),a5
	ADD.W	#50,di_MemEntries(a5)
	MOVE.W	di_MemEntries(a5),D0
	MULU	#36,D0
	MOVE.L	di_MemSize(a5),D6
	MOVE.L	D0,di_MemSize(a5)
	MOVE.L	#MEMF_ANY!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,D7
	BEQ.W	baehsj

	move.l	FileNamesPtr(pc),a5
	MOVE.L	di_MemPtr(a5),D1
	MOVE.L	D7,di_MemPtr(a5)
	TST.L	D1
	REQ
	TST.L	D6
	REQ
	MOVE.L	D1,A0
	MOVE.L	D7,A1
	MOVE.L	D6,D0
admloop	MOVE.B	(A0)+,(A1)+
	SUBQ.L	#1,D6
	BNE.S	admloop
	MOVE.L	D1,A1
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	RTS

FreeAllDirMem
	lea	ExeDirInfo(pc),a5
	bsr	FreeDirMem2
	lea	ModDirInfo(pc),a5
	bsr	FreeDirMem2
	lea	SongDirInfo(pc),a5
	bsr	FreeDirMem2
	lea	InsDirInfo(pc),a5
	bsr	FreeDirMem2
	lea	SampDirInfo(pc),a5
	bsr	FreeDirMem2
	lea	PattDirInfo(pc),a5
	bsr	FreeDirMem2
	rts
FreeDirMem
	move.l	FileNamesPtr(pc),a5
FreeDirMem2
	MOVE.L	di_MemPtr(a5),D1
	REQ
	MOVE.L	D1,A1
	MOVE.L	di_MemSize(a5),D0
	CLR.L	di_MemPtr(a5)
	CLR.W	di_MemSize(a5)
	CLR.W	di_MemEntries(a5)
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	RTS

baehsj	JSR	OutOfMemErr			; :)
	MOVEQ	#-1,D0
	RTS

DirDisk	clr.b	MaskChanged
	BSR	FreeDirMem
	BSR	AllocDirMem
	BSR	LockAndGetInfo
	RNE
	move.l	FileNamesPtr(pc),a5
	CLR.W	di_ScrPos(a5)
	MOVE.L	FileLock,D1
	MOVE.L	#FileInfoBlock,D2
	JSR	LVOExamine(A6)
	TST.L	D0
	BEQ	DirDiskError
ddloop1	MOVE.L	FileLock,D1
	MOVE.L	#FileInfoBlock,D2
	MOVE.L	DosBase,A6
	JSR	LVOExNext(A6)
	TST.L	D0
	BEQ	DirDiskUnlock
	BTST	#2,$DFF016
	BEQ.S	AbortDir
	BSR	NewDirEntry
	BRA.S	ddloop1

AbortDir
	CLR.L	di_Days(A5)
	LEA	DirAbortedText(PC),A0
	JSR	ShowStatusText
	BSR.S	DirDiskUnlock
	BSR	WaitALittle
	JSR	ShowAllRight
	MOVEQ	#0,D0
	RTS

DirDiskUnlock
	MOVE.L	FileLock,D1
	JSR	LVOUnLock(A6)
	BSR	RestorePtrCol
	;jsr	DoDirDragbar		; update dragbar
	MOVEQ	#0,D0
	RTS

DirAbortedText	dc.b 'Dir aborted!',0
	even

DirDiskError
	TST.L	FileLock
	BEQ.S	ddeskip
	MOVE.L	FileLock,D1
	JSR	LVOUnLock(A6)
ddeskip	BSR	RestorePtrCol
	LEA	CantFindDirText,A0
	JSR	ShowStatusText
	BSR	SetErrorPtrCol
	MOVEQ	#-1,D0
	RTS

ClearDirTotal
	CLR.W	di_Entries(A5)
	RTS	

CantFindDirText	dc.b "Can't find dir!",0
	cnop	0,2

NewDirEntry
	LEA	FIB_FileName,A0
	btst	#2,DiskBitFlags+3 ;(ShowDirsFlag) ok to show directories?
	BNE.S	ndeok1			;yes, go ahead...
	TST.L	FIB_EntryType		;well, lets check if this is a DIR..
	RPL				;if yes, then skip this one!
ndeok1	TST.L	FIB_EntryType		;well, IS it a DIR??
	BPL	ndeok2			;if yes, then skip this file-crap
	;TST.B	ModOnlyFlag		;only "MOD." files?
	;BEQ.S	ndeok1a			;nope, compare against masking..
	;CMP.W	#1,DirPathNum		;YES! check if we are loading mod..
	;BNE.S	ndeok2			;if, not so then skip this test anyway
	;MOVE.L	(A0),D0			;get first 4 letters of filename
	;AND.L	#$CFCFCFCF,D0		;mask to lowercase
	;CMP.L	#$4D4F440E,D0 		;is it "MOD."?	
	;RNE				;nope, skip this file!
ndeok1a	movem.l	d0-d7/a0-a6,-(sp)	;take care of the innocent registers
	moveq	#0,d0
	move.l	#FIB_FileName,a1	;pointer to null terminated string
	bsr	MakeUpperStr		;convert filename to uppercase
	btst	#0,DiskBitFlags+2	;HideShowFlag
	bne.s	.cnt
	lea	InfoMask(pc),a0
	bsr	MatchMask
	tst.l	d0			; is it '#?.INFO' ?
	beq.s	.notmsk			; ok then skip it
.cnt	move.l	maskptr(pc),a0		;this is a pointer to the mask
	bsr	MatchMask
	tst.l	d0
	beq.s	PatternMatches		;it did? oh joy!
.notmsk	movem.l	(sp)+,d0-d7/a0-a6	;rats! Skip it then :(
	rts
PatternMatches
	movem.l	(sp)+,d0-d7/a0-a6	;give the registers back
ndeok2	MOVE.W	di_Entries(A5),D0
	CMP.W	di_MemEntries(a5),D0
	BLO.S	ndeok3
	MOVE.L	A0,-(SP)
	BSR	AllocDirMem
	MOVE.L	(SP)+,A0
ndeok3	MOVE.W	di_Entries(A5),D6
	BEQ.S	ndeadd1			; If first entry
	SUBQ.W	#1,D6
	MOVE.L	di_MemPtr(A5),A1
ndeloopname
	MOVEQ	#0,D2
	MOVE.L	FIB_EntryType,D0
	MOVE.L	32(A1),D1
	TST.L	D0
	BPL.S	ndesfil			; if directory, all is well
	TST.L	D1
	BMI.S	ndenext			; was file, so skip if directory
	BRA.S	ndelopc
ndesfil	TST.L	D1			; if file
	BPL.S	ndeinse
ndelopc	MOVE.B	0(a0,D2.W),D0 		; Get a character
	BEQ.S	ndeinse
	CMP.B	#96,D0  		; Lowercase?
	BLO.S	ndeskp1
	SUB.B	#32,D0			; Switch to upper
ndeskp1	MOVE.B	0(a1,D2.W),D1
	BEQ.S	ndenext
	CMP.B	#96,D1
	BLO.S	ndeskp2
	SUB.B	#32,D1
ndeskp2	CMP.B	D0,D1
	BHI.S	ndeinse
	BNE.S	ndenext
	ADDQ.W	#1,D2
	BRA.S	ndelopc
ndenext	LEA	36(A1),A1		; next entry
	DBRA	D6,ndeloopname		; loop entries
	MOVE.L	di_MemPtr(A5),A1
	MOVE.W	di_Entries(A5),D0
	MULU	#36,D0
	ADD.W	D0,A1
	BRA.S	ndeadd2

ndeinse	MOVE.L	di_MemPtr(A5),A2
	MOVE.W	di_Entries(A5),D0
	MULU	#36,D0
	ADD.W	D0,A2
	MOVE.L	A2,A3
	LEA	36(A3),A3
nde3loop
	MOVE.W	-(A2),-(A3)
	CMP.L	A2,A1
	BNE.S	nde3loop
	BRA.S	ndeadd2
 
ndeadd1	MOVE.L	di_MemPtr(A5),A1       	; Put new filename into list
ndeadd2	LEA	FIB_FileName,A0
	MOVE.L	A1,A3
	MOVEQ	#35,D0             	; Clear old filename
nde4loop
	CLR.B	(A3)+
	DBRA	D0,nde4loop
	MOVE.W	FIB_DateStamp+ds_Days+2,30(A1)
	MOVEQ	#-1,D0
	TST.L	FIB_EntryType
	BPL	ndefskp
	MOVE.L	FIB_FileSize,D0
ndefskp	MOVE.L	D0,32(A1)
	MOVEQ	#29,D0             	; Copy new filename
nde4loop2
	MOVE.B	(A0)+,D1
	MOVE.B	D1,(A1)+
	TST.B	D1
	BEQ.S	nde4skip
	DBRA	D0,nde4loop2
nde4skip
	ADDQ.W	#1,di_Entries(A5)		; Files + 1
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	#0,d0
	bsr.b	DoRedrawFileNames
	bsr.w	DoDirDragbar
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

RedrawFileNames
	MOVE.W	D0,-(SP)
	BSR	ShowDirPath
	MOVE.W	(SP)+,D0
DoRedrawFileNames
	MOVE.W	D0,di_ScrPos(a5)
	TST.W	di_Entries(A5)
	REQ
	MOVE.L	#4*80+41,A6
	MOVE.W	A6,TextOffset
	MOVE.L	di_MemPtr(A5),D6
	MULU	#36,D0
	ADD.L	D0,D6
	and.l	#-2,d6			; prevent guru
	MOVE.W	di_Entries(A5),D0
	SUB.W	di_ScrPos(a5),D0
	CMP.W	#19,D0
	BHS.S	ShowFileNames
	SUBQ.W	#1,D0
	MOVE.W	D0,D7
	BRA.S	sfnloop
 
ShowFileNames:
	MOVEQ	#19-1,D7
sfnloop:MOVE.W	A6,TextOffset
	MOVE.L	D6,A0
	MOVEQ	#0,D0
	MOVE.W	30(A0),D0
	BSR	CalculateDate
	MOVE.W	TheDay(PC),WordNumber
	JSR	Print2DecDigits
	MOVE.W	TheMonth(PC),WordNumber
	JSR	Print2DecDigits
	MOVE.W	TheYear(PC),WordNumber
	JSR	Print2DecDigits
	ADDQ.W	#1,TextOffset
	MOVE.L	D6,ShowTextPtr
	MOVE.W	#24,TextLength
	;CMP.W	#1,DirPathNum
	;BNE.S	.skip
	;btst	#1,DiskBitFlags+2	;FileExtFlag
	;BEQ.S	.skip
	;MOVE.L	D6,A0
	;CMP.L	#"mod.",(A0)
	;BNE.S	.skip
	;ADDQ.L	#4,ShowTextPtr
.skip	JSR	SpaceShowText
	LEA	32(A6),A6		;32+40
	MOVE.W	A6,TextOffset
	MOVE.L	D6,A0
	MOVE.L	32(A0),D1
	BMI.S	.dir
	btst	#2,MiscBitFlags+3	;ShowDecFlag
	BNE.S	.dec
	SWAP	D1
	AND.W	#$000F,D1
	BSR	ShowOneDigit
	MOVE.L	D6,A0
	MOVE.W	34(A0),WordNumber
	JSR	PrintHexWord
.end	ADD.L	#36,D6
	LEA	80*5+48(A6),A6		;208
	DBRA	D7,sfnloop
	RTS
.dec	MOVE.L	D1,D0
	SUBQ.W	#1,TextOffset
	JSR	Print6DecDigits
	BRA.S	.end
.dir	MOVE.L	#DirText,ShowTextPtr
	SUBQ.W	#1,TextOffset
	MOVE.W	#6,TextLength
	JSR	ShowText
	BRA.S	.end

ClrFileText	
	dc.b "    "

CalculateDate
	DIVU	#1461,D0
	LSL.W	#2,D0
	MOVE.W	D0,TheYear
	CLR.W	D0
	SWAP	D0
	CMP.W	#789,D0
	BEQ.S	cadleap
	BLO.S	cadskp2
	SUBQ.W	#1,D0
cadskp2	DIVU	#365,D0
	MOVE.L	D0,D1
	SWAP	D1
	CMP.W	#4,D0
	BLO.S	cadskip
	SUBQ.W	#1,D0
cadskip	ADD.W	D0,TheYear
	LEA	MonthTable(PC),A1
	MOVEQ	#24,D0
cadloop	SUBQ.W	#2,D0
	MOVE.W	0(a1,D0.W),D2
	CMP.W	D2,D1
	BHS.S	cadskp3
	TST.W	D0
	BNE.S	cadloop
cadskp3	LSR.W	#1,D0
	ADDQ.W	#1,D0
	MOVE.W	D0,TheMonth
	SUB.W	D2,D1
	ADDQ.W	#1,D1
	MOVE.W	D1,TheDay
cadend	MOVEQ	#0,D0
	MOVE.W	TheYear(PC),D0
	ADD.W	#78,D0
	DIVU	#100,D0
	SWAP	D0
	MOVE.W	D0,TheYear
	RTS
cadleap	ADD.W	#2,TheYear
	MOVE.W	#2,TheMonth
	MOVE.W	#29,TheDay
	BRA	cadend

	cnop	0,4
TheYear		dc.w 0
TheMonth	dc.w 0
TheDay		dc.w 0
MonthTable	dc.w 0,31,59,90,120,151,181,212,243,273,304,334
DirText		dc.b " (DIR)"

;----------------- Main menu gadgets -----------------------

;---- Play Song ----

Continue:
	tst.l	RunMode
	RNE
	clr.w	Counter
	tst.w	PlayType
	bne.w	DoPattFrom
	bra.s	DoSongFrom

PlaySong:
	MOVEQ	#0,D0
SongFrom:
	clr.w	PlayType
	JSR	StopIt
	bsr	ClearKeyBuf
	BTST	#2,$DFF016
	BNE.S	sofr1
DoSongFrom:
	MOVE.W	PlayFromPos,D0
sofr1	MOVE.W	D0,ScrPattPos
	LSL.W	#4,D0
	AND.L	#$FFFF,D0
	MOVE.L	D0,PatternPosition
	bsr	WaitForButtonUp
	CLR.B	RawKeyCode
	CLR.B	SaveKey
	BSR	SetPlayPtrCol
	CLR.W	PatternTicks
	CLR.L	TimerTicks
	MOVE.L	#'patp',RunMode
	CLR.W	DidQuantize
	MOVE.L	#-1,LongFFFF
	BSR	SetScrPatternPos
SetPlayPosition:
	MOVE.L	CurrPos,D0
	MOVE.L	SongDataPtr,A0
	CMP.B	sd_numofpatt(A0),D0
	BHS.S	SongPosToZero
	MOVE.L	CurrPos,SongPosition
	RTS

SongPosToZero:
	CLR.L	SongPosition
	CLR.L	CurrPos
	RTS

;---- Play Pattern ----

PlayPattern:
	MOVEQ	#0,D0
PattFrom:
	move.w	#-1,PlayType
	JSR	StopIt
	bsr	ClearKeyBuf
	BTST	#2,$DFF016
	BNE.S	pafr1
DoPattFrom:
	MOVE.W	PlayFromPos,D0
pafr1	MOVE.W	D0,ScrPattPos
	LSL.W	#4,D0
	AND.L	#$FFF,D0
	MOVE.L	D0,PatternPosition
	bsr	WaitForButtonUp
	CLR.B	RawKeyCode
	CLR.B	SaveKey
	MOVE.L	#'patt',RunMode
	BSR	SetPlayPtrCol
ResetPosition:
	MOVE.L	PatternNumber,SongPosition
	RTS	

;---- Record Pattern/Song ----

RecordPattern:
	btst	#0,EditBitFlags+3	;RecHoldFlag
	beq.w	GoOnRec
	bsr	WaitForButtonUp
	clr.b	RawKeyCode
WaitForKeyRec:
	bsr	CheckNTSCPos
	btst	#6,$bfe001
	beq	GoOnRec
	btst	#2,$dff016
	beq	GoOnRec
	bsr.w	DoKeyBuffer
	tst.b	RawKeyCode
	beq.s	WaitForKeyRec
	move.b	RawKeyCode,d0
	move.b	d0,SaveKey
	moveq	#0,d0
	TST.W	SamScrEnable
	RNE
	JSR	StopIt
	BTST	#2,$DFF016
	BNE.S	refr1a
	MOVE.W	PlayFromPos,D0
refr1a	MOVE.W	D0,ScrPattPos
	LSL.W	#4,D0
	AND.L	#$FFF,D0
	MOVE.L	D0,PatternPosition
	bsr	WaitForButtonUp
	BSR	SetEditPtrCol
	move.b	SaveKey,d1
	move.b	d1,RawKeyCode
	BSR	SaveUndo
	MOVE.L	#'edit',EditMode
	MOVE.L	#'patt',RunMode
	jsr	CheckKeyboard
	TST.B	RecordMode
	BEQ.W	ResetPosition
	MOVE.L	#'patp',RunMode
	BRA	SetPlayPosition
GoOnRec:MOVEQ	#0,D0
RecordFrom:
	TST.W	SamScrEnable
	RNE
	JSR	StopIt
	BTST	#2,$DFF016
	BNE.S	refr1
	MOVE.W	PlayFromPos,D0
refr1	MOVE.W	D0,ScrPattPos
	LSL.W	#4,D0
	AND.L	#$FFF,D0
	MOVE.L	D0,PatternPosition
	bsr	WaitForButtonUp
	BSR	SetEditPtrCol
	CLR.B	RawKeyCode
	CLR.B	SaveKey
	BSR	SaveUndo
	MOVE.L	#'edit',EditMode
	MOVE.L	#'patt',RunMode
	TST.B	RecordMode
	BEQ.W	ResetPosition
	MOVE.L	#'patp',RunMode
	BRA	SetPlayPosition

;---- Show Main Screen ----

DisplayMainScreen:
	jsr	ClearKeyBuf
	CLR.W	BlockMarkFlag
	MOVE.W	#1,CurrScreen
	SF	NoSampleInfo
	TST.W	LoadInProgress
	BNE.S	.skip3
	BSR	SetNormalPtrCol
	TST.W	RunMode
	BEQ.S	.skip
	BSR	SetPlayPtrCol
.skip	TST.L	EditMode
	BEQ.S	.skip2
	BSR	SetEditPtrCol
.skip2	BSR	StorePtrCol
.skip3	JSR	ShowVolumeBar
	bsr	ShowPNote
	BSR	RedrawToggles
	jsr	ShowSubMenus
	;TST.B	EdEnable
	;BNE	EditOp
	;MOVEQ	#0,D4
	ST	ScopeEnable
	RTS

;---- Clear Areas ----

ClearFileNames	
	bsr	SlettGamle
	MOVE.L	TextBplPtr,A1
	LEA	3*80+40(A1),A1
	MOVE.W	#114*40/4-1,D0
	MOVEQ	#0,D1
	moveq	#0,d3
.loop	MOVE.L	D1,(A1)+
	add.l	#4,d3
	cmp.l	#40,d3
	bne.s	.cl
	moveq	#0,d3
	lea	40(a1),a1
.cl	DBRA	D0,.loop

	clr.w	dirdragpos
	move.w	#dirdragmaxlen,dirdraglen
	BRA	DoDirDragbar

Clear100Lines:
	MOVE.L	TextBplPtr,A0
	MOVE.W	#100*80/4-1,D0
	MOVEQ	#0,D1
.loop	MOVE.L	D1,(A0)+
	DBRA	D0,.loop
	RTS

Clear121Lines:
	MOVE.L	TextBplPtr,A0
	MOVE.W	#121*80/4-1,D0
	MOVEQ	#0,D1
.loop	MOVE.L	D1,(A0)+
	DBRA	D0,.loop
	RTS

WaitForButtonUp:
	bsr	CheckNTSCPos
	BTST	#6,$BFE001			; Check Left Mousebutton
	BEQ.S	WaitForButtonUp
	BTST	#2,$DFF016			; Check Right Mousebutton
	BEQ.S	WaitForButtonUp
	
        bsr	Wait_4000		; A little delay for angry
					; people with a bad mouse-button!
	BTST	#6,$BFE001			; Check Left Mousebutton
	BEQ.S	WaitForButtonUp
	BTST	#2,$DFF016			; Check Right Mousebutton
	BEQ.S	WaitForButtonUp
	rts

;---- Are You Sure Requester ----

; a0 = Requester text
AreYouSure:
	;MOVE.B	ScopeEnable,SaveScope
	;SF	ScopeEnable
	;JSR	ShowStatusText
	move.l	a0,-(sp)
	move.w	#-1,FileInvOn
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	BSR	Wait_4000
	bsr	SaveRequester
	move.l	(sp)+,a0	; text pointer
	lea	ReqImage,a1
	lea	Requester1,a2
	move.l	#80*14,d0
	bsr	ShowRequester

	CLR.B	RawKeyCode
.surebuttoncheck
	bsr	CheckNTSCPos
	BSR	DoKeyBuffer
	MOVE.B	RawKeyCode,D0
	CMP.B	#21,D0 			; Pressed Y
	BEQ.s	.SureAnswerYes
	CMP.B	#68,D0 			; Pressed Return
	BEQ.S	.SureAnswerYes
	CMP.B	#54,D0 			; Pressed N
	BEQ.S	.SureAnswerNo
	CMP.B	#69,D0 			; Pressed Esc
	BEQ.S	.SureAnswerNo
	BTST	#6,$BFE001		; Left Mousebutton
	BNE.S	.surebuttoncheck
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList1,a0
	jsr	GetGadget2
	tst.w	d2
	beq.s	.surebuttoncheck
	cmp.w	#1,d2
	beq.s	.SureAnswerYes
	cmp.w	#3,d2
	beq.s	.SureAnswerNo
	bra.s	.surebuttoncheck
.SureAnswerNo
	bsr	ReturnRequester
	JSR	ShowAllRight
	;MOVE.B	SaveScope,ScopeEnable
	BSR	ErrorRestoreCol
	BSR	Wait_4000
	BSR	WaitForButtonUp
	clr.w	FileInvOn
	CLR.B	RawKeyCode
	MOVEQ	#-1,D0
	RTS
.SureAnswerYes
	bsr	ReturnRequester
	JSR	ShowAllRight
	;MOVE.B	SaveScope,ScopeEnable
	BSR	RestorePtrCol
	BSR	Wait_4000
	BSR	WaitForButtonUp
	clr.w	FileInvOn
	CLR.B	RawKeyCode
	MOVEQ	#0,D0
	RTS

;---- Resume/Cancel Requester ----

; a0 = Requester text
ResumeCancelReq:
	;MOVE.B	ScopeEnable,SaveScope
	;SF	ScopeEnable
	;JSR	ShowStatusText
	move.l	a0,-(sp)
	move.w	#-1,FileInvOn
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	BSR	Wait_4000
	bsr	SaveRequester
	move.l	(sp)+,a0	; text pointer
				; ___
	lea	ReqImage,a1	; \!/
	lea	Requester2,a2
	move.l	#80*14,d0
	bsr	ShowRequester

	CLR.B	RawKeyCode
.surebuttoncheck
	bsr	CheckNTSCPos
	BSR	DoKeyBuffer
	MOVE.B	RawKeyCode,D0
	CMP.B	#$13,D0 			; Pressed R
	BEQ.s	.AnswerResume
	CMP.B	#$44,D0 			; Pressed Return
	BEQ.S	.AnswerResume
	CMP.B	#$33,D0 			; Pressed C
	BEQ.S	.AnswerCancel
	CMP.B	#$45,D0 			; Pressed Esc
	BEQ.S	.AnswerCancel
	BTST	#6,$BFE001		; Left Mousebutton
	BNE.S	.surebuttoncheck
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList1,a0
	jsr	GetGadget2
	tst.w	d2
	beq.s	.surebuttoncheck
	cmp.w	#1,d2
	beq.s	.AnswerResume
	cmp.w	#3,d2
	beq.s	.AnswerCancel
	bra.s	.surebuttoncheck
.AnswerCancel
	bsr	ReturnRequester
	JSR	ShowAllRight
	;MOVE.B	SaveScope,ScopeEnable
	BSR	ErrorRestoreCol
	BSR	Wait_4000
	BSR	WaitForButtonUp
	clr.w	FileInvOn
	CLR.B	RawKeyCode
	MOVEQ	#-1,D0
	RTS
.AnswerResume
	bsr	ReturnRequester
	JSR	ShowAllRight
	;MOVE.B	SaveScope,ScopeEnable
	BSR	RestorePtrCol
	BSR	Wait_4000
	BSR	WaitForButtonUp
	clr.w	FileInvOn
	CLR.B	RawKeyCode
	MOVEQ	#0,D0
	RTS

; ------ Requester routine ------

ShowAboutReq:			; ONLY ON MAIN SCREEN!
	move.w	#-1,FileInvOn
	sf	ScopeEnable
	bsr	SaveRequester2
	lea	AboutRequester,a0
	moveq	#64,d0
	moveq	#11,d1
	jsr	PaintScreen
	move.w	#64,d0
	moveq	#11,d1
	move.w	#512+64,d2
	moveq	#103+11,d3
	moveq	#0,d5
	jsr	ShowAnyBlock3
	lea	.text(pc),a0
	move.w	#64+64,d0
	moveq	#16,d1
	jsr	ShowColorText2
	sub.l	a0,a0
	lea	ReqImage2,a1
	sub.l	a2,a2
	move.l	#80*(-50+16)-(120/8),d0
	bsr	ShowRequester

.wait	bsr	CheckNTSCPos
	BSR	DoKeyBuffer
	; check keys
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList3,a0
	jsr	GetGadget
	tst.w	d2
	beq	.wait
	cmp.w	#2,d2
	beq	.exit
	bra	.wait
.exit	bsr	ReturnRequester2
	st	ScopeEnable
	clr.w	FileInvOn
	rts
.text	dc.b '                         ProTracker 3.15',10
	dc.b '                    (C) 1992-93 CryptoBurners',10
	dc.b '                Developed by:   Ivar Just Olsen',10
	dc.b '                                Bjarte Andreassen',10
	dc.b '                                Tom Bech',10
	dc.b '               -=* 12 bit DYN system by PuW *=-',10
	dc.b '    The authors are not responsible for any loss of data if',10
	dc.b '    ProTracker should crash your system!  Spreading through',10
	dc.b '    commercial  channels,  eg. PD libraries,  is prohibited',10
	dc.b '    without  written  permission from  one of  the authors.',10
	dc.b '    Charges may not exceed  expences for  disk and postage.'
	dc.b	0
	cnop	0,2

; a0 = Requester text
MemoryRequester:
	movem.l d1-a6,-(sp)
	move.l	a0,-(sp)
	bsr	SlettGamle
	move.w	#-1,FileInvOn
	bsr	SaveRequester
	move.l	(sp)+,a0
	lea	ReqImage4,a1
	lea	Requester4,a2
	move.l	#80*14,d0
	bsr	ShowRequester
.wait	bsr	CheckNTSCPos
	BSR	DoKeyBuffer
	; check keys
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList3,a0
	jsr	GetGadget
	tst.w	d2
	beq	.wait
	cmp.w	#2,d2
	beq	.exit
	bra	.wait
.exit	bsr	ReturnRequester
	clr.w	FileInvOn
	movem.l (sp)+,d1-a6
	rts


; a0 = Requester text, a1 = Text string, d0 = string length
; a2 = ReqImage
AskForTextString:
	movem.l d1-d7/a0-a6,-(sp)
	move.l	a2,-(sp)
	move.w	#-1,FileInvOn
	move.l	a1,.textadr
	move.l	d0,.textlen
	bsr	SaveRequester
	move.l	(sp)+,a1
	lea	StringRequester,a2
	move.l	#80*14,d0
	bsr	ShowRequester
	bsr	.showstring
.wait	bsr	CheckNTSCPos
	BSR	DoKeyBuffer
	; check keys
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	StringReqGadgetList,a0
	jsr	GetGadget2
	tst.w	d2
	beq.s	.wait
	cmp.w	#1,d2
	beq.s	.left
	cmp.w	#3,d2
	beq.s	.right
	cmp.w	#4,d2
	beq.s	.enterstring
	bra.s	.wait
.left	moveq	#0,d0
	bra.s	.ok
.right	moveq	#-1,d0
.ok	bsr	ReturnRequester
	clr.w	FileInvOn
	movem.l (sp)+,d1-d7/a0-a6
	tst.l	d0
	rts
.enterstring
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	move.l	.textadr(pc),a6
	move.l	a6,ShowTextPtr
	move.l	a6,TextEndPtr
	move.l	.textlen(pc),d0
	add.l	d0,TextEndPtr
	cmp.w	#21,d0
	bmi.s	.cnt
	moveq	#21,d0
.cnt	move.w	d0,TextLength
	move.w	#269,d0
	moveq	#79,d1
	bsr	GetAnyTextLine
	bsr	RestorePtrCol
	bsr.s	.showstring
	bra.w	.wait
.showstring
	move.l	.textadr(pc),a0
	move.l	.textlen(pc),d3
	cmp.l	#21,d3
	bmi.s	.cnt2
	moveq	#21,d3
.cnt2	move.w	#269,d0
	moveq	#79,d1
	jmp	ShowAnyText3
	cnop	0,4
.textadr	dc.l	0
.textlen	dc.l	0

;-----------

; d0=Image pos, a0=text, a1=ImageData, a2=requester
ShowRequester:
	movem.l d0-d7/a0-a6,-(sp)
	move.l	a0,-(sp)
	move.l	a1,-(sp)
	move.l	d0,-(sp)
	cmp.l	#0,a2
	beq.s	.cnt
	move.l	a2,a0
	move.w	#192,d0
	moveq	#50,d1
	jsr	PaintScreen
	move.w	#192,d0
	moveq	#50,d1
	move.w	#192+256,d2
	moveq	#50+64,d3
	moveq	#0,d5
	jsr	ShowAnyBlock3
.cnt	lea	BitPlaneData+(200/8+50*80),a0
	move.l	(sp)+,d3
	move.l	(sp)+,d0
	beq.s	.notimage
	move.l	d0,a1
	add.l	d3,a0
	moveq	#2-1,d1
.loop1	moveq	#32-1,d0
.loop2	move.b	(a1)+,0(a0)
	move.b	(a1)+,1(a0)
	move.b	(a1)+,2(a0)
	move.b	(a1)+,3(a0)
	move.b	(a1)+,4(a0)
	move.b	(a1)+,5(a0)
	lea	80(a0),a0
	dbf	d0,.loop2
	lea	(256-32)*80(a0),a0
	dbf	d1,.loop1
	move.l	TextBplPtr,a0
	add.l	#200/8+50*80,a0
	add.l	d3,a0
	moveq	#32-1,d0
.loop3	move.b	(a1)+,0(a0)
	move.b	(a1)+,1(a0)
	move.b	(a1)+,2(a0)
	move.b	(a1)+,3(a0)
	move.b	(a1)+,4(a0)
	move.b	(a1)+,5(a0)
	lea	80(a0),a0
	dbf	d0,.loop3
.notimage
	move.l	(sp)+,d0
	beq.s	.end
	move.l	d0,a0
	move.w	#248,d0
	moveq	#55,d1
	jsr	ShowColorText2
.end	movem.l (sp)+,d0-d7/a0-a6
	rts

SaveRequester:
	movem.l d0-d7/a0-a6,-(sp)
	lea	BoxDataBuffer,a0
	lea	BitPlaneData+(192/8)+50*80,a1
	moveq	#2-1,d2
.loop0	moveq	#64-1,d1
.loop1	moveq	#256/8-1,d0
.loop2	move.b	(a1)+,(a0)+
	dbf	d0,.loop2
	lea	80-(256/8)(a1),a1
	dbf	d1,.loop1
	lea	(256-64)*80(a1),a1
	dbf	d2,.loop0
	move.l	TextBplPtr,a1
	add.l	#(192/8)+50*80,a1
	moveq	#64-1,d1
.loop3	moveq	#256/8-1,d0
.loop4	move.b	(a1)+,(a0)+
	dbf	d0,.loop4
	lea	80-(256/8)(a1),a1
	dbf	d1,.loop3
	movem.l (sp)+,d0-d7/a0-a6
	rts

ReturnRequester:
	movem.l d0-d7/a0-a6,-(sp)
	lea	BoxDataBuffer,a0
	lea	BitPlaneData+(192/8)+50*80,a1
	moveq	#2-1,d2
.loop0	moveq	#64-1,d1
.loop1	moveq	#256/8-1,d0
.loop2	move.b	(a0)+,(a1)+
	dbf	d0,.loop2
	lea	80-(256/8)(a1),a1
	dbf	d1,.loop1
	lea	(256-64)*80(a1),a1
	dbf	d2,.loop0

	move.l	TextBplPtr,a1
	add.l	#(192/8)+50*80,a1
	moveq	#64-1,d1
.loop3	moveq	#256/8-1,d0
.loop4	move.b	(a0)+,(a1)+
	dbf	d0,.loop4
	lea	80-(256/8)(a1),a1
	dbf	d1,.loop3
	movem.l (sp)+,d0-d7/a0-a6
	rts

SaveRequester2:
	movem.l d0-d7/a0-a6,-(sp)
	lea	UpperBuffer,a0
	lea	BitPlaneData,a1
	moveq	#2-1,d1
.loop1	move.w	#121*80-1,d0
.loop2	move.b	(a1)+,(a0)+
	dbf	d0,.loop2
	lea	(256-121)*80(a1),a1
	dbf	d1,.loop1
	move.l	TextBplPtr,a1
	move.w	#121*80-1,d0
.loop3	move.b	(a1)+,(a0)+
	dbf	d0,.loop3
	movem.l (sp)+,d0-d7/a0-a6
	rts
ReturnRequester2:
	movem.l d0-d7/a0-a6,-(sp)
	lea	UpperBuffer,a0
	lea	BitPlaneData,a1
	moveq	#2-1,d1
.loop1	move.w	#121*80-1,d0
.loop2	move.b	(a0)+,(a1)+
	dbf	d0,.loop2
	lea	(256-121)*80(a1),a1
	dbf	d1,.loop1
	move.l	TextBplPtr,a1
	move.w	#121*80-1,d0
.loop3	move.b	(a0)+,(a1)+
	dbf	d0,.loop3
	movem.l (sp)+,d0-d7/a0-a6
	rts

;---- Set Pointercolors ----

SetDeletePtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$077,2(A6)
	MOVE.W	#$044,6(A6)
	MOVE.W	#$0AA,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetNormalPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$E44,2(A6)
	MOVE.W	#$000,6(A6)
	MOVE.W	#$EEC,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetDiskPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$070,2(A6)
	MOVE.W	#$040,6(A6)
	MOVE.W	#$0A0,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetPlayPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$770,2(A6)
	MOVE.W	#$440,6(A6)
	MOVE.W	#$AA0,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetEditPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$049,2(A6)
	MOVE.W	#$006,6(A6)
	MOVE.W	#$05B,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetWaitPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$727,2(A6)
	MOVE.W	#$404,6(A6)
	MOVE.W	#$A5A,10(A6)
	MOVE.L	(SP)+,A6
	RTS	

SetErrorPtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	#$900,2(A6)
	MOVE.W	#$700,6(A6)
	MOVE.W	#$C00,10(A6)
	MOVE.L	(SP)+,A6
	MOVE.W	#1,UpdateFreeMem
	BSR	WaitALittle
	JSR	ShowAllRight
	BSR	SetNormalPtrCol
	MOVEQ	#0,D0
	RTS

WaitALittle:
	MOVE.W	WaitTime(PC),D1
.wait	BSR	Wait_4000
	DBRA	D1,.wait
	MOVE.W	#15,WaitTime
	RTS

WaitTime:dc.w 15

StorePtrCol:
	MOVE.L	A6,-(SP)
	MOVE.L	CopListColorPtr,A6
	MOVE.W	2(A6),PointerCol1Save
	MOVE.W	6(A6),PointerCol2Save
	MOVE.W	10(A6),PointerCol3Save
	MOVE.L	(SP)+,A6
	RTS

ErrorRestoreCol:
	BSR	SetErrorPtrCol
RestorePtrCol:
	MOVE.L	A6,-(SP)
	MOVE.W	#1,UpdateFreeMem
	MOVE.L	CopListColorPtr,A6
	MOVE.W	PointerCol1Save,2(A6)
	MOVE.W	PointerCol2Save,6(A6)
	MOVE.W	PointerCol3Save,10(A6)
	MOVE.L	(SP)+,A6
	RTS

;---- Check special keys ----

CheckPlayKeys:
	MOVE.B	RawKeyCode,D0
	REQ
	CMP.B	#101,D0		; right alt
	BEQ	PlaySong
	CMP.B	#103,D0		; right amiga
	BEQ	PlayPattern
	CMP.B	#64,D0          ; space
	BNE.S	.skip
	TST.L	RunMode	
	JNE	StopIt
	TST.L	EditMode
	JNE	StopIt	
	JMP	Edit
.skip	CMP.B	#97,D0          ; shift right
	BEQ	RecordPattern
	CMP.B	#69,D0     	; esc
	BEQ	EscPressed
	CMP.B	#66,D0
	BEQ	TabulateCursor  ; tab
	;CMP.B	#127,D0
	;BEQ	GotoCLI
	CMP.B	#48,D0		; the key above "left amiga"
	JEQ	TurnOffVoices
	CMP.B	#60,D0          ; Keypad "delete/."
	JEQ	KillSample
	CMP.B	#13,D0          ; \ backslash toggles keypad mode
	BEQ	togglepnote

	CMP.B	#67,D0          ; Keypad enter
	BEQ.S	HigherInstr
	CMP.B	#67+128,D0
	BEQ.S	LowerInstr
	MOVE.W	HiLowInstr,D1
	LEA	kpinstable(PC),A0
	MOVEQ	#0,D2
kpinsloop
	CMP.B	0(a0,D2.W),D0
	BEQ.S	kpinsfound
	ADDQ.W	#1,D2
	CMP.W	#16,D2
	BLO.S	kpinsloop
	RTS

kpinsfound
	ADD.W	D2,D1
	BEQ.S	insnull
	BRA.S	redrsa2

LowerInstr
	CLR.W	HiLowInstr
	RTS
HigherInstr
	MOVE.W	#16,HiLowInstr
	MOVE.W	#16,D1
	BRA.S	redrsa2

redrsa3	MOVE.W	D1,InsNum
redrsam	CLR.B	RawKeyCode
	CLR.L	SavSamInf
	cmp.w	#DirScreen_ID,CurrScreen
	bne.s	.cnt
	jsr	SelectSamples
.cnt	JSR	ShowSampleInfo
	JMP	RedrawSample

insnull	TST.W	InsNum
	BEQ.S	insnul2
	MOVE.W	InsNum,LastInsNum
	CLR.W	InsNum
	MOVEQ	#0,D1
	BRA.S	redrsa2

insnul2	JMP	ShowSampleInfo

kpinstable
	dc.b 15,90,91,92
	dc.b 93,61,62,63,74
	dc.b 45,46,47,94,29,30
	dc.b 31

redrsa2	TST.B	pnoteflag
	BEQ.S	redrsa3
	CLR.B	RawKeyCode
	TST.W	AltKeyStatus
	BNE.S	setpnote
	MOVE.W	D1,InsNum
	JSR	ShowSampleInfo
	MOVE.W	InsNum,D0
	ADD.W	D0,D0
	MOVE.W	pnotetable(PC,D0.W),D0
	MOVEQ	#-1,D2
	BSR	playtheinstr
	JMP	RedrawSample

pnotetable
	dc.w 24,24,24,24,24,24,24,24,24,24
	dc.w 24,24,24,24,24,24,24,24,24,24
	dc.w 24,24,24,24,24,24,24,24,24,24
	dc.w 24,24

setpnote
	ADD.W	D1,D1
	LEA	pnotetable(PC,D1.W),A0
	MOVE.L	A0,SplitAddress
	MOVE.W	#4,SamNoteType
	LEA	selnotetext(PC),A0
	JMP	ShowStatusText

selnotetext	dc.b "select note",0

togglepnote
	CLR.B	RawKeyCode
	MOVEQ	#0,D0
	MOVE.B	pnoteflag,D0
	ADDQ.B	#1,D0
	CMP.B	#3,D0
	BLO.S	.skip
	MOVEQ	#0,D0
.skip	MOVE.B	D0,pnoteflag
	LEA	pnotechar(PC,D0.W),A0
	MOVEQ	#1,D0
	MOVE.W	#128*80+55,D1
	JMP	ShowText3
ShowPNote
	rts

pnotechar	dc.b 32,128,129
pnoteflag	dc.b 0

;---- Check transpose keys ----

CheckTransKeys
	TST.W	LeftAmigaStatus
	REQ
	MOVE.B	RawKeyCode,D1
	cmp.b	#55,d1	; M
	bne.b	NoScreenBack
	CLR.B	RawKeyCode
	jmp	ScreenToBack
NoScreenBack
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	MOVE.B	RawKeyCode,D1
	CLR.B	RawKeyCode
	MOVE.B	SampleAllFlag,sampallsave
	BSR.S	ctksub
	MOVE.B	sampallsave(pc),SampleAllFlag
	RTS

ctksub	MOVEQ	#0,D0
	CLR.B	SampleAllFlag
	CMP.B	#1,D1
	JEQ	NoteUp
	CMP.B	#16,D1
	JEQ	NoteDown
	CMP.B	#32,D1
	JEQ	OctaveUp
	CMP.B	#49,D1
	JEQ	OctaveDown

	MOVE.W	#300,D0
	CMP.B	#2,D1
	JEQ	NoteUp
	CMP.B	#17,D1
	JEQ	NoteDown
	CMP.B	#33,D1
	JEQ	OctaveUp
	CMP.B	#50,D1
	JEQ	OctaveDown

	MOVEQ	#0,D0
	MOVE.B	#1,SampleAllFlag
	CMP.B	#3,D1
	JEQ	NoteUp
	CMP.B	#18,D1
	JEQ	NoteDown
	CMP.B	#34,D1
	JEQ	OctaveUp
	CMP.B	#51,D1
	JEQ	OctaveDown

	MOVE.W	#300,D0
	CMP.B	#4,D1
	JEQ	NoteUp
	CMP.B	#19,D1
	JEQ	NoteDown
	CMP.B	#35,D1
	JEQ	OctaveUp
	CMP.B	#52,D1
	JEQ	OctaveDown
	RTS

;---- Check control keys ----

CheckCtrlKeys
	TST.W	CtrlKeyStatus
	REQ
	tst.w	ShiftKeyStatus
	bne	CheckMenuNumber
	MOVEQ	#0,D0
	MOVE.B	RawKeyCode,D0
	CMP.B	#35,D0 ; F
	BEQ	ToggleFilter
	CMP.B	#33,D0 ; S
	BEQ	ToggleSplit
	CMP.B	#55,D0 ; M
	JEQ	ToggleMultiMode
	CMP.B	#16,D0 ; Q
	BEQ	UnmuteAll
	CMP.B	#32,D0 ; A
	BEQ	ToggleMute
	CMP.B	#49,D0 ; Z
	BEQ	RestoreEffects
	CMP.B	#19,D0 ; R
	BEQ	RestoreFKeyPos
	CMP.B	#20,D0 ; T
	BEQ	SwapTrack

	CMP.B	#53,D0 ; B
	BEQ	BeginBlock
	CMP.B	#51,D0 ; C
	BEQ	CopyBlock
	CMP.B	#50,D0 ; X
	BEQ	CutBlock
	CMP.B	#34,D0 ; D
	BEQ	DeleteBlock
	CMP.B	#25,D0 ; P
	BEQ	PasteBlock
	CMP.B	#23,D0 ; I
	BEQ	InsertBlock
	CMP.B	#38,D0 ; J
	BEQ	JoinPasteBlock
	CMP.B	#54,D0 ; N
	BEQ	Re_MarkBlock
	CMP.B	#21,D0 ; Y
	BEQ	BackwardsBlock
	CMP.B	#17,D0 ; W
	BEQ	PolyphonizeBlock

	CMP.B	#18,D0 ; E
	BEQ	ExpandTrack
	CMP.B	#24,D0 ; O
	BEQ	ContractTrack
	CMP.B	#37,D0 ; H
	BEQ	TransBlockUp
	CMP.B	#40,D0 ; L
	BEQ	TransBlockDown
	CMP.B	#39,D0 ; K
	BEQ	KillToEndOfTrack
	CMP.B	#22,D0 ; U
	BEQ	UndoLastChange

	CMP.B	#68,D0 ; CR
	BEQ	InsCmdTrack
	CMP.B	#65,D0 ; Del
	BEQ	DelCmdTrack
	CMP.B	#36,D0 ; G
	BEQ	BoostAll
	CMP.B	#52,D0 ; V
	BEQ	FilterAll

	CMP.B	#1,D0
	RLO
	CMP.B	#10,D0
	RHI
	BNE.S	cckskip
	MOVEQ	#0,D0
cckskip	MOVE.W	D0,EditMoveAdd
	CLR.B	RawKeyCode
	ADD.B	#'0',D0
	LEA	ematext(PC),A0
	MOVE.B	D0,11(A0)
	jsr	ShowStatusText
	MOVE.W	#10,WaitTime
	BSR	WaitALittle
	jmp	ShowAllRight

ematext	dc.b "editskip = 0",0,0

;---- Check alt keys ----

CheckAltKeys
	TST.W	AltKeyStatus
	REQ
	MOVEQ	#0,D0
	MOVE.B	RawKeyCode,D0
	CMP.B	#49,D0 ; Z
	BEQ	ToggleCh1
	CMP.B	#50,D0 ; X
	BEQ	ToggleCh2
	CMP.B	#51,D0 ; C
	BEQ	ToggleCh3
	CMP.B	#52,D0 ; V
	BEQ	ToggleCh4
	CMP.B	#53,D0 ; B
	JEQ	Boost
	CMP.B	#35,D0 ; F
	JEQ	Filter
	CMP.B	#20,D0 ; T
	JEQ	TuningTone
	CMP.B	#33,D0 ; S
	JEQ	SamplerScreen
	CMP.B	#19,D0 ; R
	JEQ	Resample
	;CMP.B	#18,D0 ; E
	;BEQ	DoEditOp
	CMP.B	#23,D0 ; I
	BEQ.S	AutoInsert
	CMP.B	#34,D0 ; D
	BEQ	DiskOp
	CMP.B	#39,D0 ; K
	JEQ	KillInstrTrack
;	CMP.B	#17,D0 ; W
;	BEQ.S	WaitForNote
	CMP.B	#32,D0 ; A
	JEQ	Sampler
	CMP.B	#16,D0 ; Q
	BEQ	AskQuit

;	CMP.B	#55,D0 ; M
;	beq.w	ScreenToBack
;	CMP.B	#25,D0 ; P
;	CMP.B	#38,D0 ; J
;	CMP.B	#54,D0 ; N
;	beq.w	ScreenToBack
;	CMP.B	#21,D0 ; Y
;	CMP.B	#24,D0 ; O
;	CMP.B	#37,D0 ; H
;	CMP.B	#40,D0 ; L
;	CMP.B	#22,D0 ; U
;	CMP.B	#36,D0 ; G
	RTS

AutoInsert:
	CLR.B	RawKeyCode
	EOR.B	#1,AutoInsFlag
ShowAutoInsert:
	MOVE.B	#' ',D0
	TST.B	AutoInsFlag
	BEQ.S	.auins2
	MOVE.B	#'I',D0
.auins2	MOVE.B	D0,AutoInsText
	MOVE.W	#128*80+3,D1
	MOVEQ	#1,D0
	LEA	AutoInsText(PC),A0
	JMP	ShowText3

	cnop	0,4
AutoInsText:	dc.b 0
AutoInsFlag:	dc.b 0

;---- Jump between channels ----

Chan1Pressed:
	movem.w	MouseX2,d0/d1
	moveq	#47+0*120,d2
	moveq	#7*0,d3
	bra.s	ChanPressed
Chan2Pressed:
	movem.w	MouseX2,d0/d1
	move.w	#47+1*120,d2
	moveq	#7*1,d3
	bra.s	ChanPressed
Chan3Pressed:
	movem.w	MouseX2,d0/d1
	move.w	#47+2*120,d2
	moveq	#7*2,d3
	bra.s	ChanPressed
Chan4Pressed:
	movem.w	MouseX2,d0/d1
	move.w	#47+3*120,d2
	moveq	#7*3,d3
	;bra.s	ChanPressed
ChanPressed:
	sub.w	d2,d0
	tst.b	ButtonFlag
	beq.s	.cnt
	bsr	CheckBlock
	RNE
.cnt	bsr	WaitForButtonUp
	bra.s	GetCursorPos
	cnop	0,4
ButtonFlag:	dc.b	0,0

GetCursorPos:
	moveq	#0,d4
	cmp.w	#3*12,d0
	bmi.s	.end
	addq.w	#1,d4
	cmp.w	#4*12,d0
	bmi.s	.end
	addq.w	#1,d4
	cmp.w	#5*12,d0
	bmi.s	.end
	addq.w	#1,d4
	cmp.w	#6*12,d0
	bmi.s	.end
	addq.w	#1,d4
	cmp.w	#7*12,d0
	bmi.s	.end
	addq.w	#1,d4
	cmp.w	#8*12,d0
	bmi.s	.end
	addq.w	#1,d4
.end	add.w	d3,d4
	move.w	d4,PattCurPos
	tst.w	RunMode
	bne.s	.cnt3
	sub.w	#150,d1
	asr.w	#3,d1
	sub.w	#6,d1
	add.w	d1,ScrPattPos
	bpl.s	.cnt
	clr.w	ScrPattPos
.cnt	cmp.w	#63,ScrPattPos
	bmi.s	.cnt2
	move.w	#63,ScrPattPos
.cnt2	jsr	SetScrPatternPos
.cnt3	bsr	UpdateCursorPos
	tst.l	RunMode
	RNE
	tst.b	ButtonFlag
	REQ
	clr.w	FlipStat1
	jmp	ShowEdMode

CheckBlock:
	push    d0-d7/a0-a6
	tst.l	RunMode
	bne	.end
	move.w	d2,.xbord
	move.w	d3,BlockCurPos
	bsr	ClearPatBlock
	move.l	#-1,StoreBlock
	movem.w	MouseX,d0-d1
	sub.w	.xbord(pc),d0
	bmi.w	.not2
	cmp.w	#254,d1
	bpl	.not
	sub.w	#150,d1
	bmi	.not
	ext.l	d0
	divs	#12,d0
	asr.w	#3,d1
	add.w	ScrPattPos,d1
	cmp.w	#6,d1
	bmi	.not
	cmp.w	#64+6,d1
	bpl	.not
	move.w	d1,d2
	swap	d2
	cmp.w	#5,d0
	bpl.s	.ct
	moveq	#0,d0
	bra.s	.ct0
.ct	moveq	#5,d0
.ct0	move.w	d0,d2
	move.l	d2,.old
	move.w	BlockDelay(pc),.speed
.loop	bsr	CheckNTSCPos
	btst	#2,$dff016
	bne	.not
	move.w	BlockDelay(pc),d7
	movem.w	MouseX,d2-d3
	cmp.w	#253,d3
	bmi.s	.cn1
	bsr	.lower
	move.w	#252,d3
	move.w	BlockSpeed(pc),d7
.cn1	sub.w	#150,d3
	bpl.s	.cn2
	bsr	.upper
	moveq	#0,d3
	move.w	BlockSpeed(pc),d7
.cn2	move.w	d7,.speed
	sub.w	.xbord(pc),d2
	bpl.s	.cnt1
	moveq	#0,d2
.cnt1	ext.l	d2
	divs	#12,d2
	cmp.w	#8,d2
	bmi.s	.cnt3
	moveq	#8,d2
.cnt3	asr.w	#3,d3
	cmp.w	#13,d3
	bmi.s	.cn4
	moveq	#13,d3
.cn4	add.w	ScrPattPos,d3
	cmp.w	#6,d3
	bpl.s	.c3
	moveq	#6,d3
.c3	cmp.w	#63+6,d3
	bmi.s	.c4
	moveq	#63+6,d3
.c4
	cmp.w	#5,d2
	bpl.s	.ct3
	moveq	#0,d2
	bra.s	.ct4
.ct3	moveq	#5,d2
.ct4
	move.w	d3,d4
	swap	d4
	move.w	d2,d4
	cmp.l	.old(pc),d4
	beq.w	.loop
	move.l	d4,.old
	move.w	.xbord(pc),d4
	push    d0-d7/a0-a6
	bsr	InvertPatBlock
	pop     d0-d7/a0-a6
	bra	.loop
.end2	clr.l	StoreBlock
.end	pop     d0-d7/a0-a6
	moveq	#0,d4
	rts
.not	tst.l	StoreBlock
	bmi.s	.end2
.not2	move.w	#3,FlipStat1
	jsr	ShowEdMode
	pop     d0-d7/a0-a6
	moveq	#-1,d4
	rts
.upper	subq.w	#1,ScrPattPos
	bpl.s	.cnt7
	clr.w	ScrPattPos
.cnt7	push    d0-d7/a0-a6
	jsr	SetScrPatternPos
	move.l	DosBase,a6
	moveq	#0,d1
	move.w	.speed(pc),d1
	jsr	LVODelay(a6)
	pop     d0-d7/a0-a6
	rts
.lower	addq.w	#1,ScrPattPos
	cmp.w	#63,ScrPattPos
	bmi.s	.cnt8
	move.w	#63,ScrPattPos
.cnt8	push    d0-d7/a0-a6
	jsr	SetScrPatternPos
	move.l	DosBase,a6
	moveq	#0,d1
	move.w	.speed(pc),d1
	jsr	LVODelay(a6)
	pop     d0-d7/a0-a6
	rts

	cnop	0,4
.xbord	dc.w	0
.oldsc	dc.w	0
.speed	dc.w	0
.old	dc.l	0

BlockDelay:	dc.w	$14
BlockSpeed:	dc.w	$02
BlockX1:	dc.w	0
BlockY1:	dc.w	0
BlockX2:	dc.w	0
BlockY2:	dc.w	0
BlockCurPos:	dc.w	0
StoreBlock:	ds.w	4

GetBlockArea:
	tst.l	StoreBlock
	beq.s	.not
	move.w	BlockY1(pc),d0
	move.w	BlockY2(pc),d1
	addq.w	#1,d1
	sub.w	d0,d1
	subq.w	#6,d0
	move.w	d1,BlockLen
	move.w	d0,BlockPosY
	move.w	BlockCurPos(pc),BlockPosX
	tst.w	BlockX1
	sne	LeftFlag
	tst.w	BlockX2
	seq	RightFlag
	moveq	#0,d0
	rts
.not	moveq	#-1,d0
	rts

InvertBlockArea:
	movem.w	StoreBlock(pc),d0-d3
	bra	DoInvertBlock
ClearPatBlock:
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	movem.w	d0-d3,StoreBlock
InvertPatBlock:
	movem.w	d0-d4,-(sp)
	movem.w	.old(pc),d0-d3
	bsr	DoInvertBlock
	movem.w	(sp)+,d0-d4

	cmp.w	d0,d2
	bpl.s	.cnt5
	exg	d0,d2
.cnt5	cmp.w	d1,d3
	bpl.s	.cnt6
	exg	d1,d3
.cnt6	movem.w	d0-d3,.store
	tst.w	d2
	bne.s	.cnt7
	moveq	#5,d2
	bra.s	.cnt8
.cnt7	moveq	#9,d2
.cnt8
	muls	#12,d0
	muls	#12,d2
	asl.w	#3,d1
	asl.w	#3,d3
	add.w	d4,d0
	add.w	d4,d2
	add.w	#150-4,d1
	add.w	#150-4,d3
	addq.w	#8,d3
	movem.w	d0-d3,.old
	tst.w	d4
	REQ
	movem.w	d0-d3,StoreBlock
	bsr.s	DoInvertBlock
	movem.w	.store(pc),d0-d3
	movem.w	d0-d3,BlockX1
	rts
		cnop	0,4
.old		ds.w	4
.store		ds.w	4

DoInvertBlock:
	tst.w	d0
	REQ
	jmp	InvertAnyBlock5




TabulateCursor
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BNE.S	TabCurRight
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	ADDQ.W	#1,D0
	CMP.W	#4,D0
	BNE.S	tacskip
	MOVEQ	#0,D0
tacskip	MULU	#7,D0
	MOVE.W	D0,PattCurPos
	BRA	UpdateCursorPos

TabCurRight
	MOVE.W	PattCurPos,D0
	ADDQ.W	#5,D0
	DIVU	#7,D0
	SUBQ.W	#1,D0
	BPL.S	tacskip
	MOVEQ	#3,D0
	BRA.S	tacskip

;---- Escape was pressed ----

EscPressed:
	CLR.B	RawKeyCode
	CLR.B	SaveKey
	MOVE.W	CurrScreen,D0
	CMP.W	#2,D0
	BLO.S	BotExit
TopExit	MOVE.W	CurrScreen,D0
	CMP.W	#3,D0
	BEQ	ExitFromDir
	CMP.W	#5,D0
	BEQ	ExitSetup
	CMP.W	#7,D0
	BEQ	ExitSetup
	RTS

BotExit:TST.W	SamScrEnable
	BNE.S	samplerexit
	TST.W	BlockMarkFlag
	BNE	blkunma
	cmp.w	#MainScreen_ID,CurrScreen
	RNE
	;TST.B	EdEnable
	;BNE	ExitEditOp
	RTS
samplerexit:
	 JMP	ExitFromSam

ScreenToBack:
	bsr	DoScreenToBack
	JSR	WaitForActivate		;Wait for new activation
	bra	DoScreenToFront

DoScreenToBack:
	TST.L	RunMode
	BNE.S	.skp1a
	BSR	StopIt
	;BSR	ResetMusicInt
.skp1a	BSR	ResetVBInt
	BSR	ResetInputHandler
	BSR	ResetAutoReq
	BSR	ResetCopList
	jsr	ClrTestColors	; -maw-		; turn test color bars off

	move.l	IntuitionBase,a0
	move.w	MouseX3,d0
	move.w	MouseY3,d1
	move.w	d0,70(a0)
	move.w	d1,68(a0)

	move.l	PsScrHnd,d0
	beq.b	NoPsScr
	move.l	d0,a0
	move.l	a6,-(sp)
	move.l	IntuitionBase,a6
	cmp.l	60(a6),a0		;ib_FirstScreen
	bne.b	.not			;if we're not in front, then do 0
	jsr	-246(a6)		;ScreenToBack()
.not	move.l	(sp)+,a6
	rts

DoScreenToFront:
	jsr	ResetKeys
	move.l	IntuitionBase,a0
	move.w	70(a0),d0
	move.w	68(a0),d1
	move.w	d0,MouseX3
	move.w	d1,MouseY3
	move.w	d0,MouseX
	lsr.w	#1,d1
	move.w	d1,MouseY

NoPsScr:TST.L	RunMode
	BNE.W	.skp2a
	;BSR	SetMusicInt
.skp2a	BSR	SetVBInt
	BSR	SetInputHandler
	BSR	SetAutoReq
	BRA	SetCopList

;---- Check Function Keys F6-F10 ----

CheckF6_F10:
	CMP.B	#85,RawKeyCode
	BNE.S	CheckF7
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.S	cf6skip
	MOVE.W	ScrPattPos,F6pos
ShowPosSetText:
	LEA	PosSetText,A0
	JSR	ShowStatusText
	MOVEQ	#8,D2
.loop	BSR	Wait_4000
	DBRA	D2,.loop
	JMP	ShowAllRight	
cf6skip	MOVE.W	F6pos,D0
chkalt	TST.W	AltKeyStatus
	BNE	PattFrom
	TST.W	CtrlKeyStatus
	BNE	RecordFrom
	TST.W	LeftAmigaStatus
	BNE	SongFrom
	TST.W	RunMode
	RNE
	MOVE.W	D0,ScrPattPos
	BRA	SetScrPatternPos
 
CheckF7:CMP.B	#86,RawKeyCode
	BNE.S	CheckF8
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.S	.skip
	MOVE.W	ScrPattPos,F7pos
	BRA.S	ShowPosSetText	
.skip	MOVE.W	F7pos,D0
	BRA.S	chkalt

CheckF8:CMP.B	#87,RawKeyCode
	BNE.S	CheckF9
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.S	.skip
	MOVE.W	ScrPattPos,F8pos
	BRA	ShowPosSetText	
.skip	MOVE.W	F8pos,D0
	BRA	chkalt

CheckF9:CMP.B	#88,RawKeyCode
	BNE.S	CheckF10
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.S	.skip
	MOVE.W	ScrPattPos,F9pos
	BRA	ShowPosSetText
.skip	MOVE.W	F9pos,D0
	BRA	chkalt

CheckF10:
	CMP.B	#89,RawKeyCode
	RNE
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.S	.skip
	MOVE.W	ScrPattPos,F10pos
	BRA	ShowPosSetText	
.skip	MOVE.W	F10pos,D0
	BRA	chkalt

	cnop	0,4
F6pos:	dc.w  0
F7pos:	dc.w 16
F8pos:	dc.w 32
F9pos:	dc.w 48
F10pos:	dc.w 63

;---- Check Function Keys F3-F5 ----

CheckF3_F5:
	MOVEQ	#0,D0
	MOVE.L	D0,A0
	TST.W	ShiftKeyStatus
	BNE	CCP4
	TST.W	CtrlKeyStatus
	BNE	CCP4
	TST.W	AltKeyStatus
	BNE	CutCopPas
	CMP.B	#68,RawKeyCode
	BEQ.S	StepPlayForward
	CMP.B	#65,RawKeyCode
	BEQ.S	StepPlayBackward
	TST.W	SamScrEnable
	REQ
	CMP.B	#82,RawKeyCode
	JEQ	SamCut
	CMP.B	#83,RawKeyCode
	JEQ	SamCopy
	CMP.B	#84,RawKeyCode
	JEQ	SamPaste
	RTS

StepPlayForward:
	bsr	ClearKeyBuf
	MOVE.W	#1,StepPlayEnable
	BSR	DoStopIt
	MOVE.W	ScrPattPos,D0
	BRA	pafr1

StepPlayBackward:
	MOVE.W	#1,StepPlayEnable
	BSR	DoStopIt
	MOVE.W	ScrPattPos,D0
	SUBQ.W	#1,D0
	AND.W	#63,D0
	BRA	pafr1

	cnop	0,4
StepPlayEnable:	dc.w	0

CCP4:	MOVEQ	#0,D0
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	AND.L	#3,D0
	LSL.L	#2,D0
	MOVE.L	D0,A0
CutCopPas:
	ADD.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0
	MOVE.L	PatternNumber,D0
	LSL.L	#8,D0
	LSL.L	#2,D0
	ADD.L	D0,A0
	TST.W	AltKeyStatus
	BNE.S	CutCopPasPatt
	TST.W	CtrlKeyStatus
	BNE.S	CutCopPasCmds
CutCopPasTrack:
	CMP.B	#82,RawKeyCode
	BEQ	CutTrack
	CMP.B	#83,RawKeyCode
	BEQ	CopyTrack
	CMP.B	#84,RawKeyCode
	BEQ	PasteTrack
	CMP.B	#68,RawKeyCode
	BEQ	InsNoteTrack
	CMP.B	#65,RawKeyCode
	BEQ	DelNoteTrack
	RTS

CutCopPasPatt:
	CMP.B	#82,RawKeyCode
	BEQ.S	CutPattern
	CMP.B	#83,RawKeyCode
	BEQ.S	CopyPattern
	CMP.B	#84,RawKeyCode
	BEQ	PastePattern
	CMP.B	#68,RawKeyCode
	BEQ	InsNotePattern
	CMP.B	#65,RawKeyCode
	BEQ	DelNotePattern
	RTS

CutCopPasCmds:
	CMP.B	#82,RawKeyCode
	BEQ	CutCmds
	CMP.B	#83,RawKeyCode
	BEQ	CopyCmds
	CMP.B	#84,RawKeyCode
	BEQ	PasteCmds
	RTS

CutPattern:
	BSR	SaveUndo
	LEA	PatternBuffer,A1
	MOVE.W	#255,D0
	MOVEQ	#0,D1
.loop	MOVE.L	(A0),(A1)+
	MOVE.L	D1,(A0)+
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	JMP	RedrawPattern
 
CopyPattern:
	LEA	PatternBuffer,A1
	MOVE.W	#255,D0
.loop	MOVE.L	(A0)+,(A1)+
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	RTS	
 
PastePattern:
	BSR	SaveUndo
	LEA	PatternBuffer,A1
	MOVE.W	#255,D0
.loop	MOVE.L	(A1)+,(A0)+
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	JMP	RedrawPattern

CutTrack:
	BSR	SaveUndo
	LEA	TrackBuffer,A1
	MOVEQ	#63,D0
	MOVEQ	#0,D1
.loop	MOVE.L	(A0),(A1)+
	MOVE.L	D1,(A0)
	LEA	16(A0),A0
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	JMP	RedrawPattern

CopyTrack:
	LEA	TrackBuffer,A1
	MOVEQ	#63,D0
.loop	MOVE.L	(A0),(A1)+
	LEA	16(A0),A0
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	RTS

PasteTrack:
	BSR	SaveUndo
	LEA	TrackBuffer,A1
	MOVEQ	#63,D0
.loop	MOVE.L	(A1)+,(A0)
	LEA	16(A0),A0
	DBRA	D0,.loop
	CLR.B	RawKeyCode
	JMP	RedrawPattern

InsNotePattern:
	BSR	SaveUndo
	MOVEQ	#0,D0
	JSR	GetPositionPtr
	BSR.S	inotr
	MOVEQ	#7,D0
	JSR	GetPositionPtr
	BSR.S	inotr
	MOVEQ	#14,D0
	JSR	GetPositionPtr
	BSR.S	inotr
	MOVEQ	#21,D0
	JSR	GetPositionPtr
	BSR.S	inotr
	BRA.S	intskip
InsNoteTrack:
	BSR	SaveUndo
	BSR.S	inotr
intskip:CLR.B	RawKeyCode
	ADD.W	D2,ScrPattPos
	AND.W	#$3F,ScrPattPos
	BSR	SetScrPatternPos
	JMP	RedrawPattern

inotr:	MOVE.W	ScrPattPos,D1
	LSL.W	#4,D1			;/16
	CMP.W	#63*16,D1
	BEQ.S	.skip
	MOVE.W	#992,D0
.loop	MOVE.L	0(a0,D0.W),16(A0,D0.W)
	SUB.W	#16,D0
	CMP.W	D1,D0
	BGE.S	.loop
.skip	MOVEQ	#1,D2
	CLR.L	0(a0,D1.W)
	RTS

InsCmdTrack:
	BSR	SaveUndo
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR.S	.icmtr
	BRA.S	.skip
.icmtr	MOVE.W	ScrPattPos,D1
	LSL.W	#4,D1
	CMP.W	#63*16,D1
	BEQ.S	.skip
	MOVE.W	#992,D0
.loop	MOVE.W	2(A0,D0.W),D2
	AND.W	#$0FFF,D2
	AND.W	#$F000,18(A0,D0.W)
	OR.W	D2,18(A0,D0.W)
	SUB.W	#16,D0
	CMP.W	D1,D0
	BGE.S	.loop
.skip	MOVEQ	#1,D2
	AND.W	#$F000,2(A0,D1.W)
	RTS

DelNotePattern:
	BSR	SaveUndo
	MOVEQ	#0,D0
	JSR	GetPositionPtr
	BSR.S	dnt
	MOVEQ	#7,D0
	JSR	GetPositionPtr
	BSR.S	dnt
	MOVEQ	#14,D0
	JSR	GetPositionPtr
	BSR.S	dnt
	MOVEQ	#21,D0
	JSR	GetPositionPtr
	BSR.S	dnt
	BRA	intskip
DelNoteTrack:
	BSR	SaveUndo
	BSR.S	dnt
	BRA	intskip
dnt:	MOVE.W	ScrPattPos,D0
	REQ
	SUBQ.W	#1,D0
	LSL.W	#4,D0
.loop	MOVE.L	16(A0,D0.W),0(a0,D0.W)
	ADD.W	#16,D0
	CMP.W	#1024,D0
	BLO.S	.loop
	MOVE.W	#1008,D1
	MOVEQ	#-1,D2
	CLR.L	0(a0,D1.W)
	RTS

DelCmdTrack:
	BSR	SaveUndo
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR.S	.dct
	BRA	intskip			; is this right ?
.dct	MOVE.W	ScrPattPos,D0
	REQ
	SUBQ.W	#1,D0
	LSL.W	#4,D0
.loop	MOVE.W	18(A0,D0.W),D2
	AND.W	#$0FFF,D2
	AND.W	#$F000,2(A0,D0.W)
	OR.W	D2,2(A0,D0.W)
	ADD.W	#16,D0
	CMP.W	#1024,D0
	BLO.S	.loop
	MOVE.W	#1008,D1
	MOVEQ	#-1,D2
	AND.W	#$F000,2(A0,D1.W)
	RTS

CutCmds:BSR	SaveUndo
	LEA	CmdsBuffer,A1
	moveq	#0,d0
.loop	MOVE.L	(A0,D0.W),(A1)+
	AND.L	#$FFFFF000,(a0,D0.W)
	ADD.W	#16,D0
	CMP.W	#1024,D0
	BNE.S	.loop
	CLR.B	RawKeyCode
	jmp	RedrawPattern
 
CopyCmds:
	LEA	CmdsBuffer,A1
	CLR.W	D0
.loop	MOVE.L	(A0,D0.W),(A1)+
	ADD.W	#16,D0
	CMP.W	#1024,D0
	BNE.S	.loop
	CLR.B	RawKeyCode
	RTS	
 
PasteCmds:
	BSR	SaveUndo
	LEA	CmdsBuffer,A1
	moveq	#0,d0
.loop	MOVE.L	0(A0,D0.W),D1
	AND.L	#$FFFFF000,D1
	MOVE.L	(A1)+,D2
	AND.L	#$00000FFF,D2
	OR.L	D2,D1
	MOVE.L	D1,0(a0,D0.W)
	ADD.W	#16,D0
	CMP.W	#1024,D0
	BNE.S	.loop
	CLR.B	RawKeyCode
	jmp	RedrawPattern

;---- Swap Tracks ----

SwapTrack:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	LEA	SwapTrackText,A0
	JSR	ShowStatusText
.loop	BSR	GetHexKey
	TST.B	D1
	BEQ.S	.abor
	CMP.B	#4,D1
	BHI.S	.loop
	BSR	SaveUndo
	SUBQ.L	#1,D1
	LSL.L	#2,D1
	MOVE.L	D1,D0
	MOVE.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0
	MOVE.L	PatternNumber,D1
	LSL.L	#8,D1
	LSL.L	#2,D1
	ADD.L	D1,A0
	MOVE.L	A0,A1
	ADD.L	D0,A0
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	AND.L	#$F,D0
	LSL.L	#2,D0
	ADD.L	D0,A1
	MOVEQ	#63,D1
.loop2	MOVE.L	(A0),D0
	MOVE.L	(A1),(A0)
	MOVE.L	D0,(A1)
	LEA	16(A0),A0
	LEA	16(A1),A1
	DBRA	D1,.loop2
	JSR	RedrawPattern
.abor	JSR	ShowAllRight
	BRA	RestorePtrCol

SwapTrackText:	dc.b 'Swap with which track? (1/2/3/4)',0,0
		cnop 0,2

;---- Block Commands ----

BlockMarkText:	dc.b 'Mark block 00-00',0,0
BlockErrorText:	dc.b 'You haven''t marked any block!',0
BufEmptyText:	dc.b 'The buffer is empty!',0
		cnop 0,2
BlockFromPos:	dc.w 0
BlockToPos:	dc.w 0
BlockMarkFlag:	dc.w 0
BlockBufferFlag:dc.w 0
JoinPasteFlag:	dc.w 0
PolyPasteFlag:	dc.w 0
BuffFromPos:	dc.w 0
BuffToPos:	dc.w 0
	cnop	0,4

BeginBlock:
	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ.S	beblskp
blkunma	CLR.W	BlockMarkFlag
	JMP	ShowAllRight
beblskp	MOVE.W	#1,BlockMarkFlag
	MOVE.W	ScrPattPos,BlockFromPos
	MOVE.W	ScrPattPos,BlockToPos
ShowBlockPos:
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	.skip
	EXG	D0,D1
.skip	LEA	BlockMarkText+12(PC),A0
	BSR	IntTo2DecAscii
	LEA	BlockMarkText+15(PC),A0
	MOVE.W	D1,D0
	BSR	IntTo2DecAscii
	LEA	BlockMarkText(PC),A0
	JMP	ShowStatusText

Re_MarkBlock
	CLR.B	RawKeyCode
	MOVE.W	#1,BlockMarkFlag
	MOVE.W	BlockToPos,ScrPattPos
	BSR	SetScrPatternPos
	BRA.S	ShowBlockPos

CheckBlockPos:
	TST.W	BlockMarkFlag
	REQ
	MOVE.W	ScrPattPos,D0
	CMP.W	BlockToPos,D0
	REQ
	MOVE.W	D0,BlockToPos
	BRA.S	ShowBlockPos

IntTo2DecAscii:
	AND.L	#$FF,D0
	DIVU	#10,D0
	ADD.B	#'0',D0
	MOVE.B	D0,-1(A0)
	SWAP	D0
	ADD.B	#'0',D0
	MOVE.B	D0,(A0)
	RTS

CutBlock:
	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ	BlockError
	BSR.S	cobldo
	MOVE.W	#1,BlockMarkFlag
	BRA	ClearBlock

CopyBlock:
	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ	BlockError
cobldo	CLR.W	BlockMarkFlag
	MOVE.W	#1,BlockBufferFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	LEA	BlockBuffer,A1
	MOVEQ	#63,D0
cobllop	MOVE.L	(A0),(A1)
	LEA	16(A0),A0
	LEA	16(A1),A1
	DBRA	D0,cobllop
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	coblskp
	EXG	D0,D1
coblskp	MOVE.W	D0,BuffFromPos
	MOVE.W	D1,BuffToPos
	JMP	ShowAllRight


PasteBlock
	CLR.B	RawKeyCode
	TST.W	BlockBufferFlag
	BEQ	BufferError
	BSR	SaveUndo
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	LEA	BlockBuffer,A1
	MOVE.W	BuffFromPos,D0
	MOVE.W	BuffToPos,D1
	MOVE.W	ScrPattPos,D2
	LSL.W	#4,D0
	LSL.W	#4,D1
	LSL.W	#4,D2
pabllop	MOVE.L	0(a1,D0.W),D3
	TST.W	JoinPasteFlag
	BEQ.S	pablskp
	MOVE.L	D3,D4
	AND.L	#$FFFFF000,D4
	BNE.S	pablskp
	MOVE.L	0(a0,D2.W),D4
	AND.L	#$FFFFF000,D4
	AND.L	#$00000FFF,D3
	OR.L	D4,D3
pablskp	MOVE.L	D3,0(a0,D2.W)
	CMP.W	D0,D1
	BEQ.S	pablend
	CMP.W	#63*16,D0
	BEQ.S	pablend
	CMP.W	#63*16,D2
	BEQ.S	pablend
	ADD.W	#16,D0
	ADD.W	#16,D2
	TST.W	PolyPasteFlag
	BEQ.S	pabllop
	MOVEM.L	A1/D0-D2,-(SP)
	BSR	GotoNextMulti
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	MOVEM.L	(SP)+,A1/D0-D2
	BRA.S	pabllop
pablend	CLR.W	JoinPasteFlag
	CLR.W	PolyPasteFlag
	JSR	ShowAllRight
	jsr	RedrawPattern
	TST.W	ShiftKeyStatus
	RNE
	MOVE.W	BuffToPos,D0
	SUB.W	BuffFromPos,D0
	ADDQ.W	#1,D0
	ADD.W	ScrPattPos,D0
	CMP.W	#63,D0
	BLS.S	pablset
	MOVEQ	#0,D0
pablset	MOVE.W	D0,ScrPattPos
	BRA	SetScrPatternPos

PolyphonizeBlock
	MOVE.W	#1,PolyPasteFlag
JoinPasteBlock
	MOVE.W	#1,JoinPasteFlag
	BRA	PasteBlock

InsertBlock
	CLR.B	RawKeyCode
	TST.W	BlockBufferFlag
	BEQ	BufferError
	CMP.W	#63,ScrPattPos
	BEQ	PasteBlock
	MOVE.W	BuffToPos,D0
	SUB.W	BuffFromPos,D0
inbllop	MOVE.L	D0,-(SP)
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR	inotr
	MOVE.L	(SP)+,D0
	DBRA	D0,inbllop
	BRA	PasteBlock

DeleteBlock
	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ	BlockError
	BSR	SaveUndo
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	deblskp
	EXG	D0,D1
deblskp	CMP.W	#63,D1
	BEQ.W	ClearBlock
	CLR.W	BlockMarkFlag
	MOVE.W	D0,ScrPattPos
	ADDQ.W	#1,ScrPattPos
	SUB.W	D0,D1
	MOVE.W	D1,D0
debllop	MOVE.L	D0,-(SP)
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR	dnt
	MOVE.L	(SP)+,D0
	DBRA	D0,debllop
	SUBQ.W	#1,ScrPattPos
	JSR	ShowAllRight
	jmp	RedrawPattern

ClearBlock:
	TST.W	BlockMarkFlag
	BEQ	BlockError
	BSR	SaveUndo
	CLR.W	BlockMarkFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	clblskp
	EXG	D0,D1
clblskp	LSL.W	#4,D0
	LSL.W	#4,D1
	MOVEQ	#0,D2
clbllop	MOVE.L	D2,0(a0,D0.W)
	CMP.W	D0,D1
	BEQ.S	clblend
	ADD.W	#16,D0
	BRA.S	clbllop
clblend	JSR	ShowAllRight
	JMP	RedrawPattern

BackwardsBlock
	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ	BlockError
	BSR	SaveUndo
	CLR.W	BlockMarkFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	bablskp
	EXG	D0,D1
bablskp	LSL.W	#4,D0
	LSL.W	#4,D1
babllop	MOVE.L	0(a0,D0.W),D2
	MOVE.L	0(a0,D1.W),0(a0,D0.W)
	MOVE.L	D2,0(a0,D1.W)
	CMP.W	D1,D0
	BHS.S	bablend
	ADD.W	#16,D0
	SUB.W	#16,D1
	CMP.W	D1,D0
	BHS.S	bablend
	BRA.S	babllop
bablend	JSR	ShowAllRight
	JMP	RedrawPattern

TransBlockUp
	SF	trblflag
	BRA.S	trbldo
TransBlockDown
	ST	trblflag
trbldo	CLR.B	RawKeyCode
	TST.W	BlockMarkFlag
	BEQ	BlockError
	BSR	SaveUndo
	MOVE.W	#2,NoteShift
	MOVE.W	BlockFromPos,D0
	MOVE.W	BlockToPos,D1
	CMP.W	D0,D1
	BHS.S	trblskp
	EXG	D0,D1
trblskp	MOVE.W	D0,D5
	LSL.W	#4,D5
	SUB.W	D0,D1
	MOVE.W	D1,D6
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	LEA	0(a0,D5.W),A3
	MOVEQ	#0,D3
	MOVE.B	SampleAllFlag,sampallsave
	ST	SampleAllFlag
	TST.B	trblflag
	BEQ.S	trblup
	JSR	sandlo2
	MOVE.B	sampallsave,SampleAllFlag
	JMP	RedrawPattern
trblup	JSR	sanulo2
	MOVE.B	sampallsave,SampleAllFlag
	JMP	RedrawPattern

	cnop	0,4
trblflag	dc.b 0
sampallsave	dc.b 0

BlockError
	LEA	BlockErrorText,A0
	JSR	ShowStatusText
	BRA	SetErrorPtrCol

BufferError
	LEA	BufEmptyText,A0
	JSR	ShowStatusText
	BRA	SetErrorPtrCol

ExpandTrack
	CLR.B	RawKeyCode
	BSR	SaveUndo
	MOVE.W	ScrPattPos,PosSave
	ADDQ.W	#1,ScrPattPos
	CMP.W	#64,ScrPattPos
	BHS.S	extrend
extrlop	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR	inotr
	ADDQ.W	#2,ScrPattPos
	CMP.W	#64,ScrPattPos
	BLO.S	extrlop
extrend	MOVE.W	PosSave,ScrPattPos
	JMP	RedrawPattern

ContractTrack
	CLR.B	RawKeyCode
	BSR	SaveUndo
	MOVE.W	ScrPattPos,PosSave
	ADDQ.W	#1,ScrPattPos
	CMP.W	#64,ScrPattPos
	BHS.S	cotrend
cotrlop	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	BSR	dnt
	ADDQ.W	#1,ScrPattPos
	CMP.W	#64,ScrPattPos
	BLO.S	cotrlop
cotrend	MOVE.W	PosSave,ScrPattPos
	JMP	RedrawPattern

	cnop	0,4
PosSave	dc.w 0

KillToEndOfTrack
	CLR.B	RawKeyCode
	BSR	SaveUndo
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	MOVE.W	ScrPattPos,D0
	MOVE.W	D0,D1
	MULU	#16,D1
	LEA	0(a0,D1.W),A0
	TST.W	ShiftKeyStatus
	BNE.S	KillToStart
kteot	CLR.L	(A0)
	LEA	16(A0),A0
	ADDQ.W	#1,D0
	CMP.W	#64,D0
	BLO.S	kteot
	JMP	RedrawPattern

KillToStart
	CLR.L	(A0)
	LEA	-16(A0),A0
	TST.W	D0
	JEQ	RedrawPattern
	SUBQ.W	#1,D0
	BRA.S	KillToStart

UndoLastChange
	CLR.B	RawKeyCode
	MOVEQ	#0,D0
	JSR	GetPositionPtr
	LEA	UndoBuffer,A1
	MOVE.W	#255,D0
unlalop	MOVE.L	(A1),D1
	MOVE.L	(A0),(A1)+
	MOVE.L	D1,(A0)+
	DBRA	D0,unlalop
	JMP	RedrawPattern

SaveUndo
	MOVEM.L	D0/A0-A1,-(SP)
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	LEA	UndoBuffer,A1
	MOVE.W	#255,D0
saunlop	MOVE.L	(A0)+,(A1)+
	DBRA	D0,saunlop
	MOVEM.L	(SP)+,D0/A0-A1
	RTS

BoostAll
	LEA	BoostAllText,A0
	BSR	AreYouSure
	BNE	SetErrorPtrCol
	MOVE.W	InsNum,SaveInstr
	MOVE.W	#1,InsNum
boallop	JSR	ShowSampleInfo
	JSR	Boost2
	ADDQ.W	#1,InsNum
	CMP.W	#MAX_INSTR+1,InsNum
	BLO.S	boallop
	MOVE.W	SaveInstr,InsNum
	JMP	ShowSampleInfo

FilterAll
	LEA	FilterAllText,A0
	BSR	AreYouSure
	BNE	SetErrorPtrCol
	MOVE.W	InsNum,SaveInstr
	MOVE.W	#1,InsNum
fiallop	JSR	ShowSampleInfo
	JSR	Filter2
	ADDQ.W	#1,InsNum
	CMP.W	#MAX_INSTR+1,InsNum
	BLO.S	fiallop
	MOVE.W	SaveInstr,InsNum
	JMP	ShowSampleInfo

BoostAllText	dc.b 'boost all samples',0
FilterAllText	dc.b 'filter all sampls',0
SaveInstr	dc.w 0

;---- Check Function Keys F1-F2 ----

CheckF1_F2
	CMP.B	#80,RawKeyCode
	BEQ.S	SetOctaveLow
	CMP.B	#81,RawKeyCode
	BEQ.S	SetOctaveHigh
	RTS	
 
SetOctaveLow
	MOVE.L	#KbdTransTable1,KeyTransTabPtr
	CLR.B	RawKeyCode
	RTS	
 
SetOctaveHigh
	MOVE.L	#KbdTransTable2,KeyTransTabPtr
	CLR.B	RawKeyCode
	RTS	

;---- Get Hex Key ----

GetAnyHexByte
	move.w	#-1,HexType
	move.w	d0,HexXp
	move.w	d1,HexYp
	bra.b	OtherHexByte
GetHexByte
	clr.w	HexType
OtherHexByte
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	CLR.B	RawKeyCode
	MOVEQ	#0,D0
	MOVE.W	TextOffset,D0
	DIVU	#80,D0
	ADDQ.W	#6,D0
	MOVE.W	D0,LineCurY
	SWAP	D0
	LSL.W	#3,D0
	ADDQ.W	#4,D0
	MOVE.W	D0,LineCurX
	tst.w	HexType
	beq.b	HexOk
	move.w	HexXp(pc),d0
	addq.w	#4,d0
	move.w	d0,LineCurX
	move.w	HexYp(pc),d0
	addq.w	#5,d0
	move.w	d0,LineCurY
HexOk	BSR	UpdateLineCurPos
	BSR.S	GetHexKey
	MOVE.L	D1,D0
	MOVE.B	D1,D6
	LSL.B	#4,D6
	tst.w	HexType
	beq.b	HexOk2
	bsr.w	PrintAnyHexDigit2
	bra.b	HexOk3
HexOk2	JSR	PrintHexDigit
HexOk3	ADD.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR.S	GetHexKey
	MOVE.L	D1,D0
	OR.B	D1,D6
	tst.w	HexType
	beq.b	HexOk4
	bsr.w	PrintAnyHexDigit2
	bra.b	HexOk5
HexOk4	JSR	PrintHexDigit
HexOk5	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	BSR	RestorePtrCol
	MOVEQ	#0,D0
	MOVE.B	D6,D0
	RTS
PrintAnyHexDigit2
	movem.w	d0-d1/d3,-(sp)
	move.w	d0,d3
	move.w	LineCurX,d0
	subq.w	#4,d0
	move.w	HexYp(pc),d1
	jsr	PrintAnyHexDigit
	movem.w	(sp)+,d0-d1/d3
	rts

GetHexKey:
	bsr	CheckNTSCPos
	CLR.B	MixChar
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	BTST	#2,$DFF016
	BEQ.S	ghkreturn
	BSR	DoKeyBuffer
	MOVE.B	RawKeyCode,D0
	CLR.B	RawKeyCode
	MOVE.B	D0,MixChar	;NB! used by other procedures than MixSample!!
	BEQ.S	GetHexKey	;(do not delete withouth changing all of them)
	CMP.B	#68,D0 		; CR
	BEQ.S	ghkreturn
	CMP.B	#69,D0 		; Esc
	BEQ.S	ghkreturn
	CMP.B	#79,D0 		; <--
	BEQ.S	ghkleft
	CMP.B	#78,D0 		; -->
	BEQ.S	ghkright
	BSR.S	CheckHexKey
	CMP.B	#16,D1
	BEQ.S	GetHexKey
ghkreturn
	MOVEQ	#0,D0
	RTS

ghkleft	MOVEQ	#-1,D0
	RTS

ghkright
	MOVEQ	#1,D0
	RTS

CheckHexKey
	LEA	RawKeyHexTable,A0
	MOVEQ	#0,D1
chxloop	CMP.B	(A0)+,D0
	REQ
	ADDQ.B	#1,D1
	CMP.B	#16,D1
	BNE.S	chxloop
	RTS

	cnop	0,4
HexType	dc.w	0
HexXp	dc.w	0
HexYp	dc.w	0

;---- Enter Edit Commands (effects) ----

EditCommand:
	TST.L	EditMode
	REQ
	MOVEQ	#0,D0
	MOVE.B	RawKeyCode,D0
	BSR.S	CheckHexKey
	CMP.B	#16,D1
	BNE.S	DoEditCommand
	RTS

DoEditCommand:
	CMP.W	#1,PattCurPos		;ins1
	BNE.S	ChkPos2
	CMP.W	#1,D1
	RHI
	MOVE.L	#$0FFF,D2
	CLR.W	CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos2:CMP.W	#2,PattCurPos		;ins2
	BNE.S	ChkPos3
	MOVE.L	#$0FFF,D2		;lower instr. nibble
	MOVE.W	#2,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos3:CMP.W	#3,PattCurPos		; new command upper nibble
	BNE.S	ChkPos4
	;MOVE.L	#$F0FF,D2
	;CLR.W	CmdOffset
	;LSL.W	#8,D1
	;BRA	UpdateCommand
	bra	dscend

ChkPos4:CMP.W	#4,PattCurPos		; comm2
	BNE.S	ChkPos5
	MOVE.L	#$F0FF,D2
	MOVE.W	#2,CmdOffset
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos5:CMP.W	#5,PattCurPos		; eff1
	BNE.S	ChkPos6
	MOVE.L	#$FF0F,D2
	MOVE.W	#2,CmdOffset
	LSL.W	#4,D1
	BRA	UpdateCommand

ChkPos6:CMP.W	#6,PattCurPos		; eff2
	BNE.S	ChkPos8
	MOVE.L	#$FFF0,D2
	MOVE.W	#2,CmdOffset
	BRA	UpdateCommand

ChkPos8:CMP.W	#8,PattCurPos		; ins1
	BNE.S	ChkPos9
	CMP.W	#1,D1
	RHI
	MOVE.L	#$FFF,D2
	MOVE.W	#4,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos9:CMP.W	#9,PattCurPos		;lower instr. nibble
	BNE.S	ChkPos10
	MOVE.L	#$FFF,D2
	MOVE.W	#6,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos10:CMP.W	#10,PattCurPos		; command upper nibble
	BNE.S	ChkPos11
	;MOVE.L	#$F0FF,D2
	;MOVE.W	#4,CmdOffset
	;LSL.W	#8,D1
	;BRA	UpdateCommand
	bra	dscend

ChkPos11:CMP.W	#11,PattCurPos		; comm2
	BNE.S	ChkPos12
	MOVE.L	#$F0FF,D2
	MOVE.W	#6,CmdOffset
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos12:CMP.W	#12,PattCurPos		; eff1
	BNE.S	ChkPos13
	MOVE.L	#$FF0F,D2
	MOVE.W	#6,CmdOffset
	LSL.W	#4,D1
	BRA	UpdateCommand

ChkPos13:CMP.W	#13,PattCurPos		; eff2
	BNE.S	ChkPos15
	MOVE.L	#$FFF0,D2
	MOVE.W	#6,CmdOffset
	BRA	UpdateCommand

ChkPos15:CMP.W	#15,PattCurPos		; ins1
	BNE.S	ChkPos16
	CMP.W	#1,D1
	RHI
	MOVE.L	#$0FFF,D2
	MOVE.W	#8,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos16:CMP.W	#16,PattCurPos		;lower instr. nibble
	BNE.S	ChkPos17
	MOVE.L	#$0FFF,D2
	MOVE.W	#10,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA	UpdateCommand


ChkPos17:CMP.W	#17,PattCurPos		; command upper nibble
	BNE.S	ChkPos18
	;MOVE.L	#$F0FF,D2
	;MOVE.W	#8,CmdOffset
	;LSL.W	#8,D1
	;BRA	UpdateCommand
	bra	dscend

ChkPos18:CMP.W	#18,PattCurPos		; comm2
	BNE.S	ChkPos19
	MOVE.L	#$F0FF,D2
	MOVE.W	#10,CmdOffset
	LSL.W	#8,D1
	BRA	UpdateCommand

ChkPos19:CMP.W	#19,PattCurPos		; eff1
	BNE.S	ChkPos20
	MOVE.L	#$FF0F,D2
	MOVE.W	#10,CmdOffset
	LSL.W	#4,D1
	BRA	UpdateCommand

ChkPos20:CMP.W	#20,PattCurPos		; eff2
	BNE.S	ChkPos22
	MOVE.L	#$FFF0,D2
	MOVE.W	#10,CmdOffset
	BRA	UpdateCommand

ChkPos22:CMP.W	#22,PattCurPos		; ins1
	BNE.S	ChkPos23
	CMP.W	#1,D1
	RHI
	MOVE.L	#$FFF,D2
	MOVE.W	#12,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA.W	UpdateCommand

ChkPos23:CMP.W	#23,PattCurPos		;lower instr. nibble
	BNE.S	ChkPos24
	MOVE.L	#$FFF,D2
	MOVE.W	#14,CmdOffset
	LSL.W	#4,D1
	LSL.W	#8,D1
	BRA.S	UpdateCommand

ChkPos24:CMP.W	#24,PattCurPos		; command upper nibble
	BNE.S	ChkPos25
	;MOVE.L	#$F0FF,D2
	;MOVE.W	#12,CmdOffset
	;LSL.W	#8,D1
	;BRA	UpdateCommand
	bra	dscend

ChkPos25:CMP.W	#25,PattCurPos		; comm2
	BNE.S	ChkPos26
	MOVE.L	#$F0FF,D2
	MOVE.W	#14,CmdOffset
	LSL.W	#8,D1
	BRA.S	UpdateCommand

ChkPos26:CMP.W	#26,PattCurPos
	BNE.S	MustBePos27
	MOVE.L	#$FF0F,D2
	MOVE.W	#14,CmdOffset
	LSL.W	#4,D1
	BRA.S	UpdateCommand

MustBePos27:
	CMP.w	#27,PattCurPos
	RNE			; For safety
	MOVE.L	#$FFF0,D2
	MOVE.W	#14,CmdOffset
UpdateCommand:
	push    d0-d7/a0-a6
	bsr	ClearPatBlock
	pop     d0-d7/a0-a6
	MOVE.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0
	MOVE.L	PatternNumber,D0
	LSL.L	#8,D0			;*1024
	LSL.L	#2,D0
	ADD.L	D0,A0
	MOVEQ	#0,D0
	MOVE.W	ScrPattPos,D0		;line position in pattern
	LSL.W	#4,D0			;*16 (4 bytes per track)
	EXT.L	D0
	ADD.L	D0,A0
	move.l	a0,a1
	moveq	#0,d0
	move.w	CmdOffset,d0
	ADD.L	d0,A0			;which command to update
	and.l	#-4,d0
	add.l	d0,a1
	AND.W	D2,(A0)
	ADD.W	D1,(A0)
	MOVEQ	#0,D0
	MOVE.W	ScrPattPos,D0		;this line
	MULU	#8*80,D0		;
	MOVE.W	PattCurPos,D1		;get position on line
	DIVU	#7,D1			;find channel
	MULU	#15,D1			;this many position per channel
	ADD.L	D1,D0
	ADD.W	#194*80+6,D0		;start of pattern
	MOVE.W	D0,TextOffset
	move.l	a1,a0
	jsr	PrintTrackLine
dscend	BSR	EditMoveDown
	CLR.B	RawKeyCode
	RTS

;---- Store/Insert Effect Commands ----

CheckStoreEffect
	tst.w	CtrlKeyStatus
	bne	CheckMenuNumber
	MOVEQ	#0,D0
	MOVE.B	RawKeyCode,D0
	REQ
	CMP.B	#70,D0 			; Del
	BEQ	CheckKeyboard2
	CMP.B	#10,D0
	RHI
	SUBQ.B	#1,D0
	ADD.B	D0,D0
	MOVE.L	D0,D7
	MOVE.W	PattCurPos,D0
	BSR	GetPositionPtr
	MOVE.W	ScrPattPos,D0
	LSL.W	#4,D0
	LEA	0(a0,D0.W),A0
	MOVE.W	2(A0),D0
	AND.W	#$0FFF,D0
	LEA	EffectMacros,A0
	MOVE.W	D0,0(a0,D7.W)
	LEA	CommandStoredText,A0
	JSR	ShowStatusText
	BSR	WaitALittle
	JMP	ShowAllRight

CommandStoredText:
	dc.b 'command stored!',0

CheckInsertEffect:
	CLR.W	InsEfx
	MOVEQ	#0,D0
	MOVE.B	RawKeyCode,D0
	REQ
	CMP.B	#70,D0 ; Del
	BEQ	CheckKeyboard2
	CMP.B	#11,D0 ; -
	BEQ	DecreaseEffect
	CMP.B	#12,D0 ; = (+)
	BEQ.S	IncreaseEffect
	CMP.B	#13,D0 ; \
	BEQ.S	CopyEffect
	CMP.B	#10,D0
	RHI
	SUBQ.B	#1,D0
	ADD.B	D0,D0
	LEA	EffectMacros,A0
	MOVE.W	0(a0,D0.W),InsEfx
DoInsEffect:
	MOVE.B	#70,RawKeyCode	; del
	BRA	CheckNoteKeys

GetLastEffect:
	MOVE.W	PattCurPos,D0
	BSR	GetPositionPtr
	MOVE.W	ScrPattPos,D0
	SUBQ.W	#1,D0
	AND.W	#$3F,D0
	LSL.W	#4,D0
	LEA	0(a0,D0.W),A0
	MOVE.W	2(A0),D0
	AND.W	#$0FFF,D0
	RTS

CopyEffect
	BSR.S	GetLastEffect
	MOVE.W	D0,InsEfx
	BRA.S	DoInsEffect

IncreaseEffect
	BSR.S	GetLastEffect
	MOVE.W	D0,D1
	AND.W	#$0F00,D1
	CMP.W	#$0E00,D1
	BEQ.S	IncECom
	ADDQ.B	#1,D0
	MOVE.W	D0,InsEfx
	BRA.S	DoInsEffect

IncECom	MOVE.W	D0,D1
	ADDQ.B	#1,D1
	AND.B	#$0F,D1
	AND.W	#$0FF0,D0
	OR.B	D1,D0
	MOVE.W	D0,InsEfx
	BRA.S	DoInsEffect

DecreaseEffect
	BSR.S	GetLastEffect
	MOVE.W	D0,D1
	AND.W	#$0F00,D1
	CMP.W	#$0E00,D1
	BEQ.S	DecECom
	SUBQ.B	#1,D0
	MOVE.W	D0,InsEfx
	BRA	DoInsEffect

DecECom	MOVE.W	D0,D1
	SUBQ.B	#1,D1
	AND.B	#$0F,D1
	AND.W	#$0FF0,D0
	OR.B	D1,D0
	MOVE.W	D0,InsEfx
	BRA	DoInsEffect
	cnop	0,4
InsEfx	dc.w 0

;---- Check Keyboard for notekeys ----

CheckKeyboard
	TST.B	RawKeyCode
	REQ
	TST.W	LeftAmigaStatus
	RNE
	TST.W	CtrlKeyStatus
	RNE
	TST.W	ShiftKeyStatus
	BNE	CheckStoreEffect
	TST.W	AltKeyStatus
	BNE	CheckInsertEffect
CheckKeyboard2
	MOVE.W	PattCurPos,D0
	BEQ.S	CheckNoteKeys	; 0=NoteKey
	CMP.W	#7,D0		; 6 ''
	BEQ.S	CheckNoteKeys
	CMP.W	#7*2,D0		; 12 ''
	BEQ.S	CheckNoteKeys
	CMP.W	#7*3,D0		; 18 ''
	BEQ.S	CheckNoteKeys
	TST.L	EditMode
	BNE	EditCommand	; Otherwise it's a number
	RTS
CheckMenuNumber
	move.b	RawKeyCode,d0
	beq.s	.end
	cmp.b	#7,d0
	bhi.s	.end
	cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.end
	bsr	ClearKeyBuf
	cmp.b	#1,d0
	beq	ShowSubMenu1
	cmp.b	#2,d0
	beq	ShowSubMenu2
	cmp.b	#3,d0
	beq	ShowSubMenu3
	cmp.b	#4,d0
	beq	ShowSubMenu4
	cmp.b	#5,d0
	beq	ShowSubMenu5
	cmp.b	#6,d0
	beq	ShowSubMenu6
	cmp.b	#7,d0
	beq	ShowSubMenu7
.end	rts

CheckNoteKeys
	LEA	RawKeyScaleTable,A0
	MOVE.B	RawKeyCode,D1
	MOVEQ	#38,D0
cnkloop	CMP.B	0(A0,D0.W),D1
	BEQ.S	NoteKeyPressed
	DBRA	D0,cnkloop
	RTS

NoteKeyPressed
	tst.b	KeyRepeat
	bne.s	.cnt
	move.w	#-1,RastCont		; no key repeat
.cnt	MOVE.L	KeyTransTabPtr,A1
	MOVE.B	0(a1,D0.W),D0
	CMP.W	#36,D0              ; 3*12 notes ?
	BHS.S	nkpskip
	MOVE.L	SplitAddress,D1
	BEQ.S	nkpskip
	CLR.L	SplitAddress
	MOVE.L	D1,A0
	MOVE.B	D0,(A0)
	MOVE.W	SamNoteType,D1
	BEQ	ShowSplit
	CLR.W	SamNoteType
	AND.W	#$FF,D0
	MOVE.W	D0,(A0)
	CMP.W	#1,D1
	BEQ.S	loclab1
	CMP.W	#3,D1
	BEQ	ShowS2TuneNote
	CMP.W	#4,D1
	JEQ	ShowAllRight
	JMP	ShowResamNote
loclab1	JMP	ShowSamNote
nkpskip	MOVE.W	InsNum,PlayInsNum
	btst	#4,EditBitFlags+3	;SplitFlag
	BEQ.S	nkpskip2
	LEA	SplitInstrTable,A1
	MOVE.B	0(a1,D0.W),D1
	BEQ.S	nkpskip3
	MOVE.B	D1,PlayInsNum+1
nkpskip3
	LEA	SplitTransTable,A1
	MOVE.B	0(a1,D0.W),D0
nkpskip2
	MOVEQ	#0,D2
playtheinstr
	LEA	PeriodTable,A1 		; note in d0 here
	MOVE.L	D0,D4
	LSL.W	#1,D0
	MOVEQ	#0,D3
	MOVE.W	0(a1,D0.W),D3

	MOVE.L	SongDataPtr,A0 		; This fixes finetune...
	LEA	14(A0),A0
	MOVE.W	InsNum,D1
	BNE.S	nkpskipit
	MOVE.W	LastInsNum,D1
nkpskipit
	MULU	#INSTR_SIZEOF,D1
	ADD.L	D1,A0
	MOVEQ	#0,D1
	MOVE.B	(A0),D1 		; get finetune
	and.b	#$f,d1		; masking! -maw-
	MULU	#FINETUNETABLE_SIZE,D1
	ADD.L	D1,A1
	MOVE.W	0(a1,D0.W),CurrentPlayNote
	TST.L	D2
	BEQ.S	nkpnrml
	CMP.B	#2,pnoteflag
	BNE	antpskip

nkpnrml	TST.L	EditMode
	BEQ	antpskip
AddNoteToPattern
	push    d0-d7/a0-a6
	bsr	ClearPatBlock
	pop     d0-d7/a0-a6
	MOVE.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0	; Find first pattern
	MOVE.L	PatternNumber,D0
	LSL.L	#8,D0
	LSL.L	#2,D0
	ADD.L	D0,A0			; Find current pattern
	MOVEQ	#0,D0
	MOVE.W	ScrPattPos,D0
	BSR	QuantizeCheck
	LSL.W	#4,D0
	EXT.L	D0
	ADD.L	D0,A0			; Find current pos
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	LSL.W	#2,D0			;*8
	EXT.L	D0
	ADD.L	D0,A0			; Find current channel
	TST.W	AltKeyStatus
	BEQ.S	antpsks
	AND.L	#$FFFFF000,(A0)
	MOVE.W	InsEfx,D0
	OR.W	D0,2(A0)
	BRA.S	antp3
antpsks	TST.W	ShiftKeyStatus
	BEQ.S	antpskip2
	CLR.L	(A0)
antpskip2
	MOVE.W	D3,(A0)			; Put note into pattern
	BEQ.S	antp2
	TST.B	AutoInsFlag
	BEQ.S	antp4
	MOVE.W	VolumeEfx,2(A0)
antp4	MOVEQ	#0,D0
	MOVE.W	PlayInsNum,D0
	LSL.W	#4,D0
	AND.B	#$F,2(A0)
	ADD.B	D0,2(A0)
	LSL.W	#4,D0
	AND.W	#$F000,D0
	OR.W	D0,(A0)
	BRA.S	antp3

antp2	AND.W	#$0FFF,2(A0)
antp3	MOVE.W	2(A0),CurrCmds
	MOVEQ	#0,D0
	MOVE.W	ScrPattPos,D0
	BSR	QuantizeCheck
	MULU	#8*80,D0
	MOVEQ	#0,D1
	MOVE.W	PattCurPos,D1
	DIVU	#7,D1
	MULU	#15,D1
	ADD.L	D1,D0
	ADD.W	#194*80+6,D0
	MOVE.W	D0,TextOffset
	jsr	PrintTrackLine
	BSR	EditMoveDown
antpskip
	TST.W	DidQuantize
	BNE.S	testmul
	TST.W	CurrentPlayNote	; playnote only if not zero
	BNE	PlayNote
testmul	TST.B	MultiFlag
	REQ
GotoNextMulti
	MOVEQ	#0,D0
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0			;get channel number
	LEA	MultiModeNext,A0
	move.b	0(a0,D0.W),d0
	SUBQ.W	#1,D0
	AND.W	#3,D0
	MULU	#7,D0
	MOVE.W	D0,PattCurPos
	BRA	UpdateCursorPos

QuantizeCheck
	TST.L	RunMode
	BEQ.S	qcend
	MOVEQ	#0,D1
	MOVE.B	QuantizeValue,D1
	BEQ.S	qcend
	CMP.W	#1,D1
	BEQ.S	QuanOne
	MOVE.W	#1,DidQuantize
	MOVE.L	D1,D2
	LSR.W	#1,D2
	ADD.W	D0,D2
	AND.W	#$003F,D2
	DIVU	D1,D2
	MULU	D1,D2
	CMP.W	D0,D2
	BHI.S	qcskip
	CLR.W	DidQuantize
qcskip	MOVE.W	D2,D0
	RTS

QuanOne	MOVE.L	CurrSpeed,D1
	LSR.L	#1,D1
	CMP.L	Counter,D1
	BLS.S	QuantToNextNote
qcend	CLR.W	DidQuantize
	RTS	
 
QuantToNextNote
	ADDQ.W	#1,D0
	AND.W	#$003F,D0
	MOVE.W	#1,DidQuantize
	RTS
;----------------------------------
PlayNote:
	move.w  PlayInsNum,d0	; Check for sample 0
	bne.s	.plok
	move.w	InsNum,d0	; check Insnum then
	beq.s	DoPlayNote	; If Insnum zero, never do dyn!
.plok:	bsr	CheckDynFlag
	sne	d1		; d1 = true, if dyn

	moveq	#3*7,d7         ; position of cursor
	moveq	#3,d0		; channel
	lea	audchan4temp,a4	; the temporary sample data
	LEA	$DFF0D0,A5      ; aud3
.whatc:	cmp.w	PattCurPos,d7
	beq.s	.play
	subq.w	#7,d7
	lea	-n_SIZEOF(a4),a4	; size of audchanXtemp
	lea	-AUDOFS(a5),a5
	subq.w	#1,d0
        bge.s	.whatc
	rts                     ; just return if not on proper position
;------
.play:	tst.b	d1	; dyn flag
	beq.s	DoPlayNote

	move.w	InsNum,d1
  	move.w	#$4000,_custom+intena	; DO NOT DISTURB ME HERE!
	bsr	PrepareDynPartTab     ; does not destroy d0/a4
	bra	DoPlayDynNote

;-----------
DoPlayNote:
; If called from "play range" or "play display", PlayInsNum is zero!!!
; MOVE.L	A5,NoteAddr   	; seems as if nobody needs that!!!!

  	move.w	#$4000,_custom+intena	; DO NOT DISTURB ME HERE!

	LEA	SampleInfo,A6
	MOVE.W	PlayInsNum,D0
	BEQ.s	dpnplay		
	add.w	d0,d0
	add.w	d0,d0
	LEA	SamplePtrs,A0
	MOVE.L	0(A0,D0.W),si_pointer2	; Who the hell needs that?
	LEA	SampleInfo2,A6		; if playnum <>0, we use SampleInfo2
	MOVE.L	SongDataPtr,A0
	LEA	-10(A0),A0              ; the -10 could be in the command itself below now
	MOVE.W	PlayInsNum,D0
	MOVE.B	D0,PlayInsNum2
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	MOVE.L	22(A0),SampleInfo2
	MOVE.L	26(A0),si_long2
dpnplay	MOVE.B	PlayInsNum2,n_samplenum(A4)
;----------------
	move.w	6(a6),d2		; replen
	move.w	d2,n_replen(a4)
; set length:
	move.w	4(a6),D0 		; repeat offset ("loop start")
	moveq	#0,d1
	move.w	d0,d1
	bne.s	.repnz
	move.w	(a6),d0  		; use length if repeat is zero
	bra.s	.repz
.repnz	add.w	d2,d0 			; add replen
.repz	
	move.w	d0,n_length(A4)         ; n_length
	bne.s	.nolz
	move.w	#1,n_length(A4)         ; if length is 1, then sample is empty or invalid
	lea	Silence,a0   		; use silence then!	
	move.l	a0,n_start(a4)
	move.l	a0,n_loopstart(a4)
	bra.s	.silence_goon
.nolz:	
	add.l	d1,d1			; repeat*2
	move.l	8(a6),d0		; startptr
	add.l	d0,d1 			; + startptr
	move.l	d1,n_loopstart(a4)      ; pointer to loopstart

	add.l	StartOfs,d0             ; StartOfs of "PlayRange"
	move.l	d0,n_start(A4)          ; sample start + startofs

.silence_goon:
	clr.l	StartOfs		; we dont need it anymore

	MOVEQ	#0,D1
	MOVE.B	3(A6),D1   		; instrument volume
	MOVE.B	D1,n_volume(A4)		; n_volume
	MOVE.W	CurrentPlayNote,n_period(A4)
;-------
	st	n_normalsmp(a4)		; flag to set sample via interrupt
	clr.w	n_intcnt(a4)            ; clr the interrupt counter
	sf	n_dynflag(a4)		; this is not DYN
;-------
	lea	temp_AptrAlen,a0	; temporary buffer for AUDPTR.l,AUDLEN.w
	move.l	n_start(a4),(a0)+       ; set pointer
	move.w	n_length(a4),(a0)+	; Set length
	subq.w	#6,a0	
	bsr.s	StartSample             ; magic waitless sample start
	st	n_trigger(A4)
	bra	testmul

;------------------
; MAGIC WAITLESS SAMPLE START HERE
; INPUT: a0 = ptr to array with AUDPTR and AUDLEN in it (see temp_AprtAlen)
StartSample:
	lea	_custom,a6
	btst	#2,ScrnBitFlags+3       ; testcol on?
	beq.w	.notestcol
	;move.w	PlayTestColor,COLOR00(a6)	
.notestcol:
	btst	#4,MiscBitFlags+3	; use dmaconr?
	beq.s	.AUDDAT_version
.dmaconr_version:
	move.w	dmaconr(a6),d0		; read dmacon
	move.w	n_channel(a4),d1
	btst	d1,d0
	bne.s	.dma_was_on

	move.w	n_IntenaOff(a4),intena(a6)	; only forbid Interrupts
	move.w	n_IntenaOff(a4),intreq(a6)      ; first clear intreq
	move.w	#1,AUDPER(a5)                   ; max. dma cycle speed
	move.l	(a0)+,AUDPTR(A5)          	; set pointer
	move.w	(a0),AUDLEN(A5)			; Set length
	move.w	#0,AUDDAT(a5)			; force interrupts to come again	bra.s	.both_versions
	bra.s	.exit
.dma_was_on:
	move.w	n_IntenaOff(a4),intena(a6)	; forbid Interrupts
	move.w	n_IntenaOff(a4),intreq(a6)      ; first clear intreq
	move.w	n_DmaOff(A4),dmacon(a6)		; dma off
	move.w	#1,AUDPER(a5)                   ; max. dma cycle speed
	bra.s	.both_versions
.AUDDAT_version:
	move.w	n_IntenaOff(a4),intena(a6)	; forbid Interrupts
	MOVE.W	n_DmaOff(A4),dmacon(a6)		; dma off
	move.w	n_IntenaOff(a4),intreq(a6)      ; first clear intreq ; TEST
; question: dma off first or intreq clear first ??	

	move.w	#1,AUDPER(a5)                   ; max. dma cycle speed
	move.w	#0,AUDDAT(a5)			; always force interrupts to come again
.both_versions:
	move.l	(a0)+,AUDPTR(A5)          	; set pointer
	move.w	(a0),AUDLEN(A5)			; Set length
	move.w	#0,AUDVOL(a5)			; silenty first
.exit:
	move.w	#$C000,intena(a6)		; OK, OTHER INTERRUPTS ALLOWED AGAIN
        move.w	n_IntenaOn(a4),intena(a6)	; allow audio interrupts
	rts

;-------
	cnop	0,4
PlayInsNum2	dc.w 0

temp_AptrAlen: dc.w 0,0,0	; 6 bytes: AUDPTR,AUDLEN

_Wait1line:	move.l	d0,-(sp)	;d1 = vsync counters to wait - 1
.wl0:		move.b	$dff007,d0
.wl1:		cmp.b	$dff007,d0
		beq.s	.wl1
		dbf	d1,.wl0
		move.l	(sp)+,d0
		rts


; ******* DYN stuff -maw- ***************************************

DynMAXPART 	= 100	; this should be sufficient (100 parts)
DynPartTabSIZE 	= 8*DynMAXPART	; 8 bytes per part

;----- some hardware specs (what? still no includes? ;-)
;_custom	= $dff000
intenar     EQU   $01C
;intreqr     EQU   $01E
;dmacon	    EQU   $096
;intena	    EQU   $09A
;intreq	    EQU   $09C
AUD0	    EQU   $A0
COLOR00 equ $180
AUDPTR	= 0
AUDLEN	= 4
AUDVOL	= 8
AUDPER	= 6
AUDDAT	= $A
AUDOFS	= $10

INTB_AUD3      EQU   (10)  ; Audio channel 3 block finished
INTB_AUD2      EQU   (9)   ; Audio channel 2 block finished
INTB_AUD1      EQU   (8)   ; Audio channel 1 block finished
INTB_AUD0      EQU   (7)   ; Audio channel 0 block finished
INTB_BLIT      EQU   (6)   ;Blitter finished
INTB_VERTB     EQU   (5)   ;start of Vertical Blank
INTB_COPER     EQU   (4)   ;Coprocessor
INTB_PORTS     EQU   (3)   ;I/O Ports and timers
INTB_SOFTINT   EQU   (2)   ;software interrupt request
INTB_DSKBLK    EQU   (1)   ;Disk Block done
INTB_TBE       EQU   (0)   ;serial port Transmit Buffer Empty

NT_INTERRUPT	EQU 2


;-------------- dyn routines -------------------------------
InitAudChan: ; this has to be done only once

	lea 	DynPartPtrs,a1	; pointers to channel PartTabs
	lea	AudChanPtrs,a0	; pointers to the channel structures

	move.l	(a0)+,a2
	move.w	#$1,n_DmaOff(a2)	; this is just the same
	move.w	#$8001,n_DmaOn(a2)
	move.w	#$80,n_IntenaOff(a2)
	move.w	#$8080,n_IntenaOn(a2)
	move.l	(a1)+,n_PartTabAdr(a2)
	move.w	#0,n_channel(a2)	; looks stupid, but isnt

	move.l	(a0)+,a2
	move.w	#$2,n_DmaOff(A2)
	move.w	#$8002,n_DmaOn(a2)
	move.w	#$100,n_IntenaOff(a2)
	move.w	#$8100,n_IntenaOn(a2)
	move.l	(a1)+,n_PartTabAdr(a2)
	move.w	#1,n_channel(a2)	

	move.l	(a0)+,a2
	move.w	  #$4,n_DmaOff(A2)
	move.w #$8004,n_DmaOn(a2)
	move.w	#$200,n_IntenaOff(A2)
	move.w #$8200,n_IntenaOn(a2)
	move.l	(a1)+,n_PartTabAdr(A2)
	move.w	   #2,n_channel(a2)	

	move.l	(a0)+,a2
	move.w	  #$8,n_DmaOff(A2)
	move.w #$8008,n_DmaOn(a2)
	move.w	#$400,n_IntenaOff(A2)
	move.w #$8400,n_IntenaOn(a2)
	move.l	(a1)+,n_PartTabAdr(A2)
	move.w	   #3,n_channel(a2)	

	rts
;-------------
SetTestColors:
	movem.l	a0/a2,-(sp)
	move.w	#$0808,CiaintTestColor	; cyan
	move.w	#$0228,PlayTestColor    ; blue
	move.w	#$0a60,SoftintTestColor ; orange

	lea	AudChanPtrs,a0	; pointers to the channel structures
	move.l	(a0)+,a2
	move.w	#$666,n_DynTestColor(a2)	; white
	move.w	#$FFF,n_DynLoopColor(a2)	; grey
	move.l	(a0)+,a2
	move.w	#$660,n_DynTestColor(a2)	; yellow
	move.w	#$FF0,n_DynLoopColor(a2)	; dark yellow
	move.l	(a0)+,a2
	move.w	#$600,n_DynTestColor(a2)	; red
	move.w	#$F00,n_DynLoopColor(a2)	; dark red
	move.l	(a0)+,a2
	move.w	#$070,n_DynTestColor(A2)	; green
	move.w	#$0B0,n_DynTestColor(A2)	; dark green
	movem.l	(sp)+,a0/a2
	rts
;-----------
ClrTestColors:
	movem.l	d0/a0/a2,-(sp)
	lea	AudChanPtrs,a0	; pointers to the channel structures
	move.w	ColorTable,d0	; Color 0 of color pallet
	move.l	(a0)+,a2
	move.w	d0,n_DynTestColor(a2)	; white
	move.w	d0,n_DynLoopColor(a2)	; grey
	move.l	(a0)+,a2
	move.w	d0,n_DynTestColor(a2)	; yellow
	move.w	d0,n_DynLoopColor(a2)	; dark yellow
	move.l	(a0)+,a2
	move.w	d0,n_DynTestColor(a2)	; red
	move.w	d0,n_DynLoopColor(a2)	; dark red
	move.l	(a0)+,a2
	move.w	d0,n_DynTestColor(A2)	; green
	move.w	d0,n_DynTestColor(A2)	; dark green
	movem.l	(sp)+,d0/a0/a2
        rts
;------
PrepareDynPartTab:
; input: d0.w = channel number (0..3)
;        d1.w = sample number
; Routine does not destroy any registers
	movem.l	d0/d1/d6/d7/a0-a3,-(sp)

	lea 	DynPartPtrs,a3	; get address of channel's PartTab
	add.w	d0,d0
	add.w	d0,d0
	move.l	0(a3,d0.w),a3		

	move.w	d1,D0		; sample number
;	beq	.endmarker	; if no sample, set only endmarker!

	bne.s	.goon		; TEST TEST
	;move.w	#$F00,$dff180
	bra	.endmarker
.goon:

	add.w	d0,d0
	add.w	d0,d0		; 4 bytes each
	lea	SamplePtrs,A0
	move.l	0(A0,D0.W),a1	; sample start address
	add.w	d0,d0           ; 8 bytes, adress.L,size.L
	lea	DynMemPtrTable,a0
	move.l	0(a0,d0.w),a2	; dyntable start adress
	moveq	#0,d0		; reset part counter
	move.w	(a2)+,d7	; get number of parts
	move.w	(A2)+,d6	; get number of loop part
;---
.enter:	move.l	a1,(a3)+	; enter part address
	move.w	(a2)+,d1        ; get part length (in words!!)
	move.w	d1,(a3)+	; enter part length
	move.w	(a2)+,(a3)+	; enter part volume
	add.w	d1,d1		; watch! Hardware lengths here!
	add.w	d1,a1		; set next part address
	addq.w	#1,d0		; inc. part counter
	cmp.w	d6,d0		; was this the loop part?
	bne.s	.notlp          ; no it wasn't
	move.l	a3,a0		; remember ptr(!) adress of this part in a0
.notlp: cmp.w	d7,d0		; all parts done?
	blt.s	.enter          ; no, then go on
;---
	tst.w	d6		; did we have a loop part number
	beq.s	.endmarker      ; if not, set end marker and rts
	move.l	a3,a1
	addq.w	#4,a1		; we will check after (a0)+ in the interrupt
	sub.l	a1,a0           ; get offset from the ptr to loop part
	move.l	a0,(a3)+	; put this (negative) offset
.endmarker:	
	clr.l	(a3)+		; end marker = zero
	movem.l	(sp)+,d0/d1/d6/d7/a0-a3
	rts
;----------------------------------
DoPlayDynNote
	lea	SampleInfo,A6
	move.w	PlayInsNum,D0	; if 0, PlayInsNum2 is used
	beq	.ins0

	lea	SampleInfo2,A6		; We use SampleInfo2, if PlayInsNum<>0
	add.w	d0,d0
	add.w	d0,d0	
	lea	SamplePtrs,A0
	move.l	0(A0,D0.W),si_pointer2	; sample start adress

	move.w	PlayInsNum,D0		; set playinsnum2 to playinsnum
	MOVE.B	D0,PlayInsNum2
	MOVE.L	SongDataPtr,A0
	LEA	-10(A0),A0	; what *is* on-10 of songptr?
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	MOVE.L	22(A0),SampleInfo2
	MOVE.L	26(A0),si_long2

.ins0	MOVE.B	PlayInsNum2,n_samplenum(A4)

;--- fill variables for "red line"
; since DYN does the looping by interrupts, we can do it all right here
	moveq	#0,d1
	move.w	6(a6),d2		; replen
	move.w	d2,n_replen(a4)
	move.w	4(a6),D0 		; repeat
	move.w	d0,d1
	bne.s	.repnz
	MOVE.W	(A6),D0  		; length
	BRA.S	.dpn3
.repnz	ADD.W	d2,D0 			; add replen
.dpn3	
	MOVE.W	D0,n_length(A4)         ; n_length
	BNE.S	.nolz
	MOVE.W	#1,n_length(A4)         ; n_length	
.nolz:		
	ADD.L	D1,D1			; repeat*2
	move.l	8(a6),d0		; startptr
	ADD.L	d0,D1 			; + startptr
	MOVE.L	D1,n_loopstart(a4)


;------ here the offset stuff---------------------------

	move.l	n_PartTabAdr(a4),a0	; get start of dyn parts
	move.l	a0,n_DynPtrPre(a4)	; Put it in Hidden dynptr

	MOVE.L	d0,D1			; sample start
	move.l	StartOfs,d2             ; StartOfs of "PlayRange"
	add.l	d2,D1             	
	move.l	d1,n_start(A4)          ; sample start + startofs
	clr.l	StartOfs		; we dont need it anymore

	tst.w	PlayInsNum	; no offset fumbling if
	bne	.no_startofs	; it is "play waveform" or "key play"
	tst.l	d2		; if no offset
	beq	.checklen         check for length only

; Since the dyn sample play is based on an array of pointers,
; this means a bit more fumbling to realize "play range".
; We have to patch the part table, namely the part where the range starts
; and the length of the part where the range ends.
; The actual dyn pointer is set to patched start part.

.scanptr:
	move.l	(a0),d0     	; security check
	beq	.found    	; exit if last part encounterd
	cmp.l	d0,d1		; search for part adress > offset
	blt.s	.found
	addq.w	#8,a0		; skip to next entry
	bra.s	.scanptr

.found:	subq.w  #8,a0		; go back to previous part
	moveq	#0,d0
	move.l	(a0),d0		; get old part adress
	sub.l	d1,d0		; minus new part start -> negative
	neg.l	d0		; positive now
	lsr.l	#1,d0		; since partlens are hardware lengths
	sub.w	d0,4(a0)	; sub from partlen -> partlen is corrected ;-)
	move.l	d1,(a0)		; enter this adress in the table
	move.l	a0,n_DynPtrPre(a4)	; patch the start ptr

.checklen:
	move.w	n_length(a4),d1	; now we gotta patch the lengths
	moveq	#0,d2
.scend:	tst.l	(a0)		; security check, just in case we fail
	beq.s	.ofsfail
	move.w	4(a0),d0	; get partlength
	add.w	d0,d2		; add it to current sum
	cmp.w	d1,d2		; are we over it?
	bhs.s	.endfnd
	addq	#8,a0		; if not, take next part information
	bra.s	.scend
.endfnd: ; here we found the end
	sub.w	d1,d2		; d2 is now difference: shall-is
	sub.w	d2,d0	
	move.w	d0,4(a0)	; patch this length
	clr.l	8(a0)		; set endmarker
.ofsfail:                       ; fail here
.no_startofs:	

;---------------------------------
  	move.w	#$4000,_custom+intena	; DO NOT DISTURB ME HERE!

	MOVEQ	#0,D1
	MOVE.B	3(A6),D1   		; instrument volume
	MOVE.B	D1,n_volume(A4)         ; store n_volume
	mulu	n_relvol(a4),d1		; "overall" volume
	add.w	#32,d1
	lsr.w	#6,d1
	move.w	d1,n_DynPlayVol(a4)	; this is our playvolume then

	MOVE.W	CurrentPlayNote,n_period(A4)

; note: first part volume will be set in first interrupt anyway!	
	sf	n_normalsmp(a4)			; flag to set sample via interrupt
	clr.w	n_intcnt(a4)                    ; clr the interrupt counter
	st	n_dynflag(a4)			; this _is_ DYN
	move.l	n_DynPtrPre(a4),a0
	move.l	a0,n_DynPtr(a4)         ; set Ptr ready for first interrupt
	bsr	StartSample		; magic waitless sample start
	st	n_trigger(A4)
	bra	testmul

;******** end of DYN stuff -maw- *************************************


;---- Check Cursor Arrow Keys ----

ArrowKeys
	TST.W	SamScrEnable
	RNE
	CMP.B	#4,EnterTextFlag
	REQ
	move.b	LastRawkey,d0
	and.b	#$80,d0
	beq.s	.cnt
	clr.b	KeyStruck
.cnt	MOVE.B	KeyStruck,D0
	beq	arkeskip
	TST.W	GetLineFlag
	BNE.S	arkeskip
	TST.W	ShiftKeyStatus
	BNE.S	arkeskip
	TST.W	AltKeyStatus
	BNE.S	arkeskip
	TST.W	CtrlKeyStatus
	BNE.S	arkeskip
	CMP.B	#78,D0
	BEQ	RightArrow
	CMP.B	#79,D0
	BEQ	LeftArrow
arkeskip
	CMP.B	#76,D0
	BEQ.S	UpArrow
	CMP.B	#77,D0
	BEQ	DownArrow
	CLR.W	ArrowPressed
	clr.w	ArrowRepCounter
	RTS	
	cnop	0,4
ArrowPressed	dc.w	0
ArrowRepCounter	dc.w	0

UpArrow	TST.L	RunMode
	RNE
	cmp.w	#DirScreen_ID,CurrScreen
	REQ
	TST.W	ArrowPressed
	BEQ.S	MoveOneUp
	ADDQ.W	#1,ArrowRepCounter
	TST.W	AltKeyStatus
	BNE.S	AltUpArrow
	TST.W	ShiftKeyStatus
	BNE.S	ShiftUpArrow
	CMP.W	#6,ArrowRepCounter
	BPL.S	MoveOneUp
	RTS

ShiftUpArrow
	CMP.W	#3,ArrowRepCounter
	BPL.S	MoveOneUp
	RTS

AltUpArrow:
	CMP.W	#1,ArrowRepCounter
	BPL.S	MoveOneUp
	RTS

MoveOneUp:
	CLR.W	ArrowRepCounter
	MOVE.W	#$FFFF,ArrowPressed
	CMP.L	#'patt',RunMode
	REQ
	SUBQ.W	#1,ScrPattPos
	AND.W	#$003F,ScrPattPos
	BRA	SetScrPatternPos

DownArrow:
	TST.L	RunMode
	RNE
	cmp.w	#DirScreen_ID,CurrScreen
	REQ
	TST.W	ArrowPressed
	BEQ.S	MoveOneDown
	ADDQ.W	#1,ArrowRepCounter
	TST.W	AltKeyStatus
	BNE.S	AltDownArrow
	TST.W	ShiftKeyStatus
	BNE.S	ShiftDownArrow
	CMP.W	#6,ArrowRepCounter
	BPL.S	MoveOneDown
	RTS

ShiftDownArrow:
	CMP.W	#3,ArrowRepCounter
	BPL.S	MoveOneDown
	RTS
 
AltDownArrow:
	CMP.W	#1,ArrowRepCounter
	BPL.S	MoveOneDown
	RTS	
 
MoveOneDown:
	CLR.W	ArrowRepCounter
	MOVE.W	#$FFFF,ArrowPressed
	TST.L	RunMode
	RNE
	ADDQ.W	#1,ScrPattPos
	AND.W	#$003F,ScrPattPos
	BRA	SetScrPatternPos

EditMoveDown:
	TST.L	RunMode
	RNE
	tst.b	DownRightFlag
	bne.s	MoveOneRight
	MOVE.W	EditMoveAdd,D0
	ADD.W	D0,ScrPattPos
	AND.W	#$003F,ScrPattPos
	BRA	SetScrPatternPos

EditMoveAdd:dc.w 1

RightArrow:
	TST.W	ArrowPressed
	BEQ.S	MoveOneRight
	ADDQ.W	#1,ArrowRepCounter
	CMP.W	#6,ArrowRepCounter
	BPL.S	MoveOneRight
	RTS	
 
MoveOneRight:
	CLR.W	ArrowRepCounter
	MOVE.W	#$FFFF,ArrowPressed
	ADDQ.W	#1,PattCurPos
	CMP.W	#28,PattCurPos
	BMI.S	.skip
	CLR.W	PattCurPos
.skip	BRA.S	UpdateCursorPos
 
LeftArrow:
	TST.W	ArrowPressed
	BEQ.S	MoveOneLeft
	ADDQ.W	#1,ArrowRepCounter
	CMP.W	#6,ArrowRepCounter
	BPL.S	MoveOneLeft
	RTS	
 
MoveOneLeft:
	CLR.W	ArrowRepCounter
	MOVE.W	#$FFFF,ArrowPressed
	SUBQ.W	#1,PattCurPos
	TST.W	PattCurPos
	BPL	UpdateCursorPos
	MOVE.W	#27,PattCurPos
UpdateCursorPos:
	TST.W	SamScrEnable
	RNE
	MOVE.W	PattCurPos,D0
	LEA	CursorPosTable,A0
	MOVE.B	(A0,D0.W),D0
	move.w	d0,d1
	lsl.w	#2,d0
	lsl.w	#1,d1
	add.w	d1,d0		; *12/2
	ADD.W	#8,D0
	MOVE.W	#$c5,D1
	MOVEQ	#9,D2 			; number of lines
	move.l	CursorPosPtr,A0
	JMP	SetSpritePos

ArrowKeys2:
	MOVE.B	RawKeyCode,D0
	REQ
	CMP.B	#76,D0
	BEQ.S	UpArrow2
	CMP.B	#77,D0
	BEQ.S	DownArrow2
	CMP.B	#79,D0
	BEQ.W	LeftArrow2
	CMP.B	#78,D0
	BEQ	RightArrow2
	RTS

UpArrow2:
	cmp.w	#DirScreen_ID,CurrScreen
	BEQ	FileNameOneUp
	rts

DownArrow2:
	cmp.w	#DirScreen_ID,CurrScreen
	JEQ	FileNameOneDown

LeftArrow2:
	TST.W	ShiftKeyStatus
	BNE	PositionDown
	TST.W	AltKeyStatus
	BNE	PatternOneDown
	TST.W	CtrlKeyStatus
	BNE	SampleNumDown
	RTS

RightArrow2:
	TST.W	ShiftKeyStatus
	BNE	PositionUp
	TST.W	AltKeyStatus
	BNE	PatternOneUp
	TST.W	CtrlKeyStatus
	BNE	SampleNumUp
	RTS

;---- Update Line Cursor Position ----

UpdateLineCurPos:
	MOVE.W	LineCurX,D0
	lsr.w	#1,d0			;medres, remember?
	MOVE.W	LineCurY,D1
	SUBQ.W	#1,D0
	MOVEQ	#2,D2
	LEA	LineCurSpriteData,A0
	JMP	SetSpritePos

;---- Check Gadgets ----

CheckGadgets:
	BSR.S	CheckGadgets2
	CLR.W	notogfl
.loop	bsr	CheckNTSCPos
	movem.l d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOWaitTOF(a6)
	movem.l (sp)+,d0-d7/a0-a6
	subq.w	#1,.cntr
	bmi.s	.repeat
	BTST	#6,$BFE001
	BEQ.S	.loop
.exit	move.w	#$14,.cntr		; this is the button RepDelay
	CLR.W	UpOrDown
	BRA	MainLoop
.repeat	move.w	#1,.cntr		; this is the button RepSpeed
	BTST	#6,$BFE001
	BEQ.S	CheckGadgets
	bra.s	.exit
	cnop	0,4
.cntr	dc.w	$14	; RepDelay
 
CheckGadgets2:
	MOVE.W	MouseX,MouseX2
	MOVE.W	MouseY,MouseY2
	MOVE.W	MouseX2,D0
	MOVE.W	MouseY2,D1

;************ Her kommer det en bsr.w ExeGadget inn etterhvert *************

	CMP.W	#121,D1
	BHS	WantedPattGadg
	cmp.w	#DirScreen_ID,CurrScreen
	BEQ	CheckDirGadgets
	cmp.w	#SetupScreen1_ID,CurrScreen
	BEQ	CheckSetupGadgs
	cmp.w	#MainScreen_ID,CurrScreen
	BEQ	CheckMainScreenGadgs
	rts

CheckMainScreenGadgs:
	MOVEM.W	MouseX2,D0/D1
	lea	MainGadgetList,a0
	jsr	GetGadget
	tst.w	d2
	REQ

	cmp.w	#1,d2
	beq	AskQuit
	cmp.w	#2,d2
	beq	ScreenToBack

	cmp.w	#3,d2
	beq	TypeInSongName

	cmp.w	#4,d2
	beq	MastVolumeUp
	cmp.w	#5,d2
	beq	MastVolumeDown
	cmp.w	#6,d2
	JEQ	DoVolumeDragBar

	cmp.w	#7,d2
	beq	PosInsert
	cmp.w	#8,d2
	beq	PosDelete

	cmp.w	#9,d2
	beq	EnterPosGadg
	cmp.w	#10,d2
	beq	EnterPattGadg
	cmp.w	#11,d2
	beq	EnterLenGadg

	cmp.w	#20,d2
	beq	PlaySong
	cmp.w	#21,d2
	beq	StopIt
	cmp.w	#22,d2
	beq	Continue

	cmp.w	#23,d2
	beq	PlayPattern
	cmp.w	#24,d2
	beq	RecordPattern
	cmp.w	#25,d2
	beq	Edit

	cmp.w	#26,d2
	beq	ClearAll
	cmp.w	#27,d2
	beq	Setup
	cmp.w	#28,d2
	beq	ShowDirScreen

	cmp.w	#29,d2
	beq	TypeInSampleName

	;cmp.w	#48,d2
	;beq	LoadNamedSample
	cmp.w	#49,d2
	beq	KillSample
	cmp.w	#50,d2
	JEQ	SamplerScreen

	cmp.w	#51,d2
	beq	ToggleCh1
	cmp.w	#52,d2
	beq	ToggleCh2
	cmp.w	#53,d2
	beq	ToggleCh3
	cmp.w	#54,d2
	beq	ToggleCh4

	cmp.w	#60,d2
	beq	SubMenuPressed
	cmp.w	#61,d2
	beq	ShowSubMenu1
	cmp.w	#62,d2
	beq	ShowSubMenu2
	cmp.w	#63,d2
	beq	ShowSubMenu3
	cmp.w	#64,d2
	beq	ShowSubMenu4
	cmp.w	#65,d2
	beq	ShowSubMenu5
	cmp.w	#66,d2
	beq	ShowSubMenu6
	cmp.w	#67,d2
	beq	ShowSubMenu7

	MOVE.W	#1,UpdateFreeMem

	;cmp.w	#42,d2
	;beq	EnterSampleNum
	;cmp.w	#43,d2
	;beq	EnterVolume
	;cmp.w	#44,d2
	;beq	EnterFineTune
	cmp.w	#45,d2
	beq	EnterSampleLength
	cmp.w	#46,d2
	beq	EnterRepeat
	cmp.w	#47,d2
	beq	EnterRepLen

	MOVE.W	#-1,UpOrDown	; Down
	cmp.w	#15,d2
	beq	PositionGadg
	cmp.w	#17,d2
	beq	PatternGadg
	cmp.w	#19,d2
	beq	SongLengthGadg
	cmp.w	#31,d2
	beq	SampleNumGadg
	cmp.w	#33,d2
	beq	VolumeGadg
	cmp.w	#35,d2
	beq	FineTuneGadg
	cmp.w	#37,d2
	beq	SampleLengthGadg
	cmp.w	#39,d2
	beq	RepeatGadg
	cmp.w	#41,d2
	beq	RepLenGadg

	CLR.W	UpOrDown	; Up
	cmp.w	#14,d2
	beq	PositionGadg
	cmp.w	#16,d2
	beq	PatternGadg
	cmp.w	#18,d2
	beq	SongLengthGadg
	cmp.w	#30,d2
	beq	SampleNumGadg
	cmp.w	#32,d2
	beq	VolumeGadg
	cmp.w	#34,d2
	beq	FineTuneGadg
	cmp.w	#36,d2
	beq	SampleLengthGadg
	cmp.w	#38,d2
	beq	RepeatGadg
	cmp.w	#40,d2
	beq	RepLenGadg

	rts

;---- Check RightButton Gadgets ----

CheckRightGadgs:
	MOVE.W	MouseX,MouseX2
	MOVE.W	MouseY,MouseY2
	MOVE.W	MouseX2,D0
	MOVE.W	MouseY2,D1
	cmp.w	#121,d1		; lower half of screen ?
	blo.s	.cnt
	tst.w	SamScrEnable	; sampler screen ?
	bne.s	.cnt
	bsr	CheckRightPattGadgets
.cnt	cmp.w	#DirScreen_ID,CurrScreen	; dir screen ?
	beq	CheckRightDirGadgets
	rts


; -----  Disk Relabel ------

RelabelDiskGadg:
	lea	.diskname(pc),a0
	move.l	PathPtr,a1
	moveq	#32-1,d1
.loop	move.b	(a1)+,(a0)+
	dbf	d1,.loop
	lea	.diskname(pc),a0
	moveq	#32-1,d1
.loop2	cmp.b	#':',(a0)
	beq.s	.loop3
	addq.l	#1,a0
	dbf	d1,.loop2
	bra.s	.error1
.loop3	clr.b	(a0)+
	dbf	d1,.loop3

	lea	.diskname(pc),a0
	tst.b	(a0)
	beq.s	.error1
	moveq	#32-1,d0
.loop4	tst.b	(a0)+
	beq.s	.found
	dbf	d0,.loop4
	bra.s	.error1
.found	move.b	#":",-1(a0)

	lea	.reqtext(pc),a0
	lea	.newname+1(pc),a1
	moveq	#32,d0
	lea	ReqImage5,a2
	jsr	AskForTextString
	RNE
	lea	.relabeltext(pc),a0
	jsr	ShowStatusText

	lea	.newname(pc),a0
	lea	1(a0),a1
	moveq	#0,d0
.loop5	tst.b	(a1)+
	beq.s	.fnd
	addq.w	#1,d0
	cmp.w	#32,d0
	bne.s	.loop5
	clr.b	(a1)
.fnd	move.b	d0,(a0)	; len of BCPL string

	lea	.diskname(pc),a0
	lea	.newname(pc),a1
	bsr	DoRelabelDisk

	jsr	ShowAllRight
	rts
.error1	lea	.nodisk(pc),a0
	jsr	ShowStatusText
	jmp	SetErrorPtrCol
.error2	lea	.longdisk(pc),a0
	jsr	ShowStatusText
	jmp	SetErrorPtrCol
.reqtext
	dc.b	10,10,'   Relabel disk as:',0
.relabeltext
	dc.b	'Relabling disk...',0
.nodisk	dc.b	'No diskname to relabel',0
.longdisk
	dc.b	'Diskname to long...',0
	cnop	0,4
.diskname	ds.b	34
	cnop	0,4
.newname
	dc.b	5,'ST-00'
	ds.b	34-6
	cnop	0,2

; a0 = diskname, a1 = newname
DoRelabelDisk:
	move.l	a0,a2
	move.l	a1,a3

	lea	PacketStruct,a5
	lea	20(a5),a4	; sp_Pkt
	move.l	a4,10(a5)	; LN_NAME
	lea	(a5),a0		; sp_Msg
	move.l	a0,(a4)		; dp_Link

	move.l	PTProcess(pc),a0
	lea	92(a0),a0
	move.l	a0,4(a4)
	move.l	#9,8(a4)
	move.l	a3,d1
	lsr.l	#2,d1
	move.l	d1,20(a4)

	move.l	a2,a0
	move.l	a0,d1
	move.l	DosBase,a6
	jsr	LVODeviceProc(a6)

	move.l	d0,a0
	lea	PacketStruct,a1
	move.l	4.w,a6
	jsr	LVOPutMsg(a6)

	move.l	PTProcess(pc),a0
	lea	92(a0),a0
	move.l	a0,-(sp)
	jsr	LVOWaitPort(a6)

	move.l	(sp)+,a0
	jsr	LVOGetMsg(a6)
	move.l	d0,a1
	tst.l	d0
	beq.b	.skip
	jsr	LVOReplyMsg(a6)
.skip	rts

;---- Disk Format ----

DiskFormatGadg:
	jsr	FormatRequester
	RMI
	lea	.suretext(pc),a0
	jsr	ResumeCancelReq
	RNE
	bra	DoFormatDisk
.suretext
	dc.b	10,10,'      W A R N I N G !',10,10
	dc.b	      '  All data will be lost.',0
	cnop	0,2

FormatRequester:
	move.w	#-1,FileInvOn
	bsr	FindActiveDrives
	bsr	SaveRequester
	sub.l	a0,a0
	lea	ReqImage5,a1
	lea	FormatBox,a2
	move.l	#80*4,d0
	bsr	ShowRequester
	bsr	.showdiskname
	bsr	.showdrive
	bsr	.showmode
	bsr	.showverify
	bsr	.shownoicons
.wait	bsr	CheckNTSCPos
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	FormatGadgetList,a0
	jsr	GetGadget2
	tst.w	d2
	beq	.wait
	cmp.w	#1,d2
	beq	.left
	cmp.w	#2,d2
	beq	.middle
	cmp.w	#3,d2
	beq	.right

	pea	.wait(pc)	; OBZ!
	cmp.w	#4,d2
	beq	.toggleverify
	cmp.w	#5,d2
	beq	.togglenoicons
	cmp.w	#6,d2
	beq	.flipdrive
	cmp.w	#7,d2
	beq	.flipmode
	cmp.w	#8,d2
	beq	.enterdiskname
	rts

.left	moveq	#0,d0	; format
	bra.s	.ok
.middle	moveq	#1,d0	; qformat
	bra.s	.ok
.right	moveq	#-1,d0	; cancel
.ok	bsr	ReturnRequester
	clr.w	FileInvOn
	move.w	d0,FormatAction
	rts

.enterdiskname
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	lea	DiskName(pc),a6
	move.l	a6,ShowTextPtr
	move.l	a6,TextEndPtr
	add.l	#32,TextEndPtr
	move.w	#21,TextLength
	move.w	#269,d0
	moveq	#86,d1
	bsr	GetAnyTextLine
	bsr	RestorePtrCol
.showdiskname
	lea	DiskName(pc),a0
	move.w	#269,d0
	moveq	#86,d1
	moveq	#21,D3
	jmp	ShowAnyText3

.flipdrive
	bsr	WaitForButtonUp
.again	addq.w	#1,DriveNo
	cmp.w	#4,DriveNo
	bmi.s	.showdrive
	clr.w	DriveNo
.showdrive
	move.w	DriveNo(pc),d0
	move.w	ActiveDrives(pc),d1
	and.w	#$f,d1
	beq.s	.cnt
	btst	d0,d1
	beq.s	.again
.cnt	lea	.drives(pc),a0
	mulu	#3,d0
	add.l	d0,a0
	move.w	#415,d0
	moveq	#58,d1
	moveq	#3,d3
	jmp	ShowColorText

.flipmode
	bsr	WaitForButtonUp
	addq.w	#1,ModeNo
	cmp.w	#34,KickVersion
	bpl.s	.modec1
	clr.w	ModeNo
	bra.s	.showmode
.modec1	cmp.w	#36,KickVersion
	bpl.s	.modec2
	cmp.w	#2,ModeNo
	bmi.s	.showmode
	clr.w	ModeNo
	bra.s	.showmode
.modec2	cmp.w	#3,ModeNo
	bmi.s	.showmode
	clr.w	ModeNo
.showmode
	lea	.modes(pc),a0
	move.w	ModeNo(pc),d0
	mulu	#3,d0
	add.l	d0,a0
	move.w	#415,d0
	moveq	#71,d1
	moveq	#3,d3
	jmp	ShowColorText

.toggleverify
	bsr	WaitForButtonUp
	eor.w	#1,VerifyTogl
.showverify
	lea	.togltxt(pc),a0
	tst.w	VerifyTogl
	bne.s	.cnt9
	addq.l	#1,a0
.cnt9	move.w	#323,d0
	moveq	#58,d1
	moveq	#1,d3
	jmp	ShowColorText

.togglenoicons
	bsr	WaitForButtonUp
	eor.w	#1,NoIconsTogl
.shownoicons
	lea	.togltxt(pc),a0
	tst.w	NoIconsTogl
	bne.s	.cnt8
	addq.l	#1,a0
.cnt8	move.w	#323,d0
	moveq	#71,d1
	moveq	#1,d3
	jmp	ShowColorText

	cnop	0,4
.drives		dc.b	'DF0'
		dc.b	'DF1'
		dc.b	'DF2'
		dc.b	'DF3'
.modes		dc.b	'OFS'
		dc.b	'FFS'
		dc.b	'INT'
.togltxt	dc.b	'` '
	cnop	0,2

DiskName:	dc.b	'empty'
		ds.b	34-5
DriveNo:	dc.w	0	; df0/df1/df2/df3 (0/1/2/3)
ModeNo:		dc.w	0	; ofs/ffs/int (0/1/2)
VerifyTogl:	dc.w	1	; noverify/verify (0/1)
NoIconsTogl:	dc.w	0	; icons/noicons (0/1)
FormatAction:	dc.w	1	; format/qformat (1/2)
ActiveDrives:	dc.w	0

******************************************************

TRUE		EQU	-1
FALSE		EQU	0
ACTION_INHIBIT	EQU	31
LN_NAME		EQU	10
sp_SIZEOF	EQU	68
sp_Msg		EQU	0
sp_Pkt		EQU	20
pr_MsgPort	EQU	92
dp_Link		EQU	0
dp_Port		EQU	4
dp_Type		EQU	8
dp_Arg1		EQU	20

;IO_COMMAND	EQU	28
IO_FLAGS	EQU	30
IO_ERROR	EQU	31
;IO_ACTUAL	EQU	32
;IO_LENGTH	EQU	36
;IO_DATA	EQU	40
;IO_OFFSET	EQU	44

;CMD_READ	EQU	2
;CMD_WRITE	EQU	3
;CMD_UPDATE	EQU	4
;CMD_CLEAR	EQU	5
;TD_MOTOR	EQU	9
;TD_FORMAT	EQU	11
;TD_CHANGESTATE	EQU	14
;TD_PROTSTATUS	EQU	15
;TD_GETNUMTRACKS	EQU	19
IOF_QUICK	EQU	1

FindActiveDrives:
	lea	DResName(pc),a1
	move.l	4.w,a6
	jsr	LVOOpenResource(a6)
	move.l	d0,a0
	moveq	#0,d0
	move.b	38(a0),ActiveDrives+1
	rts

DResName:	dc.b	'disk.resource',0
	cnop	0,2


DoFormatDisk:
	move.w	#-1,FileInvOn
	bsr	SaveRequester
	sub.l	a0,a0
	sub.l	a1,a1
	lea	FormatBarReq,a2
	bsr	ShowRequester
	lea	.formatting(pc),a0
	move.w	#82+192,d0
	moveq	#50+12,d1
	jsr	ShowColorText2
	jsr	ShowStatusText

	move.w	DriveNo(pc),d0
	and.b	#3,d0
	add.b	#"0",d0
	move.b	d0,Floppy+2

	lea	BB,a0
	lea	DosString(pc),a1
	move.l	(a1),d0
	move.b	ModeNo+1(pc),d0
	move.l	d0,(a0)

	bsr.w	OpenTrackDisk
	bne.w	.error2
	bsr	CheckDiskette
	bne.w	.error3
	bsr.w	InhibitDrive
	bsr	StorePtrCol
	bsr	SetDiskPtrCol
	cmp.w	#1,FormatAction
	beq.s	.justinit
	bsr.w	FormatDrive
	bmi.s	.error
	bne.s	.abort
.justinit
	lea	.initializing(pc),a0
	move.w	#75+192,d0
	moveq	#50+12,d1
	jsr	ShowColorText2
	jsr	ShowStatusText
	bsr.w	Initialize
	bne.s	.error

	; add icons

	jsr	ShowAllRight
.end	bsr.w	MotorOff
	clr.l	_DriveOnOff		; Tell DosPacket to Initialize....
	bsr.w	InhibitDrive		; and enable floppy.. :)
	move.l	#-1,_DriveOnOff
	bsr.w	CloseTrackDisk
	jsr	RestorePtrCol

.end2	bsr	ReturnRequester
	clr.w	FileInvOn
	bsr	ClearKeyBuf
	moveq	#0,d0
	rts
.abort	bsr.s	.end
	lea	.aborted(pc),a0
	jsr	ShowStatusText
	bra	SetErrorPtrCol
.error	bsr	InstallBAD
	bsr.s	.end
	lea	.errortxt1(pc),a0
	jsr	ShowStatusText
	bra	SetErrorPtrCol
.error2	bsr.s	.end2
	lea	.errortxt2(pc),a0
	jsr	ShowStatusText
	bra	SetErrorPtrCol
.error3	bsr.s	.end
	lea	.errortxt3(pc),a0
	jsr	ShowStatusText
	bra	SetErrorPtrCol
.formatting	dc.b	'Formatting...',0
.initializing	dc.b	'Initializing...',0
.aborted	dc.b	'Formatting aborted',0
.errortxt1	dc.b	'Hard error on disk',0
.errortxt2	dc.b	'Unable to open trackdiskdevice',0
.errortxt3	dc.b	'No disk in drive',0
		cnop	0,2

FormatDrive:
	lea	TrackMask(pc),a0
	lea	WriteBuffer,a1

	move.l	#1408-1,d0		; One Track filled with "DOS0"
.masklp	move.l	(a0),(a1)+	
	dbf	d0,.masklp

	move.w	#1,.prvpos
	moveq	#0,d5			; Cleared for loop use in IO_OFFSET
	move.l	#160-1,d7		; 160 Tracks on a disk! ;)
.FormatLoop
	movem.l d0-d7/a0-a6,-(sp)
	move.w	.prvpos(pc),d0
	move.w	d0,d2
	addq.w	#1,d2
	move.w	d2,.prvpos
	lsr.w	#1,d0
	lsr.w	#1,d2
	mulu	#236,d0
	divu	#160/2,d0		; 160 tracks
	mulu	#236,d2
	divu	#160/2,d2		; 160 tracks
	add.w	#192+10,d0
	add.w	#192+10,d2
	moveq	#50+27,d1
	move.w	#50+27+9,d3
	moveq	#1,d5
	jsr	ShowAnyBlock3
	movem.l (sp)+,d0-d7/a0-a6
	bsr.b	Format_A_Track
	bne.s	.error
	add.l	#5632,d5		; Add one track!
	movem.l d0-d7/a0-a6,-(sp)
	cmp.w	#2,.prvpos
	bne.s	.cnt
	bsr	InstallBAD		; The disk is BAD while formatting...
.cnt	jsr	DoKeyBuffer
	movem.l (sp)+,d0-d7/a0-a6
	move.b	RawKeyCode,d0
	cmp.b	#$45,d0			; ESC
	beq.s	.abort
	dbf	d7,.FormatLoop
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts
.abort	moveq	#1,d0
	rts
	cnop	0,4
.prvpos		dc.w	0

Format_A_Track:
	lea	DiskIO,a1	
	move.l	#DiskRep,14(a1)			;port pointer
	move.l	#WriteBuffer,IO_DATA(a1)	; One track with "DOS0"
	move.l	d5,IO_OFFSET(a1)
	move.l	#5632,IO_LENGTH(a1)		; One track
	move.w	#TD_FORMAT,IO_COMMAND(a1)
	move.l	4.w,a6
	jsr	LVODoIO(a6)
	tst.l	d0
	bne.w	.error
	tst.b	IO_ERROR(a1)
	bne.w	.error

	tst.w	VerifyTogl
	beq.s	.skip				; Don't verify

	lea	WriteBuffer,a0			; Format buffer
	bsr.b	CalcChkSum			; CALC DATA WRITTEN!!!
	move.l	d0,_CheckSum

	lea	DiskIO,a1
	move.l	#DiskRep,14(a1)			;port pointer
	move.l	#ReadBuffer,IO_DATA(a1)
	move.l	d5,IO_OFFSET(a1)
	move.l	#5632,IO_LENGTH(a1)		; One track
	move.w	#CMD_READ,IO_COMMAND(a1)
	jsr	LVODoIO(a6)
	tst.l	d0
	bne.w	.error
	tst.b	IO_ERROR(a1)
	bne.w	.error

	lea	ReadBuffer,a0			; Verify buffer
	bsr.b	CalcChkSum			; CALC DATA READ!!!!
	cmp.l	_CheckSum(pc),d0		; Are READ & WRITE ChkSum equ??
	bne.w	.error				; If Not, ERROR!  ;(
.skip	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts
CalcChkSum:
	move.l	a0,-(sp)			; Save Buffer to calculate
	lea	DiskIO,a1
	move.l	#DiskRep,14(a1)
	move.w	#CMD_UPDATE,IO_COMMAND(a1)	; Clear internals
	move.l	4.w,a6
	jsr	LVODoIO(a6)
	move.l	(sp)+,a0			; Restore Buffer to calculate

	move.l	#(5632/4)-1,d1	; Counter for number of data (1 track)
	moveq	#0,d0
.loop:	sub.l	(a0)+,d0
	dbf	d1,.loop
	move.l	d0,_CheckSum2	; Save calculated checksum.	:)
	rts

Initialize:
	lea	RootBuffer,a1
	move.l	a1,d1
	add.l	#484,d1
	move.l	DosBase,a6
	jsr	LVODateStamp(a6)

	lea	RootBuffer,a0
	move.l	#-1,312(a0)		; Bitmap valid <> 0
	move.l	#881,316(a0)		; Ptr to Bitmap blocks

	lea	432(a0),a0
	lea	1(a0),a2
	lea	DiskName(pc),a1
	moveq	#0,d1
	moveq	#32-1,d0
.loop	move.b	(a1)+,d2
	beq.s	.cnt
	move.b	d2,(a2)+
	addq.b	#1,d1
	dbf	d0,.loop
.cnt	move.b	d1,(a0)

	lea	RootBuffer,a0
	move.l	#2,(a0)+	; Type T SHORT
	clr.l	(a0)+
	clr.l	(a0)+
	move.l	#72,(a0)+	; Size of hash table
	clr.l	(a0)+
	lea	RootBuffer,a0
	lea	508(a0),a0
	move.l	#1,(a0)		; Sub-type of block

	bsr.b	CC_Root		; Calculate ROOTBLOCK checksum

	lea	RootBuffer,a0
	move.l	d0,20(a0)	
	move.l	#450560,d5	; OFFSET #880
	bsr.w	InstallDisk	; Install rootblock
	bne.s	.error

	lea	RootBuffer,a0
	moveq	#28-1,d0
.lp	move.l	#-1,(a0)+
	dbf	d0,.lp
	move.l	#$ffff3fff,(a0)+
	moveq	#27-1,d0
.lp2	move.l	#-1,(a0)+
	dbf	d0,.lp2
	moveq	#72,d0
.lp3	clr.l	(a0)+
	dbf	d0,.lp3

	bsr.b	CC_BM		; Calculate BITMAP checksum

	lea	RootBuffer,a0
	move.l	d0,(a0)		; Put checksum
	move.l	#451072,d5	; OFFSET #881
	bsr.b	InstallDisk	; Install bitmap
	bne.s	.error
	bsr.b	InstallBB
	bne.s	.error
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts
CC_Root:lea	RootBuffer,a0
	lea	20(a0),a1
	moveq	#128-1,d1	; Counter for number of data (1 track)
	moveq	#0,d0
	move.l	d0,(a1)
.loop:	sub.l	(a0)+,d0
	dbf	d1,.loop
	move.l	d0,(a1)
	rts
CC_BM:	lea	RootBuffer,a0
	lea	(a0),a1
	moveq	#128-1,d1	; Counter for number of data (1 track)
	moveq	#0,d0
	move.l	d0,(a1)
.loop:	sub.l	(a0)+,d0
	dbf	d1,.loop
	move.l	d0,(a1)
	rts
InstallDisk:
	lea	DiskIO,a1	
	move.l	#DiskRep,14(a1)			; port pointer
	move.l	#RootBuffer,IO_DATA(a1)
	move.l	d5,IO_OFFSET(a1)
	move.l	#512,IO_LENGTH(a1)
	move.w	#CMD_WRITE,IO_COMMAND(a1)
	move.l	4.w,a6
	jsr	LVODoIO(a6)
	tst.b	IO_ERROR(a1)
	bne.s	.error
	bsr.s	Update
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts
InstallBB:
	lea	DiskIO,a1	
	move.l	#DiskRep,14(a1)			; port pointer
	move.l	#BB,IO_DATA(a1)
	clr.l	IO_OFFSET(a1)
	move.l	#1024,IO_LENGTH(a1)
	move.w	#CMD_WRITE,IO_COMMAND(a1)
	move.l	4.w,a6
	jsr	LVODoIO(a6)
	tst.b	IO_ERROR(a1)
	bne.s	.error
	bsr.s	Update
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts
Update:	lea	DiskIO,a1
	move.l	#DiskRep,14(a1)
	move.w	#CMD_UPDATE,IO_COMMAND(a1)	; Clear internals
	jsr	LVODoIO(a6)
	rts
InstallBAD:
	move.l	BB,-(sp)
	move.l	#"BAD!",BB
	bsr.s	InstallBB
	move.l	(sp)+,BB
	rts


MotorOff:
	lea	DiskIO,a1	
	move.l	#DiskRep,14(a1)			; port pointer
	move.w	#TD_MOTOR,IO_COMMAND(a1)	;MOTOR
	clr.l	IO_LENGTH(a1)			;0=OFF/1=ON 
	move.l	4.w,a6
	jsr	LVODoIO(a6)
	rts
InhibitDrive:
	lea	PacketStruct,a5
	lea	sp_Pkt(a5),a4

	move.l	a4,LN_NAME(a5)

	lea	sp_Msg(a5),a0
	move.l	a0,dp_Link(a4)

	move.l	PTProcess,a0
	lea	pr_MsgPort(a0),a0
	move.l	a0,dp_Port(a4)

	move.l	#ACTION_INHIBIT,dp_Type(a4)
	move.l	_DriveOnOff(pc),dp_Arg1(a4)		; TRUE or FALSE

	lea	Floppy(pc),a0
	move.l	a0,d1
	move.l	DosBase,a6
	jsr	LVODeviceProc(a6)

	move.l	d0,a0
	lea	PacketStruct,a1
	move.l	4.w,a6
	jsr	LVOPutMsg(a6)

	move.l	PTProcess,a0
	lea	pr_MsgPort(a0),a0
	jsr	LVOWaitPort(a6)

	move.l	PTProcess,a0
	lea	pr_MsgPort(a0),a0
	jsr	LVOGetMsg(a6)
	rts

OpenTrackDisk:
	move.l	PTProcess,d0
	move.l	d0,DiskRep+16
	lea	DiskRep,a1
	move.l	4.w,a6
	jsr	LVOAddPort(a6)
	lea	DiskIO,a1
	moveq	#0,d0
	move.w	DriveNo(pc),d0			; DriveNo
	moveq	#0,d1				; open only 3.5"
	lea	TrackdiskName,a0
	jsr	LVOOpenDevice(a6)
	bne.s	.error
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

CheckDiskette:
	lea	DiskIO,a1			; IO struct => A1
	move.b	#IOF_QUICK,IO_FLAGS(a1)
	move.w	#TD_CHANGESTATE,IO_COMMAND(a1)
	move.l	4.w,a6
	jsr	LVODoIO(a6)			; Any disk in drive??
	tst.l	IO_ACTUAL(a1)
	bne.b	.error
;	lea	DiskIO,a1	
;	clr.b	IO_FLAGS(a1)
;	move.w	#TD_PROTSTATUS,IO_COMMAND(a1)
;	jsr	LVOSendIO(a6)				; NB! This command needs SendIO
;	tst.l	IO_ACTUAL(a1)
;	bne.s	.error
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

CloseTrackDisk:
	lea	DiskIO,a1
	move.l	4.w,a6
	jsr	LVOCloseDevice(a6)
	lea	DiskRep,a1
	jsr	LVORemPort(a6)
	rts

		cnop	0,4
TrackMask:	dc.b	"DOS0"
DosString:	dc.b	'DOS',0
Floppy:		dc.b	'DF0:',0
		cnop	0,4
_CheckSum:	dc.l	0
_CheckSum2:	dc.l	0
_DriveOnOff:	dc.l	-1

******************************************************

;---- Clear All Data ----

DoClearRequester:
	lea	.text(pc),a0
	move.l	a0,-(sp)
	move.w	#-1,FileInvOn
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	BSR	Wait_4000
	bsr	SaveRequester
	move.l	(sp)+,a0	; text pointer
				; ___
	lea	ReqImage,a1	; \!/
	lea	ClearRequester,a2
	move.l	#80*14,d0	; image position
	bsr	ShowRequester

	CLR.B	RawKeyCode
.surebuttoncheck
	bsr	CheckNTSCPos
	BSR	DoKeyBuffer

	MOVE.B	RawKeyCode,D0
	CMP.B	#33,D0 ; Pressed S
	BEQ	.AnswerSamples
	CMP.B	#24,D0 ; Pressed O
	BEQ	.AnswerSong
	CMP.B	#32,D0 ; Pressed A
	BEQ	.AnswerAll
	CMP.B	#51,D0 ; Pressed C
	BEQ	.AnswerCancel
	CMP.B	#69,D0 ; Pressed Esc
	BEQ	.AnswerCancel
	BTST	#6,$BFE001		; Left Mousebutton
	BNE.S	.surebuttoncheck
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList4,a0
	jsr	GetGadget2
	tst.w	d2
	beq.s	.surebuttoncheck
	cmp.w	#1,d2
	beq.s	.AnswerSong
	cmp.w	#2,d2
	beq.s	.AnswerSamples
	cmp.w	#3,d2
	beq.s	.AnswerAll
.AnswerCancel
	bsr.s	.end
	MOVEQ	#-1,D0
	RTS
.AnswerSong
	bsr.s	.end
	MOVEQ	#1,D0
	RTS
.AnswerSamples
	bsr.s	.end
	MOVEQ	#2,D0
	RTS
.AnswerAll
	bsr.s	.end
	MOVEQ	#3,D0
	RTS
.end	bsr	ReturnRequester
	JSR	ShowAllRight
	;MOVE.B	SaveScope,ScopeEnable
	BSR	RestorePtrCol
	BSR	Wait_4000
	BSR	WaitForButtonUp
	clr.w	FileInvOn
	CLR.B	RawKeyCode
	rts
.text	dc.b	10,10,'  Select what data you',10
	dc.b	'     wish to clear.',0
	cnop	0,2

ClearAll:
	ADD.L	#1,LaHeTx
	bsr	DoClearRequester
	bmi	ClrCancel
	cmp.w	#1,d0
	beq	ClrSong
	cmp.w	#2,d0
	beq	ClrSamples
	cmp.w	#3,d0
	beq	ClrAll
ClrCancel:
	BRA	SetErrorPtrCol

ClrAll:	BSR	DoClearSong
	BSR	ClrSampleInfo
	BSR	SetNormalPtrCol
	BRA	DisplayMainAll
;--------
ClrSamples:
	BSR	StopIt
	BSR	ClrSampleInfo
	BSR	SetNormalPtrCol
	;SF	EdEnable
	MOVE.W	#1,InsNum
	BRA	DisplayMainAll

ClrSong:BSR	DoClearSong
	BSR	SetNormalPtrCol
	BRA	DisplayMainAll
;----
ClrSampleInfo:
	BSR	GiveBackInstrMem
	MOVE.L	SongDataPtr,A0
	LEA	sd_sampleinfo(A0),A0
	MOVE.W	#MAX_INSTR*INSTR_SIZEOF-1,D0
.loop	CLR.B	(A0)+
	DBRA	D0,.loop

	MOVE.L	SongDataPtr,A1
	LEA	sd_sampleinfo(A1),A1
	MOVEQ	#MAX_INSTR-1,D0
.loop2	MOVE.W	#1,INSTR_REPLEN(A1)
	LEA	INSTR_SIZEOF(A1),A1
	DBRA	D0,.loop2

	LEA	SampleLengthAdd(PC),A3
	MOVEQ	#MAX_INSTR,D0
.lop2	CLR.W	(A3)+
	DBRA	D0,.lop2
	JMP	RedrawSample
;---
DoClearSong:
	BSR	StopIt
	CLR.B	RawKeyCode
	MOVE.L	SongDataPtr,A0
	MOVE.L	A0,A1
	MOVEQ	#19,D0
.cla2x	CLR.B	(A0)+
	DBRA	D0,.cla2x
	MOVE.L	A1,A2
	ADD.L	#70716,A2
	ADD.L	#950,A1
	MOVEQ	#0,D0
.loop	MOVE.W	D0,(A1)+
	CMP.L	A1,A2
	BNE.S	.loop
	MOVE.L	SongDataPtr,A0
	MOVE.W	#$017F,sd_numofpatt(A0)
	MOVE.L	#'M.K.',sd_mahokakt(A0) ; M.K. all the way...
	;SF	EdEnable
	CLR.L	CurrPos
	CLR.L	SongPosition
	CLR.L	PatternPosition
	CLR.L	PatternPtr
	CLR.L	TimerTicks
	CLR.W	BlockMarkFlag
	CLR.B	MetroChannel
	MOVE.W	#1,EditMoveAdd
	MOVEQ	#0,D0
	MOVE.W	DefaultSpeed,D0
	MOVE.L	D0,CurrSpeed
	MOVE.W	Tempo,RealTempo
	BSR	SetTempo
	BSR	RestoreEffects2
	BSR	RestoreFKeyPos2
	BSR	UnmuteAll
	MOVE.W	#1,InsNum
	MOVE.L	#6,CurrSpeed
	CLR.L	PatternNumber
	CLR.W	ScrPattPos
	BSR	SetScrPatternPos
	JMP	RedrawPattern

UnmuteAll:
	MOVE.W	#1,audchan1toggle
	MOVE.W	#1,audchan2toggle
	MOVE.W	#1,audchan3toggle
	MOVE.W	#1,audchan4toggle
	MOVE.W	#$000F,ActiveChannels
	BRA	RedrawToggles

ToggleMute:
	CLR.B	RawKeyCode
	TST.W	ShiftKeyStatus
	BEQ.s	.skp
	CLR.W	audchan1toggle
	CLR.W	audchan2toggle
	CLR.W	audchan3toggle
	CLR.W	audchan4toggle
.skp	MOVEQ	#0,D0
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	MULU	#11,D0
	ADDQ.W	#4,D0
	BRA	DoToggleMute

RestoreEffects:
	MOVEQ	#0,D0
	MOVE.W	DefaultSpeed,D0
	MOVE.L	D0,CurrSpeed
	MOVE.W	Tempo,RealTempo
	BSR	SetTempo
	BSR.S	RestoreEffects2
	CLR.B	RawKeyCode
	LEA	EfxRestoredText(PC),A0
	JSR	ShowStatusText
	BSR	WaitALittle
	JMP	ShowAllRight

RestoreEffects2:
	LEA	audchan1temp,A0
	BSR.S	reefsub
	LEA	audchan2temp,A0
	BSR.S	reefsub
	LEA	audchan3temp,A0
	BSR.S	reefsub
	LEA	audchan4temp,A0
reefsub	CLR.B	n_wavecontrol(A0)
	CLR.B	n_glissfunk(A0)
	CLR.B	n_finetune(A0)
	CLR.B	n_loopcount(A0)
	RTS

RestoreFKeyPos:
	CLR.B	RawKeyCode
	LEA	PosRestoredText(PC),A0
	JSR	ShowStatusText
	JSR	WaitALittle
	JSR	ShowAllRight
RestoreFKeyPos2:
	MOVE.W	#00,F6pos
	MOVE.W	#16,F7pos
	MOVE.W	#32,F8pos
	MOVE.W	#48,F9pos
	MOVE.W	#63,F10pos
	RTS

EfxRestoredText:dc.b 'Effects restored!',0
PosRestoredText:dc.b 'Position restored!',0
	even

;-- FreeMem for all samples

GiveBackInstrMem:
	bsr	ClrAllDynFlags	; -maw-
	MOVEQ	#1,D7
	MOVE.L	4.w,a6
.loop	MOVE.W	D7,D2
	LSL.W	#2,D2
	LEA	SamplePtrs,A0
	MOVE.L	0(A0,D2.W),D1
	BEQ.S	.nofm1
	MOVE.L	SAMPLE_LENGTHS(A0,D2.W),D0
	CLR.L	0(A0,D2.W)
	CLR.L	SAMPLE_LENGTHS(A0,D2.W)
	MOVE.L	D1,A1
	JSR	LVOFreeMem(A6)
.nofm1:	
;-- -maw- free also the DYN tables
	move.w	d7,d2
	lsl.w	#3,d2	; *8, because of ADR.L,SIZE.L = 8
	lea	DynMemPtrTable,a0
	add.w	d2,a0
	move.l	(a0),d1
	beq.s	.nofm2
	move.l	4(a0),d0
	clr.l	(a0)
	clr.l	4(a0)
	move.l	d1,a1
	JSR	LVOFreeMem(A6)

.nofm2	ADDQ.W	#1,D7
	CMP.W	#MAX_INSTR+1,D7
	BNE.S	.loop
	MOVE.W	#1,UpdateFreeMem
	JMP	FreeCopyBuf

;---- Setup ----

Setup:	BSR	WaitForButtonUp
	MOVE.W	#5,CurrScreen
	ST	NoSampleInfo
	BSR	Clear121Lines
	BSR	MakeSetupScreen
	BNE	ExitSetup
RefreshSetup:
	BSR	SetScreenColors
	bsr	SetScreenPosition
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	BSR	CopyCfgData
	BSR	MarkColor
	bsr	ShowPNote
	bsr	ShowRainbow
	BSR	DoDelSelect
	BSR	ShowSetupToggles

	BSR	ShowSplit
	BSR	ShowPrintPath
	BSR	ShowKeyRepeat
	BSR	ShowConfigNumber
refrsh2
	BSR	ShowIntMode
	BSR	ShowTempo
	BSR	ShowSpeed
	BSR	GetColPos
	BSR	ShowColSliders
	;BSR	ShowS2Modules
	;BSR	ShowS2Songs
	;BSR	ShowS2Samples
	;BSR	ShowS2PTPath
	;BSR	ShowS2SalvAddr
	BSR	ShowS2TuneNote
	BRA	ShowAccidental 		; Always last (redraws pattern) !

MakeSetupScreen:
	LEA	SetupScreenData,A0
	lea	UpperBuffer,a1
	JSR	DePackIt	
	RNE

RemoveSetupScreen:
	LEA	BitPlaneData,A0
	lea	UpperBuffer,a1
	MOVEQ	#2-1,D2         ; number of planes
.loop1	
	MOVE.W	#121*80/4-1,D0  ; number of lines = 121
.loop2	MOVE.L	(A0),D1		
	MOVE.L	(A1),(A0)+
	MOVE.L	D1,(A1)+
	DBRA	D0,.loop2

	LEA	(256-121)*80(A0),A0		;next bitplane, please
	DBRA	D2,.loop1
	moveq	#0,d0
	RTS

; Gadgets

CheckSetupGadgs:
	TST.L	SplitAddress
	BEQ.S	csgskip
	CLR.L	SplitAddress
	BSR	ShowSplit
csgskip	MOVEM.W	MouseX2,D0/D1
	lea	SetupGadgetList,a0
	jsr	GetGadget
	tst.w	d2
	REQ
	cmp.w	#1,d2
	beq	ExitSetup
	cmp.w	#2,d2
	beq	SetLoadConfig
	cmp.w	#3,d2
	beq	SetSaveConfig
	cmp.w	#4,d2
	beq	SetConfigNumber
	cmp.w	#5,d2
	beq	ResetAll
	cmp.w	#7,d2
	beq	TempoUp
	cmp.w	#8,d2
	beq	TempoDown
	cmp.w	#10,d2
	beq	SpeedUp
	cmp.w	#11,d2
	beq	SpeedDown
	cmp.w	#12,d2
	beq	ToggleIntMode

	cmp.w	#14,d2
	beq	ToggleSoftint	; -maw

	;cmp.w	#15,d2
	;beq	SetS2Default
	;cmp.w	#16,d2
	;beq	Set2ModPath
	;cmp.w	#17,d2
	;beq	Set2SongPath
	;cmp.w	#18,d2
	;beq	Set2SamPath
	;cmp.w	#19,d2
	;beq	Set2PtPath
	;cmp.w	#24,d2
	;beq	SetS2SalvAddr
	;cmp.w	#25,d2
	;beq	RecoverSong
	cmp.w	#26,d2
	beq	ClearSplit
	cmp.w	#27,d2
	beq	SetSplit
	cmp.w	#42,d2
	beq	SetKeyRepeat
	cmp.w	#43,d2
	beq	ToggleAccidental
	cmp.w	#44,d2
	beq	PrintSong
	cmp.w	#45,d2
	beq	EnterPrintPath
	cmp.w	#46,d2
	beq	TogglePower
	cmp.w	#47,d2
	beq	ToggleVUMeterMode
	cmp.w	#76,d2
	beq	ScreenDragGadget

	cmp.w	#81,d2
	beq	SetS2TuneNote
	cmp.w	#82,d2
	beq	ss2tvol
	cmp.w	#83,d2
	beq	ss2tvolup
	cmp.w	#84,d2
	beq	ss2tvoldown

	cmp.w	#85,d2
	beq	ToggleTestCol	;-maw-

	cmp.w	#86,d2
	beq	ToggleDmaconr	;-maw-

	cmp.w	#99,d2
	beq	ScreenToBack

	cmp.w	#100,d2
	beq	ToggleSplit
	cmp.w	#101,d2
	beq	ToggleTransDel
	cmp.w	#102,d2
	beq	ToggleSolidScope
	cmp.w	#103,d2
	beq	ToggleBlankZero
	cmp.w	#104,d2
	beq	ToggleShowDec
	cmp.w	#105,d2
	beq	ToggleFilter
	cmp.w	#106,d2
	beq	ToggleNTSC
	cmp.w	#107,d2
	beq	ToggleLACE

	cmp.w	#108,d2		; activates the one right lower edge
	beq	ToggleUndynIff	; -maw-

	cmp.w	#110,d2
	beq	ToggleOverride
	cmp.w	#111,d2
	beq	ToggleNoSamples
	cmp.w	#112,d2
	beq	ToggleShowDirs
	cmp.w	#113,d2
	beq	ToggleIFFLoop
	cmp.w	#114,d2
	beq	ToggleAutoDir
	cmp.w	#115,d2
	beq	ToggleAutoExit
	cmp.w	#116,d2
	beq	ToggleCache
	cmp.w	#117,d2
	beq	ToggleCutToBuf

	cmp.w	#71,d2
	beq	SelectColor
	cmp.w	#72,d2
	beq	SelectColor2

	tst.w	ColEdMode
	bne.w	ColrEdit2
	cmp.w	#64,d2
	beq	CopyColor
	cmp.w	#66,d2
	beq	SwapColor
	cmp.w	#67,d2
	beq	CancelCol
	cmp.w	#68,d2
	beq	SetDefaultCol
	cmp.w	#64,d2
	beq	CopyColor
	cmp.w	#73,d2
	beq	SetRed
	cmp.w	#74,d2
	beq	SetGreen
	cmp.w	#75,d2
	beq	SetBlue
	rts
ColrEdit2:
	cmp.w	#64,d2
	beq	CopyColor2
	cmp.w	#65,d2
	beq	SpreadColors
	cmp.w	#66,d2
	beq	SwapColor2
	cmp.w	#67,d2
	beq	CancelCol2
	cmp.w	#68,d2
	beq	SetDefaultCol2
	cmp.w	#69,d2
	beq	RotColUp
	cmp.w	#70,d2
	beq	RotColDown
	cmp.w	#73,d2
	beq	SetRed2
	cmp.w	#74,d2
	beq	SetGreen2
	cmp.w	#75,d2
	beq	SetBlue2
	rts

ExitSetup:
	move.l	#-1,OldDateStamp	;make sure date is updated
	move.l	#-1,OldDateStamp+4
	move.l	#-1,OldDateStamp+8
	cmp.w	#-1,forrigeinv
	BSR	WaitForButtonUp
	bsr	KillRainbow
	CLR.B	RawKeyCode
	CLR.L	SplitAddress
	BSR	RemoveSetupScreen	;RestoreMainPic
	SF	NoSampleInfo
	JSR	SetupVUCols
	BSR	Clear100Lines
	BRA	DisplayMainAll

ShowSetupToggles:
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	bsr	ShowSplitTogl
	bsr	ShowSolidScopeTogl
	bsr	ShowFilterTogl
	bsr	ShowTransDelTogl
	bsr	ShowShowDecTogl
	bsr	ShowAutoDirTogl
	bsr	ShowAutoExitTogl
	bsr	ShowOverrideTogl
	bsr	ShowNoSamplesTogl
	bsr	ShowBlankZeroTogl
	bsr	ShowShowDirsTogl
	bsr	ShowCutToBufTogl
	bsr	ShowIFFLoopTogl
	bsr	ShowLACETogl

	bsr	ShowUndynIffTogl 	;-maw-
	bsr	ShowUndynModTogl 	;-maw-
	bsr	ShowTestColTogl		;-maw-
	bsr	ShowSoftintTogl		;-maw-
	bsr	ShowDmaconrTogl         ;-maw-

	bsr	ShowNTSCTogl
	bsr	ShowVUMetersTogl
	bsr	ShowVUMeterModeTogl
	bsr	ShowPowerTogl
	rts
DoShowToggle:
	MOVE.W	D6,TextOffset
	LEA	ToggleOFFText(PC),A0
	TST.B	D0
	BEQ.S	.skip
	LEA	ToggleONText(PC),A0
.skip	MOVE.W	#3,TextLength
	JMP	ShowText2

ToggleONText2:	dc.b ' '
ToggleONText:	dc.b 'on '
ToggleOFFText:	dc.b 'off '

ToggleSplit:
	bchg	#4,EditBitFlags+3	;SplitFlag
ShowSplitTogl:
	bsr	Show_MS
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	btst	#4,EditBitFlags+3	;SplitFlag
	sne	d0
	MOVE.W	#14*80+62,D6
	bsr	DoShowToggle
	bra	Show_MS

ToggleSolidScope:
	bchg	#3,ScrnBitFlags+3	;SolidScopeFlag
ShowSolidScopeTogl:
	bsr	Show_MS
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	btst	#3,ScrnBitFlags+3	;SolidScopeFlag
	sne	d0
	MOVE.W	#36*80+62,D6
	bra	DoShowToggle

ToggleFilter:
	bchg	#1,MiscBitFlags+3	;FilterFlag
ShowFilterTogl:
	btst	#1,MiscBitFlags+3	;FilterFlag
	sne	d0
	move.b	d0,d1
	not.b	d1
	and.b	#1,d1
	lsl.b	#1,d1
	bclr	#1,$bfe001
	or.b	d1,$bfe001
	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	MOVE.W	#69*80+62,D6
	bra	DoShowToggle
ToggleTransDel:
	bchg	#1,EditBitFlags+3	;TransDelFlag
ShowTransDelTogl:
	btst	#1,EditBitFlags+3	;TransDelFlag
	sne	d0
	MOVE.W	#25*80+62,D6
	bra	DoShowToggle
ToggleShowDec:
	bchg	#2,MiscBitFlags+3	;ShowDecFlag
	MOVE.W	#1,UpdateFreeMem
ShowShowDecTogl:
	btst	#2,MiscBitFlags+3	;ShowDecFlag
	sne	d0
	MOVE.W	#58*80+62,D6
	bra	DoShowToggle

ToggleAutoDir:
	bchg	#3,DiskBitFlags+3	;AutoDirFlag
ShowAutoDirTogl:
	btst	#3,DiskBitFlags+3	;DiskAutoDirFlag
	sne	d0
	MOVE.W	#58*80+76,D6
	bra	DoShowToggle

ToggleAutoExit:
	bchg	#4,DiskBitFlags+3	;AutoExitFlag
ShowAutoExitTogl:
	btst	#4,DiskBitFlags+3	;AutoExitFlag
	sne	d0
	MOVE.W	#69*80+76,D6
	bra	DoShowToggle

ToggleOverride:
	bchg	#7,DiskBitFlags+3	;OverrideFlag
ShowOverrideTogl:
	btst	#7,DiskBitFlags+3	;OverrideFlag
	sne	d0
	MOVE.W	#14*80+76,D6
	bra	DoShowToggle
ToggleNoSamples:
	bchg	#5,DiskBitFlags+3	;NosamplesFlag
ShowNoSamplesTogl:
	btst	#5,DiskBitFlags+3	;NosamplesFlag
	sne	d0
	MOVE.W	#25*80+76,D6
	bra	DoShowToggle
ToggleBlankZero:
	bchg	#3,EditBitFlags+3	;BlankZeroFlag
	pea	RedrawPattern
ShowBlankZeroTogl:
	btst	#3,EditBitFlags+3	;BlankZeroFlag
	sne	d0
	MOVE.W	#47*80+62,D6
	bra	DoShowToggle
ToggleShowDirs:
	bchg	#2,DiskBitFlags+3	;ShowDirsFlag
ShowShowDirsTogl:
	btst	#2,DiskBitFlags+3	;ShowDirsFlag
	sne	d0
	MOVE.W	#36*80+76,D6
	bra	DoShowToggle
ToggleCutToBuf:
	bchg	#5,EditBitFlags+3	;CutToBufFlag
ShowCutToBufTogl:
	btst	#5,EditBitFlags+3	;CutToBufFlag
	sne	d0
	MOVE.W	#91*80+76,D6
	bra	DoShowToggle
ToggleIFFLoop:
	bchg	#6,DiskBitFlags+3	;IFFLoopFlag
ShowIFFLoopTogl:
	btst	#6,DiskBitFlags+3	;IFFLoopFlag
	sne	d0
	MOVE.W	#47*80+76,D6
	bra	DoShowToggle

ToggleNTSC:
	bchg	#0,ScrnBitFlags+3	; NTSCFlag
ShowNTSCTogl:
	btst	#0,ScrnBitFlags+3	; NTSCFlag
	sne	d0
	MOVE.W	#80*80+62,D6
	bsr	DoShowToggle
	clr.w	NTSCAdd
	clr.w	NTSCYPos
	bsr	SetScreenPosition
	rts

ToggleLACE:
	bchg	#1,ScrnBitFlags+3	; LACEDFlag
ShowLACETogl:
	btst	#1,ScrnBitFlags+3	; LACEDFlag
	sne	d0
	move.b	d0,d1
	and.w	#4,d1
	moveq	#~4,d2
	and.w	d2,_BCON1
	or.w	d1,_BCON1
	TST.W	SamScrEnable
	bne.s	.cnt
	and.w	d2,_BCON2
	or.w	d1,_BCON2
	and.w	d2,_BCON3
	or.w	d1,_BCON3
	and.w	d2,_BCON4
	or.w	d1,_BCON4
.cnt	cmp.w	#SetupScreen1_ID,CurrScreen
	RNE
	MOVE.W	#91*80+62,D6
	bra	DoShowToggle

ToggleRecHold:
	bchg	#0,EditBitFlags+3	;RecHoldFlag
ShowRecHoldTogl:
	btst	#0,EditBitFlags+3	;RecHoldFlag
	sne	d0
	MOVE.W	#102*80+55,D6
	bra	DoShowToggle

; --- some toggles inserted by -maw- ----------------

ToggleTestCol:
	bchg	#2,ScrnBitFlags+3	; test colors on/off
ShowTestColTogl:
	btst	#2,ScrnBitFlags+3
	sne	d0
	beq.s	.clr
	bsr	SetTestColors
	bra.s	.set
.clr:	bsr	ClrTestColors
.set:	MOVE.W	#36*80+36,D6	
	bra	DoShowToggle

ToggleSoftint:
	bchg	#3,MiscBitFlags+3	; softint on/off
ShowSoftintTogl:
	btst	#3,MiscBitFlags+3
	sne	d0
	beq.s	.clr
	move.w	#$8004,_custom+intena	; soft int on
	bra.s	.set
.clr:	move.w	#4,_custom+intena	; soft int off
.set:	
	MOVE.W	#36*80+22,D6	
	bra	DoShowToggle

ToggleUndynIff:
	bchg	#3,DiskBitFlags+2	; undyn dyn samples on loading
ShowUndynIffTogl:
	btst	#3,DiskBitFlags+2
	sne	d0
	MOVE.W	#102*80+62,D6
	bra	DoShowToggle

ToggleUndynMod:                   	; undyn mod on loading
	bchg	#4,DiskBitFlags+2
ShowUndynModTogl:
	btst	#4,DiskBitFlags+2
	sne	d0
	MOVE.W	#113*80+62,D6
	bra	DoShowToggle

ToggleDmaconr:				; use dmaconr/AUDDAT
	bchg	#4,MiscBitFlags+3
ShowDmaconrTogl:
	btst	#4,MiscBitFlags+3
	sne	d0
	MOVE.W	#47*80+36,D6
	bra	DoShowToggle

;------------------------------------------

ToggleCache:
	bchg	#2,DiskBitFlags+2	; DirCacheFlag
ShowVUMetersTogl:
	btst	#2,DiskBitFlags+2	; DirCacheFlag
	sne	d0
	MOVE.W	#80*80+76,D6
	bra	DoShowToggle

ToggleVUMeterMode:
	addq.b	#1,VUMeterMode
	cmp.b	#3,VUMeterMode
	bmi.s	.cnt
	clr.b	VUMeterMode
.cnt	bsr	ShowVUMeters
ShowVUMeterModeTogl:
	lea	.text(pc),a0
	moveq	#0,d0
	MOVE.B	VUMeterMode,d0
	lsl.w	#2,d0
	lea	(a0,d0.w),a0
	move.w	#382,d0
	move.w	#113,d1
	moveq	#4,d3
	jmp	ShowAnyText3
.text	dc.b	'None'
	dc.b	'Fake'
	dc.b	'Real'
	cnop	0,2

TogglePower:
	add.b	#1,PowerFlag
	cmp.b	#5,PowerFlag
	bmi.s	.cnt
	clr.b	PowerFlag
.cnt
ShowPowerTogl:
	lea	.text(pc),a0
	moveq	#0,d0
	move.b	PowerFlag,d0	
	mulu	#6,d0
	lea	(a0,d0.w),a0
	move.w	#370,d0
	moveq	#102,d1
	moveq	#6,d3
	jmp	ShowAnyText3
.text	dc.b	'  FAST'
	dc.b	'MEDIUM'
	dc.b	'  GOOD'
	dc.b	'BETTER'
	dc.b	'  BEST'
	cnop	0,2

ClearSplit:
	BSR	WaitForButtonUp
	LEA	ClearSplitText,A0
	BSR	AreYouSure
	RNE
	LEA	SplitData,A0
	MOVEQ	#15,D0
.loop	CLR.B	(A0)+
	DBRA	D0,.loop
	;BRA	ShowSplit
ShowSplit:
	BSR	CalculateSplit
	LEA	SplitData,A3
	MOVE.L	NoteNamesPtr,A4
	MOVEQ	#0,D5
	MOVE.W	#14*80+40,D6
	CLR.W	WordNumber
.loop	MOVE.W	D6,TextOffset
	MOVE.B	0(a3,D5.W),WordNumber+1 ; instr
	JSR	PrintHexByte
	ADDQ.W	#4,D6
	MOVE.W	D6,D1
	MOVEQ	#0,D0
	MOVE.B	1(A3,D5.W),D0 		; note
	LSL.W	#2,D0
	LEA	0(a4,D0.W),A0
	MOVEQ	#4,D0
	JSR	ShowText3
	ADDQ.L	#5,D6
	MOVE.W	D6,D1
	MOVEQ	#0,D0
	MOVE.B	2(A3,D5.W),D0 		; trans
	LSL.W	#2,D0
	LEA	0(a4,D0.W),A0
	MOVEQ	#4,D0
	JSR	ShowText3
	ADD.W	#10*80+71,D6
	ADDQ.W	#4,D5
	CMP.W	#16,D5
	BNE.S	.loop
	RTS

CalculateSplit:
	LEA	SplitTransTable,A0
	LEA	SplitInstrTable,A1
	LEA	SplitData,A2
	MOVEQ	#0,D0
.loop	MOVE.B	D0,0(a0,D0.W)
	CLR.B	0(a1,D0.W)
	ADDQ.W	#1,D0
	CMP.W	#37,D0
	BLS.S	.loop

	MOVE.B	1(A2),-(SP)
	MOVE.B	1+4(A2),-(SP)
	MOVE.B	1+8(A2),-(SP)
	MOVE.B	1+12(A2),-(SP) 		; note

	MOVEQ	#3,D4
.bigloop
	MOVEQ	#127,D0
	MOVEQ	#0,D1
	MOVEQ	#0,D2
.loop2	CMP.B	1(A2,D1.W),D0 		; note
	BLS.S	.skip
	MOVE.L	D1,D2
	MOVE.B	1(A2,D1.W),D0 		; note
.skip	ADDQ.W	#4,D1
	CMP.W	#16,D1
	BNE.S	.loop2

	MOVEQ	#0,D0
	MOVE.B	1(A2,D2.W),D0 		; note
	MOVE.B	#127,1(A2,D2.W) 	; note
	MOVE.B	2(A2,D2.W),D1 		; trans
.loop3	MOVE.B	D1,0(a0,D0.W)
	MOVE.B	0(a2,D2.W),0(a1,D0.W) 	; instr
	ADDQ.W	#1,D1
	CMP.W	#36,D1
	BLO.S	.skip2
	MOVEQ	#35,D1
.skip2	ADDQ.W	#1,D0
	CMP.W	#36,D0
	BLO.S	.loop3
	DBRA	D4,.bigloop

	MOVE.B	(SP)+,1+12(A2)
	MOVE.B	(SP)+,1+8(A2)
	MOVE.B	(SP)+,1+4(A2)
	MOVE.B	(SP)+,1(A2) 		; note
	RTS

SetSplit:
	LEA	SplitData,A2
	SUBQ.W	#1,D1
	DIVU	#11,D1
	SUBQ.W	#1,D1
	MOVE.W	D1,D7
	LSL.W	#2,D7			;/4
	MULU	#11*80,D1
	ADD.W	#15*80,D1
	CMP.W	#386,D0			; OBS
	BHS.S	SetSplitTranspose
	CMP.W	#346,D0			; OBS
	BHS.S	SetSplitNote
	ADD.W	#40,D1
	MOVE.W	D1,TextOffset
	BSR	GetHexByte
	CMP.B	#$1F,D0
	BLS.S	.skip
	MOVE.B	#$1F,D0
.skip	MOVE.B	D0,0(a2,D7.W) 		; instr
	BRA	ShowSplit

SetSplitNote:                 ;s
	MOVE.L	D1,-(SP)
	BSR	ShowSplit
	MOVE.L	(SP)+,D1
	ADD.W	#44,D1
	MOVEQ	#3,D0
	LEA	SpcNoteText,A0
	JSR	ShowText3
	LEA	1(A2,D7.W),A0 		; note
	MOVE.L	A0,SplitAddress
	BRA	WaitForButtonUp

SetSplitTranspose:
	MOVE.L	D1,-(SP)
	BSR	ShowSplit
	MOVE.L	(SP)+,D1
	ADD.W	#49,D1
	MOVEQ	#3,D0
	LEA	SpcNoteText,A0
	JSR	ShowText3
	LEA	2(A2,D7.W),A0 		; trans
	MOVE.L	A0,SplitAddress
	BRA	WaitForButtonUp

SetKeyRepeat:
	cmp.w	#396,d0
	bhi.b	SetKeyRepeat2
SetKeyRepeat1:
	move.w	#378,d0
	moveq	#58,d1
	BSR	GetAnyHexByte
	MOVE.B	D0,KeyRepDelay+1
	BRA.S	ShowKeyRepeat
SetKeyRepeat2:
	move.w	#378+8*3,d0
	moveq	#58,d1
	BSR	GetAnyHexByte
	MOVE.B	D0,KeyRepSpeed+1
ShowKeyRepeat:
	move.w	#378,d0
	moveq	#58,d1
	MOVE.W	KeyRepDelay,WordNumber
	JSR	PrintAnyHexByte
	add.w	#8*3,d0
	MOVE.W	KeyRepSpeed,WordNumber
	JMP	PrintAnyHexByte

ToggleAccidental:
	MOVE.L	#NoteNames1,NoteNamesPtr
	bchg	#2,EditBitFlags+3		;Accidental
	BNE.S	ShowAccidental
	MOVE.L	#NoteNames2,NoteNamesPtr
ShowAccidental:
	LEA	AccidentalText(PC),A0
	btst	#2,EditBitFlags+3	;Accidental
	BEQ.S	.skip
	LEA	AccidentalText+1(PC),A0
.skip	move.w	#404,d0
	moveq	#69,d1
	moveq	#1,d3
	JSR	ShowAnyText3
	JMP	RedrawPattern

AccidentalText:	dc.b '#B'

;--- Loading and saveing setupdata ----

LoadConfigName:
	LEA	LoadConfigText,A0
	BSR	AreYouSure
	RNE
	BSR	WaitForButtonUp
	LEA	LoadingCfgText(PC),A0
	JSR	ShowStatusText
	bra.s	DoLoadConfigName
SetLoadConfig:
	LEA	LoadConfigText,A0
	BSR	AreYouSure
	RNE
	BSR	WaitForButtonUp
	LEA	LoadingCfgText(PC),A0
	JSR	ShowStatusText
DoLoadConfig:
	BSR	StorePtrCol
	BSR	PutConfigNumber
	lea	FileName,a1		; no path = current dir
	move.w	#"S:",(a1)+
	LEA	ConfigName(PC),A0
	MOVEQ	#12,D0
.lop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.lop
DoLoadConfigName:
	MOVE.L	#FileName,D1
	MOVE.L	#1005,D2
	MOVE.L	DosBase,A6
	JSR	LVOOpen(A6)
	move.l	d0,FileHandle
	beq	.notfil

	BSR	SetDiskPtrCol

	bsr	ReadIFFHeader
	beq.w	.fileerror
	cmp.l	#"FORM",(a0)
	bne.w	.notiff
	cmp.l	#"PTCF",8(a0)
	bne.w	.notiff

.iffloop
	bsr	ExamineChunk	; check the IFF chunk
	bmi.w	.fileerror
	beq.s	.exit
	move.l	d0,.length

	cmp.l	#"MISC",(a0)
	beq.s	.readmiscsetup
	cmp.l	#"SCRN",(a0)
	beq.s	.readscreensetup
	cmp.l	#"EDIT",(a0)
	beq.w	.readeditsetup
	cmp.l	#"DISK",(a0)
	beq.w	.readdisksetup

	bsr	SkipChunk	; skip chunk if it's unknown
	bne.w	.fileerror
	bra.s	.iffloop
.exit	clr.l	DiskDataLength
	move.l	FileHandle,d1
	beq.s	.cnt9
	MOVE.L	DosBase,A6
	JSR	LVOClose(A6)
.cnt9	JSR	ShowAllRight
	BSR	RestorePtrCol
	bsr	TranslateSetupData
	bsr	ShowFilterTogl
	JSR	SetupVUCols
	BRA	RefreshSetup
.length	dc.l	0
.readmiscsetup
	move.l	MiscSetupPtr(pc),d2
	beq	.iffloop
	move.l	d2,a0
	move.l	.length(pc),d0
	bsr	ReadAndSkipChunk
	beq.s	.exit
	bmi.s	.fileerror
	bra	.iffloop
.readscreensetup
	move.l	ScreenSetupPtr(pc),d2
	beq	.iffloop
	move.l	d2,a0
	move.l	.length(pc),d0
	bsr	ReadAndSkipChunk
	beq.s	.exit
	bmi.s	.fileerror
	bra	.iffloop
.readeditsetup
	move.l	EditSetupPtr(pc),d2
	beq	.iffloop
	move.l	d2,a0
	move.l	.length(pc),d0
	bsr	ReadAndSkipChunk
	beq.s	.exit
	bmi.s	.fileerror
	bra	.iffloop
.readdisksetup
	move.l	DiskSetupPtr(pc),d2
	beq	.iffloop
	move.l	d2,a0
	move.l	.length(pc),d0
	bsr	ReadAndSkipChunk
	beq.w	.exit
	bmi.w	.fileerror
	bra	.iffloop
.notfil	LEA	FileNotFoundText(PC),A0
	bra.s	.error
.notiff	LEA	NotAConfFileText(PC),A0
	bra.s	.error
.fileerror
	LEA	ConfigReadErText(PC),A0
.error	JSR	ShowStatusText
	tst.l	CopListPtr
	REQ
	MOVE.W	#50,WaitTime
	bsr	ErrorRestoreCol
	bra.w	.exit

	cnop	0,4
MiscSetupPtr:	dc.l	0
ScreenSetupPtr:	dc.l	0
EditSetupPtr:	dc.l	0
DiskSetupPtr:	dc.l	0
DefColPtr:	dc.l	0
DefVUColPtr:	dc.l	0

SetSaveConfig:
	LEA	SaveConfigText,A0
	BSR	AreYouSure
	RNE
	BSR	StorePtrCol
	BSR	SetDiskPtrCol
	BSR	PutConfigNumber
	LEA	SavingCfgText(PC),A0
	JSR	ShowStatusText
	bsr	MakeSetupFile
	MOVE.L	DosBase,A6
	lea	FileName,a1		; no path = current dir
	move.w	#"S:",(a1)+
	LEA	ConfigName(PC),A0
	MOVEQ	#12,D0
.lop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.lop
	MOVE.L	#FileName,D1
	MOVE.L	#1006,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,D7
	BEQ.s	.err3
	MOVE.L	D0,D1
	lea	SetupFileData,a0
	move.l	a0,d2		; config file adr
	move.l	4(a0),d3
	add.l	#8,d3		; config file size
	JSR	LVOWrite(A6)
	MOVE.L	D7,D1
	JSR	LVOClose(A6)
	JSR	ShowAllRight
	BRA	RestorePtrCol
.err3	LEA	CantCreateFiText(PC),A0
	JSR	ShowStatusText
	tst.l	CopListPtr
	REQ
	MOVE.W	#50,WaitTime
	bra	ErrorRestoreCol

FileNotFoundText dc.b "config not found!",0
NotAConfFileText dc.b "not a config file",0
CantCreateFiText dc.b "can't create file",0
ConfigReadErText dc.b "error while reading config",0
	cnop	0,2

SetConfigNumber:
	MOVE.W	#25*80+11,TextOffset
	BSR	GetHexByte
	MOVE.W	D0,ConfigNumber
ShowConfigNumber:
	MOVE.W	#25*80+11,TextOffset
	MOVE.W	ConfigNumber(PC),WordNumber
	JMP	PrintHexByte

PutConfigNumber:
	MOVE.W	ConfigNumber(PC),D0
	LEA	ConfigName+12(PC),A0
	JMP	IntToHex2

ConfigName:	dc.b 'PT.config-00',0,0
ConfigNumber:	dc.w 0
LoadingCfgText:	dc.b 'loading config',0
SavingCfgText:	dc.b 'saving config',0,0

InitSetupFile:
	lea	DefaultSetupFile,a0
	lea	SetupFileData,a1
	move.w	#setuplen+8-1,d0
.loop	move.b	(a0)+,(a1)+		; Copy defualt setupfile
	dbf	d0,.loop

	lea	SetupFileData+4,a0
	move.l	(a0)+,d1
	beq.s	.end
	btst	#0,d1
	bne.s	.end
	lea	(a0,d1.l),a1
	lea	4(a0),a0
.loop2	move.l	(a0),d1
	cmp.l	#"MISC",d1
	bne.s	.cnt1
	move.l	a0,MiscSetupPtr
.cnt1	cmp.l	#"SCRN",d1
	bne.s	.cnt2
	move.l	a0,ScreenSetupPtr
.cnt2	cmp.l	#"EDIT",d1
	bne.s	.cnt3
	move.l	a0,EditSetupPtr
.cnt3	cmp.l	#"DISK",d1
	bne.s	.cnt4
	move.l	a0,DiskSetupPtr
.cnt4	addq.l	#4,a0
	move.l	(a0)+,d1
	ble.s	.end
	btst	#0,d1
	bne.s	.end
	add.l	d1,a0
	cmp.l	a1,a0
	ble.s	.loop2
.end
	move.l	ScreenSetupPtr(pc),a0
	sub.l	#SetupFileData,a0
	add.l	#DefaultSetupFile+16,a0
	move.l	a0,DefColPtr
	lea	16(a0),a0
	move.l	a0,DefVUColPtr

	bsr	TranslateSetupData
	bsr	ShowFilterTogl
	rts

ResetAll:
	LEA	ResetAllText,A0
	BSR	AreYouSure
	RNE
DoResetAll:
	bsr	InitSetupFile
	MOVE.L	GfxBase,A0
	MOVE.W	206(A0),D0		; DisplayFlags
	BTST	#2,D0			; PAL/NTSC?
	BEQ.S	.NTSC
	bclr	#0,ScrnBitFlags+3	; NTSCFlag
	bra.s	.cnt
.NTSC	bset	#0,ScrnBitFlags+3	; NTSCFlag
.cnt	BRA	RefreshSetup

TranslateSetupData:
	;tst.l	CopListPtr
	;beq.s	.cnt1
	;jsr	ResetMusicInt
.cnt1	bsr	TransMiscSetup
	bsr	TransScreenSetup
	bsr	TransEditSetup
	bsr	TransDiskSetup
	;tst.l	CopListPtr
	;beq.s	.cnt2
	;jsr	SetMusicInt
.cnt2	rts

TransMiscSetup:
	move.l	MiscSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0
	move.l	(a0)+,MiscBitFlags

	move.w	(a0)+,TuneNote
	move.w	(a0)+,TToneVol
	move.w	(a0)+,d0;TToneIns

	move.w	(a0)+,Tempo
	move.w	Tempo,RealTempo
	move.w	(a0)+,DefaultSpeed
	move.w	(a0)+,d0	; was DMAWait

	lea	PrintPath,a1
	moveq	#32-1,d0
.loop	move.b	(a0)+,(a1)+
	dbf	d0,.loop

	move.w	(a0)+,KeyRepDelay
	move.w	(a0)+,KeyRepSpeed

.end	rts

TransScreenSetup:
	move.l	ScreenSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0
	move.l	(a0)+,ScrnBitFlags

	move.w	(a0)+,ScrXPos
	move.w	(a0)+,ScrYPos

	lea	ColorTable,a1
	moveq	#8-1,d0
.loop1	move.w	(a0)+,(a1)+
	dbf	d0,.loop1

	lea	VUMeterColors,a1
	moveq	#48-1,d0
.loop2	move.w	(a0)+,(a1)+
	dbf	d0,.loop2

	move.b	(a0)+,VUMeterMode

.end	rts

TransEditSetup:
	move.l	EditSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0
	move.l	(a0)+,EditBitFlags

	move.l	(a0)+,MultiModeNext
	lea	SplitData,a1
	moveq	#4*4-1,d0
.loop1	move.b	(a0)+,(a1)+
	dbf	d0,.loop1
	lea	EffectMacros,a1
	moveq	#10-1,d0
.loop2	move.w	(a0)+,(a1)+
	dbf	d0,.loop2
.end	rts

TransDiskSetup:
	move.l	DiskSetupPtr(pc),d0
	beq.w	.end
	add.l	#4*2,d0
	move.l	d0,a0
	move.l	(a0)+,DiskBitFlags

	move.b	(a0)+,RAWIFFMode
	move.b	(a0)+,PowerFlag

	lea	DirPathList,a1
	lea	DefPathList,a2
	moveq	#6-1,d0
.loop1	moveq	#32-1,d1
.loop2	move.b	(a0),(a1)+
	move.b	(a0)+,(a2)+
	dbf	d1,.loop2
	lea	108-32(a0),a0
	dbf	d0,.loop1

	lea	MaskTab,a1
	move.w	#(32*6)-1,d0
.loop3	move.b	(a0)+,(a1)+
	dbf	d0,.loop3

.end	rts

MakeSetupFile:
	bsr	MakeMiscSetup
	bsr	MakeScreenSetup
	bsr	MakeEditSetup
	bsr	MakeDiskSetup
	rts

MakeMiscSetup:
	move.l	MiscSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0

	move.l	MiscBitFlags,(a0)+

	move.w	TuneNote,(a0)+
	move.w	TToneVol,(a0)+
	move.w	#$1f,(a0)+;TToneIns

	move.w	Tempo,(a0)+
	move.w	DefaultSpeed,(a0)+
	clr.w	(a0)+		; Was DMAWait

	lea	PrintPath,a1
	moveq	#32-1,d0
.loop	move.b	(a1)+,(a0)+
	dbf	d0,.loop

	move.w	KeyRepDelay,(a0)+
	move.w	KeyRepSpeed,(a0)+

.end	rts

MakeScreenSetup:
	move.l	ScreenSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0

	move.l	ScrnBitFlags,(a0)+

	move.w	ScrXPos,(a0)+
	move.w	ScrYPos,(a0)+

	lea	ColorTable,a1
	moveq	#8-1,d0
.loop1	move.w	(a1)+,(a0)+
	dbf	d0,.loop1

	lea	VUMeterColors,a1
	moveq	#48-1,d0
.loop2	move.w	(a1)+,(a0)+
	dbf	d0,.loop2

	move.b	VUMeterMode,(a0)+

.end	rts

MakeEditSetup:
	move.l	EditSetupPtr(pc),d0
	beq.s	.end
	add.l	#4*2,d0
	move.l	d0,a0

	move.l	EditBitFlags,(a0)+

	move.l	MultiModeNext,(a0)+
	lea	SplitData,a1
	moveq	#4*4-1,d0
.loop1	move.b	(a1)+,(a0)+
	dbf	d0,.loop1
	lea	EffectMacros,a1
	moveq	#10-1,d0
.loop2	move.w	(a1)+,(a0)+
	dbf	d0,.loop2
.end	rts

MakeDiskSetup:
	move.l	DiskSetupPtr(pc),d0
	beq.w	.end
	add.l	#4*2,d0
	move.l	d0,a0

	move.l	DiskBitFlags,(a0)+

	move.b	RAWIFFMode,(a0)+
	move.b	PowerFlag,(a0)+

	lea	DirPathList,a1
	moveq	#6-1,d0
.loop1	moveq	#32-1,d1
.loop2	move.b	(a1)+,(a0)+
	dbf	d1,.loop2
	lea	108-32(a0),a0
	dbf	d0,.loop1

	lea	MaskTab,a1
	move.w	#(32*6)-1,d0
.loop3	move.b	(a1)+,(a0)+
	dbf	d0,.loop3

.end	rts

;------- General IFF routines -----

; Returns length in d0, and Pointer to IFF header in a0
; d0=0 -=> error
ReadIFFHeader:
	move.l	FileHandle,d1
	lea	TempFileBuf,a0
	move.l	a0,d2
	MOVE.L	#4*3,D3		; three longwords
	MOVE.L	DosBase,A6
	JSR	LVORead(A6)
	cmp.l	#4*3,d3
	bne.s	.error
	lea	TempFileBuf,a0
	move.l	4(a0),d0
	subq.l	#4,d0
	move.l	d0,IFFLength
	move.l	d0,IFFReadCnt
	rts
.error	moveq	#0,d0
	rts

; Returns chunk length in d0, and address of chunk header in a0
; d0=0  = end of file
; d1=-1 = file mismatch
ExamineChunk:
	tst.l	IFFReadCnt
	beq.s	.eof
	move.l	FileHandle,d1
	lea	TempFileBuf,a0
	move.l	a0,d2
	MOVE.L	#4*2,D3		; two longwords
	MOVE.L	DosBase,A6
	JSR	LVORead(A6)
	cmp.l	#4*2,d0
	bne.s	.error
	sub.l	d0,IFFReadCnt
	bmi.s	.error
	lea	TempFileBuf,a0
	move.l	4(a0),d0
	rts
.eof	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

; Requires length in d0
; returns d0=0 if ok

SkipChunk:
	sub.l	d0,IFFReadCnt
	bmi.s	.error
	move.l	FileHandle,d1
	move.l	d0,d2		; number of bytes to seek
	moveq	#0,d3		; seek from current pos.
	MOVE.L	DosBase,A6
	JSR	LVOSeek(A6)
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

; Requires length in d0 and address in a0
ReadChunk:
	move.l	FileHandle,d1
	move.l	a0,d2
	MOVE.L	d0,D3
	MOVE.L	DosBase,A6
	move.l	d3,-(sp)
	JSR	LVORead(A6)
	move.l	(sp)+,d3
	cmp.l	d0,d3
	bne.s	.error
	sub.l	d0,IFFReadCnt
	bmi.s	.error
	move.l	IFFReadCnt(pc),d0
	rts
.error	moveq	#-1,d0
	rts

; d0 = Length of chunk in file, a0 = adress of chunk in memory
ReadAndSkipChunk:
	move.l	4(a0),d1
	move.l	d0,d2
	sub.l	d1,d2
	bpl.s	.cnt
	moveq	#0,d2		; Skip nothing in the file
	exg	d0,d1
.cnt	move.l	d1,d0
	lea	8(a0),a0	; Data will be inserted after chunk header
	move.l	d2,d7
	bsr	ReadChunk
	bmi.s	.error
	beq.s	.end
	move.l	d7,d0
	beq.s	.ok
	bsr	SkipChunk
	bne.s	.error
.ok	moveq	#1,d0
	rts
.end	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

	cnop	0,4
IFFLength:	dc.l	0
IFFReadCnt:	dc.l	0

;-------------------------------

MultiSetup:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	MOVE.W	#1,GetLineFlag
	move.w	MouseX2,d0
	SUB.W	#412+4-8,D0
	bpl.b	.cn1
	moveq	#0,d0
.cn1	LSR.W	#4,D0
	cmp.w	#4,d0
	bmi.b	.cn2
	moveq	#3,d0
.cn2	MOVE.B	D0,musepos
.set	MOVEQ	#0,D1
	MOVE.B	musepos,D1
	LSL.W	#4,D1
	MOVE.W	#412+4,LineCurX
	MOVE.W	#91+5,LineCurY
	ADD.W	D1,LineCurX
	BSR	UpdateLineCurPos
.lop	BSR	GetHexKey
	cmp.b	#0,d1
	beq.s	.nul
	CMP.B	#4,D1
	BHI.S	.abo
	move.b	musepos,d0
	and.w	#3,d0
	LEA	MultiModeNext,A1
	move.b	d1,(a1,D0.W)
	BSR	ShowMultiSetup
	MOVEQ	#1,D0
.nul	TST.B	D0
	BEQ.S	.abo
	ADD.B	D0,musepos
	AND.B	#3,musepos
	BSR	Wait_4000
	BSR	Wait_4000
	BSR	Wait_4000
	BRA.w	.set
.abo	BSR	RestorePtrCol
	CLR.W	GetLineFlag
	MOVE.W	#0,LineCurX
	MOVE.W	#270,LineCurY
	BRA	UpdateLineCurPos

ShowMultiSetup:
	move.w	#412,d0
	moveq	#91,d1
	MOVE.B	MultiModeNext,D3
	JSR	PrintAnyHexDigit
	add.w	#8*2,d0
	MOVE.B	MultiModeNext+1,D3
	JSR	PrintAnyHexDigit
	add.w	#8*2,d0
	MOVE.B	MultiModeNext+2,D3
	JSR	PrintAnyHexDigit
	add.w	#8*2,d0
	MOVE.B	MultiModeNext+3,D3
	JMP	PrintAnyHexDigit

	cnop	0,4
musepos:dc.b 0,0

SetRed:	;CMP.W	#82,D0
	;BHS	SelectColor
.setr2	bsr	CheckNTSCPos
	BSR	GetColPos
	AND.W	#$0F00,D2
	LSR.W	#8,D2
	CMP.B	D2,D0
	BEQ.S	.skp
	AND.W	#$00FF,D1
	LSL.W	#8,D0
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	SetScreenColors
.skp	BTST	#6,$BFE001
	BEQ.S	.setr2
	RTS

SetGreen:
	;CMP.W	#82,D0
	;BHS	SelectColor
.setg2	bsr	CheckNTSCPos
	BSR.S	GetColPos
	AND.W	#$00F0,D2
	LSR.W	#4,D2
	CMP.B	D2,D0
	BEQ.S	.skp
	AND.W	#$0F0F,D1
	LSL.W	#4,D0
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	SetScreenColors
.skp	BTST	#6,$BFE001
	BEQ.S	.setg2
	RTS

SetBlue:;CMP.W	#82,D0
	;BHS	SelectColor
.setb2	bsr	CheckNTSCPos
	BSR.S	GetColPos
	AND.W	#$000F,D2
	CMP.B	D2,D0
	BEQ.S	.skp
	AND.W	#$0FF0,D1
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	SetScreenColors
.skp	BTST	#6,$BFE001
	BEQ.S	.setb2
	RTS

GetColPos:
	MOVEQ	#0,D0
	MOVE.W	MouseX,D0
	CMP.W	#26,D0
	BHS.S	.skp2
	MOVEQ	#0,D0
	BRA.S	gcpskip
.skp2	SUB.W	#26,D0
	DIVU	#3,D0
	AND.L	#$FF,D0
	CMP.W	#15,D0
	BLS.S	gcpskip
	MOVEQ	#15,D0
gcpskip:tst.w	ColEdMode
	BNE	GetColAddr
	LEA	ColorTable,A0
	MOVE.W	CurrColor,D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	MOVE.W	(A0),D1
	MOVE.W	D1,D2
	RTS

ShowColSliders:
	LEA	ColSliders(PC),A2
	MOVE.L	TextBplPtr,A1
	ADD.L	#70*80+2,A1
	BSR.S	gcpskip
	AND.W	#$000F,D1
	BSR.S	ShowOneSlider
	MOVE.L	TextBplPtr,A1
	ADD.L	#59*80+2,A1
	BSR.S	gcpskip
	AND.W	#$00F0,D1
	LSR.W	#4,D1
	BSR.S	ShowOneSlider
	MOVE.L	TextBplPtr,A1
	ADD.L	#48*80+2,A1
	BSR.S	gcpskip
	AND.W	#$0F00,D1
	LSR.W	#8,D1
ShowOneSlider:
	CLR.L	(A1)
	CLR.L	4(A1)
	CLR.L	80(A1)
	CLR.L	84(A1)
	CLR.L	160(A1)
	CLR.L	164(A1)
	MOVE.W	D1,D3
	ADD.W	D3,D3
	ADD.W	D3,D3
	MOVE.W	2(A2,D3.W),D4
	MOVE.B	0(A2,D3.W),00(A1,D4)
	MOVE.B	1(A2,D3.W),01(A1,D4)
	MOVE.B	0(A2,D3.W),80(A1,D4)
	MOVE.B	1(A2,D3.W),81(A1,D4)
	move.l	a1,-(sp)
	add.l	#160,a1
	MOVE.B	0(A2,D3.W),(A1,D4)
	MOVE.B	1(A2,D3.W),1(A1,D4)
	move.l	(sp)+,a1
	RTS

ColSliders:
	dc.w %0000000001111100,0
	dc.w %0000111110000000,1
	dc.w %0000000111110000,1
	dc.w %0000000000111110,1
	dc.w %0000011111000000,2
	dc.w %0000000011111000,2
	dc.w %0000000000011111,2
	dc.w %0000001111100000,3
	dc.w %0000000001111100,3
	dc.w %0000111110000000,4
	dc.w %0000000111110000,4
	dc.w %0000000000111110,4
	dc.w %0000011111000000,5
	dc.w %0000000011111000,5
	dc.w %0000000000011111,5
	dc.w %0000001111100000,6

SelectColor:
	tst.w	ColEdMode
	beq.s	.selcol
	movem.w	d0-d1,-(sp)
	bsr.w	DelSelect2
	movem.w	(sp)+,d0-d1
.selcol	clr.w	ColEdMode
	MOVE.L	TextBplPtr,A0
	LEA	48*80+10(A0),A0
	MOVEQ	#24,D2
.loop	CLR.L	(A0)
	LEA	80(A0),A0
	DBRA	D2,.loop

	SUB.W	#82,D0
	DIVU	#13,D0
	SUB.W	#49,D1
	DIVU	#6,D1
	MOVE.W	D0,D2
	LSL.W	#2,D2
	ADD.W	D1,D2
	MOVE.W	D2,CurrColor
MarkColor:
	BSR	gcpskip
	MOVE.L	A0,UndoColAddr
	MOVE.W	D1,UndoCol
	BSR	ShowColSliders
	BSR.W	BlockColors
	MOVE.W	CurrColor,D0
	MOVE.W	D0,D1
	AND.W	#$0003,D1
	MULU	#6*80,D1
	MOVE.L	TextBplPtr,A0
	ADD.L	D1,A0
	LEA	48*80+10(A0),A0
	BTST	#2,D0
	BNE.S	.skip
	MOVE.W	#$3FF0,(A0)
	MOVE.W	#$3FF0,6*80(A0)
	MOVEQ	#5-1,D0
.lop2	LEA	80(A0),A0
	MOVE.W	#$2010,(A0)
	DBRA	D0,.lop2
	bsr.w	CheckCopy
	bsr.w	CheckSwap
	BRA	WaitForButtonUp

.skip	MOVE.L	#$0001FF80,(A0)
	MOVE.L	#$0001FF80,6*80(A0)
	MOVEQ	#4,D0
.lop3	LEA	80(A0),A0
	MOVE.L	#$0001FF80,(A0)
	DBRA	D0,.lop3
	bsr.w	CheckCopy
	bsr.w	CheckSwap
	BRA	WaitForButtonUp

BlockColors:
	MOVE.L	TextBplPtr,A0
	LEA	49*80+12(A0),A0
	MOVEQ	#4-1,D1			;this many blocks
.loop2	MOVEQ	#5-1,D0			;this many lines pr. block
.loop3	MOVE.B	#$FF,(A0)
	ADD.L	#80,A0
	DBRA	D0,.loop3
	ADD.L	#80,A0
	DBRA	D1,.loop2
	RTS

CheckCopy:
	TST.W	CopyFlag
	REQ
	clr.w	CopyFlag
	LEA	ColorTable,A0
	MOVE.W	CopyFrom(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	move.w	(a0),d2
	LEA	ColorTable,A0
	MOVE.W	CurrColor(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	move.w	d2,(a0)
	BSR	SetScreenColors
	rts

CheckSwap:
	TST.W	SwapFlag
	REQ
	clr.w	SwapFlag
	LEA	ColorTable,A0
	move.l	a0,a1
	MOVE.W	SwapFrom(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	MOVE.W	CurrColor(pc),D1
	ADD.W	D1,D1
	LEA	0(a1,D1.W),A1
	move.w	(a0),d2
	move.w	(a1),(a0)
	move.w	d2,(a1)
	BSR	SetScreenColors
	rts

CopyColor:
	MOVE.W	CurrColor,CopyFrom
	MOVE.W	#1,CopyFlag
	clr.w	SwapFlag
	RTS

SwapColor:
	MOVE.W	CurrColor,SwapFrom
	MOVE.W	#1,SwapFlag
	clr.w	CopyFlag
	RTS

	cnop	0,4
CopyFrom:	dc.w 0
CopyFlag:	dc.w 0
SwapFrom:	dc.w 0
SwapFlag:	dc.w 0

UndoColor:
	MOVE.L	UndoColAddr,A0
	MOVE.W	UndoCol,D0
	MOVE.W	(A0),UndoCol
	MOVE.W	D0,(A0)
	BSR	ShowColSliders
	BRA	SetScreenColors

DelSelect:
	MOVE.L	TextBplPtr,A0
	lea	48*80+10(a0),a0
	moveq	#4-1,d0
.loop	clr.l	(a0)
	move.l	#$0000ff00,80(a0)
	move.l	#$0000ff00,80*2(a0)
	move.l	#$0000ff00,80*3(a0)
	move.l	#$0000ff00,80*4(a0)
	move.l	#$0000ff00,80*5(a0)
	clr.l	80*6(a0)
	lea	80*6(a0),a0
	dbf	d0,.loop
	clr.w	CopyFlag
	clr.w	SwapFlag
	rts

CancelCol:
	LEA	CanCols(PC),A0
	LEA	ColorTable,A1
	MOVEQ	#7,D0
cacolop	MOVE.W	(A0)+,(A1)+
	DBRA	D0,cacolop
	BSR	ShowColSliders
	BRA	SetScreenColors

CopyCfgData:
	LEA	ColorTable,A0
	LEA	CanCols(PC),A1
	MOVEQ	#7,D0
.loop1	MOVE.W	(A0)+,(A1)+
	DBRA	D0,.loop1
	LEA	VUMeterColors,A0
	LEA	SaveColors,A1
	MOVEQ	#40+48-1,D0
.loop2	MOVE.W	(A0)+,(A1)+
	DBRA	D0,.loop2
	RTS

	cnop	0,4
UndoCol:	dc.w 0
UndoColAddr:	dc.l 0
CanCols:	dcb.w 9,0

SetDefaultCol:
	move.l	DefColPtr,A0
	LEA	ColorTable,A1
	MOVEQ	#7,D0
sdcloop	MOVE.W	(A0)+,(A1)+
	DBRA	D0,sdcloop
	BSR	ShowColSliders
SetScreenColors:
SetScreenColors2:
	LEA	ColorTable,A0
	LEA	CopCol0,A1
	MOVE.W	(A0),(A1)
	MOVE.W	2(A0),4(A1)
	MOVE.W	4(A0),8(A1)
	MOVE.W	6(A0),12(A1)
	MOVE.W	8(A0),16(A1)
	MOVE.W	10(A0),20(A1)
	MOVE.W	12(A0),24(A1)
	MOVE.W	14(A0),28(A1)
	MOVE.W	14(A0),D0
	TST.W	SamScrEnable
	BEQ.S	.cnt
	MOVE.W	8(A0),CopListInsPos+_SMPCOL
	bra.s	.cnt2
.cnt	MOVE.W	D0,NoteCol
	move.w	10(A0),EndColor
.cnt2	MOVE.W	10(A0),D0
	MOVE.W	D0,D4
	MOVE.W	#5,FadeX
	BSR.S	FadeCol
	MOVE.W	D0,32(A1)
	MOVE.W	D4,36(A1)
	MOVE.W	D4,D0
	MOVE.W	#-4,FadeX
	BSR.S	FadeCol
	MOVE.W	D0,40(A1)
	RTS

FadeCol:MOVE.W	D0,D1
	MOVE.W	D0,D2
	MOVE.W	D0,D3
	LSR.W	#8,D1
	ADD.W	FadeX(PC),D1
	BPL.S	redskp
	MOVEQ	#0,D1
redskp	CMP.W	#15,D1
	BLS.S	redskp2
	MOVEQ	#15,D1
redskp2	AND.W	#$00F0,D2
	LSR.W	#4,D2
	ADD.W	FadeX(PC),D2
	BPL.S	grnskp
	MOVEQ	#0,D2
grnskp	CMP.W	#15,D2
	BLS.S	grnskp2
	MOVEQ	#15,D2
grnskp2	AND.W	#$000F,D3
	ADD.W	FadeX(PC),D3
	BPL.S	bluskp
	MOVEQ	#0,D3
bluskp	CMP.W	#15,D3
	BLS.S	bluskp2
	MOVEQ	#15,D3
bluskp2	MOVE.W	D3,D0
	LSL.W	#4,D2
	OR.W	D2,D0
	LSL.W	#8,D1
	OR.W	D1,D0
	RTS

	cnop	0,4
CurrColor:	dc.w	0
FadeX:		dc.w	-3

EnterPrintPath:
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	LEA	PrintPath,A6
	MOVE.L	A6,ShowTextPtr
	MOVE.L	A6,TextEndPtr
	ADD.L	#31,TextEndPtr
	MOVE.W	#12,TextLength
	MOVE.W	#91*80+40,A4
	BSR	GetTextLine
	BRA	RestorePtrCol

ShowPrintPath:
	LEA	PrintPath,A0
	MOVE.W	#91*80+40,D1
	MOVEQ	#12,D0
	JMP	ShowText3

; Print Song

PrintSong:
	LEA	PrintSongText,A0
	BSR	AreYouSure
	RNE
	BSR	StorePtrCol
	MOVE.L	#PrintPath,D1
	MOVE.L	#1006,D2
	MOVE.L	DosBase,A6
	JSR	LVOOpen(A6)
	MOVE.L	D0,FileHandle
	JEQ	CantOpenFile
	BSR	SetDiskPtrCol
	LEA	PrintingSongText,A0
	JSR	ShowStatusText
	MOVE.L	FileHandle,D1
	MOVE.L	#SongDumpText,D2
	MOVEQ	#68,D3
	MOVE.L	DosBase,A6
	JSR	LVOWrite(A6)
	MOVE.L	FileHandle,D1
	MOVE.L	SongDataPtr,D2
	MOVEQ	#20,D3
	JSR	LVOWrite(A6)
	BSR	PrintCRLF
	BSR	PrintCRLF
	BSR	PrintSong2
	BSR	PrintCRLF
	BSR	PrintSong4
	BSR	PrintFormFeed
	MOVE.L	SongDataPtr,A0
	MOVEQ	#0,D0
	MOVE.B	sd_numofpatt(A0),D0
	LEA	sd_pattpos(A0),A0
	MOVEQ	#0,D7
ps_loop	CMP.B	0(a0,D0.W),D7
	BGT.S	ps_skip
	MOVE.B	0(a0,D0.W),D7
ps_skip	SUBQ.W	#1,D0
	BPL.S	ps_loop
	MOVEQ	#0,D1
ps_loop2
	MOVEM.L	D1-D7/A0-A6,-(SP)
	BSR	PrintPattern
	MOVEM.L	(SP)+,D1-D7/A0-A6
	TST.L	D0
	BNE.S	ps_skip2
	MOVEM.L	D1/D7,-(SP)
	BSR	PrintFormFeed
	MOVEM.L	(SP)+,D1/D7
	ADDQ.W	#1,D1
	CMP.W	D7,D1
	BLO.S	ps_loop2
ps_skip2
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	JSR	LVOClose(A6)
	clr.l	FileHandle
	BSR	ShowAllRight
	BRA	RestorePtrCol

PrintSong2:
	MOVEQ	#1,D7
ps2_2	MOVE.L	D7,D0
	LSR.B	#4,D0
	CMP.B	#9,D0
	BLS.S	spujk
	ADDQ.B	#7,D0
spujk	ADD.B	#'0',D0
	MOVE.B	D0,PattXText1
	MOVE.B	D7,D0
	AND.B	#$0F,D0
	CMP.B	#9,D0
	BLS.S	spujk2
	ADDQ.B	#7,D0
spujk2	ADD.B	#'0',D0
	MOVE.B	D0,PattXText2

	MOVE.L	SongDataPtr,A0
	MOVE.W	D7,D0
	MULU	#30,D0
	LEA	-10(A0,D0.W),A0
	LEA	PpText,A1
	MOVEQ	#21,D0
ps2_loop
	MOVE.B	#' ',(A1)+
	DBRA	D0,ps2_loop
	LEA	PpText,A1

	MOVE.L	A0,SavIt
ps2_loop2
	MOVE.B	(A0)+,D0
	BEQ	PrintSong3
	MOVE.B	D0,(A1)+
	BRA.S	ps2_loop2

	cnop	0,4
SavIt	dc.l	0

PrintSong3:
	MOVE.L	D7,-(SP) ; pattnum
	MOVE.L	SavIt(PC),A0
	MOVE.W	22(A0),D0
	ADD.W	D0,D0
	LEA	Prafs+2+4,A0
	JSR	IntToHexASCII
	MOVE.L	SavIt(PC),A0
	MOVE.W	26(A0),D0
	ADD.W	D0,D0
	LEA	Prafs+8+4,A0
	JSR	IntToHexASCII
	MOVE.L	SavIt(PC),A0
	MOVE.W	28(A0),D0
	ADD.W	D0,D0
	LEA	Prafs+14+4,A0
	JSR	IntToHexASCII
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	MOVE.L	#PtotText,D2
	MOVEQ	#52,D3
	JSR	LVOWrite(A6)
	MOVE.L	(SP)+,D7
	ADDQ.W	#1,D7
	CMP.W	#$0020,D7
	BNE	ps2_2
	RTS

PrintSong4:
	MOVE.L	SongDataPtr,A0
	MOVEQ	#0,D7
	MOVE.B	sd_numofpatt(A0),D7
	LEA	sd_pattpos(A0),A0
	MOVEQ	#0,D5
ps4_loop1
	MOVEQ	#0,D6
ps4_loop2
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0
	MOVE.W	D0,D1
	LSR.W	#4,D1
	ADD.B	#$30,D1
	CMP.B	#$39,D1
	BLS.S	ps4_skip
	ADDQ.B	#7,D1
ps4_skip
	AND.B	#15,D0
	ADD.B	#$30,D0
	CMP.B	#$39,D0
	BLS.S	ps4_skip2
	ADDQ.B	#7,D0
ps4_skip2
	LEA	PnText,A1
	MOVE.B	D1,(A1)+
	MOVE.B	D0,(A1)
	MOVEM.L	D5-D7/A0,-(SP)
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	MOVE.L	#PnText,D2
	MOVEQ	#4,D3
	JSR	LVOWrite(A6)
	MOVEM.L	(SP)+,D5-D7/A0
	ADDQ.W	#1,D5
	CMP.W	D5,D7
	REQ
	ADDQ.W	#1,D6
	CMP.W	#$0010,D6
	BNE.S	ps4_loop2
	MOVEM.L	D5-D7/A0,-(SP)
	BSR.S	PrintCRLF
	MOVEM.L	(SP)+,D5-D7/A0
	BRA.S	ps4_loop1

PrintCRLF:
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	MOVE.L	#CRLF_Text,D2
	MOVEQ	#2,D3
	JSR	LVOWrite(A6)
	RTS

PrintFormFeed:
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	MOVE.L	#FF_Text,D2
	MOVEQ	#1,D3
	JSR	LVOWrite(A6)
	RTS

PrintPattern:
	MOVE.L	D1,D6 			; D1=pattern number
	DIVU	#10,D6
	ADD.B	#'0',D6
	MOVE.B	D6,PattNumText1
	SWAP	D6
	ADD.B	#'0',D6
	MOVE.B	D6,PattNumText2
	MOVEM.L	D0-D7/A0-A6,-(SP)
	MOVE.L	FileHandle,D1
	MOVE.L	#PatternNumText,D2
	MOVEQ	#18,D3
	MOVE.L	DosBase,A6
	JSR	LVOWrite(A6)
	MOVEM.L	(SP)+,D0-D7/A0-A6

	MOVE.L	D1,D6
	MOVE.L	SongDataPtr,A6
	LEA	sd_patterndata(A6),A6
	LSL.L	#8,D6
	LSL.L	#2,D6
	ADD.L	D6,A6
	CLR.L	PPattPos
	MOVEQ	#0,D6
pp_posloop
	MOVEQ	#0,D7
	MOVE.W	#2,TextLength
	MOVE.L	PPattPos,D1
	LEA	PattPosText,A5
	DIVU	#10,D1
	ADD.B	#'0',D1
	MOVE.B	D1,(A5)+
	CLR.W	D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,(A5)+
	ADDQ.L	#5,A5
pp_noteloop
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.W	#3,TextLength
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	LEA	PeriodTable,A0
pp_findloop
	CMP.W	0(A0,D0.L),D1
	BEQ	PrintNote
	ADDQ.L	#2,D0
	BRA.S	pp_findloop

PrintNote:
	ADD.L	D0,D0
	ADD.L	NoteNamesPtr,D0
	MOVE.L	D0,A0
	MOVE.L	(A0),(A5)+
	CMP.B	#'',-3(A5)
	BNE.S	prnoxyz
	MOVE.B	#'b',-3(A5)
prnoxyz	ADDQ.L	#1,A5
	MOVEQ	#0,D0
	MOVE.W	(A6),D0
	AND.W	#$F000,D0
	LSR.W	#8,D0
	LSL.L	#1,D0
	LEA	FastHexTable,A0
	ADD.L	D0,A0
	MOVE.B	(A0),(A5)+
	MOVEQ	#0,D0
	MOVE.B	2(A6),D0
	LSL.L	#1,D0
	LEA	FastHexTable,A0
	ADD.L	D0,A0
	MOVE.W	(A0),(A5)+
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	LSL.L	#1,D0
	LEA	FastHexTable,A0
	ADD.L	D0,A0
	MOVE.W	(A0),(A5)+
	ADDQ.L	#4,A5
	ADDQ.L	#4,A6
	ADDQ.L	#1,D7
	CMP.L	#4,D7
	BNE	pp_noteloop
	ADDQ.L	#1,PPattPos
	MOVEM.L	D0-D7/A0-A6,-(SP)
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle,D1
	MOVE.L	#PnText2,D2
	MOVEQ	#68,D3
	JSR	LVOWrite(A6)
	BSR	PrintCRLF
	MOVEM.L	(SP)+,D0-D7/A0-A6
	BTST	#2,$DFF016
	BEQ.S	NegativeReturn
	ADDQ.L	#1,D6
	CMP.L	#64,D6
	BNE	pp_posloop
	MOVEQ	#0,D0
	RTS

NegativeReturn:
	MOVEQ	#-1,D0
	RTS

PositiveReturn:
	MOVEQ	#0,D0
	RTS

ToggleIntMode:
	bchg	#0,MiscBitFlags+3		;IntMode
	JSR	SetTempo
ShowIntMode:
	LEA	.text1(PC),A0
	btst	#0,MiscBitFlags+3		;IntMode
	BEQ.S	.skip
	LEA	.text2(PC),A0
.skip	MOVEQ	#6,D0
	MOVE.W	#25*80+20,D1
	jmp	ShowText3
.text1	dc.b "VBLANK"
.text2	dc.b " CIA  "

SpeedUp:MOVE.W	DefaultSpeed,D1
	ADDQ.B	#1,D1
	CMP.B	#$FF,D1
	BLS.S	spedup2
	MOVE.W	#$FF,D1
spedup2:MOVE.W	D1,DefaultSpeed
	MOVE.L	D1,CurrSpeed
	BSR.S	ShowSpeed
	BSR	Wait_4000
	BRA	Wait_4000
ShowSpeed:
	MOVE.W	#14*80+20,TextOffset
	MOVE.W	DefaultSpeed,WordNumber
	JMP	PrintHexByte

SpeedDown:
	MOVE.W	DefaultSpeed,D1
	SUB.B	#1,D1
	CMP.B	#1,D1
	BHS.S	spedup2
	MOVEQ	#1,D1
	BRA.S	spedup2

SetS2TuneNote:
	LEA	SpcNoteText,A0
	move.w	#284,d0
	moveq	#14,d1
	MOVEQ	#3,D3
	jsr	ShowAnyText3	
	MOVE.W	#3,SamNoteType
	MOVE.L	#TuneNote,SplitAddress
	BRA	WaitForButtonUp

ShowS2TuneNote:
	MOVE.L	NoteNamesPtr,A4
	MOVE.W	TuneNote,D0
	LSL.W	#2,D0
	LEA	(a4,D0.W),A0
	move.w	#284,d0
	moveq	#14,d1
	MOVEQ	#4,D3
	jsr	ShowAnyText3	
	MOVE.W	TToneVol,WordNumber
	move.w	#278,d0
	moveq	#25,d1
	JMP	PrintAnyHexByte

ss2tvolup
	bsr	WaitForButtonUp
	addq.w	#1,TToneVol
	cmp.w	#$40,TToneVol
	bmi.s	.cnt
	move.w	#$40,TToneVol
.cnt	BRA.S	ShowS2TuneNote
ss2tvoldown
	bsr	WaitForButtonUp
	subq.w	#1,TToneVol
	bpl.s	.cnt
	clr.w	TToneVol
.cnt	BRA.S	ShowS2TuneNote
ss2tvol	move.w	#278,d0
	moveq	#26,d1
	BSR	GetAnyHexByte
	MOVE.W	D0,TToneVol
	BRA.S	ShowS2TuneNote

SetS2SalvAddr:
;	BRA	ShowNotImpl
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	LEA	SalvageAddress,A6
	MOVE.L	A6,ShowTextPtr
	MOVE.L	A6,TextEndPtr
	ADD.L	#6,TextEndPtr
	MOVE.W	#6,TextLength
	move.w	#268,d0
	moveq	#81,d1
	MOVE.B	#5,EnterTextFlag	; Hex mode
	BSR	GetAnyTextLine
	CLR.B	EnterTextFlag		; Text mode
	BSR	RestorePtrCol
ShowS2SalvAddr:
	LEA	SalvageAddress,A0
	move.w	#268,d0
	moveq	#80,d1
	MOVEQ	#6,D3
	JMP	ShowAnyText3

RecoverSong:
;	BRA	ShowNotImpl
	LEA	RecoverSongText(PC),A0
	BSR	AreYouSure
	RNE
	BSR	DoClearSong
	BSR	ClrSampleInfo
	BSR.S	FindAdr
	MOVE.L	D0,A0
	MOVE.L	SongDataPtr,A1
	MOVE.L	#70716,D0
.loop	MOVE.B	(A0)+,(A1)+
	SUBQ.L	#1,D0
	BNE.S	.loop	
	BRA	RedrawPattern

FindAdr:LEA	SalvageAddress+6,A0
	JSR	HexToInteger
	MOVE.W	D0,D3
	MOVEQ	#0,D0
	JSR	HexToInteger2
	SWAP	D0
	OR.W	D3,D0
	RTS

RecoverSongText:dc.b	10,10,"  Recover Song?",0

RotColUp:
	CLR.W	SpreadFlag
	MOVE.L	TheRightColors(PC),A0
	MOVE.W	(A0),D0
	MOVEQ	#48,D1
	SUBQ.W	#2,D1
.up1	MOVE.W	2(A0),(A0)+
	DBRA	D1,.up1
	MOVE.W	D0,(A0)
rocoup2	BSR	GetColPos
	BSR	ShowColSliders
	BSR	ShowRainbow
	JMP	SetupVUCols

RotColDown:
	CLR.W	SpreadFlag
	MOVE.L	TheRightColors(PC),A0
	MOVEQ	#48,D1
	ADD.W	D1,A0
	ADD.W	D1,A0
	MOVE.W	-(A0),D0
	SUBQ.W	#2,D1
.dn1	MOVE.W	-2(A0),(A0)
	SUBQ.L	#2,A0
	DBRA	D1,.dn1
	MOVE.W	D0,(A0)
	BRA.S	rocoup2

SpreadColors:
	MOVE.W	RainbowPos,SpreadFrom
	MOVE.W	#1,SpreadFlag
	clr.w	CopyFlag2
	clr.w	SwapFlag2
	rts

CopyColor2:
	MOVE.W	RainbowPos,CopyFrom2
	MOVE.W	#1,CopyFlag2
	clr.w	SwapFlag2
	clr.w	SpreadFlag
	rts

SwapColor2:
	MOVE.W	RainbowPos,SwapFrom2
	MOVE.W	#1,SwapFlag2
	clr.w	CopyFlag2
	clr.w	SpreadFlag
	RTS

	cnop	0,4
SpreadFrom:	dc.w 0
SpreadFlag:	dc.w 0
CopyFrom2:	dc.w 0
CopyFlag2:	dc.w 0
SwapFrom2:	dc.w 0
SwapFlag2:	dc.w 0

UndoColor2:
	MOVE.L	UndoColAddr,A0
	MOVE.W	UndoCol,D1
	MOVE.W	(A0),UndoCol
	MOVE.W	D1,(A0)
	BRA	rocoup2

SetDefaultCol2:
	MOVE.L	TheRightColors(PC),A0
	move.l	DefVUColPtr,a1
sedeco4	MOVEQ	#48,D0
	BRA.S	.co3
.co2	MOVE.W	(A1)+,(A0)+
.co3	DBRA	D0,.co2
	BRA	rocoup2

CancelCol2:
	MOVE.L	TheRightColors(PC),A0
	MOVE.L	A0,A1
	SUB.L	#VUMeterColors,A1
	ADD.L	#SaveColors,A1
	BRA.S	sedeco4

GetColAddr:
	MOVE.L	TheRightColors(PC),A0
	MOVE.W	RainbowPos,D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	MOVE.W	(A0),D1
	MOVE.W	D1,D2
	RTS

SetRed2:;CMP.W	#79,D0
	;BHS	SelectColor2
.t2r2	bsr	CheckNTSCPos
	BSR	GetColPos
	AND.W	#$0F00,D2
	LSR.W	#8,D2
	CMP.B	D2,D0
	BEQ.S	.sk2
	AND.W	#$00FF,D1
	LSL.W	#8,D0
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	ShowRainbow
	JSR	SetupVUCols
.sk2	BTST	#6,$BFE001
	BEQ.S	.t2r2
	RTS

SetGreen2:
	;CMP.W	#79,D0
	;BHS	SelectColor2
.t2g2	bsr	CheckNTSCPos
	BSR	GetColPos
	AND.W	#$00F0,D2
	LSR.W	#4,D2
	CMP.B	D2,D0
	BEQ.S	.sk2
	AND.W	#$0F0F,D1
	LSL.W	#4,D0
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	ShowRainbow
	JSR	SetupVUCols
.sk2	BTST	#6,$BFE001
	BEQ.S	.t2g2
	RTS

SetBlue2:
	;CMP.W	#79,D0
	;BHS.S	SelectColor2
set2b2	bsr	CheckNTSCPos
	BSR	GetColPos
	AND.W	#$000F,D2
	CMP.B	D2,D0
	BEQ.S	setbsk2
	AND.W	#$0FF0,D1
	OR.W	D0,D1
	MOVE.W	D1,(A0)
	BSR	ShowColSliders
	BSR	ShowRainbow
	JSR	SetupVUCols
setbsk2	BTST	#6,$BFE001
	BEQ.S	set2b2
	RTS

SelectColor2:
	tst.w	ColEdMode
	bne.s	.selcol
	bsr.w	DelSelect
.selcol	move.w	#-1,ColEdMode
	MOVEQ	#0,D7
.loop	bsr	CheckNTSCPos
	BTST	#6,$BFE001
	BNE.S	ChkSpread
	MOVEQ	#48,D0
	MOVE.W	MouseY,D1
	CMP.W	D7,D1
	BEQ.S	.loop
	MOVE.W	D1,D7
	CMP.W	#48,D1
	BHS.S	.coly
	MOVEQ	#48,D1
.coly	SUB.W	#48,D1
	CMP.W	D0,D1
	BLT.S	.col2
	MOVE.W	D0,D1
	SUBQ.W	#1,D1
.col2	MOVE.W	D1,RainbowPos
	BSR	ShowRainbow
	BSR	GetColPos
	MOVE.L	A0,UndoColAddr
	MOVE.W	D1,UndoCol
	BSR	ShowColSliders
	BRA	.loop

ChkSpread:
	TST.W	SpreadFlag
	BEQ	CheckCopy2
	CLR.W	SpreadFlag
	BSR	GetColPos
	MOVE.W	SpreadFrom,D0
	MOVE.W	RainbowPos,D1
	CMP.W	D1,D0
	BLO.S	.spr2
	EXG	D0,D1
.spr2	MOVE.W	D1,D4
	SUB.W	D0,D4
	CMP.W	#1,D4
	RLS
	MOVE.L	D4,A2
	ADD.W	D4,D4
	MOVE.L	TheRightColors(PC),A0
	MOVE.L	A0,A1
	ADD.W	D0,D0
	ADD.W	D1,D1
	LEA	0(a0,D0.W),A0		; 1st col
	MOVE.W	(A0),D2
	LEA	0(a1,D1.W),A1
	MOVE.W	(A1),D3			; 2nd col
	MOVEQ	#0,D5

sprdlop	MOVE.W	D2,D0 ; red
	LSR.W	#8,D0
	MOVE.W	D3,D1
	LSR.W	#8,D1
	BSR	ColCrossfade
	LSL.W	#8,D0
	MOVE.W	D0,D7
	MOVE.W	D2,D0 ; green
	LSR.W	#4,D0
	AND.W	#$000F,D0
	MOVE.W	D3,D1
	LSR.W	#4,D1
	AND.W	#$000F,D1
	BSR	ColCrossfade
	LSL.W	#4,D0
	OR.W	D0,D7
	MOVE.W	D2,D0 ; blue
	AND.W	#$000F,D0
	MOVE.W	D3,D1
	AND.W	#$000F,D1
	BSR	ColCrossfade
	OR.W	D0,D7
	ADDQ.W	#2,D5
	MOVE.W	D7,(A0)+
	CMP.L	A1,A0
	BLO	sprdlop
	BRA	rocoup2

ColCrossfade
	MOVE.W	D4,D6
	SUB.W	D5,D6
	MULU	D6,D0
	ADD.L	A2,D0
	MULU	D5,D1
	ADD.W	D1,D0
	DIVU	D4,D0
	CMP.W	#15,D0
	RLS
	MOVEQ	#15,D0
	RTS

CheckCopy2
	TST.W	CopyFlag2
	BEQ	CheckSwap2
	clr.w	CopyFlag2
	move.l	TheRightColors(pc),A0
	MOVE.W	CopyFrom2(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	move.w	(a0),d2
	move.l	TheRightColors(pc),A0
	MOVE.W	RainbowPos(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	move.w	d2,(a0)
	BRA	rocoup2

CheckSwap2
	TST.W	SwapFlag2
	REQ
	clr.w	SwapFlag2
	move.l	TheRightColors(pc),A0
	move.l	a0,a1
	MOVE.W	SwapFrom2(pc),D1
	ADD.W	D1,D1
	LEA	0(a0,D1.W),A0
	MOVE.W	RainbowPos(pc),D1
	ADD.W	D1,D1
	LEA	0(a1,D1.W),A1
	move.w	(a0),d2
	move.w	(a1),(a0)
	move.w	d2,(a1)
	BRA	rocoup2

DoDelSelect
	tst.w	ColEdMode
	bne	DelSelect
DelSelect2
	move.w	RainbowPos(pc),-(sp)
	move.w	#-1,RainbowPos
	bsr.w	ShowRainbow
	move.w	(sp)+,RainbowPos
	clr.w	SpreadFlag
	clr.w	CopyFlag2
	clr.w	SwapFlag2
	rts

ShowRainbow
	jsr	SetColBlock
	MOVE.L	TextBplPtr,A0
	LEA	47*80+13(A0),A0
	MOVEQ	#0,D1
	MOVE.L	#$00FFE000>>5,D2
	MOVE.W	RainbowPos,D3
.lop	MOVE.L	D2,D0
	CMP.W	D3,D1
	BNE.S	.sk1
	MOVE.L	#$1EFFEF00>>5,D0
.sk1	MOVE.L	D0,RainbowLin
	move.b	RainbowLin(pc),(A0)
	move.b	RainbowLin+1(pc),1(A0)
	move.b	RainbowLin+2(pc),2(A0)
	move.b	RainbowLin+3(pc),3(A0)
	LEA	80(A0),A0
	ADDQ.W	#1,D1
	CMP.W	#48,D1		; ?
	BLO.S	.lop
dorain:
	LEA	CopListAnalyzer,A0
	MOVE.L	TheRightColors(PC),A1
	move.w	#$5b,d0
	add.w	ScrYPos,d0
	sub.w	NTSCYPos,d0
	lsl.w	#8,d0
	OR.B	#$07,D0
	MOVEQ	#47,D1		; ?
	MOVEQ	#0,D2
.lp2	MOVE.W	D0,(A0)+
	MOVE.W	#$FFFE,(A0)+
	MOVE.W	#$01AA,(A0)+	; Colorbar colorreg.
	CMP.W	#48,D2
	BLO.S	.sk2
	CLR.W	(A0)+
	BRA.W	.sk3
.sk2	MOVE.W	(A1)+,(A0)+
.sk3	ADD.W	#$0100,D0
	ADDQ.W	#1,D2
	DBRA	D1,.lp2
	MOVEQ	#63,D0
.lp3	MOVE.L	#$01A80000,(a0)+
	DBRA	D0,.lp3
	RTS

KillRainbow:
	move.b	#$f8,ColBlockSpriteData+1
	LEA	CopListAnalyzer,A0
	move.w	#$5b,d0
	add.w	ScrYPos,d0
	sub.w	NTSCYPos,d0
	lsl.w	#8,d0
	OR.B	#$07,D0
	MOVEQ	#47,D1		; ?
	MOVEQ	#0,D2
.lp22	MOVE.W	D0,(A0)+
	MOVE.W	#$FFFE,(A0)+
	MOVE.W	#$01A8,(A0)+	; Colorbar colorreg.
	CMP.W	#48,D2
	BLO.S	.sk22
	CLR.W	(A0)+
	BRA.W	.sk32
.sk22	clr.w	(a0)+
.sk32	ADD.W	#$0100,D0
	ADDQ.W	#1,D2
	DBRA	D1,.lp22
	MOVEQ	#63,D0
.lp32	MOVE.L	#$01A80000,(a0)+
	DBRA	D0,.lp32
	RTS

	cnop	0,4
ColEdMode:	dc.w	0
RainbowLin:	dc.l	0
RainbowPos:	dc.w	0
TheRightColors:	dc.l	0

;----- Screen dragger -----

ScreenDragGadget:
	move.w	#-1,PointerFlag
	clr.l	DeltaX
.loop	btst	#6,$bfe001
	bne.s	.end
	tst.l	DeltaX
	beq.s	.loop
	movem.w	DeltaX,d0/d1
	clr.l	DeltaX
	add.w	d0,ScrXPos
	add.w	d1,ScrYPos
	bsr.s	SetScreenPosition
	bra.s	.loop
.end	clr.l	DeltaX
	clr.w	PointerFlag
	rts


NTSCDiff = 50		; Diffrence between NTSC and PAL (Raster lines)
			; (Actually $13c-$106)

SetScreenPosition:
	move.w	ScrXPos(pc),d0
	cmp.w	#-16,d0
	bpl.s	.cnt1
	moveq	#-16,d0
.cnt1	cmp.w	#15,d0
	bmi.s	.cnt2
	moveq	#15,d0
.cnt2	move.w	ScrYPos(pc),d1
	cmp.w	#-13,d1
	bpl.s	.cnt3
	moveq	#-13,d1
.cnt3	cmp.w	#13,d1
	bmi.s	.cnt4
	moveq	#13,d1
.cnt4	move.w	d0,ScrXPos
	move.w	d1,ScrYPos

	bsr	SetBPLPointers

	move.w	ScrXPos(pc),d0
	move.w	d0,d1
	add.w	#$81,d1
	move.b	d1,_DWS1+1
	add.w	#$c1-$81,d1
	move.b	d1,_DWS2+1
	move.w	d0,d1
	and.w	#$f,d1
	move.w	d1,d2
	lsl.w	#4,d2
	or.w	d2,d1
	move.w	d1,_SCR
	move.w	d0,d1
	and.w	#-8,d1
	lsr.w	#1,d1
	add.w	#$3c,d1
	move.w	d1,_DDF1
	add.w	#$d4-$3c,d1
	move.w	d1,_DDF2

	move.w	ScrYPos(pc),d1
	moveq	#$2c,d2
	add.w	d1,d2
	move.w	d2,d3
	move.b	d2,_DWS1
	move.b	d2,_WAIT1
	btst	#0,ScrnBitFlags+3	; NTSCFlag
	beq.s	.cnt9
	sub.w	#NTSCDiff,d2
.cnt9	move.b	d2,_DWS2
	sub.w	NTSCYPos(pc),d1
	sub.w	NTSCYPos(pc),d3
	move.w	d3,SprUpper
	moveq	#$58,d2
	add.w	d1,d2
	move.b	d2,_WAIT2
	moveq	#$7d,d2
	add.w	d0,d2
	move.w	d2,SprLeft
	jsr	UpdatePointerPos
	bsr	ShowLACETogl
	TST.W	SamScrEnable
	bne.w	.cnt0
	move.w	ScrYPos(pc),d1
	sub.w	NTSCYPos(pc),d1
	move.w	#$bb,d2
	add.w	d1,d2
	move.b	d2,_WAIT3
	move.w	#$c2,d2
	add.w	d1,d2
	move.b	d2,_WAIT4
	move.w	#$f0,d2
	add.w	d1,d2
	move.b	d2,_WAIT5
	move.w	#$129,d2
	add.w	d1,d2
	move.b	d2,_WAIT19
	move.w	#$01fe,d0
	cmp.w	#$100,d2
	bmi.s	.cntA
	move.w	#$ffdf,d0
.cntA	move.w	d0,_WAIT18
.cnt0	cmp.w	#SetupScreen1_ID,CurrScreen
	bne.s	.cnt8
	jsr	dorain
	jsr	SetColBlock
	bra.s	.cnt81
.cnt8	bsr	KillRainbow
.cnt81	cmp.w	#DirScreen_ID,CurrScreen
	bne.s	.cnt7
	bsr	DoDirDragbar
.cnt7	bsr	InitSpritePos

	TST.W	SamScrEnable
	bne.w	.cnt5
	move.w	ScrYPos(pc),d1
	sub.w	NTSCYPos(pc),d1
	jsr	SetupVUCols
	bra	.cnt6
.cnt5	move.w	ScrYPos(pc),d1
	sub.w	NTSCYPos(pc),d1
	move.w	#$b6,d2
	add.w	d1,d2
	move.b	d2,_WAIT20+CopListInsPos
	jsr	ResetLoopSprites
.cnt6	bsr	SetExtSync
	rts

InitSpritePos:
	jsr	ShowVUMeters
	jsr	UpdateCursorPos
	jsr	SetScrPatternPos
	rts

SetColBlock:
	lea	ColBlockSpriteData,a0
	moveq	#59,d0
	cmp.w	#SetupScreen1_ID,CurrScreen
	beq.s	.cnt
	moveq	#-32,d0
.cnt	moveq	#47,d1
	moveq	#48,d2
	jsr	SetSpritePos
	rts

SetExtSync:
	move.l	GfxBase,a6
	move.w	164(a6),d1	; gb_system_bplcon0
	move.w	#$f014,d2
	and.w	d2,_BCON1
	or.w	d1,_BCON1
	TST.W	SamScrEnable
	bne.s	.cnt
	and.w	d2,_BCON2
	or.w	d1,_BCON2
	and.w	d2,_BCON3
	or.w	d1,_BCON3
	and.w	d2,_BCON4
	or.w	d1,_BCON4
.cnt	rts

SetBPLPointers:
	move.w	NTSCYPos(pc),d1
	mulu	#Res/8,d1
	MOVE.L	#BitPlaneData,D0 	; Set pointers to bitplane data
	add.l	d1,d0
	LEA	CopListBitplanes,A1
	MOVE.W	D0,6(A1)
	SWAP	D0
	MOVE.W	D0,2(A1)
	SWAP	D0
	ADD.L	#20480,D0		;2 bpl. medres!
	MOVE.W	D0,14(A1)
	SWAP	D0
	MOVE.W	D0,10(A1)

	move.l	#TextBpl,d0
	add.l	d1,d0
	MOVE.W	D0,NoteBplptrLow	; set low word
	SWAP	D0
	MOVE.W	D0,NoteBplptrHigh	; set high word
	rts

CheckNTSCPos:	; Make sure the screen is scrollable in NTSC mode
	movem.l	d0-a6,-(sp)
	tst.w	NTSCAdd
	beq.s	.end
	btst	#0,ScrnBitFlags+3	; NTSCFlag
	beq.s	.not
	move.w	NTSCAdd(pc),d0
	clr.w	NTSCAdd
	add.w	d0,NTSCYPos
	bpl.s	.cnt
	clr.w	NTSCYPos
.cnt	cmp.w	#NTSCDiff,NTSCYPos
	bmi.s	.cnt2
	move.w	#NTSCDiff,NTSCYPos
.cnt2	bsr	SetScreenPosition
	bra.s	.end
.not	clr.w	NTSCAdd
	clr.w	NTSCYPos
.end	movem.l	(sp)+,d0-a6
	rts

	cnop	0,4
PointerFlag:	dc.w	0
ScrXPos:	dc.w	0
ScrYPos:	dc.w	0
NTSCYPos:	dc.w	0
NTSCAdd:	dc.w	0

;-------------- Graphics depacker ----------
; Coded by Olorin/CryptoBurners
; (C) 1991/1992 CryptoBurners

ZerLn	= 64
EquLn	= 64
AddLn	= 16
SkipLn	= 98
	rsreset
			; Zero bytes
ZerCod:	rs.b	ZerLn	; CX
ZerByt:	rs.b	1	; C	X
ZerWor:	rs.b	1	; C	Xb, X
ZerLon:	rs.b	1	; C	Xbb, Xb, X

			; Equal bytes
EquCod:	rs.b	EquLn	; CX	n
EquByt:	rs.b	1	; C	n	X
EquWor:	rs.b	1	; C	n	Xb, X
EquLon:	rs.b	1	; C	n	Xbb, Xb, X

			; Aritmethric sequences
AddCod:	rs.b	AddLn	; CX	A	n
AddByt:	rs.b	1	; C	A	n	X
AddWor:	rs.b	1	; C	A	n	Xb, X
AddLon:	rs.b	1	; C	A	n	Xbb, Xb, X

			; Nonepacked sequences
SkipCod:rs.b	SkipLn	; CX
SkipByt:rs.b	1	; C	X
SkipWor:rs.b	1	; C	Xb, X
SkipLon:rs.b	1	; C	Xbb, Xb, X
StrCode:rs.b	1	; C
EndCode:rs.b	1	; C

; a0 = Source adr
; a1 = Dest adr
DePackIt:
	move.l	(a0),d0
	move.l	4(a0),d1
	move.l	#1<<24,d2
	cmp.l	d2,d1
	bhi	.deperr
	cmp.l	d2,d0
	bhi	.deperr
	moveq	#0,d2
	cmp.l	d2,d1
	beq	.deperr
	cmp.l	d2,d0
	beq	.deperr
	;cmp.l	d1,d0		; Can the crunched data be longer than
	;bhi	.deperr		; the uncrunched data?

	lea	(a0,d0.l),a6	; End of Data
	lea	(a1,d1.l),a5	; End of Decrunched data
	cmp.b	#StrCode,-(a6)
	bne	.deperr

.mainloop
	moveq	#0,d0	; Fill Len
	moveq	#0,d1	; Equ Byte
	moveq	#0,d2	; Add Byte
	move.b	-(a6),d0

	moveq	#0,d3
	cmp.b	#ZerCod+ZerLn,d0
	bhs.s	.decn1
	sub.b	#ZerCod-1,d0
	bra	.fillmem
.decn1	moveq	#ZerLn+1,d3
	cmp.b	#ZerByt,d0
	bne.s	.decn2
.decbyt	move.b	-(a6),d0
	bra	.fillmem
.decn2	cmp.b	#ZerWor,d0
	bne.s	.decn3
.decwor	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<8,d3
	bra.s	.decbyt
.decn3	cmp.w	#ZerLon,d0
	bne.s	.decn4
.declon	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<16,d3
	bra.s	.decwor

.decn4	moveq	#0,d3
	cmp.b	#EquCod+EquLn,d0
	bhs.s	.decn5
	sub.b	#EquCod-2,d0
.decodn	move.b	-(a6),d1
	bra	.fillmem
.decn5	moveq	#EquLn+2,d3
	cmp.b	#EquByt,d0
	bne.s	.decn6
.decbytn
	move.b	-(a6),d1
	bra.s	.decbyt
.decn6	cmp.b	#EquWor,d0
	bne.s	.decn7
.decworn
	move.b	-(a6),d1
	bra.s	.decwor
.decn7	cmp.w	#EquLon,d0
	bne.s	.decn8
.declonn
	move.b	-(a6),d1
	bra.b	.declon

.decn8	moveq	#0,d3
	cmp.b	#AddCod+AddLn,d0
	bhs.s	.decn9
	sub.b	#AddCod-3,d0
	move.b	-(a6),d2
	bra.s	.decodn
.decn9	moveq	#AddLn+3,d3
	cmp.b	#AddByt,d0
	bne.s	.decna
	move.b	-(a6),d2
	bra.s	.decbytn
.decna	cmp.b	#AddWor,d0
	bne.s	.decnb
	move.b	-(a6),d2
	bra.s	.decworn
.decnb	cmp.w	#AddLon,d0
	bne.s	.decnc
	move.b	-(a6),d2
	bra.s	.declonn

.decnc	moveq	#0,d3
	cmp.b	#SkipCod+SkipLn,d0
	bhs.s	.decnd
	sub.b	#SkipCod-1,d0
	bra.s	.decrskip
.decnd	moveq	#SkipLn+1,d3
	cmp.b	#SkipByt,d0
	bne.s	.decne
.decbyts
	move.b	-(a6),d0
	bra.s	.decrskip
.decne	cmp.b	#SkipWor,d0
	bne.s	.decnf
.decwors
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<8,d3
	bra.s	.decbyts
.decnf	cmp.w	#SkipLon,d0
	bne.s	.decng
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<16,d3
	bra.s	.decwors
.decng	cmp.b	#EndCode,d0
	beq.s	.enddecr
.decrskip
	add.l	d3,d0
.skploop
	;move.b	(a6),$dff180
	move.b	-(a6),-(a5)
	subq.l	#1,d0
	bne.s	.skploop
	bra	.mainloop
.fillmem
	add.l	d3,d0
.filllp	;move.b	d1,$dff180
	move.b	d1,-(a5)
	sub.b	d2,d1
	subq.l	#1,d0
	bne.s	.filllp
	bra	.mainloop
.enddecr
	rts
.deperr	moveq	#-1,d0
.derrlop
	move.w	$dff006,$dff180
	dbf	d0,.derrlop
	rts
	cnop	0,4
CompPtr	dc.l	0
CompLen	dc.l	0

;---- Position Insert/Delete Gadgets ----

PosInsert
	MOVE.L	SongDataPtr,A0
	LEA	sd_pattpos(A0),A0
	ADD.L	#126,A0
	MOVEQ	#127,D0
	MOVE.L	CurrPos,D1
	AND.L	#127,D1
posinloop
	MOVE.B	(A0),1(A0)
	SUBQ.L	#1,A0
	SUBQ.L	#1,D0
	CMP.L	D1,D0
	BHI.S	posinloop
	CLR.B	1(A0)
	BSR	ShowPosition
	CLR.W	UpOrDown
	BSR	SongLengthGadg
	BRA	WaitForButtonUp

PosDelete
	MOVE.L	SongDataPtr,A0
	LEA	sd_pattpos(A0),A0
	MOVE.L	CurrPos,D0
	AND.L	#127,D0
	ADD.L	D0,A0
posdeloop
	MOVE.B	1(A0),(A0)
	ADDQ.L	#1,A0
	ADDQ.L	#1,D0
	CMP.L	#127,D0
	BLS.S	posdeloop
	CLR.B	-1(A0)
	BSR	ShowPosition
	MOVE.W	#-1,UpOrDown
	BSR	SongLengthGadg
	BRA	WaitForButtonUp

;---- Enter number gadg ----

EnterPosGadg
	CLR.B	RawKeyCode
	MOVE.W	#72+4,LineCurX
	MOVE.W	#47+6,LineCurY
	MOVE.W	#47*80+72/8,TextOffset
	BSR	GetDec3Dig
	TST.W	AbortDecFlag
	BNE	pogskip
	CMP.W	#127,D0
	BLS.S	eposgok
	MOVEQ	#127,D0
eposgok	MOVE.L	D0,CurrPos
	BRA	pogskip

EnterPattGadg
	CLR.B	RawKeyCode
	MOVE.W	#80+4,LineCurX
	MOVE.W	#58+6,LineCurY
	MOVE.W	#58*80+80/8,TextOffset
	BSR	GetDecByte
	TST.W	AbortDecFlag
	BNE	pogskip
	CMP.B	#63,D0
	BLS.S	epgok
	MOVEQ	#63,D0
epgok	MOVE.L	SongDataPtr,A0
	LEA	sd_pattpos(A0),A0
	ADD.L	CurrPos,A0
	MOVE.B	D0,(A0)
	BRA	pogskip

EnterLenGadg
	CLR.B	RawKeyCode
	MOVE.W	#72+4,LineCurX
	MOVE.W	#69+6,LineCurY
	MOVE.W	#69*80+72/8,TextOffset
	BSR	GetDec3Dig
	TST.W	AbortDecFlag
	BNE	ShowSongLength
	CMP.W	#128,D0
	BLS.S	elengok
	MOVE.B	#128,D0
elengok	MOVE.L	SongDataPtr,A0
	LEA	sd_numofpatt(A0),A0
	MOVE.B	D0,(A0)
	BRA	ShowSongLength

GetDec3Dig
	MOVE.W	#1,AbortDecFlag
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	BSR	UpdateLineCurPos
.loop	BSR	GetKey0_9
	CMP.W	#68,D1
	BEQ.S	.exit
	CMP.W	#2,D1
	BHI.S	.loop
	MOVE.W	D1,D0
	MULU	#100,D0
	MOVE.W	D0,.temp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	.exit
	MOVE.W	D1,D0
	MULU	#10,D0
	ADD.W	D0,.temp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	.exit
	ADD.W	D1,.temp
	CLR.W	AbortDecFlag
.exit	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	BSR	RestorePtrCol
	MOVEQ	#0,D0
	MOVE.W	.temp(PC),D0
	RTS
	cnop	0,4
.temp	dc.w	0

GetDec4Dig
	MOVE.W	#1,AbortDecFlag
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	BSR	UpdateLineCurPos
.loop
	BSR	GetKey0_9
	CMP.W	#68,D1
	BEQ	.exit
	;CMP.W	#2,D1
	;BHI.S	.loop
	MOVE.W	D1,D0
	MULU	#1000,D0
	MOVE.W	D0,.temp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	.exit
	MOVE.W	D1,D0
	MULU	#100,D0
	ADD.W	D0,.temp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	.exit
	MOVE.W	D1,D0
	MULU	#10,D0
	ADD.W	D0,.temp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	.exit
	ADD.W	D1,.temp
	CLR.W	AbortDecFlag
.exit	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	BSR	RestorePtrCol
	MOVEQ	#0,D0
	MOVE.W	.temp(PC),D0
	RTS
	cnop	0,4
.temp	dc.w	0

;----  Up/Down Gadgets ----

PositionGadg:
	TST.W	UpOrDown
	BMI.S	PositionDown
PositionUp
	ADDQ.L	#1,CurrPos
	BTST	#2,$DFF016
	BNE.S	pogskp2
	ADD.L	#9,CurrPos
pogskp2	CMP.L	#127,CurrPos
	BLS.S	pogskip
	MOVE.L	#127,CurrPos
pogskip	MOVE.L	CurrPos,SongPosition
	BSR	ShowPosition
	BSR	Wait_4000
	BSR	Wait_4000
	BRA	Wait_4000

PositionDown:
	SUBQ.L	#1,CurrPos
	BTST	#2,$DFF016
	BNE.S	pogskp3
	SUB.L	#9,CurrPos
pogskp3	TST.L	CurrPos
	BPL.S	pogskip
	CLR.L	CurrPos
	BRA.S	pogskip

PatternGadg
	MOVE.L	SongDataPtr,A0
	LEA	sd_pattpos(A0),A0
	TST.W	UpOrDown
	BMI.S	PatternDown
PatternUp
	ADD.L	CurrPos,A0
	ADDQ.B	#1,(A0)
	BTST	#2,$DFF016
	BNE.S	pagaskp
	ADD.B	#9,(A0)
pagaskp	CMP.B	#63,(A0)
	BLS.S	pogskip
	MOVE.B	#63,(A0)
	BRA.S	pogskip
 
PatternDown
	ADD.L	CurrPos,A0
	SUBQ.B	#1,(A0)
	BTST	#2,$DFF016
	BNE.S	padoskp
	SUB.B	#9,(A0)
padoskp	TST.B	(A0)
	BPL	pogskip
	CLR.B	(A0)
	BRA	pogskip


SongLengthGadg
	MOVE.L	SongDataPtr,A0
	LEA	sd_numofpatt(A0),A0
	TST.W	UpOrDown
	BMI.S	SongLengthDown
SongLengthUp
	ADDQ.B	#1,(A0)
	BTST	#2,$DFF016
	BNE.S	slupskp
	ADD.B	#9,(A0)
slupskp	CMP.B	#127,(A0)
	BMI.S	solgskip
	MOVE.B	#127,(A0)
solgskip
	BSR	ShowSongLength
	BSR	Wait_4000
	BSR	Wait_4000
	BRA	Wait_4000
 
SongLengthDown
	SUBQ.B	#1,(A0)
	BTST	#2,$DFF016
	BNE.S	sldoskp
	SUB.B	#9,(A0)
sldoskp	CMP.B	#1,(A0)
	BGE.S	solgskip
	MOVE.B	#1,(A0)
	BRA.S	solgskip

SampleNumGadg:
	BTST	#2,$DFF016		; Check Right Mousebutton
	BNE.S	SampleNum2
	TST.W	InsNum
	BEQ	ShowSampleInfo
	MOVE.W	InsNum,LastInsNum
	CLR.W	InsNum
	BRA	ShowSampleInfo
 
SampleNum2
	TST.W	UpOrDown
	BMI.S	SampleNumDown
SampleNumUp
	ADDQ.W	#1,InsNum
	CMP.W	#MAX_INSTR,InsNum
	BMI.S	snuskip
	MOVE.W	#MAX_INSTR,InsNum
snuskip	BSR	redrsam
	BSR	Wait_4000
	BRA	Wait_4000

SampleNumDown
	TST.W	InsNum
	BEQ.S	snuskip
	SUBQ.W	#1,InsNum
	CMP.W	#1,InsNum

; -maw-: Blizzard reported this bug: Allows sample to go to zero if RMB was used!
; Total system crash then!!! (not in PT310, but in PT314 only)
; well, I think, it was not intended to allow to set Insnum to zero, so...
;
;	BPL.S	snuskip		; branch plus???? -maw-
	bge.s	snuskip	; -maw- thinks: better branch if greater or equal!
	MOVE.W	#1,InsNum
	BRA.S	snuskip


FineTuneGadg:
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVE.W	InsNum,D0
	REQ
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	BTST	#2,$DFF016
	BNE.S	ftgskip
;	CLR.B	2(A0)      	; clear finetune - arggh!
	and.b	#$f0,2(a0)	; -maw-
	BRA.S	ftuskip
ftgskip	TST.W	UpOrDown
	BMI.S	FineTuneDown
FineTuneUp
	AND.B	#$0F,2(A0)
	CMP.B	#7,2(A0)
	BEQ.S	ftuskip
	ADDQ.B	#1,2(A0)
	AND.B	#$0F,2(A0)
ftuskip	BSR	ShowSampleInfo
	BSR	Wait_4000
	BRA	Wait_4000
	RTS

FineTuneDown
	AND.B	#$0F,2(A0)
	CMP.B	#8,2(A0)
	BEQ.S	ftuskip
	SUBQ.B	#1,2(A0)
	AND.B	#$0F,2(A0)
	BRA.S	ftuskip

VolumeGadg
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVE.W	InsNum,D0
	REQ
	MULU	#30,D0
	ADD.L	D0,A0
	TST.W	UpOrDown
	BMI.W	VolumeDown
VolumeUp:
	CMP.b	#$40,3(a0)	; do nothing if already 64 -maw-
	beq.s	.goon
	ADDQ.B	#1,3(A0)
	BTST	#2,$DFF016
	BNE.S	.skp
	ADD.B	#15,3(A0)
.skp	CMP.B	#$40,3(A0)
	BLS.S	.cnt
	MOVE.B	#$40,3(A0)
.cnt	bsr.s	CheckVol
	jsr	UpdateSampleVolume
.goon:	BRA.S	ftuskip

VolumeDown:
	SUBQ.B	#1,3(A0)
	BTST	#2,$DFF016
	BNE.S	.skp
	SUB.B	#15,3(A0)
.skp	TST.B	3(A0)
	BPL	.cnt
	CLR.B	3(A0)
.cnt	bsr.s	CheckVol
	jsr	UpdateSampleVolume
	BRA.W	ftuskip

CheckVol:
	lea	audchan1temp,a1
	bsr	.check
	lea	audchan2temp,a1
	bsr	.check
	lea	audchan3temp,a1
	bsr	.check
	lea	audchan4temp,a1
	bsr	.check
	rts
.check	MOVE.W	InsNum,D0
	cmp.b	n_samplenum(a1),d0
	RNE
	move.b	3(a0),n_volume(a1)
	rts

EnterSampleLength:
	MOVE.W	#1,SampleLengthFlag
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	push    d1-d7/a0-a6
	moveq	#0,d2
	move.w	(a0),d2		; length
	add.l	d2,d2
	moveq	#6,d3
	move.w	#169,d0
	moveq	#91,d1
	bsr	GetAnyNumberLine
	pop     d1-d7/a0-a6
	cmp.l	#$fffe,d0       ; 64K size check!
	bmi.s	.cnt
	move.l	#$fffe,d0
.cnt	lsr.l	#1,d0
	move.w	d0,(a0)
	bsr	CheckSampInfo
	bra	ruskip2

SampleLengthGadg
	MOVE.W	#1,SampleLengthFlag
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	TST.W	UpOrDown
	BMI.S	SampleLengthDown
SampleLengthUp
	moveq	#0,d0
	move.w	(a0),d0
	ADDQ.L	#1,d0
	BTST	#2,$DFF016
	BNE.S	.skip
	CMP.L	#$7FF0,d0	; ca. 128k
	BHS.S	.skip
	ADDQ.L	#7,d0
.skip	CMP.L	#$7FFF,d0	; 128k
	BLO	.cnt
	MOVE.L	#$7FFF,d0	; 128k
.cnt	move.w	d0,(a0)
	BRA	ShowSampleInfo
 
SampleLengthDown
	moveq	#0,d0
	MOVE.W	4(A0),D0
	ADD.W	6(A0),D0
	moveq	#0,d1
	move.w	(a0),d1
	SUBQ.L	#1,d1
	BTST	#2,$DFF016
	BNE.S	.skip
	SUBQ.L	#7,d1
.skip	BMI.S	.skip2
	CMP.L	d1,D0
	BLS.s	.cnt
	MOVE.L	D0,d1
	BRA.s	.cnt
.skip2	moveq	#0,d1
.cnt	move.w	d1,(a0)
	BRA	ShowSampleInfo
	cnop	0,4
SampleLengthFlag dc.w 0

CheckSampleLength
	TST.W	SampleLengthFlag
	REQ
	CLR.W	SampleLengthFlag
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	REQ
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVE.L	D0,D1
	LSL.W	#2,D1
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	LEA	SamplePtrs,A1
	LEA	0(a1,D1.W),A1
	MOVE.L	A0,PlaySamPtr
	MOVE.L	A1,RealSamPtr
	MOVE.L	SAMPLE_LENGTHS(A1),D0
	LSR.L	#1,D0
	MOVE.W	(A0),D1
	CMP.W	D0,D1
	BHI.S	ItsTooMuch
	RTS

ItsTooMuch
	LEA	AddWorkSpaceText(PC),A0
	BSR	AreYouSure
	BNE	RestoreLength
	BSR	TurnOffVoices
	MOVE.L	PlaySamPtr,A0
	MOVEQ	#0,D0
	MOVE.W	(A0),D0
	LSL.L	#1,D0
	MOVE.L	D0,SamAllocLen
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,SamAllocPtr
	BEQ.S	RestoreLength
	MOVE.L	D0,A1
	MOVE.L	RealSamPtr,A0
	MOVE.L	(A0),D0
	BEQ.S	nosamth
	MOVE.L	D0,A2
	MOVE.L	SAMPLE_LENGTHS(A0),D1
	BEQ.S	nosamth
.loop	MOVE.B	(A2)+,(A1)+
	subq.l	#1,d1
	bpl.s	.loop
	MOVE.L	(A0),A1
	MOVE.L	SAMPLE_LENGTHS(A0),D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
nosamth	MOVE.L	RealSamPtr,A0
	MOVE.L	SamAllocPtr,(A0)
	MOVE.L	SamAllocLen,SAMPLE_LENGTHS(A0)
	BSR	ShowSampleInfo
	JSR	RedrawSample
	BRA	WaitForButtonUp

RestoreLength
	MOVE.L	PlaySamPtr,A0
	MOVE.L	RealSamPtr,A1
	MOVE.L	SAMPLE_LENGTHS(A1),D0
	LSR.L	#1,D0
	MOVE.W	D0,(A0)
	BRA	ShowSampleInfo

AddWorkSpaceText dc.b 10,10,'  add workspace ?',0
PlaySamPtr  dc.l 0
RealSamPtr  dc.l 0
SamAllocPtr dc.l 0
SamAllocLen dc.l 0

EnterRepeat
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	push    d1-d7/a0-a6
	moveq	#0,d2
	move.w	4(a0),d2	; repeat
	add.l	d2,d2
	moveq	#6,d3
	move.w	#169,d0
	moveq	#102,d1
	bsr	GetAnyNumberLine
	pop     d1-d7/a0-a6
	lsr.l	#1,d0
	move.w	d0,4(a0)
	bsr	CheckSampInfo
	bra	ruskip2

RepeatGadg
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#30,D0
	ADD.L	D0,A0
	TST.W	UpOrDown
	BMI.S	RepeatDown
RepeatUp
	ADDQ.W	#1,4(A0)
	BTST	#2,$DFF016
	BNE.S	ruskip
	ADDQ.W	#7,4(A0)
ruskip	MOVE.W	(A0),D0			;   Length
	BEQ.S	ruskip2
	SUB.W	6(A0),D0		; - RepLen
	CMP.W	4(A0),D0
	BHI.S	ruskip2
	MOVE.W	D0,4(A0)
ruskip2	BSR	ShowSampleInfo
	BSR	UpdateRepeats
	JMP	SetLoopSprites2

RepeatDown
	SUBQ.W	#1,4(A0)
	BTST	#2,$DFF016
	BNE.S	rdskip
	SUBQ.W	#7,4(A0)
rdskip	TST.W	4(A0)
	BPL.S	ruskip2
	CLR.W	4(A0)
	BRA.S	ruskip2

EnterRepLen
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#30,D0
	ADD.L	D0,A0
	push    d1-d7/a0-a6
	moveq	#0,d2
	move.w	6(a0),d2	; rep.len
	add.l	d2,d2
	moveq	#6,d3
	move.w	#169,d0
	moveq	#113,d1
	bsr	GetAnyNumberLine
	pop     d1-d7/a0-a6
	lsr.l	#1,d0
	move.w	d0,6(a0)
	bsr	CheckSampInfo
	bra	ruskip2

RepLenGadg
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#30,D0
	ADD.L	D0,A0
	TST.W	UpOrDown
	BMI.S	RepLenDown
RepLenUp
	ADDQ.W	#1,6(A0)
	BTST	#2,$DFF016		; Check Right Mousebutton
	BNE.S	rluskip
	ADDQ.W	#7,6(A0)
rluskip	MOVE.W	(A0),D0
	BEQ.W	ruskip2
	SUB.W	4(A0),D0
	CMP.W	6(A0),D0
	BHI.W	ruskip2
	BRA.S	rldskip
 
RepLenDown
	MOVEQ	#0,D0
	MOVE.W	6(A0),D0
	SUBQ.L	#1,D0
	BTST	#2,$DFF016
	BNE.S	rldskip
	SUBQ.L	#7,D0
rldskip	CMP.L	#1,D0
	BGE.S	rldskp2
	MOVEQ	#1,D0
rldskp2	MOVE.W	D0,6(A0)
	BRA	ruskip2

CheckSampInfo
	MOVE.L	SongDataPtr,A0
	LEA	12(A0),A0
	MOVEQ	#0,D0
	MOVE.W	InsNum,D0
	BEQ	ShowSampleInfo
	MULU	#30,D0
	ADD.L	D0,A0
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	move.w	(a0),d0		; length
	move.w	4(a0),d1	; repeat
	move.w	6(a0),d2	; replen
	cmp.l	d1,d0
	bpl.s	.cnt1
	move.l	d0,d1
.cnt1	move.l	d1,d3
	add.l	d2,d3
	cmp.l	d3,d0
	bpl.s	.cnt2
	move.l	d0,d2
	sub.l	d1,d2
.cnt2	tst.l	d2
	bne.s	.cnt3
	moveq	#1,d2
.cnt3	move.w	d1,4(a0)
	move.w	d2,6(a0)
	moveq	#0,d0
	move.b	3(a0),d0	; volume
	cmp.w	#$40,d0
	bmi.s	.cnt4
	moveq	#$40,d0
.cnt4	move.b	d0,3(a0)
	rts

Wait_4000:
	movem.l d0-d7/a0-a6,-(sp)
	move.l	DosBase,a6
	moveq	#2,d1
	jsr	LVODelay(a6)
	movem.l (sp)+,d0-d7/a0-a6
	rts

UpdateRepeats
	LEA	audchan1temp,A1
	LEA	$DFF0A0,A2
	LEA	ScopeInfo,A3
	BSR.S	.upre2
	LEA	audchan2temp,A1
	LEA	$DFF0B0,A2
	LEA	ScopeInfo+20,A3
	BSR.S	.upre2
	LEA	audchan3temp,A1
	LEA	$DFF0C0,A2
	LEA	ScopeInfo+40,A3
	BSR.S	.upre2
	LEA	audchan4temp,A1
	LEA	$DFF0D0,A2
	LEA	ScopeInfo+60,A3
.upre2	MOVE.W	InsNum,D0
	CMP.B	n_samplenum(A1),D0
	beq.s	.sigh
	rts
.sigh	MOVE.L	n_start(A1),A1
	MOVEQ	#0,D0
	MOVE.W	4(A0),D0		; repeat
	ADD.L	D0,A1
	ADD.L	D0,A1
	MOVE.L	A1,AUDPTR(A2)	
	MOVE.W	6(A0),D0
	MOVE.W	D0,AUDLEN(A2)	
	MOVE.L	A1,ns_repeatptr(A3)
	ADD.L	D0,A1
	ADD.L	D0,A1
	MOVE.L	A1,ns_rependptr(A3)
	RTS

SetPatternPos:
	MOVE.L	PatternPosition,D0
	LSR.L	#4,D0
	BRA.S	ssppskip
 
SetScrPatternPos:
	MOVE.W	ScrPattPos,D0
ssppskip
	TST.W	SamScrEnable
	BNE.S	.scrpp
	move.w	d0,-(sp)
	MOVE.W	D0,PlayFromPos
	MULU	#8*80,D0
	MOVE.L	TextBplPtr,A0
	LEA	146*80(A0),A0
	ADD.L	A0,D0
	MOVE.L	CopListBpl4Ptr,A1
	MOVE.W	D0,6(A1)
	SWAP	D0
	MOVE.W	D0,2(A1)
	swap	d0

	move.w	#264,d0
	move.w	(sp)+,d1
	mulu	#PattBarArea-PattBarSize+2,d1
	lsr.l	#6,d1
	add.w	#PattBarPos,d1
	move.w	#PattBarSize,d2
	lea	PattBarSpriteData,a0
	bra	SetSpritePos

.scrpp	moveq	#-32,d0
	move.w	#PattBarPos,d1
	moveq	#24,d2
	lea	PattBarSpriteData,a0
	bra	SetSpritePos
	cnop	0,4
PlayFromPos:	dc.w 0
PlayType:	dc.w 0


WantedPattGadg:			; Lowerscreen gadget checks...
	TST.W	SamScrEnable
	JNE	CheckSamGadgets
TypeInWantedPatt:
	sf	ButtonFlag
	movem.w	MouseX,d0/d1
	cmp.w	#123,d1
	RLO
	lea	PatternGadgetList,a0
	jsr	GetGadget
	tst.w	d2
	REQ
	btst	#0,MiscBitFlags+3	;IntMode
	beq.s	.cnt			; eq = VB
	CMP.W	#5,d2
	JEQ	TempoUp
	CMP.W	#6,d2
	JEQ	TempoDown
.cnt
	cmp.w	#9,d2
	beq	FlipEdMode

	cmp.w	#41,d2
	beq	Chan1Pressed
	cmp.w	#42,d2
	beq	Chan2Pressed
	cmp.w	#43,d2
	beq	Chan3Pressed
	cmp.w	#44,d2
	beq	Chan4Pressed

	cmp.w	#45,d2
	beq	ToggleTrack1
	cmp.w	#46,d2
	beq	ToggleTrack2
	cmp.w	#47,d2
	beq	ToggleTrack3
	cmp.w	#48,d2
	beq	ToggleTrack4

	CMP.L	#'patp',RunMode		; not if a song is playing... 
	REQ

	CMP.W	#1,d2	
	BEQ.W	EnterPattNum
	cmp.w	#7,d2
	beq	PattDown
	cmp.w	#8,d2
	beq	PattUp

	push	d2
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr
	pop	d2
	cmp.w	#62,d2
	beq	CheckClear
	cmp.w	#63,d2
	beq	CheckFlip
	cmp.w	#64,d2
	beq	CheckOctUp
	cmp.w	#65,d2
	beq	CheckNoteUp
	cmp.w	#66,d2
	beq	CheckScrUp
	cmp.w	#67,d2
	beq	CheckRotUp
	cmp.w	#72,d2
	beq	CheckOctDown
	cmp.w	#73,d2
	beq	CheckNoteDown
	cmp.w	#74,d2
	beq	CheckScrDown
	cmp.w	#75,d2
	beq	CheckRotDown

	MOVE.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0
	MOVE.L	PatternNumber,D0
	LSL.L	#8,D0
	LSL.L	#2,D0
	ADD.L	D0,A0

	cmp.w	#1,FlipStat1	; pattern
	bne.s	.not0
	cmp.w	#68,d2
	beq	CutPattern
	cmp.w	#69,d2
	beq	CopyPattern
	cmp.w	#70,d2
	beq	PastePattern
	cmp.w	#60,d2
	beq	InsNotePattern
	cmp.w	#60,d2
	beq	DelNotePattern
.not0

	MOVEQ	#0,D0
	MOVE.W	PattCurPos,D0
	DIVU	#7,D0
	AND.L	#3,D0
	LSL.L	#2,D0
	ADD.L	D0,A0

	tst.w	FlipStat1	; track
	bne.s	.not1
	cmp.w	#68,d2
	beq	CutTrack
	cmp.w	#69,d2
	beq	CopyTrack
	cmp.w	#70,d2
	beq	PasteTrack
	cmp.w	#60,d2
	beq	InsNoteTrack
	cmp.w	#61,d2
	beq	DelNoteTrack
.not1
	cmp.w	#2,FlipStat1	; cmds
	bne.s	.not2
	cmp.w	#68,d2
	beq	CutCmds
	cmp.w	#69,d2
	beq	CopyCmds
	cmp.w	#70,d2
	beq	PasteCmds
	cmp.w	#60,d2
	beq	InsCmdTrack
	cmp.w	#61,d2
	beq	DelCmdTrack
.not2
	cmp.w	#3,FlipStat1	; block
	bne.s	.not3
	cmp.w	#68,d2
	beq	CheckCutBlock
	cmp.w	#69,d2
	beq	CheckCopyBlock
	cmp.w	#70,d2
	beq	CheckPasteBlock
.not3
	tst.l	RunMode
	RNE
	cmp.w	#4,d2
	beq	PatternDragbar
	rts

CheckRightPattGadgets:
	st	ButtonFlag
	movem.w	MouseX,d0/d1
	cmp.w	#123,d1
	RLO
	lea	PatternRightGadgetList,a0
	jsr	GetGadget
	tst.w	d2
	REQ
	cmp.w	#41,d2
	beq	Chan1Pressed
	cmp.w	#42,d2
	beq	Chan2Pressed
	cmp.w	#43,d2
	beq	Chan3Pressed
	cmp.w	#44,d2
	beq	Chan4Pressed
	rts


;---- Track on/off toggles ----

ToggleTrack1:
	not.b	audchan1temp+n_tracktogl
	bra.s	ShowTrackToggles
ToggleTrack2:
	not.b	audchan2temp+n_tracktogl
	bra.s	ShowTrackToggles
ToggleTrack3:
	not.b	audchan3temp+n_tracktogl
	bra.s	ShowTrackToggles
ToggleTrack4:
	not.b	audchan4temp+n_tracktogl
	bra.s	ShowTrackToggles

DoShowTrackToggles:
	lea	audchan1temp,a0
	moveq	#4-1,d1
.loop	move.b	n_tracktogl(a0),d0
	not.b	d0
	move.b	d0,n_tracktogl+1(a0)
	add.l	#n_SIZEOF,a0
	dbf	d1,.loop
ShowTrackToggles:
	lea	audchan1temp,a5
	moveq	#0,d0
	moveq	#4-1,d7
.loop	bsr	ShowTrkTogl
	addq.w	#1,d0
	add.l	#n_SIZEOF,a5
	dbf	d7,.loop
	rts
ShowTrkTogl:
	movem.l	d0-a6,-(sp)
	move.b	n_tracktogl(a5),d1
	cmp.b	n_tracktogl+1(a5),d1
	beq.s	.cnt
	move.b	d1,n_tracktogl+1(a5)
	move.w	d0,d6
	mulu	#120,d0
	add.w	#68,d0
	move.w	d0,d2
	add.w	#80,d2
	move.w	#141,d1
	move.w	#147,d3
	moveq	#2,d5
	jsr	ShowAnyBlock
	lea	.txt(pc),a0
	add.b	#"1",d6
	move.b	d6,7(a0)
	addq.w	#1,d0
	addq.w	#1,d1
	moveq	#8,d3
	moveq	#3,d2
	jsr	ShowAnyText2
	tst.b	n_tracktogl(a5)
	bne.s	.cnt
	subq.w	#1,d0
	subq.w	#1,d1
	moveq	#1,d2
	jsr	ShowAnyText2
.cnt	movem.l	(sp)+,d0-a6
	rts
.txt	dc.b	'Track #x',0
	cnop	0,2

;---------------------------

PatternOneUp
	cmp.l	#'patp',RunMode
	REQ
PattUp	addq.l	#1,PatternNumber
	bra	tiwp3
PatternOneDown
	cmp.l	#'patp',RunMode
	REQ
PattDown
	subq.l	#1,PatternNumber
	bpl	tiwp3
	clr.l	PatternNumber
	bra	tiwp3

EnterPattNum:
	CLR.B	RawKeyCode
	MOVE.W	#562+4,LineCurX
	MOVE.W	#$0096,LineCurY
	move.w	#562,d4
	move.w	#145,d5
	BSR	GetAnyDecByte		; Get pattern number
	TST.W	AbortDecFlag
	BNE.S	twexit
	MOVE.B	D0,PatternNumber+3
tiwp3	CMP.L	#63,PatternNumber	; max 64 patterns (0-63=64)
	BLS.S	twexit
	MOVE.L	#63,PatternNumber
twexit	BRA	RedrawPattern

GetKey0_9
	bsr	CheckNTSCPos
	BTST	#2,$DFF016
	BEQ.S	gk_ret
	MOVEQ	#0,D0
	JSR	DoKeyBuffer
	MOVE.B	RawKeyCode,D0
	BEQ.S	GetKey0_9
	CLR.B	RawKeyCode
	CMP.B	#68,D0
	BEQ.S	gk_ret
	CMP.B	#69,D0
	BEQ.S	gk_ret
	CMP.B	#10,D0
	BEQ.S	gk_end
	BHI.S	GetKey0_9
	CMP.B	#1,D0
	BLO.S	GetKey0_9
	MOVE.L	D0,D1
	RTS

gk_end	MOVEQ	#0,D1
	RTS

gk_ret	MOVEQ	#68,D1
	RTS

ShowOneDigit
	ADD.B	#'0',D1
	MOVE.B	D1,NumberText
	CLR.W	D1
	SWAP	D1
	MOVE.W	#1,TextLength
	MOVE.L	#NumberText,ShowTextPtr
	BSR	ShowText
	CLR.L	NumberText
	CLR.W	WordNumber
	RTS

ShowAnyOneDigit
	ADD.B	#'0',D3
	MOVE.B	D3,NumberText
	CLR.W	D3
	SWAP	D3
	MOVEQ	#1,d3		;TextLength
	MOVE.L	#NumberText,a0	;ShowTextPtr
	move.w	#$0203,d2
	BSR	ShowAnyText1
	CLR.L	NumberText
	CLR.W	WordNumber
	RTS

;---- Pattern dragbar routine ----

PattBarPos = 151
PattBarSize = 24
PattBarArea = 101

PatternDragbar:
	move.w	ScrPattPos,d0
	mulu	#PattBarArea-PattBarSize+2,d0
	lsr.l	#6,d0
	add.w	#PattBarPos,d0
	sub.w	d0,d1
	bmi.s	.upper
	cmp.w	#PattBarSize,d1
	bpl.w	.lower
	bsr	SetPattDrag2
	move.w	d1,d2
	move.w	MouseY,d1
.loop	bsr	CheckNTSCPos
	btst	#6,$bfe001
	bne.s	.end
	move.w	d1,d3
	move.w	MouseY,d1
	cmp.w	d3,d1
	beq.s	.loop

	sub.w	d2,d1
	sub.w	#PattBarPos,d1
	muls	#64,d1
	divs	#PattBarArea-PattBarSize+2,d1
	tst.w	d1
	bpl.s	.cn0
	moveq	#0,d1
.cn0	cmp.w	#63,d1
	bmi.s	.cn1
	moveq	#63,d1
.cn1	move.w	d1,ScrPattPos
	move.w	d2,-(sp)
	jsr	SetScrPatternPos
	move.w	(sp)+,d2
	btst	#6,$bfe001
	beq	.loop
.end	bsr	SetPattDrag1
	rts
.upper	sub.w	#PattBarSize*(64+15)/PattBarArea+1,ScrPattPos
	bpl.s	.cnt1
	clr.w	ScrPattPos
.cnt1	move.l	DosBase,a6
	moveq	#1,d1
	jsr	LVODelay(a6)
	jmp	SetScrPatternPos
.lower	add.w	#PattBarSize*(64+15)/PattBarArea+1,ScrPattPos
	cmp.w	#63,ScrPattPos
	bmi.s	.cnt2
	move.w	#63,ScrPattPos
.cnt2	move.l	DosBase,a6
	moveq	#1,d1
	jsr	LVODelay(a6)
	jmp	SetScrPatternPos

SetPattDrag1:
	move.l	#$f800f000,d4
	move.l	#$f0008800,d5
	move.l	#$80007800,d6
	bra.s	SetPattDrag
SetPattDrag2:
	move.l	#$0800f000,d4
	move.l	#$78008800,d5
	move.l	#$f8007800,d6
SetPattDrag:
	movem.l	d0-d7/a0-a6,-(sp)
	lea	PattBarSpriteData+4,a0
	moveq	#PattBarSize-2-1,d0
	move.l	d4,(a0)+
.loop	move.l	d5,(a0)+
	dbf	d0,.loop
	move.l	d6,(a0)+
	movem.l	(sp)+,d0-d7/a0-a6
	rts


;---- Get Text Line ----

; d0,d1 = xpos,ypos
GetAnyTextLine:
	move.w	d0,DSTXpos
	move.w	d1,DSTYpos
	move.w	#-1,DSTType
	sub.w	a4,a4
	bra.b	GetOtherTextLine
GetTextLine:
	clr.w	DSTType
GetOtherTextLine:
	MOVEQ	#0,D0
	MOVE.W	A4,D0
	DIVU	#80,D0
	ADDQ.W	#5,D0
	MOVE.W	D0,LineCurY
	SWAP	D0
	LSL.W	#3,D0
	ADDQ.W	#4,D0
	MOVE.W	D0,LineCurX
	tst.w	DSTType
	beq	CurXok
	move.w	DSTXpos(pc),d0
	addq.w	#4,d0
	move.w	d0,LineCurX
	move.w	DSTYpos(pc),d0
	addq.w	#5,d0
	move.w	d0,LineCurY
CurXok	BSR	UpdateLineCurPos
	MOVE.L	ShowTextPtr,DSTPtr
	CLR.L	DSTOffset
	CLR.L	DSTPos
	MOVE.W	#1,GetLineFlag
	MOVE.L	A4,A5
	MOVE.W	LineCurX,D5
	CLR.B	RawKeyCode
	BSR	UpdateText
WaitForKey:
	bsr	CheckNTSCPos
	BTST	#2,$DFF016
	BEQ	AbortGetLine
	BTST	#6,$BFE001
	BEQ	LineClicked
	JSR	DoKeyBuffer
	MOVEQ	#0,D1
	MOVE.B	RawKeyCode,D1
	BEQ.S	WaitForKey
	CMP.B	#78,D1		; right
	BEQ	MoveCharRight
	CMP.B	#79,D1		; left
	BEQ	MoveCharLeft
	cmp.b	#2,EnterTextFlag
	beq.s	.cnt1
	CMP.B	#70,D1		; del
	BEQ	DeleteChar
	CMP.B	#65,D1		; backspace
	BEQ	BackspaceChar
.cnt1	CMP.B	#68,D1		; return
	BEQ	GetLineReturn
	CMP.B	#69,D1		; Esc
	BEQ	GetLineReturn2
	BTST	#7,D1		; KeyUp or KeyDown stroke?
	BNE.S	WaitForKey
	LEA	UnshiftedKeymap,A4
	TST.W	ShiftKeyStatus
	BEQ.S	.skip
	LEA	ShiftedKeymap,A4
.skip	AND.W	#$007F,D1
	CMP.B	#64,D1
	BHI.W	WaitForKey
	MOVE.B	0(a4,D1.W),D1
	BEQ.W	WaitForKey
	TST.B	EnterTextFlag		; Is it text mode?
	BEQ.S	TextLineKey
	CMP.B	#'0',D1
	BLO	WaitForKey
	CMP.B	#'f',D1
	BHI	WaitForKey
	cmp.b	#2,EnterTextFlag	; Is it number mode?
	beq.s	.cnt2
	CMP.B	#'a',D1
	BHS.S	TextLineKey
.cnt2	CMP.B	#'9',D1
	BHI	WaitForKey
TextLineKey:
	CMP.L	TextEndPtr,A6
	BEQ	WaitForKey
	cmp.b	#2,EnterTextFlag
	beq.s	.cnt3
	MOVE.L	TextEndPtr,A4
.loop	MOVE.B	-(A4),1(A4)
	CMP.L	A4,A6
	BNE.S	.loop
.cnt3	MOVE.L	TextEndPtr,A4
	CLR.B	(A4)
	MOVE.B	D1,(A6)+
	BSR	PosMoveRight
	BSR	UpdateText
	CLR.B	RawKeyCode
	BRA	WaitForKey

LineClicked:
	MOVE.W	MouseY,D1
	SUB.W	LineCurY,D1
	CMP.W	#2,D1
	BGT	GetLineReturn2
	CMP.W	#-8,D1
	BLT	GetLineReturn2
	MOVE.W	MouseX,D1
	SUB.W	LineCurX,D1
	ADDQ.W	#4,D1
	ASR.W	#3,D1
	BEQ	WaitForKey
	BPL.S	linclri

	CMP.L	DSTPtr(PC),A6
	BEQ	WaitForKey
	SUBQ.L	#1,A6
	BSR	PosMoveLeft
upwake2	BSR	UpdateText
	BRA	WaitForKey

linclri	CMP.L	TextEndPtr,A6
	BEQ	WaitForKey
	TST.B	(A6)
	BEQ	WaitForKey
	ADDQ.L	#1,A6
	BSR	PosMoveRight
	BRA.S	upwake2

PosMoveRight:
	MOVE.L	DSTPos,D0
	MOVEQ	#0,D1
	MOVE.W	TextLength,D1
	TST.B	EnterTextFlag
	BNE.S	pmrskip
	SUBQ.W	#1,D1
pmrskip	CMP.L	D1,D0
	BLO.S	posrok
	ADDQ.L	#1,DSTOffset
	BRA	UpdateLineCurPos
posrok	ADDQ.L	#1,DSTPos
	ADDQ.W	#8,LineCurX
	BRA	UpdateLineCurPos

PosMoveLeft:
	TST.L	DSTPos
	BNE.S	poslok
	SUBQ.L	#1,DSTOffset
	BRA	UpdateLineCurPos	
poslok	SUBQ.L	#1,DSTPos
	SUBQ.W	#8,LineCurX
	BRA	UpdateLineCurPos

BackspaceChar:
	CMP.L	DSTPtr(PC),A6
	BEQ	WaitForKey
	SUBQ.L	#1,A6
	MOVE.L	A6,A4
.loop	MOVE.B	1(A4),(A4)+
	CMP.L	TextEndPtr,A4
	BNE.S	.loop
	BSR	PosMoveLeft
upwake	BSR	UpdateText
	BRA	WaitForKey
 
DeleteChar:
	MOVE.L	A6,A4
.loop	MOVE.B	1(A4),(A4)+
	CMP.L	TextEndPtr,A4
	BLO.S	.loop
	BRA.S	upwake
 
MoveCharRight:
	CMP.L	TextEndPtr,A6
	BEQ	WaitForKey
	TST.B	(A6)
	BEQ	WaitForKey
	ADDQ.L	#1,A6
	BSR	PosMoveRight
	BRA.S	upwake

MoveCharLeft:
	CMP.L	DSTPtr(PC),A6
	BEQ	WaitForKey
	SUBQ.L	#1,A6
	BSR	PosMoveLeft
	BRA.S	upwake

GetLineReturn2:
	move.w	#-1,TextAborted
	bra.s	GetLin2
GetLineReturn:
	clr.w	TextAborted
GetLin2	MOVE.L	DSTPtr,A6

;	CMP.B	#1,EnterTextFlag
;	BNE.S	gtl_rskip
;	TST.B	DiskNumText2
;	BEQ	WaitForKey
;;gtl_rskip
;	CMP.B	#3,EnterTextFlag
;	BNE.S	gtl_rskip2
;	TST.B	SndDiskNum1
;	BEQ	WaitForKey
;gtl_rskip2

	MOVE.L	A6,A4
dlrloop	TST.B	(A4)+
	BNE	dlrloop
	SUBQ.L	#1,A4
dlrloop2
	CMP.L	TextEndPtr,A4
	BHS.S	dlrexit
	CLR.B	(A4)+
	BRA.S	dlrloop2

dlrexit	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	CLR.W	GetLineFlag
	MOVE.B	RawKeyCode,MixChar
	CLR.B	RawKeyCode
	CLR.L	DSTOffset
	BSR.S	UpdateText
	BSR	WaitForButtonUp
	tst.w	TextAborted
	rts

AbortGetLine
	MOVE.L	DSTPtr,A6
	MOVE.L	A6,A4
clliloop
	CLR.B	(A4)+
	CMP.L	TextEndPtr,A4
	BNE.S	clliloop
	BSR.S	UpdateText
	BRA	GetLineReturn2
 
UpdateText
	tst.w	DSTType
	beq.b	OldUpdateText
	movem.l	d0-d1/d3,-(sp)
	move.w	DSTXpos(pc),d0
	move.w	DSTYpos(pc),d1
	MOVE.L	DSTPtr,A0
	ADD.L	DSTOffset,A0
	move.w	TextLength,d3
	bsr	ShowAnyText3
	movem.l	(sp)+,d0-d1/d3
	rts
OldUpdateText
	MOVE.W	A5,TextOffset
	MOVE.L	DSTPtr,A0
	ADD.L	DSTOffset,A0
	BRA	ShowText2

; In -	d0,d1,d2,d3 = xpos,ypos,integer,digits
; Out -	d0 = integer
GetAnyNumberLine
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	push    d0-d7/a0-a6
	move.l	d2,d0		; number
	move.l	d3,d1		; digits
	lea	.text(pc),a0
	bsr	ConvNum
	clr.b	(a0,d3.w)	; null terminated
	MOVE.L	A0,ShowTextPtr
	MOVE.L	A0,TextEndPtr
	ADD.L	d3,TextEndPtr
	MOVE.W	d3,TextLength
	pop     d0-d7/a0-a6
	move.b	#2,EnterTextFlag
	move.b	ShowZeroFlag,d4
	push	d4
	move.b	#" ",ShowZeroFlag
	move.l	ShowTextPtr,a6
	bsr	GetAnyTextLine
	pop	d4
	move.b	d4,ShowZeroFlag
	clr.b	EnterTextFlag
	lea	.text(pc),a0
	move.w	TextLength,d0
	bsr	AsciiToInteger
	BSR	RestorePtrCol
	tst.l	d0
	rts
	cnop	0,4
.text	ds.b	32

	cnop	0,4
TextAborted	dc.w	0
DSTPtr		dc.l	0
DSTPos		dc.l	0
DSTXpos		dc.w	0
DSTYpos		dc.w	0
DSTType		dc.w	0
DSTOffset	dc.l	0

;----

TypeInSongName
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	CLR.L	EditMode
	MOVE.L	SongDataPtr,A6
	MOVE.L	A6,TextEndPtr
	MOVE.L	A6,ShowTextPtr
	ADD.L	#19,TextEndPtr
	MOVE.W	#20,TextLength
	MOVE.W	#25*80+8,A4
	BSR	GetTextLine
	CLR.L	TextEndPtr
	BRA	RestorePtrCol

TypeInSampleName
	BSR	StorePtrCol
	BSR	SetWaitPtrCol
	CLR.L	EditMode
	MOVE.L	SongDataPtr,A6
	LEA	-10(A6),A6
	MOVE.W	InsNum,D7
	BNE.S	.skip
	MOVE.W	LastInsNum,D7
.skip	MULU	#30,D7
	ADD.L	D7,A6
	MOVE.L	A6,TextEndPtr
	MOVE.L	A6,ShowTextPtr
	ADD.L	#21,TextEndPtr
	MOVE.W	#22,TextLength
	MOVE.W	#80*80+10,A4
	BSR	GetTextLine
	CLR.L	TextEndPtr
	BRA	RestorePtrCol

;-------------------
CheckForIFF
; Input:
; a0 adress of sample file
; a1 length of sample file
	MOVEQ	#0,D2
	MOVEQ	#0,D1
	CMP.L	#'FORM',(A0)	
	BNE.S	wiskip         ; if it is not IFF

	CMP.L	#'8SVX',8(A0)
	BNE.S	wiskip         ; if it is not an audio IFF, do nothing!

	MOVE.L	A0,A2   ; original file start
	MOVE.L	A1,D0   ; file length
	ADD.L	A0,A1   ; original file end
	TST.L	D2      ; test if we should interpret the loop data
	BEQ.S	cfiloop ; if not, hunt for BODY

	BSR.S	CheckIFFLoop

cfiloop	CMP.L	#'BODY',(A0)  ; note boys, this is *crap*!
	BEQ.S	WasIFF        ; any ANNO or AUTH or whatever containing "BODY"
	ADDQ.L	#2,A0         ; will trash the system.
	CMP.L	A1,A0
	BLS.S	cfiloop
	RTS

WasIFF	ADDQ.L	#8,A0    ; a0 = real body data start
	ADD.L	A2,D0    ; a2 = org. file start -> d0 = file end
	SUB.L	A0,D0    ; d0 = real body length (ouch! not very nice!)

wiloop	MOVE.B	(A0)+,(A2)+	; down copy the body to file start
	CMP.L	A1,A0           ; test if we are on file end
	BLS.S	wiloop

	MOVE.L	SampleInstrSave(PC),A3
	LSR.L	#1,D0           ; half real body lenght
	MOVE.W	22(A3),D1       ; get old value
	SUB.W	D0,D1           ; d1 = old value - new real body length
	MOVE.W	D0,22(A3)       ; enter (real body length)/2 somewhere

wiskip	LEA	SampleLengthAdd(PC),A3
	MOVE.W	InsNum,D0
	LSL.W	#1,D0
	MOVE.W	D1,0(a3,D0.W)	; we enter zero here, if it was not iff
	RTS

CheckIFFLoop
	btst	#6,DiskBitFlags+3	; IFFLoopFlag (use loops yes/no)
	REQ                             ; just return if "ignore loops"

; Hunt for VHDR now - this is really ugly!!!

	MOVEM.L	A0/D0,-(SP)
cilloop	CMP.L	#'VHDR',(A0)
	BEQ.S	wasvhdr
	ADDQ.L	#2,A0
	CMP.L	A1,A0
	BLS.S	cilloop
cilend	MOVEM.L	(SP)+,A0/D0
	RTS

wasvhdr	MOVE.L	SampleInstrSave(PC),A3
	MOVE.L	12(A0),D0       ; loop length
	BEQ.S	cilend          ; do nothing if loop length is zero
	LSR.L	#1,D0
	MOVE.W	D0,28(A3)	
	MOVE.L	8(A0),D0        ; loop start
	BNE.S	wsvhdr2
	MOVEQ	#2,D0           ; loop start at least 2
wsvhdr2	LSR.L	#1,D0
	MOVE.W	D0,26(A3)
	BRA.S	cilend


	cnop	0,4
SampleInstrSave	dc.l	0
; 26.w = loop start
; 28.w = loop length

SampleLengthAdd	dcb.w	32,0


;- maw -------------------------------------------------------------------
; ********************************************************************************
; ** Following IFF reader is taken from "Mami" (a MIDI sample transfer program
; ** by PuW) and adapted to fit PT's purposes ;-)
; ********************************************************************************

; a0 = Requester text
; this one is stolen from "memoryrequest"
; it should be a bigger one to keep all the information I would like to show there.
mawIFFRequester				
	move.w	#-1,FileInvOn		; turn off file inversion
	move.l	a0,-(sp)		
	bsr	SaveRequester   	; save gfx under requester
	move.l	(sp)+,a0
	lea	ReqImage2,a1            ; info icon
	lea	Requester4maw,a2        ; I think here I have to fiddle(?)
	move.l	#80*14,d0
	bsr	ShowRequester
.wait	bsr	CheckNTSCPos
	JSR	DoKeyBuffer	; eat up keystrokes
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList3,a0  	; the gadget list for the "resume" gadget
	jsr	GetGadget2
	tst.w	d2      	; gadget hit?
	beq	.wait
	cmp.w	#2,d2		
	beq	.exit
	bra	.wait
.exit	bsr	ReturnRequester	; restore gfx under requester
	clr.w	FileInvOn  	; allow file inversion
	rts

; some flags indicating the type of sample loaded
SF_NOTHING 	equ -1
SF_MAESTRO 	equ 0	; Maestro v1 16-bit Mono-Format
SF_IFF	 	equ 1   ; 8-bit IFF
SF_RAW	  	equ 2   ; 8_bit raw
SF_SDS		equ 3	; MSDS-format
IFFHD_STRSIZE = 20
;-------------------------
ResetIffHeaderText:
	lea	IFF_na_txt,a0	; text saying: "not available"
PutIffHeaderText:
; input: a0 = source, a1 = dest
	moveq	#IFFHD_STRSIZE,d0	; number of chars/line
.cpy:	move.b	(a0)+,d1
	beq.s	.pad
	move.b	d1,(a1)+
	subq.w	#1,d0
	bgt.s	.cpy
	rts
.pad:	move.b	#" ",(a1)+	; destination is blank-padded!
	subq.w	#1,d0
	bgt.s	.pad
	rts
;------------------------------			
;***********************
;** maw's IFF reader ***
;***********************
maw_IFFreader:
; reset some variables first
	lea	IFFHd_Name,a1
	bsr.s	ResetIffHeaderText
	lea	IFFHd_Auth,a1
	bsr.s	ResetIffHeaderText
	lea	IFFHd_Copy,a1
	bsr.s	ResetIffHeaderText
	lea	IFFHd_Anno,a1
	bsr.s	ResetIffHeaderText
	lea	IFFHd_Dyn,a1
	bsr.s	ResetIffHeaderText

	move.b	#SF_NOTHING,kind_of_sim
	sf	error_scansam
	sf	iff_flag
	clr.l	body_start
	clr.l	body_length
	clr.l	body_end
	clr.l	loop_start
	clr.l	loop_length
	clr.l	dyn_start
	clr.l	dyn_length
	clr.w	unknown_chunks       	; reset number of unknown chunks

	move.l	TmpDataPtr,a0		; address of file in memory
	move.l	a0,form_start
	move.l	(a0)+,d0
	
	cmp.l	#"MAES",d0           	; is it a maestro sample?
	beq	process_maestro
	cmp.l	#"FORM",d0		; if not an iff FORM
	bne	process_raw_sample   	; process sample as raw sample

	move.l	(a0)+,form_length
	cmp.l	#"8SVX",(a0)+   	; error if iff, but not 8svx !
	bne	err_no8svx

	st	iff_flag		; yes, iff
	move.l	form_start,d0
	add.l	form_length,d0
	move.l	d0,form_end		; d0 = form_length (great it is!)
;------------------------------
getchunks:	; Loop to check Chunks
; -WARNING- the chunk callbacks MUST NOT destroy a0/a1 !!!!
	cmp.l	form_end,a0		; are we thru with it?
	bge	got_chunks
	tst.b	error_scansam		; any error occurred in the meantime?
	bne	load_sample_done

	lea	IFF8SVX_ChunkTable,a1	; Dispatcher table
	move.l	(a0)+,d0		; get chunk
.loop_chunks:
	move.l	(a1)+,d1    		; 4 bytes chunk template (for instance "BODY")
	beq.s	.nomore_chunks
	cmp.l	d1,d0          		; compare chunk
	bne.s	.dont_process
	move.l	(a1),a1			; get process routine adress
	jsr	(a1)			; process it
	bra.s	getchunks		; if we processed one, go to next chunk
.dont_process:
	addq	#4,a1			; go to next chunkinfo
	bra.s	.loop_chunks
.nomore_chunks:
	bsr.s	nextchunk     		; unknown chunk here!
	addq.w	#1,unknown_chunks 	; count up number of unknown chunks
	bra.s	getchunks
;-------------
err_no8svx:
   	st	error_scansam
	move.l	#IffErr8svxText,error_scansam_msg
	bra	load_sample_done
;--------------------------
got_chunks:	; thru with chunk hunt
	move.b	#SF_IFF,kind_of_sim
	tst.l	body_start	; we NEED a body, so we need a strict check.
	bne.s	.bodyfound
   	st	error_scansam
	move.l	#IffErrNoBodyText,error_scansam_msg
	bra.s	.exit
.bodyfound:
	nop
.exit:	bra	load_sample_done
;------------------------------------------------------
nextchunk:
	move.l	(a0)+,d0	; get length
	move.l	a0,a2		; store adress in a2
	addq.l	#1,d0
	bclr	#0,d0
	add.l	d0,a0 ; inc a0
	rts
;----
proc_body:
	bsr.s	nextchunk	; -> a2 = start of BODY
	move.l	a2,body_start	; only keep address and length
	move.l	d0,body_length
	rts
;----
proc_dyn:
	bsr.s	nextchunk	; -> a2 = start of DYN
	move.l	a2,dyn_start
	move.l	d0,dyn_length	; only keep adress and length
	rts
;---
proc_vhdr:
	bsr.s	nextchunk	; -> a2 = start of VHDR
	move.l	(a2)+,loop_start ; this should always be there!!!!
	move.l	(a2)+,d0
	move.l	d0,loop_length	; check if zero somewhere else

	addq	#4,a2		; ignore cycles
	moveq	#0,d0
	move.w	(a2)+,d0
	move.l	d0,sample_freq
	move.b	(a2)+,d0	; octave byte
	cmp.b	#1,d0
	beq.s	.octok
   	st	error_scansam
	move.l	#IffErrOctvText,error_scansam_msg
	bra.s	.exit
.octok:
	tst.b	(a2)+      	; compression byte
	beq.s	.exit
	st	error_scansam
	move.l	#IffErrFiboText,error_scansam_msg
.exit:	rts
;------------------
; Subroutines to process the string chunks of a IFF-8VSX-file
proc_name:
	lea	IFFHd_Name,a3
	bra.s	get_iff_string
proc_auth:
	lea	IFFHd_Auth,a3
	bra.s	get_iff_string
proc_copy:
	lea	IFFHd_Copy,a3
	bra.s	get_iff_string
proc_anno:
	lea	IFFHd_Anno,a3
;	bra.s	get_iff_string	; next command
;----------------	
get_iff_string:
; INPUT:
; a0 = points to chunk length
; a3 = destination string to copy to
	bsr	nextchunk	; -> a2 = start of string
	move.l	d0,d7			; number of characters...

;cmp.l	#IFFHD_STRSIZE,d7
;ble.s	.debra
	move.l	#IFFHD_STRSIZE,d7	; ...but we dont need it here, since we
					; always take only a certain number of chars
					; and fill up if necessary.
	bra.s	.debra
.copy:	move.b	(a2)+,d0
	bne.s	.not0
.pad:   move.b	#$20,(a3)+	; once it was zero, pad it only
	dbra	d7,.pad
	bra.s	.exit
.blnk:	moveq	#" ",d0	; insert white space instead of zero or "after string garbage"
	bra.s	.put
.not0:  cmp.b	#10,d0	; do not allow ascii(10)
	beq.s	.blnk
.put:	move.b	d0,(a3)+
.debra:	dbra	d7,.copy
.exit:	rts
;----------------		
process_raw_sample:	; here we proceed with RAW sample loading
	sf	iff_flag
	move.b	#SF_RAW,kind_of_sim
	move.l	#8363,sample_freq   ; since we dont know what it really is...
	move.l	TmpDataPtr,body_start
	move.l	TmpDataSize,body_length
	bra	load_sample_done
;-------------------
process_maestro:
	cmp.l	#$54524f00,(a0)+	; 4 "TRO "
	bne	.mae_error
	cmp.l	#$01010200,(a0)+	; 8	; No check yet
	cmp.l	#$00010000,(a0)+	; 12	
	bne	.mae_error

	move.l	(a0)+,d0		; 16	; WARNING! words here!!!
	move.l	d0,body_length	
 	move.l	(a0)+,sample_freq       ; 20
	move.l	a0,body_start
	cmp.l	#28000,sample_freq	; Should we upsample on the fly?
	ble.s	.dontupsample
	lsr.l	#1,d0
	move.l	d0,body_length		; halve this, cuz we will upsample
.dontupsample:

	move.b	#SF_MAESTRO,kind_of_sim
	sf	iff_flag
.exit:	bra	load_sample_done

.mae_error:
	st	error_scansam
	move.l	#mae_error_txt,error_scansam_msg
	bra.s	.exit
;-------------------------------------------
load_sample_done:
; originally, there happened something here, but now only "rts".
	rts
;-----------------
mawExamine:
	MOVEQ	#-2,D2
	MOVE.L	DosBase,A6
	JSR	LVOLock(A6)
	MOVE.L	D0,FileLock
	BEQ	CantFindFile
	MOVE.L	D0,D1
	MOVE.L	#FileInfoBlock,D2
	JSR	LVOExamine(A6)
	TST.L	FIB_EntryType
	BPL	CantExamFile
	MOVE.L	FileLock,D1
	JSR	LVOUnLock(A6)
	MOVE.L	FIB_FileSize,D0
	BEQ	FileIsEmpty
	RTS
;-------------------
AllocTmpData:	; alloc a temporary buffer for the sample file
; Input: d0 = size
	move.l	d0,TmpDataSize
	clr.l	TmpDataPtr
	MOVE.L	#MEMF_ANY,D1	; any type of mem
	MOVE.L	4.w,a6
    	JSR	LVOAllocMem(A6)
	move.l	d0,TmpDataPtr	
	bne.s	.tmpmemok
	lea	NoTmpMemText,a0
	bsr     ShowStatusText
	bra	OutOfMemErr
.tmpmemok:
	rts

FreeTmpData:	; free temporary sample file buffer
	MOVE.L	TmpDataPtr,d0
	beq.s	.not
	move.l	d0,A1
	move.l	TmpDataSize,d0
	beq.s	.not
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
.not:	rts

;---------------------------------
SetDynFlag:	
; input: d0 instrumentnumber (like InsNum)
; sets the dyn bit for this sample in the dynflagmask
; NOTE: These routines will be more complicated if more than 31 instruments are
; allowed one day :-)
	move.l	d1,-(sp)
	move.l	DynFlagMask,d1	; *** SET THE DYN-FLAG HERE ***
	bset.l	d0,d1
	move.l	d1,DynFlagMask
	move.l	(sp)+,d1
	rts
ClrDynFlag:	
	move.l	d1,-(sp)
	move.l	DynFlagMask,d1	; *** CLR THE DYN-FLAG HERE ***
	bclr.l	d0,d1
	move.l	d1,DynFlagMask
	move.l	(sp)+,d1
	rts
;-----------------
ClrAllDynFlags:
	clr.l	DynFlagMask
	rts
;-----------------
CheckDynFlag:              	
	movem.l	d1,-(sp)        ; use movem, because doesn't affect CCR
	move.l	DynFlagMask,d1
	btst	d0,d1
	movem.l	(sp)+,d1
	rts
;------------
; Debugging tool
testcol:	; d7.w is color for screen flash
	moveq	#-1,d0
.tc:	move.w	d7,$dff180
	dbf	d0,.tc
	rts
;--------------
;***********************************************************************
; I had to change the sample loader completely :-/
;
; here is how it works:
;---------------------
; - examine the file, return file size
; - allocate a temporary buffer of the file's size (any type of mem)
; - read the file into this buffer
; - call the IFF checker
;       - the checker is only checking, nothing else.
; 	- checker returns body_start,body_length etc.
;       - if not iff, body_start and body_length refer to the whole file
; - if no errors occured in checking:
;       - free old sample
;       - free dyn_table, if it was a dyn sample
;       - turn of voices
;       - validate body_length (64K limit)
; - allocate chip mem for sample body
; - allocate memory for dyn table, if necessary
; - update values in Songdata
; - copy the body to chipmem
;       - convert to 8bit if it was a 16 bit maestro sample
;	- upsample if it was a maestro sample with a freq > 28K
; - copy the dyn data to the dyntable
; - free the temporary buffer
; - ValidateLoops	; validate loops in songdata
; - ShowSampleInfo
; - RedrawSample
; - show a info requester about IFF header if it was an IFF
;-----------------------
; Format of Dyn chunk
;  0 "DYN " 		; last character is a blank - ascii $20)
;  4 chunklength.l      ;
;  8 dyn_anz.w		; number of parts
; 10 loop_part_nr.w	; number if loop part, 0 = no loop!
; 12 partlen.w / volume.w / partlen.w / volume.w / etc.
;------------------------------------------------------------
mawLoadSample
	TST.W	InsNum
	BEQ	NotSampleNull
	BSR	StorePtrCol

	move.l	PathPtr,a0		; concat
	JSR	CopyPath
	LEA	DirInputName,A0         ; Dirname
	MOVEQ	#DirNameLength-1,D0
lsloop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,lsloop

	MOVE.L	SongDataPtr,A0
	MOVE.W	InsNum,D0
	MULU	#30,D0
	LEA	-10(A0),A0
	ADD.L	D0,A0
	LEA	DirInputName,A1
	MOVEQ	#21,D0
lsloop2	MOVE.B	(A1)+,(A0)+
	DBRA	D0,lsloop2

	BSR	SetDiskPtrCol

;--- examine the sample file, returns FIB_FileSize
	MOVE.L	#FileName,D1
	BSR	mawExamine

;--- allocate a temporary file buffer
	MOVE.L	FIB_FileSize,D0
	bsr	AllocTmpData

; indicate it is maw's loader ;-)
	LEA	MawSampleLoaderText,A0
	BSR	ShowStatusText

;--- read the file to the temporary buffer
	MOVE.L	#FileName,D1
	MOVE.L	DosBase,A6	
	MOVE.L	#1005,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,D7
	BEQ	CantOpenFile
	MOVE.L	D0,D1
	MOVE.L	TmpDataPtr,D2
	MOVE.L	TmpDataSize,D3
	JSR	LVORead(A6)
	MOVE.L	D7,D1
	JSR	LVOClose(A6)

;--- here the new IFF reader
	bsr	maw_IFFreader

;--- check if any errors occured	
	tst.b	error_scansam
	beq.s	.no_errors
	move.l	error_scansam_msg,a0
	bsr     ShowStatusText
	bsr	FreeTmpData      ;---  free the temporary buffer
	JSR	SetErrorPtrCol
	rts				; hmm, this RTS here looks somewhat brutal
.no_errors:

	BSR	TurnOffVoices           ; it is time to stop sound now
	BSR	FreeSample		; Since everything looks o.k. so far
					; we dare to free the old sample
					; FreeSample also frees dyn tables
;--- limit sample size to 64 K
	cmp.l	#$FFFE,body_length	; check for 64 K limit :-(
        ble.s	.lenok
        move.l	#$FFFE,body_length	; and limit it (burbs!)
.lenok:
	move.l	body_start,d0
	add.l	body_length,d0
	move.l	d0,body_end             ; determine body end address

;--- allocate ChipMem for the Body
	move.l	body_length,d0
	LEA	SamplePtrs,A4	
	MOVE.W	InsNum,D1
	LSL.W	#2,D1
	ADD.W	D1,A4
	MOVE.L	D0,SAMPLE_LENGTHS(A4)	

	MOVE.L	4.w,a6
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
    	JSR	LVOAllocMem(A6)
	MOVE.L	D0,(A4)
	move.l	d0,DiskDataPtr	; store here the actual adress of the sample in Chipmem
	bne.s	.chipmemok
	lea	NoChipMemText,a0
	bsr     ShowStatusText
	bra	OutOfMemErr
.chipmemok:

;--- allocate memory for the dyntable
	move.l	dyn_length,d0
	beq	.nodyn       	; hmm, sample was not a dyn sample

	btst	#3,DiskBitFlags+2 ; undyn iff flag
	bne	.undyniff

	lea	DynMemPtrTable,a4
	move.w	InsNum,d1
	lsl.w	#3,d1		; *8, because of ADR.L,SIZE.L = 8
	add.w	d1,a4
	move.l	d0,4(a4)	; enter dyn_length
	MOVE.L	4.w,a6
	MOVE.L	#MEMF_ANY,D1	; any mem is ok
    	JSR	LVOAllocMem(A6)
	MOVE.L	D0,(A4)		; adress
	move.l	d0,DynPtr	; store the adress of dyntable of sample
	bne.s	.dynmemok

	clr.l	4(a0)		; clr the size again (well, not necessary...)
	lea	NoDynMemText,a0
	bsr     ShowStatusText
	bra	OutOfMemErr
.dynmemok:
;--- copy the dyn table to sample
	move.l	dyn_start,a0	; adress of dyn data in temporary buffer
	move.l	DynPtr,a1	; dest of dyn data
	move.l	a1,a2
	add.l	dyn_length,a2	; endmarker
.cpdyn:	move.w	(a0)+,(a1)+     ; they are words
	cmp.l	a2,a1
	blt.s	.cpdyn

	move.w	InsNum,d0
	bsr	SetDynFlag
	bra	.wasdyn

;--  here we convert the dyns to normal samples
.undyniff:			
	lea	UnDynIffText,a0
	bsr     ShowStatusText

	move.l	body_start,a0
	move.l	dyn_start,a1
	move.l	a0,a2	
	add.l	body_length,a2 ; end marker (of chipmem body)

	move.w	(a1)+,d1	; number of parts
	addq.w	#2,a1		; number of looppart
.unp:
	moveq	#0,d7
	move.w	(a1)+,d7	; partlen
	add.l	d7,d7		; cuz of hardware lengths
	move.w	(a1)+,d2	; partvol
.udlp:
	cmp.l	a2,a0   ; end of data?
	bge.s	.udone
	move.b	(a0),d0
	ext.w	d0
	muls	d2,d0	; multiply with part volume
	divs	#64,d0	; divide by 64
	move.b	d0,(a0)+
      	subq.l	#1,d7 	; end of this part
	bgt.s	.udlp
	subq.w	#1,d1	; all parts done?
	bgt.s	.unp
.udone:
.nodyn:
       	move.w	InsNum,d0
	bsr	ClrDynFlag
.wasdyn:

;--- insert the instrument parameters into Songdata
	MOVE.L	SongDataPtr,A0
	MOVE.W	InsNum,D0
	MULU	#30,D0		
	LEA	-10(A0),A0
	ADD.L	D0,A0
	MOVE.L	A0,SampleInstrSave  ; get ptr to sample instr
	MOVE.L	body_length,D0
	LSR.L	#1,D0               ; body length/2
	MOVE.W	D0,INSTR_LENGTH(A0)
	MOVE.L	#$00400000,INSTR_FINETUNE(A0)   ; all at once (finetune,volume,repstart)
	MOVE.W	#1,INSTR_REPLEN(A0)

	btst	#6,DiskBitFlags+3   ; IFFLoopFlag (use loops yes/no)
	beq.s	.lplen0             ; just return if "ignore loops"

	MOVE.L	loop_length,D0  ; loop length
	BEQ.S	.lplen0         ; do nothing if loop length is zero
	LSR.L	#1,D0
	MOVE.W	D0,INSTR_REPLEN(A0)	
	MOVE.L	loop_start,D0   ; loop start
	BNE.S	.lpstn0
	MOVEQ	#2,D0           ; loop start at least 2
.lpstn0 LSR.L	#1,D0
	MOVE.W	D0,INSTR_REPSTART(A0)
.lplen0:

; ---- now copy the body into Chip mem	
maw_copybody:	
	move.l	DiskDataPtr,a1
	move.l	body_start,a0
	move.l	a1,a2	
	add.l	body_length,a2 ; end marker (of chipmem body)

	cmp.b	#SF_MAESTRO,kind_of_sim	; check 8bit/maestro16bit
	beq.s	.do16bits
.copy:	move.w	(a0)+,(a1)+	; well, this is simple ;-)
	cmp.l	a2,a1
	blt.s	.copy
	bra.s	.bodycopied
;---
.do16bits:
	cmp.l	#28000,sample_freq	; Check if DMA can handle (Not an exact value ;-)
	ble.s	.dmaok

	movem.l	a0-a2,-(sp)		; now we will upsample on the fly
	lea	MaeUpsampleText,a0
	bsr	ShowStatusText
	movem.l	(sp)+,a0-a2

	moveq	#9,d2
.avg:	move.w	(a0)+,d0	; take 2 values and average
	move.w	(a0)+,d1
	ext.l	d0
	ext.l	d1
	add.l	d1,d0
	bmi.s	.neg	; NO! DO NOT use "asr" HERE!!!!
	lsr.l	d2,d0	; shift down to byte
	bra.s	.write
.neg:	neg.l	d0
	lsr.l	d2,d0
	neg.l	d0
.write:	move.b	d0,(a1)+ 	; write out the resulting byte
	cmp.l	a2,a1
	blt.s	.avg
	bra.s	.bodycopied
;-----		
.dmaok:	
.cp16:	move.b	(a0)+,(a1)+	; take only hibyte here
	addq.w	#1,a0
	cmp.l	a2,a1
	blt.s	.cp16
.bodycopied:
;--------------

	bsr	FreeTmpData      ;---  free the temporary buffer

;--- display results of sample loading
	BSR	ValidateLoops	; validate loops in songdata
	BSR	ShowSampleInfo

	MOVE.L	DiskDataPtr,A0  ; this looks quite ugly. >:-|
	CLR.W	(A0)            ; maybe it is for the silence

	JSR	RedrawSample

	cmp.b	#SF_IFF,kind_of_sim
	bne.s	.dontshowiff
	lea	IFFHeaderInfo,a0  ; this one could need a flag
	bsr	mawIFFRequester	  ; whether it should be displayed
.dontshowiff

	BSR	ShowAllRight
	BRA	RestorePtrCol

;--- maw end -----------------------------------------------------------------------

CreateSampleName
	LEA	SampleFileName,A0
	MOVEQ	#27,D0
csnloop	CLR.B	(A0)+
	DBRA	D0,csnloop
	MOVE.L	SongDataPtr,A0
	MOVE.W	InsNum,D0
	MULU	#INSTR_SIZEOF,D0
	LEA	-10(A0),A0
	ADD.L	D0,A0
	MOVE.L	A0,SampleInstrSave

; prepare FORM chunk
	MOVEQ	#0,D0
	MOVE.W	INSTR_LENGTH(A0),D0 ; 22
	ADD.L	D0,D0
	MOVE.L	D0,DiskDataLength
	MOVE.L	D0,IFFBODY+4		; form length
	ADD.L	#IFFEND-IFFFORM-8,D0
	MOVE.L	D0,IFFFORM+4

; prepare VHDR
	MOVEQ	#0,D0
	MOVE.W	INSTR_LENGTH(A0),D0     ; sample length
	ADD.L	D0,D0
	MOVEQ	#0,D1
	MOVE.W	INSTR_REPLEN(A0),D1
	CMP.W	#1,D1
	BLS.S	csnskp2
	ADD.L	D1,D1
	MOVEQ	#0,D0
	MOVE.W	INSTR_REPSTART(A0),D0
	ADD.L	D0,D0
	BRA.S	csnskp3
csnskp2	MOVEQ	#0,D1
csnskp3	MOVE.L	D0,IFFVHDR+8
	MOVE.L	D1,IFFVHDR+12

	LEA	SampleFileName,A1	; put the name in the NAME chunk
	LEA	IFFNAME+8,A2
	MOVEQ	#21,D0
csnloop2
	MOVE.B	(A0),(A1)+
	MOVE.B	(A0)+,(A2)+
	DBRA	D0,csnloop2

	MOVE.L	#SampleFileName,D1
	MOVE.L	D1,FileNamePtr
	BSR.S	FindColon
	BEQ.S	CheckOverride
	move.l	PathPtr,a0
	JSR	CopyPath
	MOVE.L	#SampleFileName,A0
csnloop3
	MOVE.B	(A0)+,(A1)+
	BNE	csnloop3
	MOVE.L	#FileName,FileNamePtr
	RTS

FindColon
	MOVE.L	D1,A0
fcloop	MOVE.B	(A0)+,D0
	BEQ.S	FindColonFail
	CMP.B	#':',D0
	BEQ.S	FindColonSuccess
	BRA.S	fcloop

FindColonFail
	MOVEQ	#-1,D0
	RTS

FindColonSuccess
	MOVEQ	#0,D0
	RTS

CheckOverride
	btst	#7,DiskBitFlags+3	;OverrideFlag
	REQ
	MOVE.L	#SampleFileName,A0
	MOVE.L	A0,A1
	LEA	21(A1),A1
	MOVE.L	A1,A2
chkovlp	MOVE.B	-(A1),D0
	CMP.B	#':',D0
	BEQ.S	chkovok
	CMP.B	#'/',D0
	BEQ.S	chkovok
	MOVE.L	A1,A2
	CMP.L	A0,A1
	BHI.S	chkovlp
chkovok	move.l	PathPtr,a0
	JSR	CopyPath
chkovl2	MOVE.B	(A2)+,(A1)+
	BNE.S	chkovl2
	MOVE.L	#FileName,FileNamePtr
	RTS

ValidateLoops
	MOVE.L	SongDataPtr,A0
	LEA	20(A0),A0
	MOVEQ	#30,D0
valolop	MOVE.W	22(A0),D1
	MOVE.W	26(A0),D2
	MOVE.W	28(A0),D3
	CMP.W	D1,D2
	BHS.S	valosk1
	ADD.W	D2,D3
	CMP.W	D1,D3
	BHI.S	valosk2
valoque	TST.W	28(A0)
	BNE.S	valosk3
	MOVE.W	#1,28(A0)
valosk3	LEA	30(A0),A0
	DBRA	D0,valolop
	RTS
valosk2	SUB.W	D2,D1
	MOVE.W	D1,28(A0)
	BRA.S	valoque
valosk1	MOVEQ	#1,D1
	MOVE.L	D1,26(A0)
	BRA.S	valoque

LoadPreset
	CLR.B	RawKeyCode
	TST.W	InsNum
	BEQ	NotSampleNull
	BSR	TurnOffVoices
	BSR	FreeSample
	BSR	CreateSampleName
	MOVE.L	FileNamePtr,A0
	TST.B	(A0)
	REQ
	MOVE.L	DiskDataLength,D0
	REQ
	MOVE.L	DiskDataLength,D0
	BSR	AllocSample
	MOVE.L	DiskDataPtr,D0
	BEQ.S	loprerr
	BSR	ShowSampleInfo
	BSR	DoLoadData
	BSR	ShowAllRight
	MOVE.L	DiskDataPtr,A0
	MOVE.L	DiskDataLength,A1
	BSR	CheckForIFF
	BSR	ValidateLoops
	BSR	ShowSampleInfo
	MOVE.L	DiskDataPtr,A0
	CLR.W	(A0)
	JSR	RedrawSample
	MOVE.W	#1,UpdateFreeMem
	RTS

loprerr	BSR	StorePtrCol
	BSR	OutOfMemErr
	BSR	RestorePtrCol
	JMP	RedrawSample
;-------------------
AllocSample
	MOVE.L	D0,-(SP)
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,DiskDataPtr
	LEA	SamplePtrs,A0
	MOVE.W	InsNum,D1
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVE.L	DiskDataPtr,(A0)
	MOVE.L	(SP)+,SAMPLE_LENGTHS(A0)
	RTS

FreeSample
	LEA	SamplePtrs,A0
	MOVE.W	InsNum,D0
	REQ
	LSL.W	#2,D0
	LEA	0(a0,D0.W),A0
	MOVE.L	(A0),D1
	REQ
	CLR.L	(A0)
	MOVE.L	SAMPLE_LENGTHS(A0),D0
	REQ	; -maw- 	; just another security check
	CLR.L	SAMPLE_LENGTHS(A0)
	MOVE.L	D1,A1
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)

; -maw- free also the DYN table, if any existant
	lea	DynMemPtrTable,a0
	move.w	InsNum,d0
	REQ
	lsl.w	#3,d0		; *8, because of ADR.L,SIZE.L = 8
	add.w	d0,a0
	move.l	(a0),d1
	REQ	
	clr.l	(a0)
	move.l	4(a0),d0	; enter dyn_length
	REQ
	clr.l	4(a0)
	move.l	d1,a1
	JSR	LVOFreeMem(A6)
	RTS

NotSampleNull
	LEA	NotSample0Text(PC),A0
	BSR	ShowStatusText
	JMP	SetErrorPtrCol

NotSample0Text	dc.b 'This is not sample 0!',0,0
	even
;----

DoDeleteFile
	move.w	SaveAction,Action
	LEA	DeleteFileText,A0
	JSR	AreYouSure
	RNE
	LEA	DeletingFileText,A0
	BSR	ShowStatusText
	move.l	PathPtr,a0
	JSR	CopyPath
	LEA	DirInputName,A0
	MOVEQ	#DirNameLength-1,D0
dsloop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,dsloop
	MOVE.L	#FileName,FileNamePtr
	MOVE.L	DosBase,A6
	MOVE.L	FileNamePtr,D1
	MOVE.L	D1,A0
	JSR	LVODeleteFile(A6)
	BSR	ShowAllRight
	JSR	SetNormalPtrCol
	JSR	StorePtrCol
	btst	#3,DiskBitFlags+3	;AutoDir
	REQ
	move.b	#-1,MaskChanged
	jmp	ReadDirGadg

RenameFile
	LEA	DirInputName,A0
	LEA	NewInputName,A1
	MOVEQ	#24-1,D0
.loop	MOVE.B	(A0)+,(A1)+
	BNE.S	.skip
	SUBQ.L	#1,A0
.skip	DBRA	D0,.loop
	move.w	SaveAction,Action

	lea	.reqtext(pc),a0
	LEA	NewInputName,a1
	moveq	#24,d0
	lea	ReqImage3,a2
	jsr	AskForTextString
	RNE
	LEA	RenamingFileText,A0
	BSR	ShowStatusText
	JSR	StorePtrCol
	JSR	SetWaitPtrCol

	MOVE.L	PathPtr,A0
	JSR	CopyPath
	LEA	NewInputName,A0
	MOVEQ	#24-1,D0
.loop2	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop2

	LEA	FileName,A0
	LEA	NewFileName,A1
.loop3	MOVE.B	(A0)+,(A1)+
	BNE.S	.loop3

	MOVE.L	PathPtr,A0
	JSR	CopyPath
	LEA	DirInputName,A0
	MOVEQ	#DirNameLength-1,D0
.loop4	MOVE.B	(A0)+,(A1)+
	DBRA	D0,.loop4

	MOVE.L	#FileName,D1
	MOVE.L	#NewFileName,D2
	MOVE.L	DosBase,A6
	JSR	LVORename(A6)
	JSR	RestorePtrCol
	BSR	ShowAllRight
	btst	#3,DiskBitFlags+3	; AutoDirFlag
	REQ
	move.b	#-1,MaskChanged
	jmp	ReadDirGadg
.reqtext
	dc.b	10,10,'   Rename file as:',0
	cnop	0,2

LoadSong
	MOVE.W	#1,LoadInProgress
	BSR	DoClearSong
	BSR	ClrSampleInfo
	move.l	PathPtr,a0
	JSR	CopyPath
	LEA	DirInputName,A0
	MOVEQ	#DirNameLength-1,D0
losoloop2
	MOVE.B	(A0)+,(A1)+
	DBRA	D0,losoloop2
	MOVE.L	SongDataPtr,DiskDataPtr
	MOVE.L	#FileName,FileNamePtr
	MOVE.L	#70716,DiskDataLength
	LEA	LoadingSongText,A0
	BSR	ShowStatusText
	BSR	DoLoadData
	BEQ	lososkip3
	MOVE.L	SongDataPtr,A0
	CMP.L	#'PACK',(A0)
	BNE.S	lososkip
	MOVE.L	4(A0),CrunchedSongLength
	MOVE.L	8(A0),RealSongLength
	MOVE.L	SongDataPtr,D0
	ADD.L	#70716,D0
	SUB.L	RealSongLength(PC),D0
	MOVE.L	D0,EndOfSongPtr
	LEA	DecrunchingText,A0
	BSR	ShowStatusText
	BSR	Decruncher
	BSR	ShowAllRight
lososkip
	MOVE.L	SongDataPtr,A0
	CMP.L	#'M.K.',sd_mahokakt(A0)	;  M.K. again...
	BEQ.S	lososkip2	
	BSR	MahoneyAndKaktus 	; Was 16 instr, so move up...
	cmp.w	#2,d0
	beq	CantOpenFile
lososkip2
	LEA	LoadingSongText,A0
	BSR	ShowStatusText
	BSR	CheckAbort
	BEQ.S	lososkip3
	btst	#4,DiskBitFlags+3	;AutoExitFlag
	BEQ.S	NoSongAutoExit
	JSR	ExitFromDir
NoSongAutoExit
	CLR.L	PatternNumber
	CLR.L	CurrPos
	BSR	RedrawPattern
	CLR.W	ScrPattPos
	BSR	SetScrPatternPos
	BSR	SortDisks
	LEA	SampleSortList,A0
	MOVEQ	#30,D0
losoloop3
	btst	#5,DiskBitFlags+3	;NosamplesFlag
	BNE.S	lososkip3
	BSR	CheckAbort
	BEQ.S	lososkip3
	MOVE.W	InsNum,TuneUp
	JSR	DoShowFreeMem
	MOVE.L	(A0)+,D1
	MOVE.W	D1,InsNum
	MOVEM.L	D0/D1/A0,-(SP)
	BSR	LoadPreset
	BSR	ShowSampleInfo
	MOVEM.L	(SP)+,D0/D1/A0
	DBRA	D0,losoloop3
lososkip3
	MOVE.W	#1,InsNum
	MOVE.L	#6,CurrSpeed
	CLR.W	LoadInProgress
	BSR	ShowAllRight
	JSR	SetNormalPtrCol
	JSR	DoShowFreeMem
	BSR	CheckInstrLengths
	BSR	ShowSampleInfo
	JMP	RedrawSample

SortDisks
	MOVEM.L	D0-D4/A0-A1,-(SP)
	MOVE.L	SongDataPtr,A0
	LEA	23(A0),A0
	LEA	SampleSortList,A1
	MOVEQ	#1,D0
losoloop4
	MOVE.B	(A0)+,(A1)+		; ST-(0)1
	MOVE.B	(A0),(A1)+		; ST-0(1)
	MOVE.W	D0,(A1)+		; insnum
	LEA	29(A0),A0
	ADDQ.L	#1,D0
	CMP.L	#32,D0
	BLO.S	losoloop4
losoloop5
	CLR.W	MoreInstrFlag
	LEA	SampleSortList,A0
	MOVEQ	#29,D2
losoloop6
	MOVE.W	(A0),D0
	MOVE.W	4(A0),D1
	CMP.W	D0,D1 			; if next disk greater
	BHS.S	loso2_2
	MOVE.W	#1,MoreInstrFlag
	MOVE.L	(A0),D3 		; swap disks
	MOVE.L	4(A0),D4
	MOVE.L	D4,(A0)
	MOVE.L	D3,4(A0)
loso2_2	ADDQ.L	#4,A0
	DBRA	D2,losoloop6
	TST.W	MoreInstrFlag
	BNE.S	losoloop5
	LEA	SampleSortList,A0
	MOVEQ	#30,D0
losoloop7
	CLR.W	(A0)
	ADDQ.L	#4,A0
	DBRA	D0,losoloop7
	MOVEM.L	(SP)+,D0-D4/A0-A1
	RTS

MahoneyAndKaktus
	bsr	Req31or15
	cmp.w	#2,d0
	beq	cancelmod
	cmp.w	#3,d0
	beq	putmk
	MOVE.L	SongDataPtr,A0		; M.K. 32 samples format!
	LEA	466(A0),A1
	ADD.L	#66006,A0
makloop	MOVE.L	(A0),484(A0)
	CLR.L	(A0)
	SUBQ.L	#4,A0
	CMP.L	A0,A1
	BNE.S	makloop
	MOVE.L	SongDataPtr,A0
	LEA	sd_mahokakt(A0),A1
	LEA	sd_numofpatt(A0),A0
makloop2
	MOVE.W	4(A0),(A0)+
	CMP.L	A0,A1
	BNE.S	makloop2
	MOVE.L	#'M.K.',(A0)		; M.K. again!
	MOVEQ	#0,D0
	RTS

putmk	MOVE.L	SongDataPtr,A0
	MOVE.L	#'M.K.',sd_mahokakt(A0)	;  put M.K.
	MOVEQ	#-1,D0
	RTS
cancelmod
	MOVEQ	#-2,D0
	RTS

Req31or15
	move.w	#-1,FileInvOn
	jsr	SaveRequester
	lea	.text(pc),a0
	lea	ReqImage3,a1
	lea	Requester5,a2
	move.l	#80*14,d0
	jsr	ShowRequester
.wait	bsr	CheckNTSCPos
	JSR	DoKeyBuffer
	; check keys
	btst	#6,$bfe001
	bne.s	.wait
	MOVEM.W	MouseX,D0/D1
	lea	ReqGadgetList2,a0
	jsr	GetGadget2
	tst.w	d2
	beq	.wait
	cmp.w	#1,d2
	beq	.left
	cmp.w	#2,d2
	beq	.middle
	cmp.w	#3,d2
	beq	.right
	bra	.wait
.left	moveq	#1,d0
	bra.s	.ok
.middle	moveq	#2,d0
	bra.s	.ok
.right	moveq	#3,d0
.ok	move.l	d0,-(sp)
	jsr	ReturnRequester
	clr.w	FileInvOn
	move.l	(sp)+,d0
	rts
.text	dc.b	10,10,'This file is not a standard',10
	dc.b	'ProTracker module! Load as',10
	dc.b	'31 or 15 instruments module?',0
	cnop	0,2

CheckInstrLengths
	MOVE.L	SongDataPtr,A0
	ADD.L	#20,A0
	MOVEQ	#30,D1
xilloop	MOVE.W	26(A0),D0
	ADD.W	28(A0),D0
	CMP.W	22(A0),D0
	BLS.S	xilSkip
	MOVE.W	26(A0),D0
	LSR.W	#1,D0		; ?
	MOVE.W	D0,26(A0)
xilSkip	ADD.L	#30,A0
	DBRA	D1,xilloop
	RTS	

CheckAbort
	BTST	#2,$DFF016
	RNE
	MOVEM.L	D0-D7/A0-A6,-(SP)
	LEA	AbortLoadText,A0
	JSR	AreYouSure
	BNE.S	chabno
	MOVEM.L	(SP)+,D0-D7/A0-A6
	MOVEQ	#0,D7
	RTS

chabno	MOVEM.L	(SP)+,D0-D7/A0-A6
	MOVEQ	#-1,D7
	RTS

StopIt:	BSR.S	DoStopIt
TurnOffVoices
	MOVEM.L	d0/A0-A1,-(SP)
	move.w	#$0780,_custom+intena ; -maw- ; turn off audio interrupts!
	MOVE.W	#$000F,_custom+dmacon	; dma off
	CLR.W	$DFF0A8	; AUDVOL to zero!
	CLR.W	$DFF0B8
	CLR.W	$DFF0C8
	CLR.W	$DFF0D8

	lea	audchan1temp,a0
	moveq	#3,d0
.reset:	clr.b	n_volume(a0)
	clr.l	n_DynPtr(a0)
	clr.b	n_dynflag(a0)
	clr.b	n_intsetloop(a0)
	lea	n_SIZEOF(a0),a0
	dbra	d0,.reset

	CLR.B	RawKeyCode
	LEA	ScopeInfo,A0
	LEA	BlankSample,A1
	MOVE.L	A1,(A0)
	MOVE.L	A1,20(A0)
	MOVE.L	A1,40(A0)
	MOVE.L	A1,60(A0)
	MOVEM.L	(SP)+,d0/A0-A1
	RTS

DoStopIt:
	JSR	SetNormalPtrCol
	CLR.L	EditMode
	CLR.L	RunMode
	CLR.B	PattDelayTime
	CLR.B	PattDelayTime2
	BRA	RestoreEffects2

;---- Edit ----

Edit:	TST.W	SamScrEnable
	RNE
	BSR	StopIt
	CLR.B	RawKeyCode
	JSR	SetEditPtrCol
	BSR	SetScrPatternPos
	MOVE.L	#'edit',EditMode
	JMP	WaitForButtonUp

; ---- SubMenu list -----

ShowSubMenus:
	move.w	MenuNumber(pc),d0
	cmp.w	#1,d0
	beq	ShowSubMenu1
	cmp.w	#2,d0
	beq	ShowSubMenu2
	cmp.w	#3,d0
	beq	ShowSubMenu3
	cmp.w	#4,d0
	beq	ShowSubMenu4
	cmp.w	#5,d0
	beq	ShowSubMenu5
	cmp.w	#6,d0
	beq	ShowSubMenu6
	cmp.w	#7,d0
	beq	ShowSubMenu7
	rts

MakeSubMenu:
	move.w	d0,MenuNumber
	lea	UpperBuffer,a1
	JSR	DePackIt
	RNE
	LEA	BitPlaneData+40+44*80,A0
	lea	UpperBuffer,a1
	MOVEQ	#2-1,D2
.loop1	MOVE.W	#77-1,D0
.loop2	moveq	#10-1,d1
.loop3	MOVE.L	(A1)+,(A0)+
	dbf	d1,.loop3
	lea	40(a0),a0
	DBRA	D0,.loop2
	LEA	(256-77)*80(A0),A0		;next bitplane, please
	DBRA	D2,.loop1
	move.w	#320,d0
	move.w	#45,d1
	move.w	#639,d2
	move.w	#121,d3
	moveq	#0,d5
	jsr	ShowAnyBlock3
	moveq	#0,d0
	RTS

SubMenuPressed:
	move.w	MenuNumber(pc),d0
	cmp.w	#1,d0
	beq	SubMenu1Gadgets
	cmp.w	#2,d0
	beq	SubMenu2Gadgets
	cmp.w	#3,d0
	beq	SubMenu3Gadgets
	cmp.w	#4,d0
	beq	SubMenu4Gadgets
	rts

ShowSubMenu1:
	lea	SubMenu1Data,a0
	moveq	#1,d0
	bsr	MakeSubMenu
	bsr	ShowRecordMode
	bsr	ShowQuantize
	bsr	ShowMultiMode
	bsr	ShowMetronome
	bsr	ShowMultiSetup
	bsr	ShowSampleAll
	bsr	ShowEditDownRight
	bsr	ShowRecHoldTogl
	rts
SubMenu1Gadgets:
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	SubMenu1GadgetList,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ
	cmp.w	#1,d2
	beq	SetQuantize
	cmp.w	#2,d2
	beq	QuantPlus
	cmp.w	#3,d2
	beq	QuantMinus
	;cmp.w	#4,d2
	;beq	SetMetroSamp
	;cmp.w	#5,d2
	;beq	MetroSampPlus
	;cmp.w	#6,d2
	;beq	MetroSampMinus
	cmp.w	#7,d2
	beq	SetMetronome
	cmp.w	#8,d2
	beq	MultiSetup
	cmp.w	#9,d2
	beq	ToggleRecHold
	cmp.w	#11,d2
	beq	ToggleSampleAll
	cmp.w	#12,d2
	beq	ToggleRecordMode
	cmp.w	#13,d2
	beq	ToggleMultiMode
	cmp.w	#14,d2
	beq.s	ToggleEditDownRight
	rts

ToggleEditDownRight:
	not.b	DownRightFlag
ShowEditDownRight:
	moveq	#5,d3
	move.w	#582,d0
	moveq	#91,d1
	lea	.text2(pc),a0
	tst.b	DownRightFlag
	bne.s	.cnt
	lea	.text1(pc),a0
.cnt	jmp	ShowColorText
.text1	dc.b	'Down ',0
.text2	dc.b	'Right',0
DownRightFlag:	dc.b	0
	cnop	0,2



ShowSubMenu2:
	lea	SubMenu2Data,a0
	moveq	#2,d0
	bsr	MakeSubMenu
	bsr	ShowFrom
	bsr	ShowTo
	bsr	ShowVol
	bsr	ShowPos
	bsr	ShowMod
	bsr	ShowHalfClip
	bsr	ShowTrackPatt
	rts
SubMenu2Gadgets:
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	SubMenu2GadgetList,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ

	push	d2
	MOVE.W	PattCurPos,D0	; get track pos
	JSR	GetPositionPtr
	MOVE.L	SongDataPtr,A5	; get samp pos
	LEA	-10(A5),A5
	MOVE.W	InsNum,D0
	BNE.S	.skip
	MOVE.W	LastInsNum,D0
.skip	MULU	#30,D0
	ADD.L	D0,A5
	pop	d2

	cmp.w	#1,d2
	beq	DelSampleTrack
	cmp.w	#2,d2
	beq	ExchSampleTrack
	cmp.w	#5,d2
	beq	KillSample
	cmp.w	#6,d2
	beq	CopySampleTrack
	cmp.w	#13,d2
	beq	Mix
	cmp.w	#14,d2
	beq	Boost
	cmp.w	#15,d2
	beq	XFade
	cmp.w	#16,d2
	beq	UpSample
	cmp.w	#17,d2
	beq	Echo
	cmp.w	#18,d2
	beq	Filter
	cmp.w	#19,d2
	beq	Backwards
	cmp.w	#20,d2
	beq	DownSample

	cmp.w	#3,d2
	beq	SetSampleFrom
	cmp.w	#7,d2
	beq	SetSampleFrom
	cmp.w	#8,d2
	beq	sesfup
	cmp.w	#9,d2
	beq	sesfdown

	cmp.w	#4,d2
	beq	SetSampleTo
	cmp.w	#10,d2
	beq	SetSampleTo
	cmp.w	#11,d2
	beq	sestup
	cmp.w	#12,d2
	beq	sestdown

	cmp.w	#21,d2
	beq	SetSamplePos
	cmp.w	#22,d2
	beq	SetSamplePos
	cmp.w	#23,d2
	beq	shpoup
	cmp.w	#24,d2
	beq	shpodown

	cmp.w	#25,d2
	beq	DoMod
	cmp.w	#26,d2
	beq	SetModSpeed
	cmp.w	#27,d2
	beq	semoup
	cmp.w	#28,d2
	beq	semodown

	cmp.w	#32,d2
	beq	DoChangeVol
	cmp.w	#33,d2
	beq	ChangeVolume
	cmp.w	#34,d2
	beq	shvoup
	cmp.w	#35,d2
	beq	shvodown

	cmp.w	#29,d2
	beq	CutBeg
	cmp.w	#30,d2
	beq	FadeDown
	cmp.w	#31,d2
	beq	FadeUp

	cmp.w	#36,d2
	beq	ToggleHalfClip
	cmp.w	#37,d2
	beq	ToggleTrackPatt
	rts


ShowSubMenu3:
	lea	SubMenu3Data,a0
	moveq	#3,d0
	bsr	MakeSubMenu
	bsr	ShowFromSample
	bsr	ShowToSample
	bsr	ShowNoteNum
	bsr	ShowChordNotes
	bsr	ShowChordAdjust
	rts
SubMenu3Gadgets:
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	SubMenu3GadgetList,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ
	cmp.w	#1,d2
	beq	SetFromSample
	cmp.w	#2,d2
	beq	AddFromSample
	cmp.w	#3,d2
	beq	SubFromSample
	cmp.w	#4,d2
	beq	SetToSample
	cmp.w	#5,d2
	beq	AddToSample
	cmp.w	#6,d2
	beq	SubToSample
	cmp.w	#7,d2
	beq	SetNoteNum
	cmp.w	#8,d2
	beq	AddNoteNum
	cmp.w	#9,d2
	beq	SubNoteNum

	cmp.w	#10,d2
	beq	DoMakeChord
	cmp.w	#11,d2
	beq	ChordAdjust

	cmp.w	#20,d2
	beq	EnterChord1
	cmp.w	#21,d2
	beq	EnterChord2
	cmp.w	#22,d2
	beq	EnterChord3
	cmp.w	#23,d2
	beq	EnterChord4
	cmp.w	#24,d2
	beq	EnterChord5
	cmp.w	#25,d2
	beq	EnterChord6
	cmp.w	#26,d2
	beq	EnterChord7
	rts

ShowSubMenu4:
	lea	SubMenu4Data,a0
	moveq	#4,d0
	bsr	MakeSubMenu
	bsr	ShowFrequency
	bsr	ShowQuality
	bsr	ShowGain
	bsr	ShowLoopTime
	bsr	ShowFeedBack
	rts
SubMenu4Gadgets:
	MOVEM.W	MouseX2,D0/D1		;XY position of mouse
	lea	SubMenu4GadgetList,a0	;address of gadgets
	jsr	GetGadget		;find which gadget
	tst.w	d2			;any gadgets hit
	REQ
	cmp.w	#1,d2
	beq	HighPassSample
	cmp.w	#2,d2
	beq	LowPassSample
	cmp.w	#3,d2
	beq	BandPassSample
	cmp.w	#4,d2
	beq	AllPassSample
	cmp.w	#5,d2
	beq	ShelvLowSample
	cmp.w	#6,d2
	beq	ShelvHighSample
	cmp.w	#7,d2
	beq	CombLoopSample

	cmp.w	#20,d2
	beq	EnterFrequency
	cmp.w	#21,d2
	beq	FrequencyUp
	cmp.w	#22,d2
	beq	FrequencyDown
	cmp.w	#23,d2
	beq	EnterQuality
	cmp.w	#24,d2
	beq	QualityUp
	cmp.w	#25,d2
	beq	QualityDown
	cmp.w	#26,d2
	beq	EnterGain
	cmp.w	#27,d2
	beq	GainUp
	cmp.w	#28,d2
	beq	GainDown
	cmp.w	#29,d2
	beq	EnterLoopTime
	cmp.w	#30,d2
	beq	LoopTimeUp
	cmp.w	#31,d2
	beq	LoopTimeDown
	cmp.w	#32,d2
	beq	EnterFeedBack
	cmp.w	#33,d2
	beq	FeedBackUp
	cmp.w	#34,d2
	beq	FeedBackDown
	rts

ShowSubMenu5:
	lea	SubMenu5Data,a0
	moveq	#5,d0
	bsr	MakeSubMenu
	rts
ShowSubMenu6:
	lea	SubMenu6Data,a0
	moveq	#6,d0
	bsr	MakeSubMenu
	rts
ShowSubMenu7:
	lea	SubMenu7Data,a0
	moveq	#7,d0
	bsr	MakeSubMenu
	rts
	cnop	0,4
MenuNumber:dc.w	1

;----- Filter effects ------------

EnterFrequency:
	move.l	Frequency(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#69,d1
	bsr	GetAnyNumberLine
	move.l	d0,Frequency
	bra.s	ShowFrequency
FrequencyUp:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	add.l	d0,Frequency
	bra.s	ShowFrequency
FrequencyDown:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	sub.l	d0,Frequency
	bpl.s	ShowFrequency
	clr.l	Frequency
ShowFrequency:
	move.l	Frequency(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#69,d1
	bsr	PrintAnyDigits
	move.l	Frequency(pc),d0
	move.l	#428,d1		; this is C-2
	bsr	DoConvFrequency
	move.l	d0,FValue
	rts

EnterQuality:
	move.l	Quality(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#69,d1
	bsr	GetAnyNumberLine
	move.l	d0,Quality
	bra.s	ShowQuality
QualityUp:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	add.l	d0,Quality
	bra.s	ShowQuality
QualityDown:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	sub.l	d0,Quality
	bpl.s	ShowQuality
	clr.l	Quality
ShowQuality:
	move.l	Quality(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#80,d1
	bra	PrintAnyDigits

EnterGain:
	move.l	Gain(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#91,d1
	bsr	GetAnyNumberLine
	move.l	d0,Gain
	bra.s	ShowGain
GainUp:	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	add.l	d0,Gain
	bra.s	ShowGain
GainDown:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	sub.l	d0,Gain
	bpl.s	ShowGain
	clr.l	Gain
ShowGain:
	move.l	Gain(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#91,d1
	bra	PrintAnyDigits

EnterLoopTime:
	move.l	LoopTime(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#102,d1
	bsr	GetAnyNumberLine
	move.l	d0,LoopTime
	bra.s	ShowLoopTime
LoopTimeUp:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	add.l	d0,LoopTime
	bra.s	ShowLoopTime
LoopTimeDown:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	sub.l	d0,LoopTime
	bpl.s	ShowLoopTime
	clr.l	LoopTime
ShowLoopTime:
	move.l	LoopTime(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#102,d1
	bra	PrintAnyDigits

EnterFeedBack:
	move.l	FeedBack(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#112,d1
	bsr	GetAnyNumberLine
	move.l	d0,FeedBack
	bra.s	ShowFeedBack
FeedBackUp:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	add.l	d0,FeedBack
	bra.s	ShowFeedBack
FeedBackDown:
	moveq	#1,d0
	btst	#2,$dff016
	bne.s	.cnt
	moveq	#10,d0
.cnt	sub.l	d0,FeedBack
	bpl.s	ShowFeedBack
	clr.l	FeedBack
ShowFeedBack:
	move.l	FeedBack(pc),d2
	moveq	#7,d3
	move.w	#560,d0
	moveq	#112,d1
	bra	PrintAnyDigits

HighPassSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	bsr	Highpass1p_8
	JSR	RestorePtrCol
	BRA	DisplaySample

LowPassSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	bsr	Lowpass1p_8
	JSR	RestorePtrCol
	BRA	DisplaySample

BandPassSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	move.l	Quality(pc),d2
	bsr	Bandpass2p_8
	JSR	RestorePtrCol
	BRA	DisplaySample

AllPassSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	bsr	AllpassLP_8
	JSR	RestorePtrCol
	BRA	DisplaySample

ShelvLowSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	move.l	Gain(pc),d2
	bsr	ShelvingLow_8
	JSR	RestorePtrCol
	BRA	DisplaySample

ShelvHighSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	FValue(pc),d1
	move.l	Gain(pc),d2
	bsr	ShelvingHigh_8
	JSR	RestorePtrCol
	BRA	DisplaySample

CombLoopSample:
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	move.l	LoopTime(pc),d1
	move.l	FeedBack(pc),d2
	bsr	CombLP_8
	JSR	RestorePtrCol
	BRA	DisplaySample

	cnop	0,4
FValue:		dc.l	0
Frequency:	dc.l	0
Quality:	dc.l	0
Gain:		dc.l	0
LoopTime:	dc.l	0
FeedBack:	dc.l	0

;----- Chord editor ----- plystre snill!

ChordAdjust:
	not.w	ChAdjustFlag
ShowChordAdjust:
	lea	.text1(pc),a0
	tst.w	ChAdjustFlag
	beq.s	.cnt
	lea	.text2(pc),a0
.cnt	move.w	#459,d0
	move.w	#81,d1
	moveq	#8,d3
	jmp	ShowColorText
.text1		dc.b	' Adjust '
.text2		dc.b	'NoAdjust'
ChAdjustFlag:	dc.w	0

AddFromSample:
	addq.w	#1,FromSampNum
	cmp.w	#$1f,FromSampNum
	bmi.s	.cnt
	move.w	#$1f,FromSampNum
.cnt	bsr	Wait_4000
	bra.s	ShowFromSample
SubFromSample:
	subq.w	#1,FromSampNum
	bpl.s	.cnt
	clr.w	FromSampNum
.cnt	bsr	Wait_4000
	bra.s	ShowFromSample
SetFromSample:
	move.w	InsNum,FromSampNum
ShowFromSample:
	MOVE.W	FromSampNum(PC),WordNumber
	MOVE.W	#69*80+48,TextOffset
	BRA	PrintHexWord  		; SampleNumber
	rts

AddToSample:
	addq.w	#1,ToSampNum
	cmp.w	#$1f,ToSampNum
	bmi.s	.cnt
	move.w	#$1f,ToSampNum
.cnt	bsr	Wait_4000
	bra.s	ShowToSample
SubToSample:
	subq.w	#1,ToSampNum
	bpl.s	.cnt
	clr.w	ToSampNum
.cnt	bsr	Wait_4000
	bra.s	ShowToSample
SetToSample:
	move.w	FromSampNum(pc),d0
	addq.w	#1,d0
	and.w	#$1f,d0
	move.w	d0,ToSampNum
ShowToSample:
	MOVE.W	ToSampNum(PC),WordNumber
	MOVE.W	#91*80+48,TextOffset
	BRA	PrintHexWord  		; SampleNumber
	rts

AddNoteNum:
	addq.w	#1,NoteNum
	cmp.w	#7,NoteNum
	bmi.s	.cnt
	move.w	#7,NoteNum
.cnt	bsr	Wait_4000
	bra.s	ShowNoteNum
SubNoteNum:
	subq.w	#1,NoteNum
	cmp.w	#2,NoteNum
	bpl.s	.cnt
	move.w	#2,NoteNum
.cnt	bsr	Wait_4000
	;bra.s	ShowNoteNum
SetNoteNum:
ShowNoteNum:
	MOVE.W	#70*80+61,TextOffset
	MOVE.W	NoteNum(PC),d0
	bsr	PrintHexDigit
	bra	ShowChordNotes

EnterChord1:
	moveq	#1,d7
	MOVE.W	#372+40*0,LineCurX
	lea	ChordNo1(pc),a6
	bra	EnterChord
EnterChord2:
	moveq	#2,d7
	MOVE.W	#372+40*1,LineCurX
	lea	ChordNo2(pc),a6
	bra	EnterChord
EnterChord3:
	moveq	#3,d7
	cmp.w	NoteNum(pc),d7
	RGT
	MOVE.W	#372+40*2,LineCurX
	lea	ChordNo3(pc),a6
	bra	EnterChord
EnterChord4:
	moveq	#4,d7
	cmp.w	NoteNum(pc),d7
	RGT
	MOVE.W	#372+40*3,LineCurX
	lea	ChordNo4(pc),a6
	bra	EnterChord
EnterChord5:
	moveq	#5,d7
	cmp.w	NoteNum(pc),d7
	RGT
	MOVE.W	#372+40*4,LineCurX
	lea	ChordNo5(pc),a6
	bra	EnterChord
EnterChord6:
	moveq	#6,d7
	cmp.w	NoteNum(pc),d7
	RGT
	MOVE.W	#372+40*5,LineCurX
	lea	ChordNo6(pc),a6
	bra	EnterChord
EnterChord7:
	moveq	#7,d7
	cmp.w	NoteNum(pc),d7
	RGT
	MOVE.W	#372+40*6,LineCurX
	lea	ChordNo7(pc),a6
	;bra	EnterChord
EnterChord:
	bsr	GetChordNote
	bmi.s	EndChord
	move.w	d0,(a6)
	bsr.s	ShowChordNotes
	add.w	#40,LineCurX
	lea	2(a6),a6
	addq.w	#1,d7
	cmp.w	NoteNum(pc),d7
	ble.s	EnterChord
	bra	EnterChord1
EndChord:
	move.w	#-32,LineCurX
	BSR	UpdateLineCurPos
	rts

ShowChordNotes:
	movem.l d0-d7/a0-a6,-(sp)
	move.l	NoteNamesPtr,a1
	move.w	#369,d0
	move.w	#113,d1
	lea	ChordNo1(pc),a6
	move.w	NoteNum(pc),d7
	subq.w	#1,d7
.loop	movem.l d0-d7/a0-a6,-(sp)
	move.w	(a6),d2
	lsl.w	#2,d2
	lea	(a1,d2.w),a0
	moveq	#3,d3
	jsr	ShowAnyText3
	movem.l (sp)+,d0-d7/a0-a6
	add.w	#40,d0
	lea	2(a6),a6
	dbf	d7,.loop
.loop2	cmp.l	#ChordNo7,a6
	bgt.s	.end
	lea	.notext(pc),a0
	moveq	#3,d3
	jsr	ShowAnyText3
	add.w	#40,d0
	lea	2(a6),a6
	bra	.loop2
.end	movem.l (sp)+,d0-d7/a0-a6
	rts
.notext	dc.b	'    '


GetChordNote:
	movem.l d1-d7/a0-a6,-(sp)
	jsr	WaitForButtonUp
	MOVE.W	#114+5,LineCurY
	BSR	UpdateLineCurPos
	CLR.B	RawKeyCode
.loop	bsr	CheckNTSCPos
	btst	#6,$bfe001
	beq.s	.exit
	btst	#2,$dff016
	beq.s	.exit
	JSR	DoKeyBuffer
	moveq	#0,d1
	MOVE.B	RawKeyCode,D1
	beq.s	.loop
	cmp.b	#68,d1	; cr
	beq.s	.exit
	cmp.b	#69,d1	; esc
	beq.s	.exit
	bsr	CheckF1_F2
	MOVE.B	RawKeyCode,D1
	LEA	RawKeyScaleTable,A0
	MOVEQ	#38,D0
.loop2	CMP.B	0(A0,D0.W),D1
	BEQ.S	.notekey
	DBRA	D0,.loop2
	bra.s	.loop
.exit	movem.l (sp)+,d1-d7/a0-a6
	moveq	#-1,d0
	rts
.notekey
	move.l	KeyTransTabPtr,a0
	move.b	(a0,d0.w),d0
	and.l	#$ff,d0
	move.l	d0,-(sp)
	move.l	EditMode,-(sp)
	clr.l	EditMode
	jsr	CheckNoteKeys
	move.l	(sp)+,EditMode
	move.l	(sp)+,d0
	movem.l (sp)+,d1-d7/a0-a6
	tst.l	d0
	rts

DoMakeChord:
	move.l	SongDataPtr,a0
	lea	12(a0),a0
	move.w	FromSampNum(pc),d5
	mulu	#30,d5
	move.w	4(a0,d5.l),ChRepeat
	move.w	6(a0,d5.l),ChRepLen
	moveq	#0,d6
	move.b	2(a0,d5.l),d6	; finetune
	and.b	#$f,d6	; -maw- Dont forget to mask!
	mulu	#FINETUNETABLE_SIZE,d6
	lea	PeriodTable,a0
	add.l	d6,a0

	moveq	#36,d2
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.w	ChordNo1(pc),d0
	move.w	ChordNo2(pc),d1
	cmp.w	#3,NoteNum
	blt.s	.cnt
	move.w	ChordNo3(pc),d2
	cmp.w	#4,NoteNum
	blt.s	.cnt
	move.w	ChordNo4(pc),d3
	cmp.w	#5,NoteNum
	blt.s	.cnt
	move.w	ChordNo5(pc),d4
	cmp.w	#6,NoteNum
	blt.s	.cnt
	move.w	ChordNo6(pc),d5
	cmp.w	#7,NoteNum
	blt.s	.cnt
	move.w	ChordNo7(pc),d6
.cnt
	moveq	#7-1,d7
.srloop	cmp.w	d0,d1		; sort regs
	bpl.s	.cn1
	exg	d0,d1
.cn1	cmp.w	d1,d2
	bpl.s	.cn2
	exg	d1,d2
.cn2	cmp.w	d2,d3
	bpl.s	.cn3
	exg	d2,d3
.cn3	cmp.w	d3,d4
	bpl.s	.cn4
	exg	d3,d4
.cn4	cmp.w	d4,d5
	bpl.s	.cn5
	exg	d4,d5
.cn5	cmp.w	d5,d6
	bpl.s	.cn6
	exg	d5,d6
.cn6	dbf	d7,.srloop
	move.w	d0,ChordTab
	move.w	d1,ChordTab+2
	move.w	d2,ChordTab+4
	move.w	d3,ChordTab+6
	move.w	d4,ChordTab+8
	move.w	d5,ChordTab+10
	move.w	d6,ChordTab+12

	add.w	d0,d0
	add.w	d1,d1
	add.w	d2,d2
	add.w	d3,d3
	add.w	d4,d4
	add.w	d5,d5
	add.w	d6,d6
	move.w	(a0,d0.w),d0	; sample rate
	move.w	(a0,d1.w),d1
	move.w	(a0,d2.w),d2
	move.w	(a0,d3.w),d3
	move.w	(a0,d4.w),d4
	move.w	(a0,d5.w),d5
	move.w	(a0,d6.w),d6
	move.w	d0,ChordSt1+c_Rate
	JEQ	SetErrorPtrCol
	move.w	d1,ChordSt2+c_Rate
	JEQ	SetErrorPtrCol
	moveq	#2,d7
	move.w	d2,ChordSt3+c_Rate
	beq.s	.cnt5
	addq.w	#1,d7
	move.w	d3,ChordSt4+c_Rate
	beq.s	.cnt5
	addq.w	#1,d7
	move.w	d4,ChordSt5+c_Rate
	beq.s	.cnt5
	addq.w	#1,d7
	move.w	d5,ChordSt6+c_Rate
	beq.s	.cnt5
	addq.w	#1,d7
	move.w	d6,ChordSt7+c_Rate
	beq.s	.cnt5
	addq.w	#1,d7
.cnt5	move.w	d7,NoteNum2

	move.w	FromSampNum(pc),d5
	cmp.w	ToSampNum(pc),d5
	JEQ	SetErrorPtrCol
	lsl.w	#2,d5
	lea	SamplePtrs,a0
	add.w	d5,a0
	move.l	31*4(a0),d4
	JEQ	SetErrorPtrCol
	move.l	d4,ChSampLen
	move.l	(a0),d0
	JEQ	SetErrorPtrCol
	move.l	d0,ChSampFrom
	move.w	ToSampNum(pc),d5
	JEQ	SetErrorPtrCol
	lsl.w	#2,d5
	lea	SamplePtrs,a5
	add.w	d5,a5
	move.l	(a5),d0
	beq.w	.cnt0
	lea	SureToOverwrite(pc),a0
	jsr	AreYouSure
	RNE
.cnt0
	move.w	ToSampNum(pc),InsNum
	jsr	FreeSample
	move.l	ChSampLen(pc),d0
	LEA	SamplePtrs,A4
	MOVE.W	InsNum,D1
	LSL.W	#2,D1
	ADD.W	D1,A4
	MOVE.L	D0,SAMPLE_LENGTHS(A4)
	MOVE.L	4.w,A6
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,(A4)
	BEQ	OutOfMemErr
	move.l	d0,ChSampTo

	MOVE.L	SongDataPtr,A0
	MOVE.W	FromSampNum,D0
	MULU	#30,D0
	MOVE.W	ToSampNum,D1
	MULU	#30,D1
	LEA	-10(A0),A0
	lea	(a0,D1.l),A1
	lea	(a0,D0.l),A0
	move.l	a1,a2
	moveq	#30-1,d0
.loop1	move.b	(a0)+,(a1)+
	dbf	d0,.loop1
	move.l	a2,a0
	moveq	#20-1,d0
	tst.b	(a0)
	beq.s	.cx5
.loop2	tst.b	(a0)+
	beq.s	.cx2
	dbf	d0,.loop2
	bra.s	.cx3
.cx2	subq.l	#1,a0
	addq.w	#1,d0
	move.w	NoteNum2(pc),d1
	subq.w	#2,d1
	bmi.s	.cx5
	cmp.w	d1,d0
	blt.s	.cx5
	lea	ChordTab(pc),a1
	move.w	(a1)+,d2
.loop9	move.w	(a1)+,d0
	sub.w	d2,d0
	add.b	#"0",d0
	cmp.b	#"9",d0
	bls.s	.cx4
	add.b	#"A"-"9",d0
.cx4	move.b	d0,(a0)+
	dbf	d1,.loop9
	bra.s	.cx3
.cx5	move.b	#"#",(a0)
.cx3
	; now we may mix the sample
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	lea	ChordCompute(pc),a0
	jsr	ShowStatusText

	move.l	ChSampFrom(pc),a0
	lea	ChordSt1(pc),a6
	move.l	a0,c_Ptr(a6)
	moveq	#0,d0
	move.w	c_Rate(a6),d0
	move.w	NoteNum2(pc),d7
	subq.w	#2,d7
	bmi.s	.cnt3
	lea	.cnttab+4(pc),a5
.loop5	move.l	(a5)+,a6
	bsr	.initchord
	dbf	d7,.loop5
.cnt3
	move.l	ChSampTo(pc),a5
	move.l	ChSampLen(pc),d7
	move.l	a0,a4
	add.l	d7,a4
	subq.l	#2,d7
	move.l	a4,d6
	cmp.w	#1,ChRepLen
	ble.s	.repcnt
	moveq	#0,d6
	move.w	ChRepeat(pc),d6
	add.l	d6,d6
	add.l	a0,d6
	moveq	#0,d0
	move.w	ChRepLen(pc),d0
	add.l	d0,d0
	add.l	d6,d0
	move.l	d0,a4
.repcnt	clr.w	ChMaxFrom
	clr.w	ChMaxTo
	moveq	#0,d0
	move.b	d0,(a5)+
	move.b	d0,(a5)+
	bsr.s	.domix

	move.w	ToSampNum(pc),InsNum
	BSR	ShowAllRight
	JSR	RestorePtrCol
	BSR	ShowSampleInfo
	BRA	RedrawSample

.initchord
	move.l	d0,d1
	move.w	c_Rate(a6),d2
	divu	d2,d1
	move.l	d1,c_Rest(a6)
	lsr.w	#1,d2
	move.w	d2,c_Cntr(a6)
	move.l	a0,c_Ptr(a6)
	rts
.domix	move.b	(a0)+,d0
	ext.w	d0
	move.l	d0,-(SP)
	tst.w	d0
	bpl.s	.noneg
	neg.w	d0
.noneg	cmp.w	ChMaxFrom,d0
	bmi.s	.nonew
	move.w	d0,ChMaxFrom
.nonew	move.l	(SP)+,d0
	lea	.cnttab(pc),a3
	move.w	NoteNum2(pc),d3
	subq.w	#1,d3
.loop3	move.l	(a3)+,a6
	bsr.s	.mixmax
	dbf	d3,.loop3
	ext.l	d0
	divs	NoteNum2(pc),d0
	cmp.w	#-128,d0
	bpl.s	.cnta
	move.w	#-128,d0
.cnta	cmp.w	#127,d0
	bmi.s	.cntb
	move.w	#127,d0
.cntb	move.b	d0,(a5)+
	ext.w	d0
	tst.w	d0
	bpl.s	.noneg2
	neg.w	d0
.noneg2	cmp.w	ChMaxTo,d0
	bmi.s	.nonew2
	move.w	d0,ChMaxTo
.nonew2	subq.l	#1,d7
	bne.s	.domix

	tst.w	ChAdjustFlag
	beq.b	DoAdjust
	rts

.mixmax	move.w	c_Div(a6),d4
	move.w	c_Rest(a6),d5
	sub.w	d5,c_Cntr(a6)
	bhs.s	.cnt1
	move.w	c_Rate(a6),d5
	add.w	d5,c_Cntr(a6)
	addq.w	#1,d4
.cnt1	move.l	c_Ptr(a6),a1
	add.w	d4,a1
	cmp.l	a4,a1
	blt.s	.cnt2
	move.l	d6,a1
.cnt2	move.l	a1,c_Ptr(a6)
	move.b	(a1),d1
	ext.w	d1
	add.w	d1,d0
	rts
.cnttab	dc.l ChordSt1,ChordSt2,ChordSt3,ChordSt4,ChordSt5,ChordSt6,ChordSt7

DoAdjust:movem.l d0-d7/a0-a6,-(sp)
	move.w	ChMaxFrom,d0
	move.w	ChMaxTo,d1
	mulu	#100,d0
	tst.w	d1
	bne.b	.GoOn
	movem.l (sp)+,d0-d7/a0-a6
	rts

.GoOn	;lea	ChordAdjusting(pc),a0	;show text
	;jsr	ShowStatusText

	divu	d1,d0			;get percantage to boost
	move.l	ChSampTo,a1
	move.l	ChSampLen,d3
	subq.l	#1,d3
.dcvloop
	MOVE.B	(A1),D1
	EXT.W	D1
	MULS	D0,D1
	DIVS	#100,D1
	CMP.W	#127,D1
	BLE.S	.dcvskip
	MOVEQ	#127,D1
.dcvskip
	CMP.W	#-128,D1
	BGE.S	.dcvskp2
	MOVEQ	#-128,D1
.dcvskp2
	MOVE.B	D1,(A1)+
	DBRA	D3,.dcvloop
	;CLR.W	(A1)
	movem.l (sp)+,d0-d7/a0-a6
	rts

	cnop	0,4
ChMaxFrom:	dc.w	0
ChMaxTo:	dc.w	0
ChSampFrom:	dc.l	0
ChSampTo:	dc.l	0
ChSampLen:	dc.l	0
ChRepeat:	dc.w	0
ChRepLen:	dc.w	0

	rsreset
c_Rest:	rs.w	1
c_Div:	rs.w	1
c_Cntr:	rs.w	1
c_Ptr:	rs.l	1
c_Rate:	rs.w	1
c_SIZEOF:rs.b	0

FromSampNum:	dc.w	1
ToSampNum:	dc.w	2
NoteNum:	dc.w	3
NoteNum2:	dc.w	0

ChordNo1:	dc.w	0
ChordNo2:	dc.w	0
ChordNo3:	dc.w	0
ChordNo4:	dc.w	0
ChordNo5:	dc.w	0
ChordNo6:	dc.w	0
ChordNo7:	dc.w	0

ChordTab:	ds.w	7

ChordSt1:	ds.b	c_SIZEOF
ChordSt2:	ds.b	c_SIZEOF
ChordSt3:	ds.b	c_SIZEOF
ChordSt4:	ds.b	c_SIZEOF
ChordSt5:	ds.b	c_SIZEOF
ChordSt6:	ds.b	c_SIZEOF
ChordSt7:	ds.b	c_SIZEOF

SureToOverwrite:dc.b	10,10,' Overwrite the sample?',0
ChordCompute:	dc.b	'Please wait, computing...',0
ChordAdjusting:	dc.b	'Adjusting result...',0
	cnop	0,2

;---- Edit Op. ----

	; d0 = Track number
GetPositionPtr:
	MOVE.L	SongDataPtr,A0
	LEA	sd_patterndata(A0),A0
	MOVE.L	PatternNumber,D2
	LSL.L	#8,D2
	LSL.L	#2,D2	; *1024
	ADD.L	D2,A0
	MOVEQ	#0,D2
	MOVE.W	D0,D2
	DIVU	#7,D2	; 7 positions
	LSL.W	#2,D2
	ADD.W	D2,A0
	RTS

FlipEdMode:
	addq.w	#1,FlipStat1
	cmp.w	#4,FlipStat1
	bmi.s	ShowEdMode
	clr.w	FlipStat1
ShowEdMode:
	move.w	FlipStat1(pc),d0
	lsl.w	#2,d0
	move.l	.tab(pc,d0.w),a0
	moveq	#5,d3
	move.w	#577,d0
	move.w	#160,d1
	jmp	ShowColorText
.tab	dc.l	.tx1,.tx2,.tx3,.tx4
.tx1	dc.b	'Track'
.tx2	dc.b	'Patt.'
.tx3	dc.b	'Cmds '
.tx4	dc.b	'Block'

	cnop	0,4
FlipStat1:dc.w	0

ToggleSampleAll:
	JSR	WaitForButtonUp
	not.b	SampleAllFlag
ShowSampleAll:
	moveq	#6,d3
	move.w	#582,d0
	moveq	#58,d1
	lea	.text2(pc),a0
	TST.B	SampleAllFlag
	bne.s	.cnt
	lea	.text1(pc),a0
.cnt	jmp	ShowColorText
.text1	dc.b	'Single'
.text2	dc.b	'All   '
	cnop	0,2


CheckRotUp:
	st	RotFlag
	bra.s	DoScPt1
CheckScrUp:
	sf	RotFlag
DoScPt1:sf	LeftFlag
	sf	RightFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr	; get address of track
	tst.w	FlipStat1	; Is it Track?
	beq.s	.do
	cmp.w	#2,FlipStat1	; Is it Cmds?
	beq.s	ScrCmdsUp
	cmp.w	#3,FlipStat1	; Is it Block?
	beq.s	ScrBlockUp
	cmp.w	#1,FlipStat1	; ok! Is it Pattern?
	RNE			; nope... exit!
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.W	ScrPattUp
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR	ScrPattUp
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR	ScrPattUp
	MOVEQ	#21,D0
	BSR	GetPositionPtr
.do	BSR.S	ScrPattUp
	jsr	InvertBlockArea
	jsr	RedrawPattern2
	jmp	InvertBlockArea
ScrCmdsUp:
	move.w	PattCurPos,BlockPosX
	clr.w	BlockPosY
	move.w	#64,BlockLen
	st	LeftFlag
	sf	RightFlag
	bra.s	ScrBlockUp2
ScrBlockUp:
	jsr	GetBlockArea
	RNE
ScrBlockUp2:
	move.w	BlockPosX(pc),d0
	BSR	GetPositionPtr
	move.w	BlockPosY(pc),d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	BlockLen(pc),d0
	subq.w	#1,d0
	bsr.s	ScrPattUp2
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
ScrPattUp:
	MOVEQ	#63,D0
ScrPattUp2:
	subq.l	#1,d0
	bmi.w	.end
	move.w	(a0),d1
	move.w	2(a0),d2
	tst.b	RotFlag
	bne.s	.loop
	moveq	#0,d1
	moveq	#0,d2
.loop	tst.b	LeftFlag
	bne.s	.skip1
	move.w	16(a0),(a0)
	move.w	18(a0),d3
	and.w	#$f000,d3
	and.w	#$0fff,2(a0)
	or.w	d3,2(a0)
.skip1	tst.b	RightFlag
	bne.s	.skip2
	move.w	18(a0),d3
	and.w	#$0fff,d3
	and.w	#$f000,2(a0)
	or.w	d3,2(a0)
.skip2	LEA	16(A0),A0
	DBRA	D0,.loop
	tst.b	LeftFlag
	bne.s	.skip3
	move.w	d1,(a0)
	and.w	#$0fff,2(a0)
	move.w	d2,d3
	and.w	#$f000,d3
	or.w	d3,2(a0)
.skip3	tst.b	RightFlag
	bne.s	.end
	move.w	d2,d3
	and.w	#$0fff,d3
	and.w	#$f000,2(a0)
	or.w	d2,2(a0)
.end	rts

CheckRotDown:
	st	RotFlag
	bra.w	DoScPt2
CheckScrDown:
	sf	RotFlag
DoScPt2	sf	LeftFlag
	sf	RightFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr	; get address of track
	tst.w	FlipStat1	; Is it Track?
	beq.s	.do
	cmp.w	#2,FlipStat1	; Is it Cmds?
	beq.s	ScrCmdsDown
	cmp.w	#3,FlipStat1	; Is it Block?
	beq.s	ScrBlockDown
	cmp.w	#1,FlipStat1	; ok! Is it Pattern?
	RNE			; nope... exit!
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.W	ScrPattDown
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR	ScrPattDown
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR	ScrPattDown
	MOVEQ	#21,D0
	BSR	GetPositionPtr
.do	BSR	ScrPattDown
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
ScrCmdsDown:
	move.w	PattCurPos,BlockPosX
	clr.w	BlockPosY
	move.w	#64,BlockLen
	st	LeftFlag
	sf	RightFlag
	bra.s	ScrBlockDown2
ScrBlockDown:
	jsr	GetBlockArea
	RNE
ScrBlockDown2:
	move.w	BlockPosX(pc),d0
	BSR	GetPositionPtr
	move.w	BlockPosY(pc),d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	BlockLen(pc),d0
	subq.w	#1,d0
	bsr.s	ScrPattDown2
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
ScrPattDown:
	MOVEQ	#63,D0
ScrPattDown2:
	subq.l	#1,d0
	bmi.w	.end
	move.l	d0,d3
	lsl.l	#4,d3	; *16
	add.l	d3,a0
	move.w	16(a0),d1
	move.w	18(a0),d2
	tst.b	RotFlag
	bne.s	.loop
	moveq	#0,d1
	moveq	#0,d2
.loop	tst.b	LeftFlag
	bne.s	.skip1
	move.w	(a0),16(a0)
	move.w	2(a0),d3
	and.w	#$f000,d3
	and.w	#$0fff,18(a0)
	or.w	d3,18(a0)
.skip1	tst.b	RightFlag
	bne.s	.skip2
	move.w	2(a0),d3
	and.w	#$0fff,d3
	and.w	#$f000,18(a0)
	or.w	d3,18(a0)
.skip2	LEA	-16(A0),A0
	DBRA	D0,.loop
	tst.b	LeftFlag
	bne.s	.skip3
	move.w	d1,16(a0)
	and.w	#$0fff,18(a0)
	move.w	d2,d3
	and.w	#$f000,d3
	or.w	d3,18(a0)
.skip3	tst.b	RightFlag
	bne.s	.end
	move.w	d2,d3
	and.w	#$0fff,d3
	and.w	#$f000,18(a0)
	or.w	d2,18(a0)
.end	rts

CheckFlip:
	sf	LeftFlag
	sf	RightFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr	; get address of track
	tst.w	FlipStat1	; Is it Track?
	beq.s	.do
	cmp.w	#2,FlipStat1	; Is it Cmds?
	beq.s	FlipCmds
	cmp.w	#3,FlipStat1	; Is it Block?
	beq.s	FlipBlock
	cmp.w	#1,FlipStat1	; ok! Is it Pattern?
	RNE			; nope... exit!
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.W	FlipPatt
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR	FlipPatt
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR	FlipPatt
	MOVEQ	#21,D0
	BSR	GetPositionPtr
.do	BSR	FlipPatt
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
FlipCmds:
	move.w	PattCurPos,BlockPosX
	clr.w	BlockPosY
	move.w	#64,BlockLen
	st	LeftFlag
	sf	RightFlag
	bra.s	FlipBlock2
FlipBlock:
	jsr	GetBlockArea
	RNE
FlipBlock2:
	move.w	BlockPosX(pc),d0
	BSR	GetPositionPtr
	move.w	BlockPosY(pc),d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	BlockLen(pc),d0
	subq.w	#1,d0
	bsr.s	FlipPatt2
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
FlipPatt:
	MOVEQ	#64-1,D0
FlipPatt2:
	lea	WorkBuffer,a1
	move.l	a0,a2
	move.l	a1,a3
	move.l	d0,d1
.loop1	move.l	(a2),(a3)+
	lea	16(a2),a2
	dbf	d1,.loop1
	move.l	d0,d1
	lsl.l	#2,d1
	add.l	d1,a1
.loop2	tst.b	LeftFlag
	bne.s	.skip1
	move.w	(a1),(a0)
	move.w	2(a1),d3
	and.w	#$f000,d3
	and.w	#$0fff,2(a0)
	or.w	d3,2(a0)
.skip1	tst.b	RightFlag
	bne.s	.skip2
	move.w	2(a1),d3
	and.w	#$0fff,d3
	and.w	#$f000,2(a0)
	or.w	d3,2(a0)
.skip2	LEA	16(A0),A0
	lea	-4(a1),a1
	DBRA	D0,.loop2
	rts

CheckClear:
	sf	LeftFlag
	sf	RightFlag
	MOVE.W	PattCurPos,D0
	JSR	GetPositionPtr	; get address of track
	tst.w	FlipStat1	; Is it Track?
	beq.s	.do
	cmp.w	#2,FlipStat1	; Is it Cmds?
	beq.s	_ClearCmds
	cmp.w	#3,FlipStat1	; Is it Block?
	beq	_ClearBlock
	cmp.w	#1,FlipStat1	; ok! Is it Pattern?
	RNE			; nope... exit!
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.W	_ClearPatt
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR	_ClearPatt
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR	_ClearPatt
	MOVEQ	#21,D0
	BSR	GetPositionPtr
.do	BSR	_ClearPatt
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jmp	InvertBlockArea
_ClearCmds:
	move.w	PattCurPos,BlockPosX
	clr.w	BlockPosY
	move.w	#64,BlockLen
	st	LeftFlag
	sf	RightFlag
	bra.s	_ClearBlock2
_ClearBlock:
	jsr	GetBlockArea
	RNE
_ClearBlock2:
	move.w	BlockPosX(pc),d0
	BSR	GetPositionPtr
	move.w	BlockPosY(pc),d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	BlockLen(pc),d0
	subq.w	#1,d0
	bsr.s	_ClearPatt2
	bra	RedrawPattern
_ClearPatt:
	MOVEQ	#64-1,D0
_ClearPatt2:
.loop2	tst.b	LeftFlag
	bne.s	.skip1
	clr.w	(a0)
	and.w	#$0fff,2(a0)
.skip1	tst.b	RightFlag
	bne.s	.skip2
	and.w	#$f000,2(a0)
.skip2	LEA	16(A0),A0
	DBRA	D0,.loop2
	rts

CheckCutBlock:
	cmp.w	#3,FlipStat1	; Is it Block?
	RNE
	bsr	CheckCopyBlock	; first copy it
	bsr	CheckClear	; then clear it
	rts

CheckCopyBlock:
	sf	LeftFlag
	sf	RightFlag
	cmp.w	#3,FlipStat1	; Is it Block?
	RNE
	jsr	GetBlockArea
	RNE			; (Msg Set block please ?)
	move.w	BlockPosX(pc),d0
	BSR	GetPositionPtr
	move.w	BlockPosY(pc),d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	BlockLen(pc),d0
	subq.w	#1,d0
	bsr.s	_CopyBlock
	st	CopyBlkFlag		; We have a buffer
	move.b	LeftFlag(pc),CopyLeft
	move.b	RightFlag(pc),CopyRight
	move.w	BlockLen(pc),CopyLen
	rts
_CopyBlock:
	lea	BlockBuffer2,a1
.loop2	tst.b	LeftFlag
	bne.s	.skip1
	move.w	(a0),(a1)
	move.w	2(a0),d1
	and.w	#$f000,d1
	move.w	d1,2(a1)
.skip1	tst.b	RightFlag
	bne.s	.skip2
	move.w	2(a0),d1
	and.w	#$0fff,d1
	and.w	#$f000,2(a1)
	or.w	d1,2(a1)
.skip2	LEA	16(A0),A0
	LEA	4(A1),A1
	DBRA	D0,.loop2
	rts

CheckPasteBlock:
	cmp.w	#3,FlipStat1	; Is it Block?
	RNE
	tst.b	CopyBlkFlag
	REQ
	MOVE.W	PattCurPos,D0
	BSR	GetPositionPtr	; get address of track
	move.w	ScrPattPos,d0
	lsl.w	#4,d0
	add.w	d0,a0		; address of pos. in track
	move.w	CopyLen(pc),d0
	move.w	d0,d1
	add.w	ScrPattPos,d1
	cmp.w	#64,d1
	bmi.s	.cnt
	sub.w	#64,d1
	sub.w	d1,d0
.cnt	subq.w	#1,d0
	bmi.s	.end
	bsr.s	_PasteBlock
	jsr	InvertBlockArea
	bsr	RedrawPattern2
	jsr	InvertBlockArea
.end	rts
_PasteBlock:
	lea	BlockBuffer2,a1
.loop2	tst.b	CopyLeft
	bne.s	.skip1
	move.w	(a1),(a0)
	move.w	2(a1),d1
	and.w	#$f000,d1
	move.w	d1,2(a0)
.skip1	tst.b	CopyRight
	bne.s	.skip2
	move.w	2(a1),d1
	and.w	#$0fff,d1
	and.w	#$f000,2(a0)
	or.w	d1,2(a0)
.skip2	LEA	16(A0),A0
	LEA	4(A1),A1
	DBRA	D0,.loop2
	rts


	cnop	0,4
BlockPosX:	dc.w	0
BlockPosY:	dc.w	0
BlockLen:	dc.w	0
CopyLen:	dc.w	0
RotFlag:	dc.b	0
LeftFlag:	dc.b	0
RightFlag:	dc.b	0
CopyBlkFlag:	dc.b	0
CopyLeft:	dc.b	0
CopyRight:	dc.b	0
	cnop	0,2

CheckOctUp:
	cmp.w	#1,FlipStat1
	RHI
	moveq	#0,d0
	tst.w	FlipStat1	; Is it track ?
	beq.s	OctaveUp
	move.w	#300,d0
OctaveUp:
	MOVE.W	#12*2,NoteShift
	BRA.S	nup2

CheckNoteUp:
	cmp.w	#1,FlipStat1
	RHI
	moveq	#0,d0
	tst.w	FlipStat1	; Track ?
	beq.s	NoteUp
	move.w	#300,d0
NoteUp	MOVE.W	#2,NoteShift
nup2	jSR	SaveUndo
	CMP.W	#214,D0
	BLS.s	nup3
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteUp
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteUp
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteUp
	MOVEQ	#21,D0
	BSR	GetPositionPtr
nup3	BSR.S	SampleNoteUp
	BRA	RedrawPattern

SampleNoteUp:
	MOVEQ	#64-1,D6
	MOVE.L	A0,A3
	MOVE.W	InsNum,D3
	TST.B	SampleAllFlag
	BEQ.S	sanulo2
	MOVEQ	#0,D3
sanulo2	MOVE.L	D6,D0
	MOVE.L	A3,A0
.loop	tst.b	SampleAllFlag
	bne.s	.cnt
	MOVE.B	2(A0),D1
	LSR.B	#4,D1
	MOVE.B	(A0),D2
	AND.B	#$F0,D2
	OR.B	D2,D1
	CMP.B	D3,D1
	BNE.S	.skip		; nope, not this note
.cnt	MOVE.W	(A0),D1
	MOVE.W	D1,D2
	AND.W	#$F000,D2
	AND.W	#$0FFF,D1
	BEQ.S	.skip
	BSR	CheckPeriod
	BNE.S	.skip
	ADD.W	NoteShift(PC),D5
	CMP.W	#$0048,D5
	BLO.S	.ok
	btst	#1,EditBitFlags+3	;TransDelFlag
	BEQ.S	.skip
	AND.L	#$00000FFF,(A0)
	BRA.S	.skip
.ok	MOVE.W	(A2,D5.W),D1
	OR.W	D2,D1
	MOVE.W	D1,(A0)
.skip	LEA	16(A0),A0
	DBRA	D0,.loop
	;TST.B	SampleAllFlag
	;REQ
	;ADDQ.W	#1,D3
	;CMP.W	#32,D3
	;BLO.S	sanulo2
	RTS

CheckOctDown:
	cmp.w	#1,FlipStat1
	RHI
	moveq	#0,d0
	tst.w	FlipStat1	; Track ?
	beq.s	OctaveDown
	move.w	#300,d0
OctaveDown:
	MOVE.W	#24,NoteShift
	BRA.S	ndown2

CheckNoteDown:
	cmp.w	#1,FlipStat1
	RHI
	moveq	#0,d0
	tst.w	FlipStat1	; Track ?
	beq.s	NoteDown
	move.w	#300,d0
NoteDown:
	MOVE.W	#2,NoteShift
ndown2	JSR	SaveUndo
	CMP.W	#214,D0
	BLS.S	.down3
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteDown
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteDown
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR.S	SampleNoteDown
	MOVEQ	#21,D0
	BSR	GetPositionPtr
.down3	BSR.S	SampleNoteDown
	BRA	RedrawPattern

SampleNoteDown:
	MOVEQ	#63,D6
	MOVE.L	A0,A3
	MOVE.W	InsNum,D3
	TST.B	SampleAllFlag
	BEQ.S	sandlo2
	MOVEQ	#0,D3
sandlo2	MOVE.W	D6,D0
	MOVE.L	A3,A0
.loop	tst.b	SampleAllFlag
	bne.s	.cnt
	MOVE.B	2(A0),D1
	LSR.B	#4,D1
	MOVE.B	(A0),D2
	AND.B	#$F0,D2
	OR.B	D2,D1
	CMP.B	D1,D3
	BNE.S	.skip
.cnt	MOVE.W	(A0),D1
	MOVE.W	D1,D2
	AND.W	#$F000,D2
	AND.W	#$0FFF,D1
	BEQ.S	.skip
	BSR.S	CheckPeriod
	BNE.S	.skip
	SUB.W	NoteShift(PC),D5
	BPL.S	.ok
	btst	#1,EditBitFlags+3	;TransDelFlag
	BEQ.S	.skip
	AND.L	#$00000FFF,(A0)
	BRA.S	.skip
.ok	MOVE.W	0(A2,D5.W),D1
	OR.W	D2,D1
	MOVE.W	D1,(A0)
.skip	LEA	16(A0),A0
	DBRA	D0,.loop
	;TST.B	SampleAllFlag
	;REQ
	;ADDQ.W	#1,D3
	;CMP.W	#$20,D3
	;BLO.S	sandlo2
	RTS
	cnop	0,4
NoteShift:dc.w	0

CheckPeriod:
	LEA	PeriodTable,A2
	MOVEQ	#-2,D5
.loop	ADDQ.L	#2,D5
	MOVE.W	0(A2,D5.W),D4
	BEQ.S	PeriodNotOk
	CMP.W	D4,D1
	BEQ.S	PeriodOk
	BRA.S	.loop

PeriodOk:
	MOVEQ	#0,D4
	RTS

PeriodNotOk:
	MOVEQ	#-1,D4
	RTS

ToggleTrackPatt:
	JSR	WaitForButtonUp
	ADDQ.B	#1,TrackPattFlag
	CMP.B	#3,TrackPattFlag
	BLO.S	ShowTrackPatt
	CLR.B	TrackPattFlag
ShowTrackPatt:
	move.w	#364,d0
	moveq	#58,d1
	moveq	#7,d3
	TST.B	TrackPattFlag
	bne.s	.skip1
	lea	.text1(pc),a0
	jmp	ShowColorText
.skip1	CMP.B	#1,TrackPattFlag
	bne.s	.skip2
	lea	.text2(pc),a0
	jmp	ShowColorText
.skip2	lea	.text3(pc),a0
	jmp	ShowColorText
.text1	dc.b	' Track '
.text2	dc.b	'Pattern'
.text3	dc.b	' Sample'
	cnop	0,2

KillInstrTrack
	JSR	SaveUndo
	MOVE.W	PattCurPos,D0
	BSR	GetPositionPtr
	BRA.S	dst2

DelSampleTrack
	JSR	SaveUndo
	TST.B	TrackPattFlag
	BEQ.S	dst2
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.S	dstdoit
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR.S	dstdoit
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR.S	dstdoit
	MOVEQ	#21,D0
	BSR	GetPositionPtr
dst2	BSR.S	dstdoit
	BRA	RedrawPattern

dstdoit	CLR.B	RawKeyCode
	MOVEQ	#63,D0
	MOVE.W	InsNum,D3
	BEQ	NotSampleNull
ksloop	MOVE.B	2(A0),D1
	LSR.B	#4,D1
	MOVE.B	(A0),D2
	AND.B	#$F0,D2
	OR.B	D2,D1
	CMP.B	D1,D3
	BNE.S	ksskip
	CLR.L	(A0)
ksskip	LEA	16(A0),A0
	DBRA	D0,ksloop
	RTS

KillSample:
	LEA	KillSampleText,A0
	JSR	AreYouSure
	RNE
Destroy:JSR	StorePtrCol
	MOVE.W	InsNum,D0
	JEQ	ErrorRestoreCol
	BSR	TurnOffVoices
	BSR	FreeSample
	MOVE.L	SongDataPtr,A0
	MOVE.W	InsNum,D0
	MULU	#30,D0
	LEA	-10(A0),A0
	ADD.L	D0,A0
	MOVE.L	A0,A1
	MOVEQ	#29,D0
kisalop	CLR.B	(A0)+
	DBRA	D0,kisalop
	MOVE.W	#1,28(A1)
	BSR	ShowSampleInfo
	BSR	RedrawSample
	JMP	RestorePtrCol

ExchSampleTrack
	CMP.B	#2,TrackPattFlag
	BEQ	ExchSamples
	MOVEQ	#0,D4
	BRA.S	mstskip
CopySampleTrack
	CMP.B	#2,TrackPattFlag
	BEQ	CopySamples
mstskip	TST.B	TrackPattFlag
	BEQ.S	mst2
	MOVEQ	#0,D0
	BSR	GetPositionPtr
	BSR.S	mstdoit
	MOVEQ	#7,D0
	BSR	GetPositionPtr
	BSR.S	mstdoit
	MOVEQ	#14,D0
	BSR	GetPositionPtr
	BSR.S	mstdoit
	MOVEQ	#21,D0
	BSR	GetPositionPtr
mst2	BSR.S	mstdoit
	BRA	RedrawPattern

mstdoit	MOVEQ	#63,D0
esloop	MOVE.B	2(A0),D1
	LSR.B	#4,D1
	MOVE.B	(A0),D2
	AND.B	#$F0,D2
	OR.B	D2,D1
	CMP.B	SampleFrom(PC),D1
	BNE.S	esskip2
	AND.L	#$0FFF0FFF,(A0)
	MOVE.B	SampleTo(PC),D2
	MOVE.B	D2,D3
	AND.B	#$F0,D2
	OR.B	D2,(A0)
	LSL.B	#4,D3
	OR.B	D3,2(A0)
	BRA.S	esskip3
esskip2	TST.B	D4
	BNE.S	esskip3
	CMP.B	SampleTo(PC),D1
	BNE.S	esskip3
	AND.L	#$0FFF0FFF,(A0)
	MOVE.B	SampleFrom(PC),D2
	MOVE.B	D2,D3
	AND.B	#$F0,D2
	OR.B	D2,(A0)
	LSL.B	#4,D3
	OR.B	D3,2(A0)
esskip3	LEA	16(A0),A0
	DBRA	D0,esloop
	RTS

ExchSamples
	JSR	StorePtrCol
	MOVEQ	#0,D0
	MOVE.B	SampleFrom(PC),D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D1
	MOVE.B	SampleTo(PC),D1
	JEQ	ErrorRestoreCol
	MOVE.W	D0,D2
	MOVE.W	D1,D3
	LEA	SampleLengthAdd+2,A2
	LSL.W	#1,D2
	LSL.W	#1,D3
	LEA	0(a2,D2.W),A0
	LEA	0(a2,D3.W),A1
	MOVE.W	(A0),D4
	MOVE.W	(A1),(A0)
	MOVE.W	D4,(A1)
	LEA	SamplePtrs,A2
	LSL.W	#1,D2
	LSL.W	#1,D3
	LEA	0(a2,D2.W),A0
	LEA	0(a2,D3.W),A1
	MOVE.L	(A0),D4
	MOVE.L	(A1),(A0)
	MOVE.L	D4,(A1)
	MOVE.L	SAMPLE_LENGTHS(A0),D4
	MOVE.L	SAMPLE_LENGTHS(A1),SAMPLE_LENGTHS(A0)
	MOVE.L	D4,SAMPLE_LENGTHS(A1)
	SUBQ.W	#1,D0
	SUBQ.W	#1,D1
	MULU	#30,D0
	MULU	#30,D1
	MOVE.L	SongDataPtr,A2
	LEA	20(A2),A2
	LEA	0(a2,D0.W),A0
	LEA	0(a2,D1.W),A1
	MOVEQ	#29,D0
exsalop	MOVE.B	(A0),D1
	MOVE.B	(A1),(A0)+
	MOVE.B	D1,(A1)+
	DBRA	D0,exsalop
	BSR	ShowSampleInfo
	BSR	RedrawSample
	JMP	RestorePtrCol

CopySamples
	JSR	StorePtrCol
	MOVEQ	#0,D0
	MOVE.B	SampleFrom(PC),D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D1
	MOVE.B	SampleTo(PC),D1
	JEQ	ErrorRestoreCol
	LEA	SamplePtrs,A2
	LSL.W	#2,D0
	LSL.W	#2,D1
	LEA	0(a2,D0.W),A3
	LEA	0(a2,D1.W),A4
	MOVE.L	(A3),D0
	JEQ	ErrorRestoreCol
	MOVE.L	SAMPLE_LENGTHS(A3),D0
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	TST.L	D0
	BEQ	OutOfMemErr
	MOVE.L	D0,A5
	MOVEQ	#0,D0
	MOVE.B	SampleTo(PC),D0
	MOVE.W	D0,InsNum
	BSR	Destroy
	MOVE.L	A5,(A4)
	MOVE.L	SAMPLE_LENGTHS(A3),D0
	MOVE.L	D0,SAMPLE_LENGTHS(A4)
	MOVE.L	(A3),A0
.loop	MOVE.B	(A0)+,(A5)+
	SUBQ.L	#1,D0
	BNE.S	.loop
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.B	SampleFrom(PC),D0
	MOVE.B	SampleTo(PC),D1
	MOVE.W	D1,InsNum
	MULU	#30,D0
	MULU	#30,D1
	MOVE.L	SongDataPtr,A2
	LEA	-10(A2),A2
	LEA	0(a2,D0.W),A0
	LEA	0(a2,D1.W),A1
	MOVEQ	#29,D0
cosalop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,cosalop
	BSR	ShowSampleInfo
	BSR	RedrawSample
	JMP	RestorePtrCol

SetSampleFrom
	MOVE.W	InsNum,D2
	bra	sesfskip
sesfdown
	MOVE.B	SampleFrom(PC),D2
	SUBQ.B	#1,D2
	BPL.S	sesfskip
	MOVEQ	#0,D2
sesfskip
	MOVE.B	D2,SampleFrom
	BSR	Wait_4000
	BRA.S	ShowFrom
sesfup	MOVE.B	SampleFrom(PC),D2
	ADDQ.B	#1,D2
	CMP.B	#$1F,D2
	BLS.S	sesfskip
	MOVE.B	#$1F,SampleFrom
ShowFrom
	MOVE.W	#91*80+51,TextOffset
	CLR.W	WordNumber
	MOVE.B	SampleFrom(PC),WordNumber+1
	BRA	PrintHexByte

SetSampleTo
	MOVE.W	InsNum,D2
	bra	sestskip
sestdown
	MOVE.B	SampleTo(PC),D2
	SUBQ.B	#1,D2
	BPL.S	sestskip
	MOVEQ	#0,D2
sestskip
	MOVE.B	D2,SampleTo
	BSR	Wait_4000
	BRA.S	ShowTo
sestup	MOVE.B	SampleTo(PC),D2
	ADDQ.B	#1,D2
	CMP.B	#$1F,D2
	BLS.S	sestskip
	MOVE.B	#$1F,SampleTo
ShowTo	MOVE.W	#102*80+51,TextOffset
	CLR.W	WordNumber
	MOVE.B	SampleTo(PC),WordNumber+1
	BRA	PrintHexByte
	cnop	0,4
SampleFrom	dc.b 0
SampleTo	dc.b 0

ToggleRecordMode
	JSR	WaitForButtonUp
	EOR.B	#1,RecordMode
ShowRecordMode
	move.w	#582,d0
	moveq	#69,d1
	moveq	#7,d3
	lea	.text1(pc),a0
	TST.B	RecordMode
	BEQ.S	.skip
	lea	.text2(pc),a0
.skip	jmp	ShowColorText
.text1	dc.b	'Pattern'
.text2	dc.b	'Song   '

	cnop	0,4
RecordMode	dc.b 0
QuantizeValue	dc.b 1
MetroSpeed	dc.b 4
MetroChannel	dc.b 0
MultiFlag	dc.b 0
SampleAllFlag	dc.b -1
TrackPattFlag	dc.b 0
ClipHalveFlag	dc.b 0
AbortDecFlag	dc.w 0

GetDecByte
	MOVE.W	#1,AbortDecFlag
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	gdbexit
	MOVE.B	D1,D0
	MULU	#10,D0
	MOVE.B	D0,GetDecTemp
	BSR	ShowOneDigit
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	gdbexit
	ADD.B	D1,GetDecTemp
	CLR.W	AbortDecFlag
gdbexit	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	JSR	RestorePtrCol
	MOVE.B	GetDecTemp,D0
	RTS

GetAnyDecByte
	MOVE.W	#1,AbortDecFlag
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	gdbanyexit
	MOVE.B	D1,D0
	MULU	#10,D0
	MOVE.B	D0,GetDecTemp
	move.l	d1,d3
	move.w	d4,d0
	move.w	d5,d1
	BSR	ShowAnyOneDigit
	move.l	d3,d1
	ADDQ.W	#8,LineCurX
	BSR	UpdateLineCurPos
	BSR	GetKey0_9
	CMP.B	#68,D1
	BEQ.S	gdbanyexit
	ADD.B	D1,GetDecTemp
	CLR.W	AbortDecFlag
gdbanyexit
	CLR.W	LineCurX
	MOVE.W	#270,LineCurY
	BSR	UpdateLineCurPos
	JSR	RestorePtrCol
	MOVE.B	GetDecTemp,D0
	RTS



QuantPlus
	jsr	Wait_4000
	moveq	#0,d0
	MOVE.B	QuantizeValue(pc),d0
	addq.w	#1,d0
	bra.s	tqskip2
QuantMinus
	jsr	Wait_4000
	moveq	#0,d0
	MOVE.B	QuantizeValue(pc),d0
	subq.w	#1,d0
	bpl.s	.cnt
	moveq	#0,d0
.cnt	bra.s	tqskip2
SetQuantize
	CLR.B	RawKeyCode
	MOVE.W	#436,LineCurX
	MOVE.W	#65,LineCurY
	MOVE.W	#59*80+54,TextOffset
	BSR	GetDecByte
 	TST.W	AbortDecFlag
	BNE	ShowQuantize
tqskip2	CMP.B	#63,D0
	BLS.S	tqskip
	MOVEQ	#63,D0
tqskip	MOVE.B	D0,QuantizeValue
ShowQuantize
	MOVE.W	#58*80+54,TextOffset
	CLR.W	WordNumber
	MOVE.B	QuantizeValue,WordNumber+1
	BRA	Print2DecDigits

SetMetronome
	CLR.B	RawKeyCode
	CMP.W	#450,D0
	BHS.S	smchan
	MOVE.W	#80*80+54,TextOffset
	MOVE.W	#436,LineCurX
	MOVE.W	#80+5,LineCurY
	BSR	GetDecByte
	TST.W	AbortDecFlag
	BNE	ShowMetronome
	CMP.B	#64,D0
	BLS.S	smexit
	MOVEQ	#64,D0
smexit	MOVE.B	D0,MetroSpeed
	BRA.S	ShowMetronome

smchan	MOVE.W	#80*80+57,TextOffset
	jsr	GetHexByte	
	CMP.W	#4,D0
	BLS.S	smexit2
	MOVEQ	#4,D0
smexit2	MOVE.B	D0,MetroChannel
ShowMetronome:
	MOVE.W	#80*80+54,TextOffset
	CLR.W	WordNumber
	MOVE.B	MetroSpeed,WordNumber+1
	BSR	Print2DecDigits
	MOVE.W	#80*80+57,TextOffset
	CLR.W	WordNumber
	MOVE.B	MetroChannel,WordNumber+1
	BRA	Print2DecDigits

ToggleMultiMode:
	JSR	WaitForButtonUp
	CLR.B	RawKeyCode
	EOR.B	#1,MultiFlag
ShowMultiMode:
	BSR.S	Show_MS
	cmp.w	#MainScreen_ID,CurrScreen
	RNE
	cmp.w	#1,MenuNumber
	RNE
	move.w	#582,d0
	moveq	#80,d1
	moveq	#6,d3
	lea	.text2(pc),a0
	TST.B	MultiFlag
	BEQ.S	.skip
	lea	.text1(pc),a0
.skip	jmp	ShowColorText
.text1	dc.b	'Multi '
.text2	dc.b	'Single'

Show_MS:MOVE.B	#' ',D0
	TST.B	MultiFlag
	BEQ.S	.skp1
	MOVE.B	#'M',D0
.skp1	MOVE.B	#' ',D1
	btst	#4,EditBitFlags+3	;SplitFlag
	BEQ.S	.skp2
	MOVE.B	#'S',D1
.skp2	MOVE.B	D0,.text
	MOVE.B	D1,.text+1
	MOVE.W	#128*80+1,D1
	MOVEQ	#2,D0
	LEA	.text(PC),A0
	BSR	ShowText3
	JMP	ShowAutoInsert
	cnop	0,4
.text:	dc.b '__'


;---- Edit Op. 3 ----

ToggleHalfClip:
	JSR	WaitForButtonUp
	EOR.B	#1,HalfClipFlag
ShowHalfClip:
	move.w	#593,d0
	moveq	#58,d1
	moveq	#6,d3
	TST.B	HalfClipFlag
	BEQ.S	.cnt
	lea	.text1(pc),a0
	jmp	ShowColorText
.cnt	lea	.text2(pc),a0
	jmp	ShowColorText
.text1	dc.b	' Half '
.text2	dc.b	' Clip '

SetSamplePos:
	MOVE.L	SamplePos(PC),D2
	bra	shposkip2
shpodown
	MOVE.L	SamplePos(PC),D2
	SUBQ.L	#1,D2
	BTST	#2,$DFF016
	BNE.S	shposkip
	SUB.L	#15,D2
shposkip
	BPL.S	shposkip2
	MOVEQ	#0,D2
shposkip2
	MOVE.L	D2,SamplePos
	BRA.S	ShowPos
shpoup	MOVE.L	SamplePos(PC),D2
	ADDQ.L	#1,D2
	BTST	#2,$DFF016
	BNE.S	.skip3
	ADD.L	#15,D2
.skip3	MOVEQ	#0,D3
	MOVE.W	22(A5),D3
	LSL.L	#1,D3
	CMP.L	D3,D2
	BLS.S	shposkip2
	MOVE.L	D3,SamplePos
ShowPos:cmp.w	#MainScreen_ID,CurrScreen
	bne.s	.cnt
	cmp.w	#2,MenuNumber
	bne.s	.cnt
	MOVE.W	#69*80+73,TextOffset
	MOVE.W	SamplePos+2(PC),WordNumber
	LEA	BlankSample,A0
	CMP.L	SamStart,A0
	BNE.S	.cnt4
	clr.w	WordNumber
.cnt4	BSR	PrintHexWord
.cnt	tst.w	SamScrEnable
	beq.s	.cnt3
	MOVE.L	SamplePos(PC),d2
	LEA	BlankSample,A0
	CMP.L	SamStart,A0
	BNE.S	.cnt2
	MOVEQ	#0,D2
.cnt2	move.w	#424,d0 	; x for position
	move.w	#226,d1		; y for position
	moveq	#7,d3		; number of digits
				; d2 is value, most probably
	bsr	PrintAnyDigits
	MOVE.L	MarkEndOfs(PC),d2
	MOVE.L	MarkStartOfs(PC),d0
	bpl.s	.cnt6
	moveq	#0,d0
	moveq	#0,d2
.cnt6	sub.l	d0,d2
	bpl.s	.cnt7
	neg.l	d2
.cnt7	LEA	BlankSample,A0
	CMP.L	SamStart,A0
	BNE.S	.cnt5
	MOVEQ	#0,D2
.cnt5	move.w	#424,d0 	; range len
	move.w	#237,d1
	moveq	#7,d3
	bsr	PrintAnyDigits
.cnt3	rts


SetModSpeed:
	MOVEQ	#0,D2
	BTST	#2,$DFF016
	BEQ.S	semoskp
	MOVE.B	ModSpeed,D2
	bra	semoskp
semodown
	MOVE.B	ModSpeed,D2
	SUB.B	#1,D2
	CMP.B	#127,D2
	BNE.S	semoskp
	MOVE.B	#128,D2
	BRA.S	semoskp
semoup	MOVE.B	ModSpeed,D2
	ADD.B	#1,D2
	CMP.B	#128,D2
	BNE.S	semoskp
	MOVEQ	#127,D2
semoskp	MOVE.B	D2,ModSpeed
	BSR	Wait_4000
ShowMod:LEA	PlusMinusText(PC),A0
	MOVEQ	#0,D6
	MOVE.B	ModSpeed,D6
	BPL.S	shmoskp
	NEG.B	D6
	ADDQ.L	#1,A0
shmoskp	MOVEQ	#1,D0
	MOVE.W	#80*80+73,D1
	BSR	ShowText3
	MOVE.W	D6,WordNumber
	BRA	Print3DecDigits

PlusMinusText:	dc.b ' -'

DoMod:	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D2
	MOVE.W	SampleInfo,D2
	JEQ	ErrorRestoreCol
	add.l	d2,d2
	SUBQ.L	#1,D2
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	BSR	AllocBuffer
	MOVE.L	D0,A2
	MOVE.L	D0,A3
	MOVE.L	A1,A4
	ADD.L	D2,A3
	CLR.L	ModOffset
	CLR.L	ModPos
dmoloop	CMP.L	A3,A2
	BHS.S	dmoskip
	MOVE.B	(A1),(A2)+
	BSR.S	UpdateMod
	BRA.S	dmoloop
dmoskip	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	BSR	FreeBuffer
	JSR	RestorePtrCol
	BRA	DisplaySample

UpdateMod
	MOVE.B	ModSpeed(PC),D0
	BEQ	upmplus
	EXT.W	D0
	EXT.L	D0
	MOVE.L	ModPos(PC),D1
	ADD.L	D0,D1
	MOVE.L	D1,ModPos
	ASR.L	#8,D1
	ASR.L	#4,D1
	MOVE.L	D1,D3
	AND.W	#$1F,D1	
	LEA	VibratoTable,A0
	MOVEQ	#0,D0
	MOVE.B	0(a0,D1.W),D0
	LSR.B	#2,D0
	MOVE.L	ModOffset(PC),D1
	BTST	#5,D3
	BEQ.S	upmskip
	SUB.L	D0,D1
	BRA.S	upmskp2
upmskip	ADD.L	D0,D1
upmskp2	ADD.L	#$800,D1
	MOVE.L	D1,ModOffset
	ASR.L	#8,D1
	ASR.L	#3,D1
	BPL.S	upmskp3
	MOVEQ	#0,D1
upmskp3	CMP.L	D2,D1
	BLO.S	upmskp4
	MOVE.L	D2,D1
upmskp4	MOVE.L	A4,A1
	ADD.L	D1,A1
	RTS
upmplus	ADDQ.L	#1,A1
	RTS

CutBeg
	CMP.W	#283,D0
	BHI	FadeDown
	CMP.W	#259,D0
	BHI	FadeUp

	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D3
	MOVE.W	SampleInfo,D3
	JEQ	ErrorRestoreCol
	add.l	d3,d3
	SUBQ.L	#1,D3
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A1
	MOVE.L	D0,A2
	MOVE.L	D0,A3
	ADD.L	SamplePos(PC),A2
	ADD.L	D3,A3
cbeloop	CMP.L	A3,A2
	BHS.S	cbeskip
	MOVE.B	(A2),D0
	CLR.B	(A2)+
	MOVE.B	D0,(A1)+
	BRA.S	cbeloop	
cbeskip	MOVE.L	si_pointer,A2
	CLR.W	(A2)
	SUB.L	A2,A1
	MOVE.L	A1,D0
	LSR.L	#1,D0
	ADDQ.L	#1,D0
	AND.L	#$7FFF,D0	; 128k/2
	MOVE.W	D0,22(A5)
	BSR	ShowSampleInfo
	JSR	RestorePtrCol
	BRA	DisplaySample

FadeUp	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D3
	MOVE.W	SampleInfo,D3
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D1
	MOVE.L	SamplePos(PC),D2
	JEQ	ErrorRestoreCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A0
	LSR.L	#1,D2
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D4
fuloop	MOVE.B	(A0),D0
	EXT.W	D0
	MULS	D1,D0
	DIVS	D2,D0
	MOVE.B	D0,(A0)+
	ADDQ.W	#1,D4
	MOVE.W	D4,D1
	LSR.W	#1,D1
	CMP.W	D2,D1
	BLO.S	fuloop
	JSR	RestorePtrCol
	BRA	DisplaySample

FadeDown
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D3
	MOVE.W	SampleInfo,D3
	JEQ	ErrorRestoreCol
	LSL.L	#1,D3
	SUBQ.L	#1,D3 			;Length-1
	MOVE.L	SamplePos(PC),D2
	CMP.L	D3,D2
	JHS	ErrorRestoreCol
	MOVE.L	D3,D4 			; Copy length to D4
	SUB.L	D2,D3 			; Length-pos
	MOVE.L	D3,D2 			; Copy offset to D2
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A0
	LEA	0(a0,D4.L),A0 		;Start at end of sample
	LSR.L	#1,D2
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D1
	MOVEQ	#0,D4
fdloop	MOVE.B	(A0),D0
	EXT.W	D0
	MULS	D1,D0
	DIVS	D2,D0
	MOVE.B	D0,(A0)
	SUBQ.L	#1,A0
	ADDQ.W	#1,D4
	MOVE.W	D4,D1
	LSR.W	#1,D1
	CMP.W	D2,D1
	BLO.S	fdloop
	JSR	RestorePtrCol
	BRA	DisplaySample

ChangeVolume
	MOVE.W	SampleVol(PC),D2
	bra	shvoskip2
shvodown
	MOVE.W	SampleVol(PC),D2
	SUBQ.W	#1,D2
	BTST	#2,$DFF016
	BNE.S	shvoskip
	SUB.W	#9,D2
shvoskip
	BPL.S	shvoskip2
	MOVEQ	#0,D2
shvoskip2
	MOVE.W	D2,SampleVol
	BSR	Wait_4000
	BRA.S	ShowVol
shvoup	MOVE.W	SampleVol(PC),D2
	ADDQ.L	#1,D2
	BTST	#2,$DFF016
	BNE.S	shvoskip3
	ADD.W	#9,D2
shvoskip3
	CMP.W	#999,D2
	BLS.S	shvoskip2
	MOVE.W	#999,SampleVol
	BSR	Wait_4000
ShowVol	MOVE.W	#102*80+73,TextOffset
	MOVE.W	SampleVol(PC),WordNumber
	BSR	Print3DecDigits
	LEA	PercentText(PC),A0
	MOVE.W	#1,TextLength
	BRA	ShowText2

PercentText	dc.b '%',0

DoChangeVol
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D3
	MOVE.W	SampleInfo,D3
	JEQ	ErrorRestoreCol
	ADD.L	d3,d3
	SUBQ.L	#1,D3
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A1
	MOVE.W	SampleVol(PC),D0
dcvloop	MOVE.B	(A1),D1
	EXT.W	D1
	MULS	D0,D1
	DIVS	#100,D1
	CMP.W	#127,D1
	BLE.S	dcvskip
	MOVEQ	#127,D1
dcvskip	CMP.W	#-128,D1
	BGE.S	dcvskp2
	MOVEQ	#-128,D1
dcvskp2	MOVE.B	D1,(A1)+
	DBRA	D3,dcvloop
	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	JSR	RestorePtrCol
	BRA	DisplaySample

Mix:	BTST	#2,$DFF016
	BEQ	OldMix
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.W	#1,GetLineFlag
	MOVE.W	#4,MixCurPos
mixlopx	BSR	DisplayMix
	JSR	GetHexKey
	TST.B	D0
	BNE	mixnzro
	CMP.B	#68,MixChar
	BEQ	Mix2
	CMP.B	#69,MixChar
	BEQ	EndMix
	BTST	#2,$DFF016
	BEQ	EndMix
mixpchr	LEA	MixText(PC),A0
	LEA	FastHexTable+1,A1
	LSL.W	#1,D1
	MOVE.W	MixCurPos(PC),D0
	MOVE.B	0(a1,D1.W),0(a0,D0.W)
MixMoveRight
	MOVE.W	MixCurPos,D0
	ADDQ.W	#1,D0
	CMP.W	#6,D0
	BEQ.S	mmrp1
	CMP.W	#9,D0
	BEQ.S	mmrp2
	CMP.W	#15,D0
	BHS.S	mmrp3
mmrok	MOVE.W	D0,MixCurPos
	BRA	mixlopx
mmrp1	MOVEQ	#7,D0
	BRA.S	mmrok
mmrp2	MOVEQ	#13,D0
	BRA.S	mmrok
mmrp3	MOVEQ	#14,D0
	BRA.S	mmrok

mixnzro	CMP.B	#1,D0
	BEQ.S	MixMoveRight
MixMoveLeft
	MOVE.W	MixCurPos,D0
	SUBQ.W	#1,D0
	CMP.W	#4,D0
	BLO.S	mmlp1
	CMP.W	#6,D0
	BEQ.S	mmlp2
	CMP.W	#12,D0
	BEQ.S	mmlp3
	BRA.S	mmrok
mmlp1	MOVEQ	#4,D0
	BRA.S	mmrok
mmlp2	MOVEQ	#5,D0
	BRA.S	mmrok
mmlp3	MOVEQ	#8,D0
	BRA.S	mmrok

DisplayMix
	MOVE.W	#64,LineCurY
	MOVE.W	MixCurPos,D0
	LSL.W	#3,D0
	ADD.W	#444,D0
	MOVE.W	D0,LineCurX
	JSR	UpdateLineCurPos
	LEA	MixText(PC),A0
	MOVE.W	#59*80+55,D1
	MOVEQ	#22,D0
	BSR	ShowText3
	BSR	Wait_4000
	BSR	Wait_4000
	BRA	Wait_4000

	cnop	0,4
MixText		dc.b 'mix 01+02 to 03       '
MixChar		dc.b 0,0
MixCurPos	dc.w 0
ToSam		dc.w 0
FromPtr1	dc.l 0
FromPtr2	dc.l 0
ToPtr		dc.l 0
MixPtr		dc.l 0
MixLength	dc.l 0

EndMix	CLR.B	RawKeyCode
	BSR	RestoreMix
	JMP	RestorePtrCol

RestoreMix
	CLR.W	GetLineFlag
	MOVE.W	#270,LineCurY
	CLR.W	LineCurX
	JSR	UpdateLineCurPos
	bra	ShowSubMenu2

Mix2	BSR	RestoreMix
	BSR	TurnOffVoices
	LEA	SamplePtrs,A2
	MOVEQ	#0,D0
	LEA	MixText+4(PC),A0
	BSR	HexToInteger2
	TST.W	D0
	BEQ	SamOutOfRange
	CMP.W	#$1F,D0
	BHI	SamOutOfRange
	LSL.W	#2,D0
	LEA	0(a2,D0.W),A3
	MOVE.L	A3,FromPtr1

	MOVEQ	#0,D0
	LEA	MixText+7(PC),A0
	BSR	HexToInteger2
	TST.W	D0
	BEQ	SamOutOfRange
	CMP.W	#$1F,D0
	BHI	SamOutOfRange
	LSL.W	#2,D0
	LEA	0(a2,D0.W),A3
	MOVE.L	A3,FromPtr2

	MOVEQ	#0,D0
	LEA	MixText+13(PC),A0
	BSR	HexToInteger2
	MOVE.W	D0,ToSam
	BEQ	SamOutOfRange
	CMP.W	#$1F,D0
	BHI	SamOutOfRange
	LSL.W	#2,D0
	LEA	0(a2,D0.W),A3
	MOVE.L	A3,ToPtr

	MOVE.L	FromPtr1,A1
	MOVE.L	FromPtr2,A2
	MOVE.L	SAMPLE_LENGTHS(A1),D1
	MOVE.L	SAMPLE_LENGTHS(A2),D2
	CMP.L	D1,D2
	BLO.S	mixnswp
	EXG	D1,D2
mixnswp	TST.L	D1
	BEQ	SamEmptyError 		; Both samples had length=0
	MOVE.L	D1,D0
	AND.L	#$7FFF,D0		; 128k
	MOVE.L	D0,MixLength
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,MixPtr
	BEQ	SamMemError 		; No memory for new sample...

	LEA	MixingText(PC),A0
	BSR	ShowStatusText
	MOVE.L	FromPtr1(PC),A1
	MOVE.L	SAMPLE_LENGTHS(A1),D1
	MOVE.L	(A1),A1
	MOVE.L	FromPtr2(PC),A2
	MOVE.L	SAMPLE_LENGTHS(A2),D2
	MOVE.L	(A2),A2
	MOVE.L	MixPtr(PC),A3
	MOVE.L	MixLength,D3
	TST.W	D1
	BEQ.S	mixnd1
	SUBQ.W	#1,D1
mixnd1	TST.W	D2
	BEQ.S	mixnd2
	SUBQ.L	#1,D2
mixnd2

mixlop2	MOVE.B	(A1),D4
	EXT.W	D4
	MOVE.B	(A2),D0
	EXT.W	D0
	ADD.W	D4,D0
	TST.B	HalfClipFlag
	BEQ	mixhalf
	CMP.W	#127,D0
	BLE.S	mixnbig
	MOVEQ	#127,D0
mixnbig	CMP.W	#-128,D0
	BGE	mixokok
	MOVEQ	#-128,D0
	BRA	mixokok
mixhalf	ASR.W	#1,D0
mixokok	MOVE.B	D0,(A3)+

	TST.W	D1
	BEQ.S	zerd1
	ADDQ.L	#1,A1
	SUBQ.W	#1,D1
	BNE.S	zerd1
	SUB.L	A1,A1

zerd1	TST.W	D2
	BEQ.S	zerd2
	ADDQ.L	#1,A2
	SUBQ.W	#1,D2
	BNE.S	zerd2
	SUB.L	A2,A2

zerd2	subq.l	#1,d3
	bge.s	mixlop2
	MOVE.W	ToSam(PC),InsNum
	BSR	FreeSample
	MOVE.L	ToPtr(PC),A0
	MOVE.L	MixPtr(PC),A1
	CLR.W	(A1)
	MOVE.L	A1,(A0)
	MOVE.L	MixLength(PC),SAMPLE_LENGTHS(A0)
	MOVE.L	SongDataPtr,A0
	MOVE.W	ToSam(PC),D0
	SUBQ.W	#1,D0
	MULU	#30,D0
	LEA	20(A0,D0.W),A0
	MOVE.L	MixLength(PC),D0
	LSR.L	#1,D0
	MOVE.W	D0,22(A0)
	MOVE.W	#$0040,24(A0)
	MOVE.W	#$0000,26(A0)
	MOVE.W	#$0001,28(A0)
	JSR	RestorePtrCol
	BSR	ShowAllRight
	BSR	ShowSampleInfo
	BRA	DisplaySample

SamOutOfRange
	LEA	mixerrtext1(PC),A0
	BSR	ShowStatusText
	JMP	ErrorRestoreCol
SamEmptyError
	LEA	mixerrtext2(PC),A0
	BSR	ShowStatusText
	JMP	ErrorRestoreCol
SamMemError
	LEA	mixerrtext3(PC),A0
	JSR	MemoryRequester
	JMP	ErrorRestoreCol
OutOfMemErr
	LEA	mixerrtext3(PC),A0
	JSR	MemoryRequester
	JSR	SetErrorPtrCol
	MOVEQ	#0,D0
	RTS

mixerrtext1	dc.b 'Sample not in range 01-1F!',0
mixerrtext2	dc.b 'These are empty samples!!',0
mixerrtext3	dc.b 10,10,10,'   Not enough memory!',0		; OBZ!
MixingText	dc.b 'Mixing chosen samples...',0
	cnop	0,2

OldMix	MOVE.L	SamplePos(PC),FlangePos
DoMix	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D2
	MOVE.W	SampleInfo,D2 	; 22(A0)
	REQ
	ADD.L	D2,D2
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	BSR	AllocBuffer
	MOVE.L	D0,A2
	MOVE.L	D0,A3
	MOVE.L	A1,A4
	ADD.L	D2,A3
	ADD.L	FlangePos(PC),A2
	CLR.L	ModOffset
	CLR.L	ModPos
	MOVEQ	#-1,D7
mixloop	ADDQ.L	#1,D7
	CMP.L	A3,A2
	BHS	mixskip
	MOVE.L	MarkStartOfs(PC),D0
	BMI.S	omxget
	MOVE.L	MarkEndOfs(PC),D1
	CMP.L	D0,D1
	BEQ.S	omxget
	CMP.L	D0,D7
	BLO.S	omxok2
	CMP.L	D1,D7
	BHI.S	omxok2
omxget	MOVE.B	(A2),D0
	EXT.W	D0
	MOVE.B	(A1),D1
	EXT.W	D1
	ADD.W	D1,D0
	TST.B	HalfClipFlag
	BEQ.S	omxhalf
	CMP.W	#127,D0
	BLE.S	omxnbig
	MOVEQ	#127,D0
omxnbig	CMP.W	#-128,D0
	BGE.S	omxokok
	MOVEQ	#-128,D0
	BRA.S	omxokok
omxhalf	ASR.W	#1,D0
omxokok	MOVE.B	D0,(A2)+
	BSR	UpdateMod
	BRA.S	mixloop
omxok2	ADDQ.L	#1,A2
	BSR	UpdateMod
	BRA.S	mixloop

mixskip	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	BSR	FreeBuffer
	JSR	RestorePtrCol
	JSR	WaitForButtonUp
	TST.W	DispOrRedraw
	BEQ	DisplaySample
	CLR.W	DispOrRedraw
	BRA	RedrawSample

	cnop	0,4
DispOrRedraw	dc.w 0

AllocBuffer
	MOVE.L	D0,D7
	MOVE.L	D2,D0
	MOVE.L	D2,BufMemSize
	MOVE.L	#MEMF_ANY!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,BufMemPtr
	BEQ	OutOfMemErr
	MOVE.L	D7,A0
	MOVE.L	D0,A1
	MOVE.L	BufMemSize(PC),D0
	SUBQ.L	#1,D0
albloop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,albloop
	MOVE.L	BufMemPtr(PC),A1
	MOVE.L	D7,D0
	RTS

FreeBuffer
	MOVE.L	BufMemPtr(PC),D0
	REQ
	MOVE.L	D0,A1
	MOVE.L	BufMemSize(PC),D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	CLR.L	BufMemPtr
	RTS

Echo	MOVE.L	SamplePos(PC),FlangePos
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D2
	MOVE.W	SampleInfo,D2	 	; 22(A0)
	JEQ	ErrorRestoreCol
	ADD.L	D2,D2
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A1
	MOVE.L	D0,A2
	MOVE.L	D0,A3
	MOVE.L	D0,A4
	ADD.L	D2,A3
	ADD.L	FlangePos(PC),A2
	CLR.L	ModOffset
	CLR.L	ModPos
flaloop	CMP.L	A3,A2
	BHS	flaskip
	MOVE.B	(A2),D0
	EXT.W	D0
	MOVE.B	(A1),D1
	EXT.W	D1
	ADD.W	D1,D0
	ASR.W	#1,D0
	MOVE.B	D0,(A2)+
	BSR	UpdateMod
	BRA	flaloop
flaskip	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	JSR	RestorePtrCol
	TST.B	HalfClipFlag
	BEQ	DisplaySample
	MOVE.W	SampleVol,-(SP)
	MOVE.W	#200,SampleVol
	BSR	DoChangeVol
	MOVE.W	(SP)+,SampleVol
	BRA	DisplaySample

Filter2	MOVE.W	#1,DispOrRedraw
Filter	CLR.B	RawKeyCode
	LEA	FilteringText,A0
	BSR	ShowStatusText
	MOVE.L	#1,FlangePos
	MOVE.B	ModSpeed(PC),-(SP)
	MOVE.B	HalfClipFlag,-(SP)
	CLR.B	ModSpeed
	CLR.B	HalfClipFlag
	BSR	DoMix
	MOVE.B	(SP)+,HalfClipFlag
	MOVE.B	(SP)+,ModSpeed
	BRA	ShowAllRight

FilteringText	dc.b 'filtering',0

Boost	BSR.S	Boost3
	BRA	DisplaySample
Boost2	BSR.S	Boost3
	BRA	RedrawSample
Boost3	CLR.B	RawKeyCode
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	LEA	BoostingText,A0
	BSR	ShowStatusText
	MOVEQ	#0,D3
	MOVE.W	SampleInfo,D3
	BEQ	booend
	ADD.L	D3,D3
	SUBQ.L	#1,D3
	MOVE.L	si_pointer,D0
	BEQ	booend
	MOVE.L	D0,A1
	MOVE.L	MarkStartOfs(PC),D0
	BMI.S	booskp1
	MOVE.L	MarkEndOfs(PC),D1
	SUB.L	D0,D1
	BEQ.S	booskp1
	MOVE.L	D1,D3
	MOVE.L	SamStart(PC),A1
	ADD.L	D0,A1
booskp1	MOVEQ	#0,D0
booloop	MOVE.B	(A1),D1
	EXT.W	D1
	MOVE.W	D1,D2
	SUB.W	D0,D1
	MOVE.W	D2,D0
	TST.W	D1
	BMI	booneg
	ASR.W	#2,D1
	ADD.W	D1,D2
	BRA	booskip
booneg	NEG.W	D1
	ASR.W	#2,D1
	SUB.W	D1,D2
booskip	CMP.W	#127,D2
	BLE	booskp2
	MOVEQ	#127,D2
booskp2	CMP.W	#-128,D2
	BGE	booskp3
	MOVEQ	#-128,D2
booskp3	MOVE.B	D2,(A1)+
	DBRA	D3,booloop
	MOVE.L	si_pointer,A1
	CLR.W	(A1)
booend	BSR	ShowAllRight
	JMP	RestorePtrCol
	
BoostingText	dc.b 'boosting',0,0

XFade	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D2
	MOVE.W	SampleInfo,D2 	; 22(A0)
	JEQ	ErrorRestoreCol
	ADD.L	D2,D2
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A1
	MOVE.L	D0,A2
	ADD.L	D2,A2
xfaloop	MOVE.B	(A1),D0
	EXT.W	D0
	MOVE.B	-(A2),D1
	EXT.W	D1
	ADD.W	D1,D0
	TST.B	HalfClipFlag
	BEQ	xfahalf
	CMP.W	#127,D0
	BLE	xfanbig
	MOVEQ	#127,D0
xfanbig	CMP.W	#-128,D0
	BGE	xfaokok
	MOVEQ	#-128,D0
	BRA	xfaokok
xfahalf	ASR.W	#1,D0
xfaokok	MOVE.B	D0,(A1)+
	MOVE.B	D0,(A2)
	CMP.L	A2,A1
	BLO.S	xfaloop
	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	JSR	RestorePtrCol
	BRA	DisplaySample

Backwards
	JSR	WaitForButtonUp
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D2
	MOVE.W	22(A5),D2
	JEQ	ErrorRestoreCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A1
	MOVE.L	D0,A2
	ADD.L	D2,D2
	ADD.L	D2,A2
	MOVE.L	MarkStartOfs(PC),D0
	BMI.S	bacloop
	MOVE.L	MarkEndOfs(PC),D1
	SUB.L	D0,D1
	BEQ.S	bacloop
	MOVE.L	SamStart(PC),A1
	ADD.L	D0,A1
	MOVE.L	A1,A2
	ADD.L	D1,A2
bacloop	MOVE.B	(A1),D0
	MOVE.B	-(A2),(A1)+
	MOVE.B	D0,(A2)
	CMP.L	A2,A1
	BLO.S	bacloop
	MOVE.L	si_pointer,A1
	CLR.W	(A1)
	JSR	RestorePtrCol
	BRA	DisplaySample

UpSample
	JSR	WaitForButtonUp
	LEA	UpSampleText,A0
	JSR	AreYouSure
	RNE
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.W	InsNum,D0
	LSL.W	#2,D0
	LEA	SamplePtrs,A0
	LEA	0(a0,D0.W),A0
	MOVE.L	SAMPLE_LENGTHS(A0),D3
	CMP.L	#2,D3
	JLS	ErrorRestoreCol
	MOVE.L	(A0),D0
	JEQ	ErrorRestoreCol
	MOVE.L	D0,A2
	MOVE.L	D0,A4
	MOVE.L	D3,D4
	LSR.L	#1,D3
	BCLR	#0,D3
	MOVE.L	D3,D0
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	TST.L	D0
	BEQ	upserro
	MOVE.L	D0,A3
	MOVE.L	D0,D2
	MOVE.L	D3,D5
.loop	MOVE.B	(A2)+,(A3)+
	ADDQ.L	#1,A2
	subq.l	#1,d3
	bge.s	.loop
	MOVE.L	A4,A1
	MOVE.L	D4,D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	MOVE.W	InsNum,D0
	LSL.W	#2,D0
	LEA	SamplePtrs,A0
	LEA	0(a0,D0.W),A0
	MOVE.L	D2,(A0)
	MOVE.L	D5,SAMPLE_LENGTHS(A0)
	MOVE.L	D2,A0
	CLR.W	(A0)
	MOVE.W	22(A5),D0
	LSR.W	#1,D0
	MOVE.W	D0,22(A5)
	MOVE.W	26(A5),D0
	LSR.W	#1,D0
	MOVE.W	D0,26(A5)
	MOVE.W	28(A5),D0
	LSR.W	#1,D0
	BNE	upsskip2
	MOVEQ	#1,D0
upsskip2
	MOVE.W	D0,28(A5)
	BSR	ShowSampleInfo
	JSR	WaitForButtonUp
	JSR	RestorePtrCol
	BRA	RedrawSample

upserro	JSR	RestorePtrCol
	BRA	OutOfMemErr

DownSample
	JSR	WaitForButtonUp
	TST.W	InsNum
	BEQ	NotSampleNull
	LEA	DownSampleText,A0
	JSR	AreYouSure
	RNE
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	LSL.L	#1,D0
	CMP.L	#$FFFE,D0		; 128k
	JHI	ErrorRestoreCol
	LSL.L	#1,D0
	CMP.L	#$FFFE,D0		; 128k
	BLS	dnsskip
	MOVE.L	#$FFFE,D0		; 128k
dnsskip	MOVE.L	D0,BufMemSize
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,BufMemPtr
	BEQ	SamMemError
	MOVE.L	si_pointer,A1
	MOVE.L	D0,A2
	MOVE.L	BufMemSize,D3
	LSR.L	#1,D3
	SUBQ.L	#1,D3
dnsloop	MOVE.B	(A1)+,D0
	MOVE.B	D0,(A2)+
	MOVE.B	D0,(A2)+
	DBRA	D3,dnsloop
	BSR	FreeSample
	LEA	SamplePtrs,A0
	MOVE.W	InsNum,D0
	LSL.W	#2,D0
	MOVE.L	BufMemPtr,0(a0,D0.W)
	MOVE.L	BufMemSize,SAMPLE_LENGTHS(A0,D0.W)
	moveq	#0,d0
	MOVE.W	22(A5),D0
	LSL.L	#1,D0
	CMP.L	#$7FFF,D0	; OBZ!  128k samples?
	BLS	dnsok1
	MOVE.L	#$7FFF,D0	; 128k/2
dnsok1	MOVE.W	D0,22(A5)
	moveq	#0,d0
	MOVE.W	26(A5),D0
	LSL.L	#1,D0
	CMP.L	#$7FFF,D0	; 128k/2
	BLS	dnsok2
	MOVE.L	#$7FFF,D0
dnsok2	MOVE.W	D0,26(A5)
	moveq	#0,d0
	MOVE.W	28(A5),D0
	CMP.L	#1,D0
	BEQ	dnsok3
	LSL.L	#1,D0
	CMP.L	#$7FFF,D0	; 128k/2
	BLS	dnsok3
	MOVE.L	#$7FFF,D0	; 128k/2
dnsok3	MOVE.W	D0,28(A5)
	BSR	ShowSampleInfo
	JSR	WaitForButtonUp
	JSR	RestorePtrCol
	BRA	RedrawSample


InvertSample
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	bsr	Invert_8
	JSR	RestorePtrCol
	BRA	DisplaySample

NormalDCSample
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	bsr	NormalizeDC_8
	JSR	RestorePtrCol
	BRA	DisplaySample

NormalizeSample
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	bsr	Normalize_8
	JSR	RestorePtrCol
	BRA	DisplaySample

MaximizeSample
	BSR	TurnOffVoices
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	si_pointer,D0
	JEQ	ErrorRestoreCol
	MOVEQ	#0,D0
	MOVE.W	SampleInfo,D0
	JEQ	ErrorRestoreCol
	bsr	Maximize_8
	JSR	RestorePtrCol
	BRA	DisplaySample

; List of Effects:
;
; FILTERS
;
; o Lowpass1p_8     (saminfo,range,fvalue)
; - Lowpass2p_8     (saminfo,range,fvalue)
; o Highpass1p_8    (saminfo,range,fvalue)
; - Highpass2p_8    (saminfo,range,fvalue)
; * Bandpass2p_8    (saminfo,range,fvalue,Q)
; - Notch2p_8       (saminfo,range,fvalue,Q)
; - Allpass1p_8     (saminfo,range,fvalue)
; - Allpass2p_8     (saminfo,range,fvalue,Q)
; o AllpassLP_8     (saminfo,range,looptime,feedback)
; o CombLP_8        (saminfo,range,looptime,feedback)
; * ShelvingLow_8   (saminfo,range,fvalue,gain)
; * ShelvingHigh_8  (saminfo,range,fvalue,gain)
; - ParametricEQ_8  (saminfo,range,fvalue,Q,gain)
;
; DELAY/MODULATION
;
; o Delay 8          (saminfo,range,delay,feedback,mix)
; o MultiTapDelay_8  (saminfo,range,multi-struct(del,lvl),mix)
; * SingleChorus_8   (saminfo,range,delay,rate,depth,ampmod,mix)
; - MultiChorus_8    (saminfo,range,chorus-struct,mix)
; - SplitChorus_8    (saminfo,range,chorus-struct,mix)
; - Flanger_8        (saminfo,range,mode,delay,rate,depth,feedback,mix)
; - Phaser_8         (saminfo,range,mode,delay,rate,depth,feedback,mix)
; - RotarySpeaker_8  (saminfo,range,chorus-struct,mix)
; - Vibrato_8        (saminfo,range,triglevel,rise,depth,rate,mix)
; - Tremolo_8        (saminfo,range,triglevel,rise,depth,rate)
;
; REVERB/EARLY REFLECTIONS
;
; - Reverb_8            (saminfo,range,reverb-struct,mix)
; - EarlyReflections_8  (saminfo,range,multi-struct(delay,level),mix)
;
; NONLINEAR/WAVESHAPING
;
; - Exciter_8      (saminfo,range,freq,resonance,drive,odd/even,mix)
; - Enhancer_8     ()
; o WaveShaping_8  (saminfo,range,waveform,level)
; - Overdrive_8    ()
; - Distortion_8   ()
; * SoftenPeaks_8  (saminfo,range,triglevel,mode)
;
; AMPLITUDE/OFFSET
;
; o VolumeChange_8   (saminfo,range,level)
; - VolumeRamp_8     (saminfo,range,from_level,to_level)
; - FadeIn_8         (saminfo,range,position)
; - FadeOut_8        (saminfo,range,position)
; o Normalize_8      (saminfo,range)
; o NormalizeDC_8    (saminfo,range)
; * Invert_8         (saminfo,range)
; - Panning_8        ()
; - CompanderGate_8  ()
;
; PITCH
;
; - PitchShift_8      ()
; - Resample_8        (saminfo,range,from_rate,to_rate)
; - CalculateChord_8  ()
;
; MISC.
;
; * Backwards_8      (saminfo,range)
; - RingModulator_8  (input1,intput2,output)
; - AmplitudeMod_8   (carrier,modulator,output)
; - Vocoder_8        (carrier,modulator,output,fftlength)
;
;  (Reverbtype: Room/Hall/Plate/Chamber/Gated/Reverse/Spring)

RANGE_DISPLAY = 1
RANGE_RANGE = 2

; ======================================================================
; This function converts from signed word (frequency) to an appropriate
; value to be used in all filter-functions hereunder
;
;		 fvalue can be calculated by:
;
;		 b = 2.0 - cos(frequency_in_Hz / samplerate * 2.0 * Pi);
;		 fvalue = 16384 * (b - sqrt(b * b - 1.0));
;
; Input parameters: frequency in d0, samplerate in d1. fvalue is returned
;                   in d0. If an error occured while computing, d1 is set
;                   to 0. -1 otherwise.
; =======================================================================

two:	dc.l	0
one:	dc.l	0
twopi:	dc.l	0
freq:	dc.l	0
samrate:dc.l	0
b:	dc.l	0

DoConvFrequency:
	move.l	d0,freq
	move.l	d1,samrate

	move.l	TransBase,d0
	beq.w	matherror

	move.l	FFPBase,d0
	beq.w	matherror

	bsr.w	InitFFP			;initialise variables and stuff
	bsr.w	CalcB			;b=2.0-cos(freq/samrate*2*pi)
	bsr.w	CalcFvalue		;fvalue=16384*(b-sqrt(b*b-1.0))

	moveq	#-1,d1
	rts

InitFFP:move.l	FFPBase,d0
	move.l	d0,a6
	move.l	#2,d0
	jsr	-36(a6)		;LVOFlt
	move.l	d0,two

	move.l	#1,d0
	jsr	-36(a6)		;LVOFlt
	move.l	d0,one

	move.l	#314159265,d0
	jsr	-36(a6)		;LVOFlt

	move.l	d0,-(sp)
	move.l	#100000000,d0
	jsr	-36(a6)		;LVOFlt
	move.l	d0,d1
	move.l	(sp)+,d0
	jsr	-84(a6)		;LVODiv

	move.l	two,d1
	jsr	-78(a6)		;LVOMul
	move.l	d0,twopi	;2*Pi

	move.l	freq,d0
	jsr	-36(a6)		;LVOFlt
	move.l	d0,freq

	move.l	samrate,d0
	jsr	-36(a6)		;LVOFlt
	move.l	d0,samrate
	rts

CalcB:	move.l	FFPBase,a6
	move.l	samrate,d0
	move.l	twopi,d1
	jsr	-78(a6)		;LVOMul
	move.l	d0,d1
	move.l	freq,d0
	jsr	-84(a6)		;LVODiv

	move.l	TransBase,a6
	jsr	-42(a6)		;LVOSPCos

	move.l	d0,d1
	move.l	two,d0

	move.l	FFPBase,a6
	jsr	-72(a6)		;LVOSub
	move.l	d0,b
	rts

; fvalue = 16384 * (b - sqrt(b * b - 1.0));

CalcFvalue:
	move.l	FFPBase,a6
	move.l	b,d0
	move.l	b,d1
	jsr	-78(a6)		;LVOMul
	move.l	one,d1
	jsr	-72(a6)		;LVOSub

	move.l	TransBase,a6
	jsr	-96(a6)		;LVOSPSqrt

	move.l	FFPBase,a6
	move.l	d0,d1
	move.l	b,d0
	jsr	-72(a6)		;LVOSub	(b-sqrt(b*b-1.0))

	move.l	d0,-(sp)
	move.l	#16384,d0
	jsr	-36(a6)		;LVOFlt
	move.l	(sp)+,d1

	jsr	-78(a6)		;LVOMul
	jsr	-30(a6)		;LVOFix
	rts

matherror:
	moveq	#0,d1
	rts

********************************************************
*
*  SYNOPSIS
*	GetSamRange_8(saminfo,range)
*	              a0      d0
*
*  NOTE
*	This is not the proper version of this function
*
********************************************************

GetSamRange_8
	moveq	#RANGE_DISPLAY,d0
	move.l	MarkStartOfs(pc),d1
	bmi.s	.cnt
	cmp.l	MarkEndOfs(pc),d1
	beq.s	.cnt
	moveq	#RANGE_RANGE,d0
.cnt	LEA	SamplePtrs,A0
	MOVE.W	InsNum,D1
	LSL.W	#2,D1
	move.l	(a0,d1.w),a1		;position
	MOVE.L	SAMPLE_LENGTHS(A0,d1.w),d1		;length
	cmp.w	#RANGE_DISPLAY,d0
	beq.s	.displa
	cmp.w	#RANGE_RANGE,d0
	beq.s	.range
	rts
.displa	add.l	SamOffset,a1
	move.l	SamDisplay,d1
	rts
.range	move.l	MarkStartOfs,d0
	add.l	d0,a1
	move.l	MarkEndOfs,d1
	sub.l	d0,d1
	rts

**********************************************************************
*
*  NAME
*	Lowpass1p_8 -- lowpass filter sample using a one pole filter
*
*  SYNOPSIS
*	Lowpass1p_8(saminfo,range,fvalue);
*	            a0      d0    d1
*
*	VOID Lowpass1p_8(struct SamInfo *,UWORD,WORD);
*
*  FUNCTION
*	This function processes the sample with a one-pole IIR lowpass
*	filter,	which provides 6 dB/octave attenuation above the given
*	cutoff frequency.
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	fvalue - a value controlling cutoff frequency. It is a fixed
*		 point number where 16384 (0x4000) corresponds to 1.0.
*
*		 fvalue can be calculated by:
*
*		 b = 2.0 - cos(frequency_in_Hz / samplerate * 2.0 * Pi);
*		 fvalue = 16384 * (b - sqrt(b * b - 1.0));
*
**********************************************************************

Lowpass1p_8
	push	d2-d5
	move.l	d1,d2
	bsr	GetSamRange_8
	move.l	#16384,d3
	move.l	d3,d5
	sub.w	d2,d3
	moveq	#0,d4
	moveq	#14,d2
.loop	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	sub.w	d0,d4		; calc. out-in
	muls	d3,d4		; multiply by 1-freq
	add.l	d5,d4		; add 0.5
	asr.l	d2,d4		; shift down
	add.w	d4,d0		; add original input
	move.w	d0,d4		; save for next
	move.b	d0,(a1)+	; store output sample
	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d5
	rts


**********************************************************************
*
*  NAME
*	Highpass1p_8 -- highpass filter sample using a one pole filter
*
*  SYNOPSIS
*	Highpass1p_8(saminfo,range,fvalue);
*	             a0      d0    d1
*
*	VOID Highpass1p_8(struct SamInfo *,UWORD,WORD);
*
*  FUNCTION
*	This function processes the sample with a one pole IIR highpass
*	filter, which provides 6 dB/octave attenuation below the given
*	cutoff frequency.
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	fvalue - a value controlling cutoff frequency. It is a fixed
*		 point number where 16384 (0x4000) corresponds to 1.0.
*
**********************************************************************

Highpass1p_8
	push	d2-d7
	move.l	d1,d3
	bsr	GetSamRange_8
	move.w	#16384,d2
	sub.w	d3,d2
	move.w	#0,d4
	moveq	#14,d5
	moveq	#127,d6
	moveq	#-128,d7
.loop	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	move.w	d0,d3		; save input for delta
	add.w	d4,d0		; add delta to input
	muls	d2,d0		; multiply by 1-freq
	asr.l	d5,d0		; shift down
	move.w	d0,d4		; delta = out ...
	sub.w	d3,d4		; ...minus in
	cmp.w	d6,d0		; check for clipping > 127
	ble.s	.skip
	move.w	d6,d0
	bra.s	.skip2
.skip	cmp.w	d7,d0		; check for clipping < -128
	bge.s	.skip2
	move.w	d7,d0
.skip2	move.b	d0,(a1)+	; store output sample
	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7
	rts


**********************************************************************
*
*  NAME
*	Bandpass2p_8 -- bandpass-filter sample using a two pole filter
*
*  SYNOPSIS
*	Bandpass2p_8(saminfo,range,fvalue,Q);
*	             a0      d0    d1     d2
*
*	VOID Bandpass2p_8(struct SamInfo *,UWORD,WORD,WORD);
*
*  FUNCTION
*	This function processes the sample with a two pole IIR bandpass
*	filter (resonator). The resonance frequency and Q of the filter
*	can be controlled.
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	fvalue - a value controlling resonace frequency. It is a fixed
*		 point number where 16384 (0x4000) corresponds to 1.0
*	Q - controls the Q or quality-factor of the resonant peak. The
*	    relationship to filter bandwidth is:
*
*	    bandwidth = resonance frequency / Q
*
*  BUGS
*	Zeros at -1 and 1 is not implemented yet.
*	Parameters are now really 2*r*cos(w) and -r*r. (calc yourself)
*
**********************************************************************

; out = (1-r)(in + r*in2) + 2*r*fvalue*out1 - r*r*out2

Bandpass2p_8
	push	d2-d7/a2-a4
	move.w	d1,d3
	bsr	GetSamRange_8
	moveq	#13,d0		; number of bits to scale down
	move.w	d2,a2		; r
	move.w	#16384,a3
	sub.w	d2,a3		; 1 - r
	muls	d2,d3		; r*fvalue
	asr.l	d0,d3		; 2*r*fvalue
	muls	d2,d2		; r*r
	addq.w	#1,d0
	asr.l	d0,d2
	sub.l	a0,a0
	sub.l	a4,a4		; out1 = 0
	moveq	#0,d7		; out2 = 0
.loop	move.w	a4,d5		; get out1
	muls	d3,d5		; multiply by 2*r*cos(phase)
	muls	d2,d7		; multiply by r*r
	sub.l	d7,d5		; subtract first part
	move.w	a0,d7		; get in2
	move.w	a2,d6
	muls	d6,d7		; r*in2
	asr.l	d0,d7		; shift down
	move.b	(a1),d4		; get input sample
	ext.w	d4		; extend to word
	move.w	d4,a0		; in1=in
	add.w	d4,d7		; add input to r*in2
	move.w	a3,d6
	muls	d6,d7		; multiply by 1-r
	add.w	d7,d5		; add inputmix to outputmix
	asr.l	d0,d7		; shift down
	move.w	a4,d7		; out2 = out1
	move.w	d5,a4		; out1 = out
	cmp.w	#127,d5		; check for clipping > 127
	ble.s	.skip
	moveq	#127,d5
	bra.s	.skip2
.skip	cmp.w	#-128,d5	; check for clipping < -128
	bge.s	.skip2
	moveq	#-128,d5
.skip2	move.b	d5,(a1)+	; store output sample
	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7/a2-a4
	rts


ParametricEQ_8
	rts


;---------------------------------------------
; ShelvingLow(saminfo, range, frequency, gain)
;               a0      d0       d1       d2
;
; frequency: 0 to 16384 (0.00-1.00)
; gain.....: -16384 to 16384 (-100% to +100%)
;
;---------------------------------------------

; maa putte inn highpass del her en eller annen gang...
; ellers blir det store stygge DC problemer!
; kan sikkert fikses med +0.5 et eller annet sted og.

ShelvingLow_8
	push	d2-d7
	move.w	d2,d7
	move.w	d1,d2
	bsr	GetSamRange_8
	move.w	#16384,d3
	sub.w	d2,d3
	moveq	#0,d4
	moveq	#14,d5
.loop	move.b	(a1),d0
	ext.w	d0
	move.w	d0,d6
	muls	d2,d0
	muls	d3,d4
	add.l	d4,d0
	asr.l	d5,d0
	move.w	d0,d4
	muls	d7,d0
	asr.l	d5,d0
	add.w	d6,d0
	cmp.w	#127,d0
	ble.s	.skip1
	moveq	#127,d0
	bra.s	.skip2
.skip1	cmp.w	#-128,d0
	bge.s	.skip2
	moveq	#-128,d0
.skip2	move.b	d0,(a1)+
	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7
	rts


;----------------------------------------------
; ShelvingHigh(saminfo, range, frequency, gain)
;                a0      d0       d1       d2
;
; frequency: 0 to 16384 (0.00-1.00)
; gain.....: -16384 to 16384 (-100% to +100%)
;
;----------------------------------------------

ShelvingHigh_8
	push	d2-d7
	move.w	d1,d3
	move.w	d2,d7
	bsr	GetSamRange_8
	move.w	#16384,d2
	sub.w	d3,d2
	moveq	#0,d4
	moveq	#14,d5
.loop	move.b	(a1),d0
	ext.w	d0
	move.w	d0,d6
	add.w	d4,d0
	muls	d2,d0
	asr.l	d5,d0
	move.w	d0,d3
	sub.w	d6,d3
	move.w	d3,d4
	muls	d7,d0
	asr.l	d5,d0
	add.w	d6,d0
	cmp.w	#127,d0
	ble.s	.skip1
	moveq	#127,d0
	bra.s	.skip2
.skip1	cmp.w	#-128,d0
	bge.s	.skip2
	moveq	#-128,d0
.skip2	move.b	d0,(a1)+
	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7
	rts


**********************************************************************
*
*  NAME
*	CombLP_8 -- looping comb filter
*
*  SYNOPSIS
*	CombLP_8(saminfo,range,looptime,feedback);
*	         a0      d0    d1       d2
*
*	VOID CombLP_8(struct SamInfo *,UWORD,UWORD,WORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	looptime - 0-4096 samples
*	feedback - feedback level (+/-)
*
**********************************************************************

CombLP_8
	push	d2-d7/a2
	move.w	d1,d3
	move.w	d2,d7
	bsr	GetSamRange_8
	lea	FilterBuffer,a0
	move.l	a0,a2
	add.w	d3,d3
	move.w	d3,d2
.clear	clr.b	(a0)+
	subq.w	#1,d2
	bne.s	.clear
	move.l	a2,a0
	moveq	#0,d2
	moveq	#14,d5
.loop	move.w	(a0),d0		; read from buffer
	cmp.w	#127,d0		; check for clipping > 127
	ble.s	.skip1
	moveq	#127,d0
	bra.s	.skip2
.skip1	cmp.w	#-128,d0	; check for clipping < -128
	bge.s	.skip2
	moveq	#-128,d0
.skip2	move.b	d0,(a1)+	; store output sample
	move.b	(a1),d4		; get input sample
	ext.w	d4		; extend to word
	muls	d7,d0		; multiply output by feedback
	asr.l	d5,d0
	add.w	d4,d0		; add sample
	move.w	d0,(a0)+	; store in buffer
	addq.w	#2,d2
	cmp.w	d3,d2
	blo.s	.skip3
	moveq	#0,d2
	move.l	a2,a0
.skip3	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7/a2
	rts


**********************************************************************
*
*  NAME
*	AllpassLP_8 -- looping allpass filter
*
*  SYNOPSIS
*	AllpassLP_8(saminfo,range,looptime,feedback);
*	         a0      d0    d1       d2
*
*	VOID AllpassLP_8(struct SamInfo *,UWORD,UWORD,WORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	looptime - 0-4096 samples
*	feedback - feedback level (+/-)
*
**********************************************************************

AllpassLP_8
	push	d2-d7/a2
	move.w	d1,d3
	move.w	d2,d7
	bsr	GetSamRange_8
	lea	FilterBuffer,a0
	move.l	a0,a2
	add.w	d3,d3
	move.w	d3,d2
.clear	clr.b	(a0)+
	subq.w	#1,d2
	bne.s	.clear
	move.l	a2,a0
	moveq	#0,d2
	moveq	#14,d5
.loop	move.w	(a0),d0		; get sample from buffer
	move.w	d0,d4
	muls	d7,d4
	asr.l	d5,d4
	move.b	(a1),d6		; get input sample
	ext.w	d6		; extend to word
	add.w	d6,d4
	move.w	d4,(a0)+
	muls	d7,d4
	asr.l	d5,d4
	sub.w	d4,d0
	cmp.w	#127,d0		; check for clipping > 127
	ble.s	.skip1
	moveq	#127,d0
	bra.s	.skip2
.skip1	cmp.w	#-128,d0	; check for clipping < -128
	bge.s	.skip2
	moveq	#-128,d0
.skip2	move.b	d0,(a1)+	; store output sample
	addq.w	#2,d2
	cmp.w	d3,d2
	blo.s	.skip3
	moveq	#0,d2
	move.l	a2,a0
.skip3	subq.l	#1,d1
	bne.s	.loop
	pop	d2-d7/a2
	rts


**********************************************************************
*
*  NAME
*	Delay_8 -- single delay-line with feedback
*
*  SYNOPSIS
*	Delay_8(saminfo,range,delay,feedback,output);
*	        a0      d0    d1    d2       d3
*
*	VOID Delay_8(struct SamInfo *,UWORD,ULONG,WORD,WORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	delay - number of samples to delay signal (must be > 0)
*	feedback - feedback level (+/-)
*	output - output level (+/-)
*
**********************************************************************

Delay_8	push	d2-d7/a2-a6
	move.l	d1,d6		; save delaytime
	bsr	GetSamRange_8
	move.l	d1,d4		; save samplelength
	move.l	a1,d5
	add.l	d6,d6		; find delay in number of words
	move.l	d6,d0
	move.l	#MEMF_CLEAR,d1	; clear after allocing
	move.l	4.w,a6
	jsr	LVOAllocMem(a6)	; allocate delay buffer
	tst.l	d0
	beq.s	.error		; oops, no buffer !
	move.l	d0,a0		; current buffer ptr
	move.l	d0,a2		; start of buffer
	move.l	d0,a3
	add.l	d6,a3		; end of buffer
	move.l	d4,d1
	move.l	d5,a1
	moveq	#14,d7		; bits to shift (scale down)
.loop	move.w	(a0),d4		; get sample from buffer
	move.w	d4,d5
	muls	d2,d4		; d4 * feedback level
	muls	d3,d5		; d5 * mix level
	asr.l	d7,d4		; shift back to normal
	asr.l	d7,d5
	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	add.w	d0,d4		; mix input with feedback
	add.w	d0,d5		; mix input with output
	move.w	d4,(a0)+	; store feedback into buffer
	cmp.w	#127,d5		; check for clipping > 127
	ble.s	.skip
	moveq	#127,d5
	bra.s	.skip2
.skip	cmp.w	#-128,d5	; check for clipping < -128
	bge.s	.skip2
	moveq	#-128,d5
.skip2	move.b	d5,(a1)+	; store output sample
	cmp.l	a3,a0		; are we at end of buffer?
	blo.s	.skip3		; no, skip
	move.l	a2,a0		; yes, reset to beginning
.skip3	subq.l	#1,d1		; one less sample to process
	bne.s	.loop		; do it again if more samples
	move.l	a2,a1		; free buffer memory
	move.l	d6,d0
	jsr	LVOFreeMem(a6)
	pop	d2-d7/a2-a6
	rts
.error	bsr	FlashScreen
	pop	d2-d7/a2-a6
	rts


**********************************************************************
*
*  NAME
*	MultiTapDelay_8 -- single delay-line with multiple taps
*
*  SYNOPSIS
*	MultiTapDelay_8(saminfo,range,delays,output);
*	                a0      d0    a1     d1
*
*	VOID MultiTapDelay_8(struct SamInfo *,UWORD,WORD *,WORD,WORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	delays - address of multitap data area
*	feedback - feedback level (+/-)
*	output - output level (+/-)
*
**********************************************************************

MultiTapDelay_8
	push	d2-d7/a2-a3
	move.l	a1,a3		; save delay-struct ptr
	move.w	(a3)+,d4
	subq.w	#1,d4
	move.w	d1,d6		; save output level
	bsr	GetSamRange_8
	lea	FilterBuffer,a0	; get the filterbuffer
	move.l	a0,a2
	move.w	#4095,d0
.clear	clr.w	(a2)+		; clear the buffer
	dbra	d0,.clear
	moveq	#0,d3		; buffer index
	moveq	#14,d7		; bits to shift (scale down)
.loop	move.l	a3,a2		; get beginning of delay-struct
	move.w	d4,d2		; delay count
	moveq	#0,d5		; zero delay sum
.mloop	move.w	d3,d0		; get buffer position
	move.w	(a2)+,d6	; get delay time
	sub.w	d6,d0		; subtract twice (words)
	sub.w	d6,d0
	bpl.s	.skip		; skip if positive offset
	add.w	#4096*2,d0	; wrap around
.skip	move.w	(a0,d0.w),d0	; read sample from buffer
	muls	(a2)+,d0	; multiply by delay amplitude
	add.l	d0,d5		; sum += delay
	dbra	d2,.mloop	; loop for each delay tap
	asr.l	d7,d5		; shift back down (sum >> 14)
	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	move.w	d0,(a0,d3.w)	; store back into buffer
	add.w	d0,d5		; add delay to input sample
	addq.w	#2,d3		; update buffer index
	and.w	#8192-2,d3	; at end of buffer
	cmp.w	#127,d5		; check for clipping > 127
	ble.s	.hskip
	moveq	#127,d5
	bra.s	.lskip
.hskip	cmp.w	#-128,d5	; check for clipping < -128
	bge.s	.lskip
	moveq	#-128,d5
.lskip	move.b	d5,(a1)+	; store output sample
	subq.l	#1,d1		; one less sample to process
	bne.s	.loop		; do it again if more samples
	pop	d2-d7/a2-a3
	rts


**********************************************************************
*
*  NAME
*	WaveShape_8 -- feeds sample through a waveshaping waveform
*
*  SYNOPSIS
*	WaveShape_8(saminfo,range);
*	            a0      d0
*
*	VOID WaveShape_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	waveform - waveform to use as basis for waveshaping
*	level - level of sample before the waveshaping process
*
**********************************************************************

WaveShape_8
	push	d2-d3
	move.w	d1,d3
	bsr	GetSamRange_8
	lsl.w	#2,d3
	;lea	WavePtrs,a0			; OBZ!!!
	move.l	(a0,d3.w),d0
	beq.s	.flash
	move.l	d0,a0
	move.w	(a0)+,d0
	cmp.w	#256,d0
	bne.s	.flash
	add.w	#128,a0		; offset to middle of waveform
	moveq	#14,d3
.loop	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	muls	d2,d0		; multiply to level
	asr.l	d3,d0		; shift down
	move.b	(a0,d0.w),(a1)+	; store output sample from waveform
	subq.l	#1,d1		; one less sample to process
	bne.s	.loop		; do it again if more samples
	pop	d2-d3
	rts
.flash	bsr	FlashScreen
	pop	d2-d3
	rts


**********************************************************************
*
*  NAME
*	VolumeChange_8 -- changes volume of the sample
*
*  SYNOPSIS
*	VolumeChange_8(saminfo,range);
*	               a0      d0
*
*	VOID VolumeChange_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*	gain - signed fixed number (0x0100 = 0 dB)
*
**********************************************************************

VolumeChange_8
	push	d2-d6
	move.w	d1,d2
	bsr	GetSamRange_8
	moveq	#127,d3
	moveq	#-128,d4
	moveq	#8,d5
	move.l	#128,d6
.loop	move.b	(a1),d0		; get input sample
	ext.w	d0		; extend to word
	muls	d2,d0		; multiply by volume
	add.l	d6,d0
	asr.l	d5,d0		; shift down
	cmp.w	d3,d0		; check for clipping > 127
	ble.s	.skip
	move.w	d3,d0
	bra.s	.skip2
.skip	cmp.w	d4,d0		; check for clipping < -128
	bge.s	.skip2
	move.w	d4,d0
.skip2	move.b	d0,(a1)+	; store output sample
	subq.l	#1,d1		; one less sample to process
	bne.s	.loop		; do it again if more samples
	pop	d2-d6
	rts


**********************************************************************
*
*  NAME
*	Normalize_8 -- normalizes amplitude to maximum (-128 to 127)
*
*  SYNOPSIS
*	Normalize_8(saminfo,range);
*	            a0      d0
*
*	VOID Normalize_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*
**********************************************************************

Normalize_8
	push	d2-d4
	bsr	GetSamRange_8
	move.l	a1,a0
	move.l	d1,d0
	moveq	#0,d2
.loop	move.b	(a0)+,d3
	ext.w	d3
	bpl.s	.skip
	neg.w	d3
.skip	cmp.w	d2,d3
	blo.s	.skip2
	move.w	d3,d2
.skip2	subq.l	#1,d1
	bne.s	.loop
	tst.w	d2
	beq.s	.eskip
	move.l	#16384,d3
	divu	d2,d3
	moveq	#7,d2
	moveq	#64,d4
.loop2	move.b	(a1),d1
	ext.w	d1
	muls	d3,d1
	add.l	d4,d1
	asr.l	d2,d1
	cmp.w	#127,d1
	ble.s	.skip3
	moveq	#127,d1
.skip3	move.b	d1,(a1)+
	subq.l	#1,d0
	bne.s	.loop2
.eskip	pop	d2-d4
	rts


**********************************************************************
*
*  NAME
*	NormalizeDC_8 -- removes DC offset from a sample
*
*  SYNOPSIS
*	NormalizeDC_8(saminfo,range);
*	              a0      d0
*
*	VOID NormalizeDC_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*
*  NOTE
*	max 32 meg samples :)
*
**********************************************************************

NormalizeDC_8
	push	d2-d3
	bsr	GetSamRange_8
	move.l	a1,a0
	move.l	d1,d3
	moveq	#0,d2
.loop	move.b	(a0)+,d0
	ext.w	d0
	ext.l	d0
	add.l	d0,d2
	subq.l	#1,d1
	bne.s	.loop
	move.l	d2,d0
	move.l	d3,d1
	bsr	DIVS32
.loop2	move.b	(a1),d1		; get input sample
	ext.w	d1		; extend to word
	sub.w	d0,d1		; subtract DC-offset
	cmp.w	#127,d1		; check for clipping > 127
	ble.s	.skip
	moveq	#127,d1
	bra.s	.skip2
.skip	cmp.w	#-128,d1	; check for clipping < -128
	bge.s	.skip2
	moveq	#-128,d1
.skip2	move.b	d1,(a1)+	; store output sample
	subq.l	#1,d3
	bne.s	.loop2
	pop	d2-d3
	rts


**********************************************************************
*
*  NAME
*	Maximize_8 -- expand sample to maximum volume
*
*  SYNOPSIS
*	Maximize_8(saminfo,range);
*	              a0      d0
*
*	VOID Maximize_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*
**********************************************************************

Maximize_8
	push	d2-d3
	bsr	GetSamRange_8
	move.l	a1,a0		; sample address
	move.l	d1,d3		; sample length
	moveq	#-128,d2
	moveq	#127,d4
.loop	move.b	(a0)+,d0
	ext.w	d0
	cmp.w	d0,d2
	bpl.s	.cnt1
	move.w	d0,d2
.cnt1	cmp.w	d0,d4
	bmi.s	.cnt2
	move.w	d0,d4
.cnt2	subq.l	#1,d1
	bne.s	.loop
	move.w	d2,d0
	sub.w	d4,d0		; Height
	beq.s	.end
	move.w	d2,d6
	sub.w	#127,d6
	move.w	d4,d5
	sub.w	#-128,d5
	add.w	d6,d5		; delta
	asr.w	#1,d5
.loop2	move.b	(a1),d1		; get input sample
	ext.w	d1		; extend to word
	sub.w	d5,d1		; subtract
	muls	#255,d1
	divs	d0,d1
	move.b	d1,(a1)+	; store output sample
	subq.l	#1,d3
	bne.s	.loop2
.end	pop	d2-d3
	rts

**********************************************************************
*
*  NAME
*	Backwards_8 -- turns a selected part of the sample backwards
*
*  SYNOPSIS
*	Backwards_8(saminfo,range);
*	            a0      d0
*
*	VOID Backwards_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*
**********************************************************************

Backwards_8
	bsr	GetSamRange_8
	move.l	a1,a0
	add.l	d1,a0
.loop	move.b	(a1),d0
	move.b	-(a0),(a1)+
	move.b	d0,(a0)
	cmp.l	a0,a1
	blo.s	.loop
	rts

**********************************************************************
*
*  NAME
*	Invert_8 -- invert sample (multiply sample values by -1)
*
*  SYNOPSIS
*	Invert_8(saminfo,range);
*	         a0      d0
*
*	VOID Invert_8(struct SamInfo *,UWORD);
*
*  FUNCTION
*
*  INPUTS
*	saminfo - the sample to process
*	range - what part of sample to process
*
*  NOTE
*	Since the samples are signed values (-128 to 127) there
*	are problems with inverting -128, as this would be +128,
*	which does not fit into a single byte.
*
*	This is currently solved by doing an exclusive-or with
*	$ff instead. Note that this is the same as out = (-in)-1,
*	and that the samples will be dc-offset by -1.
*	It is also possible (better?) to clip the +128 to +127.
*
**********************************************************************

Invert_8
	bsr	GetSamRange_8
	moveq	#-1,d0
.loop	eor.b	d0,(a1)+
	subq.l	#1,d1
	bne.s	.loop
	rts

***************************************************

DIVS32	divs	d1,d0
	rts

FlashScreen
	moveq	#-1,d0
.loop	move.w	d0,$dff180
	dbf	d0,.loop
	rts

***************************************************

	cnop	0,4
SamplePos	dc.l	0
SampleVol	dc.w	100
FlangePos	dc.l	0
ModSpeed	dc.b	0
HalfClipFlag	dc.b	0
ModPos		dc.l	0
ModOffset	dc.l	0
BufMemPtr	dc.l	0
BufMemSize	dc.l	0

;---- Save Song ----

SaveSong
	BSR	StopIt
	CLR.B	RawKeyCode
	MOVE.L	SongDataPtr(PC),A0
	LEA	SampleLengthAdd(PC),A1
	MOVEQ	#0,D0
	MOVEQ	#2,D1
sadloop	MOVE.W	0(a1,D1.W),D2
	ADD.W	D2,42(A0,D0.W)
	ADD.W	#30,D0
	ADDQ.W	#2,D1
	CMP.W	#62,D1
	BNE	sadloop

	LEA	sd_pattpos(A0),A0
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	CLR.W	HighPattNum
ssloop	MOVE.B	0(A0,D0.W),D1
	ADDQ.W	#1,D0
	CMP.W	#128,D0
	BHI	DoSaveSong
	MOVE.W	HighPattNum(PC),D2
	CMP.W	D2,D1
	BLS	ssloop
	MOVE.W	D1,HighPattNum
	BRA	ssloop

DoSaveSong
	move.l	PathPtr,a0
	JSR	CopyPath
	MOVE.L	SongDataPtr(PC),A0
	MOVEQ	#19,D0
dssloop	MOVE.B	(A0)+,(A1)+
	DBRA	D0,dssloop
	MOVE.L	#FileName,FileNamePtr
	MOVE.L	SongDataPtr(PC),DiskDataPtr
	MOVE.L	#1084,DiskDataLength
	MOVEQ	#0,D0
	MOVE.W	HighPattNum,D0
	ADDQ.L	#1,D0
	LSL.L	#8,D0
	LSL.L	#2,D0
	ADD.L	D0,DiskDataLength
	btst	#0,DiskBitFlags+3	;PackMode
	BEQ	dssnocr
	LEA	CrunchingText(PC),A0
	BSR	ShowStatusText
	BSR	Cruncher
dssnocr	BSR	DoSaveData
	btst	#0,DiskBitFlags+3	;PackMode
	BEQ	dssnoc2
	LEA	DecrunchingText(PC),A0
	BSR	ShowStatusText
	BSR	Decruncher
dssnoc2	MOVE.L	SongDataPtr(PC),A0
	LEA	SampleLengthAdd(PC),A1
	MOVEQ	#0,D0
	MOVEQ	#2,D1
ssuloop	MOVE.W	0(a1,D1.W),D2
	SUB.W	D2,42(A0,D0.W)
	ADD.W	#30,D0
	ADD.W	#2,D1
	CMP.W	#62,D1
	BNE	ssuloop
	BSR	ShowAllRight
	JMP	SetNormalPtrCol

Cruncher
	JSR	SetNormalPtrCol
	MOVE.L	SongDataPtr(PC),A0
	MOVE.L	A0,A1
	LEA	12(A1),A1
	MOVE.L	A1,SongPlus12Ptr
	MOVE.L	A0,A1
	ADD.L	#70716,A1		; hoeh...
	MOVE.L	A1,SongPlus70kPtr
	MOVE.L	A0,A1
	ADD.L	#70716,A1
	SUB.L	DiskDataLength(PC),A1
	MOVE.L	A1,EndOfSongPtr
	MOVE.L	DiskDataLength(PC),RealSongLength
	MOVE.L	SongDataPtr(PC),A0
	ADD.L	DiskDataLength(PC),A0
	MOVE.L	SongDataPtr(PC),A1
	ADD.L	#70716,A1
	MOVE.L	DiskDataLength(PC),D0
cloop	MOVE.B	-(A0),-(A1)
	SUBQ.L	#1,D0
	BNE	cloop
	BSR	DoCrunch
	SUB.L	SongPlus12Ptr(PC),A2
	MOVE.L	A2,D0
	MOVE.L	D0,CrunchedSongLength
	MOVE.L	D0,D1
	ADD.L	SongPlus12Ptr(PC),D1
	MOVE.L	D1,DontKnowWhat
	MOVE.L	SongDataPtr(PC),A0
	MOVE.L	#'PACK',(A0)
	MOVE.L	CrunchedSongLength,4(A0)
	MOVE.L	RealSongLength(PC),8(A0)
	MOVE.L	SongDataPtr(PC),DiskDataPtr
	MOVE.L	CrunchedSongLength(PC),D0
	ADD.L	#12,D0
	MOVE.L	D0,DiskDataLength
	RTS	
 
	cnop	0,4
EndOfSongPtr		dc.l	0
SongPlus70kPtr		dc.l	0
RealSongLength		dc.l	0
SongPlus12Ptr		dc.l	0
DontKnowWhat		dc.l	0
CrunchedSongLength	dc.l	0

DoCrunch
	MOVE.L	EndOfSongPtr(PC),A0
	MOVE.L	SongPlus70kPtr(PC),A1
	MOVE.L	SongPlus12Ptr(PC),A2
	MOVEQ	#1,D2
	CLR.W	D1
dcloop	BSR	DoCrunch2
	TST.B	D0
	BEQ	dcskip
	ADDQ.W	#1,D1
	CMP.W	#$0108,D1
	BNE	dcskip
	BSR	DoCrunch6
dcskip	CMP.L	A0,A1
	BGT	dcloop
	BSR	DoCrunch6
	BRA	DoCrunch8
 
DoCrunch2
	MOVE.L	A0,A3
	LEA	127(A3),A3
	CMP.L	A1,A3
	BLE	dc2skip
	MOVE.L	A1,A3
dc2skip	MOVEQ	#1,D5
	MOVE.L	A0,A5
	ADDQ.L	#1,A5
dc2_1	MOVE.B	(A0),D3
	MOVE.B	1(A0),D4
	MOVE.W	D3,$DFF1A2
dc2loop	CMP.B	(A5)+,D3
	BNE	dc2skip2
	CMP.B	(A5),D4
	BEQ	DoCrunch3
dc2skip2
	CMP.L	A5,A3
	BGT	dc2loop
	BRA	dc4_3
 
DoCrunch3
	SUBQ.L	#1,A5
	MOVE.L	A0,A4
dc3loop	MOVE.B	(A4)+,D3
	CMP.B	(A5)+,D3
	BNE	dc3skip
	CMP.L	A5,A3
	BGT	dc3loop
dc3skip	MOVE.L	A4,D3
	SUB.L	A0,D3
	SUBQ.L	#1,D3
	CMP.L	D3,D5
	BGE	dc4_2
	MOVE.L	A5,D4
	SUB.L	A0,D4
	SUB.L	D3,D4
	SUBQ.L	#1,D4
	CMP.L	#4,D3
	BLE	DoCrunch4
	MOVEQ	#6,D6
	CMP.L	#$00000101,D3
	BLT	dc3skip2
	MOVE.W	#$0100,D3
dc3skip2
	BRA	dc4_1
 
DoCrunch4
	MOVE.W	D3,D6
	SUBQ.W	#2,D6
	LSL.W	#1,D6
dc4_1	LEA	CrunchData3(PC),A6
	CMP.W	0(A6,D6.W),D4
	BGE	dc4_2
	MOVE.L	D3,D5
	MOVE.L	D4,CrunchData1
	MOVE.B	D6,CrunchData2
dc4_2	CMP.L	A5,A3
	BGT	dc2_1
dc4_3	CMP.L	#1,D5
	BEQ	DoCrunch5
	BSR	DoCrunch6
	MOVE.B	CrunchData2(PC),D6
	MOVE.L	CrunchData1(PC),D3
	MOVE.W	8(A6,D6.W),D0
	BSR	DoCrunch7
	MOVE.W	$0010(A6,D6.W),D0
	BEQ	dc4skip
	MOVE.L	D5,D3
	SUBQ.W	#1,D3
	BSR	DoCrunch7
dc4skip	MOVE.W	$0018(A6,D6.W),D0
	MOVE.W	$0020(A6,D6.W),D3
	BSR	DoCrunch7
	ADDQ.W	#1,$0028(A6,D6.W)
	ADD.L	D5,A0
	CLR.B	D0
	RTS	
 
DoCrunch5
	MOVE.B	(A0)+,D3
	MOVEQ	#8,D0
	BSR	DoCrunch7
	MOVEQ	#1,D0
	RTS	
 
	cnop	0,4
CrunchData1	dc.l	0
CrunchData2	dc.b	0,0
CrunchData3	dc.w	$0100,$0200,$0400,$1000,8,9,10,8
		dc.w	0,0,0,8,2,3,3,3,1,4,5,6,0,0,0,0
CrunchData4	dc.w	0
CrunchData5	dc.w	0

DoCrunch6
	TST.W	D1
	REQ
	MOVE.W	D1,D3
	CLR.W	D1
	CMP.W	#9,D3
	BGE	dc6_2
	ADDQ.W	#1,CrunchData4
	SUBQ.W	#1,D3
	MOVEQ	#5,D0
	BRA	DoCrunch7
 
dc6_2	ADDQ.W	#1,CrunchData5
	SUB.W	#9,D3
	OR.W	#$0700,D3
	MOVEQ	#11,D0
DoCrunch7
	SUBQ.W	#1,D0
dc7loop	LSR.L	#1,D3
	ROXL.L	#1,D2
	BCS	dc8_2
	DBRA	D0,dc7loop
	RTS	
 
DoCrunch8
	CLR.W	D0
dc8_2	MOVE.L	D2,(A2)+
	MOVEQ	#1,D2
	DBRA	D0,dc7loop
	RTS

Decruncher				; SongDecruncher
	MOVE.L	SongDataPtr(PC),A0
	LEA	12(A0),A0
	MOVE.L	EndOfSongPtr(PC),A1
	MOVE.L	CrunchedSongLength(PC),D0
	MOVE.L	RealSongLength(PC),D1
	BSR	DoDecrunch
	MOVE.L	EndOfSongPtr(PC),A0
	MOVE.L	SongDataPtr(PC),A1
	MOVE.L	RealSongLength(PC),D0
ddcloop	MOVE.B	(A0)+,(A1)+
	SUBQ.L	#1,D0
	BNE	ddcloop
	MOVE.L	SongDataPtr(PC),A0
	ADD.L	#$0001143C,A0
	MOVE.L	SongDataPtr(PC),A1
	ADD.L	RealSongLength(PC),A1
	SUB.L	A1,A0
	MOVE.L	A0,D0
ddcloop2
	CLR.B	(A1)+
	SUBQ.L	#1,D0
	BNE	ddcloop2
	RTS	

DoDecrunch
	ADD.L	D0,A0
	MOVE.L	D1,A2
	ADD.L	A1,A2
	MOVE.L	-(A0),D0
dec_1	LSR.L	#1,D0
	BNE.S	decskip
	BSR	dec5
decskip	BCS.S	dec3
	MOVEQ	#8,D1
	MOVEQ	#1,D3
	LSR.L	#1,D0
	BNE.S	decskip2
	BSR	dec5
decskip2
	BCS.S	dec4_1
	MOVEQ	#3,D1
	CLR.W	D4
dec_2	BSR	dec6
	MOVE.W	D2,D3
	ADD.W	D4,D3
decloop1
	MOVEQ	#7,D1
decloop2
	LSR.L	#1,D0
	BNE.S	decskip3
	BSR.S	dec5
decskip3
	ROXL.L	#1,D2
	DBRA	D1,decloop2
	MOVE.B	D2,-(A2)
	DBRA	D3,decloop1
	BRA.S	dec4_3
 
dec2	MOVEQ	#8,D1
	MOVEQ	#8,D4
	BRA.S	dec_2
 
dec3	MOVEQ	#2,D1
	BSR.S	dec6
	CMP.B	#2,D2
	BLT.S	dec4
	CMP.B	#3,D2
	BEQ.S	dec2
	MOVEQ	#8,D1
	BSR.S	dec6
	MOVE.W	D2,D3
	MOVE.W	#8,D1
	BRA.S	dec4_1
 
dec4	MOVE.W	#9,D1
	ADD.W	D2,D1
	ADDQ.W	#2,D2
	MOVE.W	D2,D3
dec4_1	BSR.S	dec6
dec4_2	SUBQ.W	#1,A2
	MOVE.B	0(A2,D2.W),(A2)
	DBRA	D3,dec4_2
dec4_3	CMP.L	A2,A1
	BLT.S	dec_1
	RTS	
 
dec5	MOVE.L	-(A0),D0
	MOVE.W	D0,$DFF1A2
	MOVE.W	#$10,CCR
	ROXR.L	#1,D0
	RTS	
 
dec6	SUBQ.W	#1,D1
	CLR.W	D2
dec6loop
	LSR.L	#1,D0
	BNE.S	dec6skip
	MOVE.L	-(A0),D0
	MOVE.W	D0,$DFF1A2
	MOVE.W	#$10,CCR
	ROXR.L	#1,D0
dec6skip
	ROXL.L	#1,D2
	DBRA	D1,dec6loop
	RTS	
 
LoadModule
	MOVE.W	#1,LoadInProgress
	JSR	SetDiskPtrCol
	move.l	PathPtr,a0
	JSR	CopyPath
	LEA	DirInputName,A0
	MOVEQ	#DirNameLength-1,D0
lmloop2	MOVE.B	(A0)+,(A1)+
	DBRA	D0,lmloop2
	MOVE.L	DosBase,A6
	MOVE.L	#FileName,D1
	MOVE.L	#1005,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,FileHandle
	BEQ	CantOpenFile
	pea	DoCloseFile		; PS! It Will close file when
					; finished!!

	move.l	FileHandle,d1
	lea	TempFileBuf,a0
	move.l	a0,d2
	MOVEQ	#4,D3
	JSR	LVORead(A6)
	cmp.l	#4,d0
	bne	MismatchError
	lea	TempFileBuf,a0
	CMP.L	#'PP20',(A0)
	BEQ	ReadPowerPacked		; powerpacked
	CMP.L	#'PX20',(A0)
	BEQ	ReadPowerPacked		; powerpacked encrypted
	cmp.l	#"FORM",(a0)		; ps! will not read PP IFF file!
	beq.w	ReadIffFile		; This will come to be...

ContReadPPMod
	move.l	FileHandle,d1
	MOVE.L	#1080,D2
	MOVEQ	#-1,D3			; seek from beginning
	bsr	SeekData
	move.l	FileHandle,d1
	lea	TempFileBuf,a0
	move.l	a0,d2
	MOVEQ	#4,D3
	bsr	ReadData
	cmp.l	#4,d0
	bne	MismatchError
	lea	TempFileBuf,a0
	CMP.L	#'M.K.',(A0)
	BEQ	ReadMahoneyKaktus	; Is 31 inst. protracker/noisetracker

	BSR	Req31or15		; ask what to do
	cmp.l	#2,d0
	REQ				; cancel chosen
	cmp.l	#1,d0
	BEQ	ReadMahoneyKaktus	; 31 instr chosen

ReadOld15Instr				; convert 15 instr to 31 instr
	JSR	DoClearSong
	JSR	ClrSampleInfo

	LEA	LoadingModuleText(PC),A0
	BSR	ShowStatusText

	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	MOVEQ	#0,D2
	MOVEQ	#-1,D3			; seek from beginning
	bsr	SeekData
	move.l	FileHandle,d1
	MOVE.L	SongDataPtr(PC),D2
	MOVE.L	#20+(20+5*2)*15,D3
	bsr	ReadData		; read name and 15 instr
	cmp.l	#20+(20+5*2)*15,d0
	bne	MismatchError

	MOVE.L	SongDataPtr(PC),A0
	add.l	#20+(20+5*2)*15,a0
	moveq	#16-1,d0
.loop	moveq	#20-1,d1
.loop2	clr.b	(a0)+
	dbf	d1,.loop2
	clr.w	(a0)+		; 1 word
	clr.w	(a0)+		; length
	clr.w	(a0)+		; volume
	clr.w	(a0)+		; repeat
	move.w	#1,(a0)+	; replen
	dbf	d0,.loop

	move.l	FileHandle,d1
	move.l	SongDataPtr(pc),d2
	add.l	#sd_numofpatt,d2
	MOVE.L	#1+1+128,D3	; posnum,maxpatt,postab
	bsr	ReadData
	cmp.l	#1+1+128,d0
	bne	MismatchError

	MOVE.L	SongDataPtr(PC),A0
	MOVE.B	#127,sd_numofpatt+1(A0) ; Set maxpatt to 127
	move.l	#"M.K.",sd_mahokakt(a0)
	bra	lmskip

ReadMahoneyKaktus		; 31 instr module
	JSR	DoClearSong
	JSR	ClrSampleInfo

	LEA	LoadingModuleText(PC),A0
	BSR	ShowStatusText

	MOVE.L	DosBase,A6
	move.l	FileHandle,d1
	MOVEQ	#0,D2
	MOVEQ	#-1,D3			; seek from beginning
	bsr	SeekData
	move.l	FileHandle,d1
	MOVE.L	SongDataPtr(PC),D2
	MOVE.L	#1084,D3
	bsr	ReadData
	cmp.l	#1084,d0
	bne	MismatchError
	MOVE.L	SongDataPtr(PC),A0
	MOVE.B	#127,sd_numofpatt+1(A0) ; Set maxpatt to 127
lmskip	bsr	TestSamples
	bne	MismatchError
	LEA	LoadingModuleText(PC),A0
	BSR	ShowStatusText
	MOVE.L	SongDataPtr(PC),A0
	LEA	sd_pattpos(A0),A0	;find fist pattern
	MOVEQ	#0,D0
	MOVE.B	-1(A0),D0		;count number of patterns
	MOVEQ	#0,D3
.loop3	CMP.B	(A0)+,D3
	BHI.s	.skip2
	MOVE.B	-1(A0),D3
.skip2	DBRA	D0,.loop3
	ADDQ.W	#1,D3
	MULU	#1024,D3		;patterns are 1024 bytes long
	MOVE.L	FileHandle(PC),D1	;now, read all patterns
	MOVE.L	SongDataPtr(PC),D2
	ADD.L	#1084,D2		;start at position 1084 in memory
	MOVE.L	DosBase,A6
	bsr	ReadData
	CLR.L	PatternNumber		;reset parameters
	CLR.L	CurrPos
	BSR	RedrawPattern		;redraw first pattern
	CLR.W	ScrPattPos
	BSR	SetScrPatternPos	;redraw screen pattern pos
	MOVE.W	#1,InsNum		;start at instrument #1
	BSR	CheckAbort		;load aborted?
	BEQ	rmiend			;yes, end
	btst	#4,DiskBitFlags+3 ;AutoExitFlag  autoexit flag set?
	BEQ	readinstrloop		;nope, read instruments
	JSR	ExitFromDir		;else, exit from directory

readinstrloop
	btst	#5,DiskBitFlags+3	;NosamplesFlag
	BNE	rmiend
	BSR	CheckAbort		;aborted?
	BEQ	rmiend
	BSR	ShowSampleInfo		;show sample info
	MOVE.W	InsNum(PC),TuneUp	;dunno
	JSR	DoShowFreeMem		;update freemem display
	MOVE.L	SongDataPtr(PC),A0	;back to start :)
	MOVE.W	InsNum(PC),D7		;this instrument!
	MULU	#INSTR_SIZEOF,D7	;this many bytes pr. name
	MOVEQ	#0,D0			;get lenght
	MOVE.W	12(A0,D7.W),D0		;..
	BEQ	rminext			;zero? -> next instrument

	move.b	14(a0,d7.w),d1		; -maw-
	btst	#7,d1                   ; check finetune MSB for dyn flag
	sne	d1
	move.b	d1,tmploaddynflag

	ADD.L	D0,D0			;else get *real* lenght
	MOVE.L	4.w,a6
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1 ;samples GOTTA lie in chip-mem
	MOVE.L	D0,-(SP)
	JSR	LVOAllocMem(A6)		;request memory
	MOVE.L	(SP)+,D6
	TST.L	D0			;success?
	BNE	ReadModInstrument	;yes, get next instrument from module
	BSR	OutOfMemErr		;nope, show error text and exit
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	MOVE.L	D6,D2
	MOVEQ	#0,D3
	BRA	rminext

ReadModInstrument
	MOVE.W	InsNum(PC),D7		;this instrument
	LSL.W	#2,D7			;make word of it
	LEA	SamplePtrs(PC),A0	;array of addresses
	MOVE.L	D0,0(A0,D7.W)		;first: the address (where to put it)
	MOVE.L	D6,SAMPLE_LENGTHS(A0,D7.W)		;then:  the lenght
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	MOVE.L	D0,D2                   ; d0=d2=buffer to read into
	MOVE.L	D6,D3			;read the sample, d6=d3=length
	bsr	ReadData
;--------------------- -maw-	
	tst.b	tmploaddynflag
	beq	.nodyn
; first, read the length of the dyntable to read (arghh!)
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	MOVE.L	#tmpdynlength,D2        ; d2=buffer to read into
	moveq	#4,D3			; read longword (dynlength)
	bsr	ReadData
	move.l	tmpdynlength,d2         ; 4 bytes read here, is it zero???
	beq	.nodyn

	move.l	d2,d0  		; ok, now get mem for it
	move.l	d2,-(sp)
	MOVE.L	4.w,a6
	MOVE.L	#MEMF_ANY,D1	; any mem is ok
    	JSR	LVOAllocMem(A6)
	move.l	(sp)+,d2
	tst.l	d0
 	bne.s	.dmemok
	BSR	OutOfMemErr		;nope, show error text and exit
	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	MOVE.L	D6,D2
	MOVEQ	#0,D3
	BRA	rminext
.dmemok:
	lea	DynMemPtrTable,a0
	move.w	InsNum,d1
	lsl.w	#3,d1		; *8, because of ADR.L,SIZE.L = 8
	add.w	d1,a0
	MOVE.L	D0,(A0)		; adress
	move.l	d2,4(a0)	; enter dyn_length
	move.l	d2,d3		; readdata length
	move.l	d0,d2   	; readdata buffer

	move.l	DynFlagMask,d1	; set the dyn flag
	move.w	InsNum,d0
	bset 	d0,d1
	move.l	d1,DynFlagMask

	MOVE.L	DosBase,A6
	MOVE.L	FileHandle(PC),D1
	bsr	ReadData	; and read the dyn table (phew!)
	
.nodyn:
;---------------------- -maw- end --------
	BSR	RedrawSample		;redraw sampleinfo (eg. waveform)

rminext	ADDQ.W	#1,InsNum		;next instrument, please!
	CMP.W	#MAX_INSTR+1,InsNum		;da end?
	BNE	readinstrloop		;nope, read the next
rmiend	MOVE.L	FileHandle(PC),D1	;close the file
	beq.s	.notclose
	MOVE.L	DosBase,A6
	JSR	LVOClose(A6)
	clr.l	FileHandle
.notclose
	MOVE.W	#1,InsNum		;back to 1 :)
	MOVE.L	#6,CurrSpeed		;set standard speed
	CLR.W	LoadInProgress		;no more loading
	BSR	ShowAllRight		;guess what
	JSR	SetNormalPtrCol		;again, guess what ;)
	BSR	CheckInstrLengths	;check lenghts
	BSR	ShowSampleInfo		;show info
	BSR	RedrawSample		;redraw sample
	btst	#4,DiskBitFlags+3	;AutoExitFlag
	bne.s	.cnt
	jsr	ShowFileName
.cnt	JMP	DoShowFreeMem		;update memorycounters and exit

; d1 = FileHD
; d2 = Dest Adr.
; d3 = Length
ReadData
	tst.l	modadr
	bne.s	.FromMem
	JMP	LVORead(A6)		; read name and 15 instr
.FromMem
	movem.l d1-d7/a0-a6,-(sp)
	move.l	modcuradr(pc),a1
	move.l	d2,a0
.loop	move.b	(a1)+,(a0)+
	subq.l	#1,d3
	bne.s	.loop
	move.l	a1,modcuradr
	movem.l (sp)+,d1-d7/a0-a6
	move.l	d3,d0
	rts

; d1 = FileHD
; d2 = Pos
; d3 = Mode (-1=beg,  0=current,  1=end)
SeekData
	tst.l	modadr
	bne.s	.FromMem
	JMP	LVOSeek(A6)		; read name and 15 instr
.FromMem
	cmp.l	#-1,d3
	beq.s	.beg
	cmp.l	#1,d3
	beq.s	.end
	tst.l	d3
	RNE
	add.l	d2,modcuradr
	move.l	d2,d0
	rts
.beg	move.l	modadr(pc),modcuradr
	add.l	d2,modcuradr
	move.l	d2,d0
	rts
.end	move.l	modadr(pc),modcuradr
	sub.l	d2,modcuradr
	move.l	d2,d0
	rts

DoCloseFile
	move.l	FileHandle(pc),d1
	beq.s	.notclose
	MOVE.L	DosBase,A6
	JSR	LVOClose(A6)
	clr.l	FileHandle
.notclose
	move.l	modadr(pc),d0
	beq.s	.notfree
	move.l	d0,a1
	move.l	modlen(pc),d0
	move.l	4.w,a6
	jsr	LVOFreeMem(a6)		; free powerpacked
	clr.l	modadr
.notfree
	CLR.W	LoadInProgress		;no more loading
	rts

TestSamples
	move.l	SongDataPtr(pc),a0
	add.l	#20,a0
	moveq	#MAX_INSTR-1,d1
.loop	cmp.b	#$40,25(a0)		; volume
	bhi.s	.error
	moveq	#0,d2
	moveq	#0,d3
	move.w	22(a0),d2		; length
	move.w	26(a0),d3		; repeat
	cmp.l	d3,d2
	blt.s	.error
	add.l	#30,a0
	dbf	d1,.loop
	moveq	#0,d0
	rts
.error	moveq	#-1,d0
	rts

MismatchError
	bsr	DoCloseFile
	JSR	DoClearSong
	JSR	ClrSampleInfo
	LEA	.text(PC),A0
	BSR	ShowStatusText
	move.w	#40,WaitTime
	JMP	SetErrorPtrCol
.text	dc.b	'Mismatch file type!?',0
	cnop	0,2

ReadPowerPacked
	lea	PowerPackedText,a0
	jsr	ShowStatusText

	bsr	DoCloseFile

	bsr	OpenPPLib
	beq	PowErr1
	move.l	d0,a6

	lea	FileName,a0		;filename (again... :)
	moveq	#DECR_POINTER,d0	;decrunch in mouse cursor
	move.l	#MEMF_ANY!MEMF_CLEAR,d1
	lea	modadr(pc),a1		;obz!
	lea	modlen(pc),a2		;the lenght
	lea	GetPassword(pc),a3	;Our password prompt
	move.l	ppbase(pc),a6
	jsr	ppLoadData(a6)		;load and decrunch
	move.l	d0,-(sp)
	move.l	modadr(pc),modcuradr

	move.l	(sp)+,d0
	bne.w	DoPPErr
	bra	ContReadPPMod

ppname	dc.b	'powerpacker.library',0
	even
pperr		dc.l	0
ppbase		dc.l	0
ppsamples	dc.l	0
modadr		dc.l	0
modlen		dc.l	0
modcuradr	dc.l	0

DoPPErr	move.l	d0,pperr
	move.l	pperr(pc),d0
	cmp.l	#PP_OPENERR,d0		;check for errors
	bne.s	ppnxt1
	lea	PP_OpenErrTxt(pc),a0
	bra.w	pperrexit
ppnxt1	cmp.l	#PP_READERR,d0
	bne.s	ppnxt2
	lea	PP_ReadErrTxt(pc),a0
	bra.w	pperrexit
ppnxt2	cmp.l	#PP_NOMEMORY,d0
	bne.s	ppnxt3
	lea	PP_NoMemoryTxt(pc),a0
	jsr	MemoryRequester
	bra.w	pperrexit2
ppnxt3	cmp.l	#PP_CRYPTED,d0
	bne.s	ppnxt4
	lea	PP_CryptedTxt(pc),a0
	bra.w	pperrexit
ppnxt4	cmp.l	#PP_PASSERR,d0
	bne.s	ppnxt5
	lea	PP_PassErrTxt(pc),a0
	bra.w	pperrexit
ppnxt5	cmp.l	#PP_UNKNOWNPP,d0
	bne.s	ppnxt6
	lea	PP_UnknownTxt(pc),a0
	bra.w	pperrexit
ppnxt6	cmp.l	#PP_EMPTYFILE,d0
	bne.s	ppnxt7
	lea	PP_EmptyTxt(pc),a0
	bra.w	pperrexit
ppnxt7	lea	PP_StrangeTxt(pc),a0
	bra.w	pperrexit

PowErr2 movem.l	(sp)+,d0-d7/a0-a6
	LEA	PowerError2,A0
	bra.b	pperrexit

PowErr3 move.l	$4.w,a6
	move.l	modadr(pc),d0
	beq.s	.cnt
	move.l	d0,a1
	move.l	modlen(pc),d0
	jsr	LVOFreeMem(a6)		;deallocate used memory
	clr.l	modadr
.cnt	move.l	ppbase(pc),a1		;close library
	jsr	LVOCloseLibrary(a6)
	clr.l	ppbase
	movem.l	(sp)+,d0-d7/a0-a6
	LEA	PowerError7,A0
	bra.b	pperrexit

PowErr1 LEA	PowerError1,A0
pperrexit
	BSR	ShowStatusText
pperrexit2
	CLR.W	LoadInProgress		;no more loading
	JSR	SetErrorPtrCol
	jmp	DoShowFreeMem		;update memorycounters and exit

OpenPPLib
	tst.l	ppbase
	bne.s	.cnt
	move.l	4.w,a6
	lea	ppname(pc),a1		;"powerpacker.library"
	moveq	#PPVERSION,d0		;i need at least this version
	jsr	LVOOpenLibrary(a6)	;OpenLibrary
	move.l	d0,ppbase		;take care of the base
.cnt	move.l	ppbase,d0
	rts

ClosePPLib
	move.l	ppbase(pc),d0
	beq.s	.cnt
	move.l	d0,a1
	move.l	4.w,a6
	jsr	LVOCloseLibrary(a6)
	clr.l	ppbase
.cnt	rts

LVOCloseWindow	= -72
LVOOpenWindow	= -204
;LVOWaitPort	= -384
;LVOGetMsg	= -372
;LVOReplyMsg	= -378
;LVODelay	= -198
LVOppCalcChecksum = -42
LVOSetWindowTitles = -276
LVODisplayBeep	= -96

GetPassword
	move.l	4(a7),.ptr
	move.l	8(a7),.check
	move.w	#3,.tries
	movem.l d0-d7/a0-a6,-(sp)
	jsr	DoScreenToBack
	move.l	IntuitionBase,a6
	;bsr	.getfontsize
	lea	.WindowDef(pc),a0
	jsr	LVOOpenWindow(A6)		; OPEN WINDOW
	move.l	d0,.window
	beq.w	.false
.again	clr.w	.cntr
	move.l	.ptr(pc),.adr
.loop	move.l	4.w,a6
	move.l	.window(pc),a0	; Pointer to Structure
	move.l	86(a0),a0		; UserPort pointer to a0
	jsr	LVOWaitPort(a6)
	move.l	.window(pc),a0	; Pointer to Structure
	move.l	86(a0),a0		; UserPort pointer to a0
	jsr	LVOGetMsg(a6)
	move.l	d0,a0			; MessagePointer to a0
	move.l	20(a0),.event		; im_Class
	move.l	24(a0),.code		; im_Code
	move.l	d0,a1
	jsr	LVOReplyMsg(a6)
	move.l	.event(pc),d0
	cmp.l	#$200000,d0		; IDCMP_VANILLAKEY
	bne.s	.loop
	move.w	.code(pc),d0
	cmp.w	#$d,d0			; enter
	beq.s	.exit
	move.l	.adr(pc),a0
	cmp.w	#8,d0			; backspace
	bne.s	.cnt2
	subq.l	#1,a0
	subq.w	#1,.cntr
	bpl.s	.cnt
	move.l	.ptr(pc),a0
	clr.w	.cntr
	bra.s	.cnt
.cnt2	move.b	d0,(a0)+
	addq.w	#1,.cntr
	cmp.w	#16,.cntr
	bne.s	.cnt
	subq.l	#1,a0
	sub.w	#1,.cntr
.cnt	move.l	a0,.adr
	bra.w	.loop
.exit	move.l	.adr(pc),a0
	clr.b	(a0)			; null terminated
	move.l	.ptr(pc),a0
	move.l	ppbase(pc),a6
	jsr	LVOppCalcChecksum(a6)
	cmp.l	.check(pc),d0
	beq.s	.true
	bsr	.wrongpassword
	subq.w	#1,.tries
	bgt.w	.again
	move.l	IntuitionBase,a6
	move.l	.window(pc),a0
	jsr	LVOCloseWindow(a6)
.false	jsr	DoScreenToFront
	movem.l (sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
.true	move.l	IntuitionBase,a6
	move.l	.window(pc),a0
	jsr	LVOCloseWindow(a6)
	jsr	DoScreenToFront
	movem.l (sp)+,d0-d7/a0-a6
	moveq	#-1,d0
	rts
.wrongpassword
	suba.l	a0,a0
	move.l	IntuitionBase,a6
	jsr	LVODisplayBeep(a6)
	move.l	.window(pc),a0
	lea	.wrongtext(pc),a1
	move.l	#-1,a2
	jsr	LVOSetWindowTitles(a6)
	move.l	DosBase(pc),a5
	moveq	#80,d1
	jsr	LVODelay(a5)
	move.l	.window(pc),a0
	lea	.name(pc),a1
	move.l	#-1,a2
	jsr	LVOSetWindowTitles(a6)
	rts
;.getfontsize
;	move.l	56(a6),a0		; ib_ActiveScreen
;	moveq	#0,d0
;	move.l	40(a0),a1		; sc_Font
;	move.w	4(a1),d0		; ta_YSize (in Struct TextAttr)
;	addq.w	#1,d0
;	add.b	35(a0),d0		; sc_WBorTop
;	move.w	d0,.wndhgt
;	rts
	cnop	0,4
.event	dc.l	0
.window	dc.l	0
.code	dc.l	0
.cntr	dc.w	0
.tries	dc.w	0
.check	dc.l	0
.adr	dc.l	0
.ptr	dc.l	0
.WindowDef
	dc.w	225		;	xpos
	dc.w	50		;	ypos
	dc.w	208		;	width
.wndhgt	dc.w	11		;	height
	dc.b	1		;	white text
	dc.b	3		;	read back
	dc.l	$200000		;VANILLAKEY
	dc.l	$11006		;ACTIVATE!RMBTRAP!WFLG_DRAGBAR!WFLG_DEPTHGADGET
	dc.l	0		;	no gadget
	dc.l	0		;	checkmark
	dc.l	.name		;	windowname
	dc.l	0		;	screen pointer
	dc.l	0		;	no bmap
	dc.w	150		;	minwidth
	dc.w	50		;	minheight
	dc.w	320		;	maxwidth
	dc.w	200		;	maxheight
	dc.w	1		;	WBENCHSCREEN
.name	dc.b	'  Enter password',0
.wrongtext
	dc.b	'Incorrect password',0
	cnop	0,2

PowerPackedText	dc.b "Reading PowerPacked module..",0

PowerError1	dc.b "Can't open PowerPacker.library!",0
PowerError2	dc.b "Error while decrunching!!",0
PP_NoMemoryTxt	dc.b 10,10,10,"   Not enough memory",10
		dc.b	   "    for decruncher!",0
PP_OpenErrTxt	dc.b "PP Open error!!",0
PP_ReadErrTxt	dc.b "PP Read error!!",0
PP_CryptedTxt	dc.b "PowerPacked module is encrypted!!",0
PP_PassErrTxt	dc.b "Permission denied",0
PP_UnknownTxt	dc.b "Unknown PowerPacker version!",0
PP_EmptyTxt	dc.b "PowerPacked file is empty!",0
PP_StrangeTxt	dc.b "Weird PowerPacker error!?",0
PowerError7	dc.b "I hate this mod!",0
	even

******************************************************************

ReadIffFile
	move.l	FileHandle,d1
	lea	TempFileBuf,a0
	move.l	a0,d2
	MOVEQ	#8,D3
	move.l	DosBase,a6
	JSR	LVORead(A6)
	cmp.l	#8,d0
	bne	MismatchError

	bsr	DoCloseFile

	lea	TempFileBuf,a0
	;cmp.l	#"PTCF",4(a0)
	;beq	LoadConfigName	; this buggs... Why?
	;cmp.l	#"8SVX",4(a0)
	;beq	AskLoadSample
	;cmp.l	#"ILBM",4(a0)
	;beq	PTCantDisplay

	lea	4(a0),a0
	lea	.type(pc),a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+

	LEA	.text(PC),A0
	BSR	ShowStatusText
	MOVE.W	#40,WaitTime
	JMP	SetErrorPtrCol
.text	dc.b	'Unknown IFF type '
.type	dc.b	'    ',0
	cnop	0,2

******************************************************************

SetDynFlagFT:
; we use the highest finetune bit to indicate sample is a dyn sample
	MOVE.L	SongDataPtr,A1
	LEA	sd_sampleinfo(A1),A1
	move.l	DynFlagMask,d1
	moveq	#1,d0
.loop	btst	d0,d1
	beq.s	.nod	
	or.b	#$80,INSTR_FINETUNE(A1)
.nod:	LEA	INSTR_SIZEOF(A1),A1
	addq	#1,d0
	cmp.w	#MAX_INSTR+1,d0
	ble.s	.loop
	rts
;--------------
ClrDynFlagFT:
; we used the highest finetune bit to indicate sample is a dyn sample
	MOVE.L	SongDataPtr,A1
	LEA	sd_sampleinfo(A1),A1
	moveq	#1,d0
.loop	and.b	#$7F,INSTR_FINETUNE(A1)
	LEA	INSTR_SIZEOF(A1),A1
	addq	#1,d0
	cmp.w	#MAX_INSTR+1,d0
	ble.s	.loop
	rts
;--------------
SaveModule
	JSR	StorePtrCol
	JSR	SetDiskPtrCol

	bsr	SetDynFlagFT	; -maw-  only temporarily!

	MOVE.L	SongDataPtr(PC),A0
	LEA	sd_pattpos(A0),A0
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	CLR.W	HighPattNum
smloop	MOVE.B	0(A0,D0.W),D1
	ADDQ.W	#1,D0
	CMP.W	#128,D0
	BHI	DoSaveModule
	MOVE.W	HighPattNum(PC),D2
	CMP.W	D2,D1
	BLS	smloop
	MOVE.W	D1,HighPattNum
	BRA	smloop
 
DoSaveModule
	move.l	PathPtr,a0
	JSR	CopyPath
	MOVE.B	#'m',(A1)+
	MOVE.B	#'o',(A1)+
	MOVE.B	#'d',(A1)+
	MOVE.B	#'.',(A1)+
	MOVE.L	SongDataPtr(PC),A0
	MOVEQ	#20-1,D0
dsmloop2
	MOVE.B	(A0)+,(A1)+
	DBRA	D0,dsmloop2

	btst	#1,DiskBitFlags+3	;ModPackMode		;powerpacked?
	bne	DoPowerSave		;yes.. save module as powerpacked
	clr.l	bufferptr
	clr.w	simmode

SaveNormalMod

	MOVE.L	SongDataPtr(PC),A0
	MOVE.L	A0,DiskDataPtr
	MOVE.L	#1084,DiskDataLength	; header (sampleinfo ++)
	MOVEQ	#0,D0
	MOVE.W	HighPattNum(PC),D0
	ADDQ.L	#1,D0
	LSL.L	#8,D0			;*1024 (1 pattern == 1024 bytes)
	LSL.L	#2,D0
	ADD.L	D0,DiskDataLength	; Add 1024 x NumOfPatt
	MOVE.B	#127,sd_numofpatt+1(A0) ; Set maxpatt to 127
	MOVE.L	#'M.K.',sd_mahokakt(A0)	; M.K. again...
	tst.w	simmode
	bne.s	.cnt
	tst.l	bufferptr	; not if powerpacking
	bne.s	.cnt
	LEA	SavingModuleText(PC),A0
	BSR	ShowStatusText
.cnt	BSR	OpenModForWrite
	BNE	CantOpenFile
	BSR	WriteModuleData
	BNE	WriteModError

	MOVE.W	InsNum(PC),SaveInstrNum
	MOVEQ	#1,D6
.loop	MOVE.W	D6,InsNum
	tst.w	simmode
	bne.s	.cnt2
	tst.l	bufferptr	; not if powerpacking
	bne.s	.cnt2
	BSR	ShowSampleInfo
.cnt2	BSR	WriteInstrument
	BNE	WriteModError
	ADDQ.B	#1,D6
	CMP.B	#MAX_INSTR+1,D6
	BNE.s	.loop

	BSR	CloseWriteMod
	MOVE.W	SaveInstrNum(PC),InsNum
	tst.w	simmode
	RNE
	tst.l	bufferptr	; not if powerpacking
	RNE
	BSR	ShowSampleInfo
	BSR	ShowAllRight

	BSR	ClrDynFlagFT	; -maw- now clean the finetune byte again
	
	JMP	RestorePtrCol
	cnop	0,4
SaveInstrNum	dc.w 0

WriteModError
	BSR	CloseWriteMod
	BRA	CantSaveFile
 
OLD_WriteInstrument
	MOVE.W	D6,D0        ; instrument number comes in d6?
	LSL.W	#2,D0
	LEA	SamplePtrs(PC),A0       ; get sample start
	MOVE.L	0(A0,D0.W),D1
	REQ                             ; do nothing if no sample there
	MOVE.L	SAMPLE_LENGTHS(A0,D0.W),D0
	REQ				; or if the length of the sample is zero
	MOVE.L	D1,DiskDataPtr          ; start adress to write
	MOVE.L	SongDataPtr(PC),A0
	LEA	12(A0),A0
	MOVE.W	D6,D0
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	MOVEQ	#0,D0
	MOVE.W	(A0),D0  ; instr_length ; get the length to write from the instr info
	LSL.L	#1,D0
	MOVE.L	D0,DiskDataLength       ; number of bytes to write
	BNE	WriteModuleData
	moveq	#0,d0
	RTS	; else it's EQ
;------------
;XXXXXXXXXXXXXXXXXXXXXX
WriteInstrument	; -maw-
	MOVE.W	D6,D0        ; instrument number comes in d6?
	LSL.W	#2,D0
	LEA	SamplePtrs(PC),A0       ; get sample start
	MOVE.L	0(A0,D0.W),D1
	REQ                             ; do nothing if no sample there
	MOVE.L	SAMPLE_LENGTHS(A0,D0.W),D0
	REQ				; or if the length of the sample is zero
	MOVE.L	D1,DiskDataPtr          ; start adress to write
	MOVE.L	SongDataPtr(PC),A0
	LEA	12(A0),A0
	MOVE.W	D6,D0
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	MOVEQ	#0,D0
	MOVE.W	(A0),D0  ; instr_length ; get the length to write from the instr info

	move.b	2(a0),d1	; finetune
	btst	#7,d1           ; check highest bit for dyn flag
	sne	d1
	move.b	d1,tmpsavedynflag

	LSL.L	#1,D0
	MOVE.L	D0,DiskDataLength       ; number of bytes to write
	BNE	.ok 
	moveq	#0,d0
	RTS             ; else it's EQ

.ok:	bsr	WriteModuleData        ; write sample

*; debug
*	movem.l	d0-d7/a0-a6,-(sp)
*	jsr	DoScreenToBack
*	JSR	WaitForActivate		
*	illegal
*	movem.l	(sp)+,d0-d7/a0-a6

	tst.b	tmpsavedynflag
	beq.s	.nodyn
; if it is a dyn, write the dyntable behind the sample
	lea	DynMemPtrTable,a0
	move.w	d6,d1
	lsl.w	#3,d1		; *8, because of ADR.L,SIZE.L = 8
	add.w	d1,a0
	move.l	(a0)+,d1	; start adress
	beq.s	.nodyn
	move.l	(a0)+,d0	; dyn_length
	beq.s	.nodyn
	move.l	d1,tmpdynstart
	move.l	d0,tmpdynlength
	
	move.l	#tmpdynlength,DiskDataPtr
	move.l	#4,DiskDataLength
	bsr	WriteModuleData

	move.l	tmpdynstart,DiskDataPtr
	move.l	tmpdynlength,DiskDataLength
	bsr	WriteModuleData
.nodyn:
	rts
	
tmploaddynflag:
tmpsavedynflag: dc.w 0
tmpdynstart:	dc.l 0
tmpdynlength:	dc.l 0

; XXXXXXXXXXXXXXXXXXXXXXXXXX

;------------
OpenModForWrite
	tst.w	simmode
	bne.s	ModWriteOk
	tst.l	bufferptr	; not if powerpacking
	bne.s	ModWriteOk
OpenModForWrite2
	MOVE.L	DosBase,A6
	MOVE.L	#FileName,D1
	MOVE.L	#1006,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,D7
	BEQ	wmfailed
ModWriteOk
	MOVEQ	#0,D0
	RTS

WriteModuleData
	MOVE.L	DosBase,A6
	MOVE.L	D7,D1           ; looks like the handle
	MOVE.L	DiskDataPtr(PC),D2
	MOVE.L	DiskDataLength(PC),D3
	bsr	WriteData
	TST.L	D0
	BEQ	wmfailed
	MOVEQ	#0,D0
	RTS

wmfailed
	MOVEQ	#-1,D0
	RTS	

CloseWriteMod
	tst.w	simmode
	RNE
	tst.l	bufferptr	; not if powerpacking
	RNE
CloseWriteMod2
	MOVE.L	DosBase,A6
	MOVE.L	D7,D1
	JMP	LVOClose(A6)

; d1 - FileHeader
; d2 - Source buffer
; d3 - Length
WriteData
	tst.w	simmode
	bne.s	.simul
	tst.l	bufferptr	; pointer to buffer to be powerpacked
	bne.s	.ispp
	jmp	LVOWrite(a6)
.ispp	movem.l d0-d7/a0-a6,-(sp)
	move.l	ppwriteptr(pc),a0
	move.l	d2,a1
.loop	move.b	(a1)+,(a0)+
	subq.l	#1,d3
	bgt.s	.loop
	move.l	a0,ppwriteptr
	movem.l (sp)+,d0-d7/a0-a6
	move.l	d3,d0
	rts
.simul	add.l	d3,simcntr
	move.l	d3,d0
	rts

; returns modlen in d0
SimulateSaveMod
	movem.l d1-d7/a0-a6,-(sp)
	move.l	DiskDataLength,-(sp)
	move.w	#-1,simmode
	clr.l	simcntr
	bsr	SaveNormalMod
	clr.w	simmode
	move.l	(sp)+,DiskDataLength
	movem.l (sp)+,d1-d7/a0-a6
	move.l	simcntr(pc),d0
	rts
	cnop	0,4
simmode	dc.w	0
simcntr	dc.l	0

DoPowerSave
	bsr.s	SimulateSaveMod
	move.l	d0,DiskDataLength
	move.l	4.w,a6
	move.l	#MEMF_ANY!MEMF_CLEAR,d1		;memf flags
	move.l	DiskDataLength,d0		;lenght
	jsr	LVOAllocMem(a6)			;try allocating it
	move.l	d0,bufferptr
	beq.w	PPSaveMemErr
	move.l	d0,ppwriteptr
	move.l	DiskDataLength,-(sp)
	bsr	SaveNormalMod	; Save almost as normaly (into ram...)
	move.l	(sp)+,DiskDataLength

	bsr	OpenPPLib
	bne.s	.cnt0
	bsr	FreePowerMem
	LEA	PowerError1(pc),A0
	BSR	ShowStatusText
	JMP	SetErrorPtrCol
.cnt0
	move.l	ppbase(pc),a6		;oh joy! :)
	moveq	#0,d0
	move.b	PowerFlag,d0		;efficiency
	move.l	#1,d1			;medium
	lea	UpdateCrunchReq(pc),a0	;function
	sub.l	a1,a1			;no userdata...
	jsr	ppAllocCrunchInfo(a6)	;allocate crunch-info buffer
	move.l	d0,crunchinfoptr
	bne.s	.cnt1
	bsr	FreePowerMem
	lea	ppsavememerr2(pc),a0
	jsr	MemoryRequester		; if no success
	bra	DoPPsaveErr2
.cnt1
	movem.l	d0-d7/a0-a6,-(sp)
	lea	ppcrunching(pc),a0
	jsr	ShowStatusText
	jsr	SetWaitPtrCol
	movem.l	(sp)+,d0-d7/a0-a6

	bsr	ShowCrunchReq

	move.l	crunchinfoptr(pc),a0
	move.l	bufferptr(pc),a1
	move.l	DiskDataLength(pc),d0
	jsr	ppCrunchBuffer(a6)	;crunch da memory :)
	move.l	d0,ppfilelen
	bne.s	.cnt2			;success ->
	bsr	ClearCrunchReq
	bsr	FreePowerMem
	lea	ppsaveerr1(pc),a0
	bra	DoPPsaveErr
.cnt2
	bsr	ClearCrunchReq

	movem.l	d0-d7/a0-a6,-(sp)
	lea	ppwriting(pc),a0
	jsr	ShowStatusText
	movem.l	(sp)+,d0-d7/a0-a6

	bsr.w	OpenModForWrite2	;open file
	tst.l	d0
	beq.s	.cnt3			;success ->
	bsr	FreePowerMem
	lea	ppsaveerr2(pc),a0
	bra	DoPPsaveErr
.cnt3	move.l	d7,ppfilehd

	movem.l	d0-d7/a0-a6,-(sp)
	lea	ppwriteheader(pc),a0
	jsr	ShowStatusText
	JSR	SetDiskPtrCol
	movem.l	(sp)+,d0-d7/a0-a6

	move.l	ppfilehd(pc),d0		; file header
	moveq	#0,d1
	move.b	PowerFlag,d1
	moveq	#0,d2			;no encryption :)
	moveq	#0,d3			;and therefore no passwd ;)
	move.l	ppbase(pc),a6
	jsr	ppWriteDataHeader(a6)	;write it

	movem.l	d0-d7/a0-a6,-(sp)
	lea	ppwritedata(pc),a0
	jsr	ShowStatusText
	movem.l	(sp)+,d0-d7/a0-a6

	move.l	ppfilehd(pc),d1
	move.l	bufferptr(pc),d2
	move.l	ppfilelen(pc),d3
	move.l	DosBase,a6
	jsr	LVOWrite(a6)		;write file (to disk actually...)
	tst.l	d0
	bne.s	.cnt4			;success ->
	move.l	ppfilehd(pc),d7
	bsr.w	CloseWriteMod2
	bsr	FreePowerMem
	lea	ppsaveerr2(pc),a0
	bra	DoPPsaveErr
.cnt4	move.l	ppfilehd(pc),d7
	bsr	CloseWriteMod2
.end	bsr.s	FreePowerMem
	BSR	ShowAllRight
	JMP	RestorePtrCol

FreePowerMem
	move.l	crunchinfoptr(pc),d0
	beq.s	.cnt2
	move.l	d0,a0
	move.l	ppbase,a6
	jsr	ppFreeCrunchInfo(a6)	;free used memory (pp)
	clr.l	crunchinfoptr
.cnt2	move.l	bufferptr(pc),d0
	beq.s	.cnt
	move.l	d0,a1
	move.l	DiskDataLength(pc),d0
	move.l	4.w,a6
	jsr	LVOFreeMem(a6)		;free used memory
	clr.l	bufferptr
.cnt	CLR.W	LoadInProgress		;no more loading
	jsr	DoShowFreeMem		;update memorycounters and exit
	JMP	RestorePtrCol

PPSaveMemErr
	lea	ppsavememerrtxt(pc),a0
	jsr	MemoryRequester
	bra.s	DoPPsaveErr2
DoPPsaveErr
	BSR	ShowStatusText
DoPPsaveErr2
	JSR	SetErrorPtrCol
	jmp	DoShowFreeMem		;update memorycounters and exit
	cnop	0,4
bufferptr	dc.l	0
crunchinfoptr	dc.l	0
ppfilelen	dc.l	0
ppwriteptr	dc.l	0
ppfilehd	dc.l	0

ppsavememerrtxt	dc.b	10,10,10,"  Not enough memory",10
		dc.b	"  for PowerPacking!",0	; OBZ!
ppsavememerr2	dc.b	10,10,10,"  Not enough memory",10
		dc.b	"   for CrunchInfo!",0	; OBZ!
ppsaveerr1	dc.b	"Error while crunching!!",0
ppsaveerr2	dc.b	"Error while writing file!",0
ppcrunching	dc.b	"Stanby, Packing..",0
ppwriting	dc.b	"Writing PP module..",0
ppwriteheader	dc.b	"Writing PP header..",0
ppwritedata	dc.b	"Writing PP data..",0
		cnop	0,2

ShowCrunchReq
	movem.l d0-d7/a0-a6,-(sp)
	move.w	#-1,FileInvOn
	jsr	SaveRequester
	sub.l	a0,a0
	sub.l	a1,a1
	lea	FormatBarReq,a2
	jsr	ShowRequester
	lea	.crunching(pc),a0
	move.w	#86+192,d0
	moveq	#50+12,d1
	jsr	ShowColorText2
	movem.l (sp)+,d0-d7/a0-a6
	rts
.crunching	dc.b	'Crunching...',0
	cnop	0,2

ClearCrunchReq
	movem.l d0-d7/a0-a6,-(sp)
	jsr	ReturnRequester
	clr.w	FileInvOn
	jsr	ClearKeyBuf
	movem.l (sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts

UpdateCrunchReq
	move.l	4(sp),.curpos
	move.l	8(sp),.crnlen
	move.l	12(sp),.length
	movem.l d0-d7/a0-a6,-(sp)
	move.l	.prvpos(pc),d0
	move.l	.curpos(pc),d2
	move.l	d2,.prvpos
	move.l	.length(pc),d3
	cmp.l	d0,d2
	bhi.s	.cnt
	moveq	#0,d0
.cnt	lsr.l	#6,d0		; max 4 meg of module data!
	lsr.l	#6,d2
	lsr.l	#6,d3
	mulu	#236,d0
	mulu	#236,d2
	divu	d3,d0
	divu	d3,d2
	add.w	#192+10,d0
	add.w	#192+10,d2
	moveq	#50+27,d1
	move.w	#50+27+9,d3
	moveq	#1,d5
	jsr	ShowAnyBlock3
.loop	jsr	DoKeyBuffer
	move.b	RawKeyCode,d0
	cmp.b	#$45,d0			; ESC
	beq.s	.abort
	tst.b	d0
	bne.s	.loop	; empty keybuffer
.end	movem.l (sp)+,d0-d7/a0-a6
	moveq	#-1,d0
	rts
.abort	movem.l (sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
	cnop	0,4
.prvpos		dc.l	0
.curpos		dc.l	0
.crnlen		dc.l	0
.length		dc.l	0

;-----------------------------------------

ShowAllRight
	MOVEM.L	D0-D7/A0-A6,-(SP)
	LEA	AllRightText(PC),A0
	BSR.S	ShowStatusText
	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS	
 
ShowStatusText
	movem.l d0-d7/a0-a6,-(sp)
	MOVE.L	TextBplPtr(PC),A1
	ADD.L	#128*80+13,A1
	MOVEQ	#5-1,D0
stloop1	MOVEQ	#38-1,D1
stloop2	CLR.B	(A1)+
	DBRA	D1,stloop2
	LEA	42(A1),A1
	DBRA	D0,stloop1
	MOVE.L	A0,A1
	MOVE.W	#128*80+13,D1
	MOVEQ	#-1,D0    ; seems to be a "StrLen"
stloop3	ADDQ.W	#1,D0
	TST.B	(A1)+
	BNE.S	stloop3
	BSR	ShowText3
	movem.l (sp)+,d0-d7/a0-a6
	rts

;---- Redraw Pattern ----

RedrawPattern2:
	tst.w	LoadInProgress
	bne.s	.cnt
	jsr	ClearKeyBuf
.cnt	TST.W	SamScrEnable
	beq.s	DoRedrawPattern
	rts
RedrawPattern:
	tst.w	LoadInProgress
	bne.s	.cnt
	jsr	ClearKeyBuf
.cnt	TST.W	SamScrEnable
	RNE
	jsr	ClearPatBlock
DoRedrawPattern:
	push	d0-a6
	tst.b	InRedraw
	bne	.exit
	st	InRedraw
	SF	PattRfsh
	move.w	#562,AnyTextPos
	move.w	#145,AnyTextPos+2
	MOVE.W	PatternNumber+2(PC),WordNumber
	BSR	PrintAny2DecDigits 	; Print PatternNumber

	MOVE.L	SongDataPtr(PC),A6
	LEA	sd_patterndata(A6),A6
	MOVE.L	PatternNumber,D6
	LSL.L	#8,D6
	LSL.L	#2,D6
	ADD.L	D6,A6
	MOVE.W	#194*80+1,TextOffset
	CLR.L	PPattPos
	LEA	PeriodTable(PC),A2
	LEA	RedrawBuffer(PC),A3
	LEA	FastHexTable(PC),A4
	MOVEQ	#'0',D4
	btst	#3,EditBitFlags+3	;BlankZeroFlag
	sne	d5
	MOVEQ	#64-1,D6
.nxpos	MOVEQ	#4-1,D7
	MOVE.W	PPattPos+2(PC),WordNumber
	moveq	#1,d1
	BSR	Print2DecDigitsTopaz60 	; Print PatternPosition
	ADDQ.W	#2,TextOffset
	ADDQ.L	#1,PPattPos
.loop	bsr	PrintOneLine
	DBRA	D7,.loop  		; Next Channel
	ADD.W	#7*80+15,TextOffset	; and now next line, please!
	DBRA	D6,.nxpos 		; Next PattPos
.exit	sf	InRedraw
	pop	d0-a6
	RTS

; a0 = address of position in pattern data
PrintTrackLine:
	push    d0-a6
	move.l	a0,a6
	;MOVE.L	SongDataPtr(PC),A6
	;LEA	sd_patterndata(A6),A6
	;MOVE.L	PatternNumber,D6
	;LSL.L	#8,D6
	;LSL.L	#2,D6
	;ADD.L	D6,A6
	LEA	PeriodTable(PC),A2
	LEA	RedrawBuffer(PC),A3
	LEA	FastHexTable(PC),A4
	MOVEQ	#'0',D4
	btst	#3,EditBitFlags+3	;BlankZeroFlag
	sne	d5
	bsr.s	PrintOneLine
	pop     d0-a6
	rts
*;-----------------------------------------------------------------------------*
*; -maw- I inserted this from Vishnus posting to USENET, just in case another *
*; poor creature like me has to fiddle around with this source and could need  *
*; this peculiar information right here.                                       *
*;-----------------------------------------------------------------------------*
;  Each note is stored as 4 bytes, and all four notes at each position in
; the pattern are stored after each other.
;
; 00 -  chan1  chan2  chan3  chan4
; 01 -  chan1  chan2  chan3  chan4
; 02 -  chan1  chan2  chan3  chan4
; etc.
;
; Info for each note:
;
;  _____byte 1_____   byte2_    _____byte 3_____   byte4_
; /                \ /      \  /                \ /      \
; 0000          0000-00000000  0000          0000-00000000
;
; Upper four    12 bits for    Lower four    Effect command.
; bits of sam-  note period.   bits of sam-
; ple number.                  ple number.
;
; output in the note scroller:
; 012 34 5678
; C-3 ss cccc
;------------------------------------------------------------------------


; this is the pattern for "empty note".
; In a luxury versiom of PT, this should be user-settable. -maw-

EmptyNotePlaceHolder:	dc.l " -  "
EmptyCmdPlaceHolder:	dc.l "  . "

PrintOneLine:
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	moveq	#0,d2		; flag for note present yes/no
	MOVE.W	(A6),D1         ; note period
	AND.W	#$0FFF,D1	; is there a note?
	;and.w	#$007f,d1	; OBS! Change to 2 instead of 3 nibbles
	BNE.S	.find
				;nope, just draw empty space
	move.l	EmptyNotePlaceHolder,(a3)	; -maw-
	BRA.S	.wasempty

;--- check to get the NoteName out of the periode
.find	MOVEQ	#36,D2          ; hmm, why 36? 3 octaves?
.findloop
	CMP.W	0(a2,D0.W),D1
	BEQ.S	.found
	ADDQ.L	#2,D0
	DBRA	D2,.findloop
	MOVE.L	#'??? ',(A3)	; marker for unknown period
	BRA.S	.wasempty
.found	LSL.L	#1,D0
	ADD.L	NoteNamesPtr(PC),D0
	MOVE.L	D0,A0
	MOVE.L	(A0),(A3)	; move the note name
	moveq	#-1,d2	; flag for "note found"	 (why? it is not used...)
.wasempty

	moveq	#0,d0
	MOVE.B	(A6),D0			;get sample number
	add.w	d0,d0

	move.b	0(a4,d0.w),3(a3)	;sample upper nibble
	;move.b	1(a4,d0.w),5(a3)	;command upper nibble (not used yet, huh?)
	MOVEQ	#0,D0
	MOVE.B	2(A6),D0
	ADD.W	D0,D0
	MOVE.b	0(a4,D0.W),4(A3)	;sample lower nibble
	MOVE.b	1(a4,D0.W),6(A3)	;command lower nibble
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	ADD.W	D0,D0
	MOVE.b	0(a4,D0.W),7(A3)	;effect upper nibble
	MOVE.b	1(a4,D0.W),8(A3)	;effect lower nibble

	lea	4(a6),a6	; this seem to be super-fluid

	TST.B	D5		; check if blankzero switch is set
	BEQ.S	.skp3

	CMP.B	3(A3),D4	; check if high sample nibble is "0"
	BNE.S	.sahini
	MOVE.B	#' ',3(A3)	; blank it
	cmp.b	4(a3),d4
	bne.s	.sahini
	move.b	#"-",4(a3)	; if sample is 00, clear also lower sample nibble
.sahini
;--- now check for empty command
	move.b	6(a3),d1	; check if any command given
	or.b	7(a3),d1        ; this is quite silly, since it checks the
	or.b	8(a3),d1	; output from above! (arghh)
	cmp.b	d4,d1           ; check if it is still "0"
	bne.s	.skp3
	lea	EmptyCmdPlaceHolder,a0
	move.b	(a0)+,5(a3)
	move.b	(a0)+,6(a3)
	move.b	(a0)+,7(a3)
	move.b	(a0)+,8(a3)
				; sample nibble

.skp3	MOVE.W	#9,TextLength
	MOVE.L	A3,ShowTextPtr
	moveq	#0,d1
	bsr	PrintTopaz60
	addq.w	#2,TextOffset
	rts

	cnop	0,4
RedrawBuffer:dc.b '---000000',0

Print2DecDigitsTopaz60:
	push	d1
	MOVE.W	#2,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	DIVU	#10,D1
	BSR.W	DoOneDigit
	BSR.W	DoOneDigit
	lea	NumberText(pc),a0
	move.l	a0,ShowTextPtr
	pop	d1

; d1 - Xpos(0/1)
PrintTopaz60:
	push    d0-d7/a0-a6
	moveq	#0,d0
	move.w	TextLength,d0
	move.l	ShowTextPtr,a0
	lea	TextBpl,a1
	moveq	#0,d2
	move.w	TextOffset,d2
	add.l	d2,a1
	lea	Topaz60Data,a2
	move.l	d0,d7
	move.l	d1,d6
	and.l	#1,d6
	subq.l	#1,d7
	bmi.w	.end
.loop	moveq	#0,d0
	move.b	(a0)+,d0
	beq.w	.end
	sub.b	#" ",d0
	add.l	d0,d0
	lea	(a2,d0.l),a3
	bchg	#0,d6
	bne	.cnt1
	move.b	0*128(a3),0*80(a1)
	move.b	0*128+1(a3),0*80+1(a1)
	move.b	1*128(a3),1*80(a1)
	move.b	1*128+1(a3),1*80+1(a1)
	move.b	2*128(a3),2*80(a1)
	move.b	2*128+1(a3),2*80+1(a1)
	move.b	3*128(a3),3*80(a1)
	move.b	3*128+1(a3),3*80+1(a1)
	move.b	4*128(a3),4*80(a1)
	move.b	4*128+1(a3),4*80+1(a1)
	move.b	5*128(a3),5*80(a1)
	move.b	5*128+1(a3),5*80+1(a1)
	move.b	6*128(a3),6*80(a1)
	move.b	6*128+1(a3),6*80+1(a1)
	move.b	7*128(a3),7*80(a1)
	move.b	7*128+1(a3),7*80+1(a1)
	addq.l	#1,a1
	addq.w	#1,TextOffset
	bra	.cnt2
.cnt1	lea	1024(a3),a3
	move.b	0*128(a3),d0
	or.b	d0,0*80(a1)
	move.b	0*128+1(a3),0*80+1(a1)
	move.b	1*128(a3),d0
	or.b	d0,1*80(a1)
	move.b	1*128+1(a3),1*80+1(a1)
	move.b	2*128(a3),d0
	or.b	d0,2*80(a1)
	move.b	2*128+1(a3),2*80+1(a1)
	move.b	3*128(a3),d0
	or.b	d0,3*80(a1)
	move.b	3*128+1(a3),3*80+1(a1)
	move.b	4*128(a3),d0
	or.b	d0,4*80(a1)
	move.b	4*128+1(a3),4*80+1(a1)
	move.b	5*128(a3),d0
	or.b	d0,5*80(a1)
	move.b	5*128+1(a3),5*80+1(a1)
	move.b	6*128(a3),d0
	or.b	d0,6*80(a1)
	move.b	6*128+1(a3),6*80+1(a1)
	move.b	7*128(a3),d0
	or.b	d0,7*80(a1)
	move.b	7*128+1(a3),7*80+1(a1)
	addq.l	#2,a1
	addq.w	#2,TextOffset
.cnt2	dbf	d7,.loop
.end	pop     d0-d7/a0-a6
	rts

ShowPosition:
	MOVE.L	SongDataPtr(PC),A0		;pointer to moduledata	
	LEA	952(A0),A0			;adress of pos-table
	ADD.L	CurrPos(PC),A0			;get current pattern
	move.b	#0,WordNumber			;clear first byte of the word
	MOVE.B	(A0),WordNumber+1
	MOVE.B	(A0),PattRfshNum+3
	MOVEQ	#0,D1
	MOVE.B	(A0),D1
	CMP.B	LongFFFF+3(PC),D1
	BEQ.S	spskip2
	ST	PattRfsh
spskip2	MOVE.W	#58*80+64/8,TextOffset
	MOVE.B	(A0),LongFFFF+3
	CMP.W	#0,CurrScreen
	BEQ.S	spokok
	cmp.w	#MainScreen_ID,CurrScreen
	BEQ.S	spokok
	RTS
spokok	BSR	Print4DecDigits
	MOVE.W	CurrPos+2,WordNumber
	MOVE.W	#47*80+64/8,TextOffset
	BRA	Print4DecDigits

ShowSongLength:
	cmp.w	#DirScreen_ID,CurrScreen
	BEQ.S	ShowSongName
	cmp.w	#SetupScreen1_ID,CurrScreen
	BEQ.S	ShowSongName
	MOVE.L	SongDataPtr(PC),A0
	LEA	sd_numofpatt(A0),A0
	MOVE.L	A0,CurrCmds
	CLR.W	WordNumber
	MOVE.B	(A0),WordNumber+1
	MOVE.W	#69*80+8,TextOffset
	BSR	Print4DecDigits
	MOVE.L	CurrCmds(PC),A0
ShowSongName:
	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	#25*80+8,D1
	MOVEQ	#20,D0
	BRA	ShowText3

ShowSampleInfo:
	MOVEQ	#0,D0
	MOVE.W	InsNum(PC),D0
	MOVE.W	D0,PlayInsNum
	BNE.S	.skip
	MOVE.W	LastInsNum(PC),D0
.skip	MOVE.W	D0,D1
	LSL.L	#2,D0
	LEA	SamplePtrs(PC),A0
	MOVE.L	0(a0,D0.W),si_pointer
	MOVE.L	SongDataPtr(PC),A0
	LEA	-10(A0),A0
	MOVE.W	D1,D0
	MULU	#INSTR_SIZEOF,D0
	ADD.L	D0,A0
	MOVE.L	A0,CurrCmds             ; remember startadr of sampleinfo
	MOVE.L	22(A0),SampleInfo	; length,finetune,volume
	MOVE.L	26(A0),si_long		; repstart/replen
	TST.B	NoSampleInfo
	BNE	.skip2

	MOVE.L	A0,-(SP)
	MOVE.B	#' ',FineTuneSign
	MOVE.B	INSTR_FINETUNE(A0),D0
	BEQ.S	.cnt
	and.b	#$f,d0	; -maw- Don't forget to mask out higher nibble!
	MOVE.B	#'+',FineTuneSign
	BTST	#3,D0                ; if nibble is negative
	BEQ.S	.cnt
	MOVE.B	#'-',FineTuneSign
	MOVEQ	#16,D1
	SUB.B	D0,D1
	MOVE.B	D1,D0
.cnt	MOVE.W	#113*80+11,TextOffset
	BSR	PrintHexDigit  		; FineTune
	LEA	FineTuneSign(PC),A0
	MOVE.W	#113*80+10,D1
	MOVEQ	#1,D0
	BSR	ShowText3  		; FineTuneSign
	MOVE.L	(SP)+,A0

	CLR.W	WordNumber
	MOVE.B	INSTR_VOLUME(A0),WordNumber+1
	MOVE.W	WordNumber,VolumeEfx
	OR.W	#$0C00,VolumeEfx
	MOVE.W	#102*80+10,TextOffset
	BSR	PrintHexByte  		; Volume

	MOVEQ	#0,D2
	MOVE.W	SampleInfo(PC),D2      ; length
	add.l	d2,d2
	MOVE.L	SamplePos,D3
	CMP.L	D2,D3
	BLS.S	.len
	MOVE.L	D2,SamplePos
	BSR	ShowPos
	MOVEQ	#0,D2
	MOVE.W	SampleInfo(PC),D2
	add.l	D2,D2
.len	move.w	#169,d0
	moveq	#91,d1
	moveq	#6,d3
	BSR	PrintAnyDigits 		; Length

	move.w	#169,d0
	moveq	#102,d1
	moveq	#0,d2
	MOVE.W	si_long,D2
	add.l	D2,D2
	moveq	#6,d3
	BSR	PrintAnyDigits 		; Repeat

	move.w	#169,d0
	moveq	#113,d1
	moveq	#0,d2
	MOVE.W	si_long+2,D2
	ADD.L	D2,D2
	moveq	#6,d3
	BSR	PrintAnyDigits 		; RepLen

	BSR.S	.inst

.skip2	TST.B	NoSampleInfo
	BEQ.S	.skip3
	;cmp.w	#SetupScreen1_ID,CurrScreen
	;BEQ.S	.skip3
	cmp.w	#DirScreen_ID,CurrScreen
	RNE
	MOVE.L	CurrCmds(PC),A0
	MOVE.W	#113*80+5,D1
	MOVEQ	#20,D0
	BRA	ShowText3  		; SampleName

.skip3	MOVE.L	CurrCmds(PC),A0
	MOVE.W	#80*80+10,D1
	MOVEQ	#22,D0
	BRA	ShowText3  		; SampleName

.inst	TST.B	NoSampleInfo
	RNE
	MOVE.W	InsNum(PC),WordNumber
	MOVE.W	#91*80+10,TextOffset
	BRA	PrintHexByte  		; SampleNumber

FineTuneSign:	dc.b ' ',0
VolumeEfx:	dc.w 0

;---- Print Decimal Digits ----
 
Print2DecDigits:
	MOVE.W	#2,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA	pdig

PrintAny2DecDigits:
	MOVE.W	#2,TextLength
	MOVEQ	#3,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA.W	panydig
 
Print3DecDigits:
	MOVE.W	#3,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA.S	pdig100

PrintAny3DecDigits:
	MOVE.W	#3,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA	panydig100

Print4DecDigits:
	MOVE.W	#4,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	DIVU	#1000,D1
	BSR.W	DoOneDigit
pdig100	DIVU	#100,D1
	BSR.W	DoOneDigit
pdig	DIVU	#10,D1
	BSR.W	DoOneDigit
	BSR.W	DoOneDigit
	MOVE.L	#NumberText,A0
	BRA	ShowText2

PrintAny4DecDigits:
	MOVE.W	#4,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	DIVU	#1000,D1
	BSR.W	DoOneDigit
panydig100
	DIVU	#100,D1
	BSR.W	DoOneDigit
panydig	DIVU	#10,D1
	BSR	DoOneDigit
	BSR	DoOneDigit
	MOVE.L	#NumberText,A0
	move.w	AnyTextPos,d0
	move.w	AnyTextPos+2,d1
	move.w	TextLength,d3
	move.w	#$0203,d2
	BRA	ShowAnyText1

Print2DecDigitsExp:
	MOVE.W	#2,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA.S	pdigexp
 
Print3DecDigitsExp:
	MOVE.W	#3,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	BRA.S	pdig100exp

Print4DecDigitsExp:
	MOVE.W	#4,TextLength
	MOVEQ	#0,D1
	MOVE.W	WordNumber(PC),D1
	LEA	NumberText(PC),A0
	DIVU	#1000,D1
	BSR.S	DoOneDigit
pdig100exp:
	DIVU	#100,D1
	BSR.S	DoOneDigit
pdigexp:DIVU	#10,D1
	BSR.S	DoOneDigit
	BSR.S	DoOneDigit
	MOVE.L	#NumberText,A0
	BRA	ShowText2

DoOneDigit:
	ADD.B	#'0',D1
	MOVE.B	D1,(A0)+
	CLR.W	D1
	SWAP	D1
	RTS

Print6DecDigits:
	LEA	NumberText,A0
	MOVE.L	D0,D1
	CMP.L	#1000000,D1
	BHS	toobig

	SWAP	D1
	CLR.W	D1
	SWAP	D1
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,5(A0)
	CMP.L	#10,D0
	BLO.S	p6zero1

	DIVU	#100,D0
	MOVE.L	D0,D1
	CLR.W	D0
	SWAP	D0
	DIVU	#10,D0
	ADD.B	#'0',D0
	MOVE.B	D0,4(A0)
	AND.L	#$FFFF,D1
	BEQ	p6zero2
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,3(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ	p6zero3
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,2(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ.S	p6zero4
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,1(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ.S	p6zero5
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,(A0)
	BRA.S	p6end

p6zero1:MOVE.B	#' ',4(A0)
p6zero2:MOVE.B	#' ',3(A0)
p6zero3:MOVE.B	#' ',2(A0)
p6zero4:MOVE.B	#' ',1(A0)
p6zero5:MOVE.B	#' ',0(A0)
p6end:	MOVE.W	#6,TextLength
	BRA	ShowText2

Print6DecDigitsExp:
	LEA	NumberText,A0
	MOVE.L	D0,D1
	CMP.L	#1000000,D1
	BHS	toobigexp

	SWAP	D1
	CLR.W	D1
	SWAP	D1
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,5(A0)
	CMP.L	#10,D0
	BLO.S	p6zero1exp

	DIVU	#100,D0
	MOVE.L	D0,D1
	CLR.W	D0
	SWAP	D0
	DIVU	#10,D0
	ADD.B	#'0',D0
	MOVE.B	D0,4(A0)
	AND.L	#$FFFF,D1
	BEQ	p6zero2exp
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,3(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ	p6zero3exp
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,2(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ.S	p6zero4exp
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,1(A0)
	CLR.W	D1
	SWAP	D1
	TST.W	D1
	BEQ.S	p6zero5exp
	DIVU	#10,D1
	SWAP	D1
	ADD.B	#'0',D1
	MOVE.B	D1,(A0)
	BRA.S	p6endexp

p6zero1exp:
	MOVE.B	#' ',4(A0)
p6zero2exp:
	MOVE.B	#' ',3(A0)
p6zero3exp:
	MOVE.B	#' ',2(A0)
p6zero4exp:
	MOVE.B	#' ',1(A0)
p6zero5exp:
	MOVE.B	#' ',0(A0)
p6endexp:
	MOVE.W	#6,TextLength
	BRA.W	ShowText2

toobig:	MOVE.B	#' ',D0
	BSR.S	toobig2
	DIVU	#1000,D0
	MOVE.W	D0,WordNumber
	BSR	Print4DecDigits
	MOVE.B	#'K',D0
toobig2:LEA	NumberText(PC),A0
	MOVE.B	D0,(A0)
	MOVE.W	#1,TextLength
	BRA	ShowText2

toobigexp:
	MOVE.B	#' ',D0
	BSR.S	toobig2exp
	DIVU	#1000,D0
	MOVE.W	D0,WordNumber
	BSR.W	Print4DecDigitsExp
	MOVE.B	#'K',D0
toobig2exp:
	LEA	NumberText(PC),A0
	MOVE.B	D0,(A0)
	MOVE.W	#1,TextLength
	BRA.W	ShowText2
	cnop	0,4
AnyTextPos:	dc.w	0,0
NumberText:	dcb.b	6,0

; d0,d1 = x,y,pos, d2= number, d3=digits
PrintAnyDigits:
	lea	.text(pc),a0
	movem.w	d0/d1,-(sp)
	move.l	d2,d0
	move.w	d3,d1
	bsr.s	ConvNum
	movem.w	(sp)+,d0/d1
	bra	ShowAnyText3	; print on text screen
.text	ds.b	12

; d0 = number, d1 = digits, a0= address
ConvNum:movem.l	d0-d4/a0-a1,-(sp)
	moveq	#10,d2
	sub.w	d1,d2
	bmi.s	.end
	lsl.w	#2,d2
	lea	.tab(pc,d2.w),a1
	moveq	#0,d4
.loop1	move.l	(a1)+,d3
	beq.s	.cnt4
	moveq	#"0",d2
.loop2	cmp.l	d3,d0
	blo.s	.cnt1
	sub.l	d3,d0
	addq.b	#1,d2
	bra.s	.loop2
.cnt1	cmp.b	#"0",d2
	bne.s	.cnt2
	tst.w	d4
	bne.s	.cnt2
	moveq	#" ",d2
	bra.s	.cnt3
.cnt2	moveq	#-1,d4
.cnt3	move.b	d2,(a0)+
	bra	.loop1
.cnt4	cmp.b	#" ",-1(a0)
	bne.s	.end
	move.b	#"0",-1(a0)
.end	movem.l	(sp)+,d0-d4/a0-a1
	rts
.tab	dc.l	1000000000
	dc.l	100000000
	dc.l	10000000
	dc.l	1000000
	dc.l	100000
	dc.l	10000
	dc.l	1000
	dc.l	100
	dc.l	10
	dc.l	1
	dc.l	0

AsciiToInteger:
	push    d1-d7/a0-a6
	lea	(a0,d0.w),a1
	lea	.tab(pc),a2
	moveq	#0,d3
.loop	move.b	-1(a1),d1
	cmp.b	#"0",d1
	blo.s	.cnt1
	cmp.b	#"9",d1
	blo.s	.loop1
.cnt1	subq.l	#1,a1
	subq.w	#1,d0
	bne.s	.loop
	bra.s	.end
.loop1	move.b	-(a1),d1
	cmp.b	#"0",d1
	blo.s	.end
	cmp.b	#"9",d1
	bhi.s	.end
	sub.b	#"0",d1
	and.w	#$f,d1
	move.l	(a2)+,d2
	beq.s	.end
.loop2	tst.w	d1
	beq.s	.next
	add.l	d2,d3
	subq.w	#1,d1
	bpl.s	.loop2
.next	subq.w	#1,d0
	bne.s	.loop
.end	move.l	d3,d0
	pop     d1-d7/a0-a6
	rts
.tab	dc.l	1
	dc.l	10
	dc.l	100
	dc.l	1000
	dc.l	10000
	dc.l	100000
	dc.l	1000000
	dc.l	10000000
	dc.l	100000000
	dc.l	1000000000
	dc.l	0

;---- Print Hex Digits ----

PrintHexDigit:
	AND.L	#$0F,D0
	ADD.L	D0,D0
	LEA	FastHexTable+1(PC),A0
	ADD.L	D0,A0
phd2	MOVE.W	#1,TextLength
	BRA.W	ShowText2

PrintAnyHexDigit:			; New feature
	AND.L	#$0F,D3
	ADD.L	D3,D3
	LEA	FastHexTable+1(PC),A0
	ADD.L	D3,A0
	MOVE.W	#1,d3
	BRA.W	ShowAnyText3

BlankInsText:dc.b " ",0

PrintHexWord:
	LEA	WordNumber(PC),A0
	MOVEQ	#0,D0
	MOVE.B	(A0),D0
	LSL.L	#1,D0
	LEA	FastHexTable(PC),A0
	ADD.L	D0,A0
	MOVE.W	#2,TextLength
	BSR.W	ShowText2
PrintHexByte:
	LEA	WordNumber(PC),A0
	MOVEQ	#0,D0
	MOVE.B	1(A0),D0
	LSL.L	#1,D0
	MOVE.L	#FastHexTable,A0
	ADD.L	D0,A0
	MOVE.W	#2,TextLength
	BSR.W	ShowText2
	CLR.W	WordNumber
	RTS	

PrintAnyHexWord:				; New feature
	LEA	WordNumber(PC),A0
	MOVEQ	#0,D3
	MOVE.B	(A0),D3
	LSL.L	#1,D3
	LEA	FastHexTable(PC),A0
	ADD.L	D3,A0
	MOVE.W	#2,d3
	BSR.W	ShowAnyText3
	add.w	#8*2,d0
PrintAnyHexByte:			; New feature
	LEA	WordNumber(PC),A0
	MOVEQ	#0,D3
	MOVE.B	1(A0),D3
	LSL.L	#1,D3
	MOVE.L	#FastHexTable,A0
	ADD.L	D3,A0
	MOVE.W	#2,d3
	BSR.W	ShowAnyText3
	CLR.W	WordNumber
	RTS	

;---- Block Output Routines ----

; ShowAnyBlock(x1,y1,x2,y2,color)(d0,d1,d2,d3,d5)
ShowAnyBlock:					; on first two bitplanes 
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BitPlaneData,a4		; Screen pointer
	moveq	#0,d6
	move.w	#2,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

ShowAnyBlock2:					; on sampler screen
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	move.l	LineScreen,a4		; Screen pointer
	moveq	#0,d6
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

ShowAnyBlock3:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6		; on text bitplane
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	move.l	TextBplPtr(pc),a4	; Screen pointer
	moveq	#0,d6
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

; InvertAnyBlock(x1,y1,x2,y2)(d0,d1,d2,d3)
InvertAnyBlock:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BitPlaneData,a4		; Screen pointer
	move.w	#$35a,d6		; EOR
	move.w	#2,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

InvertAnyBlock2:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BitPlaneData,a4		; Screen pointer
	move.w	#$35a,d6		; EOR
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

InvertAnyBlock3:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BitPlaneData+Res/8*Height,a4	; Screen pointer
	move.w	#$35a,d6		; EOR
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

InvertAnyBlock4:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	move.l	LineScreen,a4		; Screen pointer
	move.w	#$35a,d6		; EOR
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

InvertAnyBlock5:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	move.l	TextBplPtr,a4		; Screen pointer
	move.w	#$35a,d6		; EOR
	move.w	#1,BitPls
	bsr	Block
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

Block:	lea	$dff000,a6
	cmp.w	#Res+1,d0
	bhi	.not
	;cmp.w	#Height+1,d1
	;bhi.w	.not
	moveq	#0,d7
.loop	btst	#6,2(a6)
	bne.b	.loop
	cmp.w	#$35a,d6	; EOR
	beq.s	.con
	move.w	#$30a,d6	; AND
	btst	d7,d5
	beq.s	.con
	move.w	#$3fa,d6	; OR
.con	movem.w	d0-d5,-(a7)
	move.l	a4,a5
	add.w	#$10,d2
	move.w	d6,$40(a6)
	clr.w	$42(a6)
	move.w	d2,d4
	and.w	#$f,d4
	move.w	#-1,d5
	lsr.w	d4,d5
	eor.w	#-1,d5
	move.w	d5,$46(a6)
	move.w	d0,d4
	and.w	#$f,d4
	move.w	#-1,d5
	lsr.w	d4,d5
	move.w	d5,$44(a6)
	sub.w	d1,d3
	mulu	#Res/8,d1
	add.l	d1,a5
	add.w	d4,d2
	sub.w	d0,d2
	lsr.w	#3,d0
	and.w	#-2,d0
	ext.l	d0
	add.l	d0,a5
	lsr.w	#3,d2
	and.w	#-2,d2
	move.w	#Res/8,d4
	neg.w	d2
	add.w	d2,d4
	move.w	d4,$60(a6)
	move.w	d2,$64(a6)
	move.w	d4,$66(a6)
	neg.w	d2
	move.l	a5,$48(a6)
	move.w	#-1,$74(a6)
	move.l	a5,$54(a6)
	lsl.w	#6,d3
	lsr.w	#1,d2
	add.w	d2,d3
	move.w	d3,$58(a6)
	movem.w	(a7)+,d0-d5
	add.l	#Res/8*Height,a4
	addq.w	#1,d7
	cmp.w	BitPls(pc),d7			; Two blitplanes
	bmi.w	.loop
.not	btst	#6,2(a6)
	bne.b	.not
	rts
	cnop	0,4
BitPls:	dc.w	1

;---- Text Output Routines ----

ShowText3:
	MOVE.W	D0,TextLength
	MOVE.W	D1,TextOffset
ShowText2:
	MOVE.L	A0,ShowTextPtr
ShowText:
	MOVEM.L	A2-A4,-(SP)
	LEA	TextTable(PC),A3
	LEA	FontData,A4
	MOVE.W	TextLength(PC),D0
	MOVE.L	TextBplPtr(PC),A1
	moveq	#0,d1			;beware of the word boundary!!
	MOVE.W	TextOffset(PC),D1
	LEA	0(a1,D1.l),A1
	ADD.W	D0,TextOffset
	MOVE.L	ShowTextPtr(PC),A0
	BRA.S	.lope
.loop	MOVEQ	#0,D1
	MOVE.B	(A0)+,D1
	BNE.S	.skip
	MOVE.B	ShowZeroFlag(PC),D1
.skip	MOVE.B	0(a3,D1.W),D1
	LSL.W	#3,D1
	MOVE.L	A4,A2
	ADD.L	D1,A2
	MOVE.B	(A2)+,(A1)+
	MOVE.B	(A2)+,80-1(A1)
	MOVE.B	(A2)+,160-1(A1)
	MOVE.B	(A2)+,240-1(A1)
	MOVE.B	(A2),320-1(A1)
.lope	DBRA	D0,.loop
	MOVEM.L	(SP)+,A2-A4
	RTS

SpaceShowText:
	MOVE.W	ShowZeroFlag(PC),-(SP)
	MOVE.B	#' ',ShowZeroFlag
	BSR.W	ShowText
	MOVE.W	(SP)+,ShowZeroFlag
	RTS	

;ShowAnyText(Xpos,Ypos,Colors,Length,Text Ptr)(d0,d1,d2,d3,a0)

ShowAnyText1:				; With background
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BconTab1(pc),a1
	lea	BitPlaneData,a4		; Screen pointer
	moveq	#2-1,d7			; 2 Bitplanes
	bsr	ShowAnyTextRoutine
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

ShowAnyText2:				; Whithout background
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BconTab2(pc),a1
	lea	BitPlaneData,a4		; Screen pointer
	moveq	#2-1,d7			; 2 Bitplanes
	bsr	ShowAnyTextRoutine
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

ShowAnyText3:				; On textscreen
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BconTab1(pc),a1
	move.l	TextBplPtr,a4		; Screen pointer
	moveq	#1,d2
	moveq	#1-1,d7			; 1 Bitplane
	bsr	ShowAnyTextRoutine
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;ShowColorText(Xpos,Ypos,Length,Text Ptr)(d0,d1,d3,a0)
ShowColorText:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	GfxBase,a6
	jsr	LVOOwnBlitter(a6)
	jsr	LVOWaitBlit(a6)
	lea	BitPlaneData,a4		; Screen pointer
	moveq	#2-1,d7			; 2 Bitplanes
	bsr	ShowAnyTextRoutine2
	move.l	GfxBase,a6
	jsr	LVODisownBlitter(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;ShowColorText2(Xpos,Ypos,Text Ptr)(d0,d1,a0)
ShowColorText2:
	movem.l	d0-d7/a0-a1,-(sp)
	move.l	a0,a1
	moveq	#-1,d3
.loop	addq.l	#1,d3
	tst.b	(a0)+
	bne.s	.loop
	;move.l	a0,d4
	;addq.l	#1,d4
	;and.l	#-2,d4
	;move.l	d4,a0
	;move.l	a0,d5
	move.l	a1,a0
	bsr	ShowColorText
	move.l	d5,a0
	movem.l	(sp)+,d0-d7/a0-a1
	rts

ShowAnyTextRoutine:		; Plain color text (width/without background)
	lea	$dff000,a6
	lea	TextTable(pc),a5
	move.w	d2,FntColor
	mulu	#Res/8,d1
	lea	(a4,d1.l),a4
	;cmp.w	#Res/8,d3
	;bhi.w	.endtxt
	move.w	d3,d6
	subq.w	#1,d6
	bmi.w	.endtxt

	move.w	#-4,$62(a6)
	move.w	#$60-4,$64(a6)
	move.w	#Res/8-4,$60(a6)
	move.w	#Res/8-4,$66(a6)
	move.l	#CharMask,$4c(a6)
.txtlop	moveq	#0,d2
	move.b	(a0)+,d2
	bne.b	.nozero
	MOVE.B	ShowZeroFlag(PC),D2
.nozero	move.w	d0,d5
	add.w	#8,d0			; Font Width 
	move.l	a4,a3
	move.b	(a5,d2.w),d2
	cmp.w	#$a0,d2
	blo.s	.chrcn0
	sub.w	#$20,d2
.chrcn0	lea	SingColorFont,a2	; Fontadr in chip mem 
	lea	(a2,d2.w),a2
	move.l	#$ff000000,d4		; Font width mask
	and.w	#1,d2
	beq.s	.chrcn1
	sub.w	#8,d5
	lsr.l	#8,d4
.chrcn1	move.w	d5,d1
	and.w	#$f,d1
	ror.w	#4,d1
	asr.w	#3,d5
	lea	(a3,d5.w),a3
	move.b	FntColor(pc),d2
	move.b	FntColor+1(pc),d3
.wait	btst	#6,2(a6)
	bne.s	.wait
	move.l	d4,CharMask
	move.l	d4,$44(a6)
	move.w	d1,$42(a6)
	or.w	#$f00,d1
	move.w	d7,d4
.chrlop	btst	#6,2(a6)
	bne.s	.chrlop
	moveq	#0,d5
	roxr.b	#1,d2
	roxl.b	#1,d5
	roxr.b	#1,d3
	roxl.b	#1,d5
	move.b	(a1,d5),d1
	move.w	d1,$40(a6)
	move.l	a3,$48(a6)
	move.l	a2,$50(a6)
	move.l	a3,$54(a6)
	move.w	#5*$40+2,$58(a6)	; 5 in height
	lea	Res/8*Height(a3),a3
	dbf	d4,.chrlop
	dbf	d6,.txtlop
.endtxt	btst	#6,2(a6)
	bne.s	.endtxt
	rts
	cnop	0,4
FntColor:dc.w	0
BconTab1:dc.l	$02c20ece
BconTab2:dc.l	$0aca0aca

ShowAnyTextRoutine2:		; Multicolor text
	lea	$dff000,a6
	lea	TextTable(pc),a5
	move.w	d0,TextLeftEdge
	mulu	#Res/8,d1
	lea	(a4,d1.l),a4
	;cmp.w	#Res/8,d3
	;bhi	.endtxt
	move.w	d3,d6
	subq.w	#1,d6
	bmi	.endtxt

	move.w	#-4,$62(a6)
	move.w	#$60-4,$64(a6)
	move.w	#Res/8-4,$60(a6)
	move.w	#Res/8-4,$66(a6)
	move.l	#CharMask,$4c(a6)
.txtlop	moveq	#0,d2
	move.b	(a0)+,d2
	bne.b	.nozero
	MOVE.B	ShowZeroFlag(PC),D2
.nozero	cmp.w	#10,d2
	bne.s	.cnt1
	move.w	TextLeftEdge(pc),d0
	lea	7*80(a4),a4
	dbf	d6,.txtlop
	bra	.endtxt
.cnt1	move.w	d0,d5
	move.l	a4,a3
	cmp.w	#$a0,d2
	blo.s	.chrcn2
	sub.w	#$20,d2
.chrcn2	move.b	(a5,d2.w),d2
	addq.w	#7,d0
	lea	MultiColorFont,a2	; Fontadr in chip mem 
	lea	(a2,d2.w),a2
	move.l	#$fe000000,d4		; Font width mask
	and.w	#1,d2
	beq.s	.chrcn3
	sub.w	#8,d5
	lsr.l	#8,d4
.chrcn3	move.w	d5,d1
	and.w	#$f,d1
	ror.w	#4,d1
	asr.w	#3,d5
	lea	(a3,d5.w),a3
.wait	btst	#6,2(a6)
	bne.s	.wait
	move.l	d4,CharMask
	move.l	d4,$44(a6)
	move.w	d1,$42(a6)
	or.w	#$fc2,d1
	move.w	d1,$40(a6)
	move.w	d7,d4
.chrlop	btst	#6,2(a6)
	bne.s	.chrlop
	move.l	a3,$48(a6)
	move.l	a2,$50(a6)
	move.l	a3,$54(a6)
	move.w	#6*$40+2,$58(a6)	; 6 in height
	lea	$60*6(a2),a2		; -----""-----
	lea	Res/8*Height(a3),a3
	dbf	d4,.chrlop
	dbf	d6,.txtlop
.endtxt	btst	#6,2(a6)
	bne.s	.endtxt
	rts
	cnop	0,4
TextLeftEdge:dc.w	0
ShowZeroFlag:dc.b	'_',0

TextTable:
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 0
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.b 00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15 ; 32
	dc.b 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
	dc.b 32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47 ; 64
	dc.b 48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63
	dc.b 64,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47 ; 96
	dc.b 48,49,50,51,52,53,54,55,56,57,58,65,66,67,68,63
	dc.b 69,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 128
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.b 0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 160
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 192
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 224
	dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


;---- Set Sprite Position ----

SetSpritePos:
	ADD.W	SprUpper(pc),D1
	ADD.W	D1,D2
	ROL.W	#7,D2
	ASL.W	#1,D2
	BCC.S	.skip
	OR.W	#2,D2
.skip	ROL.W	#7,D1
	ASL.W	#1,D1
	BCC.S	.skip2
	OR.W	#4,D2
.skip2	ADD.W	SprLeft(pc),D0
	ASR.W	#1,D0
	BCC.S	.skip3
	OR.W	#1,D2
.skip3	OR.W	D0,D1
	MOVE.W	D1,(A0)
	MOVE.W	D2,2(A0)
	RTS	
	cnop	0,4
SprUpper:dc.w	$2c
SprLeft:dc.w	$7d

;---- Set Sprite Dragbar ----

;(Xpos,Ypos,Length)(d0,d1,d2)

SetSpriteDragBar2:
	move.l	#$0800f000,d4
	move.l	#$78008800,d5
	move.l	#$f8007800,d6
	bra.s	sprdrag2
SetSpriteDragBar:
	move.l	#$f800f000,d4
	move.l	#$f0008800,d5
	move.l	#$80007800,d6
sprdrag2:
	cmp.w	#dirdragmaxlen,d2
	bmi.b	.bar1
	moveq	#dirdragmaxlen,d2
.bar1	cmp.w	#4,d2
	bpl.b	.bar2
	moveq	#4,d2
.bar2	move.l	CursorPosPtr,a0
	move.l	(a0),CursorSpriteData
	lea	DragBarSpriteData,a0
	lea	4(a0),a0
	move.l	d4,(a0)+
	move.w	d2,d3
	sub.w	#3,d3
.barlop	move.l	d5,(a0)+
	dbf	d3,.barlop
	move.l	d6,(a0)+
	move.l	a0,CursorPosPtr
	lea	CursorSpriteData,a1
	moveq	#CursorSpriteLen-1,d3
.brlop2	move.b	(a1)+,(a0)+
	dbf	d3,.brlop2

	lea	DragBarSpriteData,a0
	bra	SetSpritePos

;---- DoLoad / DoSave Data ----

DoLoadData:
	TST.L	DiskDataLength
	BEQ.s	.end
	TST.L	DiskDataPtr
	BEQ.S	.end
	JSR	SetDiskPtrCol
	LEA	LoadingText(PC),A0
	BSR	ShowStatusText
	MOVE.L	DosBase,A6
	MOVE.L	FileNamePtr(PC),D1
	MOVE.L	#1005,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,FileHandle
	BEQ.S	CantOpenFile
	MOVE.L	FileHandle(PC),D1
	MOVE.L	DiskDataPtr(PC),D2
	MOVE.L	DiskDataLength(PC),D3
	JSR	LVORead(A6)
	MOVE.L	FileHandle(PC),D1
	JSR	LVOClose(A6)
.end	CLR.L	FileHandle
	JSR	SetNormalPtrCol
 	MOVEQ	#-1,D0
	RTS

CantOpenFile:
	LEA	CantOpenFileText(PC),A0
caopfil	BSR	ShowStatusText
	JSR	SetErrorPtrCol
 	MOVEQ	#0,D0
	RTS

CantSaveFile:
	LEA	CantSaveFileText(PC),A0
	BRA.S	caopfil
CantExamFile:
	LEA	CantExamFileText(PC),A0
	BRA.S	caopfil
CantFindFile:
	LEA	CantFindFileText(PC),A0
	BRA.S	caopfil
FileIsEmpty:
	LEA	FileIsEmptyText(PC),A0
	BRA.S	caopfil

CantOpenFileText:	dc.b "can't open file !",0
CantSaveFileText:	dc.b "can't save file !",0
CantExamFileText:	dc.b "examine error !",0
CantFindFileText:	dc.b "can't find file !",0
FileIsEmptyText:	dc.b "file is empty !",0

DoSaveData:
	JSR	SetDiskPtrCol
	LEA	SavingText(PC),A0
	BSR	ShowStatusText
	MOVE.L	DosBase,A6
	MOVE.L	FileNamePtr(PC),D1
	MOVE.L	#1006,D2
	JSR	LVOOpen(A6)
	MOVE.L	D0,FileHandle
	BEQ	CantOpenFile
	MOVE.L	FileHandle(PC),D1
	MOVE.L	DiskDataPtr(PC),D2
	MOVE.L	DiskDataLength(PC),D3
	JSR	LVOWrite(A6)
	MOVE.L	FileHandle(PC),D1
	JSR	LVOClose(A6)
	CLR.L	FileHandle
	JMP	SetNormalPtrCol

HexToInteger:
	MOVEQ	#0,D0
	BSR	Single_hti
	LSL.W	#8,D1
	LSL.W	#4,D1
	OR.W	D1,D0
	BSR	Single_hti
	LSL.W	#8,D1
	OR.W	D1,D0
HexToInteger2:
	BSR	Single_hti
	LSL.W	#4,D1
	OR.W	D1,D0
	BSR	Single_hti
	OR.W	D1,D0
	RTS

Single_hti:
	MOVEQ	#0,D1
	MOVE.B	(A0)+,D1
	CMP.B	#$60,D1
	BLO.s	.skip
	SUB.B	#$20,D1
.skip	SUB.B	#$30,D1
	CMP.B	#9,D1
	RLS
	SUBQ.B	#7,D1
	RTS

IntToDecASCII:
	MOVEQ	#3,D3
	MOVE.L	#1000,D2
.loop	EXT.L	D0
	DIVU	D2,D0
	ADD.B	#'0',D0
	MOVE.B	D0,(A0)+
	DIVU	#10,D2
	SWAP	D0
	DBRA	D3,.loop
	RTS

IntToHex2:
	MOVEQ	#1,D2
	BRA	ithaloop

IntToHexASCII:
	MOVEQ	#3,D2
ithaloop:
	MOVE.W	D0,D1
	AND.B	#15,D1
	CMP.B	#10,D1
	BLO.s	.skip
	ADDQ.B	#7,D1
.skip	ADD.B	#'0',D1
	MOVE.B	D1,-(A0)
	ROR.W	#4,D0
	DBRA	D2,ithaloop
	RTS

;---- Sampler Screen ----

SamplerScreen:
	jsr	ClearKeyBuf
	JSR	WaitForButtonUp
	jsr	ClearPatBlock
	TST.W	SamScrEnable
	BNE	ExitFromSam
	MOVE.W	#1,SamScrEnable
	clr.b	PattBarSpriteData+1
	MOVE.L	EditMode(PC),SaveEditMode
	CLR.L	EditMode

	MOVEQ	#0,D0
	MOVE.W	#270,D1
	MOVEQ	#14,D2
	move.l	CursorPosPtr,A0
	BSR	SetSpritePos
	JSR	SetSamSpritePtrs
	MOVE.W	CopCol0+16,CopList2+_SMPCOL
	BSR	MakeSampleScreen
	BNE	exisam2
	BSR	SwapCopLists
	JSR	SetScreenPosition
	BSR	ClearSamScr
	JSR	DoShowFreeMem
	jsr	ShowPNote
	BSR	ShowSamNote
	BSR	ShowResamNote
	BRA	RedrawSample

ExitFromSam:
	JSR	WaitForButtonUp
	BSR	SwapCopLists
	BSR	RemoveSampleScreen
exisam2:JSR	SetDefSpritePtrs
	CLR.B	RawKeyCode
	CLR.W	SamScrEnable
	move.b	#$da,PattBarSpriteData
	MOVEQ	#-1,D0
	MOVE.L	D0,MarkStartOfs
	MOVE.L	SaveEditMode(PC),EditMode
	JSR	SetScreenColors2
	JSR	SetupVUCols
	JSR	SetScrPatternPos
	JSR	SetScreenPosition
	BSR	ClearSamScr
	JSR	UpdateCursorPos
	JSR	SetTempo
	BRA	RedrawPattern

MakeSampleScreen:
	LEA	SampScreenData,A0
	lea	LowerBuffer,a1
	JSR	DePackIt
	RNE
RemoveSampleScreen:
	LEA	BitPlaneData+138*Res/8,A0
	lea	LowerBuffer,a1
	MOVEQ	#2-1,D2
.loop1	MOVE.W	#118*80/4-1,D0
.loop2	MOVE.L	(A0),D1
	MOVE.L	(A1),(A0)+
	MOVE.L	D1,(A1)+
	DBRA	D0,.loop2
	LEA	(256-118)*80(A0),A0		;next bitplane, please
	DBRA	D2,.loop1
	moveq	#0,d0
	RTS

SwapCopLists:
	LEA	CopListInsPos,A0
	LEA	CopList2,A1
.loop	MOVE.W	(A0),D0
	MOVE.W	(A1),(A0)+
	MOVE.W	D0,(A1)+
	cmp.l	#CopList2End,a1
	bmi.s	.loop
	MOVEQ	#-1,D0
	RTS

ClearSamScr:
	MOVE.W	#117*80/4-1,D0
	MOVE.L	TextBplPtr,A0
	LEA	139*80(A0),A0
	MOVE.L	A0,LineScreen
	MOVEQ	#0,D1
.loop	MOVE.L	D1,(A0)+
	DBRA	D0,.loop
	RTS

blnktxt:dc.b "    "

ClearSamArea:
	MOVE.W	#2*64*10-1,D0
	MOVE.L	TextBplPtr,A0
	LEA	139*80(A0),A0
	MOVE.L	A0,LineScreen
	MOVEQ	#0,D1
.loop	MOVE.L	D1,(A0)+
	DBRA	D0,.loop
	RTS

ClearSamArea2:
	moveq	#0,d0
	moveq	#0,d1
	move.w	#640,d2
	moveq	#64,d3
	moveq	#0,d5
	BRA	ShowAnyBlock2

CheckSamGadgets:
	MOVEM.W	MouseX2,D0/D1
	lea	SamplerGadgetsList,a0
	jsr	GetGadget
	tst.w	d2
	beq.w	NoSamGadg
	cmp.w	#1,d2			;Exit?
	beq.w	ExitFromSam
	cmp.w	#2,d2			;SampleWindow?
	beq.w	SamplePressed
	cmp.w	#3,d2			;DragBar?
	beq.w	SamDragBar
	cmp.w	#4,d2			;Play Waveform?
	beq.w	PlayWaveform
	cmp.w	#5,d2			;Show range?
	beq.w	ShowRange
	cmp.w	#6,d2			;Zoom Out?
	beq.w	ZoomOut
	cmp.w	#7,d2			;Disp?
	beq.w	DispBox
;	cmp.w	#8,d2			;Seek Zero?
;	beq.w	SeekZero
;	cmp.w	#9,d2			;Power Spectrum?
;	beq.w	PowerSpectrum
	cmp.w	#10,d2			;Stop?
	beq.w	StopPlaying
	cmp.w	#11,d2			;Display?
	beq.w	PlayDisplay
	cmp.w	#12,d2			;Show All?
	beq.w	ShowAll
	cmp.w	#13,d2			;Range All?
	beq.w	RangeAll
	cmp.w	#14,d2			;Loop?
	beq.w	LoopToggle
	cmp.w	#16,d2			;Range?
	beq.w	PlayRange
	cmp.w	#17,d2			;Beg?
	beq.w	CurToStart
	cmp.w	#18,d2			;End?
	beq.w	CurToEnd
	cmp.w	#19,d2			;Swap Buffer?
	beq.w	SwapBuffer
	cmp.w	#20,d2			;Sample?
	beq.w	Sampler
	cmp.w	#21,d2			;Note?
	beq.w	SetSamNote
	cmp.w	#23,d2			;Cut?
	beq.w	SamCut
	cmp.w	#24,d2			;Copy?
	beq.w	SamCopy
	cmp.w	#25,d2			;Paste?
	beq.w	SamPaste
	cmp.w	#26,d2			;Volume?
	beq.w	RampVolume
	cmp.w	#27,d2			;Tunetone?
	beq.w	TuningTone
	cmp.w	#28,d2			;Resample?
	beq.w	Resample
	cmp.w	#29,d2			;Note?
	beq.w	SetResamNote

	MOVE.L	SongDataPtr,A5
	LEA	-10(A5),A5
	MOVE.W	InsNum,D0
	BNE.S	.skip
	MOVE.W	LastInsNum,D0
.skip	MULU	#30,D0
	ADD.L	D0,A5

	cmp.w	#34,d2
	beq	InvertSample
	cmp.w	#35,d2
	beq	MaximizeSample
	cmp.w	#36,d2
	beq	NormalizeSample
	cmp.w	#37,d2
	beq	NormalDCSample
	cmp.w	#38,d2
	beq	Backwards
	cmp.w	#39,d2
	beq	Boost
	cmp.w	#40,d2
	beq	Filter
	cmp.w	#41,d2
	beq	UpSample
	cmp.w	#42,d2
	beq	DownSample
NoSamGadg:
	RTS

PlayWaveform:
	JSR	PlayNote
	JMP	WaitForButtonUp
PlayDisplay:
	LEA	SampleInfo,A0		; we use sampleInfo to export the current values
	MOVE.L	SamOffset(PC),StartOfs
	MOVE.L	SamDisplay(PC),D0
	LSR.L	#1,D0
	MOVE.W	D0,(A0)
	CLR.W	4(A0)
	MOVE.W	#1,6(A0)
	MOVE.W	PlayInsNum,-(SP)
	CLR.W	PlayInsNum
	JSR	PlayNote
	MOVE.W	(SP)+,PlayInsNum
	BSR	ShowSampleInfo
	JMP	WaitForButtonUp
PlayRange:
	MOVE.L	MarkStartOfs(PC),D1
	BMI	NoRangeError
	MOVE.L	MarkEndOfs(PC),D0
	CMP.L	D0,D1
	BEQ	LargerRangeError
	LEA	SampleInfo,A0
	MOVE.L	D1,StartOfs
	SUB.L	D1,D0
	LSR.L	#1,D0
	MOVE.W	D0,(A0)          ; hmm, 0(a0) = ? length, maybe?
	CLR.W	4(A0)            ;              ? loop length ?
	MOVE.W	#1,6(A0)                        ?
	MOVE.W	PlayInsNum,-(SP)
	CLR.W	PlayInsNum
	JSR	PlayNote
	MOVE.W	(SP)+,PlayInsNum
	BSR	ShowSampleInfo
	JMP	WaitForButtonUp
StopPlaying:
	BRA	TurnOffVoices

	cnop	0,4
StartOfs:dc.l	0

;----

ShowRange:
	MOVE.L	MarkStartOfs(PC),D0
	BMI	NoRangeError
	MOVE.L	MarkEndOfs(PC),D1
	CMP.L	D1,D0
	BEQ	LargerRangeError
	SUB.L	D0,D1
	BNE.s	.cnt
	MOVEQ	#1,D1
.cnt	MOVE.L	D1,SamDisplay
	MOVE.L	D0,SamOffset
	MOVEQ	#-1,D0
	MOVE.L	D0,MarkStartOfs
	CLR.W	MarkStart
	BSR	DisplaySample
	JMP	WaitForButtonUp

ZoomOut:MOVE.L	SamDisplay(PC),D0
	MOVE.L	SamLength(PC),D1
	MOVE.L	SamOffset(PC),D2
	MOVE.L	D0,D3
	LSL.L	#1,D3
	CMP.L	D1,D3
	BHI	ShowAll
	LSR.L	#1,D0
	CMP.L	D2,D0
	BLO.s	.zoom2
	MOVEQ	#0,D0
.zoom2	SUB.L	D0,D2
	MOVE.L	D2,D0
	ADD.L	D3,D0
	CMP.L	D1,D0
	BLS.s	.zoom3
	SUB.L	D3,D1
	MOVE.L	D1,D2
.zoom3	MOVE.L	D2,SamOffset
	MOVE.L	D3,SamDisplay
	BSR	OffsetToMark
	MOVE.L	MarkStartOfs(PC),D0
	CMP.L	MarkEndOfs(PC),D0
	BNE.s	.zoom
	MOVEQ	#-1,D0
	MOVE.L	D0,MarkStartOfs
.zoom	BSR	DisplaySample
	JMP	WaitForButtonUp

ShowAll:CLR.L	SamOffset
	MOVE.L	SamLength(PC),SamDisplay
	BSR	OffsetToMark
	MOVE.L	MarkStartOfs(PC),D0
	CMP.L	MarkEndOfs(PC),D0
	BNE.s	.cnt
	MOVEQ	#-1,D0
	MOVE.L	D0,MarkStartOfs
	CLR.W	MarkStart
.cnt	BSR	DisplaySample
	JMP	WaitForButtonUp

RangeAll:
	BSR	InvertRange
	MOVE.W	#3,MarkStart
	MOVE.W	#636,MarkEnd
	BSR	MarkToOffset
ranall2:BSR	InvertRange
	JMP	WaitForButtonUp

CurToStart:
	BSR	InvertRange
	MOVEQ	#3,D0
	MOVE.W	D0,MarkStart
	MOVE.W	D0,MarkEnd
	MOVE.L	SamOffset(PC),D0
	MOVE.L	D0,MarkStartOfs
	MOVE.L	D0,MarkEndOfs
	BRA.S	ranall2

CurToEnd:
	BSR	InvertRange
	MOVE.W	#636,D0
	MOVE.W	D0,MarkStart
	MOVE.W	D0,MarkEnd
	MOVE.L	SamOffset(PC),D0
	ADD.L	SamDisplay(PC),D0
	MOVE.L	D0,MarkStartOfs
	MOVE.L	D0,MarkEndOfs
	BRA.S	ranall2

SwapBuffer:
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	LSL.W	#2,D1
	LEA	SamplePtrs,A0
	LEA	0(a0,D1.W),A0

	MOVE.L	CopyBufPtr(PC),D0
	MOVE.L	(A0),CopyBufPtr
	MOVE.L	D0,(A0)
	MOVE.L	D0,A1
	CLR.W	(A1)

	MOVE.L	CopyBufSize(PC),D0
	MOVE.L	SAMPLE_LENGTHS(A0),CopyBufSize
	MOVE.L	D0,SAMPLE_LENGTHS(A0)

	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	LEA	12(A0,D1.W),A0
	LSR.L	#1,D0
	MOVE.W	D0,(A0)
	MOVE.L	RepBuf(PC),D0
	MOVE.L	4(A0),RepBuf
	MOVE.L	D0,4(A0)

	MOVE.W	RepBuf2(PC),D0
	MOVE.W	2(A0),RepBuf2
	TST.B	D0
	BNE.S	.swap2
	MOVE.B	#$40,D0
.swap2	MOVE.W	D0,2(A0)
	JSR	TurnOffVoices
	BSR	ValidateLoops
	BSR	ShowSampleInfo
	JSR	UpdateRepeats
	BSR	RedrawSample
	JMP	WaitForButtonUp

	cnop	0,4
RepBuf:	dc.l	1
RepBuf2:dc.w	$0040

;----

NoRangeError:
	LEA	NoRangeText(PC),A0
nres2:	BSR	ShowStatusText
	JMP	SetErrorPtrCol

LargerRangeError:
	LEA	LargerRangeText(PC),A0
	BRA.S	nres2

SetCursorError:
	LEA	SetCursorText(PC),A0
	BRA.S	nres2

BufIsEmptyError:
	LEA	BufIsEmptyText(PC),A0
	BRA.S	nres2

EmptySampleError:
	LEA	EmptySampleText(PC),A0
	BRA.S	nres2

NoRangeText:	dc.b "no range selected",0
LargerRangeText:dc.b "set larger range",0
SetCursorText:	dc.b "set cursor pos",0
BufIsEmptyText:	dc.b "buffer is empty",0
EmptySampleText:dc.b "sample is empty",0

;----

DispBox:RTS

LoopToggle:
	JSR	WaitForButtonUp
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	MOVE.L	SongDataPtr(PC),A0
	MULU	#30,D1
	LEA	12(A0,D1.W),A0
	TST.W	LoopOnOffFlag
	BEQ.S	.lton
	MOVE.L	4(A0),SavSamInf	
	MOVEQ	#1,D0
	MOVE.L	D0,4(A0)
	JSR	TurnOffVoices
.ltlo	BSR	ShowSampleInfo
	JSR	UpdateRepeats
	BRA	DisplaySample
.lton	MOVE.L	SavSamInf(PC),D0
	BNE.S	.lto2
	MOVE.W	(A0),D0
.lto2	MOVE.L	D0,4(A0)
	BRA	.ltlo

ShowLoopToggle:
	LEA	ToggleOFFText,A0
	TST.W	LoopOnOffFlag
	BEQ.S	.skip
	LEA	ToggleONText,A0
.skip	MOVEQ	#3,D0
	MOVE.W	#226*80+46,D1
	BRA	ShowText3

	cnop	0,4
LoopOnOffFlag:	dc.w 0
SavSamInf:	dc.l 0

SetSamNote:
	BSR	ShowResamNote
	MOVE.W	#237*80+46,TextOffset
	MOVE.W	#3,TextLength
	MOVE.L	#SpcNoteText,ShowTextPtr
	BSR	ShowText
	MOVE.W	#1,SamNoteType
	MOVE.L	#SampleNote,SplitAddress
	JMP	WaitForButtonUp

SetResamNote:
	BSR	ShowSamNote
	MOVE.W	#248*80+46,TextOffset
	MOVE.W	#3,TextLength
	MOVE.L	#SpcNoteText,ShowTextPtr
	BSR	ShowText
	MOVE.W	#2,SamNoteType
	MOVE.L	#ResampleNote,SplitAddress
	JMP	WaitForButtonUp

ResampleText:	dc.b 10,10,"     Resample?",0
ResamplingText:	dc.b "Resampling...",0
	cnop	0,2

Resample:
	LEA	ResampleText(PC),A0
	JSR	AreYouSure
	RNE
	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	LEA	ResamplingText(PC),A0
	BSR	ShowStatusText
	LEA	SamplePtrs,A0
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVE.L	(A0),D0
	BEQ	.erc2
	MOVE.L	D0,A2
	MOVE.L	SAMPLE_LENGTHS(A0),D6
	CMP.L	#2,D6
	BLS	.erc2

	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	MOVEQ	#0,D0
	MOVE.B	12+2(A0,D1.W),D0 	; finetune
	and.b	#$f,d0	; -maw- Don't forget to mask out higher nibble!
	MULU	#FINETUNETABLE_SIZE,D0
	LEA	PeriodTable(PC),A0
	ADD.L	D0,A0
	MOVEQ	#0,D1
	MOVE.W	ResampleNote(PC),D1
	LSL.W	#1,D1
	MOVE.W	0(a0,D1.W),D1
	BEQ	.erc2

	LEA	PeriodTable,A0
	MOVEQ	#0,D5
	MOVE.W	TuneNote,D5
	LSL.W	#1,D5
	MOVE.W	0(a0,D5.W),D5
	BEQ	.erc2

; D1=resamperiod, D5=tuneperiod

	MOVE.L	D5,D0 			; tune
	LSL.L	#8,D0
	LSL.L	#4,D0 			; * 4096
	DIVU	D1,D0 			; / resample
	MOVEQ	#0,D4
	MOVE.W	D0,D4
	LSL.L	#4,D4 			; hi-word=add value, lo-word=fraction

	MOVE.W	D6,D7
	LSR.W	#1,D7
	MULU	D1,D7
	DIVU	D5,D7
	AND.L	#$7FFF,D7	; 128k
	CMP.L	#2,D7
	BLO	.erc2
	CMP.L	#$7FFF,D7	; 128k
	BLO.s	.low
	MOVE.L	#$7FFF,D7	; 128k
.low	ADD.L	D7,D7
	MOVE.L	D7,D0
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	TST.L	D0
	BEQ	SamMemError
	MOVE.L	D0,A1
	MOVE.L	D0,A3
	JSR	TurnOffVoices
	MOVE.L	A2,A0

; D4=resample value, D6=old length, D7=new length
; A0/A2=old sample, A1/A3=new sample

	MOVE.W	#32767,D1
	MOVEQ	#0,D3
	MOVEQ	#0,D5
.rsloop	MOVE.B	1(A0),D0
	EXT.W	D0
	MULS	D1,D0
	MOVE.B	(A0),D2
	EXT.W	D2
	MULS	D3,D2
	ADD.L	D2,D0
	ASR.L	#8,D0
	ASR.L	#7,D0
	MOVE.B	D0,(A1)+

	ADD.L	D4,D5
	SWAP	D5
	MOVE.L	A2,A0
	MOVEQ	#0,D0
	MOVE.W	D5,D0
	ADD.L	D0,A0
	SWAP	D5
	MOVE.W	D5,D1
	LSR.W	#1,D1
	MOVE.W	#32767,D3	; ?
	SUB.W	D1,D3

	MOVE.L	A1,A4
	SUB.L	A3,A4
	CMP.L	D7,A4
	BHS.S	.rsskip
	MOVE.L	A0,A4
	SUB.L	A2,A4
	CMP.L	D6,A4
	BLO.S	.rsloop

.rsskip	MOVE.L	A2,A1
	MOVE.L	D6,D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	MOVE.W	InsNum(PC),D1
	LSL.W	#2,D1
	LEA	SamplePtrs,A0
	LEA	0(a0,D1.W),A0
	MOVE.L	A3,(A0)
	MOVE.L	D7,SAMPLE_LENGTHS(A0)

	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	LEA	12(A0,D1.W),A0
	LSR.L	#1,D7
	MOVE.W	D7,(A0)
	CLR.B	2(A0)
	CLR.W	4(A0)
	MOVE.W	#1,6(A0)
	JSR	RestorePtrCol
	BSR	ClearSamStarts
	BSR	ShowSampleInfo
	BSR	ShowAllRight
	BRA	RedrawSample

.erc2	JMP	ErrorRestoreCol

SamCut:	CLR.B	RawKeyCode
	MOVE.L	MarkStartOfs(PC),D0
	BMI	NoRangeError
	CMP.L	MarkEndOfs(PC),D0
	BEQ	LargerRangeError
	btst	#5,EditBitFlags+3	;CutToBufFlag
	BEQ.S	.cut2
	BSR	SamCopy
.cut2	BSR	TurnOffVoices
	LEA	SamplePtrs(PC),A0
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVE.L	(A0),D0
	BEQ	EmptySampleError
	MOVE.L	SAMPLE_LENGTHS(A0),D2
	CMP.L	#2,D2
	BLO	EmptySampleError

	MOVE.L	D0,A1
	MOVE.L	D0,A2			; sample start
	MOVE.L	D0,A3
	MOVE.L	D0,A4
	MOVE.L	D0,A5
	ADD.L	MarkStartOfs(PC),A3	; mark start
	MOVE.L	MarkEndOfs(PC),D0
	SUB.L	MarkStartOfs(PC),D0
	CMP.L	D2,D0
	BHS	Destroy
	MOVE.L	MarkEndOfs(PC),D0
	CMP.L	D2,D0
	BLO.S	.some
	MOVE.L	D2,D0
	SUBQ.L	#1,D0
.some	ADD.L	D0,A4			; mark end
	ADD.L	D2,A5			; sample end

	MOVE.L	A3,D0
	SUB.L	A2,D0
	ADD.L	A5,D0
	SUB.L	A4,D0
	BNE	.oklen
	MOVEQ	#0,D3
	MOVEQ	#0,D4
	BRA	.free

.oklen	MOVE.L	D0,D3
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,D4
	BEQ	OutOfMemErr 		; No memory :(

	MOVE.L	D0,A0
	MOVE.L	A2,A1
	MOVE.L	A3,D0
	SUB.L	A2,D0
	BRA.S	.skp1
.lop1	MOVE.B	(A2)+,(A0)+
.skp1	DBRA	D0,.lop1

	MOVE.L	A5,D0
	SUB.L	A4,D0
	BRA.S	.skp2
.lop2	MOVE.B	(A4)+,(A0)+
.skp2	DBRA	D0,.lop2

.free	MOVE.L	4.w,a6
	MOVE.L	D2,D0
	beq.s	.skip
	JSR	LVOFreeMem(A6)

.skip	MOVE.W	InsNum(PC),D1
	LSL.W	#2,D1
	LEA	SamplePtrs(PC),A0
	LEA	0(a0,D1.W),A0
	move.l	(a0),.start
	MOVE.L	D4,(A0)
	MOVE.L	D3,SAMPLE_LENGTHS(A0)

	MOVE.L	D4,SamStart
	MOVE.L	D3,SamLength
	MOVE.L	SamOffset(PC),D4
	ADD.L	SamDisplay(PC),D4
	CMP.L	D3,D4
	BLO.s	.cuto			; display ok
	MOVE.L	SamDisplay(PC),D4
	CMP.L	D3,D4
	BLO.s	.nils			; if display < length, move offset
.sall	CLR.L	SamOffset		; else show all
	MOVE.L	D3,SamDisplay
	BRA.s	.cuto
.nils	MOVE.L	D3,D4
	SUB.L	SamDisplay(PC),D4
	BMI.S	.sall			; if offset < 0, show all
	MOVE.L	D4,SamOffset
.cuto	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	LEA	12(A0,D1.W),A0

	;move.l	MarkStartOfs(pc),d4
	;sub.l	MarkEndOfs(pc),d4
	;lsr.l	#1,d4

	;moveq	#0,d0
	;move.w	4(a0),d0
	;add.l	d0,d0
	;add.l	.start(pc),d0
	;cmp.l	MarkEndOfs(pc),d0
	;bpl.s	.cnt1
	;cmp.l	MarkStartOfs(pc),d0
	;bpl.s	.cnt2
;.cnt1	;sub.w	d4,4(a0)	; repeat
	;bcc.s	.c1
	;clr.w	4(a0)
;.c1	;bra.s	.cnt4
;.cnt2
	;moveq	#0,d0
	;move.w	6(a0),d0
	;add.w	4(a0),d0
	;add.l	d0,d0
	;add.l	.start(pc),d0
	;cmp.l	MarkEndOfs(pc),d0
	;bpl.s	.cnt3
	;cmp.l	MarkStartOfs(pc),d0
	;bpl.s	.cnt4
;.cnt3	;sub.w	d4,6(a0)	; replen
	;bcc.s	.cnt4
	;move.w	#2,6(a0)
	;clr.w	4(a0)
;.cnt4
	LSR.L	#1,D3
	MOVE.W	D3,(A0)		; length
	MOVE.W	4(A0),D0	; repeat
	CMP.W	D3,D0
	BLS.S	.cuxx	
	MOVEQ	#1,D0
	MOVE.L	D0,4(A0)	; repeat
	BRA.S	.cuex
.cuxx	ADD.W	6(A0),D0	; replen
	CMP.W	D3,D0
	BLS.S	.cuex
	SUB.W	4(A0),D3	; repeat
	MOVE.W	D3,6(A0)	; replen

.cuex	MOVE.L	MarkStartOfs(PC),MarkEndOfs
	BSR	ClearSamStarts
	BSR	ValidateLoops
	BSR	ShowSampleInfo
	BRA	DisplaySample
	cnop	0,4
.start	dc.l	0


SamCopy:CLR.B	RawKeyCode
	MOVE.L	MarkStartOfs(PC),D0
	BMI	NoRangeError
	CMP.L	MarkEndOfs(PC),D0
	BEQ	LargerRangeError
	LEA	SamplePtrs(PC),A0
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVE.L	(A0),D0
	BEQ	EmptySampleError
	MOVE.L	SAMPLE_LENGTHS(A0),D2
	BEQ	EmptySampleError
	MOVE.L	D0,A3
	MOVE.L	D0,A4
	ADD.L	MarkStartOfs(PC),A3	; mark start
	MOVE.L	MarkEndOfs(PC),D0	; mark end
	CMP.L	D2,D0
	BLO.S	.som
	MOVE.L	D2,D0
	SUBQ.L	#1,D0
.som	ADD.L	D0,A4
	BSR.S	FreeCopyBuf
	MOVE.L	A4,D0
	SUB.L	A3,D0
	ADDQ.L	#1,D0
	MOVE.L	D0,CopyBufSize
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	MOVE.L	D0,CopyBufPtr
	BEQ	OutOfMemErr 		; No memory
	MOVE.L	D0,A5
.lop	MOVE.B	(A3)+,(A5)+
	CMP.L	A4,A3
	BLS.S	.lop
	BSR	InvertRange
	BSR	InvertRange
	JMP	WaitForButtonUp

FreeCopyBuf:
	MOVE.L	CopyBufPtr(PC),D0
	REQ
	MOVE.L	D0,A1
	MOVE.L	CopyBufSize(PC),D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
	CLR.L	CopyBufPtr
	RTS

	cnop	0,4
CopyBufPtr:	dc.l	0
CopyBufSize:	dc.l	0

SamPaste:
	CLR.B	RawKeyCode
	MOVE.L	MarkStartOfs(PC),D0
	BMI	SetCursorError
	LEA	SamplePtrs(PC),A0
	MOVE.W	InsNum(PC),D1
	BEQ	NotSampleNull
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVEQ	#0,D2
	MOVE.L	(A0),D0
	BEQ.S	.nul
	MOVE.L	SAMPLE_LENGTHS(A0),D2
.nul	MOVE.L	D0,A2
	MOVE.L	CopyBufPtr(PC),D3
	BEQ	BufIsEmptyError
	MOVE.L	D3,A3
	MOVE.L	CopyBufSize(PC),D3
	BEQ	BufIsEmptyError

	MOVE.L	D3,D4 			; copysize
	ADD.L	D2,D4 			; + origsize
	CMP.L	#$1FFFE,D4
	BLO.S	.ok
	MOVE.L	#$1FFFE,D4
.ok	MOVE.L	D4,D0
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	TST.L	D0
	BEQ	OutOfMemErr
	MOVE.L	D0,A4
	MOVEQ	#0,D0
	TST.L	D2
	BEQ.S	.ask1
	MOVE.L	MarkStartOfs(PC),D0
.ask1	MOVE.L	D0,MarkStartOfs
	MOVE.L	A2,A1
	MOVE.L	D2,D1
	MOVE.L	A4,A5
	MOVE.L	A4,A0
	ADD.L	D4,A0

; D0    = paste position
; A0    = end of new sample
; A1/D1 = copy of A2/D2
; A2/D2 = original sample
; A3/D3 = copy buffer
; A4/D4 = new sample
; A5    = copy of A4

	BRA.S	.ask2
.alp1	MOVE.B	(A2)+,(A4)+ 		; copy first part
	CMP.L	A0,A4
	BHS.S	.aski
	SUBQ.L	#1,D2
.ask2	DBRA	D0,.alp1
	BRA.S	.ask3
.alp2	MOVE.B	(A3)+,(A4)+ 		; copy from buffer
	CMP.L	A0,A4
	BHS.S	.aski
.ask3	DBRA	D3,.alp2
	TST.L	D2
	BEQ.S	.aski
	BMI.S	.aski
.alp3	MOVE.B	(A2)+,(A4)+ 		; copy last part
	CMP.L	A0,A4
	BHS.S	.aski
	SUBQ.L	#1,D2
	BNE.S	.alp3

.aski	MOVE.L	D1,D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)

	MOVE.W	InsNum(PC),D1
	LSL.W	#2,D1
	LEA	SamplePtrs(PC),A0
	LEA	0(a0,D1.W),A0
	MOVE.L	A5,(A0)
	MOVE.L	D4,SAMPLE_LENGTHS(A0)

	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	LEA	12(A0,D1.W),A0
	LSR.L	#1,D4
	MOVE.W	D4,(A0)

	MOVE.L	MarkStartOfs(PC),MarkEndOfs
	BSR	OffsetToMark
	BSR	ClearSamStarts
	BSR	ShowSampleInfo
	BRA	RedrawSample

RampVolume:
	MOVE.L	TextBplPtr(PC),A0
	LEA	155*80+9(A0),A0
	MOVEQ	#32,D3
.lap2	MOVEQ	#16,D2
.lap1	CLR.B	(A0)+
	DBRA	D2,.lap1
	LEA	63(A0),A0
	DBRA	D3,.lap2
	LEA	VolBoxPos,A0
	LEA	VolBoxData,A1
	MOVEQ	#1,D4
.lop3	MOVEQ	#32,D3
.lop2	MOVEQ	#16,D2
.lop1	MOVE.B	(A1)+,(A0)+
	DBRA	D2,.lop1
	ADDQ.L	#1,A1
	LEA	63(A0),A0
	DBRA	D3,.lop2
	LEA	223*80(A0),A0
	DBRA	D4,.lop3
	BSR	ShowVolSliders
	JSR	WaitForButtonUp
ravloop:jsr	CheckNTSCPos
	BTST	#2,$DFF016
	BEQ	ExitVolBox
	JSR	DoKeyBuffer
	MOVE.B	RawKeyCode(PC),D2
	CMP.B	#68,D2
	BEQ	ExitVolBox
	BTST	#6,$BFE001
	BNE.S	ravloop
	MOVEM.W	MouseX,D0-D1
	CMP.W	#72,D0
	BLO.S	ravloop
	CMP.W	#72+136,D0
	BHS.S	ravloop
	CMP.W	#155,D1
	BLO.S	ravloop
	CMP.W	#166,D1
	BLO.S	Vol1Slider
	CMP.W	#177,D1
	BLO	Vol2Slider
	CMP.W	#188,D1
	BLO	VolGadgs
	BRA.S	ravloop

ExitVolBox:
	LEA	VolBoxPos,A0
	MOVEQ	#1,D2
.lap3	MOVEQ	#32,D1
.lap2	MOVEQ	#16,D0
.lap1	CLR.B	(A0)+
	DBRA	D0,.lap1
	LEA	63(A0),A0
	DBRA	D1,.lap2
	LEA	223*80(A0),A0
	DBRA	D2,.lap3
	BRA	DisplaySample

Vol1Slider:
	CMP.W	#167,D0
	BHI	shvskip
	LEA	Vol1(PC),A4
	MOVEQ	#0,D7
v1loop1:BTST	#6,$BFE001
	BNE	ravloop
	MOVE.W	MouseX(PC),D0
	CMP.W	D7,D0
	BEQ.S	v1loop1
	MOVE.W	D0,D7
	SUB.W	#107,D0
	BPL.S	.skp2
	MOVEQ	#0,D0
.skp2	CMP.W	#60,D0
	BLS.S	.skp3
	MOVEQ	#60,D0
.skp3	MULU	#200,D0
	DIVU	#60,D0
	MOVE.W	D0,(A4)
shvosl:	BSR	ShowVolSliders
	BRA.S	v1loop1

shvskip:MOVE.W	#180,LineCurX
	MOVE.W	#164,LineCurY
	MOVE.W	#158*80+22,TextOffset
	JSR	GetDec3Dig
	TST.W	AbortDecFlag
	BNE	shvosl
	CMP.W	#200,D0
	BLS.S	.sk2
	MOVE.W	#200,D0
.sk2	MOVE.W	D0,Vol1
	BRA.S	shvosl

Vol2Slider:
	CMP.W	#167,D0
	BHI.S	.skip
	LEA	Vol2(PC),A4
	MOVEQ	#0,D7
	BRA	v1loop1
.skip	MOVE.W	#180,LineCurX
	MOVE.W	#175,LineCurY
	MOVE.W	#169*80+22,TextOffset
	JSR	GetDec3Dig
	TST.W	AbortDecFlag
	BNE	shvosl
	CMP.W	#200,D0
	BLS.S	.sk2
	MOVE.W	#200,D0
.sk2	MOVE.W	D0,Vol2
	BRA	shvosl

VolGadgs:
	CMP.W	#100,D0
	BLO	DoRampVol
	CMP.W	#144,D0
	BLO	Normalize
	CMP.W	#154,D0
	BLO.S	SetRampDown
	CMP.W	#164,D0
	BLO.S	SetRampUp
	CMP.W	#174,D0
	BLO.S	SetRampUnity
	BRA	ExitVolBox

SetRampDown:
	MOVE.W	#100,Vol1
	CLR.W	Vol2
	BRA.S	sru2
SetRampUp:
	CLR.W	Vol1
	MOVE.W	#100,Vol2
	BRA.S	sru2
SetRampUnity:
	MOVE.W	#100,Vol1
	MOVE.W	#100,Vol2
sru2:	BSR.S	ShowVolSliders
	JSR	WaitForButtonUp
	BRA	ravloop

ShowVolSliders:
	MOVE.L	TextBplPtr(PC),A0
	LEA	155*80+9(A0),A0
	MOVEQ	#22-1,D3
.lip2	MOVEQ	#13-1,D2
.lip1	CLR.B	(A0)+
	DBRA	D2,.lip1
	LEA	67(A0),A0
	DBRA	D3,.lip2
	MOVEQ	#0,D4
	MOVE.W	Vol1(PC),D4
	MOVEQ	#20,D5
	BSR	OneSlider
	MOVEQ	#0,D4
	MOVE.W	Vol2(PC),D4
	MOVEQ	#31,D5
	BSR	OneSlider
	MOVE.W	Vol1(PC),WordNumber
	MOVE.W	#158*80+22,TextOffset
	BSR	Print3DecDigits
	MOVE.W	Vol2(PC),WordNumber
	MOVE.W	#169*80+22,TextOffset
	BRA	Print3DecDigits

OneSlider:
	MOVE.W	D4,D6
	ADD.W	D4,D4
	ADD.W	D6,D4
	DIVU	#10,D4
	ADD.W	#105,D4
	MOVEQ	#2,D6
.lop	MOVE.W	D4,D0
	MOVE.W	D4,D2
	ADDQ.W	#5,D2
	MOVE.W	D5,D1
	MOVE.W	D5,D3
	BSR	DrawLine
	ADDQ.W	#1,D5
	DBRA	D6,.lop
	RTS

DoRampVol:
	CLR.B	RawKeyCode
	LEA	SamplePtrs(PC),A0
	MOVE.W	InsNum(PC),D1
	BEQ	nozerr1
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVEQ	#0,D2
	MOVE.L	(A0),D0
	BEQ	nozerr2
	MOVE.L	D0,A2
	MOVE.L	SAMPLE_LENGTHS(A0),D2
	BEQ	nozerr2
	MOVE.L	MarkStartOfs(PC),D0
	BMI	.skip
	MOVE.L	MarkEndOfs(PC),D1
	SUB.L	D0,D1
	BEQ.S	.skip
	ADD.L	D0,A2
	MOVE.L	D1,D2
	ADDQ.L	#1,D2
.skip	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVE.L	D2,D5
	MOVEQ	#0,D3
.loop	MOVE.W	D3,D1
	MULU	Vol2(PC),D1
	DIVU	D2,D1
	MOVE.W	D2,D4
	SUB.W	D3,D4
	MULU	Vol1(PC),D4
	DIVU	D2,D4
	ADD.W	D4,D1
	ADDQ.W	#1,D3
	MOVE.B	(A2),D0
	EXT.W	D0
	MULS	D1,D0
	DIVS	#100,D0
	CMP.W	#127,D0
	BLT.S	.skp2
	MOVEQ	#127,D0
.skp2	CMP.W	#-128,D0
	BGT.S	.skp3
	MOVEQ	#-128,D0
.skp3	MOVE.B	D0,(A2)+
	SUBQ.L	#1,D5
	BNE	.loop
	JSR	RestorePtrCol
	BRA	ExitVolBox

nozerr1	JSR	NotSampleNull
	BRA	ravloop
nozerr2	BSR	EmptySampleError
	BRA	ravloop

Normalize:
	CLR.B	RawKeyCode
	LEA	SamplePtrs(PC),A0
	MOVE.W	InsNum(PC),D1
	BEQ	nozerr1
	LSL.W	#2,D1
	LEA	0(a0,D1.W),A0
	MOVEQ	#0,D2
	MOVE.L	(A0),D0
	BEQ	nozerr2
	MOVE.L	D0,A2
	MOVE.L	SAMPLE_LENGTHS(A0),D2
	BEQ	nozerr2
	MOVE.L	MarkStartOfs(PC),D0
	BMI	.skip
	MOVE.L	MarkEndOfs(PC),D1
	SUB.L	D0,D1
	BEQ.S	.skip
	ADD.L	D0,A2
	MOVE.L	D1,D2
	ADDQ.L	#1,D2
.skip	JSR	StorePtrCol
	JSR	SetWaitPtrCol
	MOVEQ	#0,D0
.loop	MOVE.B	(A2)+,D1
	EXT.W	D1
	BPL.S	.skp2
	NEG.W	D1
.skp2	CMP.W	D0,D1
	BLO.S	.skp3
	MOVE.W	D1,D0
.skp3	SUBQ.L	#1,D2
	BNE	.loop
	JSR	RestorePtrCol
	TST.W	D0
	BEQ	SetRampUnity
	CMP.W	#127,D0
	BHI	SetRampUnity
	CMP.W	#64,D0
	BLO.S	.max
	MOVE.L	#12700,D1
	DIVU	D0,D1
	MOVE.W	D1,Vol1
	MOVE.W	D1,Vol2
	BRA	sru2
.max	MOVE.W	#200,Vol1
	MOVE.W	#200,Vol2
	BRA	sru2

	cnop	0,4
Vol1:	dc.w	100
Vol2:	dc.w	100

TuningTone:
	JSR	WaitForButtonUp
	CLR.B	RawKeyCode
	TST.W	TToneFlag	; is it on already?
	BNE	TToneOff	; if yes turn it off

	MOVE.W	#1,TToneFlag	; set da flag

	MOVE.W	PattCurPos,D2	; ok, lets find out which channel it is
	DIVU	#7,D2
	ADDQ.W	#1,D2		; take next channel
	AND.W	#3,D2		; now we have 0-3 again

	MOVEQ	#1,D0
	LSL.W	D2,D0           ; build a dmacon mask

	MOVE.W	D0,TToneBit

	LEA	$DFF0A0,A0
	LSL.W	#4,D2
	LEA	0(a0,D2.W),A0	; set base for audio registers

	LEA	PeriodTable(PC),A1
	MOVE.W	TuneNote,D1
	LSL.W	#1,D1
	MOVE.W	0(a1,D1.W),D1	; period

	move.w	d0,d2
	lsl.w	#7,d2
	move.w	d2,_custom+intena	; do not allow interrupts
	move.w	d2,_custom+intreq	; clear interrupts
	MOVE.W	D0,_custom+dmacon	; DMA off
	move.w	#1,AUDPER(a0)		; max. period
	move.w	#0,AUDDAT(a0)		; force interrupt to come again
	MOVE.L	#TToneData,AUDPTR(A0)	
	MOVE.W	#16,AUDLEN(A0) 		; 32 bytes
	MOVE.W	D1,AUDPER(A0)
	MOVE.W	TToneVol,d1		; set volume
	mulu	RelVolume(pc),d1
	add.l	#32,d1
	lsr.l	#6,d1		;divu	#MaxVol,d1
	move.w	d1,AUDVOL(A0)
.wait:	move.w	_custom+intreqr,d1	; wait for dma ready ;-maw-
	and.w	d2,d1
	beq.s	.wait
	or.w	#$8000,d0		; set "set bit"
	MOVE.W	D0,_custom+dmacon	; dma on again
	RTS

TToneOff:
	CLR.W	TToneFlag               ; clr da flag
	MOVE.W	TToneBit(PC),d0
	move.w	d0,d2
	lsl.w	#7,d2
	move.w	d2,_custom+intena	; do not allow interrupts
	move.w	d0,_custom+dmacon	; dma off
	RTS

	cnop	0,4
TToneFlag:	dc.w 0
TToneBit:	dc.w 0

SamplePressed:
	CMP.W	#144,D1			;same in y.. (phew :)
	BHS.S	.skp
	MOVE.W	LoopStartPos(PC),D2
	BEQ.S	.sk5
	SUBQ.W	#3*2,D2			;now, this is in X (darn it)
	CMP.W	D2,D0
	BLT.S	.sk5
	ADDQ.W	#4*2,D2
	CMP.W	D2,D0
	BLO	LoopStartDrag
.sk5	MOVE.W	LoopEndPos(PC),D2
	BEQ.S	.skp
	SUBQ.W	#3*2,D2
	CMP.W	D2,D0
	BLT.S	.skp
	ADDQ.W	#4*2,D2
	CMP.W	D2,D0
	BLO	LoopEndDrag
.skp	CMP.W	#3,D0
	RLO
	CMP.W	#637,D0
	RHS
	MOVE.W	D0,LastSamPos
	BSR	InvertRange
	MOVE.W	LastSamPos(PC),D0
	MOVE.W	D0,MarkStart
	MOVE.W	D0,MarkEnd
	move.w	d0,PrevMark
	BSR	InvertPartRange
	BSR	MarkToOffset
	MOVE.L	MarkEndOfs(PC),SamplePos
	BSR	ShowPos
	jsr	InvertLine
	move.w	#-1,MarkFlag
.lop	jsr	CheckNTSCPos
	BTST	#6,$BFE001
	BNE	.end
	MOVE.W	MouseX(PC),D0
	CMP.W	#3,D0
	BLO	.sk3
	CMP.W	#637,D0
	BHS	.sk2
	BRA	.sk4
.sk2	MOVE.W	#636,D0
	BRA	.sk4
.sk3	MOVEQ	#3,D0
.sk4	CMP.W	LastSamPos(PC),D0
	BEQ	.lop
	MOVE.W	D0,LastSamPos
	BSR	InvertPartRange
	MOVE.W	LastSamPos(PC),MarkEnd
	BSR	InvertPartRange
	BSR	MarkToOffset
	MOVE.L	MarkEndOfs(PC),SamplePos
	BSR	ShowPos
	BRA	.lop
.end	MOVE.W	MarkStart(PC),D0
	MOVE.W	MarkEnd(PC),D1
	CMP.W	D0,D1
	BHS	MarkToOffset
	MOVE.W	D0,MarkEnd
	MOVE.W	D1,MarkStart
	BRA	MarkToOffset

InvertRange:
	tst.w	MarkFlag
	bne	InvertLine
	move.w	MarkStart(pc),d0
	REQ
	move.w	MarkEnd(pc),d2
	moveq	#0,d1
	moveq	#64,d3
	cmp.w	d0,d2
	bpl.s	.cnt
	exg	d0,d2
.cnt	bra	InvertAnyBlock4

InvertPartRange:
	tst.w	MarkFlag
	beq.s	.cnt2
	bsr	InvertLine
.cnt2	MOVE.W	MarkStart(PC),D4
	REQ
	move.w	PrevMark(pc),d0
	move.w	MarkEnd(pc),d2
	move.w	d2,PrevMark

	moveq	#0,d1
	moveq	#64,d3
	cmp.w	d0,d2
	bpl.b	.cnt
	exg	d0,d2
.cnt	bra	InvertAnyBlock4

InvertLine:
	clr.w	MarkFlag
	moveq	#0,d1
	moveq	#64,d3
	MOVE.W	MarkStart(PC),D0
	move.w	d0,d2
	addq.w	#1,d2
	bra	InvertAnyBlock4

	cnop	0,4
PrevMark:	dc.w	0
MarkFlag:	dc.w	0
LoopStartPos:	dc.w	0
LoopEndPos:	dc.w	0

LoopStartDrag:
	CLR.W	DragType
LopDrgLop:
	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D0
	REQ
	MULU	#30,D0
	LEA	12(A0,D0.W),A0
	MOVE.W	MouseX(PC),D0
.lop1	jsr	CheckNTSCPos
	BTST	#6,$BFE001
	BNE	lsdexit
	MOVE.W	MouseX(PC),D1
	CMP.W	D0,D1
	BEQ.S	.lop1
	SUB.W	DragType,D1
	BPL.S	.msk1
	MOVEQ	#0,D1
.msk1	CMP.W	#SAMPLEDISPLAY_W,D1
	BLO.S	.msk2
	MOVE.W	#SAMPLEDISPLAY_W,D1
.msk2	MOVE.L	SamDisplay(PC),D0
	;move.l	d2,-(sp)
	;move.w	d1,d2
	MULU	D0,D1
	;swap	d0
	;mulu	d0,d2
	;swap	d2
	;add.l	d2,d1
	;move.l	d1,d2
	DIVU	#SAMPLEDISPLAY_W,D1
	AND.L	#$FFFF,D1
	;swap	d2
	;and.l	#$ffff,d2
	;divu	#SAMPLEDISPLAY_W,d2
	;and.l	#$ffff,d2
	;swap	d2
	;add.l	d2,d1
	;move.l	(sp)+,d2
	MOVE.L	SamOffset(PC),D0
	ADD.W	D1,D0    		; new repeat
	BCLR	#0,D0
	MOVEQ	#0,D1
	MOVE.W	4(A0),D1 		; old repeat
	ADD.W	D1,D1
	TST.W	DragType
	BNE	drgrepl
	MOVE.W	D1,D3
	SUB.W	D1,D0    		; offset
	ADD.W	D0,D1
	MOVE.W	6(A0),D2
	ADD.W	D2,D2
	ADD.W	D2,D3
	SUBQ.W	#2,D3
	SUB.W	D0,D2
	CMP.W	D3,D1
	BLS.S	lsdok
	MOVE.W	D3,D1
	MOVEQ	#2,D2
lsdok:	LSR.W	#1,D1
	MOVE.W	D1,4(A0)
	LSR.W	#1,D2
	MOVE.W	D2,6(A0)
	BSR.S	lsdexit
	BRA	LopDrgLop
lsdexit:BSR	ShowSampleInfo
	JSR	UpdateRepeats
	BRA	SetLoopSprites2

LoopEndDrag:
	MOVE.W	#3,DragType
	BRA	LopDrgLop

drgrepl:MOVE.L	D0,D2 			; repend
	SUB.L	D1,D2 			; subtract repstart
	CMP.L	#2,D2
	BGT.S	.skp1
	MOVEQ	#2,D2
	BRA.S	lsdok

.skp1	MOVE.W	D1,D0 			; repeat
	ADD.W	D2,D0 			; + replen
	MOVE.W	(A0),D3
	ADD.W	D3,D3
	CMP.W	D3,D0
	BLS.S	lsdok
	SUB.W	D1,D3
	MOVE.W	D3,D2
	BRA.S	lsdok

	cnop	0,4
DragType:dc.w 0

SamDragBar:
	CMP.W	DragStart(PC),D0
	BLO	.draglo
	CMP.W	DragEnd(PC),D0
	BHI	.draghi
	MOVE.W	MouseX(PC),D0
	MOVE.W	D0,D1
	SUB.W	DragStart(PC),D1
	MOVE.W	D1,SaveMX
.lop1	jsr	CheckNTSCPos
	BTST	#6,$BFE001
	BNE	DisplaySample3
	MOVE.W	MouseX(PC),D1
	CMP.W	D0,D1
	BEQ.S	.lop1
	SUB.W	SaveMX(PC),D0
	SUBQ.W	#4,D0
	BPL.S	.skp1
	MOVEQ	#0,D0
.skp1	MOVE.L	SamLength(PC),D1
	REQ
	;move.l	d2,-(sp)
	;move.l	d0,d2
	;swap	d2
	MULU	D1,D0
	;mulu	d1,d2
	;swap	d2
	;add.l	d2,d0
	;move.l	d0,d2
	DIVU	#631,D0
	AND.L	#$FFFF,D0
	;swap	d2
	;and.l	#$ffff,d2
	;divu	#631,d2
	;and.l	#$ffff,d2
	;swap	d2
	;add.l	d2,d0
	;move.l	(sp)+,d2
	BSR	.dragchk
	MOVE.W	MouseX(PC),D0
	BRA.S	.lop1
.dragchk
	MOVE.L	D0,D1
	ADD.L	SamDisplay(PC),D1
	CMP.L	SamLength(PC),D1
	BLS.S	.chk2
	MOVE.L	SamLength(PC),D0
	SUB.L	SamDisplay(PC),D0
.chk2	CMP.L	SamOffset(PC),D0
	REQ
	MOVE.L	D0,SamOffset
	BRA	DisplaySample2

.draglo	MOVE.L	SamOffset(PC),D0
	SUB.L	SamDisplay(PC),D0
	BPL.S	.drglo2
	MOVEQ	#0,D0
.drglo2	CMP.L	SamOffset(PC),D0
	REQ
	MOVE.L	D0,SamOffset
	BRA	DisplaySample

.draghi	MOVE.L	SamOffset(PC),D0
	ADD.L	SamDisplay(PC),D0
	MOVE.L	D0,D1
	ADD.L	SamDisplay(PC),D1
	CMP.L	SamLength(PC),D1
	BLS.S	.drglo2
	MOVE.L	SamLength(PC),D0
	SUB.L	SamDisplay(PC),D0
	BRA.S	.drglo2

	cnop	0,4
SaveMX:	dc.w	0

;----

MarkToOffset:
	MOVE.L	SamDisplay(PC),D0
	moveq	#0,d1
	MOVE.W	MarkStart(PC),D1
	REQ
	SUBQ.W	#3,D1
	;move.l	d2,-(sp)
	;move.l	d1,d2
	MULU	D0,D1
	;swap	d0
	;mulu	d0,d2
	;swap	d2
	;add.l	d2,d1
	;swap	d0
	;move.l	d1,d2
	DIVU	#SAMPLEDISPLAY_W,D1
	AND.L	#$FFFF,D1
	;swap	d2
	;and.l	#$ffff,d2
	;divu	#SAMPLEDISPLAY_W,d2
	;and.l	#$ffff,d2
	;swap	d2
	;add.l	d2,d1
	;move.l	(sp)+,d2
	ADD.L	SamOffset(PC),D1
	MOVE.L	D1,MarkStartOfs
	MOVE.W	MarkEnd(PC),D1
	CMP.W	#636,D1
	BLO.S	.some
	MOVE.L	SamOffset(PC),D1
	ADD.L	D0,D1
	BRA.S	.exit
.some	SUBQ.W	#3,D1
	;move.l	d2,-(sp)
	;move.w	d1,d2
	MULU	D0,D1
	;swap	d0
	;mulu	d0,d2
	;swap	d2
	;add.l	d2,d1
	;move.l	d1,d2
	DIVU	#SAMPLEDISPLAY_W,D1
	AND.L	#$FFFF,D1
	;swap	d2
	;and.l	#$ffff,d2
	;divu	#SAMPLEDISPLAY_W,d2
	;and.l	#$ffff,d2
	;swap	d2
	;add.l	d2,d1
	;move.l	(sp)+,d2
	ADD.L	SamOffset(PC),D1
.exit	MOVE.L	D1,MarkEndOfs
	RTS

OffsetToMark:
	MOVE.L	MarkStartOfs(PC),D0
	BMI.W	.out
	MOVE.W	#3,MarkStart
	SUB.L	SamOffset(PC),D0
	BMI.S	.skip			; set to start if before offset
	;move.l	d2,(sp)
	;move.l	d0,d2
	MULU	#SAMPLEDISPLAY_W,D0
	;swap	d2
	;mulu	#SAMPLEDISPLAY_W,d2
	;swap	d2
	;add.l	d2,d0
	;move.l	(sp)+,d2
	MOVE.L	SamDisplay(PC),D1
	BEQ.S	.skip
	DIVU	D1,D0
	CMP.W	#SAMPLEDISPLAY_W,D0
	BHI	.out			; if start after display
	ADD.W	D0,MarkStart
.skip	MOVE.W	#3,MarkEnd
	MOVE.L	MarkEndOfs(PC),D0
	SUB.L	SamOffset(PC),D0
	BMI.S	.out			; if end before offset
	;move.l	d2,-(sp)
	;move.l	d0,d2
	MULU	#SAMPLEDISPLAY_W,D0
	;swap	d2
	;mulu	#SAMPLEDISPLAY_W,d2
	;swap	d2
	;add.l	d2,d0
	;move.l	(sp)+,d2
	MOVE.L	SamDisplay(PC),D1
	REQ
	DIVU	D1,D0
	CMP.W	#633,D0
	BLS.S	.ok
	MOVE.W	#633,D0			; set to end if after display
.ok	ADD.W	D0,MarkEnd
	RTS
.out	CLR.W	MarkStart
	RTS

	cnop	0,4
SamScrEnable:	dc.w	0
SamMemPtr:	dc.l	0
SamMemSize:	dc.l	0
LastSamPos:	dc.w	0
MarkStart:	dc.w	0
MarkEnd:	dc.w	0
MarkStartOfs:	dc.l	0
MarkEndOfs:	dc.l	0

;---- Sample graphing stuff ----
SAMPLEDISPLAY_W  = 634

DisplaySample:
	TST.W	SamScrEnable
	REQ
	BSR	rdsdoit
	TST.L	MarkStartOfs
	RMI
	BSR	OffsetToMark
	BRA	InvertRange

DisplaySample3:
	TST.W	SamScrEnable
	REQ
	BSR	InvertRange
	BSR	rdsdoit3
	TST.L	MarkStartOfs
	RMI
	BSR	OffsetToMark
	BRA	InvertRange

rdsdoit3:
	MOVE.L	GfxBase,A6
	JSR	LVOOwnBlitter(A6)
	JSR	LVOWaitBlit(A6)
	bra.w	rdsdoit4

RedrawSample:
	tst.w	LoadInProgress
	bne.s	.cnt
	jsr	ClearKeyBuf
.cnt	TST.W	SamScrEnable		;is the samplescreen active?
	REQ				;nope, no need fro redrawing!
	MOVEQ	#-1,D0			;else: JUST DO IT
	MOVE.L	D0,MarkStartOfs
	CLR.W	MarkStart
	MOVE.W	InsNum(PC),D0		; sample number
	BEQ	rdsblnk

	LEA	SampleStarts(PC),A1
	SUBQ.W	#1,D0
	LSL.W	#2,D0
	MOVE.L	0(a1,D0.W),SamStart	; is it empty?
	BEQ	rdsblnk

	MOVE.L	SAMPLE_LENGTHS(A1,D0.W),D1         ; get sample length
	BEQ	rdsblnk
	MOVE.L	D1,SamLength
	CLR.L	SamOffset
	MOVE.L	D1,SamDisplay
	BRA	rdsdoit

;-- here if sample nummer zero or sample is empty

rdsblnk	LEA	BlankSample,A0	; display blank sample (arggh!!)
	MOVE.L	A0,SamStart
	MOVE.L	#SAMPLEDISPLAY_W,SamLength
	CLR.L	SamOffset
	MOVE.L	#SAMPLEDISPLAY_W,SamDisplay

rdsdoit	MOVE.L	GfxBase,A6
	JSR	LVOOwnBlitter(A6)
	JSR	LVOWaitBlit(A6)
	BSR	ClearSamArea	; first clear the area

rdsdoit4
	MOVE.L	SamStart(PC),A0
	MOVEQ	#0,D4
	move.l	#-1,a2
	MOVE.L	SamOffset(PC),D5
	MOVE.L	SamDisplay(PC),D6
	lea	(a0,d5.l),a0
	move.l	A0,D0
	MOVE.L	D0,SamDrawStart
	ADD.L	D6,D0
	MOVE.L	D0,SamDrawEnd

	moveq	#3,d0
	MOVEQ	#127,D1
	SUB.B	(a0),D1
	LSR.W	#2,D1
	BSR	MoveTo		; Move to first point

	cmp.l	#SAMPLEDISPLAY_W,d6         ; if it is shorter then the sample area
	blt	drawsample2

	; drawing sample if length=>SAMPLEDISPLAY_W
	; d6 = length
	; display length = 640-6 (=SAMPLEDISPLAY_W)
drawsample1:
	divu	#SAMPLEDISPLAY_W,d6		; How much to add between each byte
	move.l	d6,d5
	swap	d5		; how often to add one more
	move.w	#SAMPLEDISPLAY_W/2,d7	; counter
	MOVEQ	#0,D4
.loop	MOVE.W	D4,D0
	ADDQ.W	#3,D0
	MOVEQ	#127,D1		
	SUB.B	(a0),D1
	LSR.W	#2,D1           ; display only upper 6 bits
	BSR	DrawTo
	ADDQ.W	#1,D4
	lea	(a0,d6.w),a0	; wonder if this is really faster, hmm...
	sub.w	d5,d7
	bge.s	.skip
	add.w	#SAMPLEDISPLAY_W,d7
	addq.l	#1,a0
.skip	cmp.w	#SAMPLEDISPLAY_W,d4
	blo.s	.loop
	bra	rdscont

	; drawing sample if length<SAMPLEDISPLAY_W
	; d6 = length
	; display length = 640-6 (=SAMPLEDISPLAY_W)
drawsample2:
	move.l	#SAMPLEDISPLAY_W,d7
	divu	d6,d7		; How much to add between each byte
	move.l	d7,d5
	swap	d5		; how often to add one more
	move.w	d6,.adder
	lsr.w	#1,d6		; counter
	MOVEQ	#0,D4
.loop
	MOVE.W	D4,D0
	ADDQ.W	#3,D0
	MOVEQ	#127,D1
	SUB.B	(a0),D1
	LSR.W	#2,D1
	BSR	DrawTo
	add.w	d7,d4		; how many pixels to skip
	lea	1(a0),a0
	sub.w	d5,d6
	bge.s	.skip
	add.w	.adder(pc),d6
	addq.w	#1,d4
.skip	cmp.w	#SAMPLEDISPLAY_W,d4
	blo.s	.loop
	MOVE.W	#SAMPLEDISPLAY_W+3-1,D0
	MOVEQ	#127,D1
	SUB.B	-1(a0),D1
	LSR.W	#2,D1    	; display only upper 6bits
	BSR	DrawTo
	bra.s	rdscont
.adder	dc.w	0

	; do this when finished drawing
rdscont	MOVE.L	GfxBase,A6
	JSR	LVODisownBlitter(A6)
	BSR.W	SetDragBar
	bsr	ShowDisplay
	bsr	ShowPos
	BRA	SetLoopSprites

ShowDisplay:
	MOVE.L	SamDisplay(PC),D2
	LEA	BlankSample,A0
	CMP.L	SamStart,A0
	BNE.S	.cnt
	MOVEQ	#0,D2
.cnt	move.w	#424,d0
	move.w	#215,d1
	moveq	#7,d3
	bra	PrintAnyDigits

DisplaySample2:
	TST.W	SamScrEnable
	REQ
	BSR	rdsdoit2
	TST.L	MarkStartOfs
	RMI
	BSR	OffsetToMark
	BRA	InvertRange

rdsdoit2
	BSR	ClearSamArea2
	MOVE.L	SamStart(PC),A0
	MOVEQ	#0,D4
	moveq	#-1,d2
	MOVE.L	SamOffset(PC),D5
	MOVE.L	SamDisplay(PC),D6
	lea	(a0,d5.l),a0
	MOVE.L	A0,D0
	MOVE.L	D0,SamDrawStart
	ADD.L	D6,D0
	MOVE.L	D0,SamDrawEnd

	cmp.l	#SAMPLEDISPLAY_W,d6
	blt	drawsample4

	; drawing sample if length=>SAMPLEDISPLAY_W
	; d6 = length
	; display length = 640-6 (=SAMPLEDISPLAY_W)
drawsample3
	divu	#SAMPLEDISPLAY_W,d6		; How much to add between each byte
	move.l	d6,d5
	swap	d5		; how often to add one more
	move.w	#SAMPLEDISPLAY_W/2,d7	; counter
	MOVEQ	#0,D4
.loop	MOVE.W	D4,D0
	ADDQ.W	#3,D0
	MOVEQ	#127,D1
	SUB.B	(a0),D1
	LSR.W	#2,D1
	;pixel
	move.l	LineScreen(pc),a1
	move.w	d1,d2
	lsl.w	#4,d2
	lsl.w	#6,d1
	add.w	d2,d1
	;mulu	#80,d1
	lea	(a1,d1.w),a1
	move.w	d0,d1
	asr.w	#3,d1
	eor.b	#7,d0
	bset	d0,(a1,d1.w)
	; end pixel
	addq.w	#1,d4
	lea	(a0,d6.w),a0
	sub.w	d5,d7
	bge.s	.skip
	add.w	#SAMPLEDISPLAY_W,d7
	addq.l	#1,a0
.skip	cmp.w	#SAMPLEDISPLAY_W,d4
	blo.s	.loop
	bra	rdscont1

	; drawing sample if length<SAMPLEDISPLAY_W
	; d6 = length
	; display length = 640-6 (=SAMPLEDISPLAY_W)
drawsample4
	move.l	#SAMPLEDISPLAY_W,d7
	divu	d6,d7		; How much to add between each byte
	move.l	d7,d5
	swap	d5		; how often to add one more
	move.w	d6,.adder
	lsr.w	#1,d6		; counter
	MOVEQ	#0,D4
.loop	MOVE.W	D4,D0
	ADDQ.W	#3,D0
	MOVEQ	#127,D1
	SUB.B	(a0),D1
	LSR.W	#2,D1
	;pixel
	move.l	LineScreen(pc),a1
	move.w	d1,d2
	lsl.w	#4,d2
	lsl.w	#6,d1
	add.w	d2,d1
	;mulu	#80,d1
	lea	(a1,d1.l),a1
	move.w	d0,d1
	asr.w	#3,d1
	eor.b	#7,d0
	bset	d0,(a1,d1.w)
	; end pixel
	add.w	d7,d4		; how many pixels to skip
	lea	1(a0),a0
	sub.w	d5,d6
	bge.s	.skip
	add.w	.adder(pc),d6
	addq.w	#1,d4
.skip	cmp.w	#SAMPLEDISPLAY_W,d4
	blo.s	.loop
	bra.s	rdscont1
.adder	dc.w	0

	; do this when finished drawing
rdscont1
	BSR.W	SetDragBar
	bsr	ShowDisplay
	bsr	ShowPos
	BRA	SetLoopSprites

	cnop	0,4
SamStart	dc.l	0
SamLength	dc.l	0
SamOffset	dc.l	0
SamDisplay	dc.l	0
SavSamIns	dc.w	0

SetDragBar
	MOVE.W	#2*4*10-1,D0
	MOVE.L	TextBplPtr,A0
	LEA	207*80(A0),A0
	MOVEQ	#0,D1
sdblop2	MOVE.L	D1,(A0)+
	DBRA	D0,sdblop2
	MOVE.L	SamLength(PC),D0
	REQ
	MOVE.L	SamOffset(PC),D4
	MOVE.L	SamDisplay(PC),D5
	CMP.L	D0,D5
	REQ
	ADD.L	D4,D5
	;move.l	d2,-(sp)
	;move.l	d4,d2
	MULU	#631,D4
	;swap	d2
	;mulu	#631,d2
	;swap	d2
	;add.l	d2,d4
	;move.l	(sp)+,d2
	DIVU	D0,D4
	ADDQ.W	#4,D4
	MOVE.W	D4,DragStart
	MULU	#631,D5
	DIVU	D0,D5
	ADDQ.W	#5,D5
	MOVE.W	D5,DragEnd

	move.w	d4,d0
	move.w	d5,d2
	moveq	#68,d1
	moveq	#68+4,d3
	moveq	#1,d5
	BRA	ShowAnyBlock2

	cnop	0,4
DragStart	dc.w	0
DragEnd		dc.w	0

;---- Pixel Routine ----

ShowPixel
	movem.l	d0-d1/a0,-(sp)
	lea	BitPlaneData,a0
	mulu	#80,d1
	lea	(a0,d1.l),a0
	move.w	d0,d1
	eor.b	#7,d0
	lsr.w	#3,d1
	lea	(a0,d1.w),a0
	moveq	#0,d1
pixloop	btst	d1,d5
	bne.s	pixcn1
	bclr	d0,(a0)
	bra.s	pixcn2
pixcn1	bset	d0,(a0)
pixcn2	lea	80*256(a0),a0
	addq.w	#1,d1
	cmp.w	#2,d1
	blo.s	pixloop
	movem.l	(sp)+,d0-d1/a0
	rts

;---- Line Routine ----

ShowLine
	move.l	LineScreen(pc),-(sp)
	move.l	#BitPlaneData,LineScreen
	moveq	#0,d4
dlinloop
	move.b	#$ca,MinTerm
	btst	d4,d5
	bne.b	dlincon
	move.b	#$0a,MinTerm
dlincon	bsr	DrawLine
	add.l	#80*256,LineScreen
	addq.w	#1,d4
	cmp.w	#2,d4
	blo.s	dlinloop
	MOVE.B	#$C8,MinTerm
	move.l	(sp)+,LineScreen
	rts

DrawInvertLine
	MOVE.B	#$48,MinTerm
	BSR.S	DrawLine
	MOVE.B	#$C8,MinTerm
	RTS

MoveTo	MOVE.W	D0,PenX
	MOVE.W	D1,PenY
	RTS

DrawTo	MOVE.W	PenX(PC),D2
	MOVE.W	PenY(PC),D3
	MOVE.W	D0,PenX
	MOVE.W	D1,PenY
	cmp.w	d0,d2
	bne.s	DrawLine
	cmp.w	d1,d3
	beq.w	nodrawto
DrawLine
	MOVEM.L	D4-D7/A0,-(SP)
	MOVEQ	#0,D4
	SUB.W	D1,D3
	BGE.S	dypos
	NEG.W	D3
	BRA.S	dyneg
dypos	BSET	#0,D4
dyneg	SUB.W	D0,D2
	BGE.S	dxpos
	NEG.W	D2
	BRA.S	dxneg
dxpos	BSET	#1,D4
dxneg	MOVE.W	D2,D5
	SUB.W	D3,D5
	BGE.S	dxdypos
	EXG	D2,D3
	BRA.S	dxdyneg
dxdypos	BSET	#2,D4
dxdyneg	MOVEQ	#0,D5
	ROR.W	#4,D0
	OR.W	#$0B00,D0
	MOVE.B	D0,D5
	MOVE.B	MinTerm(PC),D0
	LSL.W	#1,D5
	MULS	#ScrWidth,D1
	ADD.W	D5,D1
	ADD.L	LineScreen(PC),D1
blitrdy	BTST	#14,$DFF002 		; DMACONR	; this works :-) -maw-
	BNE.S	blitrdy					; it is the same as btst #6 :-)

;nonsense	MOVE.W	$DFF01C,-(SP)		; intenar
;nonsense	BSET	#7,(SP)
;nonsense	MOVE.W	#$7FFF,$DFF09A          ; intena

	move.w	#$4000,_custom+intena	; master disable is sufficient! -maw-
					; so we need no save and stuff
	MOVE.B	Octants(PC,D4),D4
	ADD.L	D3,D3
	MOVE.W	D3,$DFF062 		; BLTBMOD
	SUB.W	D2,D3
	BGE.S	dldspos
	OR.B	#$40,D4
dldspos	MOVE.L	D3,$DFF050 		; BLTAPTR
	SUB.W	D2,D3
	MOVE.W	D3,$DFF064 		; BLTAMOD
	MOVE.W	D4,$DFF042 		; BLTCON1
	MOVE.W	D0,$DFF040 		; BLTCON0
	MOVE.L	D1,$DFF048 		; BLTCPTR
	MOVE.L	D1,$DFF054 		; BLTDPTR
	MOVE.W	#ScrWidth,$DFF060 	; BLTCMOD
	MOVE.W	#ScrWidth,$DFF066 	; BLTDMOD
	MOVE.W	#$8000,$DFF074 		; BLTADAT
	MOVE.W	#$FFFF,$DFF044 		; BLTAFWM
	MOVE.W	LinMask(PC),$DFF072 	; BLTBDAT
	ASL.W	#6,D2
	ADD.W	#2,D2
	MOVE.W	D2,$DFF058 		; BLTSIZE -> start blitter

;nonsense	MOVE.W	(SP)+,$DFF09A           ; intena, see above
	move.w	#$C000,_custom+intena	

	MOVEM.L	(SP)+,D4-D7/A0
nodrawto
	RTS

ScrWidth = 80

Octants	dc.b	3*4+1,2*4+1,1*4+1,0*4+1,7*4+1,5*4+1,6*4+1,4*4+1
LinMask	dc.w	$FFFF
MinTerm	dc.b	$C8 			;was $CA
	cnop 0,2
PenX	dc.w	0
PenY	dc.w	0
LineScreen dc.l	0

;---- Loop Sprites ----

SetLoopSprites
	MOVEQ	#-1,D6
	MOVEQ	#-1,D7
	MOVE.W	InsNum(PC),D0
	BEQ	slsset
	MULU	#INSTR_SIZEOF,D0
	MOVE.L	SongDataPtr(PC),A0
	LEA	12(A0,D0.W),A0		;get sampleinfo
SetLoopSprites2
	TST.W	SamScrEnable		;samplerscreen active?
	REQ
	CLR.W	LoopOnOffFlag		;loop is now off
	MOVEQ	#-1,D6
	MOVEQ	#-1,D7
	MOVEQ	#0,D0
	MOVE.W	4(A0),D0		;get repeat
	ADD.L	D0,D0			;*2
	MOVEQ	#0,D1
	MOVE.W	6(A0),D1		;get replen
	ADD.L	D1,D1			;*2
	MOVE.L	D0,D5
	ADD.L	D1,D5			;find end of loop
	CMP.W	#2,D5			;smallest possible?
	BLS	slsset			;lower or same -> exit
	MOVE.W	#1,LoopOnOffFlag	;loop is now on
	MOVE.L	SamOffset(PC),D2	;get start in displayed sample
	MOVE.L	SamDisplay(PC),D3	;get end of displayed sample
	MOVE.L	D2,D4
	ADD.L	D3,D4			;this is the start 
	CMP.L	D2,D0			
	BLO.S	neste1
	CMP.L	D4,D0
	BHI.S	neste1
	SUB.L	D2,D0
	;move.l	d2,-(sp)
	;move.l	d0,d2
	MULU	#SAMPLEDISPLAY_W,D0
	;swap	d2
	;mulu	#SAMPLEDISPLAY_W,d2
	;swap	d2
	;add.l	d2,d0
	;move.l	(sp)+,d2
	DIVU	D3,D0
	ADDQ.W	#3,D0
	MOVE.W	D0,D6
neste1	CMP.L	D2,D5
	BLO.S	slsset
	CMP.L	D4,D5
	BHI.S	slsset
	SUB.L	D2,D5
	;move.l	d2,-(sp)
	;move.l	d5,d2
	MULU	#SAMPLEDISPLAY_W,D5
	;swap	d2
	;mulu	#SAMPLEDISPLAY_W,d2
	;swap	d2
	;add.l	d2,d5
	;move.l	(sp)+,d2
	DIVU	D3,D5
	ADDQ.W	#6,D5
	MOVE.W	D5,D7
slsset	MOVE.W	#139,D1			;ypos
	MOVE.W	D6,D0
	BPL.S	neste2
	MOVEQ	#0,D0
	MOVE.W	#270,D1
neste2	MOVEQ	#64,D2			;heigth
	LEA	LoopSpriteData1,A0
	MOVE.W	D0,LoopStartPos
	lsr.w	#1,d0			;medres, remember?
	BSR	SetSpritePos
	MOVE.W	#139,D1
	MOVE.W	D7,D0
	BPL.S	neste3
	MOVEQ	#0,D0
	MOVE.W	#270,D1
neste3	MOVEQ	#64,D2
	LEA	LoopSpriteData2,A0
	MOVE.W	D0,LoopEndPos
	lsr.w	#1,d0			;medres...
	BSR	SetSpritePos
	BRA	ShowLoopToggle

ResetLoopSprites
	LEA	LoopSpriteData1,A0
	MOVE.W	LoopStartPos(pc),d0
	lsr.w	#1,d0			;medres, remember?
	tst.w	LoopOnOffFlag
	bne.s	.cnt1
	moveq	#-32,d0
.cnt1	MOVE.W	#139,D1
	MOVEQ	#64,D2			;heigth
	BSR	SetSpritePos
	LEA	LoopSpriteData2,A0
	MOVE.W	LoopEndPos(pc),d0
	lsr.w	#1,d0			;medres, remember?
	tst.w	LoopOnOffFlag
	bne.s	.cnt2
	moveq	#-32,d0
.cnt2	MOVE.W	#139,D1
	MOVEQ	#64,D2			;heigth
	BSR	SetSpritePos
	rts

;---- Sampler routines ----

_custom	EQU	$00DFF000
intreq	EQU	$0000009C
intreqr	EQU	$0000001E
intena	EQU	$0000009A
joy0dat	EQU	$0000000A
vhposr	EQU	$00000006
dmacon	EQU	$00000096
dmaconr	EQU	$00000002

	cnop	0,4
SamInfoPtr	dc.l	0
SamInfoLen	dc.l	0
SampleNote	dc.w	24 ; C-3
ResampleNote	dc.w	24 ; C-3
SamIntSave	dc.w	0
SamDMASave	dc.w	0

ClearTempSampArea
	LEA	TempSampArea,A0
	MOVE.W	#379,D0
	MOVEQ	#0,D1
ctsalop	MOVE.W	D1,(A0)+
	DBRA	D0,ctsalop
	RTS

Sampler:tst.w	SamScrEnable
	REQ
	move.w	LoopOnOffFlag,-(sp)
	clr.w	LoopOnOffFlag
	bsr	ResetLoopSprites
	CLR.B	RawKeyCode
	JSR	StopIt
	JSR	TopExit
	JSR	WaitForButtonUp
	JSR	SetWaitPtrCol
	BSR	ShowMon
	JSR	Wait_4000
	BSR	ClearTempSampArea
	BSR	WaitForDiskDrive
	MOVE.W	$DFF01C,SamIntSave 	; intenar
	MOVE.W	#$7FFF,_custom+intena	
	JSR	TurnOffVoices
	MOVE.W	SampleNote,D0
	ASL.W	#1,D0
	LEA	PeriodTable,A0
	MOVE.W	0(a0,D0.W),D0
	LSR.W	#1,D0
	LEA	$00DFF000,A0
	LEA	$AA(A0),A5
	LEA	$BA(A0),A6
	MOVE.W	D0,$A6(A0)
	MOVE.W	D0,$B6(A0)
	MOVEQ.L	#$20,D0
	mulu	RelVolume(pc),d0
	add.l	#32,d0
	lsr.l	#6,d0	;divu	#MaxVol,d0
	MOVE.W	D0,$A8(A0)
	MOVE.W	D0,$B8(A0)
	MOVEQ.L	#0,D0
	MOVE.W	D0,(A5)
	MOVE.W	D0,(A6)
	MOVE.B	#6,$00BFD200
	MOVEQ.L	#2,D0
	MOVE.B	D0,$00BFD000
	MOVE.B	#0,$00BFE301
	LEA	GraphOffsets(PC),A0
	LEA	TempSampArea,A1
	MOVE.L	TextBplPtr,A2
	LEA	160*80+30(A2),A2
	LEA	$00BFE101,A3
	LEA	_custom+intreqr,A4
	MOVE.W	#$0180,D7
	MOVEQ.L	#6,D6
	MOVEQ.L	#10,D3
.lop2	MOVEQ.L	#22,D5
.lop4	MOVEQ.L	#7,D4
.lop3	BTST	D7,(A4)
	BEQ.S	.lop3
	MOVE.W	D7,$7E(A4)	;intreq
	MOVEQ.L	#0,D0
	MOVE.B	(A3),D0
	MOVE.W	D0,D1
	SUB.B	D7,D0
	MOVE.B	D0,(A5)
	MOVE.B	D0,(A6)
	LSR.W	#3,D1
	ADD.W	D1,D1
	MOVE.W	0(A0,D1.W),D0
	MOVE.W	(A1),D1
	MOVE.W	D0,(A1)+
	BCLR	D4,0(A2,D1.W)
	BSET	D4,0(A2,D0.W)
	DBRA	D4,.lop3
	ADDQ.L	#1,A2
	DBRA	D5,.lop4
	SUB.L	#23,A2
	SUB.L	#368,A1
	BTST	D6,-$0100(A3)
	BEQ	.exit
	BTST	D3,-8(A4)
	BNE.S	.lop2

;-- start sampling --

	MOVE.W	InsNum(PC),D1
	BEQ	.exit
	LSL.W	#2,D1
	LEA	SamplePtrs,A0
	MOVE.L	0(a0,D1.W),D0
	BEQ.S	.ok1
	CLR.L	0(a0,D1.W)
	MOVE.L	D0,A1
	MOVE.L	SAMPLE_LENGTHS(A0,D1.W),D0
	BEQ.S	.ok1
	CLR.L	SAMPLE_LENGTHS(A0,D1.W)
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)
.ok1	MOVE.L	#$FFFE,D6		; try 128k
.alclop	MOVE.L	D6,D0
	MOVE.L	#MEMF_CHIP!MEMF_CLEAR,D1
	MOVE.L	4.w,a6
	JSR	LVOAllocMem(A6)
	TST.L	D0
	BNE.S	.alloc
	SUB.L	#2048,D6		; try 2k less
	BPL.S	.alclop
	JSR	OutOfMemErr
	BRA	.exit
.alloc	MOVE.W	InsNum(PC),D1
	LSL.W	#2,D1
	LEA	SamplePtrs(PC),A0
	MOVE.L	D0,0(a0,D1.W)
	MOVE.L	D6,SAMPLE_LENGTHS(A0,D1.W)

	MOVE.W	$DFF002,SamDMASave
	MOVE.W	#$03FF,_custom+dmacon
	BSR	GetSampleInfo
	MOVE.L	SamInfoLen,D4
	move.w	#0,$DFF100
	move.w	#0,$DFF180
	MOVE.L	SamInfoPtr,A1
	LEA	_custom+intreq,A2
	LEA	$00BFE101,A3 		; parallel port
	LEA	_custom+intreqr,A4
	LEA	$DFF0BA,A6

	MOVE.W	#$0180,D7
	MOVEQ.L	#6,D6
	MOVEQ.L	#0,D5
.loop	BTST	D7,(A4)
	BEQ.S	.loop
	MOVE.W	D7,(A2)
	MOVE.B	(A3),D0
	SUB.B	D7,D0
	MOVE.B	D0,(A5)
	MOVE.B	D0,(A6)
	MOVE.B	D0,(A1)+
	ADDQ.W	#1,D5
	CMP.W	D4,D5
	BEQ.S	.end
	BTST	D6,-$0100(A3)
	BNE.S	.loop
.end	MOVE.W	SamDMASave,D0
	OR.W	#$8000,D0
	MOVE.W	D0,$00DFF096

	MOVE.L	A1,D0
	SUB.L	SamInfoPtr(PC),D0
	MOVE.L	D0,SamInfoLen

	MOVE.L	SongDataPtr(PC),A0
	MOVE.W	InsNum(PC),D1
	MULU	#30,D1
	LEA	12(A0,D1.W),A0
	MOVE.L	SamInfoLen(PC),D0
	LSR.L	#1,D0
	MOVE.W	D0,(A0)+
	MOVE.W	#$0040,(A0)+
	CLR.W	(A0)+
	MOVE.W	#1,(A0)

	MOVE.L	SamInfoLen(PC),D1
	NEG.L	D1
	AND.L	#$FFFFFFF8,D1
	NEG.L	D1
	MOVE.W	InsNum(PC),D0
	ASL.W	#2,D0
	LEA	SamplePtrs,A0
	CMP.L	SAMPLE_LENGTHS(A0,D0.W),D1
	BGE.S	.exit
	MOVE.L	SAMPLE_LENGTHS(A0,D0.W),D2
	MOVE.L	D1,SAMPLE_LENGTHS(A0,D0.W)
	SUB.L	D1,D2
	MOVE.L	0(A0,D0.W),A1
	MOVE.L	SAMPLE_LENGTHS(A0,D0.W),D0
	ADD.L	D0,A1
	MOVE.L	D2,D0
	MOVE.L	4.w,a6
	JSR	LVOFreeMem(A6)

.exit	MOVE.W	SamIntSave,D0
	BSET	#15,D0
	MOVE.W	D0,$DFF09A
	JSR	TurnOffVoices
	JSR	DisplayMainScreen
	BSR	ClearMon
	BSR	ClearSamStarts
	move.w	(sp)+,LoopOnOffFlag
	bsr	ResetLoopSprites
	BSR	ShowSampleInfo
	BSR	RedrawSample
	JSR	WaitForButtonUp
	;jsr	ClearKeyBuf
	CLR.W	ShiftKeyStatus
	JMP	Wait_4000

SampleNullInfo:
	CLR.L	SamInfoPtr
	CLR.L	SamInfoLen
	MOVEQ	#-1,D0
	RTS	
 
GetSampleInfo:
	MOVE.W	InsNum(PC),D0
	BEQ.S	SampleNullInfo
	LSL.W	#2,D0
	LEA	SamplePtrs(PC),A0
	MOVE.L	0(a0,D0.W),SamInfoPtr
	MOVE.L	SAMPLE_LENGTHS(A0,D0.W),SamInfoLen
	MOVEQ	#0,D0
	RTS

ShowMon:movem.l	d0-d7/a0-a6,-(sp)
	move.w	#232,d0
	move.w	#144,d1
	lea	SampleMonitor,a0
	jsr	PaintScreen
	move.w	#232,d0
	move.w	#144,d1
	move.w	#232+200,d2
	move.w	#144+55,d3
	moveq	#0,d5
	jsr	ShowAnyBlock3
	movem.l	(sp)+,d0-d7/a0-a6
	rts
ClearMon:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	#232,d0
	move.w	#144,d1
	lea	ClrMonitor,a0
	jsr	PaintScreen
	movem.l	(sp)+,d0-d7/a0-a6
	rts


WaitForDiskDrive:
	JSR	StorePtrCol
	move.l	4.w,a6

	suba.l	a1,a1
	jsr	LVOFindTask(a6)
	move.l	d0,DiskRep+$10
	lea	DiskRep,a1
	jsr	LVOAddPort(a6)
	move.l	4.w,a6

	lea	DiskIO,a1
	moveq	#0,d0
	moveq	#0,d1
	lea	TrackdiskName(pc),a0
    	jsr	LVOOpenDevice(a6)

	lea	DrivePtr(pc),a0
	lea	DiskIO,a1
	move.l	20(a1),a2		; IO_DEVICE
	move.l	a2,DevPtr
	lea	36(a2),a2

	moveq	#4-1,d1
.CopyLp	move.l	(a2)+,(a0)+		; Copy ptr to all mounted drives!
	dbf	d1,.CopyLp
***********************************
	moveq	#0,d0
	lea	DrivePtr(pc),a4

	move.l	(a4)+,a0
	move.l	(a4)+,a1
	move.l	(a4)+,a2
	move.l	(a4)+,a3

	movem.l d0-d7/a0-a6,-(sp)
	JSR	SetDiskPtrCol
	movem.l (sp)+,d0-d7/a0-a6

.waitlp	cmp.l	#0,a0
	beq.b	.skip1
	move.b	34(a0),d0
.skip1	cmp.l	#0,a1
	beq.b	.skip2
	ori.b	34(a1),d0
.skip2	cmp.l	#0,a2
	beq.b	.skip3
	ori.b	34(a2),d0
.skip3	cmp.l	#0,a3
	beq.b	.nomore
	ori.b	34(a3),d0
.nomore	tst.b	d0		; All drives waiting for something to do???
	bne.b	.waitlp		; If still working, loop again!

.done	lea	DiskIO,a1
	jsr	LVOCloseDevice(a6)
	lea	DiskRep,a1
	jsr	LVORemPort(a6)
	Jsr	RestorePtrCol
	rts
	cnop	0,4
DevPtr:		dc.l	0
DrivePtr:	dcb.l	4,0

*******************************************************************************

ClearSamStarts:
	LEA	SamplePtrs+4,A0
	MOVEQ	#30,D0
cssLoop	MOVE.L	(A0)+,D1
	BEQ	cssSkip
	MOVE.L	D1,A1
	CLR.W	(A1)
cssSkip	DBRA	D0,cssLoop
	RTS

GraphOffsets:
	dc.w 31*80,30*80,29*80,28*80,27*80,26*80,25*80,24*80
	dc.w 23*80,22*80,21*80,20*80,19*80,18*80,17*80,16*80
	dc.w 15*80,14*80,13*80,12*80,11*80,10*80,09*80,08*80
	dc.w 07*80,06*80,05*80,04*80,03*80,02*80,01*80,00*80

SamNoteType:	dc.w	0

ShowSamNote:
	TST.W	SamScrEnable
	REQ
	MOVE.L	NoteNamesPtr,A4
	MOVE.W	#237*80+46,TextOffset
	MOVE.W	SampleNote,D0
	LSL.W	#2,D0
	LEA	0(a4,D0.W),A0
	MOVE.L	A0,ShowTextPtr
	MOVE.W	#4,TextLength
	BRA	ShowText

ShowResamNote:
	TST.W	SamScrEnable
	REQ
	MOVE.L	NoteNamesPtr,A4
	MOVE.W	#248*80+46,TextOffset
	MOVE.W	ResampleNote,D0
	LSL.W	#2,D0
	LEA	0(a4,D0.W),A0
	MOVE.L	A0,ShowTextPtr
	MOVE.W	#4,TextLength
	BRA	ShowText

*******************************************************************************

;---- Playroutine ----
	cnop	0,4
; size was 44
; since I added some variables, size is >44 now -maw-
AudChanPtrs:	dc.l audchan1temp
		dc.l audchan2temp
		dc.l audchan3temp
		dc.l audchan4temp
MaxVol = 64

CIAIntMusic:
	movem.l	d0-a6,-(sp)
	bsr.s	.doint
	movem.l	(sp)+,d0-a6
	rts
.doint	btst	#3,MiscBitFlags+3	; Softint?
	beq.s	IntMusic		; if not, just do the music int
	lea	SoftintHandler,a1       ; cause the soft int
	move.l	4.w,a6
	jmp	-180(a6)		; Cause

IntMusic:
	MOVEM.L	D0-A6,-(SP)

	MOVE.L	RunMode(PC),D0
	BEQ	NoNewPositionYet
	CMP.L	#'patt',D0
	BEQ.S	.neste4
	MOVE.L	SongPosition(PC),CurrPos
.neste4	MOVE.L	SongDataPtr(PC),A0
	MOVE.B	sd_numofpatt(A0),SongNumOfPatt+1
	TST.W	StepPlayEnable
	BNE.S	.neste5
	ADDQ.L	#1,Counter
	MOVE.L	Counter(PC),D0
	CMP.L	CurrSpeed(PC),D0
	BLO.S	NoNewNote
.neste5	CLR.L	Counter
	TST.B	PattDelayTime2
	BEQ	GetNewNote
	BSR.S	NoNewAllChannels
	BRA	dskip

NoNewNote:
	BSR.S	NoNewAllChannels
	BRA	NoNewPositionYet

NoNewAllChannels:
	LEA	audchan1temp,A6
	LEA	$DFF0A0,A5
	moveq	#4-1,d7
.loop	push	d7
	BSR	CheckEffects
	pop	d7
	lea	$10(a5),a5
	lea	n_SIZEOF(a6),a6
	dbf	d7,.loop
	rts

	;LEA	audchan2temp,A6
	;LEA	$DFF0B0,A5
	;BSR	CheckEffects

	;LEA	audchan3temp,A6
	;LEA	$DFF0C0,A5
	;BSR	CheckEffects

	;LEA	audchan4temp,A6
	;LEA	$DFF0D0,A5
	;BRA	CheckEffects

;---------------------------------
SetAudXVol:
	tst.b	n_tracktogl(a6)
	RNE
	tst.b	n_dynflag(a6)
	bne	.dyn_vol
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	mulu	n_relvol(a6),d0
	add.w	#32,d0
	lsr.w	#6,d0
	MOVE.W	D0,AUDVOL(A5)       ; AUDxVOL
	rts
.dyn_vol:
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	mulu	n_relvol(a6),d0
	add.w	#32,d0
	lsr.w	#6,d0
	MOVE.W	D0,n_DynPlayVol(A6)	; export to Dyn-Interrupt
					; changes the next part only!
; immediate update of the hardware volume
;	tst.w	n_intcnt(a6)		; dont update if newly started
;	bne.s	.notnewtrigger
;        rts
.notnewtrigger:
	move.w	d2,-(sp)
	move.w	n_DynPartVol(a6),d2	; get current part volume
	bne.s	.nz			; if it is not zero
	moveq	#0,d0           	; if part volume is zero, real volume is also 0
	bra.s	.vok
.nz:	mulu.w	d2,d0
	add.w	#32,d0			; use rounding
	lsr.w	#6,d0		
	bne.s	.vok        		; but don't let it go zero...
	moveq	#1,d0			; it should be 1 at least
.vok:
	MOVE.W	D0,AUDVOL(A5)       ; AUDxVOL
	move.w	(sp)+,d2
	rts

GetNewNote:
	LEA	12(A0),A3
	LEA	sd_pattpos(A0),A2
	LEA	sd_patterndata(A0),A0
	MOVEQ	#0,D1
	MOVE.L	SongPosition(PC),D0
	MOVE.B	0(a2,D0.W),D1
	CMP.L	#'patt',RunMode
	BNE.S	.neste6
	MOVE.L	PatternNumber(PC),D1
.neste6	ASL.L	#8,D1

	ASL.L	#2,D1
	ADD.L	PatternPosition(PC),D1
	MOVE.L	D1,PatternPtr

	moveq	#4-1,d7
	LEA	$DFF0A0,A5
	LEA	audchan1temp,A6
.loop	push	d0-a6
	BSR	PlayVoice
	bsr	SetAudXVol
	pop	d0-a6
	lea	$10(a5),a5
	lea	n_SIZEOF(a6),a6
	ADDQ.L	#4,D1
	dbf	d7,.loop
	BRA	SetDMA	        ; this is for all channels!

CheckMetronome:
	addq.b	#1,d2	; -maw- ; channels now come from 0-3 (was 1-4)
	CMP.B	MetroChannel,D2
	RNE
	MOVE.B	MetroSpeed,D2
	REQ
	and.w	#$ff,d2		; is it word?
	MOVE.L	PatternPosition,D3
	LSR.L	#4,D3
	DIVU	D2,D3
	SWAP	D3
	TST.W	D3
	RNE
	AND.L	#$00000FFF,(A6)
	OR.L	#$10D6F000,(A6) 	; Play sample $1F at period $0D6 (214)
	RTS

PlayVoice:
	move.b	n_tracktogl(a6),d5
	bne.s	.cnt
	TST.L	(A6)		; if no note & no command
	BNE.S	.plvskip
.cnt	BSR	PerNop		; set period in AUDxPER first
	tst.b	d5
	beq.s	.plvskip
	BSR.S	CheckMetronome
	rts
.plvskip:
	MOVE.L	0(a0,D1.L),(A6)		; Read note from pattern
	BSR.S	CheckMetronome
	MOVEQ	#0,D2
	MOVE.B	n_cmd(A6),D2		; Get lower 4 bits of instrument
	AND.B	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0			; Get higher 4 bits of instrument
	AND.B	#$F0,D0
	OR.B	D0,D2   	; d2.w = instrument number
	TST.B	D2
	BEQ	.SetRegisters		; Instrument was zero

	moveq	#0,d3
	LEA	SampleStarts(PC),A1

	move.l	DynFlagMask,d4		; -maw- check if dyn
	btst	d2,d4			; why here? because i have the registers here
	sne	n_dynflag(a6)

	MOVE.W	D2,D4
	MOVE.B	D2,n_samplenum(A6)
	SUBQ.L	#1,D2
	LSL.L	#2,D2
	MULU	#30,D4
	MOVE.L	(a1,D2.L),n_oldstart(A6)
	move.l	n_oldstart(a6),n_start(a6)
	MOVE.W	(a3,D4.L),n_oldlength(A6)		; a3 seems 2 b something
	move.l	n_oldlength(a6),n_length(a6)
	MOVE.W	(a3,D4.L),n_reallength(A6)
	MOVE.B	2(A3,D4.L),n_finetune(A6)
	moveq	#0,d0
	MOVE.B	3(A3,D4.L),d0
	move.b	d0,n_volume(A6)

	MOVEQ	#0,D3
	MOVE.W	4(A3,D4.L),D3 ; Get repeat
	TST.W	D3
	BEQ.S	.NoLoop
	MOVE.L	n_start(A6),D2		; Get start
	ASL.W	#1,D3
	ADD.L	D3,D2			; Add repeat
	MOVE.L	D2,n_loopstart(A6)
	MOVE.L	D2,n_wavestart(A6)
	MOVE.W	4(A3,D4.L),D0		; Get repeat
	ADD.W	6(A3,D4.L),D0		; Add replen
	MOVE.W	D0,n_length(A6)
	MOVE.W	6(A3,D4.L),n_replen(A6)	; Save replen
	BRA.S	.SetRegisters

.NoLoop	MOVE.L	n_start(A6),D2
	ADD.L	D3,D2
	MOVE.L	D2,n_loopstart(A6)
	MOVE.L	D2,n_wavestart(A6)
	MOVE.W	6(A3,D4.L),n_replen(A6)	; Save replen

.SetRegisters
	MOVE.W	(A6),D0
	AND.W	#$0FFF,D0
	BEQ	CheckMoreEffects	; If no note, check effects and exit

	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0E50,D0 		; finetune
	BEQ.S	DoSetFineTune

	MOVE.B	2(A6),D0                ; effect nibble
	AND.B	#$0F,D0

	CMP.B	#3,D0			; TonePortamento
	bne.s	.noporta3
	BSR	SetTonePorta
	BRA	CheckMoreEffects	; and exit
.noporta3:

	CMP.B	#5,D0			; TonePortamento + VolSlide
	bne.s	.noporta5
	BSR	SetTonePorta
	BRA	CheckMoreEffects	; end exit
.noporta5:

; -maw- Fighting the clicking... ---
	CMP.B	#$C,D0			; volume
	BNE.S	.novol
	BSR	VolumeChange		; do the volume check now!
	bra	SetPeriod	
.novol:
;-----------------------------------

	CMP.B	#9,D0			; Sample Offset
	BNE.S	SetPeriod
	BSR	CheckMoreEffects	; get the new values for n_start and n_length
	BRA.S	SetPeriod


DoSetFineTune:
	BSR	SetFineTune
;-----------------------------
SetPeriod:
	MOVEM.L	D0-D1/A0-A1,-(SP)
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	LEA	PeriodTable(PC),A1
	MOVEQ	#0,D0
	MOVEQ	#$24,D7
.loop	CMP.W	0(a1,D0.W),D1
	BHS.s	.found
	ADDQ.L	#2,D0
	DBRA	D7,.loop
.found	MOVEQ	#0,D1
	MOVE.B	n_finetune(A6),D1
	and.b	#$f,d1	; -maw- Don't forget to mask out higher nibble!
	MULU	#FINETUNETABLE_SIZE,D1
	ADD.L	D1,A1
	MOVE.W	0(a1,D0.W),n_period(A6)
	MOVEM.L	(SP)+,D0-D1/A0-A1
;-------------------------------------
	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0ED0,D0
	BEQ	CheckMoreEffects   ; exit if it is NoteDelay !!!!!!!!
;-----------------------------
	BTST	#2,n_wavecontrol(A6)
	BNE.s	.vibnoc
	CLR.B	n_vibratopos(A6)
.vibnoc	BTST	#6,n_wavecontrol(A6)
	BNE.s	.trenoc
	CLR.B	n_tremolopos(A6)
.trenoc

;************ TRIGGERING THE SAMPLES *************************
	tst.b	n_dynflag(a6)	; -maw- (we have to check it somewhere :)
	beq.s	.normal
	bsr	StartDyn	; start dyn sample
	BRA	AfterPlayVoice_CME ; was "CheckMoreEffects"
.normal:
;-- START NORMAL SAMPLE VIA INTERRUPT
	movem.l	d0/d1/a0,-(sp)
	move.w	ActiveChannels,d0               ; check if muted
	move.w	n_channel(a6),d1		; which channel was it?
	btst	d1,d0
	beq	.dontplay

	st	n_normalsmp(a6)			; flag to start sample via interrupt
	clr.w	n_intcnt(a6)                  	; reset interrupt counter
	cmp.w	#2,n_length(a6)                 ; if too short -> silence
	bls.s	.silence
	tst.l	n_start(a6)			; if invalid Ptr -> silence
	bne.s	.okidoki
.silence:
	lea	Silence,a0
	move.l	a0,n_start(a6)
	move.l	a0,n_loopstart(A6)	; these two we must set in the interrupt!
	move.w	#16,n_replen(A6)	; TEST
	move.w	#16,n_length(a6)
.okidoki:
	lea	_custom,a0                      ; Custom in a0
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	move.w	n_IntenaOff(a6),intreq(a0) 	; clear da interrupts
	move.w	n_DmaOff(A6),dmacon(a0)		; dma off
	move.w	#1,AUDPER(A5)    		; max. speed of audio-dma cycles
	move.w	#0,AUDDAT(a5)			; force interrupt
	move.l	n_start(a6),AUDPTR(A5)		; Set start
	move.w	n_length(A6),AUDLEN(A5)		; Set length
        move.w	n_IntenaOn(a6),intena(a0)	; allow audio interrupts
	ST	n_trigger(A6)
.dontplay:
	movem.l	(sp)+,d0/d1/a0
	BRA	AfterPlayVoice_CME ; was "CheckMoreEffects"

TEST1:	movem.l	d0/d1,-(sp)
	move.l	#Silence,AUDPTR(a5)
	moveq	#0,d0
	moveq	#1,d1
	move.w	d1,AUDLEN(a5)
	move.w	d1,AUDPER(A5)
	move.w	d0,AUDVOL(a5)	; TEST
	move.w	d0,AUDDAT(a5)
	movem.l	(sp)+,d0/d1
        rts

;----------------------------------------------------
; This is called for starting dyn sample by music routine
StartDyn:
	movem.l	d0-d2/a0-a1,-(sp)

	move.w	#$4000,_custom+intena

	move.w	ActiveChannels,d1               ; check if muted
	move.w	n_channel(a6),d0		; which channel was it?
	btst	d0,d1
	beq	.dontplay

	moveq	#0,d1
	move.b	n_samplenum(a6),d1
	jsr	PrepareDynPartTab	; d0 is still channel number

	moveq	#0,D1
	move.b	n_volume(A6),d1         ; store n_volume
	mulu	RelVolume,d1		; "overall" volume
	add.w	#32,d1
	lsr.w	#6,d1
	move.w	d1,n_DynPlayVol(a6)	; this is our playvolume then

	sf	n_normalsmp(a6)			; flag to set sample via interrupt
	clr.w	n_intcnt(a6)                    ; clr the interrupt counter
	st	n_dynflag(a6)			; this _is_ DYN

	move.l	n_PartTabAdr(a6),a0		; get start of dyn parts
	move.l	a0,n_DynPtr(a6)         	; set Ptr ready for first interrupt

;--- offset stuff for dyn samples
	tst.b	n_sampleoffset(A6)
	beq	.no_ofs
	move.l	n_start(a6),d1	; new sample start
.scan:	move.l	(a0),d0     	; security check
	beq	.found    	; exit if last part encounterd
	cmp.l	d0,d1		; search for part adress > offset
	blt.s	.found
	addq.w	#8,a0		; skip to next entry
	bra.s	.scan
.found:	subq.w  #8,a0		; go back to previous part
	moveq	#0,d0
	move.l	(a0),d0		; get old part adress
	sub.l	d1,d0		; minus new part start -> negative
	neg.l	d0		; positive now
	lsr.l	#1,d0		; since partlens are hardware lengths
	sub.w	d0,4(a0)	; sub from partlen -> partlen is corrected ;-)
	move.l	d1,(a0)		; enter this adress in the table
	move.l	a0,n_DynPtr(a6)	; patch the start ptr

	move.w	n_length(a6),d1	; now we gotta patch the lengths
	moveq	#0,d2
.scend:	tst.l	(a0)		; security check, just in case we fail
	beq.s	.ofsfail
	move.w	4(a0),d0	; get partlength
	add.w	d0,d2		; add it to current sum
	cmp.w	d1,d2		; are we over it?
	bhs.s	.endfnd
	addq	#8,a0		; if not, take next part information
	bra.s	.scend
.endfnd: 			; here we found the end
	sub.w	d1,d2		; d2 is now difference: shall-is
	sub.w	d2,d0	
	move.w	d0,4(a0)	; patch this length
	clr.l	8(a0)		; set endmarker
.ofsfail:                       ; fail here
.no_ofs:
;----------------------------------------------
; hm, should we need the dmaconr check again???
	move.l	n_DynPtr(a6),a1			; dynptr in a1
	lea	_custom,a0                      ; Custom in a0

	btst	#4,MiscBitFlags+3	; use dmaconr?
	beq.s	.AUDDAT_version
;-----------------------
	;move.w	#$70,COLOR00(a0)		; TEST green = DMACONR version	
	move.w	dmaconr(a0),d0		; read dmaconr
	move.w	n_channel(a6),d1
	btst	d1,d0
	bne.s	.dma_was_on
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	bra.s	.dma_was_off
.dma_was_on:
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	move.w	n_DmaOff(A6),dmacon(a0)		; dma off
	move.w	n_IntenaOff(a6),intreq(a0)      ; first clear intreq
.dma_was_off:
	move.w	#1,AUDPER(a5)             	; max. dma cycle speed
	move.l	(a1)+,AUDPTR(a5)		; partadr
	move.w	(a1),AUDLEN(a5)			; partlength
	bra.s	.goon
;----------------------
.AUDDAT_version:
	;move.w	#$700,COLOR00(a0)		; TEST red = AUDDAT version
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	move.w	n_DmaOff(A6),dmacon(a0)		; dma off
	move.l	(a1)+,AUDPTR(a5)		; partadr
	move.w	(a1),AUDLEN(a5)			; partlength
	move.w	n_IntenaOff(a6),intreq(a0)      ; first clear intreq
	move.w	#1,AUDPER(a5)             	; max. dma cycle speed
 	move.w	#0,AUDDAT(a5)			; force interrupts to come again
.goon:
	move.w	#0,AUDVOL(a5)			; silent here!
	move.w	n_IntenaOn(a6),intena(a0)	; allow audio interrupts
	ST	n_trigger(A6)
.dontplay:
	movem.l	(sp)+,d0-d2/a0-a1
	move.w	#$C000,_custom+intena
	rts
;-----------------------------------------------------------------

SetDMA:	
	; WE DONT NEED THAT ANYMORE :-)	
;-- entry point after "NoNewAllChannels"

dskip	TST.L	RunMode
	BEQ.s	.skipx
	JSR	SetPatternPos
.skipx	MOVE.L	PatternPosition(PC),D0
	LSR.L	#4,D0
	MOVE.W	D0,ScrPattPos
	ADD.L	#16,PatternPosition
	MOVE.B	PattDelayTime,D0
	BEQ.s	.skpc
	MOVE.B	D0,PattDelayTime2
	CLR.B	PattDelayTime
.skpc	TST.B	PattDelayTime2
	BEQ.s	.skpa
	SUBQ.B	#1,PattDelayTime2
	BEQ.s	.skpa
	SUB.L	#16,PatternPosition
.skpa	TST.B	PBreakFlag
	BEQ.s	.pysk
	SF	PBreakFlag
	MOVEQ	#0,D0
	MOVE.B	PBreakPosition(PC),D0
	LSL.W	#4,D0
	MOVE.L	D0,PatternPosition
	CLR.B	PBreakPosition
.pysk	TST.W	StepPlayEnable
	BEQ	.pysk2
	JSR	DoStopIt
	CLR.W	StepPlayEnable
	MOVE.L	PatternPosition(PC),D0
	LSR.L	#4,D0
	AND.W	#63,D0
	MOVE.W	D0,ScrPattPos
.pysk2	CMP.L	#1024,PatternPosition
	BNE	NoNewPositionYet
NextPosition:
	MOVEQ	#0,D0
	MOVE.B	PBreakPosition(PC),D0
	LSL.W	#4,D0
	MOVE.L	D0,PatternPosition
	CLR.B	PBreakPosition
	CLR.B	PosJumpAssert
	CMP.L	#'patp',RunMode
	BNE	NoNewPositionYet
	ADDQ.L	#1,SongPosition
	st	NewPosition			; We got another position
	AND.L	#$7F,SongPosition
	MOVE.L	SongPosition(PC),D1
	MOVE.L	SongDataPtr(PC),A0
	CMP.B	sd_numofpatt(A0),D1
	BLO	NoNewPositionYet
	CLR.L	SongPosition

	TST.W	StepPlayEnable
	BEQ	NoNewPositionYet
	JSR	DoStopIt
	CLR.W	StepPlayEnable
	MOVE.L	PatternPosition(PC),D0
	LSR.L	#4,D0
	MOVE.W	D0,ScrPattPos

NoNewPositionYet:
	TST.B	PosJumpAssert
	BNE	NextPosition
	;tst.b	NewPosition
	;beq	.exit
	;sf	NewPosition
	;lea	PatternSoftintHandler,a1      ; cause the soft int
	;move.l	4.w,a6
	;jsr	-180(a6)	; LVOCause
.exit	MOVEM.L	(SP)+,D0-A6
	rts

CheckEffects:
	tst.b	n_tracktogl(a6)
	RNE
	BSR	.chkefx
	bsr	SetAudXVol
	RTS
.chkefx	BSR	UpdateFunk
	MOVE.W	n_cmd(A6),D0
	AND.W	#$0FFF,D0
	REQ
	MOVE.B	n_cmd(A6),D0
	AND.B	#$0F,D0
	TST.B	D0
	BEQ	Arpeggio
	CMP.B	#1,D0
	BEQ	PortaUp
	CMP.B	#2,D0
	BEQ	PortaDown
	CMP.B	#3,D0
	BEQ	TonePortamento
	CMP.B	#4,D0
	BEQ	Vibrato
	CMP.B	#5,D0
	BEQ	TonePlusVolSlide
	CMP.B	#6,D0
	BEQ	VibratoPlusVolSlide
	CMP.B	#$E,D0
	BEQ	E_Commands
SetBack:MOVE.W	n_period(A6),AUDPER(A5)         ; AUDxPER
	CMP.B	#7,D0
	BEQ	Tremolo
	CMP.B	#$A,D0
	BEQ	VolumeSlide
	RTS

PerNop:	MOVE.W	n_period(A6),AUDPER(A5)	; AUDxPER
	RTS

Arpeggio:
	MOVEQ	#0,D0
	MOVE.L	Counter(PC),D0
	DIVS	#3,D0
	SWAP	D0
	CMP.W	#1,D0
	BEQ	Arpeggio1
	CMP.W	#2,D0
	BEQ	Arpeggio2
Arpeggio0:
	MOVE.W	n_period(A6),D2
	BRA	ArpeggioSet

Arpeggio1:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	LSR.B	#4,D0
	BRA	ArpeggioFind

Arpeggio2:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#15,D0
ArpeggioFind:
	ASL.W	#1,D0
	MOVEQ	#0,D1
	MOVE.B	n_finetune(A6),D1
	and.b	#$f,d1	; -maw- Don't forget to mask out higher nibble!
	MULU	#FINETUNETABLE_SIZE,D1
	LEA	PeriodTable(PC),A0
	ADD.L	D1,A0
	MOVEQ	#0,D1
	MOVE.W	n_period(A6),D1
	MOVEQ	#$24,D7
.loop	MOVE.W	0(a0,D0.W),D2
	CMP.W	(A0),D1
	BHS	ArpeggioSet
	ADDQ.L	#2,A0
	DBRA	D7,.loop
	RTS

ArpeggioSet:
	MOVE.W	D2,6(A5)	; AUDxPER
	RTS

FinePortaUp:
	TST.L	Counter
	RNE
	MOVE.B	#$0F,LowMask
PortaUp:MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	LowMask,D0
	MOVE.B	#$FF,LowMask
	SUB.W	D0,n_period(A6)
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#$0071,D0
	BPL.s	.skip
	AND.W	#$F000,n_period(A6)
	OR.W	#$0071,n_period(A6)
.skip	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)		; AUDxPER
	RTS

FinePortaDown:
	TST.L	Counter
	RNE
	MOVE.B	#$0F,LowMask
PortaDown:
	CLR.W	D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	LowMask,D0
	MOVE.B	#$FF,LowMask
	ADD.W	D0,n_period(A6)
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#$0358,D0
	BMI.s	.skip
	AND.W	#$F000,n_period(A6)
	OR.W	#$0358,n_period(A6)
.skip	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)                 ; AUDxPER
	RTS

SetTonePorta:
	MOVE.L	A0,-(SP)
	MOVE.W	(A6),D2
	AND.W	#$0FFF,D2
	MOVEQ	#0,D0
	MOVE.B	n_finetune(A6),D0
	and.b	#$f,d0	; -maw- Don't forget to mask out higher nibble!
	MULU	#FINETUNETABLE_SIZE,D0
	LEA	PeriodTable(PC),A0
	ADD.L	D0,A0
	MOVEQ	#0,D0
.loop	CMP.W	0(a0,D0.W),D2
	BHS.s	.found
	ADDQ.W	#2,D0
	CMP.W	#FINETUNETABLE_SIZE,D0
	BLO.s	.loop
	MOVEQ	#35*2,D0
.found	MOVE.B	n_finetune(A6),D2
	AND.B	#8,D2
	BEQ.s	.goss
	TST.W	D0
	BEQ.s	.goss
	SUBQ.W	#2,D0
.goss	MOVE.W	0(a0,D0.W),D2
	MOVE.L	(SP)+,A0
	MOVE.W	D2,n_wantedperiod(A6)
	MOVE.W	n_period(A6),D0
	CLR.B	n_toneportdirec(A6)
	CMP.W	D0,D2
	BEQ	ClearTonePorta
	RGE
	MOVE.B	#1,n_toneportdirec(A6)
	RTS

ClearTonePorta:
	CLR.W	n_wantedperiod(A6)
	RTS	

TonePortamento:
	MOVE.B	n_cmdlo(A6),D0
	BEQ	TonePortNoChange
	MOVE.B	D0,n_toneportspeed(A6)
	CLR.B	n_cmdlo(A6)
TonePortNoChange:
	TST.W	n_wantedperiod(A6)
	REQ
	MOVEQ	#0,D0
	MOVE.B	n_toneportspeed(A6),D0
	TST.B	n_toneportdirec(A6)
	BNE	TonePortaUp
TonePortaDown:
	ADD.W	D0,n_period(A6)
	MOVE.W	n_wantedperiod(A6),D0
	CMP.W	n_period(A6),D0
	BGT	TonePortaSetPer
	MOVE.W	n_wantedperiod(A6),n_period(A6)
	CLR.W	n_wantedperiod(A6)
	BRA	TonePortaSetPer

TonePortaUp:
	SUB.W	D0,n_period(A6)
	MOVE.W	n_wantedperiod(A6),D0
	CMP.W	n_period(A6),D0
	BLT	TonePortaSetPer
	MOVE.W	n_wantedperiod(A6),n_period(A6)
	CLR.W	n_wantedperiod(A6)

TonePortaSetPer:
	MOVE.W	n_period(A6),D2
	MOVE.B	n_glissfunk(A6),D0
	AND.B	#$0F,D0
	BEQ.s	.skip
	MOVEQ	#0,D0
	MOVE.B	n_finetune(A6),D0
	and.b	#$f,d0	; -maw- Don't forget to mask out higher nibble!
	MULU	#FINETUNETABLE_SIZE,D0
	LEA	PeriodTable(PC),A0
	ADD.L	D0,A0
	MOVEQ	#0,D0
.loop	CMP.W	(a0,D0.W),D2
	BHS.s	.found
	ADDQ.W	#2,D0
	CMP.W	#FINETUNETABLE_SIZE,D0
	BLO.s	.loop
	MOVEQ	#35*2,D0
.found	MOVE.W	(a0,D0.W),D2
.skip	MOVE.W	D2,AUDPER(A5) ; Set period		; AUDxPER
	RTS

Vibrato:MOVE.B	n_cmdlo(A6),D0
	BEQ	Vibrato2
	MOVE.B	n_vibratocmd(A6),D2
	AND.B	#$0F,D0
	BEQ.s	.skip
	AND.B	#$F0,D2
	OR.B	D0,D2
.skip	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	BEQ.s	.skip2
	AND.B	#$0F,D2
	OR.B	D0,D2
.skip2	MOVE.B	D2,n_vibratocmd(A6)
Vibrato2:
	move.l	a4,-(sp)
	MOVE.B	n_vibratopos(A6),D0
	LEA	VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	n_wavecontrol(A6),D2
	AND.B	#$03,D2
	BEQ.s	.sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.s	.rampdown
	MOVE.B	#255,D2
	BRA.s	.set
.rampdown
	TST.B	n_vibratopos(A6)
	BPL.s	.rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.s	.set
.rampdown2
	MOVE.B	D0,D2
	BRA.s	.set
.sine	MOVE.B	0(A4,D0.W),D2
.set	MOVE.B	n_vibratocmd(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#7,D2
	MOVE.W	n_period(A6),D0
	TST.B	n_vibratopos(A6)
	BMI.s	VibratoNeg
	ADD.W	D2,D0
	BRA.s	Vibrato3
VibratoNeg:
	SUB.W	D2,D0
Vibrato3:
	MOVE.W	D0,AUDPER(A5)			; AUDxPER
	MOVE.B	n_vibratocmd(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,n_vibratopos(A6)
	move.l	(sp)+,a4
	RTS

TonePlusVolSlide:
	BSR	TonePortNoChange
	BRA	VolumeSlide

VibratoPlusVolSlide:
	BSR	Vibrato2
	BRA	VolumeSlide

Tremolo:move.l	a4,-(sp)
	MOVE.B	n_cmdlo(A6),D0
	BEQ.s	Tremolo2
	MOVE.B	n_tremolocmd(A6),D2
	AND.B	#$0F,D0
	BEQ.s	.skip
	AND.B	#$F0,D2
	OR.B	D0,D2
.skip	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	BEQ.s	.skip2
	AND.B	#$0F,D2
	OR.B	D0,D2
.skip2	MOVE.B	D2,n_tremolocmd(A6)
Tremolo2:
	MOVE.B	n_tremolopos(A6),D0
	LEA	VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	n_wavecontrol(A6),D2
	LSR.B	#4,D2
	AND.B	#$03,D2
	BEQ.s	.sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.s	.rampdown
	MOVE.B	#255,D2
	BRA	.set
.rampdown
	TST.B	n_vibratopos(A6)
	BPL	.rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA	.set
.rampdown2
	MOVE.B	D0,D2
	BRA	.set
.sine	MOVE.B	(A4,D0.W),D2
.set	MOVE.B	n_tremolocmd(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#6,D2
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	TST.B	n_tremolopos(A6)
	BMI.s	TremoloNeg
	ADD.W	D2,D0
	BRA.s	Tremolo3
TremoloNeg:
	SUB.W	D2,D0
Tremolo3:
	BPL	TremoloSkip
	CLR.W	D0
TremoloSkip:
	CMP.W	#$40,D0
	BLS	TremoloOk
	MOVE.W	#$40,D0
TremoloOk:
	mulu	RelVolume(pc),d0
	add.l	#32,d0
	lsr.l	#6,d0	;divu	#MaxVol,d0
	MOVE.W	D0,AUDVOL(A5)			; AUDxVOL
	MOVE.B	n_tremolocmd(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,n_tremolopos(A6)
	move.l	(sp)+,a4
	ADDQ.L	#4,SP
	RTS

SampleOffset:	; this really has to be executed *before* playvoice!
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	BEQ.s	.nonew
	MOVE.B	D0,n_sampleoffset(A6)
.nonew	MOVE.B	n_sampleoffset(A6),D0
	LSL.L	#7,D0

	CMP.W	n_oldlength(A6),D0
	BGE.s	.skip
	move.w	n_oldlength(a6),d1
	sub.w	d0,d1
	move.w	d1,n_length(a6)
	add.l	d0,d0
	add.l	n_oldstart(a6),d0
	move.l	D0,n_start(A6)
	RTS
.skip	MOVE.W	#$0001,n_length(A6)
	RTS
;--------------------------
;--------------------------

VolumeSlide:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ	VolSlideDown
VolSlideUp:
	ADD.B	D0,n_volume(A6)
	CMP.B	#$40,n_volume(A6)
	BMI.s	.skip
	MOVE.B	#$40,n_volume(A6)
.skip	MOVE.B	n_volume(A6),D0
	RTS

VolSlideDown:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
VolSlideDown2:
	SUB.B	D0,n_volume(A6)
	BPL.s	.skip
	CLR.B	n_volume(A6)
.skip	MOVE.B	n_volume(A6),D0
	RTS

PositionJump:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	SUBQ.B	#1,D0
	MOVE.L	D0,SongPosition
pj2:	CLR.B	PBreakPosition
	ST 	PosJumpAssert
	RTS

VolumeChange:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	CMP.B	#$40,D0
	BLS	VolumeOk
	MOVEQ	#$40,D0
VolumeOk:
	MOVE.B	D0,n_volume(A6)		
	RTS

PatternBreak:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	MOVE.L	D0,D2
	LSR.B	#4,D0
	MULU	#10,D0
	AND.B	#$0F,D2
	ADD.B	D2,D0
	CMP.B	#63,D0
	BHI	pj2
	MOVE.B	D0,PBreakPosition
	ST	PosJumpAssert
	RTS

SetSpeed:
	MOVE.B	3(A6),D0
	AND.W	#$FF,D0
	BEQ.S	SpeedNull
	btst	#0,MiscBitFlags+3	;IntMode
	BEQ.S	normspd
	CMP.W	#32,D0
	BLO.S	normspd
	MOVE.W	D0,RealTempo
	MOVEM.L	D0-D7/A0-A6,-(SP)
	MOVE.W	SamScrEnable,-(SP)
	ST	SamScrEnable
	ST	UpdateTempo
	JSR	SetTempo
	MOVE.W	(SP)+,SamScrEnable
	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS
normspd:CLR.L	Counter
	MOVE.W	D0,CurrSpeed+2
	RTS
SpeedNull:
	CLR.L	RunMode
	JSR	SetNormalPtrCol
	RTS

CheckMoreEffects:
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#$9,D0
	BEQ	SampleOffset
	CMP.B	#$B,D0
	BEQ	PositionJump
	CMP.B	#$D,D0
	BEQ	PatternBreak
	CMP.B	#$E,D0
	BEQ	E_Commands
	CMP.B	#$F,D0
	BEQ	SetSpeed
	CMP.B	#$C,D0
	BEQ	VolumeChange
	BRA	PerNop	

AfterPlayVoice_CME: ; "after play voice " CheckMoreEffects
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#$B,D0
	BEQ	PositionJump
	CMP.B	#$D,D0
	BEQ	PatternBreak
	CMP.B	#$E,D0
	BEQ	E_Commands
	CMP.B	#$F,D0
	BEQ	SetSpeed
;	CMP.B	#$C,D0
;	BEQ	VolumeChange
	rts                     ; -maw- just rts, nothing else!
;	BRA	PerNop		; THIS IS NOT ALLOWED IF THE INTERRUPT DMA STUFF
				; IS SUPPOSED TO WORK!!!!!!!!!

E_Commands:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	LSR.B	#4,D0
	BEQ	FilterOnOff
	CMP.B	#1,D0
	BEQ	FinePortaUp
	CMP.B	#2,D0
	BEQ	FinePortaDown
	CMP.B	#3,D0
	BEQ	SetGlissControl
	CMP.B	#4,D0
	BEQ	SetVibratoControl
	CMP.B	#5,D0
	BEQ	SetFineTune
	CMP.B	#6,D0
	BEQ	JumpLoop
	CMP.B	#7,D0
	BEQ	SetTremoloControl
	CMP.B	#8,D0
	BEQ	KarplusStrong
	CMP.B	#$E,D0
	BEQ	PatternDelay
	CMP.B	#9,D0
	BEQ	RetrigNote
	CMP.B	#$A,D0
	BEQ	VolumeFineUp
	CMP.B	#$B,D0
	BEQ	VolumeFineDown
	CMP.B	#$C,D0
	BEQ	NoteCut
	CMP.B	#$D,D0
	BEQ	NoteDelay
	CMP.B	#$F,D0
	BEQ	FunkIt
	RTS

FilterOnOff:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#1,D0
	ASL.B	#1,D0
	AND.B	#$FD,$BFE001
	OR.B	D0,$BFE001
	RTS	

SetGlissControl:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,n_glissfunk(A6)
	OR.B	D0,n_glissfunk(A6)
	RTS

SetVibratoControl:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,n_wavecontrol(A6)
	OR.B	D0,n_wavecontrol(A6)
	RTS

SetFineTune:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	MOVE.B	D0,n_finetune(A6)
	RTS

JumpLoop:
	TST.L	Counter
	RNE
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BEQ	SetLoop
	TST.B	n_loopcount(A6)
	BEQ	jumpcnt
	SUB.B	#1,n_loopcount(A6)
	REQ
jmploop:MOVE.B	n_pattpos(A6),PBreakPosition
	ST	PBreakFlag
	RTS

jumpcnt:MOVE.B	D0,n_loopcount(A6)
	BRA	jmploop

SetLoop:MOVE.L	PatternPosition,D0
	LSR.L	#4,D0
	AND.B	#63,D0
	MOVE.B	D0,n_pattpos(A6)
	RTS

SetTremoloControl:
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,n_wavecontrol(A6)
	OR.B	D0,n_wavecontrol(A6)
	RTS

KarplusStrong:
	MOVEM.L	D1-D2/A0-A1,-(SP)
	MOVE.L	n_loopstart(A6),A0
	MOVE.L	A0,A1
	MOVE.W	n_replen(A6),D0
	ADD.W	D0,D0
	SUBQ.W	#2,D0
.loop	MOVE.B	(A0),D1
	EXT.W	D1
	MOVE.B	1(A0),D2
	EXT.W	D2
	ADD.W	D1,D2
	ASR.W	#1,D2
	MOVE.B	D2,(A0)+
	DBRA	D0,.loop
	MOVE.B	(A0),D1
	EXT.W	D1
	MOVE.B	(A1),D2
	EXT.W	D2
	ADD.W	D1,D2
	ASR.W	#1,D2
	MOVE.B	D2,(A0)
	MOVEM.L	(SP)+,D1-D2/A0-A1
	RTS

RetrigNote:
	MOVE.L	D1,-(SP)
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BEQ	rtnend
	MOVE.L	Counter,D1
	BNE	rtnskp
	MOVE.W	n_note(A6),D1
	AND.W	#$0FFF,D1
	BNE	rtnend
	MOVE.L	Counter,D1
rtnskp:	DIVU	D0,D1
	SWAP	D1
	TST.W	D1
	BNE	rtnend

DoRetrg:
;--  -maw-  This is the "no dma wait" version ----------
	tst.b	n_dynflag(a6)                  ; check if dyn
	bne	.is_dyn
; for normal samples
	move.l	a0,-(sp)
	move.w	ActiveChannels,d0               ; check if muted
	move.w	n_channel(a6),d1		; which channel was it?
	btst	d1,d0
	beq	.dontplay

	lea	_custom,a0                      ; Custom in a0
	st	n_normalsmp(a6)			; flag to start sample via interrupt
	clr.w	n_intcnt(a6)                    ; reset interrupt counter
	move.w	dmaconr(a0),d0		; check if dma of this channel was on
	btst	d1,d0                   ; d1 is channel (0-3)
	bne.s	.dma_was_on
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	bra.s	.dma_was_off
.dma_was_on:
	move.w	n_IntenaOff(a6),intena(a0)	; forbid Interrupts
	move.w	n_IntenaOff(a6),intreq(a0) 	; clear da interrupts
	move.w	n_DmaOff(A6),dmacon(a0)		; dma off
.dma_was_off:
	move.w	#1,AUDPER(A5)    		; max. speed of audio-dma cycles
	move.l	n_start(a6),AUDPTR(A5)		; Set start
	move.w	n_length(A6),AUDLEN(A5)		; Set length
        move.w	n_IntenaOn(a6),intena(a0)	; allow audio interrupts
	ST	n_trigger(A6)
.dontplay:
	move.l	(sp)+,a0
	bra.s	rtnend
;------
; for DYN samples
.is_dyn:					; here if DYN
	bsr	StartDyn

;-- end of "no dma wait" version of "DoRetrg" ---------

rtnend:	MOVE.L	(SP)+,D1
	RTS

VolumeFineUp:
	TST.L	Counter
	RNE
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F,D0
	BRA	VolSlideUp

VolumeFineDown:
	TST.L	Counter
	RNE
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BRA	VolSlideDown2

NoteCut:MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	CMP.L	Counter,D0
	RNE
	CLR.B	n_volume(A6)
;	MOVE.W	#0,8(A5)
	RTS

NoteDelay:
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	CMP.L	Counter,D0
	RNE
	MOVE.W	(A6),D0
	AND.W	#$0FFF,D0
	REQ
	MOVE.L	D1,-(SP)
	BRA	DoRetrg

PatternDelay:
	TST.L	Counter
	RNE
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	TST.B	PattDelayTime2
	RNE
	ADDQ.B	#1,D0
	MOVE.B	D0,PattDelayTime
	RTS

FunkIt:	TST.L	Counter
	RNE
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,n_glissfunk(A6)
	OR.B	D0,n_glissfunk(A6)
	TST.B	D0
	REQ
UpdateFunk:
	MOVEM.L	A0/D1,-(SP)
	MOVEQ	#0,D0
	MOVE.B	n_glissfunk(A6),D0
	LSR.B	#4,D0
	BEQ	funkend
	LEA	FunkTable(PC),A0
	MOVE.B	0(a0,D0.W),D0
	ADD.B	D0,n_funkoffset(A6)
	BTST	#7,n_funkoffset(A6)
	BEQ	funkend
	CLR.B	n_funkoffset(A6)
	MOVE.L	n_loopstart(A6),D0
	MOVEQ	#0,D1
	MOVE.W	n_replen(A6),D1
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	n_wavestart(A6),A0
	ADDQ.L	#1,A0
	CMP.L	D0,A0
	BLO.S	funkok
	MOVE.L	n_loopstart(A6),A0
funkok:	MOVE.L	A0,n_wavestart(A6)
	MOVEQ	#-1,D0
	SUB.B	(A0),D0
	MOVE.B	D0,(A0)
funkend:MOVEM.L	(SP)+,A0/D1
	RTS

;************************* End of Code ******************************

	cnop	0,4		; Longword aligned to please the CPU Cache!

FunkTable: dc.b 0,5,6,7,8,10,11,13,16,19,22,26,32,43,64,128

VibratoTable:
	dc.b 0,24,49,74,97,120,141,161
	dc.b 180,197,212,224,235,244,250,253
	dc.b 255,253,250,244,235,224,212,197
	dc.b 180,161,141,120,97,74,49,24


AllRightText:	dc.b	'All right',0
WriteProtectedText:dc.b	'The disk is WriteProtected!',0
OprAbortedText:	dc.b	'Print aborted!',0
EnterDataText:	dc.b	'Enter data',0
DiskErrorText:	dc.b	'Disk error!!',0
LoadingText:	dc.b	'Loading..',0
LoadingSongText:dc.b	'Loading song',0
LoadingModuleText:dc.b	'Loading module..',0
LoadingSampleText:dc.b	'Loading sample..',0
SavingText:	dc.b	'Saving..',0
SavingSongText:	dc.b	'Saving song',0
SavingModuleText:dc.b	'Saving module..',0
;SaveSampleText:dc.b	'Save this sample?',0
SavingSampleText:dc.b	'Saving your sample..',0
DeletingFileText:dc.b	'Deleting file...',0
RenamingFileText:dc.b	'Renaming file..',0
DecrunchingText:dc.b	'Decrunching...',0
CrunchingText:	dc.b	'Crunching...',0
SelectEntryText:dc.b	'Please select entry',0
SelectSongText:	dc.b	'Please select song',0
SelectModuleText:dc.b	'Please select module',0
SelectSampleText:dc.b	'Please select sample',0
SelectFileRenameText:dc.b	'Please select file to rename',0
SelectFileDeleteText:dc.b	'Please select file to delete!',0

ReadingDirText:	dc.b	'Reading dir...',0
PosSetText:	dc.b	'Position now set',0
PrintingSongText:dc.b	'Printing song..',0

SaveSongText:	dc.b	10,10,'Do you want to save',10
		dc.b	'       the song?',0
DeleteFileText:	dc.b	10,10,'  Delete this file?',0
SaveModuleText:	dc.b	10,10,'  Do you want to save',10
		dc.b	'      the module?',0
SaveSampleText:	dc.b	10,10,'Save this sample?',0
PrintSongText:	dc.b	10,10,'Print the song?',0
QuitPTText:	dc.b	10,10
		dc.b	'   Are you sure you',10
		dc.b	'    want to quit ?',0
		cnop	0,2
UpSampleText:	dc.b	10,10,'     Upsample?',0
DownSampleText:	dc.b	10,10,'     Downsample?',0
ClearSplitText:	dc.b	10,10,'     Clear split',10
		dc.b	      '    and transpose?',0
ResetAllText:	dc.b	10,10,'Reset the configuration?',0
KillSampleText:	dc.b	10,10,'   Kill this sample?',0
AbortLoadText:	dc.b	10,10,'    Abort loading?',0
LoadConfigText:	dc.b	'Load configuration?',0
SaveConfigText:	dc.b	10,10,'  Save configuration?',0
ItsAnOlder:	dc.b	10,10,'   Old configuration!',10
		dc.b	'      Load anyway?',0
DiskFormatText:	dc.b	'Disk format'
InProgressText:	dc.b	'in progress'
FormattingCylText:
		dc.b	'Formatting cyl ',0
VerifyingText:	dc.b	'Verifying  cyl ',0
InitDiskText:	dc.b	'Initializing',0
	cnop 0,2
	
SongDumpText:
	dc.b	9
	dc.b	'Protracker Song-Dump -- Made with '
	dc.b	'Protracker 3.15 ',$D,$A,$A
	dc.b	9
	dc.b	'Songname:  '
CRLF_Text:	dc.b	13,10
FF_Text:	dc.b	12,0

		cnop 0,2
PatternNumText:	dc.b	9,9,9,'Pattern: '
PattNumText1:	dc.b	'0'
PattNumText2:	dc.b	'0',$D,$A,$D,$A

PtotText:	dc.b	9
PattXText1:	dc.b	"0"
PattXText2:	dc.b	"0 : "
PpText:		dc.b	"                      "
Prafs:		dc.b	"  0000  0000  0000    ",$D,$A
PnText2:	dc.b	"        "
		cnop 0,2
		dc.b	0
PattPosText:	dc.b '00  :'
		dc.b '                                                       '
PnText:		dc.b '    ',0
		cnop 0,2

EmptyLineText:	dc.b	'                       ',0

FastHexTable:	dc.b	'000102030405060708090A0B0C0D0E0F'
		dc.b	'101112131415161718191A1B1C1D1E1F'
		dc.b	'202122232425262728292A2B2C2D2E2F'
		dc.b	'303132333435363738393A3B3C3D3E3F'
		dc.b	'404142434445464748494A4B4C4D4E4F'
		dc.b	'505152535455565758595A5B5C5D5E5F'
		dc.b	'606162636465666768696A6B6C6D6E6F'
		dc.b	'707172737475767778797A7B7C7D7E7F'
		dc.b	'808182838485868788898A8B8C8D8E8F'
		dc.b	'909192939495969798999A9B9C9D9E9F'
		dc.b	'A0A1A2A3A4A5A6A7A8A9AAABACADAEAF'
		dc.b	'B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF'
		dc.b	'C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF'
		dc.b	'D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF'
		dc.b	'E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF'
		dc.b	'F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF'

TrackdiskName:	dc.b	'trackdisk.device',0
InputDevName:	dc.b	'input.device',0
	cnop	0,2
DosBase:	dc.l	0
IntuitionBase:	dc.l	0
GfxBase:	dc.l	0
TransBase:	dc.l	0
FFPBase:	dc.l	0

RawKeyHexTable:
	dc.b	10,1,2,3,4,5,6,7
	dc.b	8,9,32,53,51,34,18,35
RawKeyScaleTable:
	dc.b	49,33,50,34,51,52,36,53,37,54,38,55,56,40,57
	dc.b	41,58,16,2,17,3,18,19,5,20,6,21,7,22,23,9,24,10
	dc.b	25,26,12,27,70,70,0

KbdTransTable1:
	dc.b	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16
	dc.b	12,13,14,15,16,17,18,19,20,21,22,23
	dc.b	24,25,26,27,28,29,30,31,36,36
KbdTransTable2:
	dc.b	12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28
	dc.b	24,25,26,27,28,29,30,31,32,33,34,35
	dc.b	36,36,36,36,36,36,36,36,36,36
NoteNames1:
	dc.b	'C-1 C#1 D-1 D#1 E-1 F-1 F#1 G-1 G#1 A-1 A#1 B-1 '
	dc.b	'C-2 C#2 D-2 D#2 E-2 F-2 F#2 G-2 G#2 A-2 A#2 B-2 '
	dc.b	'C-3 C#3 D-3 D#3 E-3 F-3 F#3 G-3 G#3 A-3 A#3 B-3 '
SpcNoteText:
	dc.b	'--- '
NoteNames2:
	dc.b	'C-1 D^1 D-1 E^1 E-1 F-1 G^1 G-1 A^1 A-1 B^1 B-1 '
	dc.b	'C-2 D^2 D-2 E^2 E-2 F-2 G^2 G-2 A^2 A-2 B^2 B-2 '
	dc.b	'C-3 D^3 D-3 E^3 E-3 F-3 G^3 G-3 A^3 A-3 B^3 B-3 '
	dc.b	'--- '

PeriodTable:
; Tuning 0
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113,0
; Tuning 1
	dc.w	850,802,757,715,674,637,601,567,535,505,477,450
	dc.w	425,401,379,357,337,318,300,284,268,253,239,225
	dc.w	213,201,189,179,169,159,150,142,134,126,119,113,0
; Tuning 2
	dc.w	844,796,752,709,670,632,597,563,532,502,474,447
	dc.w	422,398,376,355,335,316,298,282,266,251,237,224
	dc.w	211,199,188,177,167,158,149,141,133,125,118,112,0
; Tuning 3
	dc.w	838,791,746,704,665,628,592,559,528,498,470,444
	dc.w	419,395,373,352,332,314,296,280,264,249,235,222
	dc.w	209,198,187,176,166,157,148,140,132,125,118,111,0
; Tuning 4
	dc.w	832,785,741,699,660,623,588,555,524,495,467,441
	dc.w	416,392,370,350,330,312,294,278,262,247,233,220
	dc.w	208,196,185,175,165,156,147,139,131,124,117,110,0
; Tuning 5
	dc.w	826,779,736,694,655,619,584,551,520,491,463,437
	dc.w	413,390,368,347,328,309,292,276,260,245,232,219
	dc.w	206,195,184,174,164,155,146,138,130,123,116,109,0
; Tuning 6
	dc.w	820,774,730,689,651,614,580,547,516,487,460,434
	dc.w	410,387,365,345,325,307,290,274,258,244,230,217
	dc.w	205,193,183,172,163,154,145,137,129,122,115,109,0
; Tuning 7
	dc.w	814,768,725,684,646,610,575,543,513,484,457,431
	dc.w	407,384,363,342,323,305,288,272,256,242,228,216
	dc.w	204,192,181,171,161,152,144,136,128,121,114,108,0
; Tuning -8
	dc.w	907,856,808,762,720,678,640,604,570,538,508,480
	dc.w	453,428,404,381,360,339,320,302,285,269,254,240
	dc.w	226,214,202,190,180,170,160,151,143,135,127,120,0
; Tuning -7
	dc.w	900,850,802,757,715,675,636,601,567,535,505,477
	dc.w	450,425,401,379,357,337,318,300,284,268,253,238
	dc.w	225,212,200,189,179,169,159,150,142,134,126,119,0
; Tuning -6
	dc.w	894,844,796,752,709,670,632,597,563,532,502,474
	dc.w	447,422,398,376,355,335,316,298,282,266,251,237
	dc.w	223,211,199,188,177,167,158,149,141,133,125,118,0
; Tuning -5
	dc.w	887,838,791,746,704,665,628,592,559,528,498,470
	dc.w	444,419,395,373,352,332,314,296,280,264,249,235
	dc.w	222,209,198,187,176,166,157,148,140,132,125,118,0
; Tuning -4
	dc.w	881,832,785,741,699,660,623,588,555,524,494,467
	dc.w	441,416,392,370,350,330,312,294,278,262,247,233
	dc.w	220,208,196,185,175,165,156,147,139,131,123,117,0
; Tuning -3
	dc.w	875,826,779,736,694,655,619,584,551,520,491,463
	dc.w	437,413,390,368,347,328,309,292,276,260,245,232
	dc.w	219,206,195,184,174,164,155,146,138,130,123,116,0
; Tuning -2
	dc.w	868,820,774,730,689,651,614,580,547,516,487,460
	dc.w	434,410,387,365,345,325,307,290,274,258,244,230
	dc.w	217,205,193,183,172,163,154,145,137,129,122,115,0
; Tuning -1
	dc.w	862,814,768,725,684,646,610,575,543,513,484,457
	dc.w	431,407,384,363,342,323,305,288,272,256,242,228
	dc.w	216,203,192,181,171,161,152,144,136,128,121,114,0

CursorPosTable:	
	dc.b	03,06,07,08,09,10,11
	dc.b	13,16,17,18,19,20,21
	dc.b	23,26,27,28,29,30,31
	dc.b	33,36,37,38,39,40,41
UnshiftedKeymap:
	dc.b	'`1234567890-=\*0'
	dc.b	'qwertyuiop[]*123'
	dc.b	'asdfghjkl;',39,'#',0,'456'
	dc.b	'<zxcvbnm,./',0,'.','789 '
ShiftedKeymap:
	dc.b	'~!@#$%^&*()_+|*0'
	dc.b	'qwertyuiop{}*123'
	dc.b	'asdfghjkl:',34,'^',0,'456'
	dc.b	'>zxcvbnm<>?',0,'.','789 '
	cnop	0,2
; -maw-----------------
; stuff needed for the IFF reader

MawSampleLoaderText:	dc.b "Maw's sample loader active...",0
IffErrFiboText:		dc.b 'IFF error: Fibonacci compression unsupported!',0
IffErrOctvText:		dc.b 'IFF error: only 1 octave samples supported!',0
IffErrNoBodyText:	dc.b 'IFF error: Body not found!',0
IffErr8svxText:		dc.b 'IFF error: Not an 8SVX file!',0
IffErrNoVhdrText:	dc.b 'IFF error: Vhdr not found!',0
mae_error_txt:		dc.b "Not a Maestro 16 bit mono sample!",0
MaeUpsampleText:	dc.b "Upsampling Maestro file...",0
NoChipMemText:		dc.b 'Could not allocate chip memory!',0
NoDynMemText:		dc.b 'Could not allocate DYN memory!',0
NoTmpMemText:		dc.b 'Could not allocate any memory!',0
UnDynIffText:		dc.b "Undynning...",0

IFFHeaderInfo:
	dc.b 'IFF header information:',10
	dc.b 'NAME: '
IFFHd_Name:
	dcb.b IFFHD_STRSIZE," "
	dc.b 10
	dc.b 'AUTH: '
IFFHd_Auth:
	dcb.b IFFHD_STRSIZE," "
	dc.b 10
	dc.b 'COPY: '
IFFHd_Copy:
	dcb.b IFFHD_STRSIZE," "
	dc.b 10
	dc.b 'ANNO: '
IFFHd_Anno:
	dcb.b IFFHD_STRSIZE," "
	dc.b 10
	dc.b 'DYN : '
IFFHd_Dyn:
	dcb.b IFFHD_STRSIZE," "
	dc.b 0

IFF_na_txt:
	dc.b '- not available -',0

	EVEN
IFF8SVX_ChunkTable:
	dc.l 	"VHDR",proc_vhdr
	dc.l 	"NAME",proc_name
	dc.l	"AUTH",proc_auth
	dc.l	"ANNO",proc_anno
	dc.l 	"(c) ",proc_copy
	dc.l	"DYN ",proc_dyn
	dc.l 	"BODY",proc_body
	dc.l	0,0

; some variables needed:

body_start: 	dc.l 0	; start of real sample body
body_length: 	dc.l 0	; length of real sample body
body_end:	dc.l 0
TmpDataPtr:	dc.l 0	; ptr to temporary file buffer
TmpDataSize:	dc.l 0	; length of temporary file buffer
form_start:	dc.l 0	; start of IFF-Form
form_length:	dc.l 0	; length of IFF-Form
form_end:	dc.l 0	; end of IFF-Form
unknown_chunks:	dc.w 0 	; number of unknown chunks encountered
loop_start:	dc.l 0  ; well, what can this be? ;-)
loop_length:	dc.l 0
dyn_start: 	dc.l 0	; Start of dyn chunk
dyn_length:	dc.l 0	; length of dyn chunk
DynPtr:		dc.l 0	; Pointer to dyntable of sample
sample_freq:	dc.l 0	; sample frequency (Hz)
error_scansam_msg:	dc.l 0 	; pointer to an error text
error_scansam:	dc.b 0	; if true, indicating an error
kind_of_sim:	dc.b 0	; kind of sample in memory
iff_flag:	dc.b 0
	cnop	0,2
DynFlagMask:	dc.l 0	; flag mask: bit set means sample is a dyn sample
DynPartPtrs:	dc.l	DynPartMem
		dc.l	DynPartMem+1*DynPartTabSIZE
		dc.l	DynPartMem+2*DynPartTabSIZE
		dc.l	DynPartMem+3*DynPartTabSIZE
CiaintTestColor:	dc.w 0
SoftintTestColor:	dc.w 0
PlayTestColor: 		dc.w 0
; -mawend--------------------

RelVolume:	dc.w	MaxVol
SongNumOfPatt:	dc.w	1
NoteNamesPtr:	dc.l	0
CursorPosPtr:	dc.l	0
SpritePtrsPtr:	dc.l	0
LineCurPosPtr:	dc.l	0
ColSpritePtr:	dc.l	0
DragBarPosPtr:	dc.l	0
Ch1SpritePtr:	dc.l	0
Ch2SpritePtr:	dc.l	0
Ch3SpritePtr:	dc.l	0
Ch4SpritePtr:	dc.l	0
PPattPos:	dc.l	0
SaveEditMode:	dc.l	0
EditMode:	dc.l	0
RunMode:	dc.l	0
CurrCmds:	dc.l	0
TextBplPtr:	dc.l	0
TextOffset:	dc.w	0
TextLength:	dc.w	0
TextLenTemp:	dc.l	0
ShowTextPtr:	dc.l	0
PatternNumber:	dc.l	0
CurrPos:	dc.l	0
CurrSpeed:	dc.l	0
KeyTransTabPtr:	dc.l	0
CmdOffset:	dc.w	0
RawKeyCode:	dc.b	0
PattRfsh:	dc.b	0
MountFlag:	dc.w	0
GetLineFlag:	dc.w	0
LoadInProgress:	dc.w	0
KbIntSave:	dc.l	0
KbIntSavePtr:	dc.l	0
CurrentPlayNote:dc.w	214
LineCurX:	dc.w	0
LineCurY:	dc.w	0
TextEndPtr:	dc.l	0
ScrPattPos:	dc.w	0
PattCurPos:	dc.w	0
GadgRepeat:	dc.w	0
WordNumber:	dc.w	0
HighPattNum:	dc.w	0
InsNum:		dc.w	0
LastInsNum:	dc.w	1
PlayInsNum:	dc.w	1
HiLowInstr:	dc.w	0
UpOrDown:	dc.w	0

MsRealY:	dc.w	0
MouseX:		dc.w	0
MouseY:		dc.w	0
MouseX2:	dc.w	0
MouseY2:	dc.w	0
MouseX3:	dc.w	0
MouseY3:	dc.w	0
DeltaX:		dc.w	0
DeltaY:		dc.w	0

SampleInfo:	dc.w	0		; 0	; the nasty multipurpose SampleInfo
si_volume:	dc.w	0               ; 2
si_long:	dc.l	0               ; 4
si_pointer:	dc.l	0,0,0,0,0       ; 8,12,16,20,24
SampleInfo2:	dc.w	0
si_volume2:	dc.w	0
si_long2:	dc.l	0
si_pointer2:	dc.l	0,0,0,0,0

LongFFFF:	dc.l	0
PosJumpAssert:	dc.b	0
PBreakPosition:	dc.b	0
PBreakFlag:	dc.b	0
LEDStatus:	dc.b	0
PattDelayTime:	dc.b	0
PattDelayTime2:	dc.b	0
PattRfshNum:	dc.l	0
DidQuantize:	dc.w	0
MessagePtr:	dc.l	0
FileNamePtr:	dc.l	0
DiskDataPtr:	dc.l	0
FileHandle:	dc.l	0
DiskDataLength:	dc.l	0
LowMask:	dc.b	$FF
InRedraw:	dc.b	0	; flag
NewPosition:	dc.b	0	; flag
		cnop	0,2
PatternPosition:dc.l	0
SongPosition:	dc.l	0
Counter:	dc.l	0
PatternPtr:	dc.l	0
SongDataPtr:	dc.l	0
SampleStarts:	dcb.l	31,0
SamplePtrs	EQU	SampleStarts-4
SampleLengths:	dcb.l	32,0
;DMACONtemp:	dc.w	0 obsolete! -maw-
StackSave:	dc.l	0
InputDevMouse:	dc.l	0,0,0
Action:		dc.w	0
SaveAction:	dc.w	0
PathPtr:	dc.l	0
FileLock:	dc.l	0
CurrScreen:	dc.w	MainScreen_ID
SaveCurrScreen:	dc.w	0
PointerCol1Save:dc.w	0
PointerCol2Save:dc.w	0
PointerCol3Save:dc.w	0
GetDecTemp:	dc.b	0
UpdateTempo:	dc.b	0
MoreInstrFlag:	dc.w	0
SampleSortList:	dcb.l	32,0
SaveScope:	dc.b	0
		dc.b	0 ;free 0
		dc.b	0
ReqRunning:	dc.b	0
NoSampleInfo:	dc.b	0
		cnop	0,2
FormatDataPtr:	dc.l	0
CylinderNumber:	dc.w	0
TrackdiskPort:	dc.l	0,0,0,0
ProcessPtr:	dc.l	0,0,0,0
DateStamp:	dc.l	0,0,0,0
NoteAddr:	dc.l	0
EnterTextFlag:	dc.w	0
SplitAddress:	dc.l	0
LaHeTx:		dc.l	$12345678

;******************************************************************************

	; Default setup
DefaultSetupFile:
	dc.l	"FORM",setuplen
setupchk
	dc.l	"PTCF"
;------------------------------------
	dc.l	"VERS",.len1
.chk1	dc.l	302
	dc.b	'$VER: ProTrackerV3.15 (16/06/93)',0
	cnop	0,2
.len1 = *-.chk1
;------------------------------------
	;MiscSetupData
	dc.l	"MISC",.len2
.chk2	dc.l	$00000007	; Flags

	dc.w	24  		; TuneNote (C-3)
	dc.w	$20 		; TToneVol
	dc.w	$1f		; TToneSample

	dc.w	125 		; Tempo
	dc.w	6 		; DefaultSpeed
	dc.w	0 		; Was DMAWait

	dc.b	'PRT:'
	ds.b	32-4

	dc.w	20,2    	; KeyRepDelay/Speed

.len2 = *-.chk2
;------------------------------------
	;ScreenSetupData
	dc.l	"SCRN",.len3
.chk3	dc.l	$00000000	;Flags

	dc.w	0,0		; x,y, pos of screen

	dc.w	$006,$CDF,$68B,$338,$FD0,$D04,$000,$34F	; screen cols

	dc.w	$500,$610,$810,$920,$a20,$b30,$c30,$d40 ; VU-Meter
	dc.w	$d50,$e60,$e60,$f70,$f80,$f90,$fa0,$fb0 ; colors
	dc.w	$fc0,$fd0,$fe0,$ee0,$ee0,$ef0,$ef0,$df0
	dc.w	$df0,$cf0,$cf0,$bf0,$ae0,$9e0,$9d0,$8c0
	dc.w	$7c0,$6b0,$6a0,$5a0,$490,$390,$380,$380
	dc.w	$270,$270,$260,$160,$150,$150,$040,$040

	dc.b	2	; VUMeterMode

	cnop	0,2

.len3 = *-.chk3
;------------------------------------
	;EditSetupData
	dc.l	"EDIT",.len4
.chk4	dc.l	$00000020	; Flags

	dc.b	2,3,4,1		; Multi Mode Next

	dc.b	1,$18,$18,0	; SplitData
	dc.b	2,$1A,$18,0
	dc.b	3,$1C,$18,0
	dc.b	4,$1D,$18,0

	; Default cmds
	dc.w	$102,$202,$037,$047,$304,$F06,$C10,$C20,$E93,$A0F

.len4 = *-.chk4
;------------------------------------
	;DiskSetupData
	dc.l	"DISK",.len5
.chk5	dc.l	$00000044	; Flags

	dc.b	1 		; RAW/IFF Save, 0=RAW, 1=IFF, 2=PAK
	dc.b	0   		; PowerPacker efficiency

	dc.b	'ST-00:EXECUTABLE'
	ds.b	108-16
	dc.b	'ST-00:MODULES'
	ds.b	108-13
	dc.b	'ST-00:SONGS'
	ds.b	108-11
	dc.b	'ST-00:INSTRUMENTS'
	ds.b	108-17
	dc.b	'ST-01:'
	ds.b	108-6
	dc.b	'ST-00:PATTERNS'
	ds.b	108-14

	dc.b	'#?.EXE'
	ds.b	32-6
	dc.b	'#?MOD#?'
	ds.b	32-7
	dc.b	'#?'
	ds.b	32-2
	dc.b	'#?.INS'
	ds.b	32-6
	dc.b	'#?'
	ds.b	32-2
	dc.b	'#?.PAT'
	ds.b	32-6

.len5 = *-.chk5
;------------------------------------
setuplen = *-setupchk

;******************************************************************************
;GadgetLists:   ID, x0,y0, x1,y1

DirGadgetsList:
	dc.w	1,1,0,0,99,10		; [Main Menu]
	dc.w	2,1,0,11,99,21		; [Pack] on/off
	dc.w	3,1,0,22,99,32		; [SampForm] iff/raw
	;dc.w	4,1,0,33,99,43		; [Save Icon] on/off
	dc.w	5,1,0,44,99,54		; [Hide/Show .info] on/off
	dc.w	6,1,0,55,99,65		; [Reset Paths]
	dc.w	7,1,0,66,99,76		; [Format Disk]
	dc.w	8,1,0,77,99,87		; [Relabel Disk]
	dc.w	9,0,0,88,99,98		; [Mask]
	dc.w	10,1,100,0,199,10	; [Makedir]
	dc.w	11,1,100,11,199,21	; [Rename file]
	dc.w	12,1,100,22,199,32	; [Delete file]
	dc.w	13,0,0,99,216,109	; [Path]
	dc.w	14,0,0,110,216,120	; [FileName]
	dc.w	15,1,624,0,639,10	; [] Flip Screen
	dc.w	16,1,200,0,259,10	; [Read Dir]
	dc.w	17,1,260,0,319,10	; [Parent]
	dc.w	18,1,217,110,319,120	; [] Exe./Module/Song/Ins/Sample/Patt

	dc.w	20,0,100,33,110,43	; [ ] Exe.
	;dc.w	21,1,111,33,199,43	; [Save Exe.]
	dc.w	22,0,100,44,110,54	; [ ] Module
	dc.w	23,1,111,44,199,54	; [Save Module]
	dc.w	24,0,100,55,110,65	; [ ] Song
	dc.w	25,1,111,55,199,65	; [Save Song]
	dc.w	26,0,100,66,110,76	; [ ] Instr.
	;dc.w	27,1,111,66,199,76	; [Save Instr.]
	dc.w	28,0,100,77,110,87	; [ ] Sample
	dc.w	29,1,111,77,199,87	; [Save Sample]
	dc.w	30,0,100,88,110,98	; [ ] Patt.
	;dc.w	31,1,111,88,199,98	; [Save Patt.]

	dc.w	32,0,624,11,639,21	; [] Arrow up
	dc.w	33,0,624,22,639,108	; [] Dragbar
	dc.w	34,0,624,109,639,120	; [] Arrow down
	dc.w	37,1,217,99,319,109	; [Free]
	dc.w	38,0,322,3,624,117	; [] File area

	dc.w	100,1,200,11,259,21	; [] Devs...
	dc.w	101,1,260,11,319,21	; [] Devs...
	dc.w	102,1,200,22,259,32	; [] Devs...
	dc.w	103,1,260,22,319,32	; [] Devs...
	dc.w	104,1,200,33,259,43	; [] Devs...
	dc.w	105,1,260,33,319,43	; [] Devs...
	dc.w	106,1,200,44,259,54	; [] Devs...
	dc.w	107,1,260,44,319,54	; [] Devs...
	dc.w	108,1,200,55,259,65	; [] Devs...
	dc.w	109,1,260,55,319,65	; [] Devs...
	dc.w	110,1,200,66,259,76	; [] Devs...
	dc.w	111,1,260,66,319,76	; [] Devs...
	dc.w	112,1,200,77,259,87	; [] Devs...
	dc.w	113,1,260,77,319,87	; [] Devs...
	dc.w	114,1,200,88,259,98	; [] Devs...
	dc.w	115,1,260,88,319,98	; [] Devs...
	dc.w	0,0,0,0,0,0		; #no gadgets hit#

DirGadgetsList2:			; When right button pressed
	dc.w	1,0,200,11,319,98	; Devs area
	dc.w	10,0,100,33,110,43	; [ ] Exe.
	dc.w	11,0,100,44,110,54	; [ ] Module
	dc.w	12,0,100,55,110,65	; [ ] Song
	dc.w	13,0,100,66,110,76	; [ ] Instr.
	dc.w	14,0,100,77,110,87	; [ ] Sample
	dc.w	15,0,100,88,110,98	; [ ] Patt.
	dc.w	0,0,0,0,0,0		; #no gadgets hit#

SamplerGadgetsList:
	dc.w	1,1,0,212,43,222	;[Exit]
	dc.w	2,0,0,138,639,203	;[Sample Window]
	dc.w	3,0,2,205,637,212	;[Dragbar Window]
	dc.w	4,1,44,214,123,222	;[Waveform]
	dc.w	5,1,124,212,239,222	;[Show Range]
	dc.w	6,1,240,212,319,222	;[Zoom Out]
	;dc.w	8,1,320,212,399,222	;[Seek Zero]
	dc.w	10,1,0,223,43,244	;[Stop]
	dc.w	11,1,44,223,123,233	;[Display]
	dc.w	12,1,124,223,239,233	;[Show All]
	dc.w	13,1,240,223,319,233	;[Range All]
	dc.w	14,1,320,223,399,233	;[Loop]
	dc.w	16,1,44,234,123,244	;[Range]
	dc.w	17,1,124,234,150,244	;[Beg]
	dc.w	18,1,151,234,177,244	;[End]
	dc.w	19,1,178,234,239,244	;[Swap Buf]
	dc.w	20,1,240,234,319,244	;[Sample]
	dc.w	21,1,320,234,399,244	;[Note]
	dc.w	23,1,0,245,43,255	;[Cut]
	dc.w	24,1,44,245,80,255	;[Copy]
	dc.w	25,1,81,245,123,255	;[Paste]
	dc.w	26,1,124,245,177,255	;[Volume]
	dc.w	27,1,178,245,239,255	;[Tunetone]
	dc.w	28,1,240,245,319,255	;[Resample]
	dc.w	29,1,320,245,399,255	;[Note]
	dc.w	30,0,400,212,479,222	;[Disp:]
	dc.w	31,0,400,223,479,233	;[Pos:]
	dc.w	32,0,400,234,479,244	;[Rang:]
	dc.w	34,1,400,245,479,255	;[Invert]
	dc.w	35,1,480,212,559,222	;[Maximize]
	dc.w	36,1,480,223,559,233	;[Normalize]
	dc.w	37,1,480,234,559,244	;[NormalDC]
	dc.w	38,1,480,245,559,255	;[Backwards]
	dc.w	39,1,560,212,639,222	;[Boost]
	dc.w	40,1,560,223,639,233	;[Interpolate]
	dc.w	41,1,560,234,639,244	;[Upsample]
	dc.w	42,1,560,245,639,255	;[Downsample]
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

SetupGadgetList:
	dc.w	01,1,0,0,107,10		;[Main menu]
	dc.w	02,1,0,11,83,21		;[Load Config]
	dc.w	03,1,0,22,83,32		;[Save Config]
	dc.w	04,0,84,11,107,32	;[Cnfig]
	;dc.w	04,0,84,22,107,32	;[] Config number
	dc.w	05,1,0,33,107,43	;[Reset All]
	dc.w	06,0,108,0,193,10	;[Tempo]
	dc.w	07,0,194,0,204,10	;[] Tempo Up
	dc.w	08,0,205,0,215,10	;[] Tempo Down
	dc.w	09,0,108,11,193,21	;[Speed]
	dc.w	10,0,194,11,204,21	;[] Speed Up
	dc.w	11,0,205,11,215,21	;[] Speed Down
	dc.w	12,1,108,22,215,32	;[Timing:]

	dc.w	14,0,108,33,215,43	;[] Softint:  -maw- (was: DMAWait)

	dc.w	26,1,264,0,317,10	;[Clear->]
	dc.w	27,0,318,11,419,54	;[Sample]
	;dc.w	28,0,318,11,345,21	;[] Sample 1
	;dc.w	29,0,318,22,345,32	;[] Sample 2
	;dc.w	30,0,318,33,345,43	;[] Sample 3
	;dc.w	31,0,318,44,345,54	;[] Sample 4
	;dc.w	32,0,346,0,385,10	;[Split]
	;dc.w	33,0,346,11,385,21	;[] Split 1
	;dc.w	34,0,346,22,385,32	;[] Split 2
	;dc.w	35,0,346,33,385,43	;[] Split 3
	;dc.w	36,0,346,44,385,54	;[] Split 4
	;dc.w	37,0,386,0,419,10	;[Trans]
	;dc.w	38,0,386,11,419,21	;[] Trans 1
	;dc.w	39,0,386,22,419,32	;[] Trans 2
	;dc.w	40,0,386,33,419,43	;[] Trans 3
	;dc.w	41,0,386,44,419,54	;[] Trans 4
	dc.w	42,0,318,55,419,65	;[KeyRep:]
	dc.w	43,1,318,66,419,76	;[Accidental:]
	dc.w	44,1,318,77,419,87	;[Print Song]
	dc.w	45,0,318,88,419,98	;[] Print Song (DEV)
	dc.w	46,1,318,99,419,109	;[] PP Eff.
	dc.w	47,1,318,110,419,120	;[] VUMeter mode

	; Color req.
	dc.w	64,1,0,77,31,87		;[Copy]
	dc.w	65,1,32,77,77,87	;[Spread]
	dc.w	66,1,0,88,31,98		;[Swap]
	dc.w	67,1,32,88,77,98	;[Cancel]
	dc.w	68,1,78,88,107,98	;[Def.]
	dc.w	69,0,78,77,92,87	;[] Col.bar Up
	dc.w	70,0,93,77,107,87	;[] Col.bar Down
	dc.w	71,0,81,47,105,71	;[] Color req.
	dc.w	72,0,108,44,136,98	;[] Col.bar req.
	dc.w	73,0,22,46,78,51	;[] Red req.
	dc.w	74,0,22,57,78,62	;[] Green req.
	dc.w	75,0,22,68,78,73	;[] Blue req.

	dc.w	76,0,137,44,215,74	;[] Screen drag gadget, smaller now -maw-

	dc.w	80,1,216,0,263,10	;[\/Default]
	dc.w	81,0,216,11,317,21	;[TuneNote:]
	dc.w	82,0,216,22,295,32	;[TuneVol:]
	dc.w	83,0,296,22,306,32	;[] TVol Up
	dc.w	84,0,307,22,317,32	;[] TVol Down

	dc.w	85,0,216,33,317,43	;[] TestCol on/off ;-maw-
	dc.w	86,0,216,44,317,54	;[] Dmaconr on/off ;-maw-	

	;dc.w	87,0,216,55,317,65	;[]
	;dc.w	88,0,216,66,317,76	;[]
	;dc.w	89,0,216,77,317,87	;[]
	;dc.w	90,0,216,88,317,98	;[]
	;dc.w	91,0,216,99,317,109	;[]
	;dc.w	92,0,216,110,317,120	;[Recover Song]

; comments seem to be wrong!!! :-( -maw-
	dc.w	98,0,420,0,623,10	;[Default setupflags]
	dc.w	99,1,624,0,639,10	;[] Screen to Back
	dc.w	100,1,420,11,529,21	;[Split:]
	dc.w	101,1,420,22,529,32	;[Trans del:]
	dc.w	102,1,420,33,529,43	;[RecHold:]
	dc.w	103,1,420,44,529,54	;[BlankZero:]
	dc.w	104,1,420,55,529,65	;[ShowDec:]
	dc.w	105,1,420,66,529,76	;[Filter:]
	dc.w	106,1,420,77,529,87	;[NTSC:]
	dc.w	107,1,420,88,529,98	;[VUMeters:]
	dc.w	108,1,420,99,529,109	;[undyn iff]
	dc.w	109,1,420,110,529,120	;[undyn mod]
	dc.w	110,1,530,11,639,21	;[Override]
	dc.w	111,1,530,22,639,32	;[NoSamples]
	dc.w	112,1,530,33,639,43	;[Show dirs]
	dc.w	113,1,530,44,639,54	;[LoadLoop]
	dc.w	114,1,530,55,639,65	;[AutoDir]
	dc.w	115,1,530,66,639,76	;[AutoExit]
	dc.w	116,1,530,77,639,87	;[CutToBuf]
	dc.w	117,1,530,88,639,98	;[Laced]
	; dc.w	118,1,530,99,639,109	;[]
	;dc.w	119,1,530,110,639,120	;[]

	dc.w	0,0,0,0,0,0		;#no gadgets hit#

PatternGadgetList:
	dc.w	1,0,559,142,578,152	; [] Pattern Number
	dc.w	4,0,522,151,531,251	; [] Dragbar area
	dc.w	5,0,629,144,636,151	; Tempo Up
	dc.w	6,0,595,144,603,151	; Tempo Down
	dc.w	7,0,547,144,555,151	; Patt <
	dc.w	8,0,582,144,590,151	; Patt >
	dc.w	9,1,544,157,639,167	; [@ Track/Patt/Cmds/Block...]

	dc.w	41,0,45,149,157,253	; Track1
	dc.w	42,0,165,149,277,253	; Track2
	dc.w	43,0,285,149,397,253	; Track3
	dc.w	44,0,405,149,516,253	; Track4

	dc.w	45,0,68,141,132,146	; Track 1 toggle
	dc.w	46,0,188,141,252,146	; Track 2 toggle
	dc.w	47,0,308,141,372,146	; Track 3 toggle
	dc.w	48,0,428,141,492,146	; Track 4 toggle

	dc.w	60,1,544,168,591,178	; [Insert]
	dc.w	61,1,544,179,591,189	; [Delete]
	dc.w	62,1,544,190,591,200	; [Clear]
	dc.w	63,1,544,201,591,211	; [Flip]
	dc.w	64,1,544,212,591,222	; [Oct. Up]
	dc.w	65,1,544,223,591,233	; [Note Up]
	dc.w	66,1,544,234,591,244	; [Scr. Up]
	dc.w	67,1,544,245,591,255	; [Rot. Up]

	dc.w	68,1,592,168,639,178	; [Cut]
	dc.w	69,1,592,179,639,189	; [Copy]
	dc.w	70,1,592,190,639,200	; [Paste]
	dc.w	71,1,592,201,639,211	; [Exchg]
	dc.w	72,1,592,212,639,222	; [Oct. Down]
	dc.w	73,1,592,223,639,233	; [Note Down]
	dc.w	74,1,592,234,639,244	; [Scr. Down]
	dc.w	75,1,592,245,639,255	; [Rot. Down]

	dc.w	0,0,0,0,0,0		;#no gadgets hit#

PatternRightGadgetList:
	dc.w	41,0,45,149,157,253	; Track1
	dc.w	42,0,165,149,277,253	; Track2
	dc.w	43,0,285,149,397,253	; Track3
	dc.w	44,0,405,149,516,253	; Track4
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

MainGadgetList:

	dc.w	1,1,0,0,10,9		; Quit
	dc.w	2,1,624,0,639,10	; [] Amiga M (Flip screen)

	dc.w	3,0,0,22,319,32		; SongName

	dc.w	4,0,98,33,108,43	; MasterVolume +
	dc.w	5,0,109,33,119,43	; MasterVolume -
	dc.w	6,0,120,33,319,44	; Volume dragbar

	dc.w	7,1,31,44,45,54		; I (Insert)
	dc.w	8,1,46,44,61,54		; D (Delete)

	dc.w	9,0,62,44,97,54		; Enter Pos
	dc.w	10,0,62,55,97,65	; Enter Patt
	dc.w	11,0,62,66,97,76	; Enter Len
	;dc.w	12,0,45,55,97,65	; Pattern
	;dc.w	13,0,45,66,97,76	; Length

	dc.w	14,0,98,44,108,54	; Pos +
	dc.w	15,0,109,44,119,54	; Pos -
	dc.w	16,0,98,55,108,65	; Pattern +
	dc.w	17,0,109,55,119,65	; Pattern -
	dc.w	18,0,98,66,108,76	; Length +
	dc.w	19,0,109,66,119,76	; Length -

	dc.w	20,1,120,44,185,54	; Play
	dc.w	21,1,120,55,185,65	; Stop
	dc.w	22,1,120,66,185,76	; Contiune

	dc.w	23,1,186,44,252,54	; Pattern
	dc.w	24,1,186,55,252,65	; Record
	dc.w	25,1,186,66,252,76	; Edit

	dc.w	26,1,253,44,319,54	; Clear
	dc.w	27,1,253,55,319,65	; Setup
	dc.w	28,1,253,66,319,76	; DiskOp.

	dc.w	29,0,0,77,319,87	; SampleName

	dc.w	30,0,98,88,108,98	; Sample +
	dc.w	31,0,109,88,119,98	; Sample -
	dc.w	32,0,98,99,108,109	; Volume +
	dc.w	33,0,109,99,119,109	; Volume -
	dc.w	34,0,98,110,108,120	; Finetune +
	dc.w	35,0,109,110,119,120	; Finetune -

	dc.w	36,0,218,88,228,98	; Length +
	dc.w	37,0,229,88,239,98	; Length -
	dc.w	38,0,218,99,228,109	; Repeat +
	dc.w	39,0,229,99,239,109	; Repeat -
	dc.w	40,0,218,110,228,120	; RepLen +
	dc.w	41,0,229,110,239,120	; RepLen -

	dc.w	42,0,45,88,97,98	; Enter Sample
	dc.w	43,0,45,99,97,109	; Enter Volume
	dc.w	44,0,59,110,97,120	; Enter FineTune

	dc.w	45,0,165,88,217,98	; Enter Length
	dc.w	46,0,165,99,217,109	; Enter Repeat
	dc.w	47,0,165,110,217,120	; Enter RepLen

	dc.w	48,1,240,88,319,98	; Load Sample
	dc.w	49,1,240,99,319,109	; Kill Sample
	dc.w	50,1,240,110,319,120	; Sampler

	dc.w	51,0,327,5,368,39	; Voice 1 toggle
	dc.w	52,0,375,5,416,39	; Voice 2 toggle
	dc.w	53,0,423,5,464,39	; Voice 3 toggle
	dc.w	54,0,471,5,512,39	; Voice 4 toggle

	dc.w	60,0,360,44,639,120	; SubMenu area
	dc.w	61,1,320,44,359,54	; Menu 1
	dc.w	62,1,320,55,359,65	; Menu 2
	dc.w	63,1,320,66,359,76	; Menu 3
	dc.w	64,1,320,77,359,87	; Menu 4
	dc.w	65,1,320,88,359,98	; Menu 5
	dc.w	66,1,320,99,359,109	; Menu 6
	dc.w	67,1,320,110,359,120	; Menu 7

	dc.w	0,0,0,0,0,0		;#no gadgets hit#

SubMenu1GadgetList:
	dc.w	1,0,360,55,452,65	; Quantize
	dc.w	2,0,453,55,463,65	; Quant +
	dc.w	3,0,464,55,474,65	; Quant -
	dc.w	4,0,360,66,452,76	; MetroSamp
	dc.w	5,0,453,66,463,76	; MetroSamp +
	dc.w	6,0,464,66,474,76	; MetroSamp -
	dc.w	7,0,360,77,474,87	; Metronome
	dc.w	8,0,360,88,474,98	; Multi select
	dc.w	9,1,360,99,474,109	; [Rec. Hold]
	dc.w	10,1,360,110,474,120	; []
	dc.w	11,1,556,55,639,65	; Sample:	[Single/All]
	dc.w	12,1,556,66,639,76	; Record:	[Pattern/Song]
	dc.w	13,1,556,77,639,87	; PlayNote:	[Multi/Single]
	dc.w	14,1,556,88,639,98	; Edit:		[Down/Right]
	dc.w	15,1,556,99,639,109	; []
	dc.w	16,1,556,110,639,120	; []
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

SubMenu2GadgetList:
	dc.w	1,1,360,66,406,76	; Delete
	dc.w	2,1,360,77,406,87	; Exchange
	dc.w	3,1,360,88,406,98	; From
	dc.w	4,1,360,99,406,109	; To
	dc.w	5,1,407,66,452,76	; Kill
	dc.w	6,1,407,77,452,87	; Copy
	dc.w	7,0,407,88,430,98	; [] From num
	dc.w	8,0,431,88,441,98	; [] up
	dc.w	9,0,442,88,452,98	; [] down
	dc.w	10,0,407,99,430,109	; [] To num
	dc.w	11,0,431,99,441,109	; [] up
	dc.w	12,0,442,99,452,109	; [] down
	dc.w	13,1,453,66,498,76	; Mix
	dc.w	14,1,453,77,498,87	; Boost
	dc.w	15,1,453,88,498,98	; X-Fade
	dc.w	16,1,453,99,498,109	; UpSamp
	dc.w	17,1,499,66,545,76	; Echo
	dc.w	18,1,499,77,545,87	; Filter
	dc.w	19,1,499,88,545,98	; BackWd
	dc.w	20,1,499,99,545,109	; DnSamp
	dc.w	21,1,546,66,576,76	; Pos
	dc.w	22,0,577,66,617,76	; [] Pos
	dc.w	23,0,618,66,628,76	; [] up
	dc.w	24,0,629,66,639,76	; [] down
	dc.w	25,1,546,77,576,87	; Mod
	dc.w	26,0,577,77,617,87	; [] Mod
	dc.w	27,0,618,77,628,87	; [] up
	dc.w	28,0,629,77,639,87	; [] down
	dc.w	29,1,546,88,592,98	; CutBeg
	dc.w	30,1,593,88,617,98	; FU
	dc.w	31,1,618,88,639,98	; FD
	dc.w	32,1,546,99,576,109	; Vol
	dc.w	33,0,577,99,617,109	; [] Vol
	dc.w	34,0,618,99,628,109	; [] up
	dc.w	35,0,629,99,639,109	; [] down
	dc.w	36,1,583,55,639,65	; Halve/Clip
	dc.w	37,1,360,55,416,65	; Track/Pattern/Sample
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

SubMenu3GadgetList:
	dc.w	1,0,360,66,421,76	; From sample number
	dc.w	2,0,422,66,432,76	; up
	dc.w	3,0,433,66,443,76	; down
	dc.w	4,0,360,88,421,98	; To sample number
	dc.w	5,0,422,88,432,98	; up
	dc.w	6,0,433,88,443,98	; down
	dc.w	7,0,444,66,505,76	; Notes number
	dc.w	8,0,506,66,516,76	; up
	dc.w	9,0,517,66,527,76	; down
	dc.w	10,1,444,88,527,98	; Make Chord
	dc.w	11,1,444,77,527,87	; Adjust on/off

	dc.w	20,0,360,110,399,120	; Note 1
	dc.w	21,0,400,110,439,120	; Note 2
	dc.w	22,0,440,110,479,120	; Note 3
	dc.w	23,0,480,110,519,120	; Note 4
	dc.w	24,0,520,110,559,120	; Note 5
	dc.w	25,0,560,110,599,120	; Note 6
	dc.w	26,0,600,110,639,120	; Note 7

	;dc.w	30,1,528,55,583,65	; Major
	;dc.w	31,1,584,55,639,65	; Minor
	;dc.w	32,1,528,66,583,76	; []
	;dc.w	33,1,584,66,639,76	; []
	;dc.w	34,1,528,77,583,87	; []
	;dc.w	35,1,584,77,639,87	; []
	;dc.w	36,1,528,88,583,98	; []
	;dc.w	37,1,584,88,639,98	; []
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

SubMenu4GadgetList:
	dc.w	1,1,360,55,431,65	; HighPass
	dc.w	2,1,360,66,431,76	; LowPass
	dc.w	3,1,360,77,431,87	; BandPass
	dc.w	4,1,360,88,431,98	; AllPass
	dc.w	5,1,360,99,431,109	; ShelvLow
	dc.w	6,1,360,110,431,120	; ShelvHigh
	dc.w	7,1,432,55,503,65	; CombLoop
	dc.w	20,0,556,66,617,76	; Frequency
	dc.w	21,0,618,66,628,76	; Frequency Up
	dc.w	22,0,629,66,639,76	; Frequency Down
	dc.w	23,0,556,77,617,87	; Quality
	dc.w	24,0,618,77,628,87	; Quality Up
	dc.w	25,0,629,77,639,87	; Quality Down
	dc.w	26,0,556,88,617,98	; Gain
	dc.w	27,0,618,88,628,98	; Gain Up
	dc.w	28,0,629,88,639,98	; Gain Down
	dc.w	29,0,556,99,617,109	; LoopTime
	dc.w	30,0,618,99,628,109	; LoopTime Up
	dc.w	31,0,629,99,639,109	; LoopTime Down
	dc.w	32,0,556,110,617,120	; FeedBack
	dc.w	33,0,618,110,628,120	; FeedBack Up
	dc.w	34,0,629,110,639,120	; FeedBack Down
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

ReqGadgetList1:
	dc.w	1,1,201,98,249,108	; Left answer
	dc.w	3,1,391,98,439,108	; Right answer
	dc.w	0,0,0,0,0,0		;#no gadgets hit#
ReqGadgetList2:
	dc.w	1,1,201,98,249,108	; Left answer
	dc.w	2,1,296,98,344,108	; Middle answer
	dc.w	3,1,391,98,439,108	; Right answer
	dc.w	0,0,0,0,0,0		;#no gadgets hit#
ReqGadgetList3:
	dc.w	2,1,296,98,344,108	; Middle answer
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

ReqGadgetList4:
	dc.w	1,1,202,98,255,108	; Song
	dc.w	2,1,263,98,316,108	; Samples
	dc.w	3,1,324,98,377,108	; All
	dc.w	4,1,385,98,438,108	; Cancel
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

StringReqGadgetList:
	dc.w	1,1,201,98,249,108	; Left answer
	dc.w	3,1,391,98,439,108	; Right answer
	dc.w	4,0,264,76,438,86	; [] String gadget
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

FormatGadgetList:
	dc.w	1,1,202,98,248,108	; [Format]
	dc.w	2,1,293,98,347,108	; [QFormat]
	dc.w	3,1,392,98,438,108	; [Cancel]
	dc.w	4,0,319,55,332,65	; [] Verify
	dc.w	5,0,319,68,332,78	; [] NoIcons
	dc.w	6,1,412,55,438,65	; [] Floppy
	dc.w	7,1,412,68,438,78	; [] FileSys
	dc.w	8,0,264,83,438,93	; [] DiskName
	dc.w	0,0,0,0,0,0		;#no gadgets hit#

;*****************************************************
;Painted screens

	rsreset	; PaintScreen defs.
EndPaint:	rs.b 1
Box1:		rs.b 1	; x,y, width,height (Normal)
Box2:		rs.b 1	; x,y, width,height (Invert)
Box3:		rs.b 1	; x,y, width,height (Double)
Box4:		rs.b 1	; x,y, width,height (Double, Invert)
Box5:		rs.b 1	; col, x,y, width,height (Single color)
Txt1:		rs.b 1	; x,y (Multicol font)
Txt2:		rs.b 1	; col, x,y (Singlecol font)
Txt3:		rs.b 1	; col, x,y (Backg., Foregr. color font)
Pix1:		rs.b 1	; col, x,y
Lin1:		rs.b 1	; col, x1,y1, x2,y2

SampleMonitor:
	dc.w Box1,0,0,200,11
	dc.w Txt1,53,3
	dc.b	'Sample Monitor',0,0
	dc.w Box1,0,11,200,44
	dc.w Box2,7,16,186,34
	dc.w Box5,0,8,17,184,32
	dc.w Pix1,3,6,32
	dc.w Pix1,1,193,32
	dc.w EndPaint
ClrMonitor:
	dc.w Box5,0,0,0,200,55
	dc.w EndPaint

FormatBox:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Txt1,78,8
	dc.b	'Verify',0,0
	dc.w Box1,127,5,14,11
	dc.w Txt1,72,21
	dc.b	'NoIcons',0
	dc.w Box1,127,18,14,11
	dc.w Txt1,176,8
	dc.b	'Floppy',0,0
	dc.w Box1,220,5,27,11
	dc.w Txt1,165,21
	dc.b	'FileSys',0
	dc.w Box1,220,18,27,11
	dc.w Txt1,10,36
	dc.b	'DiskName',0,0
	dc.w Box2,72,33,175,11
	dc.w Box1,10,48,47,11
	dc.w Txt1,13,51
	dc.b	'Format',0,0
	dc.w Box1,101,48,55,11
	dc.w Txt1,104,51
	dc.b	'QFormat',0
	dc.w Box1,200,48,47,11
	dc.w Txt1,203,51
	dc.b	'Cancel',0,0
	dc.w EndPaint

FormatBarReq:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box2,9,26,238,11
	dc.w Txt1,60,50
	dc.b	'Press ESC to abort...',0
	dc.w EndPaint

;ClearBox:
;	dc.w Box3, 0,0, 104,39
;	dc.w Box2, 6,6, 33,11
;	dc.w Txt1, 9,9
;	dc.b	'Song',0,0
;	dc.w Box2, 44,6, 54,11
;	dc.w Txt1, 47,9
;	dc.b	'Samples',0
;	dc.w Box2, 6,22, 33,11
;	dc.w Txt1, 12,25
;	dc.b	'All',0
;	dc.w Box2, 44,22, 54,11
;	dc.w Txt1, 51,25
;	dc.b	'Cancel',0,0
;	dc.w EndPaint

;SureBox:	dc.w Box3, 0,0, 104,39
;	dc.w Txt1, 7,8
;	dc.b	'Are You Sure?',0
;	dc.w Box2, 11,20, 26,11
;	dc.w Txt1, 14,23
;	dc.b	'Yes',0
;	dc.w Box2, 74,20, 19,11
;	dc.w Txt1, 77,23
;	dc.b	'No',0,0
;	dc.w EndPaint

Requester1:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box1,9,48,49,11
	dc.w Box1,199,48,49,11
	dc.w Txt1,23,51
	dc.b	'Yes',0
	dc.w Txt1,217,51
	dc.b	'No',0,0
	dc.w EndPaint

Requester2:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box1,9,48,49,11
	dc.w Box1,199,48,49,11
	dc.w Txt1,12,51
	dc.b	'Resume',0,0
	dc.w Txt1,202,51
	dc.b	'Cancel',0,0
	dc.w EndPaint

;Requester3:
;	dc.w Box5, 0, 0,0, 256,64
;	dc.w Box3, 2,1, 252,62
;	dc.w Box1, 9,48, 49,11
;	dc.w Box1, 104,48, 49,11
;	dc.w Box1, 199,48, 49,11
;	dc.w Txt1, 16,51
;	dc.b	'Retry',0
;	dc.w Txt1, 107,51
;	dc.b	'Middle',0,0
;	dc.w Txt1, 202,51
;	dc.b	'Cancel',0,0
;	dc.w EndPaint

AboutRequester:
	dc.w Box5,0,0,0,512,103
	dc.w Box3,2,1,508,101
	dc.w Box1,232,87,49,11
	dc.w Txt1,235,90
	dc.b	'Resume',0,0
	dc.w EndPaint

Requester4:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box1,104,48,49,11
	dc.w Txt1,107,51
	dc.b	'Resume',0,0
	dc.w EndPaint

Requester4maw:	; -maw-
	dc.w Box5,0,0,0,256,64	; what is it: width, height maybe?
	dc.w Box3,2,1,252,62	; inner border?
	dc.w Box1,104,48,49,11	; border for gadget?
	dc.w Txt1,107,51	; gadget text position?
	dc.b	'Resume',0,0
	dc.w EndPaint

Requester5:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box1,9,48,49,11
	dc.w Box1,104,48,49,11
	dc.w Box1,199,48,49,11
	dc.w Txt1,27,51
	dc.b	'31',0,0
	dc.w Txt1,107,51
	dc.b	'Cancel',0,0
	dc.w Txt1,216,51
	dc.b	'15',0,0
	dc.w EndPaint

StringRequester:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box2,72,26,175,11
	dc.w Box1,9,48,49,11
	dc.w Box1,199,48,49,11
	dc.w Txt1,27,51
	dc.b	'OK',0,0
	dc.w Txt1,202,51
	dc.b	'Cancel',0,0
	dc.w EndPaint

ClearRequester:
	dc.w Box5,0,0,0,256,64
	dc.w Box3,2,1,252,62
	dc.w Box1,10,48,54,11
	dc.w Box1,71,48,54,11
	dc.w Box1,132,48,54,11
	dc.w Box1,193,48,54,11
	dc.w Txt1,24,51
	dc.b	'Song',0,0
	dc.w Txt1,73,51
	dc.b	'Samples',0
	dc.w Txt1,149,51
	dc.b	'All',0
	dc.w Txt1,199,51
	dc.b	'Cancel',0,0
	dc.w EndPaint

;---- Graphics Data ----

FontSize	= 568

		INCDIR hd1:languages/sources/protracker/
SubMenu1Data:	INCBIN "pak/ptsubmenu1.pak"
		cnop	0,2
SubMenu2Data:	INCBIN "pak/ptsubmenu2.pak"
		cnop	0,2
SubMenu3Data:	INCBIN "pak/ptsubmenu3.pak"
		cnop	0,2
SubMenu4Data:	INCBIN "pak/ptsubmenu4.pak"
		cnop	0,2
SubMenu5Data:	INCBIN "pak/ptsubmenu5.pak"
		cnop	0,2
SubMenu6Data:	INCBIN "pak/ptsubmenu6.pak"
		cnop	0,2
SubMenu7Data:	INCBIN "pak/ptsubmenu7.pak"
		cnop	0,2
DirScreenData:	INCBIN "pak/ptfilereq.pak"
		cnop	0,2
SetupScreenData:INCBIN "pak/ptsetup.pak"
		cnop	0,2
SampScreenData:	INCBIN "pak/ptsampler.pak"
		cnop	0,2
VolBoxData:	INCBIN "raw/ptvolbox.raw"
ReqImage:	INCBIN "raw/PTReqSign.raw"
ReqImage2:	INCBIN "raw/PTReqSign2.raw"
ReqImage3:	INCBIN "raw/PTReqSign3.raw"
ReqImage4:	INCBIN "raw/PTReqSign4.raw"
ReqImage5:	INCBIN "raw/PTReqSign5.raw"

FontData:	INCBIN "raw/ptfont.raw"
Topaz60Data:	INCBIN "raw/topaz60.raw"
		ds.w	64*8

;************************** CHIP DATA HUNK **************************

	SECTION ptdata,DATA_C
Silence:	dc.l 0,0,0,0	; -maw-  ; needed for AUDxDAT
		dc.l 0,0,0,0	; 32 bytes to have a nice audlen, too.
;		INCBIN "Dmatest/testsample"	; this is just there to see
;						; if there will be ever
;						; played more than silence!
		CNOP	0,2
BitPlaneData:	INCBIN "raw/PTMainScreen.raw"

;SamScrPos	EQU	BitPlaneData+121*80
VolBoxPos	EQU	BitPlaneData+155*80+9

SingColorFont:	INCBIN	"raw/SingWidthFont.raw"	; For blitter operations
MultiColorFont:	INCBIN	"raw/PTColorFont.raw"	; --------- "" ---------

TToneData:	; Tuning Tone (Sine Wave)
	dc.b 0,25,49,71,91,106,118,126
	dc.b 127,126,118,106,91,71,49,25
	dc.b 0,-25,-49,-71,-91,-106,-118,-126
	dc.b -127,-126,-118,-106,-91,-71,-49,-25

CopList:dc.w	$0120,$0000	; Sprite 0 high
	dc.w	$0122,$0000	; Sprite 0 low
	dc.w	$0124,$0000	; Sprite 1 high
	dc.w	$0126,$0000	; Sprite 1 low
	dc.w	$0128,$0000	; Sprite 2 high
	dc.w	$012A,$0000	; Sprite 2 low
	dc.w	$012C,$0000	; Sprite 3 high
	dc.w	$012E,$0000	; Sprite 3 low
	dc.w	$0130,$0000	; Sprite 4 high
	dc.w	$0132,$0000	; Sprite 4 low
	dc.w	$0134,$0000	; Sprite 5 high
	dc.w	$0136,$0000	; Sprite 5 low
	dc.w	$0138,$0000	; Sprite 6 high
	dc.w	$013A,$0000	; Sprite 6 low
	dc.w	$013C,$0000	; Sprite 7 high
	dc.w	$013E,$0000	; Sprite 7 low
CopListBitplanes:
	dc.w	$00E0,$0000	; Bitplane 0 high
	dc.w	$00E2,$0000	; Bitplane 0 low
	dc.w	$00E4,$0000	; Bitplane 1 high
	dc.w	$00E6,$0000	; Bitplane 1 low
	dc.w	$00E8		; Bitplane 2 high
NoteBplptrHigh:
	dc.w	0
	dc.w	$00EA		; Bitplane 2 low
NoteBplptrLow:
	dc.w	0
CopListColors:
	dc.w	$01A2,$0AAA	; Color 17
	dc.w	$01A4,$0888	; Color 18
	dc.w	$01A6,$0666	; Color 19
	dc.w	$01A0,$0000	; Color 16
	dc.w	$0180	; Color 0
CopCol0:dc.w	0
	dc.w	$0182,$0AAA	; Color 1
	dc.w	$0184,$0777	; Color 2
	dc.w	$0186,$0444	; Color 3
	dc.w	$0188,$0CCC	; Color 4
	dc.w	$018A,$0A00	; Color 5
	dc.w	$018C,$0000	; Color 6
	dc.w	$018E,$004D	; Color 7
	dc.w	$01AE,$0A00	; Color 23
	dc.w	$01AA,$0700	; Color 21
	dc.w	$01AC,$0400	; Color 22
	dc.w	$008E		; Display Window Start
_DWS1:	dc.w	$2C81		; 2C / 81
	dc.w	$0090		; Display Window Stop
_DWS2:	dc.w	$2CC1		; 2C / C1
	dc.w	$0092		; Display Data Fetch Start
_DDF1:	dc.w	$003C
	dc.w	$0094		; Display Data Fetch Stop
_DDF2:	dc.w	$00D4
	dc.w	$0108,$0000
	dc.w	$010A,$0000
	dc.w	$0102		; bplcon1
_SCR:	dc.w	0
	dc.w	$0104,$0024	; bplcon2
	dc.w	$0106,$0c40	; bplcon3 (AGA ColorMode and Lo-Res Sprites)
	dc.w	$01fc,$0000	; Normal (Single) Bandwidth
_WAIT1:	dc.w	$2C07,$FFFE	; Wait for line $2C, pos $07
	dc.w	$0100		; bplcon0
_BCON1:	dc.w	$b300		; 3 bitplanes, MEDRES
_WAIT2:	dc.w	$5801,$ff00
	dc.w	$009c,$8010	; Set CopInt REQBIT
CopListAnalyzer:
	dcb.l	162,$01fe0000
CopListInsPos:
_WAIT3:	dc.w	$BB07,$FFFE	; Wait for line $88, pos $07
	dc.w	$0100		; bplcon0
_BCON2:	dc.w	$a300		; still medres
CopListBpl4:
	dc.w	$00E8,$0000	; Bitplane 4 high
	dc.w	$00EA,$0000	; Bitplane 4 low
	dc.w	$0188		; Color 4
NoteCol:dc.w	$004D
_WAIT4:	dc.w	$C207,$FFFE	; Wait for line $89, pos $07
	dc.w	$0100		; bplcon0
_BCON3:	dc.w	$b300		; medres
	dc.w	$01AA
EndColor:dc.w	$0000

CopListMark2:
	dcb.w	672,$01fe	; 'Edit color' bar

	; Do NOT make change this, is is beeing modyfied

_WAIT5:	dc.w	$f007,$FFFE	; Wait for line $E9, pos $07
	dc.w	$01B2,$0000	; Color 1
	dc.w	$01B4,$0000	; Color 2
	dc.w	$01B6,$0000	; Color 3
	dc.w	$01BA,$0000	; Color 5
	dc.w	$01BC,$0000	; Color 6
	dc.w	$01BE,$0000	; Color 7
_WAIT18:dc.w	$FFDF,$FFFE	; Wait for line $FF, pos $DF
_WAIT19:dc.w	$2907,$FFFE	; Wait for line $29, pos $07
	dc.w	$0100	; bplcon0
_BCON4:	dc.w	$a300	; medres
	dc.l	-2	; End of Copper
	ds.l	100	; Safety buffer



	rsreset
CopList2:			; Used by sampler screen!
	dc.w	$B607,$FFFE	; Wait for line $B6, pos $07
_WAIT20:rs.w	2
	dc.w	$0188,$004D	; Color 4
	rs.w	1
_SMPCOL:rs.w	1
	dc.w	$01B2,$00F0	; LoopSprite color
	rs.w	2
	dc.w	$01BA,$00FF	; PlayPos Sprite color
	rs.w	2
	dc.l	-2
	rs.w	2
CopList2End:

bmask	dc.w	0,0,0,0,0

PointerSpriteData:
	INCBIN	raw/Pointer20.raw
	dc.l	0

NoSpriteData:
	dc.w	0,0,0,0
CursorSpriteData:
	dc.l	0
	dc.w	$fe00,$fe00
	dcb.l	7,$82000000
	dc.w	$0000,$fe00
	dc.l	0
CursorSpriteLen	equ *-CursorSpriteData

DragBarSpriteData:
	dc.l	0
	dcb.l	dirdragmaxlen,0
	dcb.b	CursorSpriteLen,0
LineCurSpriteData:
	dc.w	0,0,$3c00,$0000,$3c00,$0000,$0000,$0000,0,0
ColBlockSpriteData:
	dc.l	0
	dcb.l	48,$3f000000
PattBarSpriteData:	; Must be located after ColBlockSpriteData
	dc.l	0
	dc.l	$f800f000
	dcb.l	24-2,$f0008800
	dc.l	$80007800
	dc.l	0

VUSpriteLine1:
	dc.l	0
	dc.l	$c0c03fc0
VUSpriteData1:
	dc.l	0
	dcb.l	48,$c0c03fc0
	dc.l	0

VUSpriteLine2:
	dc.l	0
	dc.l	$c0c03fc0
VUSpriteData2:
	dc.l	0
	dcb.l	48,$c0c03fc0
	dc.l	0

VUSpriteLine3:
	dc.l	0
	dc.l	$c0c03fc0
VUSpriteData3:
	dc.l	0
	dcb.l	48,$c0c03fc0
	dc.l	0

VUSpriteLine4:
	dc.l	0
	dc.l	$c0c03fc0
VUSpriteData4:
	dc.l	0
	dcb.l	48,$c0c03fc0
	dc.l	0

LoopSpriteData1:
	dc.l	0
	dc.w	$F000,0,$F000,0,$F000,0,$F000,0
	dcb.l	60,$10000000
	dc.l	0
LoopSpriteData2:
	dc.l	0
	dc.w	$F000,0,$F000,0,$F000,0,$F000,0
	dcb.l	60,$80000000
	dc.l	0
PlayPosSpriteData:
	dc.l	0
	dcb.l	64,$80000000
	dc.l	0

;******** CHIPMEM BSS HUNK ********

	SECTION	ptbss2,BSS_C
WriteBuffer:	ds.l	1408			; One track (#5632.b)
ReadBuffer:	ds.l	1408
BB:		ds.b	1024
RootBuffer:	ds.b	512			; Root block buffer

CharMask:	ds.l	1		; Blitter mask for text printing

TextBpl:	ds.b	((64+12)*8+148)*80	; Text bitplane (BPL3 + pattern gfx)

;******** PUBLIC BSS HUNK ********

	SECTION ptbss,BSS
;-- -maw- ----------
DynMemPtrTable:	ds.b 8*32	; PtrTable for Dyntables (adr.l,len.l) -maw-
DynPartMem:	ds.b 4*DynPartTabSIZE	
old_lvl4_exc:	ds.l 1

audchan1temp:	ds.b n_SIZEOF
audchan2temp:	ds.b n_SIZEOF
audchan3temp:	ds.b n_SIZEOF	
audchan4temp:	ds.b n_SIZEOF		

OldAud0Int: 	ds.l 1
OldAud1Int: 	ds.l 1
OldAud2Int: 	ds.l 1
OldAud3Int: 	ds.l 1

;--- -maw- end ----

FileInfoBlock:	ds.b	256 ;,0
FIB_EntryType	EQU	FileInfoBlock+4
FIB_FileName	EQU	FileInfoBlock+8
FIB_FileSize	EQU	FileInfoBlock+124
FIB_DateStamp	EQU	FileInfoBlock+132

InfoData:	ds.b	36
TextDataBuffer:	ds.b	550
BoxDataBuffer:	ds.b	(256/8)*64*3	; buffer for requesters
TrackBuffer:	ds.l	64
CmdsBuffer:	ds.l	64
BlockBuffer:	ds.l	64
BlockBuffer2:	ds.l	64
PatternBuffer:	ds.l	64*4
UndoBuffer:	ds.l	64*4
WorkBuffer:	ds.l	64	; for flipping

UpperBuffer:	ds.b	Res/8*2*121	; buffer for upper screen area
LowerBuffer:	ds.b	Res/8*2*118	; buffer for lower screen area
		;ds.b	Res/8*2*17

	cnop	0,4
DiskIO:		ds.b	80			; I/O Structure
DiskRep:	ds.b	32			; I/O Port
	cnop	0,4
PacketStruct:	ds.b	sp_SIZEOF		; Memory for DosPacket

SplitTransTable:ds.b	38
SplitInstrTable:ds.b	38

		ds.l	1

************************************
* Setup data read from config file *
************************************

SalvageAddress:	ds.b	8

PowerFlag:	ds.b	1
RAWIFFMode:	ds.b	1
VUMeterMode:	ds.b	1
		ds.b	1

MiscBitFlags:	ds.l	1
	; bit	func		def/other
	; 0	IntMode		CIA/VBLANK
	; 1	Filter		OFF/ON
	; 2	ShowDec		ON/OFF
	; 3     Softint		ON/OFF
	; 4     Dmaconr		On/off
	; 5-31 **Free**

ScrnBitFlags:	ds.l	1
	; bit	func		def/other
	; 0	NTSC		OFF/ON
	; 1	LACED		OFF/ON
	; 2 	TESTCOL		OFF/ON
	; 3	SOLIDSCOPE	OFF/ON
	; 3-31 **Free**

EditBitFlags:	ds.l	1
	; bit	func		def/other
	; 0	RecHold		OFF/ON
	; 1	TransDel	OFF/ON
	; 2	Accidental	  #/b
	; 3	BlankZero	OFF/ON
	; 4	Split		OFF/ON
	; 5	CutToBuf	ON/OFF
	; 6-31 **Free**

DiskBitFlags:	ds.l	1
	; bit	func		def/other
	; 0	SongPack	OFF/ON
	; 1	ModPack		OFF/ON
	; 2	ShowDirs	ON/OFF
	; 3	AutoDir		OFF/ON
	; 4	AutoExit	OFF/ON
	; 5	NoSamples	OFF/ON
	; 6	IFFLoop		ON/OFF
	; 7	Override	OFF/ON

	; 8(0)	HideShowInfo	Hide/Show
	; 9(1)	FileExtention	ON/OFF
	; 10(2)	MultiDirCache	OFF/ON
	; 11(3) Undyn IFF	OFF/ON  ;-maw-
	; 12(4) Undyn MOD	OFF/ON	;-maw-
	; 13(5) UPS > 28khz     ON/OFF
	; 15-31 **free**

PrintPath:	ds.b	32
ColorTable:	ds.w	8
VUMeterColors:	ds.w	48
SplitData:	ds.b	4
		ds.b	4
		ds.b	4
		ds.b	4
KeyRepDelay:	ds.w	1
KeyRepSpeed:	ds.w	1
MultiModeNext:	ds.b	4
EffectMacros:	ds.w	10
Tempo:		ds.w	1
TuneNote:	ds.w	1
TToneVol:	ds.w	1
DefaultSpeed:	ds.w	1

DirPathList:	ds.b	6*32
DefPathList:	ds.b	6*32
MaskTab:	ds.b	6*32

****************************************

InpEvPort:	ds.b	34
InpEvIOReq:	ds.b	48

ScopeInfo:	ds.b	20*4
ScopeSamInfo:	ds.b	16*31
BlankSample:	ds.b	640
FileName:	ds.b	110
NewFileName:	ds.b	110
SampleFileName:	ds.b	28
DirInputName:	ds.b	30
NewInputName:	ds.b	30
TempSampArea:	ds.w	380
SaveColors:	ds.w	40+48
AudIORequest:	ds.b	70
AudIOReply:	ds.b	80
FilterBuffer:	ds.w	4096
TempFileBuf:	ds.l	4
SetupFileData:	ds.b	setuplen+8
SongData:	ds.b	70716	; Song data (instr. info, pattern)

